module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};

/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {

/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;

/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};

/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);

/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;

/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}


/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;

/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;

/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";

/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/*!*********************************!*\
  !*** ./src/firefox/lib/main.js ***!
  \*********************************/
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Mailvelope - secure email with OpenPGP encryption for Webmail
	 * Copyright (C) 2012-2015 Mailvelope GmbH
	 *
	 * This program is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU Affero General Public License version 3
	 * as published by the Free Software Foundation.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU Affero General Public License for more details.
	 *
	 * You should have received a copy of the GNU Affero General Public License
	 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	'use strict';

	var ss = __webpack_require__(/*! sdk/simple-storage */ 1);
	var data = __webpack_require__(/*! sdk/self */ 2).data;
	var pageMod = __webpack_require__(/*! sdk/page-mod */ 3);
	var unload = __webpack_require__(/*! sdk/system/unload */ 4);
	var l10nGet = __webpack_require__(/*! sdk/l10n */ 5).get;

	var ToggleButton = __webpack_require__(/*! sdk/ui/button/toggle */ 6).ToggleButton;
	var Panel = __webpack_require__(/*! sdk/panel */ 7).Panel;

	var mvelo = __webpack_require__(/*! ./lib-mvelo.js */ 8);
	var controller = __webpack_require__(/*! ../../controller/main.controller */ 20);
	var prompts = __webpack_require__(/*! ./prompt */ 58);

	var pageMods = {};

	var mailvelopePanel = null;

	unload.when(function(reason) {
	  // reason is never 'uninstall' https://bugzilla.mozilla.org/show_bug.cgi?id=571049
	  if (reason === 'uninstall' || reason === 'disable') {
	    //console.log("Extension disabled or unistalled");
	    if (prompts.confirm(l10nGet("clear_localstorage_confirm_title"), l10nGet("clear_localstorage_confirm_message"))) {
	      clearStorage();
	    }
	  }
	});

	function init() {
	  controller.extend({
	    initScriptInjection: function() {
	      injectMainCS();
	    },
	    activate: function() {},
	    deactivate: function() {}
	  });
	  controller.init();
	  initAddonButton();
	  activatePageMods();
	}

	init();

	function onPanelMessage(msg) {
	  switch (msg.event) {
	    case 'close-popup':
	      mailvelopePanel.hide();
	      break;
	    case 'browser-action':
	    case 'activate':
	    case 'deactivate':
	      mailvelopePanel.hide();
	      controller.handleMessageEvent(msg, null, mailvelopePanel.postMessage.bind(mailvelopePanel));
	      break;
	    default:
	      controller.handleMessageEvent(msg, null, mailvelopePanel.postMessage.bind(mailvelopePanel));
	  }
	}

	function initAddonButton() {
	  mailvelopePanel = new Panel({
	    width: 202,
	    height: 310,
	    contentURL: data.url('components/browser-action/popup.html'),
	    onMessage: onPanelMessage,
	    onHide: function() {
	      if (mvelo.browserAction.toggleButton) {
	        mvelo.browserAction.toggleButton.state('window', {checked: false});
	      }
	    },
	    onShow: function() {
	      this.postMessage({"event": "init"});
	    }
	  });
	  mvelo.browserAction.toggleButton = new ToggleButton({
	    id: 'mailvelope-options',
	    label: 'Mailvelope',
	    icon: {
	      '16': data.url('img/cryptography-icon16.png'),
	      '48': data.url('img/cryptography-icon48.png')
	    },
	    onChange: function(state) {
	      if (state.checked) {
	        mailvelopePanel.show({
	          position: mvelo.browserAction.toggleButton
	        });
	      }
	    }
	  });
	}

	function activatePageMods() {
	  injectMainCS();
	  injectMessageAdapter();
	  injectDecryptInline();
	  injectVerifyInline();
	  injectEmbeddedEditor();
	  injectEmbeddedOptions();
	  injectEmbeddedKeyGen();
	  injectEmbeddedKeyBackup();
	  injectEmbeddedRestoreBackup();
	}

	function clearStorage() {
	  for (var obj in ss.storage) {
	    delete ss.storage[obj];
	  }
	}

	function injectMainCS() {

	  var filterURL = controller.getWatchListFilterURLs();

	  var modOptions = {
	    include: filterURL,
	    onAttach: onCsAttach,
	    contentScriptFile: [
	      data.url('lib/messageAdapter.js'),
	      data.url('content-scripts/cs-mailvelope.js')
	    ],
	    contentStyle: getDynamicStyle('content-scripts/framestyles.css'),
	    contentScriptOptions: {
	      expose_messaging: false,
	      data_path: data.url()
	    },
	    contentScriptWhen: 'ready',
	    attachTo: ['existing', 'top', 'frame']
	  };

	  if (pageMods.mainPageMod !== undefined) {
	    try {
	      pageMods.mainPageMod.destroy();
	    } catch (e) {
	      console.log('Destroying active page-mod failed', e);
	    }
	  }

	  //console.log('modOptions.include', modOptions.include);
	  pageMods.mainPageMod = pageMod.PageMod(modOptions);

	}

	function onCsAttach(worker) {
	  //console.log("Attaching content scripts", worker.url);
	  var pageHidden = false;
	  worker.port.on('port-message', controller.portManager.handlePortMessage);
	  worker.port.on('connect', function(portName) {
	    var eventName = 'port-message' + '.' + portName;
	    var port = {
	      name: portName,
	      postMessage: function(message) {
	        if (!pageHidden) {
	          worker.port.emit(eventName, message);
	        }
	      },
	      disconnect: function() {
	        controller.portManager.removePort({name: portName});
	      },
	      ref: worker.port
	    };
	    controller.portManager.addPort(port);
	  });
	  worker.port.on('disconnect', function(portName) {
	    controller.portManager.removePort({name: portName});
	  });
	  worker.on('pagehide', function() {
	    pageHidden = true;
	  });
	  worker.on('detach', function() {
	    controller.portManager.removePort(worker.port);
	  });
	  worker.port.on('message-event', function(msg) {
	    var that = this;
	    var result;
	    switch (msg.event) {
	      case 'get-l10n-messages':
	        if (!pageHidden) { // otherwise exception
	          result = {};
	          msg.ids.forEach(function(id) {
	            result[id] = l10nGet(id);
	          });
	          that.emit(msg.response, result);
	        }
	        break;
	      case 'data-load':
	        if (!pageHidden) { // otherwise exception
	          result = data.load(msg.path);
	          that.emit(msg.response, result);
	        }
	        break;
	      default:
	        controller.handleMessageEvent(msg, null, function(respData) {
	          if (!pageHidden) { // otherwise exception
	            that.emit(msg.response, respData);
	          }
	        });
	    }
	  });
	  if (/^resource.*app\.html/.test(worker.url)) {
	    mvelo.tabs.worker[worker.tab.index] = worker;
	  }
	}

	function getDynamicStyle(path) {
	  var css = data.load(path);
	  var token = /\.\.\//g;
	  css = css.replace(token, data.url(''));
	  return css;
	}

	function injectMessageAdapter() {
	  pageMods.messageAdapterPageMod = pageMod.PageMod({
	    include: [
	      data.url('components/decrypt-popup/decryptPopup.html*'),
	      data.url('components/decrypt-inline/decryptInline.html*'),
	      data.url('components/verify-popup/verifyPopup.html*'),
	      data.url('components/editor/editor.html*'),
	      data.url('components/enter-password/pwdDialog.html*'),
	      data.url('components/import-key/importKeyDialog.html*'),
	      data.url('app/app.html*'),
	      data.url('components/recovery-sheet/recoverySheet.1und1.html*'),
	      data.url('components/recovery-sheet/recoverySheet.html*')
	    ],
	    onAttach: onCsAttach,
	    contentScriptFile: data.url('lib/messageAdapter.js'),
	    contentScriptWhen: 'start',
	    contentScriptOptions: {
	      expose_messaging: true,
	      data_path: data.url()
	    }
	  });
	}

	function injectDecryptInline() {
	  pageMods.decryptInlinePageMod = pageMod.PageMod({
	    include: 'about:blank?mvelo=decryptInline*',
	    onAttach: onCsAttach,
	    contentScriptFile: [
	      data.url('dep/jquery.min.js'),
	      data.url('lib/jquery.ext.js'),
	      data.url('dep/bootstrap/js/bootstrap.js'),
	      data.url('lib/messageAdapter.js'),
	      data.url('mvelo.js'),
	      data.url('components/decrypt-inline/decryptInline.js')
	    ],
	    contentStyleFile: [
	      data.url("dep/bootstrap/css/bootstrap.css"),
	      data.url("mvelo.css"),
	      data.url("components/decrypt-inline/decryptInline.css")
	    ],
	    contentScriptWhen: 'ready',
	    attachTo: ['existing', 'frame'],
	    contentScriptOptions: {
	      expose_messaging: false,
	      data_path: data.url()
	    }
	  });
	}

	function injectVerifyInline() {
	  pageMods.verifyInlinePageMod = pageMod.PageMod({
	    include: 'about:blank?mvelo=verifyInline*',
	    onAttach: onCsAttach,
	    contentScriptFile: [
	      data.url('dep/jquery.min.js'),
	      data.url('lib/jquery.ext.js'),
	      data.url('lib/messageAdapter.js'),
	      data.url('mvelo.js'),
	      data.url('components/verify-inline/verifyInline.js')
	    ],
	    contentStyleFile: [
	      data.url("dep/bootstrap/css/bootstrap.css"),
	      data.url("mvelo.css"),
	      data.url("components/verify-inline/verifyInline.css")
	    ],
	    contentScriptWhen: 'ready',
	    attachTo: ['existing', 'frame'],
	    contentScriptOptions: {
	      expose_messaging: false,
	      data_path: data.url()
	    }
	  });
	}

	function injectEmbeddedEditor() {
	  pageMods.embeddedEditorPageMod = pageMod.PageMod({
	    include: 'about:blank?mvelo=editor*',
	    onAttach: onCsAttach,
	    contentScriptFile: [
	      data.url('dep/jquery.min.js'),
	      data.url('lib/jquery.ext.js'),
	      data.url('dep/bootstrap/js/bootstrap.js'),
	      data.url('dep/angular/angular.min.js'),
	      data.url('dep/ng-tags-input/ng-tags-input.min.js'),
	      data.url('dep/react/react.js'),
	      data.url('dep/react/react-dom.js'),
	      data.url('lib/messageAdapter.js'),
	      data.url('components/editor/editor.bundle.js')
	    ],
	    contentStyleFile: [
	      data.url("dep/bootstrap/css/bootstrap.css"),
	      data.url("dep/ng-tags-input/ng-tags-input.min.css"),
	      data.url("dep/ng-tags-input/ng-tags-input.bootstrap.min.css"),
	      data.url("dep/angular/angular-csp.css"),
	      data.url("mvelo.css"),
	      data.url("components/editor/editor.css")
	    ],
	    contentScriptWhen: 'ready',
	    attachTo: ['existing', 'frame'],
	    contentScriptOptions: {
	      expose_messaging: false,
	      data_path: data.url()
	    }
	  });
	}

	function injectEmbeddedOptions() {
	  pageMods.embeddedOptionsPageMod = pageMod.PageMod({
	    include: 'about:blank?mvelo=options*',
	    onAttach: onCsAttach,
	    contentScriptFile: [
	      data.url('dep/jquery.min.js'),
	      data.url('lib/jquery.ext.js'),
	      data.url('lib/messageAdapter.js'),
	      data.url('dep/bootstrap/js/bootstrap.js'),
	      data.url('dep/bootstrap-sortable/bootstrap-sortable.js'),
	      data.url('dep/react/react.js'),
	      data.url('dep/react/react-dom.js'),
	      data.url('app/app.bundle.js')
	    ],
	    contentStyleFile: [
	      data.url("dep/bootstrap/css/bootstrap.css"),
	      data.url("dep/bootstrap-sortable/bootstrap-sortable.css"),
	      data.url("mvelo.css")
	    ],
	    contentScriptWhen: 'ready',
	    attachTo: ['existing', 'frame'],
	    contentScriptOptions: {
	      expose_messaging: false,
	      data_path: data.url()
	    }
	  });
	}

	function injectEmbeddedKeyGen() {
	  pageMods.embeddedOptionsPageMod = pageMod.PageMod({
	    include: 'about:blank?mvelo=keyGenDialog*',
	    onAttach: onCsAttach,
	    contentScriptFile: [
	      data.url('dep/jquery.min.js'),
	      data.url('lib/jquery.ext.js'),
	      data.url('lib/messageAdapter.js'),
	      data.url('dep/bootstrap/js/bootstrap.js'),
	      data.url('mvelo.js'),
	      data.url('components/generate-key/keyGenDialog.js')
	    ],
	    contentStyleFile: [
	      data.url("dep/bootstrap/css/bootstrap.css"),
	      data.url("mvelo.css"),
	      data.url("components/generate-key/keyGenDialog.css")
	    ],
	    contentScriptWhen: 'ready',
	    attachTo: ['existing', 'frame'],
	    contentScriptOptions: {
	      expose_messaging: false,
	      data_path: data.url()
	    }
	  });
	}

	function injectEmbeddedKeyBackup() {
	  pageMods.embeddedOptionsPageMod = pageMod.PageMod({
	    include: 'about:blank?mvelo=keybackup*',
	    onAttach: onCsAttach,
	    contentScriptFile: [
	      data.url('dep/jquery.min.js'),
	      data.url('lib/jquery.ext.js'),
	      data.url('lib/messageAdapter.js'),
	      data.url('dep/bootstrap/js/bootstrap.js'),
	      data.url('mvelo.js'),
	      data.url('components/key-backup/keyBackupDialog.js')
	    ],
	    contentStyleFile: [
	      data.url("dep/bootstrap/css/bootstrap.css"),
	      data.url("mvelo.css"),
	      data.url("components/key-backup/keyBackupDialog.css")
	    ],
	    contentScriptWhen: 'ready',
	    attachTo: ['existing', 'frame'],
	    contentScriptOptions: {
	      expose_messaging: false,
	      data_path: data.url()
	    }
	  });
	}

	function injectEmbeddedRestoreBackup() {
	  pageMods.embeddedOptionsPageMod = pageMod.PageMod({
	    include: 'about:blank?mvelo=restoreBackup*',
	    onAttach: onCsAttach,
	    contentScriptFile: [
	      data.url('dep/jquery.min.js'),
	      data.url('lib/jquery.ext.js'),
	      data.url('lib/messageAdapter.js'),
	      data.url('dep/bootstrap/js/bootstrap.js'),
	      data.url('mvelo.js'),
	      data.url('components/restore-backup/restoreBackupDialog.js')
	    ],
	    contentStyleFile: [
	      data.url("dep/bootstrap/css/bootstrap.css"),
	      data.url("mvelo.css"),
	      data.url("components/restore-backup/restoreBackupDialog.css")
	    ],
	    contentScriptWhen: 'ready',
	    attachTo: ['existing', 'frame'],
	    contentScriptOptions: {
	      expose_messaging: false,
	      data_path: data.url()
	    }
	  });
	}


/***/ },
/* 1 */
/*!*************************************!*\
  !*** external "sdk/simple-storage" ***!
  \*************************************/
/***/ function(module, exports) {

	module.exports = require("sdk/simple-storage");

/***/ },
/* 2 */
/*!***************************!*\
  !*** external "sdk/self" ***!
  \***************************/
/***/ function(module, exports) {

	module.exports = require("sdk/self");

/***/ },
/* 3 */
/*!*******************************!*\
  !*** external "sdk/page-mod" ***!
  \*******************************/
/***/ function(module, exports) {

	module.exports = require("sdk/page-mod");

/***/ },
/* 4 */
/*!************************************!*\
  !*** external "sdk/system/unload" ***!
  \************************************/
/***/ function(module, exports) {

	module.exports = require("sdk/system/unload");

/***/ },
/* 5 */
/*!***************************!*\
  !*** external "sdk/l10n" ***!
  \***************************/
/***/ function(module, exports) {

	module.exports = require("sdk/l10n");

/***/ },
/* 6 */
/*!***************************************!*\
  !*** external "sdk/ui/button/toggle" ***!
  \***************************************/
/***/ function(module, exports) {

	module.exports = require("sdk/ui/button/toggle");

/***/ },
/* 7 */
/*!****************************!*\
  !*** external "sdk/panel" ***!
  \****************************/
/***/ function(module, exports) {

	module.exports = require("sdk/panel");

/***/ },
/* 8 */
/*!**************************************!*\
  !*** ./src/firefox/lib/lib-mvelo.js ***!
  \**************************************/
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Mailvelope - secure email with OpenPGP encryption for Webmail
	 * Copyright (C) 2012-2015 Mailvelope GmbH
	 *
	 * This program is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU Affero General Public License version 3
	 * as published by the Free Software Foundation.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU Affero General Public License for more details.
	 *
	 * You should have received a copy of the GNU Affero General Public License
	 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	/* eslint strict: 0 */

	var data = __webpack_require__(/*! sdk/self */ 2).data;
	var tabs = __webpack_require__(/*! sdk/tabs */ 9);
	var windows = __webpack_require__(/*! sdk/windows */ 10).browserWindows;
	var addonWindow = __webpack_require__(/*! sdk/addon/window */ 11);
	//var {open} = require('sdk/window/utils');
	var timer = __webpack_require__(/*! sdk/timers */ 12);
	var ss = __webpack_require__(/*! sdk/simple-storage */ 1);
	var url = __webpack_require__(/*! sdk/url */ 13);
	var l10nGet = __webpack_require__(/*! sdk/l10n */ 5).get;

	var mvelo = __webpack_require__(/*! ../../mvelo */ 14);
	var CWorker = __webpack_require__(/*! ./web-worker */ 15).Worker;
	var request = __webpack_require__(/*! sdk/request */ 17).Request;

	var mainWindow = windows.activeWindow; // current active main window
	windows.on('close', () => mainWindow = windows.activeWindow);

	mvelo.ffa = true;
	mvelo.crx = false;

	mvelo.data = {};

	mvelo.data.url = function(path) {
	  return data.url(path);
	};

	mvelo.data.load = function(path) {
	  return new Promise(function(resolve) {
	    resolve(data.load(path));
	  });
	};

	mvelo.tabs = {};

	mvelo.tabs.worker = {};

	mvelo.tabs.getActive = function(callback) {
	  callback(tabs.activeTab);
	};

	mvelo.tabs.attach = function(tab, options, callback) {
	  var lopt = {};
	  if (options) {
	    lopt.contentScriptFile = options.contentScriptFile && options.contentScriptFile.map(function(file) {
	      return data.url(file);
	    });
	    lopt.contentScript = options.contentScript;
	    lopt.contentScriptOptions = options.contentScriptOptions;
	  }
	  lopt.contentScriptFile = lopt.contentScriptFile || [];
	  lopt.contentScriptFile.push(data.url('lib/messageAdapter.js'));
	  lopt.contentScriptOptions = lopt.contentScriptOptions || {};
	  lopt.contentScriptOptions.expose_messaging = lopt.contentScriptOptions.expose_messaging || true;
	  lopt.contentScriptOptions.data_path = data.url();
	  var worker = tab.attach(lopt);
	  this.worker[tab.index] = worker;
	  worker.port.on('message-event', options.onMessage);
	  //console.log('attach registers for message-event', Date.now());
	  worker.port.once('message-event', function() {
	    if (callback) {
	      // first event on port will fire callback after 200ms delay
	      //console.log('starting attach callback timer', msg.event, Date.now());
	      timer.setTimeout(callback.bind(this, tab), 200);
	    }
	  });
	};

	mvelo.tabs.query = function(url, callback) {
	  var result = [];
	  var tabs = windows.activeWindow.tabs;
	  var reUrl = new RegExp(url + '.*');
	  for (var i = 0; i < tabs.length; i++) {
	    if (reUrl.test(tabs[i].url)) {
	      result.push(tabs[i]);
	    }
	  }
	  callback(result);
	};

	mvelo.tabs.create = function(url, complete, callback) {
	  tabs.open({
	    url: url,
	    onReady: complete ? callback : undefined,
	    onOpen: complete ? undefined : callback
	  });
	};

	mvelo.tabs.activate = function(tab, options, callback) {
	  if (options.url) {
	    tab.url = options.url;
	  }
	  tab.activate();
	  if (callback) {
	    callback(tab);
	  }
	};

	mvelo.tabs.eventIndex = 0;

	mvelo.tabs.sendMessage = function(tab, msg, callback) {
	  if (callback) {
	    msg.response = 'resp' + this.eventIndex++;
	    this.worker[tab.index].port.once(msg.response, callback);
	  }
	  this.worker[tab.index].port.emit('message-event', msg);
	};

	mvelo.tabs.loadOptionsTab = function(hash, callback) {
	  mainWindow.activate();
	  // check if options tab already exists
	  var url = data.url('app/app.html');
	  this.query(url, function(tabs) {
	    if (tabs.length === 0) {
	      // if not existent, create tab
	      if (hash === undefined) {
	        hash = '';
	      }
	      mvelo.tabs.create(url + hash, false, function(tab) {
	        mvelo.tabs._loadOptionsTabReady = callback.bind(this, false, tab);
	      });
	    } else {
	      // if existent, set as active tab
	      mvelo.tabs.activate(tabs[0], {url: url + hash}, callback.bind(this, true));
	    }
	  });
	};

	mvelo.tabs.onOptionsTabReady = function() {
	  if (mvelo.tabs._loadOptionsTabReady) {
	    mvelo.tabs._loadOptionsTabReady();
	    mvelo.tabs._loadOptionsTabReady = null;
	  }
	};

	mvelo.storage = {};

	mvelo.storage.get = function(id) {
	  return ss.storage[id];
	};

	mvelo.storage.set = function(id, obj) {
	  ss.storage[id] = obj;
	};

	mvelo.windows = {};

	mvelo.windows.modalActive = false;

	mvelo.windows.internalURL = new RegExp('^' + data.url(''));

	// FIFO list for window options
	mvelo.windows.options = [];

	mvelo.windows.openPopup = function(url, options, callback) {
	  var winOpts = {};
	  winOpts.url = data.url(url);
	  if (mvelo.windows.internalURL.test(winOpts.url)) {
	    this.options.push(options);
	  }
	  winOpts.onDeactivate = function() {
	    if (options && options.modal) {
	      this.activate();
	    }
	  };
	  if (callback) {
	    winOpts.onOpen = callback;
	  }
	  mainWindow = windows.activeWindow;
	  windows.open(winOpts);
	};

	var delegate = {
	  onTrack: function(window) {
	    // check for mailvelope popup
	    if (window.arguments && mvelo.windows.internalURL.test(window.arguments[0])) {
	      window.locationbar.visible = false;
	      window.menubar.visible = false;
	      window.personalbar.visible = false;
	      window.toolbar.visible = false;
	      var options = mvelo.windows.options.shift();
	      if (options) {
	        window.innerWidth = options.width;
	        window.innerHeight = options.height;
	        for (var main in winUtils.windowIterator()) {
	          var y = parseInt(main.screenY + (main.outerHeight - options.height) / 2);
	          var x = parseInt(main.screenX + (main.outerWidth - options.width) / 2);
	          window.moveTo(x, y);
	          break;
	        }
	      }
	    }
	  }
	};

	var winUtils = __webpack_require__(/*! sdk/deprecated/window-utils */ 18);
	new winUtils.WindowTracker(delegate);

	mvelo.windows.BrowserWindow = function(id) {
	  this._id = id;
	};

	mvelo.windows.BrowserWindow.prototype.activate = function() {
	  chrome.windows.update(this._id, {focused: true});
	};

	mvelo.util = mvelo.util || {};

	var dompurifyWorker = __webpack_require__(/*! sdk/page-worker */ 19).Page({
	  contentScriptFile: [
	    data.url('dep/purify.js'),
	    data.url('dep/purifyAdapter.js')
	  ]
	});

	mvelo.util.parseHTML = function(html, callback) {
	  var message = {
	    data: html,
	    response: mvelo.util.getHash()
	  };
	  dompurifyWorker.port.once(message.response, callback);
	  dompurifyWorker.port.emit('parse', message);
	};

	// must be bound to window, otherwise illegal invocation
	mvelo.util.setTimeout = timer.setTimeout;
	mvelo.util.clearTimeout = timer.clearTimeout;

	mvelo.util.getHostname = function(source) {
	  return url.URL(source).host.split(':')[0];
	};

	mvelo.util.getHost = function(source) {
	  return url.URL(source).host;
	};

	mvelo.util.getDOMWindow = function() {
	  return addonWindow.window;
	};

	mvelo.util.getWorker = function() {
	  return CWorker;
	};

	mvelo.util.fetch = function(url, options) {
	  options = options || {};
	  return new Promise(function(resolve) {
	    var fetchRequ = request({
	      url: url,
	      content: options.body,
	      contentType: 'application/json',
	      onComplete: function(response) {
	        resolve({
	          status: response.status,
	          json: function() {
	            return Promise.resolve(response.json);
	          }
	        });
	      }
	    });
	    switch (options.method) {
	      case 'POST':
	        fetchRequ.post();
	        break;
	      case 'DELETE':
	        fetchRequ.delete();
	        break;
	      default:
	        fetchRequ.get();
	    }
	  });
	};

	mvelo.l10n = mvelo.l10n || {};

	mvelo.l10n.get = function(id, substitutions) {
	  if (substitutions) {
	    return l10nGet.apply(null, [id].concat(substitutions));
	  } else {
	    return l10nGet(id);
	  }
	};

	mvelo.browserAction = {};

	mvelo.browserAction.toggleButton = null;

	mvelo.browserAction.state = function(options) {
	  this.toggleButton.state('window', options);
	};

	module.exports = mvelo;


/***/ },
/* 9 */
/*!***************************!*\
  !*** external "sdk/tabs" ***!
  \***************************/
/***/ function(module, exports) {

	module.exports = require("sdk/tabs");

/***/ },
/* 10 */
/*!******************************!*\
  !*** external "sdk/windows" ***!
  \******************************/
/***/ function(module, exports) {

	module.exports = require("sdk/windows");

/***/ },
/* 11 */
/*!***********************************!*\
  !*** external "sdk/addon/window" ***!
  \***********************************/
/***/ function(module, exports) {

	module.exports = require("sdk/addon/window");

/***/ },
/* 12 */
/*!*****************************!*\
  !*** external "sdk/timers" ***!
  \*****************************/
/***/ function(module, exports) {

	module.exports = require("sdk/timers");

/***/ },
/* 13 */
/*!**************************!*\
  !*** external "sdk/url" ***!
  \**************************/
/***/ function(module, exports) {

	module.exports = require("sdk/url");

/***/ },
/* 14 */
/*!**********************!*\
  !*** ./src/mvelo.js ***!
  \**********************/
/***/ function(module, exports, __webpack_require__) {

	
	/**
	 * Mailvelope - secure email with OpenPGP encryption for Webmail
	 * Copyright (C) 2012-2015 Mailvelope GmbH
	 *
	 * This program is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU Affero General Public License version 3
	 * as published by the Free Software Foundation.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU Affero General Public License for more details.
	 *
	 * You should have received a copy of the GNU Affero General Public License
	 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	/* eslint strict: 0 */

	var mvelo = typeof window !== 'undefined' && window.mvelo || {};
	// chrome extension
	mvelo.crx = typeof chrome !== 'undefined';
	// firefox addon
	mvelo.ffa = mvelo.ffa || typeof self !== 'undefined' && self.port || !mvelo.crx;

	/* constants */

	// min height for large frame
	mvelo.LARGE_FRAME = 600;
	// frame constants
	mvelo.FRAME_STATUS = 'stat';
	// frame status
	mvelo.FRAME_ATTACHED = 'att';
	mvelo.FRAME_DETACHED = 'det';
	// key for reference to frame object
	mvelo.FRAME_OBJ = 'fra';
	// marker for dynamically created iframes
	mvelo.DYN_IFRAME = 'dyn';
	mvelo.IFRAME_OBJ = 'obj';
	// armor header type
	mvelo.PGP_MESSAGE = 'msg';
	mvelo.PGP_SIGNATURE = 'sig';
	mvelo.PGP_PUBLIC_KEY = 'pub';
	mvelo.PGP_PRIVATE_KEY = 'priv';
	// display decrypted message
	mvelo.DISPLAY_INLINE = 'inline';
	mvelo.DISPLAY_POPUP = 'popup';
	// editor type
	mvelo.PLAIN_TEXT = 'plain';
	mvelo.RICH_TEXT = 'rich';
	// keyring
	mvelo.KEYRING_DELIMITER = '|#|';
	mvelo.LOCAL_KEYRING_ID = 'localhost' + mvelo.KEYRING_DELIMITER + 'mailvelope';
	// colors for secure background
	mvelo.SECURE_COLORS = ['#e9e9e9', '#c0c0c0', '#808080', '#ffce1e', '#ff0000', '#85154a', '#6f2b8b', '#b3d1e3', '#315bab', '#1c449b', '#4c759c', '#1e8e9f', '#93b536'];

	mvelo.MAXFILEUPLOADSIZE = 25 * 1024 * 1024;
	mvelo.MAXFILEUPLOADSIZECHROME = 20 * 1024 * 1024; // temporal fix due issue in Chrome

	mvelo.appendTpl = function($element, path) {
	  if (mvelo.ffa && !/^resource/.test(document.location.protocol)) {
	    return new Promise(function(resolve) {
	      mvelo.data.load(path, function(result) {
	        $element.append($.parseHTML(result));
	        resolve($element);
	      });
	    });
	  } else {
	    return new Promise(function(resolve, reject) {
	      var req = new XMLHttpRequest();
	      req.open('GET', path);
	      req.responseType = 'text';
	      req.onload = function() {
	        if (req.status == 200) {
	          $element.append($.parseHTML(req.response));
	          resolve($element);
	        } else {
	          reject(new Error(req.statusText));
	        }
	      };
	      req.onerror = function() {
	        reject(new Error('Network Error'));
	      };
	      req.send();
	    });
	  }
	};

	// for fixfox, mvelo.extension is exposed from a content script
	mvelo.extension = mvelo.extension || mvelo.crx && chrome.runtime;
	// extension.connect shim for Firefox
	if (mvelo.ffa && mvelo.extension) {
	  mvelo.extension.connect = function(obj) {
	    mvelo.extension._connect(obj);
	    obj.events = {};
	    var port = {
	      postMessage: mvelo.extension.port.postMessage,
	      disconnect: mvelo.extension.port.disconnect.bind(null, obj),
	      onMessage: {
	        addListener: mvelo.extension.port.addListener.bind(null, obj)
	      },
	      onDisconnect: {
	        addListener: mvelo.extension.port.addDisconnectListener.bind(null)
	      }
	    };
	    // page unload triggers port disconnect
	    window.addEventListener('unload', port.disconnect);
	    return port;
	  };
	}

	// for fixfox, mvelo.l10n is exposed from a content script
	mvelo.l10n = mvelo.l10n || mvelo.crx && {
	  getMessages: function(ids, callback) {
	    var result = {};
	    ids.forEach(function(id) {
	      result[id] = chrome.i18n.getMessage(id);
	    });
	    callback(result);
	  },
	  localizeHTML: function(l10n, idSelector) {
	    var selector = idSelector ? idSelector + ' [data-l10n-id]' : '[data-l10n-id]';
	    $(selector).each(function() {
	      var jqElement = $(this);
	      var id = jqElement.data('l10n-id');
	      var text = l10n ? l10n[id] : chrome.i18n.getMessage(id) || id;
	      jqElement.text(text);
	    });
	    $('[data-l10n-title-id]').each(function() {
	      var jqElement = $(this);
	      var id = jqElement.data('l10n-title-id');
	      var text = l10n ? l10n[id] : chrome.i18n.getMessage(id) || id;
	      jqElement.attr('title', text);
	    });
	  }
	};

	mvelo.util = {};

	mvelo.util.sortAndDeDup = function(unordered, compFn) {
	  var result = [];
	  var sorted = unordered.sort(compFn);
	  // remove duplicates
	  for (var i = 0; i < sorted.length; i++) {
	    if (i === 0 || compFn && compFn(sorted[i - 1], sorted[i]) !== 0 || !compFn && sorted[i - 1] !== sorted[i]) {
	      result.push(sorted[i]);
	    }
	  }
	  return result;
	};

	/**
	 * Only deduplicates, does not sort
	 * @param  {Array} list   The list of items with duplicates
	 * @return {Array}        The list of items without duplicates
	 */
	mvelo.util.deDup = function(list) {
	  var result = [];
	  (list || []).forEach(function(i) {
	    if (result.indexOf(i) === -1) {
	      result.push(i);
	    }
	  });
	  return result;
	};

	// random hash generator
	mvelo.util.getHash = function() {
	  var result = '';
	  var buf = new Uint16Array(6);
	  if (typeof window !== 'undefined') {
	    window.crypto.getRandomValues(buf);
	  } else {
	    mvelo.util.getDOMWindow().crypto.getRandomValues(buf);
	  }
	  for (var i = 0; i < buf.length; i++) {
	    result += buf[i].toString(16);
	  }
	  return result;
	};

	mvelo.util.encodeHTML = function(text) {
	  return String(text)
	    .replace(/&/g, "&amp;")
	    .replace(/</g, "&lt;")
	    .replace(/>/g, "&gt;")
	    .replace(/"/g, "&quot;")
	    .replace(/'/g, "&#039;")
	    .replace(/\//g, "&#x2F;");
	};

	mvelo.util.decodeHTML = function(html) {
	  return String(html)
	    .replace(/&amp;/g, "&")
	    .replace(/&lt;/g, "<")
	    .replace(/&gt;/g, ">")
	    .replace(/&quot;/g, "\"")
	    .replace(/&#039;/g, "\'")
	    .replace(/&#x2F;/g, "\/");
	};

	mvelo.util.decodeQuotedPrint = function(armored) {
	  return armored
	    .replace(/=3D=3D\s*$/m, "==")
	    .replace(/=3D\s*$/m, "=")
	    .replace(/=3D(\S{4})\s*$/m, "=$1");
	};

	mvelo.util.text2html = function(text) {
	  return this.encodeHTML(text).replace(/\n/g, '<br>');
	};

	mvelo.util.html2text = function(html) {
	  html = html.replace(/\n/g, ' '); // replace new line with space
	  html = html.replace(/(<br>)/g, '\n'); // replace <br> with new line
	  html = html.replace(/<\/(blockquote|div|dl|dt|dd|form|h1|h2|h3|h4|h5|h6|hr|ol|p|pre|table|tr|td|ul|li|section|header|footer)>/g, '\n'); // replace block closing tags </..> with new line
	  html = html.replace(/<(.+?)>/g, ''); // remove tags
	  html = html.replace(/&nbsp;/g, ' '); // replace non-breaking space with whitespace
	  html = html.replace(/\n{3,}/g, '\n\n'); // compress new line
	  return mvelo.util.decodeHTML(html);
	};

	/**
	 * This function will return the byte size of any UTF-8 string you pass to it.
	 * @param {string} str
	 * @returns {number}
	 */
	mvelo.util.byteCount = function(str) {
	  return encodeURI(str).split(/%..|./).length - 1;
	};

	mvelo.util.ab2str = function(buf) {
	  var str = '';
	  var ab = new Uint8Array(buf);
	  var CHUNK_SIZE = Math.pow(2, 16);
	  var offset, len, subab;
	  for (offset = 0; offset < ab.length; offset += CHUNK_SIZE) {
	    len = Math.min(CHUNK_SIZE, ab.length - offset);
	    subab = ab.subarray(offset, offset + len);
	    str += String.fromCharCode.apply(null, subab);
	  }
	  return str;
	};

	mvelo.util.str2ab = function(str) {
	  var bufView = new Uint8Array(str.length);
	  for (var i = 0; i < str.length; i++) {
	    bufView[i] = str.charCodeAt(i);
	  }
	  return bufView.buffer;
	};

	mvelo.util.getExtensionClass = function(fileExt) {
	  var extClass = '';
	  if (fileExt) {
	    extClass = 'ext-color-' + fileExt;
	  }
	  return extClass;
	};

	mvelo.util.extractFileNameWithoutExt = function(fileName) {
	  var indexOfDot = fileName.lastIndexOf('.');
	  if (indexOfDot > 0) { // case: regular
	    return fileName.substring(0, indexOfDot);
	  } else {
	    return fileName;
	  }
	};

	mvelo.util.extractFileExtension = function(fileName) {
	  var lastindexDot = fileName.lastIndexOf('.');
	  if (lastindexDot <= 0) { // no extension
	    return '';
	  } else {
	    return fileName.substring(lastindexDot + 1, fileName.length).toLowerCase().trim();
	  }
	};

	// Attribution: http://www.2ality.com/2012/08/underscore-extend.html
	mvelo.util.extend = function(target) {
	  var sources = [].slice.call(arguments, 1);
	  sources.forEach(function(source) {
	    Object.getOwnPropertyNames(source).forEach(function(propName) {
	      Object.defineProperty(target, propName,
	          Object.getOwnPropertyDescriptor(source, propName));
	    });
	  });
	  return target;
	};

	mvelo.util.addLoadingAnimation = function($parent) {
	  $parent = $parent || $('body')[0];
	  var spinner = $('<div class="m-spinner"><div class="bounce1"></div><div class="bounce2"></div><div class="bounce3"></div></div>');
	  spinner.appendTo($parent);
	};

	mvelo.util.showLoadingAnimation = function($parent) {
	  $parent = $parent || $('body')[0];
	  $('.m-spinner', $parent).show();
	};

	mvelo.util.hideLoadingAnimation = function($parent) {
	  $parent = $parent || $('body')[0];
	  $('.m-spinner', $parent).hide();
	};

	mvelo.util.generateSecurityBackground = function(angle, scaling, coloring) {
	  var security = mvelo.util.secBgnd,
	    iconWidth = security.width * security.scaling,
	    iconHeight = security.height * security.scaling,
	    iconAngle = security.angle,
	    iconColor = mvelo.SECURE_COLORS[security.colorId];

	  if (angle || angle === 0) {
	    iconAngle = angle;
	  }
	  if (scaling) {
	    iconWidth = security.width * scaling;
	    iconHeight = security.height * scaling;
	  }
	  if (coloring) {
	    iconColor = mvelo.SECURE_COLORS[coloring];
	  }

	  return '<?xml version="1.0" encoding="UTF-8" standalone="no"?><svg xmlns="http://www.w3.org/2000/svg" id="secBgnd" version="1.1" width="' + iconWidth + 'px" height="' + iconHeight + 'px" viewBox="0 0 27 27"><path transform="rotate(' + iconAngle + ' 14 14)" style="fill: ' + iconColor + ';" d="m 13.963649,25.901754 c -4.6900005,0 -8.5000005,-3.78 -8.5000005,-8.44 0,-1.64 0.47,-3.17 1.29,-4.47 V 9.0417546 c 0,-3.9399992 3.23,-7.1499992 7.2000005,-7.1499992 3.97,0 7.2,3.21 7.2,7.1499992 v 3.9499994 c 0.82,1.3 1.3,2.83 1.3,4.48 0,4.65 -3.8,8.43 -8.49,8.43 z m -1.35,-7.99 v 3.33 h 0 c 0,0.02 0,0.03 0,0.05 0,0.74 0.61,1.34 1.35,1.34 0.75,0 1.35,-0.6 1.35,-1.34 0,-0.02 0,-0.03 0,-0.05 h 0 v -3.33 c 0.63,-0.43 1.04,-1.15 1.04,-1.97 0,-1.32 -1.07,-2.38 -2.4,-2.38 -1.32,0 -2.4,1.07 -2.4,2.38 0.01,0.82 0.43,1.54 1.06,1.97 z m 6.29,-8.8699994 c 0,-2.7099992 -2.22,-4.9099992 -4.95,-4.9099992 -2.73,0 -4.9500005,2.2 -4.9500005,4.9099992 V 10.611754 C 10.393649,9.6217544 12.103649,9.0317546 13.953649,9.0317546 c 1.85,0 3.55,0.5899998 4.94,1.5799994 l 0.01,-1.5699994 z" /></svg>';
	};

	mvelo.util.showSecurityBackground = function(isEmbedded) {
	  if (isEmbedded) {
	    $('.secureBgndSettingsBtn').on('mouseenter', function() {
	      $('.secureBgndSettingsBtn').removeClass('btn-link').addClass('btn-default');
	    });

	    $('.secureBgndSettingsBtn').on('mouseleave', function() {
	      $('.secureBgndSettingsBtn').removeClass('btn-default').addClass('btn-link');
	    });
	  }

	  mvelo.extension.sendMessage({event: "get-security-background"}, function(background) {
	    mvelo.util.secBgnd = background;

	    var secBgndIcon = mvelo.util.generateSecurityBackground(),
	      secureStyle = '.secureBackground {' +
	        'background-color: ' + mvelo.util.secBgnd.color + ';' +
	        'background-position: -20px -20px;' +
	        'background-image: url(data:image/svg+xml;base64,' + btoa(secBgndIcon) + ');' +
	        '}';

	    var lockIcon = mvelo.util.generateSecurityBackground(0, null, 2),
	      lockButton = '.lockBtnIcon, .lockBtnIcon:active {' +
	        'margin: 0px;' +
	        'width: 28px; height: 28px;' +
	        'background-size: 100% 100%;' +
	        'background-repeat: no-repeat;' +
	        'background-image: url(data:image/svg+xml;base64,' + btoa(lockIcon) + ');' +
	        '}';

	    var secBgndStyle = document.getElementById('secBgndCss');
	    if (secBgndStyle) {
	      secBgndStyle.parentNode.removeChild(secBgndStyle);
	    }
	    $('head').append($('<style>').attr('id', 'secBgndCss').text(secureStyle + lockButton));
	  });
	};

	mvelo.util.matchPattern2RegEx = function(matchPattern) {
	  return new RegExp(
	    '^' + matchPattern.replace(/\./g, '\\.')
	                      .replace(/\*\\\./, '(\\w+(-\\w+)*\\.)*') + '$'
	  );
	};

	mvelo.util.mapError = function(error) {
	  return { message: error.message, code: error.code  || 'INTERNAL_ERROR' };
	};

	mvelo.util.throwError = function(message, code) {
	  var error = new Error(message);
	  error.code = code;
	  throw error;
	};

	mvelo.util.PromiseQueue = function() {
	  this.queue = [];
	};

	mvelo.util.PromiseQueue.prototype.push = function(thisArg, method, args) {
	  var that = this;
	  return new Promise(function(resolve, reject) {
	    that.queue.push({resolve: resolve, reject: reject, thisArg: thisArg, method: method, args: args});
	    if (that.queue.length === 1) {
	      that._next();
	    }
	  });
	};

	mvelo.util.PromiseQueue.prototype._next = function() {
	  if (this.queue.length === 0) {
	    return;
	  }
	  var that = this;
	  var nextEntry = this.queue[0];
	  mvelo.util.setTimeout(function() {
	    nextEntry.thisArg[nextEntry.method].apply(nextEntry.thisArg, nextEntry.args)
	    .then(function(result) {
	      nextEntry.resolve(result);
	    })
	    .catch(function(error) {
	      nextEntry.reject(error);
	    })
	    .then(function() {
	      that.queue.shift();
	      that._next();
	    });
	  }, 0);
	};

	/**
	 * Waterfall of async processes
	 * @param  {Function} process - has to return Promise, result as array
	 * @param  {Array} list - each item is processed
	 * @return {Promise} - resolved when all processes finished with end result as array
	 */
	mvelo.util.sequential = (process, list) => {
	  return list.reduce((acc, item) => {
	    return acc.then((result) => {
	      return process(item).then((processResult) => {
	        result.push(...processResult);
	        return result;
	      })
	    });
	  }, Promise.resolve([]));
	}

	/**
	 * Validate an email address.
	 * @param  {String} address   The email address to validate
	 * @return {Boolean}          True if valid, false if not
	 */
	mvelo.util.checkEmail = function(address) {
	  var pattern = /^[+a-zA-Z0-9_.!#$%&'*\/=?^`{|}~-]+@([a-zA-Z0-9-]+\.)+[a-zA-Z0-9]{2,63}$/;
	  return pattern.test(address);
	};

	/**
	 * Inherit from mvelo.EventHandler.prototype to use the new event handling
	 * apis 'on' and 'emit'.
	 * @param {Port} port   port object received from runtime.connect()
	 * @param {String} sender identifier of sender (type + id)
	 */
	mvelo.EventHandler = function(port, sender) {
	  if (port) {
	    this._port = port;
	    this._port.onMessage.addListener(this.handlePortMessage.bind(this));
	    this._senderId = sender;
	  }
	};

	/**
	 * Generic port message handler that can be attached via port.onMessage.addListener().
	 * Once set up, events can be handled with on('event', function(options) {})
	 * @param  {String} options.event   The event descriptor
	 * @param  {Object} options         Contains message attributes and data
	 */
	mvelo.EventHandler.prototype.handlePortMessage = function(options) {
	  options = options || {};
	  if (this._handlers && this._handlers.has(options.event)) {
	    this._handlers.get(options.event).call(this, options);
	  } else {
	    console.log('Unknown event', options);
	  }
	};

	/**
	 * The new event handling style to asign a function to an event.
	 * @param  {String} event       The event descriptor
	 * @param  {Function} handler   The event handler
	 */
	mvelo.EventHandler.prototype.on = function(event, handler) {
	  if (!event || typeof event !== 'string' || typeof handler !== 'function') {
	    throw new Error('Invalid event handler!');
	  }
	  if (!this._handlers) {
	    this._handlers = new Map();
	  }
	  this._handlers.set(event, handler);
	};

	/**
	 * Helper to emit events via postMessage using a port.
	 * @param  {String} event     The event descriptor
	 * @param  {Object} options   (optional) Data to be sent in the event
	 * @param  {Object} port      (optional) The port to be used. If
	 *                            not specified, the main port is used.
	 */
	mvelo.EventHandler.prototype.emit = function(event, options, port) {
	  if (!event || typeof event !== 'string') {
	    throw new Error('Invalid event!');
	  }
	  options = options || {};
	  options.event = event;
	  options.sender = options.sender || this._senderId;
	  (port || this._port || this.ports[this.mainType]).postMessage(options);
	};

	if (true) {
	  module.exports = mvelo;
	}


/***/ },
/* 15 */
/*!***************************************!*\
  !*** ./src/firefox/lib/web-worker.js ***!
  \***************************************/
/***/ function(module, exports, __webpack_require__) {

	
	'use strict';

	var ChromeWorker = __webpack_require__(/*! chrome */ 16).ChromeWorker;

	exports.Worker = ChromeWorker;


/***/ },
/* 16 */
/*!*************************!*\
  !*** external "chrome" ***!
  \*************************/
/***/ function(module, exports) {

	module.exports = require("chrome");

/***/ },
/* 17 */
/*!******************************!*\
  !*** external "sdk/request" ***!
  \******************************/
/***/ function(module, exports) {

	module.exports = require("sdk/request");

/***/ },
/* 18 */
/*!**********************************************!*\
  !*** external "sdk/deprecated/window-utils" ***!
  \**********************************************/
/***/ function(module, exports) {

	module.exports = require("sdk/deprecated/window-utils");

/***/ },
/* 19 */
/*!**********************************!*\
  !*** external "sdk/page-worker" ***!
  \**********************************/
/***/ function(module, exports) {

	module.exports = require("sdk/page-worker");

/***/ },
/* 20 */
/*!*******************************************!*\
  !*** ./src/controller/main.controller.js ***!
  \*******************************************/
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Mailvelope - secure email with OpenPGP encryption for Webmail
	 * Copyright (C) 2012-2015 Mailvelope GmbH
	 *
	 * This program is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU Affero General Public License version 3
	 * as published by the Free Software Foundation.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU Affero General Public License for more details.
	 *
	 * You should have received a copy of the GNU Affero General Public License
	 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	'use strict';


	var mvelo = __webpack_require__(/*! lib-mvelo */ 8);
	var model = __webpack_require__(/*! ../modules/pgpModel */ 21);
	var keyring = __webpack_require__(/*! ../modules/keyring */ 32);
	var KeyServer = __webpack_require__(/*! ../modules/keyserver */ 38);
	var keyServer = new KeyServer(mvelo);
	var defaults = __webpack_require__(/*! ../modules/defaults */ 24);
	var prefs = __webpack_require__(/*! ../modules/prefs */ 26);
	var sub = __webpack_require__(/*! ./sub.controller */ 35);
	var api = __webpack_require__(/*! ./api.controller */ 39);
	var uiLog = __webpack_require__(/*! ../modules/uiLog */ 29);

	sub.factory.register('dFrame',              __webpack_require__(/*! ./decrypt.controller */ 40).DecryptController);
	sub.factory.register('decryptCont',         __webpack_require__(/*! ./decrypt.controller */ 40).DecryptController);
	sub.factory.register('eFrame',              __webpack_require__(/*! ./encrypt.controller */ 47).EncryptController);
	sub.factory.register('imFrame',             __webpack_require__(/*! ./import.controller */ 48).ImportController);
	sub.factory.register('importKeyDialog',     __webpack_require__(/*! ./import.controller */ 48).ImportController);
	sub.factory.register('mainCS',              __webpack_require__(/*! ./mainCs.controller */ 49).MainCsController);
	sub.factory.register('vFrame',              __webpack_require__(/*! ./verify.controller */ 50).VerifyController);
	sub.factory.register('pwdDialog',           __webpack_require__(/*! ./pwd.controller */ 51).PwdController);
	sub.factory.register('editor',              __webpack_require__(/*! ./editor.controller */ 52).EditorController);
	sub.factory.register('editorCont',          __webpack_require__(/*! ./editor.controller */ 52).EditorController);
	sub.factory.register('syncHandler',         __webpack_require__(/*! ./sync.controller */ 34).SyncController);
	sub.factory.register('keyGenCont',          __webpack_require__(/*! ./privateKey.controller */ 57).PrivateKeyController);
	sub.factory.register('keyGenDialog',        __webpack_require__(/*! ./privateKey.controller */ 57).PrivateKeyController);
	sub.factory.register('keyBackupCont',       __webpack_require__(/*! ./privateKey.controller */ 57).PrivateKeyController);
	sub.factory.register('keyBackupDialog',     __webpack_require__(/*! ./privateKey.controller */ 57).PrivateKeyController);
	sub.factory.register('restoreBackupCont',   __webpack_require__(/*! ./privateKey.controller */ 57).PrivateKeyController);
	sub.factory.register('restoreBackupDialog', __webpack_require__(/*! ./privateKey.controller */ 57).PrivateKeyController);

	// recipients of encrypted mail
	var scannedHosts = [];
	var specific = {};

	function extend(obj) {
	  specific.initScriptInjection = obj.initScriptInjection;
	  specific.activate = obj.activate;
	  specific.deactivate = obj.deactivate;
	}

	function init() {
	  model.init();
	}

	function handleMessageEvent(request, sender, sendResponse) {
	  //console.log('controller: handleMessageEvent', request);
	  if (request.api_event) {
	    return api.handleApiEvent(request, sender, sendResponse);
	  }
	  switch (request.event) {
	    case 'pgpmodel':
	      methodEvent(model, request, sendResponse);
	      // return true for async calls, otherwise Chrome does not handle sendResponse
	      return true;
	    case 'keyring':
	      methodEvent(keyring.getById(request.keyringId), request, sendResponse)
	      .then(() => {
	        // update editor controllers
	        sub.getByMainType('editor').forEach(editorCntrl => editorCntrl.sendKeyUpdate());
	      });
	      // return true for async calls, otherwise Chrome does not handle sendResponse
	      return true;
	    case 'browser-action':
	      onBrowserAction(request.action);
	      break;
	    case 'iframe-scan-result':
	      scannedHosts = scannedHosts.concat(request.result);
	      break;
	    case 'set-watch-list':
	      model.setWatchList(request.data);
	      if (mvelo.ffa) {
	        reloadFrames(true);
	      }
	      specific.initScriptInjection();
	      break;
	    case 'get-all-keyring-attr':
	      try {
	        sendResponse({result: keyring.getAllKeyringAttr()});
	      } catch (e) {
	        sendResponse({error: e});
	      }
	      break;
	    case 'set-keyring-attr':
	      keyring.setKeyringAttr(request.keyringId, request.keyringAttr);
	      break;
	    case 'get-active-keyring':
	      sendResponse(sub.getActiveKeyringId());
	      break;
	    case 'delete-keyring':
	      if (request.keyringId !== mvelo.LOCAL_KEYRING_ID) {
	        keyring.deleteKeyring(request.keyringId);
	        sub.setActiveKeyringId(mvelo.LOCAL_KEYRING_ID);
	        sendResponse(true);
	      } else {
	        console.log('Keyring could not be deleted');
	      }
	      break;
	    case 'send-by-mail':
	      var link = encodeURI('mailto:?subject=Public OpenPGP key of ');
	      link += encodeURIComponent(request.message.data.name);
	      link += '&body=' + encodeURIComponent(request.message.data.armoredPublic);
	      link += encodeURIComponent('\n*** exported with www.mailvelope.com ***');
	      mvelo.tabs.create(link);
	      break;
	    case 'get-prefs':
	      request.prefs = prefs.data();
	      sendResponse(request);
	      break;
	    case 'set-prefs':
	      prefs.update(request.data);
	      sendResponse(true);
	      // update content scripts
	      sub.getByMainType('mainCS').forEach(mainCScontrl => mainCScontrl.updatePrefs());
	      break;
	    case 'get-ui-log':
	      request.secLog = uiLog.getAll();
	      request.secLog = request.secLog.slice(request.securityLogLength);
	      sendResponse(request);
	      break;
	    case 'get-security-background':
	      sendResponse({
	        color: prefs.data().security.secureBgndColor,
	        iconColor: prefs.data().security.secureBgndIconColor,
	        angle: prefs.data().security.secureBgndAngle,
	        scaling: prefs.data().security.secureBgndScaling,
	        width: prefs.data().security.secureBgndWidth,
	        height: prefs.data().security.secureBgndHeight,
	        colorId: prefs.data().security.secureBgndColorId
	      });
	      break;
	    case 'get-version':
	      sendResponse(defaults.getVersion());
	      break;
	    case 'activate':
	      postToNodes(sub.getByMainType('mainCS'), {event: 'on'});
	      specific.activate();
	      prefs.update({main_active: true});
	      break;
	    case 'deactivate':
	      postToNodes(sub.getByMainType('mainCS'), {event: 'off'});
	      specific.deactivate();
	      reloadFrames();
	      prefs.update({main_active: false});
	      break;
	    case 'get-all-key-userid':
	      sendResponse({result: keyring.getAllKeyUserId()});
	      break;
	    case 'open-tab':
	      mvelo.tabs.create(request.url);
	      break;
	    case 'options-ready':
	      mvelo.tabs.onOptionsTabReady();
	      break;
	    case 'upload-primary-public-key':
	      var localKeyring = keyring.getById(mvelo.LOCAL_KEYRING_ID);
	      var primaryKey = localKeyring.getPrimaryKey();
	      if (!primaryKey) {
	        sendResponse({error: {message: 'Primary key not found'}});
	        return;
	      }
	      keyServer.upload({
	        publicKeyArmored: primaryKey.key.toPublic().armor()
	      }).then(function() {
	        sendResponse(true);
	      }).catch(function(err) {
	        sendResponse({error: mvelo.util.mapError(err)});
	      });
	      return true;
	    default:
	      console.log('unknown event:', request);
	  }
	}

	function methodEvent(thisArg, request, sendResponse) {
	  //console.log('controller: methodEvent', request);
	  request.args = request.args || [];
	  if (!Array.isArray(request.args)) {
	    request.args = [request.args];
	  }
	  return Promise.resolve()
	  .then(function() {
	    return thisArg[request.method].apply(thisArg, request.args);
	  })
	  .then(function(result) {
	    sendResponse({result: result});
	  })
	  .catch(function(error) {
	    console.log('error in method ' + request.method + ': ', error);
	    sendResponse({error: mvelo.util.mapError(error)});
	  });
	}

	function destroyNodes(subControllers) {
	  postToNodes(subControllers, {event: 'destroy'});
	}

	function postToNodes(subControllers, msg) {
	  subControllers.forEach(function(subContr) {
	    subContr.ports[subContr.mainType].postMessage(msg);
	  });
	}

	function reloadFrames(main) {
	  if (main) {
	    destroyNodes(sub.getByMainType('mainCS'));
	  }
	  // close frames
	  destroyNodes(sub.getByMainType('dFrame'));
	  destroyNodes(sub.getByMainType('vFrame'));
	  destroyNodes(sub.getByMainType('eFrame'));
	  destroyNodes(sub.getByMainType('imFrame'));
	}

	function addToWatchList() {
	  var scanScript = " \
	      var hosts = $('iframe').get().map(function(element) { \
	        return $('<a/>').attr('href', element.src).prop('hostname'); \
	      }); \
	      hosts.push(document.location.hostname); \
	      mvelo.extension.sendMessage({ \
	        event: 'iframe-scan-result', \
	        result: hosts \
	      }); \
	    ";

	  mvelo.tabs.getActive(function(tab) {
	    if (tab) {
	      // reset scanned hosts buffer
	      scannedHosts.length = 0;
	      var options = {};
	      options.contentScriptFile = [];
	      options.contentScriptFile.push('dep/jquery.min.js');
	      options.contentScriptFile.push('mvelo.js');
	      options.contentScript = scanScript;
	      options.onMessage = handleMessageEvent;
	      // inject scan script
	      mvelo.tabs.attach(tab, options, function() {
	        // wait for message from scan script
	        mvelo.util.setTimeout(() => {
	          if (scannedHosts.length === 0) {
	            return;
	          }
	          // remove duplicates and add wildcards
	          var hosts = reduceHosts(scannedHosts);
	          var site = model.getHostname(tab.url);
	          scannedHosts.length = 0;
	          mvelo.tabs.loadOptionsTab('#watchList', function(old, tab) {
	            sendToWatchList(tab, site, hosts, old);
	          });
	        }, 250);
	      });
	    }
	  });

	}

	function sendToWatchList(tab, site, hosts, old) {
	  mvelo.tabs.sendMessage(tab, {
	    event: 'add-watchlist-item',
	    site: site,
	    hosts: hosts,
	    old: old
	  });
	}

	function onBrowserAction(action) {
	  switch (action) {
	    case 'reload':
	      reloadFrames();
	      break;
	    case 'add':
	      addToWatchList();
	      break;
	    case 'options':
	      loadOptions('#keyring');
	      break;
	    case 'showlog':
	      loadOptions('#securityLog');
	      break;
	    default:
	      console.log('unknown browser action');
	  }
	}

	function loadOptions(hash) {
	  mvelo.tabs.loadOptionsTab(hash, function(old, tab) {
	    if (old) {
	      mvelo.tabs.sendMessage(tab, {
	        event: 'reload-options',
	        hash: hash
	      });
	    }
	  });
	}

	function reduceHosts(hosts) {
	  var reduced = [];
	  hosts.forEach(function(element) {
	    var labels = element.split('.');
	    if (labels.length < 2) {
	      return;
	    }
	    if (labels.length <= 3) {
	      if (/www.*/.test(labels[0])) {
	        labels[0] = '*';
	      } else {
	        labels.unshift('*');
	      }
	      reduced.push(labels.join('.'));
	    } else {
	      reduced.push('*.' + labels.slice(-3).join('.'));
	    }
	  });
	  return mvelo.util.sortAndDeDup(reduced);
	}

	function getWatchListFilterURLs() {
	  var result = [];
	  model.getWatchList().forEach(function(site) {
	    site.active && site.frames && site.frames.forEach(function(frame) {
	      frame.scan && result.push(frame.frame);
	    });
	  });
	  if (result.length !== 0) {
	    result = mvelo.util.sortAndDeDup(result);
	  }
	  return result;
	}

	exports.handleMessageEvent = handleMessageEvent;
	exports.onBrowserAction = onBrowserAction;
	exports.extend = extend;
	exports.init = init;
	exports.portManager = sub;
	exports.getWatchListFilterURLs = getWatchListFilterURLs;


/***/ },
/* 21 */
/*!*********************************!*\
  !*** ./src/modules/pgpModel.js ***!
  \*********************************/
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Mailvelope - secure email with OpenPGP encryption for Webmail
	 * Copyright (C) 2012-2015 Mailvelope GmbH
	 *
	 * This program is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU Affero General Public License version 3
	 * as published by the Free Software Foundation.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU Affero General Public License for more details.
	 *
	 * You should have received a copy of the GNU Affero General Public License
	 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	'use strict';


	var mvelo = __webpack_require__(/*! lib-mvelo */ 8);
	var l10n = mvelo.l10n.get;
	var openpgp = __webpack_require__(/*! openpgp */ 22);
	var defaults = __webpack_require__(/*! ./defaults */ 24);
	var prefs = __webpack_require__(/*! ./prefs */ 26);
	var pwdCache = __webpack_require__(/*! ./pwdCache */ 27);
	var crypto = __webpack_require__(/*! ./crypto */ 28);
	var uiLog = __webpack_require__(/*! ./uiLog */ 29);

	var goog = __webpack_require__(/*! ./closure-library/closure/goog/emailaddress */ 30).goog;
	var keyring = __webpack_require__(/*! ./keyring */ 32);
	var keyringSync = __webpack_require__(/*! ./keyringSync */ 33);
	var trustKey = __webpack_require__(/*! ./trustKey */ 36);
	var sub = __webpack_require__(/*! ../controller/sub.controller */ 35);
	var unlockQueue = new mvelo.util.PromiseQueue();

	var watchListBuffer = null;

	function init() {
	  defaults.init();
	  prefs.init();
	  pwdCache.init();
	  initOpenPGP();
	  keyring.init();
	  trustKey.init();
	}

	function initOpenPGP() {
	  openpgp.config.commentstring = 'https://www.mailvelope.com';
	  openpgp.config.versionstring = 'Mailvelope v' + defaults.getVersion();
	  if (mvelo.crx) {
	    openpgp.initWorker('dep/openpgp.worker.js');
	  } else if (mvelo.ffa) {
	    var CWorker = mvelo.util.getWorker();
	    openpgp.initWorker('', {
	      worker: new CWorker(mvelo.data.url('openpgp.worker.min.js'))
	    });
	  }
	}

	exports.init = init;

	/*
	function decode_utf8(str) {
	  // if str contains umlauts (öäü) this throws an exeception -> no decoding required
	  try {
	    return decodeURIComponent(escape(str));
	  } catch (e) {
	    return str;
	  }
	}
	*/

	function validateEmail(email) {
	  return goog.format.EmailAddress.isValidAddrSpec(email);
	}

	function readMessage(armoredText, keyringId) {
	  return new Promise(function(resolve, reject) {
	    var result = {};
	    try {
	      result.message = openpgp.message.readArmored(armoredText);
	    } catch (e) {
	      console.log('openpgp.message.readArmored', e);
	      return reject({
	        code: 'ARMOR_PARSE_ERROR',
	        message: l10n('message_read_error', [e])
	      });
	    }

	    var encryptionKeyIds = result.message.getEncryptionKeyIds();
	    var privKey = findPrivateKey(encryptionKeyIds, keyringId);

	    if (privKey && privKey.key) {
	      result.keyid = privKey.keyid;
	      result.key = privKey.key;
	      result.userid = keyring.getUserId(result.key, false);
	    } else {
	      // unknown private key
	      result.keyid = encryptionKeyIds[0].toHex();
	      var message = l10n("message_no_keys", [result.keyid.toUpperCase()]);
	      for (var i = 1; i < encryptionKeyIds.length; i++) {
	        message = message + ' ' + l10n("word_or") + ' ' + encryptionKeyIds[i].toHex().toUpperCase();
	      }
	      return reject({
	        code: 'NO_KEY_FOUND',
	        message: message
	      });
	    }

	    resolve(result);
	  });
	}

	function findPrivateKey(encryptionKeyIds, keyringId) {
	  var result = {};
	  for (var i = 0; i < encryptionKeyIds.length; i++) {
	    var keyrings;
	    if (keyringId) {
	      keyrings = [keyring.getById(keyringId)];
	    } else {
	      keyrings = keyring.getAll();
	    }
	    for (var j = 0; j < keyrings.length; j++) {
	      result.keyid = encryptionKeyIds[i].toHex();
	      result.key = keyrings[j].keyring.privateKeys.getForId(result.keyid, true);
	      if (result.key) {
	        return result;
	      }
	    }
	  }
	}

	function readCleartextMessage(armoredText, keyringId) {
	  var result = {};
	  try {
	    result.message = openpgp.cleartext.readArmored(armoredText);
	  } catch (e) {
	    console.log('openpgp.cleartext.readArmored', e);
	    throw {
	      message: l10n('cleartext_read_error', [e])
	    };
	  }

	  result.signers = [];
	  var signingKeyIds = result.message.getSigningKeyIds();
	  if (signingKeyIds.length === 0) {
	    throw {
	      message: 'No signatures found'
	    };
	  }
	  for (var i = 0; i < signingKeyIds.length; i++) {
	    var signer = {};
	    signer.keyid = signingKeyIds[i].toHex();
	    signer.key = keyring.getById(keyringId).keyring.getKeysForId(signer.keyid, true);
	    signer.key = signer.key ? signer.key[0] : null;
	    if (signer.key) {
	      signer.userid = keyring.getUserId(signer.key);
	    }
	    result.signers.push(signer);
	  }

	  return result;
	}

	function unlockKey(privKey, keyid, passwd) {
	  return openpgp.getWorker().decryptKeyPacket(privKey, [openpgp.Keyid.fromId(keyid)], passwd);
	}

	function decryptMessage(message, keyringId, callback) {
	  const options = message.options || {};
	  let senderAddress = options.senderAddress;
	  // normalize sender address to array
	  senderAddress = [].concat(senderAddress || []);
	  // verify signatures if sender address provided or self signed message (draft)
	  if (senderAddress.length || options.selfSigned) {
	    var keyRing = keyring.getById(keyringId);
	    var signingKeys = [];
	    if (senderAddress.length) {
	      signingKeys = keyRing.getKeyByAddress(senderAddress, {validity: true});
	      signingKeys = senderAddress.reduce((result, email) => result.concat(signingKeys[email] || []), []);
	    }
	    // if no signing keys found we use decryption key for verification
	    // this covers the self signed message (draft) use case
	    // also signingKeys parameter in decryptAndVerifyMessage has to contain at least one key
	    if (!signingKeys.length) {
	      signingKeys = [message.key];
	    }
	    openpgp.getWorker().decryptAndVerifyMessage(message.key, signingKeys, message.message).then(function(result) {
	      result.signatures = result.signatures.map(function(signature) {
	        signature.keyid = signature.keyid.toHex();
	        if (signature.valid !== null) {
	          var signingKey = keyRing.keyring.getKeysForId(signature.keyid, true);
	          signature.keyDetails = keyring.mapKeys(signingKey)[0];
	        }
	        return signature;
	      });
	      callback(null, result);
	    }, callback);
	  } else {
	    openpgp.getWorker().decryptMessage(message.key, message.message).then(function(result) {
	      callback(null, {text: result});
	    }, callback);
	  }
	}

	function getKeysForEncryption(options) {
	  var keys = options.keyIdsHex.map(function(keyIdHex) {
	    var keyArray = keyring.getById(options.keyringId).keyring.getKeysForId(keyIdHex);
	    return keyArray ? keyArray[0] : null;
	  }).filter(function(key) {
	    return key !== null;
	  });
	  if (keys.length === 0) {
	    throw {
	      code: 'NO_KEY_FOUND_FOR_ENCRYPTION',
	      message: 'No key found for encryption'
	    };
	  }
	  return keys;
	}

	/**
	 * @param {Object} options
	 * @param {String} options.keyIdsHex
	 * @param {String} options.keyringId
	 * @param {String} options.message  message as native JavaScript string
	 * @param {String} options.uiLogSource
	 * @returns {Promise<String.{type: String, code: String, message: String}>}
	 */
	function encryptMessage(options) {
	  return new Promise(function(resolve, reject) {
	    var keys = getKeysForEncryption(options);
	    openpgp.getWorker().encryptMessage(keys, options.message)
	      .then(function(msg) {
	        logEncryption(options.uiLogSource, keys);
	        resolve(msg);
	      })
	      .catch(function(e) {
	        console.log('openpgp.getWorker().encryptMessage() error', e);
	        reject({
	          message: l10n('encrypt_error', [e])
	        });
	      });
	  });
	}

	/**
	 * @param {Object} options
	 * @param {String} options.keyIdsHex
	 * @param {String} options.keyringId
	 * @param {String} options.message  message as native JavaScript string
	 * @param {Object} options.primaryKey
	 * @param {String} options.uiLogSource
	 * @return {Promise.<String>}
	 */
	function signAndEncryptMessage(options) {
	  return new Promise(function(resolve, reject) {
	    var keys = getKeysForEncryption(options);
	    openpgp.getWorker().signAndEncryptMessage(keys, options.primaryKey.key, options.message)
	      .then(function(msg) {
	        logEncryption(options.uiLogSource, keys);
	        resolve(msg);
	      })
	      .catch(function(e) {
	        console.log('openpgp.getWorker().signAndEncryptMessage() error', e);
	        reject({
	          code: 'ENCRYPT_ERROR',
	          message: l10n('encrypt_error', [e])
	        });
	      });
	  });
	}

	function logEncryption(source, keys) {
	  if (source) {
	    var recipients = keys.map(function(key) {
	      return keyring.getUserId(key, false);
	    });
	    uiLog.push(source, l10n('security_log_encryption_operation', [recipients.join(', ')]));
	  }
	}

	function verifyMessage(message, signers, callback) {
	  var keys = signers.map(function(signer) {
	    return signer.key;
	  }).filter(function(key) {
	    return key !== null;
	  });
	  try {
	    var verified = message.verify(keys);
	    signers = signers.map(function(signer) {
	      signer.valid = signer.key && verified.some(function(verifiedSig) {
	        return signer.keyid === verifiedSig.keyid.toHex() && verifiedSig.valid;
	      });
	      // remove key object
	      delete signer.key;
	      return signer;
	    });
	    callback(null, signers);
	  } catch (e) {
	    callback({
	      message: l10n('verify_error', [e])
	    });
	  }
	}

	/**
	 * @param {String} message
	 * @param {String} signKey
	 * @return {Promise<String>}
	 */
	function signMessage(message, signKey) {
	  return openpgp.getWorker().signClearMessage([signKey], message);
	}

	function createPrivateKeyBackup(primaryKey, keyPwd) {
	  // create backup code
	  var backupCode = crypto.randomString(26);
	  // create packet structure
	  var packetList = new openpgp.packet.List();
	  var literal = new openpgp.packet.Literal();
	  var text = 'Version: 1\n';
	  text += 'Pwd: ' + keyPwd + '\n';
	  literal.setText(text);
	  packetList.push(literal);
	  packetList.concat(primaryKey.toPacketlist());
	  // symmetrically encrypt with backup code
	  var msg = new openpgp.message.Message(packetList);
	  msg = msg.symEncrypt(backupCode);
	  return {
	    backupCode: backupCode,
	    message: msg.armor()
	  };
	}

	function parseMetaInfo(txt) {
	  var result = {};
	  txt.replace(/\r/g, '').split('\n').forEach(function(row) {
	    if (row.length) {
	      var keyValue = row.split(/:\s/);
	      result[keyValue[0]] = keyValue[1];
	    }
	  });
	  return result;
	}

	function restorePrivateKeyBackup(armoredBlock, code) {
	  //console.log('restorePrivateKeyBackup', armoredBlock);
	  try {
	    var message = openpgp.message.readArmored(armoredBlock);
	    if (!(message.packets.length === 2 &&
	          message.packets[0].tag === 3 && // Symmetric-Key Encrypted Session Key Packet
	          message.packets[0].sessionKeyAlgorithm === 'aes256' &&
	          (message.packets[0].sessionKeyEncryptionAlgorithm === null || message.packets[0].sessionKeyEncryptionAlgorithm === 'aes256') &&
	          message.packets[1].tag === 18 // Sym. Encrypted Integrity Protected Data Packet
	       )) {
	      return { error: {message: 'Illegal private key backup structure.'}};
	    }
	    try {
	      message = message.symDecrypt(code);
	    } catch (e) {
	      return { error: {message: 'Could not decrypt message with this restore code', code: 'WRONG_RESTORE_CODE'}};
	    }
	    // extract password
	    var pwd = parseMetaInfo(message.getText()).Pwd;
	    // remove literal data packet
	    var keyPackets = message.packets.slice(1);
	    var privKey =  new openpgp.key.Key(keyPackets);
	    return { key: privKey, password: pwd };
	  } catch (e) {
	    return { error: e.message };
	  }
	}

	/**
	 * @param  {openpgp.key.Key} key - key to decrypt and verify signature
	 * @param  {openpgp.message.Message} message - sync packet
	 * @return {Promise<Object,Error>}
	 */
	function decryptSyncMessage(key, message) {
	  return openpgp.getWorker().decryptAndVerifyMessage(key, [key], message)
	    .then(function(msg) {
	      // check signature
	      var sig = msg.signatures[0];
	      if (!(sig && sig.valid && sig.keyid.equals(key.getSigningKeyPacket().getKeyId()))) {
	        throw new Error('Signature of synced keyring is invalid');
	      }
	      var syncData = JSON.parse(msg.text);
	      var publicKeys = [];
	      var changeLog = {};
	      var fingerprint;
	      for (fingerprint in syncData.insertedKeys) {
	        publicKeys.push({
	          type: 'public',
	          armored: syncData.insertedKeys[fingerprint].armored
	        });
	        changeLog[fingerprint] = {
	          type: keyringSync.INSERT,
	          time: syncData.insertedKeys[fingerprint].time
	        };
	      }
	      for (fingerprint in syncData.deletedKeys) {
	        changeLog[fingerprint] = {
	          type: keyringSync.DELETE,
	          time: syncData.deletedKeys[fingerprint].time
	        };
	      }
	      return {
	        changeLog: changeLog,
	        keys: publicKeys
	      };
	    });
	}

	/**
	 * @param  {Key} key - used to sign and encrypt the package
	 * @param  {Object} changeLog
	 * @param  {String} keyringId - selects keyring for the sync
	 * @return {Promise<Object, Error>} - the encrypted message and the own public key
	 */
	function encryptSyncMessage(key, changeLog, keyringId) {
	  var syncData = {};
	  syncData.insertedKeys = {};
	  syncData.deletedKeys = {};
	  var keyRing = keyring.getById(keyringId).keyring;
	  keyRing.publicKeys.keys.forEach(function(pubKey) {
	    convertChangeLog(pubKey, changeLog, syncData);
	  });
	  keyRing.privateKeys.keys.forEach(function(privKey) {
	    convertChangeLog(privKey.toPublic(), changeLog, syncData);
	  });
	  for (var fingerprint in changeLog) {
	    if (changeLog[fingerprint].type === keyringSync.DELETE) {
	      syncData.deletedKeys[fingerprint] = {
	        time: changeLog[fingerprint].time
	      };
	    }
	  }
	  syncData = JSON.stringify(syncData);
	  return openpgp.getWorker().signAndEncryptMessage([key], key, syncData);
	}

	function convertChangeLog(key, changeLog, syncData) {
	  var fingerprint = key.primaryKey.getFingerprint();
	  var logEntry = changeLog[fingerprint];
	  if (!logEntry) {
	    console.log('Key ' + fingerprint + ' in keyring but not in changeLog.');
	    return;
	  }
	  if (logEntry.type === keyringSync.INSERT) {
	    syncData.insertedKeys[fingerprint] = {
	      armored: key.armor(),
	      time: logEntry.time
	    };
	  } else if (logEntry.type === keyringSync.DELETE) {
	    console.log('Key ' + fingerprint + ' in keyring but has DELETE in changeLog.');
	  } else {
	    console.log('Invalid changeLog type:', logEntry.type);
	  }
	}

	function getLastModifiedDate(key) {
	  var lastModified = new Date(0);
	  key.toPacketlist().forEach(function(packet) {
	    if (packet.created && packet.created > lastModified) {
	      lastModified = packet.created;
	    }
	  });
	  return lastModified;
	}

	function encryptFile(plainFile, receipients) {
	  var keys;
	  return Promise.resolve()
	  .then(function() {
	    keys = receipients.map(function(receipient) {
	      var keyArray = keyring.getById(receipient.keyringId).keyring.getKeysForId(receipient.keyid);
	      return keyArray ? keyArray[0] : null;
	    }).filter(function(key) {
	      return key !== null;
	    });
	    if (keys.length === 0) {
	      throw { message: 'No key found for encryption' };
	    }
	    var content = dataURL2str(plainFile.content);
	    return openpgp.getWorker().encryptMessage(keys, content, 'binary', plainFile.name);
	  })
	  .then(function(msg) {
	    logEncryption('security_log_encrypt_dialog', keys);
	    return msg;
	  })
	  .catch(function(e) {
	    console.log('openpgp.getWorker().encryptFile() error', e);
	    throw { message: l10n('encrypt_error', [e.message]) };
	  });
	}

	function decryptFile(encryptedFile) {
	  return Promise.resolve()
	  .then(function() {
	    var armored = dataURL2str(encryptedFile.content);
	    return readMessage(armored);
	  })
	  .then(function(message) {
	    return unlockQueue.push(sub.factory.get('pwdDialog'), 'unlockKey', [message]);
	  })
	  .then(function(message) {
	    return openpgp.getWorker().decryptMessage(message.key, message.message, 'binary');
	  })
	  .then(function(result) {
	    return {
	      name: result.filename || encryptedFile.name.slice(0, -4),
	      content: result.text
	    };
	  })
	  .catch(function(e) {
	    console.log('openpgp.getWorker().decryptFile() error', e);
	    throw mvelo.util.mapError(e);
	  });
	}

	function dataURL2str(dataURL) {
	  var base64 = dataURL.split(';base64,')[1];
	  return mvelo.util.getDOMWindow().atob(base64);
	}

	exports.validateEmail = validateEmail;
	exports.readMessage = readMessage;
	exports.readCleartextMessage = readCleartextMessage;
	exports.decryptMessage = decryptMessage;
	exports.unlockKey = unlockKey;
	exports.encryptMessage = encryptMessage;
	exports.signAndEncryptMessage = signAndEncryptMessage;
	exports.signMessage = signMessage;
	exports.verifyMessage = verifyMessage;
	exports.createPrivateKeyBackup = createPrivateKeyBackup;
	exports.restorePrivateKeyBackup = restorePrivateKeyBackup;
	exports.decryptSyncMessage = decryptSyncMessage;
	exports.encryptSyncMessage = encryptSyncMessage;
	exports.getLastModifiedDate = getLastModifiedDate;
	exports.encryptFile = encryptFile;
	exports.decryptFile = decryptFile;

	function getWatchList() {
	  watchListBuffer = watchListBuffer || mvelo.storage.get('mailvelopeWatchList');
	  return watchListBuffer;
	}

	function setWatchList(watchList) {
	  mvelo.storage.set('mailvelopeWatchList', watchList);
	  watchListBuffer = watchList;
	}

	function getHostname(url) {
	  var hostname = mvelo.util.getHostname(url);
	  // limit to 3 labels per domain
	  return hostname.split('.').slice(-3).join('.');
	}

	function getPreferences() {
	  return mvelo.storage.get('mailvelopePreferences');
	}

	function setPreferences(preferences) {
	  mvelo.storage.set('mailvelopePreferences', preferences);
	}

	exports.getWatchList = getWatchList;
	exports.setWatchList = setWatchList;
	exports.getHostname = getHostname;
	exports.getPreferences = getPreferences;
	exports.setPreferences = setPreferences;

	/*
	function migrate08() {
	  var prefs = getPreferences();
	  if (mvelo.crx && prefs.migrate08 && prefs.migrate08.done) {
	    window.localStorage.removeItem("privatekeys");
	    window.localStorage.removeItem("publickeys");
	    delete prefs.migrate08;
	    setPreferences(prefs);
	  }

	}

	exports.migrate08 = migrate08;
	*/


/***/ },
/* 22 */
/*!***********************************************!*\
  !*** ./dep/firefox/openpgpjs/dist/openpgp.js ***!
  \***********************************************/
/***/ function(module, exports, __webpack_require__) {

	var require;var require;/*! OpenPGPjs.org  this is LGPL licensed code, see LICENSE/our website for more information.- v1.6.2 - 2016-11-07 */
	var window = __webpack_require__(/*! window */ 23);
	!function(a){if(true)module.exports=a();else if("function"==typeof define&&define.amd)define([],a);else{var b;b="undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:this,b.openpgp=a()}}(function(){return function a(b,c,d){function e(g,h){if(!c[g]){if(!b[g]){var i="function"==typeof require&&require;if(!h&&i)return require(g,!0);if(f)return f(g,!0);var j=new Error("Cannot find module '"+g+"'");throw j.code="MODULE_NOT_FOUND",j}var k=c[g]={exports:{}};b[g][0].call(k.exports,function(a){var c=b[g][1][a];return e(c?c:a)},k,k.exports,a,b,c,d)}return c[g].exports}for(var f="function"==typeof require&&require,g=0;g<d.length;g++)e(d[g]);return e}({1:[function(a,b,c){"use strict";function d(a,b){return this instanceof d?(this.text=a.replace(/\r/g,"").replace(/[\t ]+\n/g,"\n").replace(/\n/g,"\r\n"),void(this.packets=b||new h.List)):new d(a,b)}function e(a){var b=j.decode(a);if(b.type!==i.armor.signed)throw new Error("No cleartext signed message.");var c=new h.List;c.read(b.data),f(b.headers,c);var e=new d(b.text,c);return e}function f(a,b){for(var c=function(a){for(var c=0;c<b.length;c++)if(b[c].tag===i.packet.signature&&!a.some(function(a){return b[c].hashAlgorithm===a}))return!1;return!0},d=null,e=[],f=0;f<a.length;f++){if(d=a[f].match(/Hash: (.+)/),!d)throw new Error('Only "Hash" header allowed in cleartext signed message');d=d[1].replace(/\s/g,""),d=d.split(","),d=d.map(function(a){a=a.toLowerCase();try{return i.write(i.hash,a)}catch(b){throw new Error("Unknown hash algorithm in armor header: "+a)}}),e=e.concat(d)}if(!e.length&&!c([i.hash.md5]))throw new Error('If no "Hash" header in cleartext signed message, then only MD5 signatures allowed');if(!c(e))throw new Error("Hash algorithm mismatch in armor header and signature")}var g=a("./config"),h=a("./packet"),i=a("./enums.js"),j=a("./encoding/armor.js");d.prototype.getSigningKeyIds=function(){var a=[],b=this.packets.filterByTag(i.packet.signature);return b.forEach(function(b){a.push(b.issuerKeyId)}),a},d.prototype.sign=function(a){var b=new h.List,c=new h.Literal;c.setText(this.text);for(var d=0;d<a.length;d++){if(a[d].isPublic())throw new Error("Need private key for signing");var e=new h.Signature;e.signatureType=i.signature.text,e.hashAlgorithm=g.prefer_hash_algorithm;var f=a[d].getSigningKeyPacket();if(e.publicKeyAlgorithm=f.algorithm,!f.isDecrypted)throw new Error("Private key is not decrypted.");e.sign(f,c),b.push(e)}this.packets=b},d.prototype.verify=function(a){var b=[],c=this.packets.filterByTag(i.packet.signature),d=new h.Literal;d.setText(this.text);for(var e=0;e<c.length;e++){for(var f=null,g=0;g<a.length&&!(f=a[g].getSigningKeyPacket(c[e].issuerKeyId));g++);var j={};f?(j.keyid=c[e].issuerKeyId,j.valid=c[e].verify(f,d)):(j.keyid=c[e].issuerKeyId,j.valid=null),b.push(j)}return b},d.prototype.getText=function(){return this.text.replace(/\r\n/g,"\n")},d.prototype.armor=function(){var a={hash:i.read(i.hash,g.prefer_hash_algorithm).toUpperCase(),text:this.text,data:this.packets.write()};return j.encode(i.armor.signed,a)},c.CleartextMessage=d,c.readArmored=e},{"./config":6,"./encoding/armor.js":30,"./enums.js":32,"./packet":44}],2:[function(a,b,c){(function(){"use strict";function a(a,b){var c=a.split("."),d=n;!(c[0]in d)&&d.execScript&&d.execScript("var "+c[0]);for(var e;c.length&&(e=c.shift());)c.length||b===l?d=d[e]?d[e]:d[e]={}:d[e]=b}function b(a,b){if(this.index="number"==typeof b?b:0,this.d=0,this.buffer=a instanceof(o?Uint8Array:Array)?a:new(o?Uint8Array:Array)(32768),2*this.buffer.length<=this.index)throw Error("invalid index");this.buffer.length<=this.index&&c(this)}function c(a){var b,c=a.buffer,d=c.length,e=new(o?Uint8Array:Array)(d<<1);if(o)e.set(c);else for(b=0;d>b;++b)e[b]=c[b];return a.buffer=e}function d(a){this.buffer=new(o?Uint16Array:Array)(2*a),this.length=0}function e(a,b){this.e=w,this.f=0,this.input=o&&a instanceof Array?new Uint8Array(a):a,this.c=0,b&&(b.lazy&&(this.f=b.lazy),"number"==typeof b.compressionType&&(this.e=b.compressionType),b.outputBuffer&&(this.b=o&&b.outputBuffer instanceof Array?new Uint8Array(b.outputBuffer):b.outputBuffer),"number"==typeof b.outputIndex&&(this.c=b.outputIndex)),this.b||(this.b=new(o?Uint8Array:Array)(32768))}function f(a,b){this.length=a,this.g=b}function g(a,b){function c(a,b){var c,d=a.g,e=[],f=0;c=z[a.length],e[f++]=65535&c,e[f++]=c>>16&255,e[f++]=c>>24;var g;switch(m){case 1===d:g=[0,d-1,0];break;case 2===d:g=[1,d-2,0];break;case 3===d:g=[2,d-3,0];break;case 4===d:g=[3,d-4,0];break;case 6>=d:g=[4,d-5,1];break;case 8>=d:g=[5,d-7,1];break;case 12>=d:g=[6,d-9,2];break;case 16>=d:g=[7,d-13,2];break;case 24>=d:g=[8,d-17,3];break;case 32>=d:g=[9,d-25,3];break;case 48>=d:g=[10,d-33,4];break;case 64>=d:g=[11,d-49,4];break;case 96>=d:g=[12,d-65,5];break;case 128>=d:g=[13,d-97,5];break;case 192>=d:g=[14,d-129,6];break;case 256>=d:g=[15,d-193,6];break;case 384>=d:g=[16,d-257,7];break;case 512>=d:g=[17,d-385,7];break;case 768>=d:g=[18,d-513,8];break;case 1024>=d:g=[19,d-769,8];break;case 1536>=d:g=[20,d-1025,9];break;case 2048>=d:g=[21,d-1537,9];break;case 3072>=d:g=[22,d-2049,10];break;case 4096>=d:g=[23,d-3073,10];break;case 6144>=d:g=[24,d-4097,11];break;case 8192>=d:g=[25,d-6145,11];break;case 12288>=d:g=[26,d-8193,12];break;case 16384>=d:g=[27,d-12289,12];break;case 24576>=d:g=[28,d-16385,13];break;case 32768>=d:g=[29,d-24577,13];break;default:throw"invalid distance"}c=g,e[f++]=c[0],e[f++]=c[1],e[f++]=c[2];var h,i;for(h=0,i=e.length;i>h;++h)r[s++]=e[h];u[e[0]]++,v[e[3]]++,t=a.length+b-1,n=null}var d,e,f,g,i,j,k,n,p,q={},r=o?new Uint16Array(2*b.length):[],s=0,t=0,u=new(o?Uint32Array:Array)(286),v=new(o?Uint32Array:Array)(30),w=a.f;if(!o){for(f=0;285>=f;)u[f++]=0;for(f=0;29>=f;)v[f++]=0}for(u[256]=1,d=0,e=b.length;e>d;++d){for(f=i=0,g=3;g>f&&d+f!==e;++f)i=i<<8|b[d+f];if(q[i]===l&&(q[i]=[]),j=q[i],!(0<t--)){for(;0<j.length&&32768<d-j[0];)j.shift();if(d+3>=e){for(n&&c(n,-1),f=0,g=e-d;g>f;++f)p=b[d+f],r[s++]=p,++u[p];break}0<j.length?(k=h(b,d,j),n?n.length<k.length?(p=b[d-1],r[s++]=p,++u[p],c(k,0)):c(n,-1):k.length<w?n=k:c(k,0)):n?c(n,-1):(p=b[d],r[s++]=p,++u[p])}j.push(d)}return r[s++]=256,u[256]++,a.j=u,a.i=v,o?r.subarray(0,s):r}function h(a,b,c){var d,e,g,h,i,j,k=0,l=a.length;h=0,j=c.length;a:for(;j>h;h++){if(d=c[j-h-1],g=3,k>3){for(i=k;i>3;i--)if(a[d+i-1]!==a[b+i-1])continue a;g=k}for(;258>g&&l>b+g&&a[d+g]===a[b+g];)++g;if(g>k&&(e=d,k=g),258===g)break}return new f(k,b-e)}function i(a,b){var c,e,f,g,h,i=a.length,k=new d(572),l=new(o?Uint8Array:Array)(i);if(!o)for(g=0;i>g;g++)l[g]=0;for(g=0;i>g;++g)0<a[g]&&k.push(g,a[g]);if(c=Array(k.length/2),e=new(o?Uint32Array:Array)(k.length/2),1===c.length)return l[k.pop().index]=1,l;for(g=0,h=k.length/2;h>g;++g)c[g]=k.pop(),e[g]=c[g].value;for(f=j(e,e.length,b),g=0,h=c.length;h>g;++g)l[c[g].index]=f[g];return l}function j(a,b,c){function d(a){var c=n[a][p[a]];c===b?(d(a+1),d(a+1)):--l[c],++p[a]}var e,f,g,h,i,j=new(o?Uint16Array:Array)(c),k=new(o?Uint8Array:Array)(c),l=new(o?Uint8Array:Array)(b),m=Array(c),n=Array(c),p=Array(c),q=(1<<c)-b,r=1<<c-1;for(j[c-1]=b,f=0;c>f;++f)r>q?k[f]=0:(k[f]=1,q-=r),q<<=1,j[c-2-f]=(j[c-1-f]/2|0)+b;for(j[0]=k[0],m[0]=Array(j[0]),n[0]=Array(j[0]),f=1;c>f;++f)j[f]>2*j[f-1]+k[f]&&(j[f]=2*j[f-1]+k[f]),m[f]=Array(j[f]),n[f]=Array(j[f]);for(e=0;b>e;++e)l[e]=c;for(g=0;g<j[c-1];++g)m[c-1][g]=a[g],n[c-1][g]=g;for(e=0;c>e;++e)p[e]=0;for(1===k[c-1]&&(--l[0],++p[c-1]),f=c-2;f>=0;--f){for(h=e=0,i=p[f+1],g=0;g<j[f];g++)h=m[f+1][i]+m[f+1][i+1],h>a[e]?(m[f][g]=h,n[f][g]=b,i+=2):(m[f][g]=a[e],n[f][g]=e,++e);p[f]=0,1===k[f]&&d(f)}return l}function k(a){var b,c,d,e,f=new(o?Uint16Array:Array)(a.length),g=[],h=[],i=0;for(b=0,c=a.length;c>b;b++)g[a[b]]=(0|g[a[b]])+1;for(b=1,c=16;c>=b;b++)h[b]=i,i+=0|g[b],i<<=1;for(b=0,c=a.length;c>b;b++)for(i=h[a[b]],h[a[b]]+=1,d=f[b]=0,e=a[b];e>d;d++)f[b]=f[b]<<1|1&i,i>>>=1;return f}var l=void 0,m=!0,n=this,o="undefined"!=typeof Uint8Array&&"undefined"!=typeof Uint16Array&&"undefined"!=typeof Uint32Array&&"undefined"!=typeof DataView;b.prototype.a=function(a,b,d){var e,f=this.buffer,g=this.index,h=this.d,i=f[g];if(d&&b>1&&(a=b>8?(u[255&a]<<24|u[a>>>8&255]<<16|u[a>>>16&255]<<8|u[a>>>24&255])>>32-b:u[a]>>8-b),8>b+h)i=i<<b|a,h+=b;else for(e=0;b>e;++e)i=i<<1|a>>b-e-1&1,8===++h&&(h=0,f[g++]=u[i],i=0,g===f.length&&(f=c(this)));f[g]=i,this.buffer=f,this.d=h,this.index=g},b.prototype.finish=function(){var a,b=this.buffer,c=this.index;return 0<this.d&&(b[c]<<=8-this.d,b[c]=u[b[c]],c++),o?a=b.subarray(0,c):(b.length=c,a=b),a};var p,q=new(o?Uint8Array:Array)(256);for(p=0;256>p;++p){for(var r=p,s=r,t=7,r=r>>>1;r;r>>>=1)s<<=1,s|=1&r,--t;q[p]=(s<<t&255)>>>0}var u=q;d.prototype.getParent=function(a){return 2*((a-2)/4|0)},d.prototype.push=function(a,b){var c,d,e,f=this.buffer;for(c=this.length,f[this.length++]=b,f[this.length++]=a;c>0&&(d=this.getParent(c),f[c]>f[d]);)e=f[c],f[c]=f[d],f[d]=e,e=f[c+1],f[c+1]=f[d+1],f[d+1]=e,c=d;return this.length},d.prototype.pop=function(){var a,b,c,d,e,f=this.buffer;for(b=f[0],a=f[1],this.length-=2,f[0]=f[this.length],f[1]=f[this.length+1],e=0;(d=2*e+2,!(d>=this.length))&&(d+2<this.length&&f[d+2]>f[d]&&(d+=2),f[d]>f[e]);)c=f[e],f[e]=f[d],f[d]=c,c=f[e+1],f[e+1]=f[d+1],f[d+1]=c,e=d;return{index:a,value:b,length:this.length}};var v,w=2,x=[];for(v=0;288>v;v++)switch(m){case 143>=v:x.push([v+48,8]);break;case 255>=v:x.push([v-144+400,9]);break;case 279>=v:x.push([v-256+0,7]);break;case 287>=v:x.push([v-280+192,8]);break;default:throw"invalid literal: "+v}e.prototype.h=function(){var a,c,d,e,f=this.input;switch(this.e){case 0:for(d=0,e=f.length;e>d;){c=o?f.subarray(d,d+65535):f.slice(d,d+65535),d+=c.length;var h=c,j=d===e,n=l,p=l,q=l,r=l,s=l,t=this.b,u=this.c;if(o){for(t=new Uint8Array(this.b.buffer);t.length<=u+h.length+5;)t=new Uint8Array(t.length<<1);t.set(this.b)}if(n=j?1:0,t[u++]=0|n,p=h.length,q=~p+65536&65535,t[u++]=255&p,t[u++]=p>>>8&255,t[u++]=255&q,t[u++]=q>>>8&255,o)t.set(h,u),u+=h.length,t=t.subarray(0,u);else{for(r=0,s=h.length;s>r;++r)t[u++]=h[r];t.length=u}this.c=u,this.b=t}break;case 1:var v=new b(o?new Uint8Array(this.b.buffer):this.b,this.c);v.a(1,1,m),v.a(1,2,m);var y,z,A,B=g(this,f);for(y=0,z=B.length;z>y;y++)if(A=B[y],b.prototype.a.apply(v,x[A]),A>256)v.a(B[++y],B[++y],m),v.a(B[++y],5),v.a(B[++y],B[++y],m);else if(256===A)break;this.b=v.finish(),this.c=this.b.length;break;case w:var C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R=new b(o?new Uint8Array(this.b.buffer):this.b,this.c),S=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15],T=Array(19);for(C=w,R.a(1,1,m),R.a(C,2,m),D=g(this,f),H=i(this.j,15),I=k(H),J=i(this.i,7),K=k(J),E=286;E>257&&0===H[E-1];E--);for(F=30;F>1&&0===J[F-1];F--);var U,V,W,X,Y,Z,$=E,_=F,aa=new(o?Uint32Array:Array)($+_),ba=new(o?Uint32Array:Array)(316),ca=new(o?Uint8Array:Array)(19);for(U=V=0;$>U;U++)aa[V++]=H[U];for(U=0;_>U;U++)aa[V++]=J[U];if(!o)for(U=0,X=ca.length;X>U;++U)ca[U]=0;for(U=Y=0,X=aa.length;X>U;U+=V){for(V=1;X>U+V&&aa[U+V]===aa[U];++V);if(W=V,0===aa[U])if(3>W)for(;0<W--;)ba[Y++]=0,ca[0]++;else for(;W>0;)Z=138>W?W:138,Z>W-3&&W>Z&&(Z=W-3),10>=Z?(ba[Y++]=17,ba[Y++]=Z-3,ca[17]++):(ba[Y++]=18,ba[Y++]=Z-11,ca[18]++),W-=Z;else if(ba[Y++]=aa[U],ca[aa[U]]++,W--,3>W)for(;0<W--;)ba[Y++]=aa[U],ca[aa[U]]++;else for(;W>0;)Z=6>W?W:6,Z>W-3&&W>Z&&(Z=W-3),ba[Y++]=16,ba[Y++]=Z-3,ca[16]++,W-=Z}for(a=o?ba.subarray(0,Y):ba.slice(0,Y),L=i(ca,7),P=0;19>P;P++)T[P]=L[S[P]];for(G=19;G>4&&0===T[G-1];G--);for(M=k(L),R.a(E-257,5,m),R.a(F-1,5,m),R.a(G-4,4,m),P=0;G>P;P++)R.a(T[P],3,m);for(P=0,Q=a.length;Q>P;P++)if(N=a[P],R.a(M[N],L[N],m),N>=16){switch(P++,N){case 16:O=2;break;case 17:O=3;break;case 18:O=7;break;default:throw"invalid code: "+N}R.a(a[P],O,m)}var da,ea,fa,ga,ha,ia,ja,ka,la=[I,H],ma=[K,J];for(ha=la[0],ia=la[1],ja=ma[0],ka=ma[1],da=0,ea=D.length;ea>da;++da)if(fa=D[da],R.a(ha[fa],ia[fa],m),fa>256)R.a(D[++da],D[++da],m),ga=D[++da],R.a(ja[ga],ka[ga],m),R.a(D[++da],D[++da],m);else if(256===fa)break;this.b=R.finish(),this.c=this.b.length;break;default:throw"invalid compression type"}return this.b};var y=function(){function a(a){switch(m){case 3===a:return[257,a-3,0];case 4===a:return[258,a-4,0];case 5===a:return[259,a-5,0];case 6===a:return[260,a-6,0];case 7===a:return[261,a-7,0];case 8===a:return[262,a-8,0];case 9===a:return[263,a-9,0];case 10===a:return[264,a-10,0];case 12>=a:return[265,a-11,1];case 14>=a:return[266,a-13,1];case 16>=a:return[267,a-15,1];case 18>=a:return[268,a-17,1];case 22>=a:return[269,a-19,2];case 26>=a:return[270,a-23,2];case 30>=a:return[271,a-27,2];case 34>=a:return[272,a-31,2];case 42>=a:return[273,a-35,3];case 50>=a:return[274,a-43,3];case 58>=a:return[275,a-51,3];case 66>=a:return[276,a-59,3];case 82>=a:return[277,a-67,4];case 98>=a:return[278,a-83,4];case 114>=a:return[279,a-99,4];case 130>=a:return[280,a-115,4];case 162>=a:return[281,a-131,5];case 194>=a:return[282,a-163,5];case 226>=a:return[283,a-195,5];case 257>=a:return[284,a-227,5];case 258===a:return[285,a-258,0];default:throw"invalid length: "+a}}var b,c,d=[];for(b=3;258>=b;b++)c=a(b),d[b]=c[2]<<24|c[1]<<16|c[0];return d}(),z=o?new Uint32Array(y):y;a("Zlib.RawDeflate",e),a("Zlib.RawDeflate.prototype.compress",e.prototype.h);var A,B,C,D,E={NONE:0,FIXED:1,DYNAMIC:w};if(Object.keys)A=Object.keys(E);else for(B in A=[],C=0,E)A[C++]=B;for(C=0,D=A.length;D>C;++C)B=A[C],a("Zlib.RawDeflate.CompressionType."+B,E[B])}).call(this)},{}],3:[function(a,b,c){(function(){"use strict";function a(a,b){var c=a.split("."),d=g;!(c[0]in d)&&d.execScript&&d.execScript("var "+c[0]);for(var e;c.length&&(e=c.shift());)c.length||void 0===b?d=d[e]?d[e]:d[e]={}:d[e]=b}function b(a){var b,c,d,e,f,g,i,j,k,l,m=a.length,n=0,o=Number.POSITIVE_INFINITY;for(j=0;m>j;++j)a[j]>n&&(n=a[j]),a[j]<o&&(o=a[j]);for(b=1<<n,c=new(h?Uint32Array:Array)(b),d=1,e=0,f=2;n>=d;){for(j=0;m>j;++j)if(a[j]===d){for(g=0,i=e,k=0;d>k;++k)g=g<<1|1&i,i>>=1;for(l=d<<16|j,k=g;b>k;k+=f)c[k]=l;++e}++d,e<<=1,f<<=1}return[c,n,o]}function c(a,b){switch(this.g=[],this.h=32768,this.c=this.f=this.d=this.k=0,this.input=h?new Uint8Array(a):a,this.l=!1,this.i=j,this.q=!1,(b||!(b={}))&&(b.index&&(this.d=b.index),b.bufferSize&&(this.h=b.bufferSize),b.bufferType&&(this.i=b.bufferType),b.resize&&(this.q=b.resize)),this.i){case i:this.a=32768,this.b=new(h?Uint8Array:Array)(32768+this.h+258);break;case j:this.a=0,this.b=new(h?Uint8Array:Array)(this.h),this.e=this.v,this.m=this.s,this.j=this.t;break;default:throw Error("invalid inflate mode")}}function d(a,b){for(var c,d=a.f,e=a.c,f=a.input,g=a.d,h=f.length;b>e;){if(g>=h)throw Error("input buffer is broken");d|=f[g++]<<e,e+=8}return c=d&(1<<b)-1,a.f=d>>>b,a.c=e-b,a.d=g,c}function e(a,b){for(var c,d,e=a.f,f=a.c,g=a.input,h=a.d,i=g.length,j=b[0],k=b[1];k>f&&!(h>=i);)e|=g[h++]<<f,f+=8;return c=j[e&(1<<k)-1],d=c>>>16,a.f=e>>d,a.c=f-d,a.d=h,65535&c}function f(a){function c(a,b,c){var f,g,h,i=this.p;for(h=0;a>h;)switch(f=e(this,b)){case 16:for(g=3+d(this,2);g--;)c[h++]=i;break;case 17:for(g=3+d(this,3);g--;)c[h++]=0;i=0;break;case 18:for(g=11+d(this,7);g--;)c[h++]=0;i=0;break;default:i=c[h++]=f}return this.p=i,c}var f,g,i,j,k=d(a,5)+257,l=d(a,5)+1,m=d(a,4)+4,o=new(h?Uint8Array:Array)(n.length);for(j=0;m>j;++j)o[n[j]]=d(a,3);if(!h)for(j=m,m=o.length;m>j;++j)o[n[j]]=0;f=b(o),g=new(h?Uint8Array:Array)(k),i=new(h?Uint8Array:Array)(l),a.p=0,a.j(b(c.call(a,k,f,g)),b(c.call(a,l,f,i)))}var g=this,h="undefined"!=typeof Uint8Array&&"undefined"!=typeof Uint16Array&&"undefined"!=typeof Uint32Array&&"undefined"!=typeof DataView,i=0,j=1;c.prototype.u=function(){for(;!this.l;){var a=d(this,3);switch(1&a&&(this.l=!0),a>>>=1){case 0:var b=this.input,c=this.d,e=this.b,g=this.a,k=b.length,l=void 0,m=void 0,n=e.length,o=void 0;if(this.c=this.f=0,c+1>=k)throw Error("invalid uncompressed block header: LEN");if(l=b[c++]|b[c++]<<8,c+1>=k)throw Error("invalid uncompressed block header: NLEN");if(m=b[c++]|b[c++]<<8,l===~m)throw Error("invalid uncompressed block header: length verify");if(c+l>b.length)throw Error("input buffer is broken");switch(this.i){case i:for(;g+l>e.length;){if(o=n-g,l-=o,h)e.set(b.subarray(c,c+o),g),g+=o,c+=o;else for(;o--;)e[g++]=b[c++];this.a=g,e=this.e(),g=this.a}break;case j:for(;g+l>e.length;)e=this.e({o:2});break;default:throw Error("invalid inflate mode")}if(h)e.set(b.subarray(c,c+l),g),g+=l,c+=l;else for(;l--;)e[g++]=b[c++];this.d=c,this.a=g,this.b=e;break;case 1:this.j(z,B);break;case 2:f(this);break;default:throw Error("unknown BTYPE: "+a)}}return this.m()};var k,l,m=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15],n=h?new Uint16Array(m):m,o=[3,4,5,6,7,8,9,10,11,13,15,17,19,23,27,31,35,43,51,59,67,83,99,115,131,163,195,227,258,258,258],p=h?new Uint16Array(o):o,q=[0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0,0,0],r=h?new Uint8Array(q):q,s=[1,2,3,4,5,7,9,13,17,25,33,49,65,97,129,193,257,385,513,769,1025,1537,2049,3073,4097,6145,8193,12289,16385,24577],t=h?new Uint16Array(s):s,u=[0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13],v=h?new Uint8Array(u):u,w=new(h?Uint8Array:Array)(288);for(k=0,l=w.length;l>k;++k)w[k]=143>=k?8:255>=k?9:279>=k?7:8;var x,y,z=b(w),A=new(h?Uint8Array:Array)(30);for(x=0,y=A.length;y>x;++x)A[x]=5;var B=b(A);c.prototype.j=function(a,b){var c=this.b,f=this.a;this.n=a;for(var g,h,i,j,k=c.length-258;256!==(g=e(this,a));)if(256>g)f>=k&&(this.a=f,c=this.e(),f=this.a),c[f++]=g;else for(h=g-257,j=p[h],0<r[h]&&(j+=d(this,r[h])),g=e(this,b),i=t[g],0<v[g]&&(i+=d(this,v[g])),f>=k&&(this.a=f,c=this.e(),f=this.a);j--;)c[f]=c[f++-i];for(;8<=this.c;)this.c-=8,this.d--;this.a=f},c.prototype.t=function(a,b){var c=this.b,f=this.a;this.n=a;for(var g,h,i,j,k=c.length;256!==(g=e(this,a));)if(256>g)f>=k&&(c=this.e(),k=c.length),c[f++]=g;else for(h=g-257,j=p[h],0<r[h]&&(j+=d(this,r[h])),g=e(this,b),i=t[g],0<v[g]&&(i+=d(this,v[g])),f+j>k&&(c=this.e(),k=c.length);j--;)c[f]=c[f++-i];for(;8<=this.c;)this.c-=8,this.d--;this.a=f},c.prototype.e=function(){var a,b,c=new(h?Uint8Array:Array)(this.a-32768),d=this.a-32768,e=this.b;if(h)c.set(e.subarray(32768,c.length));else for(a=0,b=c.length;b>a;++a)c[a]=e[a+32768];if(this.g.push(c),this.k+=c.length,h)e.set(e.subarray(d,d+32768));else for(a=0;32768>a;++a)e[a]=e[d+a];return this.a=32768,e},c.prototype.v=function(a){var b,c,d,e,f=this.input.length/this.d+1|0,g=this.input,i=this.b;return a&&("number"==typeof a.o&&(f=a.o),"number"==typeof a.r&&(f+=a.r)),2>f?(c=(g.length-this.d)/this.n[2],e=258*(c/2)|0,d=e<i.length?i.length+e:i.length<<1):d=i.length*f,h?(b=new Uint8Array(d),b.set(i)):b=i,this.b=b},c.prototype.m=function(){var a,b,c,d,e,f=0,g=this.b,i=this.g,j=new(h?Uint8Array:Array)(this.k+(this.a-32768));if(0===i.length)return h?this.b.subarray(32768,this.a):this.b.slice(32768,this.a);for(b=0,c=i.length;c>b;++b)for(a=i[b],d=0,e=a.length;e>d;++d)j[f++]=a[d];for(b=32768,c=this.a;c>b;++b)j[f++]=g[b];return this.g=[],this.buffer=j},c.prototype.s=function(){var a,b=this.a;return h?this.q?(a=new Uint8Array(b),a.set(this.b.subarray(0,b))):a=this.b.subarray(0,b):(this.b.length>b&&(this.b.length=b),a=this.b),this.buffer=a},a("Zlib.RawInflate",c),a("Zlib.RawInflate.prototype.decompress",c.prototype.u);var C,D,E,F,G={ADAPTIVE:j,BLOCK:i};if(Object.keys)C=Object.keys(G);else for(D in C=[],E=0,G)C[E++]=D;for(E=0,F=C.length;F>E;++E)D=C[E],a("Zlib.RawInflate.BufferType."+D,G[D])}).call(this)},{}],4:[function(a,b,c){(function(){"use strict";function a(a){throw a}function b(a,b){var c=a.split("."),d=w;!(c[0]in d)&&d.execScript&&d.execScript("var "+c[0]);for(var e;c.length&&(e=c.shift());)c.length||b===u?d=d[e]?d[e]:d[e]={}:d[e]=b}function c(b,c){this.index="number"==typeof c?c:0,this.i=0,this.buffer=b instanceof(x?Uint8Array:Array)?b:new(x?Uint8Array:Array)(32768),2*this.buffer.length<=this.index&&a(Error("invalid index")),this.buffer.length<=this.index&&this.f()}function d(a){this.buffer=new(x?Uint16Array:Array)(2*a),this.length=0}function e(a){var b,c,d,e,f,g,h,i,j,k,l=a.length,m=0,n=Number.POSITIVE_INFINITY;for(i=0;l>i;++i)a[i]>m&&(m=a[i]),a[i]<n&&(n=a[i]);for(b=1<<m,c=new(x?Uint32Array:Array)(b),d=1,e=0,f=2;m>=d;){for(i=0;l>i;++i)if(a[i]===d){for(g=0,h=e,j=0;d>j;++j)g=g<<1|1&h,h>>=1;for(k=d<<16|i,j=g;b>j;j+=f)c[j]=k;++e}++d,e<<=1,f<<=1}return[c,m,n]}function f(a,b){this.h=F,this.w=0,this.input=x&&a instanceof Array?new Uint8Array(a):a,this.b=0,b&&(b.lazy&&(this.w=b.lazy),"number"==typeof b.compressionType&&(this.h=b.compressionType),b.outputBuffer&&(this.a=x&&b.outputBuffer instanceof Array?new Uint8Array(b.outputBuffer):b.outputBuffer),"number"==typeof b.outputIndex&&(this.b=b.outputIndex)),this.a||(this.a=new(x?Uint8Array:Array)(32768))}function g(a,b){this.length=a,this.H=b}function h(b,c){function d(b,c){var d,e=b.H,f=[],g=0;d=J[b.length],f[g++]=65535&d,f[g++]=d>>16&255,f[g++]=d>>24;var h;switch(v){case 1===e:h=[0,e-1,0];break;case 2===e:h=[1,e-2,0];break;case 3===e:h=[2,e-3,0];break;case 4===e:h=[3,e-4,0];break;case 6>=e:h=[4,e-5,1];break;case 8>=e:h=[5,e-7,1];break;case 12>=e:h=[6,e-9,2];break;case 16>=e:h=[7,e-13,2];break;case 24>=e:h=[8,e-17,3];break;case 32>=e:h=[9,e-25,3];break;case 48>=e:h=[10,e-33,4];break;case 64>=e:h=[11,e-49,4];break;case 96>=e:h=[12,e-65,5];break;case 128>=e:h=[13,e-97,5];break;case 192>=e:h=[14,e-129,6];break;case 256>=e:h=[15,e-193,6];break;case 384>=e:h=[16,e-257,7];break;case 512>=e:h=[17,e-385,7];break;case 768>=e:h=[18,e-513,8];break;case 1024>=e:h=[19,e-769,8];break;case 1536>=e:h=[20,e-1025,9];break;case 2048>=e:h=[21,e-1537,9];break;case 3072>=e:h=[22,e-2049,10];break;case 4096>=e:h=[23,e-3073,10];break;case 6144>=e:h=[24,e-4097,11];break;case 8192>=e:h=[25,e-6145,11];break;case 12288>=e:h=[26,e-8193,12];break;case 16384>=e:h=[27,e-12289,12];break;case 24576>=e:h=[28,e-16385,13];break;case 32768>=e:h=[29,e-24577,13];break;default:a("invalid distance")}d=h,f[g++]=d[0],f[g++]=d[1],f[g++]=d[2];var i,j;for(i=0,j=f.length;j>i;++i)p[q++]=f[i];s[f[0]]++,t[f[3]]++,r=b.length+c-1,m=null}var e,f,g,h,j,k,l,m,n,o={},p=x?new Uint16Array(2*c.length):[],q=0,r=0,s=new(x?Uint32Array:Array)(286),t=new(x?Uint32Array:Array)(30),w=b.w;if(!x){for(g=0;285>=g;)s[g++]=0;for(g=0;29>=g;)t[g++]=0}for(s[256]=1,e=0,f=c.length;f>e;++e){for(g=j=0,h=3;h>g&&e+g!==f;++g)j=j<<8|c[e+g];if(o[j]===u&&(o[j]=[]),k=o[j],!(0<r--)){for(;0<k.length&&32768<e-k[0];)k.shift();if(e+3>=f){for(m&&d(m,-1),g=0,h=f-e;h>g;++g)n=c[e+g],p[q++]=n,++s[n];break}0<k.length?(l=i(c,e,k),m?m.length<l.length?(n=c[e-1],p[q++]=n,++s[n],d(l,0)):d(m,-1):l.length<w?m=l:d(l,0)):m?d(m,-1):(n=c[e],p[q++]=n,++s[n])}k.push(e)}return p[q++]=256,s[256]++,b.M=s,b.L=t,x?p.subarray(0,q):p}function i(a,b,c){var d,e,f,h,i,j,k=0,l=a.length;h=0,j=c.length;a:for(;j>h;h++){if(d=c[j-h-1],f=3,k>3){for(i=k;i>3;i--)if(a[d+i-1]!==a[b+i-1])continue a;f=k}for(;258>f&&l>b+f&&a[d+f]===a[b+f];)++f;if(f>k&&(e=d,k=f),258===f)break}return new g(k,b-e)}function j(a,b){var c,e,f,g,h,i=a.length,j=new d(572),l=new(x?Uint8Array:Array)(i);if(!x)for(g=0;i>g;g++)l[g]=0;for(g=0;i>g;++g)0<a[g]&&j.push(g,a[g]);if(c=Array(j.length/2),e=new(x?Uint32Array:Array)(j.length/2),1===c.length)return l[j.pop().index]=1,l;for(g=0,h=j.length/2;h>g;++g)c[g]=j.pop(),e[g]=c[g].value;for(f=k(e,e.length,b),g=0,h=c.length;h>g;++g)l[c[g].index]=f[g];return l}function k(a,b,c){function d(a){var c=n[a][o[a]];c===b?(d(a+1),d(a+1)):--l[c],++o[a]}var e,f,g,h,i,j=new(x?Uint16Array:Array)(c),k=new(x?Uint8Array:Array)(c),l=new(x?Uint8Array:Array)(b),m=Array(c),n=Array(c),o=Array(c),p=(1<<c)-b,q=1<<c-1;for(j[c-1]=b,f=0;c>f;++f)q>p?k[f]=0:(k[f]=1,p-=q),p<<=1,j[c-2-f]=(j[c-1-f]/2|0)+b;for(j[0]=k[0],m[0]=Array(j[0]),n[0]=Array(j[0]),f=1;c>f;++f)j[f]>2*j[f-1]+k[f]&&(j[f]=2*j[f-1]+k[f]),m[f]=Array(j[f]),n[f]=Array(j[f]);for(e=0;b>e;++e)l[e]=c;for(g=0;g<j[c-1];++g)m[c-1][g]=a[g],n[c-1][g]=g;for(e=0;c>e;++e)o[e]=0;for(1===k[c-1]&&(--l[0],++o[c-1]),f=c-2;f>=0;--f){for(h=e=0,i=o[f+1],g=0;g<j[f];g++)h=m[f+1][i]+m[f+1][i+1],h>a[e]?(m[f][g]=h,n[f][g]=b,i+=2):(m[f][g]=a[e],n[f][g]=e,++e);o[f]=0,1===k[f]&&d(f)}return l}function l(a){var b,c,d,e,f=new(x?Uint16Array:Array)(a.length),g=[],h=[],i=0;for(b=0,c=a.length;c>b;b++)g[a[b]]=(0|g[a[b]])+1;for(b=1,c=16;c>=b;b++)h[b]=i,i+=0|g[b],i<<=1;for(b=0,c=a.length;c>b;b++)for(i=h[a[b]],h[a[b]]+=1,d=f[b]=0,e=a[b];e>d;d++)f[b]=f[b]<<1|1&i,i>>>=1;return f}function m(b,c){switch(this.l=[],this.m=32768,this.e=this.g=this.c=this.q=0,this.input=x?new Uint8Array(b):b,this.s=!1,this.n=L,this.C=!1,(c||!(c={}))&&(c.index&&(this.c=c.index),c.bufferSize&&(this.m=c.bufferSize),c.bufferType&&(this.n=c.bufferType),c.resize&&(this.C=c.resize)),this.n){case K:this.b=32768,this.a=new(x?Uint8Array:Array)(32768+this.m+258);break;case L:this.b=0,this.a=new(x?Uint8Array:Array)(this.m),this.f=this.K,this.t=this.I,this.o=this.J;break;default:a(Error("invalid inflate mode"))}}function n(b,c){for(var d,e=b.g,f=b.e,g=b.input,h=b.c,i=g.length;c>f;)h>=i&&a(Error("input buffer is broken")),e|=g[h++]<<f,f+=8;return d=e&(1<<c)-1,b.g=e>>>c,b.e=f-c,b.c=h,d}function o(a,b){for(var c,d,e=a.g,f=a.e,g=a.input,h=a.c,i=g.length,j=b[0],k=b[1];k>f&&!(h>=i);)e|=g[h++]<<f,f+=8;return c=j[e&(1<<k)-1],d=c>>>16,a.g=e>>d,a.e=f-d,a.c=h,65535&c}function p(a){function b(a,b,c){var d,e,f,g=this.z;for(f=0;a>f;)switch(d=o(this,b)){case 16:for(e=3+n(this,2);e--;)c[f++]=g;break;case 17:for(e=3+n(this,3);e--;)c[f++]=0;g=0;break;case 18:for(e=11+n(this,7);e--;)c[f++]=0;g=0;break;default:g=c[f++]=d}return this.z=g,c}var c,d,f,g,h=n(a,5)+257,i=n(a,5)+1,j=n(a,4)+4,k=new(x?Uint8Array:Array)(Q.length);for(g=0;j>g;++g)k[Q[g]]=n(a,3);if(!x)for(g=j,j=k.length;j>g;++g)k[Q[g]]=0;c=e(k),d=new(x?Uint8Array:Array)(h),f=new(x?Uint8Array:Array)(i),a.z=0,a.o(e(b.call(a,h,c,d)),e(b.call(a,i,c,f)))}function q(a){if("string"==typeof a){var b,c,d=a.split("");for(b=0,c=d.length;c>b;b++)d[b]=(255&d[b].charCodeAt(0))>>>0;a=d}for(var e,f=1,g=0,h=a.length,i=0;h>0;){e=h>1024?1024:h,h-=e;do f+=a[i++],g+=f;while(--e);f%=65521,g%=65521}return(g<<16|f)>>>0}function r(b,c){var d,e;switch(this.input=b,this.c=0,(c||!(c={}))&&(c.index&&(this.c=c.index),c.verify&&(this.N=c.verify)),d=b[this.c++],e=b[this.c++],15&d){case da:this.method=da;break;default:a(Error("unsupported compression method"))}0!==((d<<8)+e)%31&&a(Error("invalid fcheck flag:"+((d<<8)+e)%31)),32&e&&a(Error("fdict flag is not supported")),this.B=new m(b,{index:this.c,bufferSize:c.bufferSize,bufferType:c.bufferType,resize:c.resize})}function s(a,b){this.input=a,this.a=new(x?Uint8Array:Array)(32768),this.h=ea.k;var c,d={};!b&&(b={})||"number"!=typeof b.compressionType||(this.h=b.compressionType);for(c in b)d[c]=b[c];d.outputBuffer=this.a,this.A=new f(this.input,d)}function t(a,c){var d,e,f,g;if(Object.keys)d=Object.keys(c);else for(e in d=[],f=0,c)d[f++]=e;for(f=0,g=d.length;g>f;++f)e=d[f],b(a+"."+e,c[e])}var u=void 0,v=!0,w=this,x="undefined"!=typeof Uint8Array&&"undefined"!=typeof Uint16Array&&"undefined"!=typeof Uint32Array&&"undefined"!=typeof DataView;c.prototype.f=function(){var a,b=this.buffer,c=b.length,d=new(x?Uint8Array:Array)(c<<1);if(x)d.set(b);else for(a=0;c>a;++a)d[a]=b[a];return this.buffer=d},c.prototype.d=function(a,b,c){var d,e=this.buffer,f=this.index,g=this.i,h=e[f];if(c&&b>1&&(a=b>8?(D[255&a]<<24|D[a>>>8&255]<<16|D[a>>>16&255]<<8|D[a>>>24&255])>>32-b:D[a]>>8-b),8>b+g)h=h<<b|a,g+=b;else for(d=0;b>d;++d)h=h<<1|a>>b-d-1&1,8===++g&&(g=0,e[f++]=D[h],h=0,f===e.length&&(e=this.f()));e[f]=h,this.buffer=e,this.i=g,this.index=f},c.prototype.finish=function(){var a,b=this.buffer,c=this.index;return 0<this.i&&(b[c]<<=8-this.i,b[c]=D[b[c]],c++),x?a=b.subarray(0,c):(b.length=c,a=b),a};var y,z=new(x?Uint8Array:Array)(256);for(y=0;256>y;++y){for(var A=y,B=A,C=7,A=A>>>1;A;A>>>=1)B<<=1,B|=1&A,--C;z[y]=(B<<C&255)>>>0}var D=z;d.prototype.getParent=function(a){return 2*((a-2)/4|0)},d.prototype.push=function(a,b){var c,d,e,f=this.buffer;for(c=this.length,f[this.length++]=b,f[this.length++]=a;c>0&&(d=this.getParent(c),f[c]>f[d]);)e=f[c],f[c]=f[d],f[d]=e,e=f[c+1],f[c+1]=f[d+1],f[d+1]=e,c=d;return this.length},d.prototype.pop=function(){var a,b,c,d,e,f=this.buffer;for(b=f[0],a=f[1],this.length-=2,f[0]=f[this.length],f[1]=f[this.length+1],e=0;(d=2*e+2,!(d>=this.length))&&(d+2<this.length&&f[d+2]>f[d]&&(d+=2),f[d]>f[e]);)c=f[e],f[e]=f[d],f[d]=c,c=f[e+1],f[e+1]=f[d+1],f[d+1]=c,e=d;return{index:a,value:b,length:this.length}};var E,F=2,G={NONE:0,r:1,k:F,O:3},H=[];for(E=0;288>E;E++)switch(v){case 143>=E:H.push([E+48,8]);break;case 255>=E:H.push([E-144+400,9]);break;case 279>=E:H.push([E-256+0,7]);break;case 287>=E:H.push([E-280+192,8]);break;default:a("invalid literal: "+E)}f.prototype.j=function(){var b,d,e,f,g=this.input;switch(this.h){case 0:for(e=0,f=g.length;f>e;){d=x?g.subarray(e,e+65535):g.slice(e,e+65535),e+=d.length;var i=d,k=e===f,m=u,n=u,o=u,p=u,q=u,r=this.a,s=this.b;if(x){for(r=new Uint8Array(this.a.buffer);r.length<=s+i.length+5;)r=new Uint8Array(r.length<<1);r.set(this.a)}if(m=k?1:0,r[s++]=0|m,n=i.length,o=~n+65536&65535,r[s++]=255&n,r[s++]=n>>>8&255,r[s++]=255&o,r[s++]=o>>>8&255,x)r.set(i,s),s+=i.length,r=r.subarray(0,s);else{for(p=0,q=i.length;q>p;++p)r[s++]=i[p];r.length=s}this.b=s,this.a=r}break;case 1:var t=new c(x?new Uint8Array(this.a.buffer):this.a,this.b);t.d(1,1,v),t.d(1,2,v);var w,y,z,A=h(this,g);for(w=0,y=A.length;y>w;w++)if(z=A[w],c.prototype.d.apply(t,H[z]),z>256)t.d(A[++w],A[++w],v),t.d(A[++w],5),t.d(A[++w],A[++w],v);else if(256===z)break;this.a=t.finish(),this.b=this.a.length;break;case F:var B,C,D,E,G,I,J,K,L,M,N,O,P,Q,R,S=new c(x?new Uint8Array(this.a.buffer):this.a,this.b),T=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15],U=Array(19);for(B=F,S.d(1,1,v),S.d(B,2,v),C=h(this,g),I=j(this.M,15),J=l(I),K=j(this.L,7),L=l(K),D=286;D>257&&0===I[D-1];D--);for(E=30;E>1&&0===K[E-1];E--);var V,W,X,Y,Z,$,_=D,aa=E,ba=new(x?Uint32Array:Array)(_+aa),ca=new(x?Uint32Array:Array)(316),da=new(x?Uint8Array:Array)(19);for(V=W=0;_>V;V++)ba[W++]=I[V];for(V=0;aa>V;V++)ba[W++]=K[V];if(!x)for(V=0,Y=da.length;Y>V;++V)da[V]=0;for(V=Z=0,Y=ba.length;Y>V;V+=W){for(W=1;Y>V+W&&ba[V+W]===ba[V];++W);if(X=W,0===ba[V])if(3>X)for(;0<X--;)ca[Z++]=0,da[0]++;else for(;X>0;)$=138>X?X:138,$>X-3&&X>$&&($=X-3),10>=$?(ca[Z++]=17,ca[Z++]=$-3,da[17]++):(ca[Z++]=18,ca[Z++]=$-11,da[18]++),X-=$;else if(ca[Z++]=ba[V],da[ba[V]]++,X--,3>X)for(;0<X--;)ca[Z++]=ba[V],da[ba[V]]++;else for(;X>0;)$=6>X?X:6,$>X-3&&X>$&&($=X-3),ca[Z++]=16,ca[Z++]=$-3,da[16]++,X-=$}for(b=x?ca.subarray(0,Z):ca.slice(0,Z),M=j(da,7),Q=0;19>Q;Q++)U[Q]=M[T[Q]];for(G=19;G>4&&0===U[G-1];G--);for(N=l(M),S.d(D-257,5,v),S.d(E-1,5,v),S.d(G-4,4,v),Q=0;G>Q;Q++)S.d(U[Q],3,v);for(Q=0,R=b.length;R>Q;Q++)if(O=b[Q],S.d(N[O],M[O],v),O>=16){switch(Q++,O){case 16:P=2;break;case 17:P=3;break;case 18:P=7;break;default:a("invalid code: "+O)}S.d(b[Q],P,v)}var ea,fa,ga,ha,ia,ja,ka,la,ma=[J,I],na=[L,K];for(ia=ma[0],ja=ma[1],ka=na[0],la=na[1],ea=0,fa=C.length;fa>ea;++ea)if(ga=C[ea],S.d(ia[ga],ja[ga],v),ga>256)S.d(C[++ea],C[++ea],v),ha=C[++ea],S.d(ka[ha],la[ha],v),S.d(C[++ea],C[++ea],v);else if(256===ga)break;this.a=S.finish(),this.b=this.a.length;break;default:a("invalid compression type")}return this.a};var I=function(){function b(b){switch(v){case 3===b:return[257,b-3,0];case 4===b:return[258,b-4,0];case 5===b:return[259,b-5,0];case 6===b:return[260,b-6,0];case 7===b:return[261,b-7,0];case 8===b:return[262,b-8,0];case 9===b:return[263,b-9,0];case 10===b:return[264,b-10,0];case 12>=b:return[265,b-11,1];case 14>=b:return[266,b-13,1];case 16>=b:return[267,b-15,1];case 18>=b:return[268,b-17,1];case 22>=b:return[269,b-19,2];case 26>=b:return[270,b-23,2];case 30>=b:return[271,b-27,2];case 34>=b:return[272,b-31,2];case 42>=b:return[273,b-35,3];case 50>=b:return[274,b-43,3];case 58>=b:return[275,b-51,3];case 66>=b:return[276,b-59,3];case 82>=b:return[277,b-67,4];case 98>=b:return[278,b-83,4];case 114>=b:return[279,b-99,4];case 130>=b:return[280,b-115,4];case 162>=b:return[281,b-131,5];case 194>=b:return[282,b-163,5];case 226>=b:return[283,b-195,5];case 257>=b:return[284,b-227,5];case 258===b:return[285,b-258,0];default:a("invalid length: "+b)}}var c,d,e=[];for(c=3;258>=c;c++)d=b(c),e[c]=d[2]<<24|d[1]<<16|d[0];return e}(),J=x?new Uint32Array(I):I,K=0,L=1,M={F:K,D:L};
	m.prototype.p=function(){for(;!this.s;){var b=n(this,3);switch(1&b&&(this.s=v),b>>>=1){case 0:var c=this.input,d=this.c,e=this.a,f=this.b,g=c.length,h=u,i=u,j=e.length,k=u;switch(this.e=this.g=0,d+1>=g&&a(Error("invalid uncompressed block header: LEN")),h=c[d++]|c[d++]<<8,d+1>=g&&a(Error("invalid uncompressed block header: NLEN")),i=c[d++]|c[d++]<<8,h===~i&&a(Error("invalid uncompressed block header: length verify")),d+h>c.length&&a(Error("input buffer is broken")),this.n){case K:for(;f+h>e.length;){if(k=j-f,h-=k,x)e.set(c.subarray(d,d+k),f),f+=k,d+=k;else for(;k--;)e[f++]=c[d++];this.b=f,e=this.f(),f=this.b}break;case L:for(;f+h>e.length;)e=this.f({v:2});break;default:a(Error("invalid inflate mode"))}if(x)e.set(c.subarray(d,d+h),f),f+=h,d+=h;else for(;h--;)e[f++]=c[d++];this.c=d,this.b=f,this.a=e;break;case 1:this.o(aa,ca);break;case 2:p(this);break;default:a(Error("unknown BTYPE: "+b))}}return this.t()};var N,O,P=[16,17,18,0,8,7,9,6,10,5,11,4,12,3,13,2,14,1,15],Q=x?new Uint16Array(P):P,R=[3,4,5,6,7,8,9,10,11,13,15,17,19,23,27,31,35,43,51,59,67,83,99,115,131,163,195,227,258,258,258],S=x?new Uint16Array(R):R,T=[0,0,0,0,0,0,0,0,1,1,1,1,2,2,2,2,3,3,3,3,4,4,4,4,5,5,5,5,0,0,0],U=x?new Uint8Array(T):T,V=[1,2,3,4,5,7,9,13,17,25,33,49,65,97,129,193,257,385,513,769,1025,1537,2049,3073,4097,6145,8193,12289,16385,24577],W=x?new Uint16Array(V):V,X=[0,0,0,0,1,1,2,2,3,3,4,4,5,5,6,6,7,7,8,8,9,9,10,10,11,11,12,12,13,13],Y=x?new Uint8Array(X):X,Z=new(x?Uint8Array:Array)(288);for(N=0,O=Z.length;O>N;++N)Z[N]=143>=N?8:255>=N?9:279>=N?7:8;var $,_,aa=e(Z),ba=new(x?Uint8Array:Array)(30);for($=0,_=ba.length;_>$;++$)ba[$]=5;var ca=e(ba);m.prototype.o=function(a,b){var c=this.a,d=this.b;this.u=a;for(var e,f,g,h,i=c.length-258;256!==(e=o(this,a));)if(256>e)d>=i&&(this.b=d,c=this.f(),d=this.b),c[d++]=e;else for(f=e-257,h=S[f],0<U[f]&&(h+=n(this,U[f])),e=o(this,b),g=W[e],0<Y[e]&&(g+=n(this,Y[e])),d>=i&&(this.b=d,c=this.f(),d=this.b);h--;)c[d]=c[d++-g];for(;8<=this.e;)this.e-=8,this.c--;this.b=d},m.prototype.J=function(a,b){var c=this.a,d=this.b;this.u=a;for(var e,f,g,h,i=c.length;256!==(e=o(this,a));)if(256>e)d>=i&&(c=this.f(),i=c.length),c[d++]=e;else for(f=e-257,h=S[f],0<U[f]&&(h+=n(this,U[f])),e=o(this,b),g=W[e],0<Y[e]&&(g+=n(this,Y[e])),d+h>i&&(c=this.f(),i=c.length);h--;)c[d]=c[d++-g];for(;8<=this.e;)this.e-=8,this.c--;this.b=d},m.prototype.f=function(){var a,b,c=new(x?Uint8Array:Array)(this.b-32768),d=this.b-32768,e=this.a;if(x)c.set(e.subarray(32768,c.length));else for(a=0,b=c.length;b>a;++a)c[a]=e[a+32768];if(this.l.push(c),this.q+=c.length,x)e.set(e.subarray(d,d+32768));else for(a=0;32768>a;++a)e[a]=e[d+a];return this.b=32768,e},m.prototype.K=function(a){var b,c,d,e,f=this.input.length/this.c+1|0,g=this.input,h=this.a;return a&&("number"==typeof a.v&&(f=a.v),"number"==typeof a.G&&(f+=a.G)),2>f?(c=(g.length-this.c)/this.u[2],e=258*(c/2)|0,d=e<h.length?h.length+e:h.length<<1):d=h.length*f,x?(b=new Uint8Array(d),b.set(h)):b=h,this.a=b},m.prototype.t=function(){var a,b,c,d,e,f=0,g=this.a,h=this.l,i=new(x?Uint8Array:Array)(this.q+(this.b-32768));if(0===h.length)return x?this.a.subarray(32768,this.b):this.a.slice(32768,this.b);for(b=0,c=h.length;c>b;++b)for(a=h[b],d=0,e=a.length;e>d;++d)i[f++]=a[d];for(b=32768,c=this.b;c>b;++b)i[f++]=g[b];return this.l=[],this.buffer=i},m.prototype.I=function(){var a,b=this.b;return x?this.C?(a=new Uint8Array(b),a.set(this.a.subarray(0,b))):a=this.a.subarray(0,b):(this.a.length>b&&(this.a.length=b),a=this.a),this.buffer=a},r.prototype.p=function(){var b,c,d=this.input;return b=this.B.p(),this.c=this.B.c,this.N&&(c=(d[this.c++]<<24|d[this.c++]<<16|d[this.c++]<<8|d[this.c++])>>>0,c!==q(b)&&a(Error("invalid adler-32 checksum"))),b};var da=8,ea=G;s.prototype.j=function(){var b,c,d,e,f,g,h,i=0;switch(h=this.a,b=da){case da:c=Math.LOG2E*Math.log(32768)-8;break;default:a(Error("invalid compression method"))}switch(d=c<<4|b,h[i++]=d,b){case da:switch(this.h){case ea.NONE:f=0;break;case ea.r:f=1;break;case ea.k:f=2;break;default:a(Error("unsupported compression type"))}break;default:a(Error("invalid compression method"))}return e=f<<6|0,h[i++]=e|31-(256*d+e)%31,g=q(this.input),this.A.b=i,h=this.A.j(),i=h.length,x&&(h=new Uint8Array(h.buffer),h.length<=i+4&&(this.a=new Uint8Array(h.length+4),this.a.set(h),h=this.a),h=h.subarray(0,i+4)),h[i++]=g>>24&255,h[i++]=g>>16&255,h[i++]=g>>8&255,h[i++]=255&g,h},b("Zlib.Inflate",r),b("Zlib.Inflate.prototype.decompress",r.prototype.p),t("Zlib.Inflate.BufferType",{ADAPTIVE:M.D,BLOCK:M.F}),b("Zlib.Deflate",s),b("Zlib.Deflate.compress",function(a,b){return new s(a,b).j()}),b("Zlib.Deflate.prototype.compress",s.prototype.j),t("Zlib.Deflate.CompressionType",{NONE:ea.NONE,FIXED:ea.r,DYNAMIC:ea.k})}).call(this)},{}],5:[function(a,b,c){var d=a("../enums.js");b.exports={prefer_hash_algorithm:d.hash.sha256,encryption_cipher:d.symmetric.aes256,compression:d.compression.zip,integrity_protect:!0,ignore_mdc_error:!1,rsa_blinding:!0,useWebCrypto:!0,show_version:!0,show_comment:!0,versionstring:"OpenPGP.js v1.6.2",commentstring:"http://openpgpjs.org",keyserver:"https://keyserver.ubuntu.com",node_store:"./openpgp.store",debug:!1}},{"../enums.js":32}],6:[function(a,b,c){b.exports=a("./config.js")},{"./config.js":5}],7:[function(a,b,c){"use strict";var d=a("../util.js"),e=a("./cipher");b.exports={encrypt:function(a,b,c,f,g){b=new e[b](f);var h=b.blockSize,i=new Uint8Array(h),j=new Uint8Array(h);a=a+a.charAt(h-2)+a.charAt(h-1);var k,l,m,n=new Uint8Array(c.length+2+2*h),o=g?0:2;for(k=0;h>k;k++)i[k]=0;for(j=b.encrypt(i),k=0;h>k;k++)n[k]=j[k]^a.charCodeAt(k);for(i.set(n.subarray(0,h)),j=b.encrypt(i),n[h]=j[0]^a.charCodeAt(h),n[h+1]=j[1]^a.charCodeAt(h+1),g?i.set(n.subarray(2,h+2)):i.set(n.subarray(0,h)),j=b.encrypt(i),k=0;h>k;k++)n[h+2+k]=j[k+o]^c.charCodeAt(k);for(l=h;l<c.length+o;l+=h)for(m=l+2-o,i.set(n.subarray(m,m+h)),j=b.encrypt(i),k=0;h>k;k++)n[h+m+k]=j[k]^c.charCodeAt(l+k-o);return n=n.subarray(0,c.length+2+h),d.Uint8Array2str(n)},mdc:function(a,b,c){a=new e[a](b);var f,g=a.blockSize,h=new Uint8Array(g),i=new Uint8Array(g);for(f=0;g>f;f++)h[f]=0;for(h=a.encrypt(h),f=0;g>f;f++)i[f]=c.charCodeAt(f),h[f]^=i[f];return i=a.encrypt(i),d.bin2str(h)+String.fromCharCode(i[0]^c.charCodeAt(g))+String.fromCharCode(i[1]^c.charCodeAt(g+1))},decrypt:function(a,b,c,d){a=new e[a](b);var f,g=a.blockSize,h=new Uint8Array(g),i=new Uint8Array(g),j="",k=[];for(f=0;g>f;f++)h[f]=0;for(h=a.encrypt(h),f=0;g>f;f++)i[f]=c.charCodeAt(f),h[f]^=i[f];if(i=a.encrypt(i),h[g-2]!=(i[0]^c.charCodeAt(g))||h[g-1]!=(i[1]^c.charCodeAt(g+1)))throw new Error("CFB decrypt: invalid key");if(d){for(f=0;g>f;f++)h[f]=c.charCodeAt(f+2);for(j=g+2;j<c.length;j+=g)for(i=a.encrypt(h),f=0;g>f&&f+j<c.length;f++)h[f]=c.charCodeAt(j+f),k.push(String.fromCharCode(i[f]^h[f]))}else{for(f=0;g>f;f++)h[f]=c.charCodeAt(f);for(j=g;j<c.length;j+=g)for(i=a.encrypt(h),f=0;g>f&&f+j<c.length;f++)h[f]=c.charCodeAt(j+f),k.push(String.fromCharCode(i[f]^h[f]))}return d||k.splice(0,2),k.splice(c.length-g-2),k},normalEncrypt:function(a,b,c,f){a=new e[a](b);var g=a.blockSize,h="",i="",j=0,k="",l="";for(i=f.substring(0,g);c.length>g*j;){var m=a.encrypt(d.str2bin(i));h=c.substring(j*g,j*g+g);for(var n=0;n<h.length;n++)l+=String.fromCharCode(h.charCodeAt(n)^m[n]);i=l,l="",k+=i,j++}return k},normalDecrypt:function(a,b,c,f){a=new e[a](b);var g,h=a.blockSize,i="",j=0,k="",l=0;if(null===f)for(g=0;h>g;g++)i+=String.fromCharCode(0);else i=f.substring(0,h);for(;c.length>h*j;){var m=a.encrypt(d.str2bin(i));for(i=c.substring(j*h+l,j*h+h+l),g=0;g<i.length;g++)k+=String.fromCharCode(i.charCodeAt(g)^m[g]);j++}return k}}},{"../util.js":65,"./cipher":12}],8:[function(a,b,c){"use strict";function d(a){return 255&a}function e(a){return a>>8&255}function f(a){return a>>16&255}function g(a){return a>>24&255}function h(a,b,c,d){return e(p[255&a])|e(p[b>>8&255])<<8|e(p[c>>16&255])<<16|e(p[d>>>24])<<24}function i(a){var b,c,d=a.length,e=new Array(d/4);if(a&&!(d%4)){for(b=0,c=0;d>c;c+=4)e[b++]=a[c]|a[c+1]<<8|a[c+2]<<16|a[c+3]<<24;return e}}function j(a){var b,c=0,h=a.length,i=new Array(4*h);for(b=0;h>b;b++)i[c++]=d(a[b]),i[c++]=e(a[b]),i[c++]=f(a[b]),i[c++]=g(a[b]);return i}function k(a){var b,c,h,i,j,k,l=new Array(u+1),m=a.length,p=new Array(t),q=new Array(t),r=0;if(16==m)k=10,b=4;else if(24==m)k=12,b=6;else{if(32!=m)throw new Error("Invalid key-length for AES key:"+m);k=14,b=8}for(c=0;u+1>c;c++)l[c]=new Uint32Array(4);for(c=0,h=0;m>h;h++,c+=4)p[h]=a.charCodeAt(c)|a.charCodeAt(c+1)<<8|a.charCodeAt(c+2)<<16|a.charCodeAt(c+3)<<24;for(h=b-1;h>=0;h--)q[h]=p[h];for(i=0,j=0,h=0;b>h&&k+1>i;){for(;b>h&&4>j;h++,j++)l[i][j]=q[h];4==j&&(i++,j=0)}for(;k+1>i;){var s=q[b-1];if(q[0]^=o[e(s)]|o[f(s)]<<8|o[g(s)]<<16|o[d(s)]<<24,q[0]^=n[r++],8!=b)for(h=1;b>h;h++)q[h]^=q[h-1];else{for(h=1;b/2>h;h++)q[h]^=q[h-1];for(s=q[b/2-1],q[b/2]^=o[d(s)]|o[e(s)]<<8|o[f(s)]<<16|o[g(s)]<<24,h=b/2+1;b>h;h++)q[h]^=q[h-1]}for(h=0;b>h&&k+1>i;){for(;b>h&&4>j;h++,j++)l[i][j]=q[h];4==j&&(i++,j=0)}}return{rounds:k,rk:l}}function l(a,b,c){var d,e,f;for(f=i(a),e=b.rounds,d=0;e-1>d;d++)c[0]=f[0]^b.rk[d][0],c[1]=f[1]^b.rk[d][1],c[2]=f[2]^b.rk[d][2],c[3]=f[3]^b.rk[d][3],f[0]=p[255&c[0]]^q[c[1]>>8&255]^r[c[2]>>16&255]^s[c[3]>>>24],f[1]=p[255&c[1]]^q[c[2]>>8&255]^r[c[3]>>16&255]^s[c[0]>>>24],f[2]=p[255&c[2]]^q[c[3]>>8&255]^r[c[0]>>16&255]^s[c[1]>>>24],f[3]=p[255&c[3]]^q[c[0]>>8&255]^r[c[1]>>16&255]^s[c[2]>>>24];return d=e-1,c[0]=f[0]^b.rk[d][0],c[1]=f[1]^b.rk[d][1],c[2]=f[2]^b.rk[d][2],c[3]=f[3]^b.rk[d][3],f[0]=h(c[0],c[1],c[2],c[3])^b.rk[e][0],f[1]=h(c[1],c[2],c[3],c[0])^b.rk[e][1],f[2]=h(c[2],c[3],c[0],c[1])^b.rk[e][2],f[3]=h(c[3],c[0],c[1],c[2])^b.rk[e][3],j(f)}function m(a){var b=function(a){this.key=k(a),this._temp=new Uint32Array(this.blockSize/4),this.encrypt=function(a){return l(a,this.key,this._temp)}};return b.blockSize=b.prototype.blockSize=16,b.keySize=b.prototype.keySize=a/8,b}var n=(a("../../util.js"),new Uint8Array([1,2,4,8,16,32,64,128,27,54,108,216,171,77,154,47,94,188,99,198,151,53,106,212,179,125,250,239,197,145])),o=new Uint8Array([99,124,119,123,242,107,111,197,48,1,103,43,254,215,171,118,202,130,201,125,250,89,71,240,173,212,162,175,156,164,114,192,183,253,147,38,54,63,247,204,52,165,229,241,113,216,49,21,4,199,35,195,24,150,5,154,7,18,128,226,235,39,178,117,9,131,44,26,27,110,90,160,82,59,214,179,41,227,47,132,83,209,0,237,32,252,177,91,106,203,190,57,74,76,88,207,208,239,170,251,67,77,51,133,69,249,2,127,80,60,159,168,81,163,64,143,146,157,56,245,188,182,218,33,16,255,243,210,205,12,19,236,95,151,68,23,196,167,126,61,100,93,25,115,96,129,79,220,34,42,144,136,70,238,184,20,222,94,11,219,224,50,58,10,73,6,36,92,194,211,172,98,145,149,228,121,231,200,55,109,141,213,78,169,108,86,244,234,101,122,174,8,186,120,37,46,28,166,180,198,232,221,116,31,75,189,139,138,112,62,181,102,72,3,246,14,97,53,87,185,134,193,29,158,225,248,152,17,105,217,142,148,155,30,135,233,206,85,40,223,140,161,137,13,191,230,66,104,65,153,45,15,176,84,187,22]),p=new Uint32Array([2774754246,2222750968,2574743534,2373680118,234025727,3177933782,2976870366,1422247313,1345335392,50397442,2842126286,2099981142,436141799,1658312629,3870010189,2591454956,1170918031,2642575903,1086966153,2273148410,368769775,3948501426,3376891790,200339707,3970805057,1742001331,4255294047,3937382213,3214711843,4154762323,2524082916,1539358875,3266819957,486407649,2928907069,1780885068,1513502316,1094664062,49805301,1338821763,1546925160,4104496465,887481809,150073849,2473685474,1943591083,1395732834,1058346282,201589768,1388824469,1696801606,1589887901,672667696,2711000631,251987210,3046808111,151455502,907153956,2608889883,1038279391,652995533,1764173646,3451040383,2675275242,453576978,2659418909,1949051992,773462580,756751158,2993581788,3998898868,4221608027,4132590244,1295727478,1641469623,3467883389,2066295122,1055122397,1898917726,2542044179,4115878822,1758581177,0,753790401,1612718144,536673507,3367088505,3982187446,3194645204,1187761037,3653156455,1262041458,3729410708,3561770136,3898103984,1255133061,1808847035,720367557,3853167183,385612781,3309519750,3612167578,1429418854,2491778321,3477423498,284817897,100794884,2172616702,4031795360,1144798328,3131023141,3819481163,4082192802,4272137053,3225436288,2324664069,2912064063,3164445985,1211644016,83228145,3753688163,3249976951,1977277103,1663115586,806359072,452984805,250868733,1842533055,1288555905,336333848,890442534,804056259,3781124030,2727843637,3427026056,957814574,1472513171,4071073621,2189328124,1195195770,2892260552,3881655738,723065138,2507371494,2690670784,2558624025,3511635870,2145180835,1713513028,2116692564,2878378043,2206763019,3393603212,703524551,3552098411,1007948840,2044649127,3797835452,487262998,1994120109,1004593371,1446130276,1312438900,503974420,3679013266,168166924,1814307912,3831258296,1573044895,1859376061,4021070915,2791465668,2828112185,2761266481,937747667,2339994098,854058965,1137232011,1496790894,3077402074,2358086913,1691735473,3528347292,3769215305,3027004632,4199962284,133494003,636152527,2942657994,2390391540,3920539207,403179536,3585784431,2289596656,1864705354,1915629148,605822008,4054230615,3350508659,1371981463,602466507,2094914977,2624877800,555687742,3712699286,3703422305,2257292045,2240449039,2423288032,1111375484,3300242801,2858837708,3628615824,84083462,32962295,302911004,2741068226,1597322602,4183250862,3501832553,2441512471,1489093017,656219450,3114180135,954327513,335083755,3013122091,856756514,3144247762,1893325225,2307821063,2811532339,3063651117,572399164,2458355477,552200649,1238290055,4283782570,2015897680,2061492133,2408352771,4171342169,2156497161,386731290,3669999461,837215959,3326231172,3093850320,3275833730,2962856233,1999449434,286199582,3417354363,4233385128,3602627437,974525996]),q=new Uint32Array([1667483301,2088564868,2004348569,2071721613,4076011277,1802229437,1869602481,3318059348,808476752,16843267,1734856361,724260477,4278118169,3621238114,2880130534,1987505306,3402272581,2189565853,3385428288,2105408135,4210749205,1499050731,1195871945,4042324747,2913812972,3570709351,2728550397,2947499498,2627478463,2762232823,1920132246,3233848155,3082253762,4261273884,2475900334,640044138,909536346,1061125697,4160222466,3435955023,875849820,2779075060,3857043764,4059166984,1903288979,3638078323,825320019,353708607,67373068,3351745874,589514341,3284376926,404238376,2526427041,84216335,2593796021,117902857,303178806,2155879323,3806519101,3958099238,656887401,2998042573,1970662047,151589403,2206408094,741103732,437924910,454768173,1852759218,1515893998,2694863867,1381147894,993752653,3604395873,3014884814,690573947,3823361342,791633521,2223248279,1397991157,3520182632,0,3991781676,538984544,4244431647,2981198280,1532737261,1785386174,3419114822,3200149465,960066123,1246401758,1280088276,1482207464,3486483786,3503340395,4025468202,2863288293,4227591446,1128498885,1296931543,859006549,2240090516,1162185423,4193904912,33686534,2139094657,1347461360,1010595908,2678007226,2829601763,1364304627,2745392638,1077969088,2408514954,2459058093,2644320700,943222856,4126535940,3166462943,3065411521,3671764853,555827811,269492272,4294960410,4092853518,3537026925,3452797260,202119188,320022069,3974939439,1600110305,2543269282,1145342156,387395129,3301217111,2812761586,2122251394,1027439175,1684326572,1566423783,421081643,1936975509,1616953504,2172721560,1330618065,3705447295,572671078,707417214,2425371563,2290617219,1179028682,4008625961,3099093971,336865340,3739133817,1583267042,185275933,3688607094,3772832571,842163286,976909390,168432670,1229558491,101059594,606357612,1549580516,3267534685,3553869166,2896970735,1650640038,2442213800,2509582756,3840201527,2038035083,3890730290,3368586051,926379609,1835915959,2374828428,3587551588,1313774802,2846444e3,1819072692,1448520954,4109693703,3941256997,1701169839,2054878350,2930657257,134746136,3132780501,2021191816,623200879,774790258,471611428,2795919345,3031724999,3334903633,3907570467,3722289532,1953818780,522141217,1263245021,3183305180,2341145990,2324303749,1886445712,1044282434,3048567236,1718013098,1212715224,50529797,4143380225,235805714,1633796771,892693087,1465364217,3115936208,2256934801,3250690392,488454695,2661164985,3789674808,4177062675,2560109491,286335539,1768542907,3654920560,2391672713,2492740519,2610638262,505297954,2273777042,3924412704,3469641545,1431677695,673730680,3755976058,2357986191,2711706104,2307459456,218962455,3216991706,3873888049,1111655622,1751699640,1094812355,2576951728,757946999,252648977,2964356043,1414834428,3149622742,370551866]),r=new Uint32Array([1673962851,2096661628,2012125559,2079755643,4076801522,1809235307,1876865391,3314635973,811618352,16909057,1741597031,727088427,4276558334,3618988759,2874009259,1995217526,3398387146,2183110018,3381215433,2113570685,4209972730,1504897881,1200539975,4042984432,2906778797,3568527316,2724199842,2940594863,2619588508,2756966308,1927583346,3231407040,3077948087,4259388669,2470293139,642542118,913070646,1065238847,4160029431,3431157708,879254580,2773611685,3855693029,4059629809,1910674289,3635114968,828527409,355090197,67636228,3348452039,591815971,3281870531,405809176,2520228246,84545285,2586817946,118360327,304363026,2149292928,3806281186,3956090603,659450151,2994720178,1978310517,152181513,2199756419,743994412,439627290,456535323,1859957358,1521806938,2690382752,1386542674,997608763,3602342358,3011366579,693271337,3822927587,794718511,2215876484,1403450707,3518589137,0,3988860141,541089824,4242743292,2977548465,1538714971,1792327274,3415033547,3194476990,963791673,1251270218,1285084236,1487988824,3481619151,3501943760,4022676207,2857362858,4226619131,1132905795,1301993293,862344499,2232521861,1166724933,4192801017,33818114,2147385727,1352724560,1014514748,2670049951,2823545768,1369633617,2740846243,1082179648,2399505039,2453646738,2636233885,946882616,4126213365,3160661948,3061301686,3668932058,557998881,270544912,4293204735,4093447923,3535760850,3447803085,202904588,321271059,3972214764,1606345055,2536874647,1149815876,388905239,3297990596,2807427751,2130477694,1031423805,1690872932,1572530013,422718233,1944491379,1623236704,2165938305,1335808335,3701702620,574907938,710180394,2419829648,2282455944,1183631942,4006029806,3094074296,338181140,3735517662,1589437022,185998603,3685578459,3772464096,845436466,980700730,169090570,1234361161,101452294,608726052,1555620956,3265224130,3552407251,2890133420,1657054818,2436475025,2503058581,3839047652,2045938553,3889509095,3364570056,929978679,1843050349,2365688973,3585172693,1318900302,2840191145,1826141292,1454176854,4109567988,3939444202,1707781989,2062847610,2923948462,135272456,3127891386,2029029496,625635109,777810478,473441308,2790781350,3027486644,3331805638,3905627112,3718347997,1961401460,524165407,1268178251,3177307325,2332919435,2316273034,1893765232,1048330814,3044132021,1724688998,1217452104,50726147,4143383030,236720654,1640145761,896163637,1471084887,3110719673,2249691526,3248052417,490350365,2653403550,3789109473,4176155640,2553000856,287453969,1775418217,3651760345,2382858638,2486413204,2603464347,507257374,2266337927,3922272489,3464972750,1437269845,676362280,3752164063,2349043596,2707028129,2299101321,219813645,3211123391,3872862694,1115997762,1758509160,1099088705,2569646233,760903469,253628687,2960903088,1420360788,3144537787,371997206]),s=new Uint32Array([3332727651,4169432188,4003034999,4136467323,4279104242,3602738027,3736170351,2438251973,1615867952,33751297,3467208551,1451043627,3877240574,3043153879,1306962859,3969545846,2403715786,530416258,2302724553,4203183485,4011195130,3001768281,2395555655,4211863792,1106029997,3009926356,1610457762,1173008303,599760028,1408738468,3835064946,2606481600,1975695287,3776773629,1034851219,1282024998,1817851446,2118205247,4110612471,2203045068,1750873140,1374987685,3509904869,4178113009,3801313649,2876496088,1649619249,708777237,135005188,2505230279,1181033251,2640233411,807933976,933336726,168756485,800430746,235472647,607523346,463175808,3745374946,3441880043,1315514151,2144187058,3936318837,303761673,496927619,1484008492,875436570,908925723,3702681198,3035519578,1543217312,2767606354,1984772923,3076642518,2110698419,1383803177,3711886307,1584475951,328696964,2801095507,3110654417,0,3240947181,1080041504,3810524412,2043195825,3069008731,3569248874,2370227147,1742323390,1917532473,2497595978,2564049996,2968016984,2236272591,3144405200,3307925487,1340451498,3977706491,2261074755,2597801293,1716859699,294946181,2328839493,3910203897,67502594,4269899647,2700103760,2017737788,632987551,1273211048,2733855057,1576969123,2160083008,92966799,1068339858,566009245,1883781176,4043634165,1675607228,2009183926,2943736538,1113792801,540020752,3843751935,4245615603,3211645650,2169294285,403966988,641012499,3274697964,3202441055,899848087,2295088196,775493399,2472002756,1441965991,4236410494,2051489085,3366741092,3135724893,841685273,3868554099,3231735904,429425025,2664517455,2743065820,1147544098,1417554474,1001099408,193169544,2362066502,3341414126,1809037496,675025940,2809781982,3168951902,371002123,2910247899,3678134496,1683370546,1951283770,337512970,2463844681,201983494,1215046692,3101973596,2673722050,3178157011,1139780780,3299238498,967348625,832869781,3543655652,4069226873,3576883175,2336475336,1851340599,3669454189,25988493,2976175573,2631028302,1239460265,3635702892,2902087254,4077384948,3475368682,3400492389,4102978170,1206496942,270010376,1876277946,4035475576,1248797989,1550986798,941890588,1475454630,1942467764,2538718918,3408128232,2709315037,3902567540,1042358047,2531085131,1641856445,226921355,260409994,3767562352,2084716094,1908716981,3433719398,2430093384,100991747,4144101110,470945294,3265487201,1784624437,2935576407,1775286713,395413126,2572730817,975641885,666476190,3644383713,3943954680,733190296,573772049,3535497577,2842745305,126455438,866620564,766942107,1008868894,361924487,3374377449,2269761230,2868860245,1350051880,2776293343,59739276,1509466529,159418761,437718285,1708834751,3610371814,2227585602,3501746280,2193834305,699439513,1517759789,504434447,2076946608,2835108948,1842789307,742004246]),t=8,u=14;b.exports={};var v=[128,192,256];for(var w in v)b.exports[v[w]]=m(v[w])},{"../../util.js":65}],9:[function(a,b,c){function d(){}function e(a){this.bf=new d,this.bf.init(f.str2bin(a)),this.encrypt=function(a){return this.bf.encrypt_block(a)}}d.prototype.BLOCKSIZE=8,d.prototype.SBOXES=[[3509652390,2564797868,805139163,3491422135,3101798381,1780907670,3128725573,4046225305,614570311,3012652279,134345442,2240740374,1667834072,1901547113,2757295779,4103290238,227898511,1921955416,1904987480,2182433518,2069144605,3260701109,2620446009,720527379,3318853667,677414384,3393288472,3101374703,2390351024,1614419982,1822297739,2954791486,3608508353,3174124327,2024746970,1432378464,3864339955,2857741204,1464375394,1676153920,1439316330,715854006,3033291828,289532110,2706671279,2087905683,3018724369,1668267050,732546397,1947742710,3462151702,2609353502,2950085171,1814351708,2050118529,680887927,999245976,1800124847,3300911131,1713906067,1641548236,4213287313,1216130144,1575780402,4018429277,3917837745,3693486850,3949271944,596196993,3549867205,258830323,2213823033,772490370,2760122372,1774776394,2652871518,566650946,4142492826,1728879713,2882767088,1783734482,3629395816,2517608232,2874225571,1861159788,326777828,3124490320,2130389656,2716951837,967770486,1724537150,2185432712,2364442137,1164943284,2105845187,998989502,3765401048,2244026483,1075463327,1455516326,1322494562,910128902,469688178,1117454909,936433444,3490320968,3675253459,1240580251,122909385,2157517691,634681816,4142456567,3825094682,3061402683,2540495037,79693498,3249098678,1084186820,1583128258,426386531,1761308591,1047286709,322548459,995290223,1845252383,2603652396,3431023940,2942221577,3202600964,3727903485,1712269319,422464435,3234572375,1170764815,3523960633,3117677531,1434042557,442511882,3600875718,1076654713,1738483198,4213154764,2393238008,3677496056,1014306527,4251020053,793779912,2902807211,842905082,4246964064,1395751752,1040244610,2656851899,3396308128,445077038,3742853595,3577915638,679411651,2892444358,2354009459,1767581616,3150600392,3791627101,3102740896,284835224,4246832056,1258075500,768725851,2589189241,3069724005,3532540348,1274779536,3789419226,2764799539,1660621633,3471099624,4011903706,913787905,3497959166,737222580,2514213453,2928710040,3937242737,1804850592,3499020752,2949064160,2386320175,2390070455,2415321851,4061277028,2290661394,2416832540,1336762016,1754252060,3520065937,3014181293,791618072,3188594551,3933548030,2332172193,3852520463,3043980520,413987798,3465142937,3030929376,4245938359,2093235073,3534596313,375366246,2157278981,2479649556,555357303,3870105701,2008414854,3344188149,4221384143,3956125452,2067696032,3594591187,2921233993,2428461,544322398,577241275,1471733935,610547355,4027169054,1432588573,1507829418,2025931657,3646575487,545086370,48609733,2200306550,1653985193,298326376,1316178497,3007786442,2064951626,458293330,2589141269,3591329599,3164325604,727753846,2179363840,146436021,1461446943,4069977195,705550613,3059967265,3887724982,4281599278,3313849956,1404054877,2845806497,146425753,1854211946],[1266315497,3048417604,3681880366,3289982499,290971e4,1235738493,2632868024,2414719590,3970600049,1771706367,1449415276,3266420449,422970021,1963543593,2690192192,3826793022,1062508698,1531092325,1804592342,2583117782,2714934279,4024971509,1294809318,4028980673,1289560198,2221992742,1669523910,35572830,157838143,1052438473,1016535060,1802137761,1753167236,1386275462,3080475397,2857371447,1040679964,2145300060,2390574316,1461121720,2956646967,4031777805,4028374788,33600511,2920084762,1018524850,629373528,3691585981,3515945977,2091462646,2486323059,586499841,988145025,935516892,3367335476,2599673255,2839830854,265290510,3972581182,2759138881,3795373465,1005194799,847297441,406762289,1314163512,1332590856,1866599683,4127851711,750260880,613907577,1450815602,3165620655,3734664991,3650291728,3012275730,3704569646,1427272223,778793252,1343938022,2676280711,2052605720,1946737175,3164576444,3914038668,3967478842,3682934266,1661551462,3294938066,4011595847,840292616,3712170807,616741398,312560963,711312465,1351876610,322626781,1910503582,271666773,2175563734,1594956187,70604529,3617834859,1007753275,1495573769,4069517037,2549218298,2663038764,504708206,2263041392,3941167025,2249088522,1514023603,1998579484,1312622330,694541497,2582060303,2151582166,1382467621,776784248,2618340202,3323268794,2497899128,2784771155,503983604,4076293799,907881277,423175695,432175456,1378068232,4145222326,3954048622,3938656102,3820766613,2793130115,2977904593,26017576,3274890735,3194772133,1700274565,1756076034,4006520079,3677328699,720338349,1533947780,354530856,688349552,3973924725,1637815568,332179504,3949051286,53804574,2852348879,3044236432,1282449977,3583942155,3416972820,4006381244,1617046695,2628476075,3002303598,1686838959,431878346,2686675385,1700445008,1080580658,1009431731,832498133,3223435511,2605976345,2271191193,2516031870,1648197032,4164389018,2548247927,300782431,375919233,238389289,3353747414,2531188641,2019080857,1475708069,455242339,2609103871,448939670,3451063019,1395535956,2413381860,1841049896,1491858159,885456874,4264095073,4001119347,1565136089,3898914787,1108368660,540939232,1173283510,2745871338,3681308437,4207628240,3343053890,4016749493,1699691293,1103962373,3625875870,2256883143,3830138730,1031889488,3479347698,1535977030,4236805024,3251091107,2132092099,1774941330,1199868427,1452454533,157007616,2904115357,342012276,595725824,1480756522,206960106,497939518,591360097,863170706,2375253569,3596610801,1814182875,2094937945,3421402208,1082520231,3463918190,2785509508,435703966,3908032597,1641649973,2842273706,3305899714,1510255612,2148256476,2655287854,3276092548,4258621189,236887753,3681803219,274041037,1734335097,3815195456,3317970021,1899903192,1026095262,4050517792,356393447,2410691914,3873677099,3682840055],[3913112168,2491498743,4132185628,2489919796,1091903735,1979897079,3170134830,3567386728,3557303409,857797738,1136121015,1342202287,507115054,2535736646,337727348,3213592640,1301675037,2528481711,1895095763,1721773893,3216771564,62756741,2142006736,835421444,2531993523,1442658625,3659876326,2882144922,676362277,1392781812,170690266,3921047035,1759253602,3611846912,1745797284,664899054,1329594018,3901205900,3045908486,2062866102,2865634940,3543621612,3464012697,1080764994,553557557,3656615353,3996768171,991055499,499776247,1265440854,648242737,3940784050,980351604,3713745714,1749149687,3396870395,4211799374,3640570775,1161844396,3125318951,1431517754,545492359,4268468663,3499529547,1437099964,2702547544,3433638243,2581715763,2787789398,1060185593,1593081372,2418618748,4260947970,69676912,2159744348,86519011,2512459080,3838209314,1220612927,3339683548,133810670,1090789135,1078426020,1569222167,845107691,3583754449,4072456591,1091646820,628848692,1613405280,3757631651,526609435,236106946,48312990,2942717905,3402727701,1797494240,859738849,992217954,4005476642,2243076622,3870952857,3732016268,765654824,3490871365,2511836413,1685915746,3888969200,1414112111,2273134842,3281911079,4080962846,172450625,2569994100,980381355,4109958455,2819808352,2716589560,2568741196,3681446669,3329971472,1835478071,660984891,3704678404,4045999559,3422617507,3040415634,1762651403,1719377915,3470491036,2693910283,3642056355,3138596744,1364962596,2073328063,1983633131,926494387,3423689081,2150032023,4096667949,1749200295,3328846651,309677260,2016342300,1779581495,3079819751,111262694,1274766160,443224088,298511866,1025883608,3806446537,1145181785,168956806,3641502830,3584813610,1689216846,3666258015,3200248200,1692713982,2646376535,4042768518,1618508792,1610833997,3523052358,4130873264,2001055236,3610705100,2202168115,4028541809,2961195399,1006657119,2006996926,3186142756,1430667929,3210227297,1314452623,4074634658,4101304120,2273951170,1399257539,3367210612,3027628629,1190975929,2062231137,2333990788,2221543033,2438960610,1181637006,548689776,2362791313,3372408396,3104550113,3145860560,296247880,1970579870,3078560182,3769228297,1714227617,3291629107,3898220290,166772364,1251581989,493813264,448347421,195405023,2709975567,677966185,3703036547,1463355134,2715995803,1338867538,1343315457,2802222074,2684532164,233230375,2599980071,2000651841,3277868038,1638401717,4028070440,3237316320,6314154,819756386,300326615,590932579,1405279636,3267499572,3150704214,2428286686,3959192993,3461946742,1862657033,1266418056,963775037,2089974820,2263052895,1917689273,448879540,3550394620,3981727096,150775221,3627908307,1303187396,508620638,2975983352,2726630617,1817252668,1876281319,1457606340,908771278,3720792119,3617206836,2455994898,1729034894,1080033504],[976866871,3556439503,2881648439,1522871579,1555064734,1336096578,3548522304,2579274686,3574697629,3205460757,3593280638,3338716283,3079412587,564236357,2993598910,1781952180,1464380207,3163844217,3332601554,1699332808,1393555694,1183702653,3581086237,1288719814,691649499,2847557200,2895455976,3193889540,2717570544,1781354906,1676643554,2592534050,3230253752,1126444790,2770207658,2633158820,2210423226,2615765581,2414155088,3127139286,673620729,2805611233,1269405062,4015350505,3341807571,4149409754,1057255273,2012875353,2162469141,2276492801,2601117357,993977747,3918593370,2654263191,753973209,36408145,2530585658,25011837,3520020182,2088578344,530523599,2918365339,1524020338,1518925132,3760827505,3759777254,1202760957,3985898139,3906192525,674977740,4174734889,2031300136,2019492241,3983892565,4153806404,3822280332,352677332,2297720250,60907813,90501309,3286998549,1016092578,2535922412,2839152426,457141659,509813237,4120667899,652014361,1966332200,2975202805,55981186,2327461051,676427537,3255491064,2882294119,3433927263,1307055953,942726286,933058658,2468411793,3933900994,4215176142,1361170020,2001714738,2830558078,3274259782,1222529897,1679025792,2729314320,3714953764,1770335741,151462246,3013232138,1682292957,1483529935,471910574,1539241949,458788160,3436315007,1807016891,3718408830,978976581,1043663428,3165965781,1927990952,4200891579,2372276910,3208408903,3533431907,1412390302,2931980059,4132332400,1947078029,3881505623,4168226417,2941484381,1077988104,1320477388,886195818,18198404,3786409e3,2509781533,112762804,3463356488,1866414978,891333506,18488651,661792760,1628790961,3885187036,3141171499,876946877,2693282273,1372485963,791857591,2686433993,3759982718,3167212022,3472953795,2716379847,445679433,3561995674,3504004811,3574258232,54117162,3331405415,2381918588,3769707343,4154350007,1140177722,4074052095,668550556,3214352940,367459370,261225585,2610173221,4209349473,3468074219,3265815641,314222801,3066103646,3808782860,282218597,3406013506,3773591054,379116347,1285071038,846784868,2669647154,3771962079,3550491691,2305946142,453669953,1268987020,3317592352,3279303384,3744833421,2610507566,3859509063,266596637,3847019092,517658769,3462560207,3443424879,370717030,4247526661,2224018117,4143653529,4112773975,2788324899,2477274417,1456262402,2901442914,1517677493,1846949527,2295493580,3734397586,2176403920,1280348187,1908823572,3871786941,846861322,1172426758,3287448474,3383383037,1655181056,3139813346,901632758,1897031941,2986607138,3066810236,3447102507,1393639104,373351379,950779232,625454576,3124240540,4148612726,2007998917,544563296,2244738638,2330496472,2058025392,1291430526,424198748,50039436,29584100,3605783033,2429876329,2791104160,1057563949,3255363231,3075367218,3463963227,1469046755,985887462]],
	d.prototype.PARRAY=[608135816,2242054355,320440878,57701188,2752067618,698298832,137296536,3964562569,1160258022,953160567,3193202383,887688300,3232508343,3380367581,1065670069,3041331479,2450970073,2306472731],d.prototype.NN=16,d.prototype._clean=function(a){if(0>a){var b=2147483647&a;a=b+2147483648}return a},d.prototype._F=function(a){var b,c,d,e,f;return e=255&a,a>>>=8,d=255&a,a>>>=8,c=255&a,a>>>=8,b=255&a,f=this.sboxes[0][b]+this.sboxes[1][c],f^=this.sboxes[2][d],f+=this.sboxes[3][e]},d.prototype._encrypt_block=function(a){var b,c=a[0],d=a[1];for(b=0;b<this.NN;++b){c^=this.parray[b],d=this._F(c)^d;var e=c;c=d,d=e}c^=this.parray[this.NN+0],d^=this.parray[this.NN+1],a[0]=this._clean(d),a[1]=this._clean(c)},d.prototype.encrypt_block=function(a){var b,c=[0,0],d=this.BLOCKSIZE/2;for(b=0;b<this.BLOCKSIZE/2;++b)c[0]=c[0]<<8|255&a[b+0],c[1]=c[1]<<8|255&a[b+d];this._encrypt_block(c);var e=[];for(b=0;b<this.BLOCKSIZE/2;++b)e[b+0]=c[0]>>>24-8*b&255,e[b+d]=c[1]>>>24-8*b&255;return e},d.prototype._decrypt_block=function(a){var b,c=a[0],d=a[1];for(b=this.NN+1;b>1;--b){c^=this.parray[b],d=this._F(c)^d;var e=c;c=d,d=e}c^=this.parray[1],d^=this.parray[0],a[0]=this._clean(d),a[1]=this._clean(c)},d.prototype.init=function(a){var b,c=0;for(this.parray=[],b=0;b<this.NN+2;++b){var d,e=0;for(d=0;4>d;++d)e=e<<8|255&a[c],++c>=a.length&&(c=0);this.parray[b]=this.PARRAY[b]^e}for(this.sboxes=[],b=0;4>b;++b)for(this.sboxes[b]=[],c=0;256>c;++c)this.sboxes[b][c]=this.SBOXES[b][c];var f=[0,0];for(b=0;b<this.NN+2;b+=2)this._encrypt_block(f),this.parray[b+0]=f[0],this.parray[b+1]=f[1];for(b=0;4>b;++b)for(c=0;256>c;c+=2)this._encrypt_block(f),this.sboxes[b][c+0]=f[0],this.sboxes[b][c+1]=f[1]};var f=a("../../util.js");b.exports=e,b.exports.keySize=e.prototype.keySize=16,b.exports.blockSize=e.prototype.blockSize=16},{"../../util.js":65}],10:[function(a,b,c){function d(){function a(a,b,c){var d=b+a,e=d<<c|d>>>32-c;return(f[0][e>>>24]^f[1][e>>>16&255])-f[2][e>>>8&255]+f[3][255&e]}function b(a,b,c){var d=b^a,e=d<<c|d>>>32-c;return f[0][e>>>24]-f[1][e>>>16&255]+f[2][e>>>8&255]^f[3][255&e]}function c(a,b,c){var d=b-a,e=d<<c|d>>>32-c;return(f[0][e>>>24]+f[1][e>>>16&255]^f[2][e>>>8&255])-f[3][255&e]}this.BlockSize=8,this.KeySize=16,this.setKey=function(a){if(this.masking=new Array(16),this.rotate=new Array(16),this.reset(),a.length!=this.KeySize)throw new Error("CAST-128: keys must be 16 bytes");return this.keySchedule(a),!0},this.reset=function(){for(var a=0;16>a;a++)this.masking[a]=0,this.rotate[a]=0},this.getBlockSize=function(){return BlockSize},this.encrypt=function(d){for(var e=new Array(d.length),f=0;f<d.length;f+=8){var g,h=d[f]<<24|d[f+1]<<16|d[f+2]<<8|d[f+3],i=d[f+4]<<24|d[f+5]<<16|d[f+6]<<8|d[f+7];g=i,i=h^a(i,this.masking[0],this.rotate[0]),h=g,g=i,i=h^b(i,this.masking[1],this.rotate[1]),h=g,g=i,i=h^c(i,this.masking[2],this.rotate[2]),h=g,g=i,i=h^a(i,this.masking[3],this.rotate[3]),h=g,g=i,i=h^b(i,this.masking[4],this.rotate[4]),h=g,g=i,i=h^c(i,this.masking[5],this.rotate[5]),h=g,g=i,i=h^a(i,this.masking[6],this.rotate[6]),h=g,g=i,i=h^b(i,this.masking[7],this.rotate[7]),h=g,g=i,i=h^c(i,this.masking[8],this.rotate[8]),h=g,g=i,i=h^a(i,this.masking[9],this.rotate[9]),h=g,g=i,i=h^b(i,this.masking[10],this.rotate[10]),h=g,g=i,i=h^c(i,this.masking[11],this.rotate[11]),h=g,g=i,i=h^a(i,this.masking[12],this.rotate[12]),h=g,g=i,i=h^b(i,this.masking[13],this.rotate[13]),h=g,g=i,i=h^c(i,this.masking[14],this.rotate[14]),h=g,g=i,i=h^a(i,this.masking[15],this.rotate[15]),h=g,e[f]=i>>>24&255,e[f+1]=i>>>16&255,e[f+2]=i>>>8&255,e[f+3]=255&i,e[f+4]=h>>>24&255,e[f+5]=h>>>16&255,e[f+6]=h>>>8&255,e[f+7]=255&h}return e},this.decrypt=function(d){for(var e=new Array(d.length),f=0;f<d.length;f+=8){var g,h=d[f]<<24|d[f+1]<<16|d[f+2]<<8|d[f+3],i=d[f+4]<<24|d[f+5]<<16|d[f+6]<<8|d[f+7];g=i,i=h^a(i,this.masking[15],this.rotate[15]),h=g,g=i,i=h^c(i,this.masking[14],this.rotate[14]),h=g,g=i,i=h^b(i,this.masking[13],this.rotate[13]),h=g,g=i,i=h^a(i,this.masking[12],this.rotate[12]),h=g,g=i,i=h^c(i,this.masking[11],this.rotate[11]),h=g,g=i,i=h^b(i,this.masking[10],this.rotate[10]),h=g,g=i,i=h^a(i,this.masking[9],this.rotate[9]),h=g,g=i,i=h^c(i,this.masking[8],this.rotate[8]),h=g,g=i,i=h^b(i,this.masking[7],this.rotate[7]),h=g,g=i,i=h^a(i,this.masking[6],this.rotate[6]),h=g,g=i,i=h^c(i,this.masking[5],this.rotate[5]),h=g,g=i,i=h^b(i,this.masking[4],this.rotate[4]),h=g,g=i,i=h^a(i,this.masking[3],this.rotate[3]),h=g,g=i,i=h^c(i,this.masking[2],this.rotate[2]),h=g,g=i,i=h^b(i,this.masking[1],this.rotate[1]),h=g,g=i,i=h^a(i,this.masking[0],this.rotate[0]),h=g,e[f]=i>>>24&255,e[f+1]=i>>>16&255,e[f+2]=i>>>8&255,e[f+3]=255&i,e[f+4]=h>>>24&255,e[f+5]=h>>16&255,e[f+6]=h>>8&255,e[f+7]=255&h}return e};var d=new Array(4);d[0]=new Array(4),d[0][0]=new Array(4,0,13,15,12,14,8),d[0][1]=new Array(5,2,16,18,17,19,10),d[0][2]=new Array(6,3,23,22,21,20,9),d[0][3]=new Array(7,1,26,25,27,24,11),d[1]=new Array(4),d[1][0]=new Array(0,6,21,23,20,22,16),d[1][1]=new Array(1,4,0,2,1,3,18),d[1][2]=new Array(2,5,7,6,5,4,17),d[1][3]=new Array(3,7,10,9,11,8,19),d[2]=new Array(4),d[2][0]=new Array(4,0,13,15,12,14,8),d[2][1]=new Array(5,2,16,18,17,19,10),d[2][2]=new Array(6,3,23,22,21,20,9),d[2][3]=new Array(7,1,26,25,27,24,11),d[3]=new Array(4),d[3][0]=new Array(0,6,21,23,20,22,16),d[3][1]=new Array(1,4,0,2,1,3,18),d[3][2]=new Array(2,5,7,6,5,4,17),d[3][3]=new Array(3,7,10,9,11,8,19);var e=new Array(4);e[0]=new Array(4),e[0][0]=new Array(24,25,23,22,18),e[0][1]=new Array(26,27,21,20,22),e[0][2]=new Array(28,29,19,18,25),e[0][3]=new Array(30,31,17,16,28),e[1]=new Array(4),e[1][0]=new Array(3,2,12,13,8),e[1][1]=new Array(1,0,14,15,13),e[1][2]=new Array(7,6,8,9,3),e[1][3]=new Array(5,4,10,11,7),e[2]=new Array(4),e[2][0]=new Array(19,18,28,29,25),e[2][1]=new Array(17,16,30,31,28),e[2][2]=new Array(23,22,24,25,18),e[2][3]=new Array(21,20,26,27,22),e[3]=new Array(4),e[3][0]=new Array(8,9,7,6,3),e[3][1]=new Array(10,11,5,4,7),e[3][2]=new Array(12,13,3,2,8),e[3][3]=new Array(14,15,1,0,13),this.keySchedule=function(a){var b,c,g=new Array(8),h=new Array(32);for(b=0;4>b;b++)c=4*b,g[b]=a[c]<<24|a[c+1]<<16|a[c+2]<<8|a[c+3];for(var i,j=[6,7,4,5],k=0,l=0;2>l;l++)for(var m=0;4>m;m++){for(c=0;4>c;c++){var n=d[m][c];i=g[n[1]],i^=f[4][g[n[2]>>>2]>>>24-8*(3&n[2])&255],i^=f[5][g[n[3]>>>2]>>>24-8*(3&n[3])&255],i^=f[6][g[n[4]>>>2]>>>24-8*(3&n[4])&255],i^=f[7][g[n[5]>>>2]>>>24-8*(3&n[5])&255],i^=f[j[c]][g[n[6]>>>2]>>>24-8*(3&n[6])&255],g[n[0]]=i}for(c=0;4>c;c++){var o=e[m][c];i=f[4][g[o[0]>>>2]>>>24-8*(3&o[0])&255],i^=f[5][g[o[1]>>>2]>>>24-8*(3&o[1])&255],i^=f[6][g[o[2]>>>2]>>>24-8*(3&o[2])&255],i^=f[7][g[o[3]>>>2]>>>24-8*(3&o[3])&255],i^=f[4+c][g[o[4]>>>2]>>>24-8*(3&o[4])&255],h[k]=i,k++}}for(b=0;16>b;b++)this.masking[b]=h[b],this.rotate[b]=31&h[16+b]};var f=new Array(8);f[0]=new Array(821772500,2678128395,1810681135,1059425402,505495343,2617265619,1610868032,3483355465,3218386727,2294005173,3791863952,2563806837,1852023008,365126098,3269944861,584384398,677919599,3229601881,4280515016,2002735330,1136869587,3744433750,2289869850,2731719981,2714362070,879511577,1639411079,575934255,717107937,2857637483,576097850,2731753936,1725645e3,2810460463,5111599,767152862,2543075244,1251459544,1383482551,3052681127,3089939183,3612463449,1878520045,1510570527,2189125840,2431448366,582008916,3163445557,1265446783,1354458274,3529918736,3202711853,3073581712,3912963487,3029263377,1275016285,4249207360,2905708351,3304509486,1442611557,3585198765,2712415662,2731849581,3248163920,2283946226,208555832,2766454743,1331405426,1447828783,3315356441,3108627284,2957404670,2981538698,3339933917,1669711173,286233437,1465092821,1782121619,3862771680,710211251,980974943,1651941557,430374111,2051154026,704238805,4128970897,3144820574,2857402727,948965521,3333752299,2227686284,718756367,2269778983,2731643755,718440111,2857816721,3616097120,1113355533,2478022182,410092745,1811985197,1944238868,2696854588,1415722873,1682284203,1060277122,1998114690,1503841958,82706478,2315155686,1068173648,845149890,2167947013,1768146376,1993038550,3566826697,3390574031,940016341,3355073782,2328040721,904371731,1205506512,4094660742,2816623006,825647681,85914773,2857843460,1249926541,1417871568,3287612,3211054559,3126306446,1975924523,1353700161,2814456437,2438597621,1800716203,722146342,2873936343,1151126914,4160483941,2877670899,458611604,2866078500,3483680063,770352098,2652916994,3367839148,3940505011,3585973912,3809620402,718646636,2504206814,2914927912,3631288169,2857486607,2860018678,575749918,2857478043,718488780,2069512688,3548183469,453416197,1106044049,3032691430,52586708,3378514636,3459808877,3211506028,1785789304,218356169,3571399134,3759170522,1194783844,1523787992,3007827094,1975193539,2555452411,1341901877,3045838698,3776907964,3217423946,2802510864,2889438986,1057244207,1636348243,3761863214,1462225785,2632663439,481089165,718503062,24497053,3332243209,3344655856,3655024856,3960371065,1195698900,2971415156,3710176158,2115785917,4027663609,3525578417,2524296189,2745972565,3564906415,1372086093,1452307862,2780501478,1476592880,3389271281,18495466,2378148571,901398090,891748256,3279637769,3157290713,2560960102,1447622437,4284372637,216884176,2086908623,1879786977,3588903153,2242455666,2938092967,3559082096,2810645491,758861177,1121993112,215018983,642190776,4169236812,1196255959,2081185372,3508738393,941322904,4124243163,2877523539,1848581667,2205260958,3180453958,2589345134,3694731276,550028657,2519456284,3789985535,2973870856,2093648313,443148163,46942275,2734146937,1117713533,1115362972,1523183689,3717140224,1551984063),f[1]=new Array(522195092,4010518363,1776537470,960447360,4267822970,4005896314,1435016340,1929119313,2913464185,1310552629,3579470798,3724818106,2579771631,1594623892,417127293,2715217907,2696228731,1508390405,3994398868,3925858569,3695444102,4019471449,3129199795,3770928635,3520741761,990456497,4187484609,2783367035,21106139,3840405339,631373633,3783325702,532942976,396095098,3548038825,4267192484,2564721535,2011709262,2039648873,620404603,3776170075,2898526339,3612357925,4159332703,1645490516,223693667,1567101217,3362177881,1029951347,3470931136,3570957959,1550265121,119497089,972513919,907948164,3840628539,1613718692,3594177948,465323573,2659255085,654439692,2575596212,2699288441,3127702412,277098644,624404830,4100943870,2717858591,546110314,2403699828,3655377447,1321679412,4236791657,1045293279,4010672264,895050893,2319792268,494945126,1914543101,2777056443,3894764339,2219737618,311263384,4275257268,3458730721,669096869,3584475730,3835122877,3319158237,3949359204,2005142349,2713102337,2228954793,3769984788,569394103,3855636576,1425027204,108000370,2736431443,3671869269,3043122623,1750473702,2211081108,762237499,3972989403,2798899386,3061857628,2943854345,867476300,964413654,1591880597,1594774276,2179821409,552026980,3026064248,3726140315,2283577634,3110545105,2152310760,582474363,1582640421,1383256631,2043843868,3322775884,1217180674,463797851,2763038571,480777679,2718707717,2289164131,3118346187,214354409,200212307,3810608407,3025414197,2674075964,3997296425,1847405948,1342460550,510035443,4080271814,815934613,833030224,1620250387,1945732119,2703661145,3966000196,1388869545,3456054182,2687178561,2092620194,562037615,1356438536,3409922145,3261847397,1688467115,2150901366,631725691,3840332284,549916902,3455104640,394546491,837744717,2114462948,751520235,2221554606,2415360136,3999097078,2063029875,803036379,2702586305,821456707,3019566164,360699898,4018502092,3511869016,3677355358,2402471449,812317050,49299192,2570164949,3259169295,2816732080,3331213574,3101303564,2156015656,3705598920,3546263921,143268808,3200304480,1638124008,3165189453,3341807610,578956953,2193977524,3638120073,2333881532,807278310,658237817,2969561766,1641658566,11683945,3086995007,148645947,1138423386,4158756760,1981396783,2401016740,3699783584,380097457,2680394679,2803068651,3334260286,441530178,4016580796,1375954390,761952171,891809099,2183123478,157052462,3683840763,1592404427,341349109,2438483839,1417898363,644327628,2233032776,2353769706,2201510100,220455161,1815641738,182899273,2995019788,3627381533,3702638151,2890684138,1052606899,588164016,1681439879,4038439418,2405343923,4229449282,167996282,1336969661,1688053129,2739224926,1543734051,1046297529,1138201970,2121126012,115334942,1819067631,1902159161,1941945968,2206692869,1159982321),f[2]=new Array(2381300288,637164959,3952098751,3893414151,1197506559,916448331,2350892612,2932787856,3199334847,4009478890,3905886544,1373570990,2450425862,4037870920,3778841987,2456817877,286293407,124026297,3001279700,1028597854,3115296800,4208886496,2691114635,2188540206,1430237888,1218109995,3572471700,308166588,570424558,2187009021,2455094765,307733056,1310360322,3135275007,1384269543,2388071438,863238079,2359263624,2801553128,3380786597,2831162807,1470087780,1728663345,4072488799,1090516929,532123132,2389430977,1132193179,2578464191,3051079243,1670234342,1434557849,2711078940,1241591150,3314043432,3435360113,3091448339,1812415473,2198440252,267246943,796911696,3619716990,38830015,1526438404,2806502096,374413614,2943401790,1489179520,1603809326,1920779204,168801282,260042626,2358705581,1563175598,2397674057,1356499128,2217211040,514611088,2037363785,2186468373,4022173083,2792511869,2913485016,1173701892,4200428547,3896427269,1334932762,2455136706,602925377,2835607854,1613172210,41346230,2499634548,2457437618,2188827595,41386358,4172255629,1313404830,2405527007,3801973774,2217704835,873260488,2528884354,2478092616,4012915883,2555359016,2006953883,2463913485,575479328,2218240648,2099895446,660001756,2341502190,3038761536,3888151779,3848713377,3286851934,1022894237,1620365795,3449594689,1551255054,15374395,3570825345,4249311020,4151111129,3181912732,310226346,1133119310,530038928,136043402,2476768958,3107506709,2544909567,1036173560,2367337196,1681395281,1758231547,3641649032,306774401,1575354324,3716085866,1990386196,3114533736,2455606671,1262092282,3124342505,2768229131,4210529083,1833535011,423410938,660763973,2187129978,1639812e3,3508421329,3467445492,310289298,272797111,2188552562,2456863912,310240523,677093832,1013118031,901835429,3892695601,1116285435,3036471170,1337354835,243122523,520626091,277223598,4244441197,4194248841,1766575121,594173102,316590669,742362309,3536858622,4176435350,3838792410,2501204839,1229605004,3115755532,1552908988,2312334149,979407927,3959474601,1148277331,176638793,3614686272,2083809052,40992502,1340822838,2731552767,3535757508,3560899520,1354035053,122129617,7215240,2732932949,3118912700,2718203926,2539075635,3609230695,3725561661,1928887091,2882293555,1988674909,2063640240,2491088897,1459647954,4189817080,2302804382,1113892351,2237858528,1927010603,4002880361,1856122846,1594404395,2944033133,3855189863,3474975698,1643104450,4054590833,3431086530,1730235576,2984608721,3084664418,2131803598,4178205752,267404349,1617849798,1616132681,1462223176,736725533,2327058232,551665188,2945899023,1749386277,2575514597,1611482493,674206544,2201269090,3642560800,728599968,1680547377,2620414464,1388111496,453204106,4156223445,1094905244,2754698257,2201108165,3757000246,2704524545,3922940700,3996465027),f[3]=new Array(2645754912,532081118,2814278639,3530793624,1246723035,1689095255,2236679235,4194438865,2116582143,3859789411,157234593,2045505824,4245003587,1687664561,4083425123,605965023,672431967,1336064205,3376611392,214114848,4258466608,3232053071,489488601,605322005,3998028058,264917351,1912574028,756637694,436560991,202637054,135989450,85393697,2152923392,3896401662,2895836408,2145855233,3535335007,115294817,3147733898,1922296357,3464822751,4117858305,1037454084,2725193275,2127856640,1417604070,1148013728,1827919605,642362335,2929772533,909348033,1346338451,3547799649,297154785,1917849091,4161712827,2883604526,3968694238,1469521537,3780077382,3375584256,1763717519,136166297,4290970789,1295325189,2134727907,2798151366,1566297257,3672928234,2677174161,2672173615,965822077,2780786062,289653839,1133871874,3491843819,35685304,1068898316,418943774,672553190,642281022,2346158704,1954014401,3037126780,4079815205,2030668546,3840588673,672283427,1776201016,359975446,3750173538,555499703,2769985273,1324923,69110472,152125443,3176785106,3822147285,1340634837,798073664,1434183902,15393959,216384236,1303690150,3881221631,3711134124,3960975413,106373927,2578434224,1455997841,1801814300,1578393881,1854262133,3188178946,3258078583,2302670060,1539295533,3505142565,3078625975,2372746020,549938159,3278284284,2620926080,181285381,2865321098,3970029511,68876850,488006234,1728155692,2608167508,836007927,2435231793,919367643,3339422534,3655756360,1457871481,40520939,1380155135,797931188,234455205,2255801827,3990488299,397000196,739833055,3077865373,2871719860,4022553888,772369276,390177364,3853951029,557662966,740064294,1640166671,1699928825,3535942136,622006121,3625353122,68743880,1742502,219489963,1664179233,1577743084,1236991741,410585305,2366487942,823226535,1050371084,3426619607,3586839478,212779912,4147118561,1819446015,1911218849,530248558,3486241071,3252585495,2886188651,3410272728,2342195030,20547779,2982490058,3032363469,3631753222,312714466,1870521650,1493008054,3491686656,615382978,4103671749,2534517445,1932181,2196105170,278426614,6369430,3274544417,2913018367,697336853,2143000447,2946413531,701099306,1558357093,2805003052,3500818408,2321334417,3567135975,216290473,3591032198,23009561,1996984579,3735042806,2024298078,3739440863,569400510,2339758983,3016033873,3097871343,3639523026,3844324983,3256173865,795471839,2951117563,4101031090,4091603803,3603732598,971261452,534414648,428311343,3389027175,2844869880,694888862,1227866773,2456207019,3043454569,2614353370,3749578031,3676663836,459166190,4132644070,1794958188,51825668,2252611902,3084671440,2036672799,3436641603,1099053433,2469121526,3059204941,1323291266,2061838604,1018778475,2233344254,2553501054,334295216,3556750194,1065731521,183467730),f[4]=new Array(2127105028,745436345,2601412319,2788391185,3093987327,500390133,1155374404,389092991,150729210,3891597772,3523549952,1935325696,716645080,946045387,2901812282,1774124410,3869435775,4039581901,3293136918,3438657920,948246080,363898952,3867875531,1286266623,1598556673,68334250,630723836,1104211938,1312863373,613332731,2377784574,1101634306,441780740,3129959883,1917973735,2510624549,3238456535,2544211978,3308894634,1299840618,4076074851,1756332096,3977027158,297047435,3790297736,2265573040,3621810518,1311375015,1667687725,47300608,3299642885,2474112369,201668394,1468347890,576830978,3594690761,3742605952,1958042578,1747032512,3558991340,1408974056,3366841779,682131401,1033214337,1545599232,4265137049,206503691,103024618,2855227313,1337551222,2428998917,2963842932,4015366655,3852247746,2796956967,3865723491,3747938335,247794022,3755824572,702416469,2434691994,397379957,851939612,2314769512,218229120,1380406772,62274761,214451378,3170103466,2276210409,3845813286,28563499,446592073,1693330814,3453727194,29968656,3093872512,220656637,2470637031,77972100,1667708854,1358280214,4064765667,2395616961,325977563,4277240721,4220025399,3605526484,3355147721,811859167,3069544926,3962126810,652502677,3075892249,4132761541,3498924215,1217549313,3250244479,3858715919,3053989961,1538642152,2279026266,2875879137,574252750,3324769229,2651358713,1758150215,141295887,2719868960,3515574750,4093007735,4194485238,1082055363,3417560400,395511885,2966884026,179534037,3646028556,3738688086,1092926436,2496269142,257381841,3772900718,1636087230,1477059743,2499234752,3811018894,2675660129,3285975680,90732309,1684827095,1150307763,1723134115,3237045386,1769919919,1240018934,815675215,750138730,2239792499,1234303040,1995484674,138143821,675421338,1145607174,1936608440,3238603024,2345230278,2105974004,323969391,779555213,3004902369,2861610098,1017501463,2098600890,2628620304,2940611490,2682542546,1171473753,3656571411,3687208071,4091869518,393037935,159126506,1662887367,1147106178,391545844,3452332695,1891500680,3016609650,1851642611,546529401,1167818917,3194020571,2848076033,3953471836,575554290,475796850,4134673196,450035699,2351251534,844027695,1080539133,86184846,1554234488,3692025454,1972511363,2018339607,1491841390,1141460869,1061690759,4244549243,2008416118,2351104703,2868147542,1598468138,722020353,1027143159,212344630,1387219594,1725294528,3745187956,2500153616,458938280,4129215917,1828119673,544571780,3503225445,2297937496,1241802790,267843827,2694610800,1397140384,1558801448,3782667683,1806446719,929573330,2234912681,400817706,616011623,4121520928,3603768725,1761550015,1968522284,4053731006,4192232858,4005120285,872482584,3140537016,3894607381,2287405443,1963876937,3663887957,1584857e3,2975024454,1833426440,4025083860),f[5]=new Array(4143615901,749497569,1285769319,3795025788,2514159847,23610292,3974978748,844452780,3214870880,3751928557,2213566365,1676510905,448177848,3730751033,4086298418,2307502392,871450977,3222878141,4110862042,3831651966,2735270553,1310974780,2043402188,1218528103,2736035353,4274605013,2702448458,3936360550,2693061421,162023535,2827510090,687910808,23484817,3784910947,3371371616,779677500,3503626546,3473927188,4157212626,3500679282,4248902014,2466621104,3899384794,1958663117,925738300,1283408968,3669349440,1840910019,137959847,2679828185,1239142320,1315376211,1547541505,1690155329,739140458,3128809933,3933172616,3876308834,905091803,1548541325,4040461708,3095483362,144808038,451078856,676114313,2861728291,2469707347,993665471,373509091,2599041286,4025009006,4170239449,2149739950,3275793571,3749616649,2794760199,1534877388,572371878,2590613551,1753320020,3467782511,1405125690,4270405205,633333386,3026356924,3475123903,632057672,2846462855,1404951397,3882875879,3915906424,195638627,2385783745,3902872553,1233155085,3355999740,2380578713,2702246304,2144565621,3663341248,3894384975,2502479241,4248018925,3094885567,1594115437,572884632,3385116731,767645374,1331858858,1475698373,3793881790,3532746431,1321687957,619889600,1121017241,3440213920,2070816767,2833025776,1933951238,4095615791,890643334,3874130214,859025556,360630002,925594799,1764062180,3920222280,4078305929,979562269,2810700344,4087740022,1949714515,546639971,1165388173,3069891591,1495988560,922170659,1291546247,2107952832,1813327274,3406010024,3306028637,4241950635,153207855,2313154747,1608695416,1150242611,1967526857,721801357,1220138373,3691287617,3356069787,2112743302,3281662835,1111556101,1778980689,250857638,2298507990,673216130,2846488510,3207751581,3562756981,3008625920,3417367384,2198807050,529510932,3547516680,3426503187,2364944742,102533054,2294910856,1617093527,1204784762,3066581635,1019391227,1069574518,1317995090,1691889997,3661132003,510022745,3238594800,1362108837,1817929911,2184153760,805817662,1953603311,3699844737,120799444,2118332377,207536705,2282301548,4120041617,145305846,2508124933,3086745533,3261524335,1877257368,2977164480,3160454186,2503252186,4221677074,759945014,254147243,2767453419,3801518371,629083197,2471014217,907280572,3900796746,940896768,2751021123,2625262786,3161476951,3661752313,3260732218,1425318020,2977912069,1496677566,3988592072,2140652971,3126511541,3069632175,977771578,1392695845,1698528874,1411812681,1369733098,1343739227,3620887944,1142123638,67414216,3102056737,3088749194,1626167401,2546293654,3941374235,697522451,33404913,143560186,2595682037,994885535,1247667115,3859094837,2699155541,3547024625,4114935275,2968073508,3199963069,2732024527,1237921620,951448369,1898488916,1211705605,2790989240,2233243581,3598044975),f[6]=new Array(2246066201,858518887,1714274303,3485882003,713916271,2879113490,3730835617,539548191,36158695,1298409750,419087104,1358007170,749914897,2989680476,1261868530,2995193822,2690628854,3443622377,3780124940,3796824509,2976433025,4259637129,1551479e3,512490819,1296650241,951993153,2436689437,2460458047,144139966,3136204276,310820559,3068840729,643875328,1969602020,1680088954,2185813161,3283332454,672358534,198762408,896343282,276269502,3014846926,84060815,197145886,376173866,3943890818,3813173521,3545068822,1316698879,1598252827,2633424951,1233235075,859989710,2358460855,3503838400,3409603720,1203513385,1193654839,2792018475,2060853022,207403770,1144516871,3068631394,1121114134,177607304,3785736302,326409831,1929119770,2983279095,4183308101,3474579288,3200513878,3228482096,119610148,1170376745,3378393471,3163473169,951863017,3337026068,3135789130,2907618374,1183797387,2015970143,4045674555,2182986399,2952138740,3928772205,384012900,2454997643,10178499,2879818989,2596892536,111523738,2995089006,451689641,3196290696,235406569,1441906262,3890558523,3013735005,4158569349,1644036924,376726067,1006849064,3664579700,2041234796,1021632941,1374734338,2566452058,371631263,4007144233,490221539,206551450,3140638584,1053219195,1853335209,3412429660,3562156231,735133835,1623211703,3104214392,2738312436,4096837757,3366392578,3110964274,3956598718,3196820781,2038037254,3877786376,2339753847,300912036,3766732888,2372630639,1516443558,4200396704,1574567987,4069441456,4122592016,2699739776,146372218,2748961456,2043888151,35287437,2596680554,655490400,1132482787,110692520,1031794116,2188192751,1324057718,1217253157,919197030,686247489,3261139658,1028237775,3135486431,3059715558,2460921700,986174950,2661811465,4062904701,2752986992,3709736643,367056889,1353824391,731860949,1650113154,1778481506,784341916,357075625,3608602432,1074092588,2480052770,3811426202,92751289,877911070,3600361838,1231880047,480201094,3756190983,3094495953,434011822,87971354,363687820,1717726236,1901380172,3926403882,2481662265,400339184,1490350766,2661455099,1389319756,2558787174,784598401,1983468483,30828846,3550527752,2716276238,3841122214,1765724805,1955612312,1277890269,1333098070,1564029816,2704417615,1026694237,3287671188,1260819201,3349086767,1016692350,1582273796,1073413053,1995943182,694588404,1025494639,3323872702,3551898420,4146854327,453260480,1316140391,1435673405,3038941953,3486689407,1622062951,403978347,817677117,950059133,4246079218,3278066075,1486738320,1417279718,481875527,2549965225,3933690356,760697757,1452955855,3897451437,1177426808,1702951038,4085348628,2447005172,1084371187,3516436277,3068336338,1073369276,1027665953,3284188590,1230553676,1368340146,2226246512,267243139,2274220762,4070734279,2497715176,2423353163,2504755875),f[7]=new Array(3793104909,3151888380,2817252029,895778965,2005530807,3871412763,237245952,86829237,296341424,3851759377,3974600970,2475086196,709006108,1994621201,2972577594,937287164,3734691505,168608556,3189338153,2225080640,3139713551,3033610191,3025041904,77524477,185966941,1208824168,2344345178,1721625922,3354191921,1066374631,1927223579,1971335949,2483503697,1551748602,2881383779,2856329572,3003241482,48746954,1398218158,2050065058,313056748,4255789917,393167848,1912293076,940740642,3465845460,3091687853,2522601570,2197016661,1727764327,364383054,492521376,1291706479,3264136376,1474851438,1685747964,2575719748,1619776915,1814040067,970743798,1561002147,2925768690,2123093554,1880132620,3151188041,697884420,2550985770,2607674513,2659114323,110200136,1489731079,997519150,1378877361,3527870668,478029773,2766872923,1022481122,431258168,1112503832,897933369,2635587303,669726182,3383752315,918222264,163866573,3246985393,3776823163,114105080,1903216136,761148244,3571337562,1690750982,3166750252,1037045171,1888456500,2010454850,642736655,616092351,365016990,1185228132,4174898510,1043824992,2023083429,2241598885,3863320456,3279669087,3674716684,108438443,2132974366,830746235,606445527,4173263986,2204105912,1844756978,2532684181,4245352700,2969441100,3796921661,1335562986,4061524517,2720232303,2679424040,634407289,885462008,3294724487,3933892248,2094100220,339117932,4048830727,3202280980,1458155303,2689246273,1022871705,2464987878,3714515309,353796843,2822958815,4256850100,4052777845,551748367,618185374,3778635579,4020649912,1904685140,3069366075,2670879810,3407193292,2954511620,4058283405,2219449317,3135758300,1120655984,3447565834,1474845562,3577699062,550456716,3466908712,2043752612,881257467,869518812,2005220179,938474677,3305539448,3850417126,1315485940,3318264702,226533026,965733244,321539988,1136104718,804158748,573969341,3708209826,937399083,3290727049,2901666755,1461057207,4013193437,4066861423,3242773476,2421326174,1581322155,3028952165,786071460,3900391652,3918438532,1485433313,4023619836,3708277595,3678951060,953673138,1467089153,1930354364,1533292819,2492563023,1346121658,1685000834,1965281866,3765933717,4190206607,2052792609,3515332758,690371149,3125873887,2180283551,2903598061,3933952357,436236910,289419410,14314871,1242357089,2904507907,1616633776,2666382180,585885352,3471299210,2699507360,1432659641,277164553,3354103607,770115018,2303809295,3741942315,3177781868,2853364978,2269453327,3774259834,987383833,1290892879,225909803,1741533526,890078084,1496906255,1111072499,916028167,243534141,1252605537,2204162171,531204876,290011180,3916834213,102027703,237315147,209093447,1486785922,220223953,2758195998,4175039106,82940208,3127791296,2569425252,518464269,1353887104,3941492737,2377294467,3935040926)}function e(a){this.cast5=new d,this.cast5.setKey(f.str2bin(a)),this.encrypt=function(a){return this.cast5.encrypt(a)}}var f=a("../../util.js");b.exports=e,b.exports.blockSize=e.prototype.blockSize=8,b.exports.keySize=e.prototype.keySize=16},{"../../util.js":65}],11:[function(a,b,c){"use strict";function d(a,b,c,d,e,h){var i,j,k,l,m,n,o,p,q,r,s,t,u,v,w=new Array(16843776,0,65536,16843780,16842756,66564,4,65536,1024,16843776,16843780,1024,16778244,16842756,16777216,4,1028,16778240,16778240,66560,66560,16842752,16842752,16778244,65540,16777220,16777220,65540,0,1028,66564,16777216,65536,16843780,4,16842752,16843776,16777216,16777216,1024,16842756,65536,66560,16777220,1024,4,16778244,66564,16843780,65540,16842752,16778244,16777220,1028,66564,16843776,1028,16778240,16778240,0,65540,66560,0,16842756),x=new Array(-2146402272,-2147450880,32768,1081376,1048576,32,-2146435040,-2147450848,-2147483616,-2146402272,-2146402304,-2147483648,-2147450880,1048576,32,-2146435040,1081344,1048608,-2147450848,0,-2147483648,32768,1081376,-2146435072,1048608,-2147483616,0,1081344,32800,-2146402304,-2146435072,32800,0,1081376,-2146435040,1048576,-2147450848,-2146435072,-2146402304,32768,-2146435072,-2147450880,32,-2146402272,1081376,32,32768,-2147483648,32800,-2146402304,1048576,-2147483616,1048608,-2147450848,-2147483616,1048608,1081344,0,-2147450880,32800,-2147483648,-2146435040,-2146402272,1081344),y=new Array(520,134349312,0,134348808,134218240,0,131592,134218240,131080,134217736,134217736,131072,134349320,131080,134348800,520,134217728,8,134349312,512,131584,134348800,134348808,131592,134218248,131584,131072,134218248,8,134349320,512,134217728,134349312,134217728,131080,520,131072,134349312,134218240,0,512,131080,134349320,134218240,134217736,512,0,134348808,134218248,131072,134217728,134349320,8,131592,131584,134217736,134348800,134218248,520,134348800,131592,8,134348808,131584),z=new Array(8396801,8321,8321,128,8396928,8388737,8388609,8193,0,8396800,8396800,8396929,129,0,8388736,8388609,1,8192,8388608,8396801,128,8388608,8193,8320,8388737,1,8320,8388736,8192,8396928,8396929,129,8388736,8388609,8396800,8396929,129,0,0,8396800,8320,8388736,8388737,1,8396801,8321,8321,128,8396929,129,1,8192,8388609,8193,8396928,8388737,8193,8320,8388608,8396801,128,8388608,8192,8396928),A=new Array(256,34078976,34078720,1107296512,524288,256,1073741824,34078720,1074266368,524288,33554688,1074266368,1107296512,1107820544,524544,1073741824,33554432,1074266112,1074266112,0,1073742080,1107820800,1107820800,33554688,1107820544,1073742080,0,1107296256,34078976,33554432,1107296256,524544,524288,1107296512,256,33554432,1073741824,34078720,1107296512,1074266368,33554688,1073741824,1107820544,34078976,1074266368,256,33554432,1107820544,1107820800,524544,1107296256,1107820800,34078720,0,1074266112,1107296256,524544,33554688,1073742080,524288,0,1074266112,34078976,1073742080),B=new Array(536870928,541065216,16384,541081616,541065216,16,541081616,4194304,536887296,4210704,4194304,536870928,4194320,536887296,536870912,16400,0,4194320,536887312,16384,4210688,536887312,16,541065232,541065232,0,4210704,541081600,16400,4210688,541081600,536870912,536887296,16,541065232,4210688,541081616,4194304,16400,536870928,4194304,536887296,536870912,16400,536870928,541081616,4210688,541065216,4210704,541081600,0,541065232,16,16384,541065216,4210704,16384,4194320,536887312,0,541081600,536870912,4194320,536887312),C=new Array(2097152,69206018,67110914,0,2048,67110914,2099202,69208064,69208066,2097152,0,67108866,2,67108864,69206018,2050,67110912,2099202,2097154,67110912,67108866,69206016,69208064,2097154,69206016,2048,2050,69208066,2099200,2,67108864,2099200,67108864,2099200,2097152,67110914,67110914,69206018,69206018,2,2097154,67108864,67110912,2097152,69208064,2050,2099202,69208064,2050,67108866,69208066,69206016,2099200,0,2,69208066,0,2099202,69206016,2048,67108866,67110912,2048,2097154),D=new Array(268439616,4096,262144,268701760,268435456,268439616,64,268435456,262208,268697600,268701760,266240,268701696,266304,4096,64,268697600,268435520,268439552,4160,266240,262208,268697664,268701696,4160,0,0,268697664,268435520,268439552,266304,262144,266304,262144,268701696,4096,64,268697664,4096,266304,268439552,64,268435520,268697600,268697664,268435456,262144,268439616,0,268701760,262208,268435520,268697600,268439552,268439616,0,268701760,266240,266240,4160,4160,262208,268435456,268701696),E=0,F=b.length,G=0,H=32==a.length?3:9;
	p=3==H?c?new Array(0,32,2):new Array(30,-2,-2):c?new Array(0,32,2,62,30,-2,64,96,2):new Array(94,62,-2,32,64,2,30,-2,-2),c&&(b=f(b,h),F=b.length);var I="",J="";for(1==d&&(q=e.charCodeAt(E++)<<24|e.charCodeAt(E++)<<16|e.charCodeAt(E++)<<8|e.charCodeAt(E++),s=e.charCodeAt(E++)<<24|e.charCodeAt(E++)<<16|e.charCodeAt(E++)<<8|e.charCodeAt(E++),E=0);F>E;){for(n=b.charCodeAt(E++)<<24|b.charCodeAt(E++)<<16|b.charCodeAt(E++)<<8|b.charCodeAt(E++),o=b.charCodeAt(E++)<<24|b.charCodeAt(E++)<<16|b.charCodeAt(E++)<<8|b.charCodeAt(E++),1==d&&(c?(n^=q,o^=s):(r=q,t=s,q=n,s=o)),k=252645135&(n>>>4^o),o^=k,n^=k<<4,k=65535&(n>>>16^o),o^=k,n^=k<<16,k=858993459&(o>>>2^n),n^=k,o^=k<<2,k=16711935&(o>>>8^n),n^=k,o^=k<<8,k=1431655765&(n>>>1^o),o^=k,n^=k<<1,n=n<<1|n>>>31,o=o<<1|o>>>31,j=0;H>j;j+=3){for(u=p[j+1],v=p[j+2],i=p[j];i!=u;i+=v)l=o^a[i],m=(o>>>4|o<<28)^a[i+1],k=n,n=o,o=k^(x[l>>>24&63]|z[l>>>16&63]|B[l>>>8&63]|D[63&l]|w[m>>>24&63]|y[m>>>16&63]|A[m>>>8&63]|C[63&m]);k=n,n=o,o=k}n=n>>>1|n<<31,o=o>>>1|o<<31,k=1431655765&(n>>>1^o),o^=k,n^=k<<1,k=16711935&(o>>>8^n),n^=k,o^=k<<8,k=858993459&(o>>>2^n),n^=k,o^=k<<2,k=65535&(n>>>16^o),o^=k,n^=k<<16,k=252645135&(n>>>4^o),o^=k,n^=k<<4,1==d&&(c?(q=n,s=o):(n^=r,o^=t)),J+=String.fromCharCode(n>>>24,n>>>16&255,n>>>8&255,255&n,o>>>24,o>>>16&255,o>>>8&255,255&o),G+=8,512==G&&(I+=J,J="",G=0)}return I+=J,c||(I=g(I,h)),I}function e(a){for(var b,c,d,e=new Array(0,4,536870912,536870916,65536,65540,536936448,536936452,512,516,536871424,536871428,66048,66052,536936960,536936964),f=new Array(0,1,1048576,1048577,67108864,67108865,68157440,68157441,256,257,1048832,1048833,67109120,67109121,68157696,68157697),g=new Array(0,8,2048,2056,16777216,16777224,16779264,16779272,0,8,2048,2056,16777216,16777224,16779264,16779272),h=new Array(0,2097152,134217728,136314880,8192,2105344,134225920,136323072,131072,2228224,134348800,136445952,139264,2236416,134356992,136454144),i=new Array(0,262144,16,262160,0,262144,16,262160,4096,266240,4112,266256,4096,266240,4112,266256),j=new Array(0,1024,32,1056,0,1024,32,1056,33554432,33555456,33554464,33555488,33554432,33555456,33554464,33555488),k=new Array(0,268435456,524288,268959744,2,268435458,524290,268959746,0,268435456,524288,268959744,2,268435458,524290,268959746),l=new Array(0,65536,2048,67584,536870912,536936448,536872960,536938496,131072,196608,133120,198656,537001984,537067520,537004032,537069568),m=new Array(0,262144,0,262144,2,262146,2,262146,33554432,33816576,33554432,33816576,33554434,33816578,33554434,33816578),n=new Array(0,268435456,8,268435464,0,268435456,8,268435464,1024,268436480,1032,268436488,1024,268436480,1032,268436488),o=new Array(0,32,0,32,1048576,1048608,1048576,1048608,8192,8224,8192,8224,1056768,1056800,1056768,1056800),p=new Array(0,16777216,512,16777728,2097152,18874368,2097664,18874880,67108864,83886080,67109376,83886592,69206016,85983232,69206528,85983744),q=new Array(0,4096,134217728,134221824,524288,528384,134742016,134746112,16,4112,134217744,134221840,524304,528400,134742032,134746128),r=new Array(0,4,256,260,0,4,256,260,1,5,257,261,1,5,257,261),s=a.length>8?3:1,t=new Array(32*s),u=new Array(0,0,1,1,1,1,1,1,0,1,1,1,1,1,1,0),v=0,w=0,x=0;s>x;x++){var y=a.charCodeAt(v++)<<24|a.charCodeAt(v++)<<16|a.charCodeAt(v++)<<8|a.charCodeAt(v++),z=a.charCodeAt(v++)<<24|a.charCodeAt(v++)<<16|a.charCodeAt(v++)<<8|a.charCodeAt(v++);d=252645135&(y>>>4^z),z^=d,y^=d<<4,d=65535&(z>>>-16^y),y^=d,z^=d<<-16,d=858993459&(y>>>2^z),z^=d,y^=d<<2,d=65535&(z>>>-16^y),y^=d,z^=d<<-16,d=1431655765&(y>>>1^z),z^=d,y^=d<<1,d=16711935&(z>>>8^y),y^=d,z^=d<<8,d=1431655765&(y>>>1^z),z^=d,y^=d<<1,d=y<<8|z>>>20&240,y=z<<24|z<<8&16711680|z>>>8&65280|z>>>24&240,z=d;for(var A=0;A<u.length;A++)u[A]?(y=y<<2|y>>>26,z=z<<2|z>>>26):(y=y<<1|y>>>27,z=z<<1|z>>>27),y&=-15,z&=-15,b=e[y>>>28]|f[y>>>24&15]|g[y>>>20&15]|h[y>>>16&15]|i[y>>>12&15]|j[y>>>8&15]|k[y>>>4&15],c=l[z>>>28]|m[z>>>24&15]|n[z>>>20&15]|o[z>>>16&15]|p[z>>>12&15]|q[z>>>8&15]|r[z>>>4&15],d=65535&(c>>>16^b),t[w++]=b^d,t[w++]=c^d<<16}return t}function f(a,b){var c=8-a.length%8;return 2==b&&8>c?a+="        ".substr(0,c):1==b?a+=String.fromCharCode(c,c,c,c,c,c,c,c).substr(0,c):!b&&8>c&&(a+="\x00\x00\x00\x00\x00\x00\x00\x00".substr(0,c)),a}function g(a,b){if(2==b)a=a.replace(/ *$/g,"");else if(1==b){var c=a.charCodeAt(a.length-1);a=a.substr(0,a.length-c)}else b||(a=a.replace(/\0*$/g,""));return a}function h(a){this.key=[];for(var b=0;3>b;b++)this.key.push(a.substr(8*b,8));this.encrypt=function(a){return j.str2bin(d(e(this.key[2]),d(e(this.key[1]),d(e(this.key[0]),j.bin2str(a),!0,0,null,null),!1,0,null,null),!0,0,null,null))}}function i(a){this.key=a,this.encrypt=function(a,b){var c=e(this.key);return j.str2bin(d(c,j.bin2str(a),!0,0,null,b))},this.decrypt=function(a,b){var c=e(this.key);return j.str2bin(d(c,j.bin2str(a),!1,0,null,b))}}var j=a("../../util.js");h.keySize=h.prototype.keySize=24,h.blockSize=h.prototype.blockSize=8,b.exports={des:h,originalDes:i}},{"../../util.js":65}],12:[function(a,b,c){var d=a("./des.js");b.exports={des:d.originalDes,tripledes:d.des,cast5:a("./cast5.js"),twofish:a("./twofish.js"),blowfish:a("./blowfish.js"),idea:function(){throw new Error("IDEA symmetric-key algorithm not implemented")}};var e=a("./aes.js");for(var f in e)b.exports["aes"+f]=e[f]},{"./aes.js":8,"./blowfish.js":9,"./cast5.js":10,"./des.js":11,"./twofish.js":13}],13:[function(a,b,c){function d(a,b){return(a<<b|a>>>32-b)&k}function e(a,b){return a[b]|a[b+1]<<8|a[b+2]<<16|a[b+3]<<24}function f(a,b,c){a.splice(b,4,255&c,c>>>8&255,c>>>16&255,c>>>24&255)}function g(a,b){return a>>>8*b&255}function h(){function a(a){function b(a){return a^a>>2^[0,90,180,238][3&a]}function c(a){return a^a>>1^a>>2^[0,238,180,90][3&a]}function f(a,b){var c,d,e;for(c=0;8>c;c++)d=b>>>24,b=b<<8&k|a>>>24,a=a<<8&k,e=d<<1,128&d&&(e^=333),b^=d^e<<16,e^=d>>>1,1&d&&(e^=166),b^=e<<24|e<<8;return b}function h(a,b){var c,d,e,f;return c=b>>4,d=15&b,e=A[a][c^d],f=B[a][E[d]^F[c]],D[a][E[f]^F[e]]<<4|C[a][e^f]}function i(a,b){var c=g(a,0),d=g(a,1),e=g(a,2),f=g(a,3);switch(q){case 4:c=G[1][c]^g(b[3],0),d=G[0][d]^g(b[3],1),e=G[0][e]^g(b[3],2),f=G[1][f]^g(b[3],3);case 3:c=G[1][c]^g(b[2],0),d=G[1][d]^g(b[2],1),e=G[0][e]^g(b[2],2),f=G[0][f]^g(b[2],3);case 2:c=G[0][G[0][c]^g(b[1],0)]^g(b[0],0),d=G[0][G[1][d]^g(b[1],1)]^g(b[0],1),e=G[1][G[0][e]^g(b[1],2)]^g(b[0],2),f=G[1][G[1][f]^g(b[1],3)]^g(b[0],3)}return H[0][c]^H[1][d]^H[2][e]^H[3][f]}o=a;var j,l,m,n,p,q,r,u,v,w=[],x=[],y=[],z=[],A=[[8,1,7,13,6,15,3,2,0,11,5,9,14,12,10,4],[2,8,11,13,15,7,6,14,3,1,9,4,0,10,12,5]],B=[[14,12,11,8,1,2,3,5,15,4,10,6,7,0,9,13],[1,14,2,11,4,12,3,7,6,13,10,5,15,9,0,8]],C=[[11,10,5,14,6,13,9,0,12,8,15,3,2,4,7,1],[4,12,7,5,1,6,9,10,0,14,13,8,2,11,3,15]],D=[[13,7,15,4,1,2,6,14,9,11,3,0,8,5,12,10],[11,9,5,1,12,3,13,14,6,4,7,15,2,0,8,10]],E=[0,8,1,9,2,10,3,11,4,12,5,13,6,14,7,15],F=[0,9,2,11,4,13,6,15,8,1,10,3,12,5,14,7],G=[[],[]],H=[[],[],[],[]];for(o=o.slice(0,32),j=o.length;16!=j&&24!=j&&32!=j;)o[j++]=0;for(j=0;j<o.length;j+=4)y[j>>2]=e(o,j);for(j=0;256>j;j++)G[0][j]=h(0,j),G[1][j]=h(1,j);for(j=0;256>j;j++)r=G[1][j],u=b(r),v=c(r),H[0][j]=r+(u<<8)+(v<<16)+(v<<24),H[2][j]=u+(v<<8)+(r<<16)+(v<<24),r=G[0][j],u=b(r),v=c(r),H[1][j]=v+(v<<8)+(u<<16)+(r<<24),H[3][j]=u+(r<<8)+(v<<16)+(u<<24);for(q=y.length/2,j=0;q>j;j++)l=y[j+j],w[j]=l,m=y[j+j+1],x[j]=m,z[q-j-1]=f(l,m);for(j=0;40>j;j+=2)l=16843009*j,m=l+16843009,l=i(l,w),m=d(i(m,x),8),s[j]=l+m&k,s[j+1]=d(l+2*m,9);for(j=0;256>j;j++)switch(l=m=n=p=j,q){case 4:l=G[1][l]^g(z[3],0),m=G[0][m]^g(z[3],1),n=G[0][n]^g(z[3],2),p=G[1][p]^g(z[3],3);case 3:l=G[1][l]^g(z[2],0),m=G[1][m]^g(z[2],1),n=G[0][n]^g(z[2],2),p=G[0][p]^g(z[2],3);case 2:t[0][j]=H[0][G[0][G[0][l]^g(z[1],0)]^g(z[0],0)],t[1][j]=H[1][G[0][G[1][m]^g(z[1],1)]^g(z[0],1)],t[2][j]=H[2][G[1][G[0][n]^g(z[1],2)]^g(z[0],2)],t[3][j]=H[3][G[1][G[1][p]^g(z[1],3)]^g(z[0],3)]}}function b(a){return t[0][g(a,0)]^t[1][g(a,1)]^t[2][g(a,2)]^t[3][g(a,3)]}function c(a){return t[0][g(a,3)]^t[1][g(a,0)]^t[2][g(a,1)]^t[3][g(a,2)]}function h(a,e){var f=b(e[0]),g=c(e[1]);e[2]=d(e[2]^f+g+s[4*a+8]&k,31),e[3]=d(e[3],1)^f+2*g+s[4*a+9]&k,f=b(e[2]),g=c(e[3]),e[0]=d(e[0]^f+g+s[4*a+10]&k,31),e[1]=d(e[1],1)^f+2*g+s[4*a+11]&k}function i(a,e){var f=b(e[0]),g=c(e[1]);e[2]=d(e[2],1)^f+g+s[4*a+10]&k,e[3]=d(e[3]^f+2*g+s[4*a+11]&k,31),f=b(e[2]),g=c(e[3]),e[0]=d(e[0],1)^f+g+s[4*a+8]&k,e[1]=d(e[1]^f+2*g+s[4*a+9]&k,31)}function j(){s=[],t=[[],[],[],[]]}function l(a,b){p=a,q=b;for(var c=[e(p,q)^s[0],e(p,q+4)^s[1],e(p,q+8)^s[2],e(p,q+12)^s[3]],d=0;8>d;d++)h(d,c);return f(p,q,c[2]^s[4]),f(p,q+4,c[3]^s[5]),f(p,q+8,c[0]^s[6]),f(p,q+12,c[1]^s[7]),q+=16,p}function m(a,b){p=a,q=b;for(var c=[e(p,q)^s[4],e(p,q+4)^s[5],e(p,q+8)^s[6],e(p,q+12)^s[7]],d=7;d>=0;d--)i(d,c);f(p,q,c[2]^s[0]),f(p,q+4,c[3]^s[1]),f(p,q+8,c[0]^s[2]),f(p,q+12,c[1]^s[3]),q+=16}function n(){return p}var o=null,p=null,q=-1,r=null;r="twofish";var s=[],t=[[],[],[],[]];return{name:"twofish",blocksize:16,open:a,close:j,encrypt:l,decrypt:m,finalize:n}}function i(a){this.tf=h(),this.tf.open(l.str2bin(a),0),this.encrypt=function(a){return this.tf.encrypt(j(a),0)}}function j(a){for(var b=[],c=0;c<a.length;c++)b[c]=a[c];return b}var k=4294967295,l=a("../../util.js");b.exports=i,b.exports.keySize=i.prototype.keySize=32,b.exports.blockSize=i.prototype.blockSize=16},{"../../util.js":65}],14:[function(a,b,c){var d=a("./random.js"),e=a("./cipher"),f=a("./public_key"),g=a("../type/mpi.js");b.exports={publicKeyEncrypt:function(a,b,c){var d=function(){var d;switch(a){case"rsa_encrypt":case"rsa_encrypt_sign":var e=new f.rsa,g=b[0].toBigInteger(),h=b[1].toBigInteger();return d=c.toBigInteger(),[e.encrypt(d,h,g)];case"elgamal":var i=new f.elgamal,j=b[0].toBigInteger(),k=b[1].toBigInteger(),l=b[2].toBigInteger();return d=c.toBigInteger(),i.encrypt(d,k,j,l);default:return[]}}();return d.map(function(a){var b=new g;return b.fromBigInteger(a),b})},publicKeyDecrypt:function(a,b,c){var d,e=function(){switch(a){case"rsa_encrypt_sign":case"rsa_encrypt":var e=new f.rsa,g=b[0].toBigInteger(),h=b[1].toBigInteger(),i=b[2].toBigInteger();d=b[3].toBigInteger();var j=b[4].toBigInteger(),k=b[5].toBigInteger(),l=c[0].toBigInteger();return e.decrypt(l,g,h,i,d,j,k);case"elgamal":var m=new f.elgamal,n=b[3].toBigInteger(),o=c[0].toBigInteger(),p=c[1].toBigInteger();return d=b[0].toBigInteger(),m.decrypt(o,p,d,n);default:return null}}(),h=new g;return h.fromBigInteger(e),h},getPrivateMpiCount:function(a){switch(a){case"rsa_encrypt":case"rsa_encrypt_sign":case"rsa_sign":return 4;case"elgamal":return 1;case"dsa":return 1;default:throw new Error("Unknown algorithm")}},getPublicMpiCount:function(a){switch(a){case"rsa_encrypt":case"rsa_encrypt_sign":case"rsa_sign":return 2;case"elgamal":return 3;case"dsa":return 4;default:throw new Error("Unknown algorithm.")}},generateMpi:function(a,b){function c(a){return a.map(function(a){var b=new g;return b.fromBigInteger(a),b})}switch(a){case"rsa_encrypt":case"rsa_encrypt_sign":case"rsa_sign":var d=new f.rsa;return d.generate(b,"10001").then(function(a){var b=[];return b.push(a.n),b.push(a.ee),b.push(a.d),b.push(a.p),b.push(a.q),b.push(a.u),c(b)});default:throw new Error("Unsupported algorithm for key generation.")}},getPrefixRandom:function(a){return d.getRandomBytes(e[a].blockSize)},generateSessionKey:function(a){return d.getRandomBytes(e[a].keySize)}}},{"../type/mpi.js":63,"./cipher":12,"./public_key":25,"./random.js":28}],15:[function(a,b,c){var d=b.exports={},e=a("./forge_util.js"),f=null,g=!1,h=null,i=function(){f=String.fromCharCode(128),f+=e.fillString(String.fromCharCode(0),64),h=[1116352408,1899447441,3049323471,3921009573,961987163,1508970993,2453635748,2870763221,3624381080,310598401,607225278,1426881987,1925078388,2162078206,2614888103,3248222580,3835390401,4022224774,264347078,604807628,770255983,1249150122,1555081692,1996064986,2554220882,2821834349,2952996808,3210313671,3336571891,3584528711,113926993,338241895,666307205,773529912,1294757372,1396182291,1695183700,1986661051,2177026350,2456956037,2730485921,2820302411,3259730800,3345764771,3516065817,3600352804,4094571909,275423344,430227734,506948616,659060556,883997877,958139571,1322822218,1537002063,1747873779,1955562222,2024104815,2227730452,2361852424,2428436474,2756734187,3204031479,3329325298],g=!0},j=function(a,b,c){for(var d,e,f,g,i,j,k,l,m,n,o,p,q,r,s,t=c.length();t>=64;){for(k=0;16>k;++k)b[k]=c.getInt32();for(;64>k;++k)d=b[k-2],d=(d>>>17|d<<15)^(d>>>19|d<<13)^d>>>10,e=b[k-15],e=(e>>>7|e<<25)^(e>>>18|e<<14)^e>>>3,b[k]=d+b[k-7]+e+b[k-16]&4294967295;for(l=a.h0,m=a.h1,n=a.h2,o=a.h3,p=a.h4,q=a.h5,r=a.h6,s=a.h7,k=0;64>k;++k)g=(p>>>6|p<<26)^(p>>>11|p<<21)^(p>>>25|p<<7),i=r^p&(q^r),f=(l>>>2|l<<30)^(l>>>13|l<<19)^(l>>>22|l<<10),j=l&m|n&(l^m),d=s+g+i+h[k]+b[k],e=f+j,s=r,r=q,q=p,p=o+d&4294967295,o=n,n=m,m=l,l=d+e&4294967295;a.h0=a.h0+l&4294967295,a.h1=a.h1+m&4294967295,a.h2=a.h2+n&4294967295,a.h3=a.h3+o&4294967295,a.h4=a.h4+p&4294967295,a.h5=a.h5+q&4294967295,a.h6=a.h6+r&4294967295,a.h7=a.h7+s&4294967295,t-=64}};d.create=function(){g||i();var a=null,b=e.createBuffer(),c=new Array(64),d={algorithm:"sha256",blockLength:64,digestLength:32,messageLength:0};return d.start=function(){return d.messageLength=0,b=e.createBuffer(),a={h0:1779033703,h1:3144134277,h2:1013904242,h3:2773480762,h4:1359893119,h5:2600822924,h6:528734635,h7:1541459225},d},d.start(),d.update=function(f,g){return"utf8"===g&&(f=e.encodeUtf8(f)),d.messageLength+=f.length,b.putBytes(f),j(a,c,b),(b.read>2048||0===b.length())&&b.compact(),d},d.digest=function(){var g=d.messageLength,h=e.createBuffer();h.putBytes(b.bytes()),h.putBytes(f.substr(0,64-(g+8)%64)),h.putInt32(g>>>29&255),h.putInt32(g<<3&4294967295);var i={h0:a.h0,h1:a.h1,h2:a.h2,h3:a.h3,h4:a.h4,h5:a.h5,h6:a.h6,h7:a.h7};j(i,c,h);var k=e.createBuffer();return k.putInt32(i.h0),k.putInt32(i.h1),k.putInt32(i.h2),k.putInt32(i.h3),k.putInt32(i.h4),k.putInt32(i.h5),k.putInt32(i.h6),k.putInt32(i.h7),k},d}},{"./forge_util.js":16}],16:[function(a,b,c){var d=b.exports={};d.isArray=Array.isArray||function(a){return"[object Array]"===Object.prototype.toString.call(a)},d.isArrayBuffer=function(a){return"undefined"!=typeof ArrayBuffer&&a instanceof ArrayBuffer};var e=[];"undefined"!=typeof Int8Array&&e.push(Int8Array),"undefined"!=typeof Uint8Array&&e.push(Uint8Array),"undefined"!=typeof Uint8ClampedArray&&e.push(Uint8ClampedArray),"undefined"!=typeof Int16Array&&e.push(Int16Array),"undefined"!=typeof Uint16Array&&e.push(Uint16Array),"undefined"!=typeof Int32Array&&e.push(Int32Array),"undefined"!=typeof Uint32Array&&e.push(Uint32Array),"undefined"!=typeof Float32Array&&e.push(Float32Array),"undefined"!=typeof Float64Array&&e.push(Float64Array),d.isArrayBufferView=function(a){for(var b=0;b<e.length;++b)if(a instanceof e[b])return!0;return!1},d.ByteBuffer=function(a){if(this.data="",this.read=0,"string"==typeof a)this.data=a;else if(d.isArrayBuffer(a)||d.isArrayBufferView(a)){var b=new Uint8Array(a);try{this.data=String.fromCharCode.apply(null,b)}catch(c){for(var e=0;e<b.length;++e)this.putByte(b[e])}}},d.ByteBuffer.prototype.length=function(){return this.data.length-this.read},d.ByteBuffer.prototype.isEmpty=function(){return this.length()<=0},d.ByteBuffer.prototype.putByte=function(a){return this.data+=String.fromCharCode(a),this},d.ByteBuffer.prototype.fillWithByte=function(a,b){a=String.fromCharCode(a);for(var c=this.data;b>0;)1&b&&(c+=a),b>>>=1,b>0&&(a+=a);return this.data=c,this},d.ByteBuffer.prototype.putBytes=function(a){return this.data+=a,this},d.ByteBuffer.prototype.putString=function(a){return this.data+=d.encodeUtf8(a),this},d.ByteBuffer.prototype.putInt16=function(a){return this.data+=String.fromCharCode(a>>8&255)+String.fromCharCode(255&a),this},d.ByteBuffer.prototype.putInt24=function(a){return this.data+=String.fromCharCode(a>>16&255)+String.fromCharCode(a>>8&255)+String.fromCharCode(255&a),this},d.ByteBuffer.prototype.putInt32=function(a){return this.data+=String.fromCharCode(a>>24&255)+String.fromCharCode(a>>16&255)+String.fromCharCode(a>>8&255)+String.fromCharCode(255&a),this},d.ByteBuffer.prototype.putInt16Le=function(a){return this.data+=String.fromCharCode(255&a)+String.fromCharCode(a>>8&255),this},d.ByteBuffer.prototype.putInt24Le=function(a){return this.data+=String.fromCharCode(255&a)+String.fromCharCode(a>>8&255)+String.fromCharCode(a>>16&255),this},d.ByteBuffer.prototype.putInt32Le=function(a){return this.data+=String.fromCharCode(255&a)+String.fromCharCode(a>>8&255)+String.fromCharCode(a>>16&255)+String.fromCharCode(a>>24&255),this},d.ByteBuffer.prototype.putInt=function(a,b){do b-=8,this.data+=String.fromCharCode(a>>b&255);while(b>0);return this},d.ByteBuffer.prototype.putSignedInt=function(a,b){return 0>a&&(a+=2<<b-1),this.putInt(a,b)},d.ByteBuffer.prototype.putBuffer=function(a){return this.data+=a.getBytes(),this},d.ByteBuffer.prototype.getByte=function(){return this.data.charCodeAt(this.read++)},d.ByteBuffer.prototype.getInt16=function(){var a=this.data.charCodeAt(this.read)<<8^this.data.charCodeAt(this.read+1);return this.read+=2,a},d.ByteBuffer.prototype.getInt24=function(){var a=this.data.charCodeAt(this.read)<<16^this.data.charCodeAt(this.read+1)<<8^this.data.charCodeAt(this.read+2);return this.read+=3,a},d.ByteBuffer.prototype.getInt32=function(){var a=this.data.charCodeAt(this.read)<<24^this.data.charCodeAt(this.read+1)<<16^this.data.charCodeAt(this.read+2)<<8^this.data.charCodeAt(this.read+3);return this.read+=4,a},d.ByteBuffer.prototype.getInt16Le=function(){var a=this.data.charCodeAt(this.read)^this.data.charCodeAt(this.read+1)<<8;return this.read+=2,a},d.ByteBuffer.prototype.getInt24Le=function(){var a=this.data.charCodeAt(this.read)^this.data.charCodeAt(this.read+1)<<8^this.data.charCodeAt(this.read+2)<<16;return this.read+=3,a},d.ByteBuffer.prototype.getInt32Le=function(){var a=this.data.charCodeAt(this.read)^this.data.charCodeAt(this.read+1)<<8^this.data.charCodeAt(this.read+2)<<16^this.data.charCodeAt(this.read+3)<<24;return this.read+=4,a},d.ByteBuffer.prototype.getInt=function(a){var b=0;do b=(b<<8)+this.data.charCodeAt(this.read++),a-=8;while(a>0);return b},d.ByteBuffer.prototype.getSignedInt=function(a){var b=this.getInt(a),c=2<<a-2;return b>=c&&(b-=c<<1),b},d.ByteBuffer.prototype.getBytes=function(a){var b;return a?(a=Math.min(this.length(),a),b=this.data.slice(this.read,this.read+a),this.read+=a):0===a?b="":(b=0===this.read?this.data:this.data.slice(this.read),this.clear()),b},d.ByteBuffer.prototype.bytes=function(a){return"undefined"==typeof a?this.data.slice(this.read):this.data.slice(this.read,this.read+a)},d.ByteBuffer.prototype.at=function(a){return this.data.charCodeAt(this.read+a)},d.ByteBuffer.prototype.setAt=function(a,b){return this.data=this.data.substr(0,this.read+a)+String.fromCharCode(b)+this.data.substr(this.read+a+1),this},d.ByteBuffer.prototype.last=function(){return this.data.charCodeAt(this.data.length-1)},d.ByteBuffer.prototype.copy=function(){var a=d.createBuffer(this.data);return a.read=this.read,a},d.ByteBuffer.prototype.compact=function(){return this.read>0&&(this.data=this.data.slice(this.read),this.read=0),this},d.ByteBuffer.prototype.clear=function(){return this.data="",this.read=0,this},d.ByteBuffer.prototype.truncate=function(a){var b=Math.max(0,this.length()-a);return this.data=this.data.substr(this.read,b),this.read=0,this},d.ByteBuffer.prototype.toHex=function(){for(var a="",b=this.read;b<this.data.length;++b){var c=this.data.charCodeAt(b);16>c&&(a+="0"),a+=c.toString(16)}return a},d.ByteBuffer.prototype.toString=function(){return d.decodeUtf8(this.bytes())},d.createBuffer=function(a,b){return b=b||"raw",void 0!==a&&"utf8"===b&&(a=d.encodeUtf8(a)),new d.ByteBuffer(a)},d.fillString=function(a,b){for(var c="";b>0;)1&b&&(c+=a),b>>>=1,b>0&&(a+=a);return c},d.xorBytes=function(a,b,c){for(var d="",e="",f="",g=0,h=0;c>0;--c,++g)e=a.charCodeAt(g)^b.charCodeAt(g),h>=10&&(d+=f,f="",h=0),f+=String.fromCharCode(e),++h;return d+=f},d.hexToBytes=function(a){var b="",c=0;for(a.length&!0&&(c=1,b+=String.fromCharCode(parseInt(a[0],16)));c<a.length;c+=2)b+=String.fromCharCode(parseInt(a.substr(c,2),16));return b},d.bytesToHex=function(a){return d.createBuffer(a).toHex()},d.int32ToBytes=function(a){return String.fromCharCode(a>>24&255)+String.fromCharCode(a>>16&255)+String.fromCharCode(a>>8&255)+String.fromCharCode(255&a)};var f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",g=[62,-1,-1,-1,63,52,53,54,55,56,57,58,59,60,61,-1,-1,-1,64,-1,-1,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,-1,-1,-1,-1,-1,-1,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51];d.encode64=function(a,b){for(var c,d,e,g="",h="",i=0;i<a.length;)c=a.charCodeAt(i++),d=a.charCodeAt(i++),e=a.charCodeAt(i++),g+=f.charAt(c>>2),g+=f.charAt((3&c)<<4|d>>4),isNaN(d)?g+="==":(g+=f.charAt((15&d)<<2|e>>6),g+=isNaN(e)?"=":f.charAt(63&e)),b&&g.length>b&&(h+=g.substr(0,b)+"\r\n",g=g.substr(b));return h+=g},d.decode64=function(a){a=a.replace(/[^A-Za-z0-9\+\/\=]/g,"");for(var b,c,d,e,f="",h=0;h<a.length;)b=g[a.charCodeAt(h++)-43],c=g[a.charCodeAt(h++)-43],d=g[a.charCodeAt(h++)-43],e=g[a.charCodeAt(h++)-43],f+=String.fromCharCode(b<<2|c>>4),64!==d&&(f+=String.fromCharCode((15&c)<<4|d>>2),64!==e&&(f+=String.fromCharCode((3&d)<<6|e)));return f},d.encodeUtf8=function(a){return unescape(encodeURIComponent(a))},d.decodeUtf8=function(a){return decodeURIComponent(escape(a))}},{}],17:[function(a,b,c){var d=a("./sha.js"),e=a("./forge_sha256.js");b.exports={md5:a("./md5.js"),sha1:d.sha1,sha224:d.sha224,sha256:d.sha256,sha384:d.sha384,sha512:d.sha512,ripemd:a("./ripe-md.js"),digest:function(a,b){switch(a){case 1:return this.md5(b);case 2:return this.sha1(b);case 3:return this.ripemd(b);case 8:var c=e.create();return c.update(b),c.digest().getBytes();case 9:return this.sha384(b);case 10:return this.sha512(b);case 11:return this.sha224(b);default:throw new Error("Invalid hash function.")}},getHashByteLength:function(a){switch(a){case 1:return 16;case 2:case 3:return 20;case 8:return 32;case 9:return 48;case 10:return 64;case 11:return 28;default:throw new Error("Invalid hash algorithm.")}}}},{"./forge_sha256.js":15,"./md5.js":18,"./ripe-md.js":19,"./sha.js":20}],18:[function(a,b,c){function d(a,b){var c=a[0],d=a[1],e=a[2],j=a[3];c=f(c,d,e,j,b[0],7,-680876936),j=f(j,c,d,e,b[1],12,-389564586),e=f(e,j,c,d,b[2],17,606105819),d=f(d,e,j,c,b[3],22,-1044525330),c=f(c,d,e,j,b[4],7,-176418897),j=f(j,c,d,e,b[5],12,1200080426),e=f(e,j,c,d,b[6],17,-1473231341),d=f(d,e,j,c,b[7],22,-45705983),c=f(c,d,e,j,b[8],7,1770035416),j=f(j,c,d,e,b[9],12,-1958414417),e=f(e,j,c,d,b[10],17,-42063),d=f(d,e,j,c,b[11],22,-1990404162),c=f(c,d,e,j,b[12],7,1804603682),j=f(j,c,d,e,b[13],12,-40341101),e=f(e,j,c,d,b[14],17,-1502002290),d=f(d,e,j,c,b[15],22,1236535329),c=g(c,d,e,j,b[1],5,-165796510),j=g(j,c,d,e,b[6],9,-1069501632),e=g(e,j,c,d,b[11],14,643717713),d=g(d,e,j,c,b[0],20,-373897302),c=g(c,d,e,j,b[5],5,-701558691),j=g(j,c,d,e,b[10],9,38016083),e=g(e,j,c,d,b[15],14,-660478335),d=g(d,e,j,c,b[4],20,-405537848),c=g(c,d,e,j,b[9],5,568446438),j=g(j,c,d,e,b[14],9,-1019803690),e=g(e,j,c,d,b[3],14,-187363961),d=g(d,e,j,c,b[8],20,1163531501),c=g(c,d,e,j,b[13],5,-1444681467),j=g(j,c,d,e,b[2],9,-51403784),e=g(e,j,c,d,b[7],14,1735328473),d=g(d,e,j,c,b[12],20,-1926607734),c=h(c,d,e,j,b[5],4,-378558),j=h(j,c,d,e,b[8],11,-2022574463),e=h(e,j,c,d,b[11],16,1839030562),d=h(d,e,j,c,b[14],23,-35309556),c=h(c,d,e,j,b[1],4,-1530992060),j=h(j,c,d,e,b[4],11,1272893353),e=h(e,j,c,d,b[7],16,-155497632),d=h(d,e,j,c,b[10],23,-1094730640),c=h(c,d,e,j,b[13],4,681279174),j=h(j,c,d,e,b[0],11,-358537222),e=h(e,j,c,d,b[3],16,-722521979),d=h(d,e,j,c,b[6],23,76029189),c=h(c,d,e,j,b[9],4,-640364487),j=h(j,c,d,e,b[12],11,-421815835),e=h(e,j,c,d,b[15],16,530742520),d=h(d,e,j,c,b[2],23,-995338651),c=i(c,d,e,j,b[0],6,-198630844),j=i(j,c,d,e,b[7],10,1126891415),e=i(e,j,c,d,b[14],15,-1416354905),d=i(d,e,j,c,b[5],21,-57434055),c=i(c,d,e,j,b[12],6,1700485571),j=i(j,c,d,e,b[3],10,-1894986606),e=i(e,j,c,d,b[10],15,-1051523),d=i(d,e,j,c,b[1],21,-2054922799),c=i(c,d,e,j,b[8],6,1873313359),j=i(j,c,d,e,b[15],10,-30611744),e=i(e,j,c,d,b[6],15,-1560198380),d=i(d,e,j,c,b[13],21,1309151649),c=i(c,d,e,j,b[4],6,-145523070),j=i(j,c,d,e,b[11],10,-1120210379),e=i(e,j,c,d,b[2],15,718787259),d=i(d,e,j,c,b[9],21,-343485551),a[0]=o(c,a[0]),a[1]=o(d,a[1]),a[2]=o(e,a[2]),a[3]=o(j,a[3])}function e(a,b,c,d,e,f){return b=o(o(b,a),o(d,f)),o(b<<e|b>>>32-e,c)}function f(a,b,c,d,f,g,h){return e(b&c|~b&d,a,b,f,g,h)}function g(a,b,c,d,f,g,h){return e(b&d|c&~d,a,b,f,g,h)}function h(a,b,c,d,f,g,h){return e(b^c^d,a,b,f,g,h)}function i(a,b,c,d,f,g,h){return e(c^(b|~d),a,b,f,g,h)}function j(a){var b,c=a.length,e=[1732584193,-271733879,-1732584194,271733878];for(b=64;b<=a.length;b+=64)d(e,k(a.substring(b-64,b)));a=a.substring(b-64);var f=[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0];for(b=0;b<a.length;b++)f[b>>2]|=a.charCodeAt(b)<<(b%4<<3);if(f[b>>2]|=128<<(b%4<<3),b>55)for(d(e,f),b=0;16>b;b++)f[b]=0;return f[14]=8*c,d(e,f),e}function k(a){var b,c=[];for(b=0;64>b;b+=4)c[b>>2]=a.charCodeAt(b)+(a.charCodeAt(b+1)<<8)+(a.charCodeAt(b+2)<<16)+(a.charCodeAt(b+3)<<24);return c}function l(a){for(var b="",c=0;4>c;c++)b+=q[a>>8*c+4&15]+q[a>>8*c&15];return b}function m(a){for(var b=0;b<a.length;b++)a[b]=l(a[b]);return a.join("")}function n(a){return m(j(a))}function o(a,b){return a+b&4294967295}function o(a,b){var c=(65535&a)+(65535&b),d=(a>>16)+(b>>16)+(c>>16);return d<<16|65535&c}var p=a("../../util.js");b.exports=function(a){var b=n(a),c=p.hex2bin(b);return c};var q="0123456789abcdef".split("");"5d41402abc4b2a76b9719d911017c592"!=n("hello")},{"../../util.js":65}],19:[function(a,b,c){function d(a,b){return new Number(a<<b|a>>>32-b)}function e(a,b,c){return new Number(a^b^c)}function f(a,b,c){return new Number(a&b|~a&c)}function g(a,b,c){return new Number((a|~b)^c)}function h(a,b,c){return new Number(a&c|b&~c)}function i(a,b,c){return new Number(a^(b|~c))}function j(a,b,c,j,k,l,m,n){switch(n){case 0:a+=e(b,c,j)+l+0;break;case 1:a+=f(b,c,j)+l+1518500249;break;case 2:a+=g(b,c,j)+l+1859775393;break;case 3:a+=h(b,c,j)+l+2400959708;break;case 4:a+=i(b,c,j)+l+2840853838;break;case 5:a+=i(b,c,j)+l+1352829926;break;case 6:a+=h(b,c,j)+l+1548603684;break;case 7:a+=g(b,c,j)+l+1836072691;break;case 8:a+=f(b,c,j)+l+2053994217;break;case 9:a+=e(b,c,j)+l+0;break;default:throw new Error("Bogus round number")}a=d(a,m)+k,c=d(c,10),a&=4294967295,b&=4294967295,c&=4294967295,j&=4294967295,k&=4294967295;var o=[];return o[0]=a,o[1]=b,o[2]=c,o[3]=j,o[4]=k,o[5]=l,o[6]=m,o}function k(a){a[0]=1732584193,a[1]=4023233417,a[2]=2562383102,a[3]=271733878,a[4]=3285377520}function l(a,b){var c,d,e,f=[],g=[];for(d=0;5>d;d++)f[d]=new Number(a[d]),g[d]=new Number(a[d]);var h=0;for(e=0;5>e;e++)for(d=0;16>d;d++)c=j(f[(h+0)%5],f[(h+1)%5],f[(h+2)%5],f[(h+3)%5],f[(h+4)%5],b[t[e][d]],s[e][d],e),f[(h+0)%5]=c[0],f[(h+1)%5]=c[1],f[(h+2)%5]=c[2],f[(h+3)%5]=c[3],f[(h+4)%5]=c[4],h+=4;for(h=0,e=5;10>e;e++)for(d=0;16>d;d++)c=j(g[(h+0)%5],g[(h+1)%5],g[(h+2)%5],g[(h+3)%5],g[(h+4)%5],b[t[e][d]],s[e][d],e),g[(h+0)%5]=c[0],g[(h+1)%5]=c[1],g[(h+2)%5]=c[2],g[(h+3)%5]=c[3],g[(h+4)%5]=c[4],h+=4;g[3]+=f[2]+a[1],a[1]=a[2]+f[3]+g[4],a[2]=a[3]+f[4]+g[0],a[3]=a[4]+f[0]+g[1],a[4]=a[0]+f[1]+g[2],a[0]=g[3]}function m(a){for(var b=0;16>b;b++)a[b]=0}function n(a,b,c,d){var e=new Array(16);m(e);for(var f=0,g=0;(63&c)>g;g++)e[g>>>2]^=(255&b.charCodeAt(f++))<<8*(3&g);e[c>>>2&15]^=1<<8*(3&c)+7,(63&c)>55&&(l(a,e),e=new Array(16),m(e)),e[14]=c<<3,e[15]=c>>>29|d<<3,l(a,e)}function o(a){var b=(255&a.charCodeAt(3))<<24;return b|=(255&a.charCodeAt(2))<<16,b|=(255&a.charCodeAt(1))<<8,b|=255&a.charCodeAt(0)}function p(a){var b,c,d=new Array(r/32),e=new Array(r/8);k(d),b=a.length;var f=new Array(16);m(f);var g,h=0;for(c=b;c>63;c-=64){for(g=0;16>g;g++)f[g]=o(a.substr(h,4)),h+=4;l(d,f)}for(n(d,a.substr(h),b,0),g=0;r/8>g;g+=4)e[g]=255&d[g>>>2],e[g+1]=d[g>>>2]>>>8&255,e[g+2]=d[g>>>2]>>>16&255,e[g+3]=d[g>>>2]>>>24&255;return e}function q(a){for(var b=p(a),c="",d=0;r/8>d;d++)c+=String.fromCharCode(b[d]);return c}var r=160,s=[[11,14,15,12,5,8,7,9,11,13,14,15,6,7,9,8],[7,6,8,13,11,9,7,15,7,12,15,9,11,7,13,12],[11,13,6,7,14,9,13,15,14,8,13,6,5,12,7,5],[11,12,14,15,14,15,9,8,9,14,5,6,8,6,5,12],[9,15,5,11,6,8,13,12,5,12,13,14,11,8,5,6],[8,9,9,11,13,15,15,5,7,7,8,11,14,14,12,6],[9,13,15,7,12,8,9,11,7,7,12,7,6,15,13,11],[9,7,15,11,8,6,6,14,12,13,5,14,13,13,7,5],[15,5,8,11,14,14,6,14,6,9,12,9,12,5,15,8],[8,5,12,9,12,5,14,6,8,13,6,5,15,13,11,11]],t=[[0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15],[7,4,13,1,10,6,15,3,12,0,9,5,2,14,11,8],[3,10,14,4,9,15,8,1,2,7,0,6,13,11,5,12],[1,9,11,10,0,8,12,4,13,3,7,15,14,5,6,2],[4,0,5,9,7,12,2,10,14,1,3,8,11,6,15,13],[5,14,7,0,9,2,11,4,13,6,15,8,1,10,3,12],[6,11,3,7,0,13,5,10,14,15,8,12,4,9,1,2],[15,5,1,3,7,14,6,9,11,8,12,2,10,0,4,13],[8,6,4,1,3,11,15,0,5,12,2,13,9,7,10,14],[12,15,10,4,1,5,8,7,6,2,13,14,0,3,9,11]];b.exports=q},{}],20:[function(a,b,c){var d=function(){var a=8,b="",c=0,d=function(a,b){this.highOrder=a,this.lowOrder=b},e=function(b){var c,d=[],e=(1<<a)-1,f=b.length*a;for(c=0;f>c;c+=a)d[c>>5]|=(b.charCodeAt(c/a)&e)<<32-a-c%32;return d},f=function(a){var b,c,d=[],e=a.length;for(b=0;e>b;b+=2){if(c=parseInt(a.substr(b,2),16),isNaN(c))throw new Error("INVALID HEX STRING");d[b>>3]|=c<<24-4*(b%8)}return d},g=function(a){var b,d,e=c?"0123456789ABCDEF":"0123456789abcdef",f="",g=4*a.length;for(b=0;g>b;b+=1)d=a[b>>2]>>8*(3-b%4),f+=e.charAt(d>>4&15)+e.charAt(15&d);return f},h=function(a){var c,d,e,f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",g="",h=4*a.length;for(c=0;h>c;c+=3)for(e=(a[c>>2]>>8*(3-c%4)&255)<<16|(a[c+1>>2]>>8*(3-(c+1)%4)&255)<<8|a[c+2>>2]>>8*(3-(c+2)%4)&255,d=0;4>d;d+=1)g+=8*c+6*d<=32*a.length?f.charAt(e>>6*(3-d)&63):b;return g},i=function(a){for(var b="",c=255,d=0;d<32*a.length;d+=8)b+=String.fromCharCode(a[d>>5]>>>24-d%32&c);return b},j=function(a,b){return a<<b|a>>>32-b},k=function(a,b){return a>>>b|a<<32-b},l=function(a,b){return 32>=b?new d(a.highOrder>>>b|a.lowOrder<<32-b,a.lowOrder>>>b|a.highOrder<<32-b):new d(a.lowOrder>>>b|a.highOrder<<32-b,a.highOrder>>>b|a.lowOrder<<32-b)},m=function(a,b){return a>>>b},n=function(a,b){return 32>=b?new d(a.highOrder>>>b,a.lowOrder>>>b|a.highOrder<<32-b):new d(0,a.highOrder<<32-b)},o=function(a,b,c){return a^b^c},p=function(a,b,c){return a&b^~a&c},q=function(a,b,c){return new d(a.highOrder&b.highOrder^~a.highOrder&c.highOrder,a.lowOrder&b.lowOrder^~a.lowOrder&c.lowOrder)},r=function(a,b,c){return a&b^a&c^b&c},s=function(a,b,c){return new d(a.highOrder&b.highOrder^a.highOrder&c.highOrder^b.highOrder&c.highOrder,a.lowOrder&b.lowOrder^a.lowOrder&c.lowOrder^b.lowOrder&c.lowOrder)},t=function(a){return k(a,2)^k(a,13)^k(a,22)},u=function(a){var b=l(a,28),c=l(a,34),e=l(a,39);return new d(b.highOrder^c.highOrder^e.highOrder,b.lowOrder^c.lowOrder^e.lowOrder)},v=function(a){return k(a,6)^k(a,11)^k(a,25)},w=function(a){var b=l(a,14),c=l(a,18),e=l(a,41);return new d(b.highOrder^c.highOrder^e.highOrder,b.lowOrder^c.lowOrder^e.lowOrder)},x=function(a){return k(a,7)^k(a,18)^m(a,3)},y=function(a){var b=l(a,1),c=l(a,8),e=n(a,7);return new d(b.highOrder^c.highOrder^e.highOrder,b.lowOrder^c.lowOrder^e.lowOrder)},z=function(a){return k(a,17)^k(a,19)^m(a,10)},A=function(a){var b=l(a,19),c=l(a,61),e=n(a,6);return new d(b.highOrder^c.highOrder^e.highOrder,b.lowOrder^c.lowOrder^e.lowOrder)},B=function(a,b){var c=(65535&a)+(65535&b),d=(a>>>16)+(b>>>16)+(c>>>16);return(65535&d)<<16|65535&c},C=function(a,b,c,d){var e=(65535&a)+(65535&b)+(65535&c)+(65535&d),f=(a>>>16)+(b>>>16)+(c>>>16)+(d>>>16)+(e>>>16);return(65535&f)<<16|65535&e},D=function(a,b,c,d,e){var f=(65535&a)+(65535&b)+(65535&c)+(65535&d)+(65535&e),g=(a>>>16)+(b>>>16)+(c>>>16)+(d>>>16)+(e>>>16)+(f>>>16);return(65535&g)<<16|65535&f},E=function(a,b){var c,e,f,g;return c=(65535&a.lowOrder)+(65535&b.lowOrder),e=(a.lowOrder>>>16)+(b.lowOrder>>>16)+(c>>>16),f=(65535&e)<<16|65535&c,c=(65535&a.highOrder)+(65535&b.highOrder)+(e>>>16),e=(a.highOrder>>>16)+(b.highOrder>>>16)+(c>>>16),g=(65535&e)<<16|65535&c,new d(g,f)},F=function(a,b,c,e){
	var f,g,h,i;return f=(65535&a.lowOrder)+(65535&b.lowOrder)+(65535&c.lowOrder)+(65535&e.lowOrder),g=(a.lowOrder>>>16)+(b.lowOrder>>>16)+(c.lowOrder>>>16)+(e.lowOrder>>>16)+(f>>>16),h=(65535&g)<<16|65535&f,f=(65535&a.highOrder)+(65535&b.highOrder)+(65535&c.highOrder)+(65535&e.highOrder)+(g>>>16),g=(a.highOrder>>>16)+(b.highOrder>>>16)+(c.highOrder>>>16)+(e.highOrder>>>16)+(f>>>16),i=(65535&g)<<16|65535&f,new d(i,h)},G=function(a,b,c,e,f){var g,h,i,j;return g=(65535&a.lowOrder)+(65535&b.lowOrder)+(65535&c.lowOrder)+(65535&e.lowOrder)+(65535&f.lowOrder),h=(a.lowOrder>>>16)+(b.lowOrder>>>16)+(c.lowOrder>>>16)+(e.lowOrder>>>16)+(f.lowOrder>>>16)+(g>>>16),i=(65535&h)<<16|65535&g,g=(65535&a.highOrder)+(65535&b.highOrder)+(65535&c.highOrder)+(65535&e.highOrder)+(65535&f.highOrder)+(h>>>16),h=(a.highOrder>>>16)+(b.highOrder>>>16)+(c.highOrder>>>16)+(e.highOrder>>>16)+(f.highOrder>>>16)+(g>>>16),j=(65535&h)<<16|65535&g,new d(j,i)},H=function(a,b){var c,d,e,f,g,h,i,k,l,m=[],n=p,q=o,s=r,t=j,u=B,v=D,w=[1732584193,4023233417,2562383102,271733878,3285377520],x=[1518500249,1518500249,1518500249,1518500249,1518500249,1518500249,1518500249,1518500249,1518500249,1518500249,1518500249,1518500249,1518500249,1518500249,1518500249,1518500249,1518500249,1518500249,1518500249,1518500249,1859775393,1859775393,1859775393,1859775393,1859775393,1859775393,1859775393,1859775393,1859775393,1859775393,1859775393,1859775393,1859775393,1859775393,1859775393,1859775393,1859775393,1859775393,1859775393,1859775393,2400959708,2400959708,2400959708,2400959708,2400959708,2400959708,2400959708,2400959708,2400959708,2400959708,2400959708,2400959708,2400959708,2400959708,2400959708,2400959708,2400959708,2400959708,2400959708,2400959708,3395469782,3395469782,3395469782,3395469782,3395469782,3395469782,3395469782,3395469782,3395469782,3395469782,3395469782,3395469782,3395469782,3395469782,3395469782,3395469782,3395469782,3395469782,3395469782,3395469782];for(a[b>>5]|=128<<24-b%32,a[(b+65>>9<<4)+15]=b,l=a.length,i=0;l>i;i+=16){for(c=w[0],d=w[1],e=w[2],f=w[3],g=w[4],k=0;80>k;k+=1)16>k?m[k]=a[k+i]:m[k]=t(m[k-3]^m[k-8]^m[k-14]^m[k-16],1),h=20>k?v(t(c,5),n(d,e,f),g,x[k],m[k]):40>k?v(t(c,5),q(d,e,f),g,x[k],m[k]):60>k?v(t(c,5),s(d,e,f),g,x[k],m[k]):v(t(c,5),q(d,e,f),g,x[k],m[k]),g=f,f=e,e=t(d,30),d=c,c=h;w[0]=u(c,w[0]),w[1]=u(d,w[1]),w[2]=u(e,w[2]),w[3]=u(f,w[3]),w[4]=u(g,w[4])}return w},I=function(a,b,c){var e,f,g,h,i,j,k,l,m,n,o,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z=[];for("SHA-224"===c||"SHA-256"===c?(H=64,I=(b+65>>9<<4)+15,L=16,M=1,W=Number,N=B,O=C,P=D,Q=x,R=z,S=t,T=v,V=r,U=p,X=[1116352408,1899447441,3049323471,3921009573,961987163,1508970993,2453635748,2870763221,3624381080,310598401,607225278,1426881987,1925078388,2162078206,2614888103,3248222580,3835390401,4022224774,264347078,604807628,770255983,1249150122,1555081692,1996064986,2554220882,2821834349,2952996808,3210313671,3336571891,3584528711,113926993,338241895,666307205,773529912,1294757372,1396182291,1695183700,1986661051,2177026350,2456956037,2730485921,2820302411,3259730800,3345764771,3516065817,3600352804,4094571909,275423344,430227734,506948616,659060556,883997877,958139571,1322822218,1537002063,1747873779,1955562222,2024104815,2227730452,2361852424,2428436474,2756734187,3204031479,3329325298],o="SHA-224"===c?[3238371032,914150663,812702999,4144912697,4290775857,1750603025,1694076839,3204075428]:[1779033703,3144134277,1013904242,2773480762,1359893119,2600822924,528734635,1541459225]):("SHA-384"===c||"SHA-512"===c)&&(H=80,I=(b+128>>10<<5)+31,L=32,M=2,W=d,N=E,O=F,P=G,Q=y,R=A,S=u,T=w,V=s,U=q,X=[new W(1116352408,3609767458),new W(1899447441,602891725),new W(3049323471,3964484399),new W(3921009573,2173295548),new W(961987163,4081628472),new W(1508970993,3053834265),new W(2453635748,2937671579),new W(2870763221,3664609560),new W(3624381080,2734883394),new W(310598401,1164996542),new W(607225278,1323610764),new W(1426881987,3590304994),new W(1925078388,4068182383),new W(2162078206,991336113),new W(2614888103,633803317),new W(3248222580,3479774868),new W(3835390401,2666613458),new W(4022224774,944711139),new W(264347078,2341262773),new W(604807628,2007800933),new W(770255983,1495990901),new W(1249150122,1856431235),new W(1555081692,3175218132),new W(1996064986,2198950837),new W(2554220882,3999719339),new W(2821834349,766784016),new W(2952996808,2566594879),new W(3210313671,3203337956),new W(3336571891,1034457026),new W(3584528711,2466948901),new W(113926993,3758326383),new W(338241895,168717936),new W(666307205,1188179964),new W(773529912,1546045734),new W(1294757372,1522805485),new W(1396182291,2643833823),new W(1695183700,2343527390),new W(1986661051,1014477480),new W(2177026350,1206759142),new W(2456956037,344077627),new W(2730485921,1290863460),new W(2820302411,3158454273),new W(3259730800,3505952657),new W(3345764771,106217008),new W(3516065817,3606008344),new W(3600352804,1432725776),new W(4094571909,1467031594),new W(275423344,851169720),new W(430227734,3100823752),new W(506948616,1363258195),new W(659060556,3750685593),new W(883997877,3785050280),new W(958139571,3318307427),new W(1322822218,3812723403),new W(1537002063,2003034995),new W(1747873779,3602036899),new W(1955562222,1575990012),new W(2024104815,1125592928),new W(2227730452,2716904306),new W(2361852424,442776044),new W(2428436474,593698344),new W(2756734187,3733110249),new W(3204031479,2999351573),new W(3329325298,3815920427),new W(3391569614,3928383900),new W(3515267271,566280711),new W(3940187606,3454069534),new W(4118630271,4000239992),new W(116418474,1914138554),new W(174292421,2731055270),new W(289380356,3203993006),new W(460393269,320620315),new W(685471733,587496836),new W(852142971,1086792851),new W(1017036298,365543100),new W(1126000580,2618297676),new W(1288033470,3409855158),new W(1501505948,4234509866),new W(1607167915,987167468),new W(1816402316,1246189591)],o="SHA-384"===c?[new W(3418070365,3238371032),new W(1654270250,914150663),new W(2438529370,812702999),new W(355462360,4144912697),new W(1731405415,4290775857),new W(41048885895,1750603025),new W(3675008525,1694076839),new W(1203062813,3204075428)]:[new W(1779033703,4089235720),new W(3144134277,2227873595),new W(1013904242,4271175723),new W(2773480762,1595750129),new W(1359893119,2917565137),new W(2600822924,725511199),new W(528734635,4215389547),new W(1541459225,327033209)]),a[b>>5]|=128<<24-b%32,a[I]=b,Y=a.length,J=0;Y>J;J+=L){for(e=o[0],f=o[1],g=o[2],h=o[3],i=o[4],j=o[5],k=o[6],l=o[7],K=0;H>K;K+=1)16>K?Z[K]=new W(a[K*M+J],a[K*M+J+1]):Z[K]=O(R(Z[K-2]),Z[K-7],Q(Z[K-15]),Z[K-16]),m=P(l,T(i),U(i,j,k),X[K],Z[K]),n=N(S(e),V(e,f,g)),l=k,k=j,j=i,i=N(h,m),h=g,g=f,f=e,e=N(m,n);o[0]=N(e,o[0]),o[1]=N(f,o[1]),o[2]=N(g,o[2]),o[3]=N(h,o[3]),o[4]=N(i,o[4]),o[5]=N(j,o[5]),o[6]=N(k,o[6]),o[7]=N(l,o[7])}switch(c){case"SHA-224":return[o[0],o[1],o[2],o[3],o[4],o[5],o[6]];case"SHA-256":return o;case"SHA-384":return[o[0].highOrder,o[0].lowOrder,o[1].highOrder,o[1].lowOrder,o[2].highOrder,o[2].lowOrder,o[3].highOrder,o[3].lowOrder,o[4].highOrder,o[4].lowOrder,o[5].highOrder,o[5].lowOrder];case"SHA-512":return[o[0].highOrder,o[0].lowOrder,o[1].highOrder,o[1].lowOrder,o[2].highOrder,o[2].lowOrder,o[3].highOrder,o[3].lowOrder,o[4].highOrder,o[4].lowOrder,o[5].highOrder,o[5].lowOrder,o[6].highOrder,o[6].lowOrder,o[7].highOrder,o[7].lowOrder];default:throw new Error("Unknown SHA variant")}},J=function(b,c){if(this.sha1=null,this.sha224=null,this.sha256=null,this.sha384=null,this.sha512=null,this.strBinLen=null,this.strToHash=null,"HEX"===c){if(0!==b.length%2)throw new Error("TEXT MUST BE IN BYTE INCREMENTS");this.strBinLen=4*b.length,this.strToHash=f(b)}else{if("ASCII"!==c&&"undefined"!=typeof c)throw new Error("UNKNOWN TEXT INPUT TYPE");this.strBinLen=b.length*a,this.strToHash=e(b)}};return J.prototype={getHash:function(a,b){var c=null,d=this.strToHash.slice();switch(b){case"HEX":c=g;break;case"B64":c=h;break;case"ASCII":c=i;break;default:throw new Error("FORMAT NOT RECOGNIZED")}switch(a){case"SHA-1":return null===this.sha1&&(this.sha1=H(d,this.strBinLen)),c(this.sha1);case"SHA-224":return null===this.sha224&&(this.sha224=I(d,this.strBinLen,a)),c(this.sha224);case"SHA-256":return null===this.sha256&&(this.sha256=I(d,this.strBinLen,a)),c(this.sha256);case"SHA-384":return null===this.sha384&&(this.sha384=I(d,this.strBinLen,a)),c(this.sha384);case"SHA-512":return null===this.sha512&&(this.sha512=I(d,this.strBinLen,a)),c(this.sha512);default:throw new Error("HASH NOT RECOGNIZED")}},getHMAC:function(b,c,d,j){var k,l,m,n,o,p,q,r,s,t=[],u=[];switch(j){case"HEX":k=g;break;case"B64":k=h;break;case"ASCII":k=i;break;default:throw new Error("FORMAT NOT RECOGNIZED")}switch(d){case"SHA-1":m=64,s=160;break;case"SHA-224":m=64,s=224;break;case"SHA-256":m=64,s=256;break;case"SHA-384":m=128,s=384;break;case"SHA-512":m=128,s=512;break;default:throw new Error("HASH NOT RECOGNIZED")}if("HEX"===c){if(0!==b.length%2)throw new Error("KEY MUST BE IN BYTE INCREMENTS");l=f(b),r=4*b.length}else{if("ASCII"!==c)throw new Error("UNKNOWN KEY INPUT TYPE");l=e(b),r=b.length*a}for(n=8*m,q=m/4-1,r/8>m?(l="SHA-1"===d?H(l,r):I(l,r,d),l[q]&=4294967040):m>r/8&&(l[q]&=4294967040),o=0;q>=o;o+=1)t[o]=909522486^l[o],u[o]=1549556828^l[o];return"SHA-1"===d?(p=H(t.concat(this.strToHash),n+this.strBinLen),p=H(u.concat(p),n+s)):(p=I(t.concat(this.strToHash),n+this.strBinLen,d),p=I(u.concat(p),n+s,d)),k(p)}},J}();b.exports={sha1:function(a){var b=new d(a,"ASCII");return b.getHash("SHA-1","ASCII")},sha224:function(a){var b=new d(a,"ASCII");return b.getHash("SHA-224","ASCII")},sha256:function(a){var b=new d(a,"ASCII");return b.getHash("SHA-256","ASCII")},sha384:function(a){var b=new d(a,"ASCII");return b.getHash("SHA-384","ASCII")},sha512:function(a){var b=new d(a,"ASCII");return b.getHash("SHA-512","ASCII")}}},{}],21:[function(a,b,c){b.exports={cipher:a("./cipher"),hash:a("./hash"),cfb:a("./cfb.js"),publicKey:a("./public_key"),signature:a("./signature.js"),random:a("./random.js"),pkcs1:a("./pkcs1.js")};var d=a("./crypto.js");for(var e in d)b.exports[e]=d[e]},{"./cfb.js":7,"./cipher":12,"./crypto.js":14,"./hash":17,"./pkcs1.js":22,"./public_key":25,"./random.js":28,"./signature.js":29}],22:[function(a,b,c){function d(a){for(var b,c="";c.length<a;)b=f.getSecureRandomOctet(),0!==b&&(c+=String.fromCharCode(b));return c}var e=[];e[1]=[48,32,48,12,6,8,42,134,72,134,247,13,2,5,5,0,4,16],e[2]=[48,33,48,9,6,5,43,14,3,2,26,5,0,4,20],e[3]=[48,33,48,9,6,5,43,36,3,2,1,5,0,4,20],e[8]=[48,49,48,13,6,9,96,134,72,1,101,3,4,2,1,5,0,4,32],e[9]=[48,65,48,13,6,9,96,134,72,1,101,3,4,2,2,5,0,4,48],e[10]=[48,81,48,13,6,9,96,134,72,1,101,3,4,2,3,5,0,4,64],e[11]=[48,45,48,13,6,9,96,134,72,1,101,3,4,2,4,5,0,4,28];var f=(a("./crypto.js"),a("./random.js")),g=a("../util.js"),h=a("./public_key/jsbn.js"),i=a("./hash");b.exports={eme:{encode:function(a,b){var c=a.length;if(c>b-11)throw new Error("Message too long");var e=d(b-c-3),f=String.fromCharCode(0)+String.fromCharCode(2)+e+String.fromCharCode(0)+a;return f},decode:function(a){0!==a.charCodeAt(0)&&(a=String.fromCharCode(0)+a);for(var b=a.charCodeAt(0),c=a.charCodeAt(1),d=2;0!==a.charCodeAt(d)&&d<a.length;)d++;var e=d-2,f=a.charCodeAt(d++);if(0===b&&2===c&&e>=8&&0===f)return a.substr(d);throw new Error("Decryption error")}},emsa:{encode:function(a,b,c){var d,f=i.digest(a,b);if(f.length!==i.getHashByteLength(a))throw new Error("Invalid hash length");var j="";for(d=0;d<e[a].length;d++)j+=String.fromCharCode(e[a][d]);j+=f;var k=j.length;if(k+11>c)throw new Error("Intended encoded message length too short");var l="";for(d=0;c-k-3>d;d++)l+=String.fromCharCode(255);var m=String.fromCharCode(0)+String.fromCharCode(1)+l+String.fromCharCode(0)+j;return new h(g.hexstrdump(m),16)}}}},{"../util.js":65,"./crypto.js":14,"./hash":17,"./public_key/jsbn.js":26,"./random.js":28}],23:[function(a,b,c){function d(){function a(a,b,c,d,i,j){for(var k,l,m,n=h.getLeftNBits(g.digest(a,b),i.bitLength()),o=new e(h.hexstrdump(n),16);;)if(k=f.getRandomBigIntegerInRange(e.ONE,i.subtract(e.ONE)),l=c.modPow(k,d).mod(i),m=k.modInverse(i).multiply(o.add(j.multiply(l))).mod(i),0!=l&&0!=m)break;var p=[];return p[0]=l.toMPI(),p[1]=m.toMPI(),p}function b(a){var b=i.prefer_hash_algorithm;switch(Math.round(a.bitLength()/8)){case 20:return 2!=b&&b>11&&10!=b&&8>b?2:b;case 28:return b>11&&8>b?11:b;case 32:return b>10&&8>b?8:b;default:return h.print_debug("DSA select hash algorithm: returning null for an unknown length of q"),null}}function c(a,b,c,d,f,i,j,k){var l=h.getLeftNBits(g.digest(a,d),i.bitLength()),m=new e(h.hexstrdump(l),16);if(e.ZERO.compareTo(b)>=0||b.compareTo(i)>=0||e.ZERO.compareTo(c)>=0||c.compareTo(i)>=0)return h.print_debug("invalid DSA Signature"),null;var n=c.modInverse(i);if(0==e.ZERO.compareTo(n))return h.print_debug("invalid DSA Signature"),null;var o=m.multiply(n).mod(i),p=b.multiply(n).mod(i);return j.modPow(o,f).multiply(k.modPow(p,f)).mod(f).mod(i)}this.select_hash_algorithm=b,this.sign=a,this.verify=c}var e=a("./jsbn.js"),f=a("../random.js"),g=a("../hash"),h=a("../../util.js"),i=a("../../config");b.exports=d},{"../../config":6,"../../util.js":65,"../hash":17,"../random.js":28,"./jsbn.js":26}],24:[function(a,b,c){function d(){function a(a,b,c,d){var g=c.subtract(e.TWO),h=f.getRandomBigIntegerInRange(e.ONE,g);h=h.mod(g).add(e.ONE);var i=[];return i[0]=b.modPow(h,c),i[1]=d.modPow(h,c).multiply(a).mod(c),i}function b(a,b,c,d){return g.print_debug("Elgamal Decrypt:\nc1:"+g.hexstrdump(a.toMPI())+"\nc2:"+g.hexstrdump(b.toMPI())+"\np:"+g.hexstrdump(c.toMPI())+"\nx:"+g.hexstrdump(d.toMPI())),a.modPow(d,c).modInverse(c).multiply(b).mod(c)}this.encrypt=a,this.decrypt=b}var e=a("./jsbn.js"),f=a("../random.js"),g=a("../../util.js");b.exports=d},{"../../util.js":65,"../random.js":28,"./jsbn.js":26}],25:[function(a,b,c){b.exports={rsa:a("./rsa.js"),elgamal:a("./elgamal.js"),dsa:a("./dsa.js")}},{"./dsa.js":23,"./elgamal.js":24,"./rsa.js":27}],26:[function(a,b,c){function d(a,b,c){null!=a&&("number"==typeof a?this.fromNumber(a,b,c):null==b&&"string"!=typeof a?this.fromString(a,256):this.fromString(a,b))}function e(){return new d(null)}function f(a,b,c,d,e,f){for(;--f>=0;){var g=b*this[a++]+c[d]+e;e=Math.floor(g/67108864),c[d++]=67108863&g}return e}function g(a){return fb.charAt(a)}function h(a,b){var c=gb[a.charCodeAt(b)];return null==c?-1:c}function i(a){for(var b=this.t-1;b>=0;--b)a[b]=this[b];a.t=this.t,a.s=this.s}function j(a){this.t=1,this.s=0>a?-1:0,a>0?this[0]=a:-1>a?this[0]=a+this.DV:this.t=0}function k(a){var b=e();return b.fromInt(a),b}function l(a,b){var c;if(16==b)c=4;else if(8==b)c=3;else if(256==b)c=8;else if(2==b)c=1;else if(32==b)c=5;else{if(4!=b)return void this.fromRadix(a,b);c=2}this.t=0,this.s=0;for(var e=a.length,f=!1,g=0;--e>=0;){var i=8==c?255&a[e]:h(a,e);0>i?"-"==a.charAt(e)&&(f=!0):(f=!1,0==g?this[this.t++]=i:g+c>this.DB?(this[this.t-1]|=(i&(1<<this.DB-g)-1)<<g,this[this.t++]=i>>this.DB-g):this[this.t-1]|=i<<g,g+=c,g>=this.DB&&(g-=this.DB))}8==c&&0!=(128&a[0])&&(this.s=-1,g>0&&(this[this.t-1]|=(1<<this.DB-g)-1<<g)),this.clamp(),f&&d.ZERO.subTo(this,this)}function m(){for(var a=this.s&this.DM;this.t>0&&this[this.t-1]==a;)--this.t}function n(a){if(this.s<0)return"-"+this.negate().toString(a);var b;if(16==a)b=4;else if(8==a)b=3;else if(2==a)b=1;else if(32==a)b=5;else{if(4!=a)return this.toRadix(a);b=2}var c,d=(1<<b)-1,e=!1,f="",h=this.t,i=this.DB-h*this.DB%b;if(h-- >0)for(i<this.DB&&(c=this[h]>>i)>0&&(e=!0,f=g(c));h>=0;)b>i?(c=(this[h]&(1<<i)-1)<<b-i,c|=this[--h]>>(i+=this.DB-b)):(c=this[h]>>(i-=b)&d,0>=i&&(i+=this.DB,--h)),c>0&&(e=!0),e&&(f+=g(c));return e?f:"0"}function o(){var a=e();return d.ZERO.subTo(this,a),a}function p(){return this.s<0?this.negate():this}function q(a){var b=this.s-a.s;if(0!=b)return b;var c=this.t;if(b=c-a.t,0!=b)return this.s<0?-b:b;for(;--c>=0;)if(0!=(b=this[c]-a[c]))return b;return 0}function r(a){var b,c=1;return 0!=(b=a>>>16)&&(a=b,c+=16),0!=(b=a>>8)&&(a=b,c+=8),0!=(b=a>>4)&&(a=b,c+=4),0!=(b=a>>2)&&(a=b,c+=2),0!=(b=a>>1)&&(a=b,c+=1),c}function s(){return this.t<=0?0:this.DB*(this.t-1)+r(this[this.t-1]^this.s&this.DM)}function t(a,b){var c;for(c=this.t-1;c>=0;--c)b[c+a]=this[c];for(c=a-1;c>=0;--c)b[c]=0;b.t=this.t+a,b.s=this.s}function u(a,b){for(var c=a;c<this.t;++c)b[c-a]=this[c];b.t=Math.max(this.t-a,0),b.s=this.s}function v(a,b){var c,d=a%this.DB,e=this.DB-d,f=(1<<e)-1,g=Math.floor(a/this.DB),h=this.s<<d&this.DM;for(c=this.t-1;c>=0;--c)b[c+g+1]=this[c]>>e|h,h=(this[c]&f)<<d;for(c=g-1;c>=0;--c)b[c]=0;b[g]=h,b.t=this.t+g+1,b.s=this.s,b.clamp()}function w(a,b){b.s=this.s;var c=Math.floor(a/this.DB);if(c>=this.t)return void(b.t=0);var d=a%this.DB,e=this.DB-d,f=(1<<d)-1;b[0]=this[c]>>d;for(var g=c+1;g<this.t;++g)b[g-c-1]|=(this[g]&f)<<e,b[g-c]=this[g]>>d;d>0&&(b[this.t-c-1]|=(this.s&f)<<e),b.t=this.t-c,b.clamp()}function x(a,b){for(var c=0,d=0,e=Math.min(a.t,this.t);e>c;)d+=this[c]-a[c],b[c++]=d&this.DM,d>>=this.DB;if(a.t<this.t){for(d-=a.s;c<this.t;)d+=this[c],b[c++]=d&this.DM,d>>=this.DB;d+=this.s}else{for(d+=this.s;c<a.t;)d-=a[c],b[c++]=d&this.DM,d>>=this.DB;d-=a.s}b.s=0>d?-1:0,-1>d?b[c++]=this.DV+d:d>0&&(b[c++]=d),b.t=c,b.clamp()}function y(a,b){var c=this.abs(),e=a.abs(),f=c.t;for(b.t=f+e.t;--f>=0;)b[f]=0;for(f=0;f<e.t;++f)b[f+c.t]=c.am(0,e[f],b,f,0,c.t);b.s=0,b.clamp(),this.s!=a.s&&d.ZERO.subTo(b,b)}function z(a){for(var b=this.abs(),c=a.t=2*b.t;--c>=0;)a[c]=0;for(c=0;c<b.t-1;++c){var d=b.am(c,b[c],a,2*c,0,1);(a[c+b.t]+=b.am(c+1,2*b[c],a,2*c+1,d,b.t-c-1))>=b.DV&&(a[c+b.t]-=b.DV,a[c+b.t+1]=1)}a.t>0&&(a[a.t-1]+=b.am(c,b[c],a,2*c,0,1)),a.s=0,a.clamp()}function A(a,b,c){var f=a.abs();if(!(f.t<=0)){var g=this.abs();if(g.t<f.t)return null!=b&&b.fromInt(0),void(null!=c&&this.copyTo(c));null==c&&(c=e());var h=e(),i=this.s,j=a.s,k=this.DB-r(f[f.t-1]);k>0?(f.lShiftTo(k,h),g.lShiftTo(k,c)):(f.copyTo(h),g.copyTo(c));var l=h.t,m=h[l-1];if(0!=m){var n=m*(1<<this.F1)+(l>1?h[l-2]>>this.F2:0),o=this.FV/n,p=(1<<this.F1)/n,q=1<<this.F2,s=c.t,t=s-l,u=null==b?e():b;for(h.dlShiftTo(t,u),c.compareTo(u)>=0&&(c[c.t++]=1,c.subTo(u,c)),d.ONE.dlShiftTo(l,u),u.subTo(h,h);h.t<l;)h[h.t++]=0;for(;--t>=0;){var v=c[--s]==m?this.DM:Math.floor(c[s]*o+(c[s-1]+q)*p);if((c[s]+=h.am(0,v,c,t,0,l))<v)for(h.dlShiftTo(t,u),c.subTo(u,c);c[s]<--v;)c.subTo(u,c)}null!=b&&(c.drShiftTo(l,b),i!=j&&d.ZERO.subTo(b,b)),c.t=l,c.clamp(),k>0&&c.rShiftTo(k,c),0>i&&d.ZERO.subTo(c,c)}}}function B(a){var b=e();return this.abs().divRemTo(a,null,b),this.s<0&&b.compareTo(d.ZERO)>0&&a.subTo(b,b),b}function C(a){this.m=a}function D(a){return a.s<0||a.compareTo(this.m)>=0?a.mod(this.m):a}function E(a){return a}function F(a){a.divRemTo(this.m,null,a)}function G(a,b,c){a.multiplyTo(b,c),this.reduce(c)}function H(a,b){a.squareTo(b),this.reduce(b)}function I(){if(this.t<1)return 0;var a=this[0];if(0==(1&a))return 0;var b=3&a;return b=b*(2-(15&a)*b)&15,b=b*(2-(255&a)*b)&255,b=b*(2-((65535&a)*b&65535))&65535,b=b*(2-a*b%this.DV)%this.DV,b>0?this.DV-b:-b}function J(a){this.m=a,this.mp=a.invDigit(),this.mpl=32767&this.mp,this.mph=this.mp>>15,this.um=(1<<a.DB-15)-1,this.mt2=2*a.t}function K(a){var b=e();return a.abs().dlShiftTo(this.m.t,b),b.divRemTo(this.m,null,b),a.s<0&&b.compareTo(d.ZERO)>0&&this.m.subTo(b,b),b}function L(a){var b=e();return a.copyTo(b),this.reduce(b),b}function M(a){for(;a.t<=this.mt2;)a[a.t++]=0;for(var b=0;b<this.m.t;++b){var c=32767&a[b],d=c*this.mpl+((c*this.mph+(a[b]>>15)*this.mpl&this.um)<<15)&a.DM;for(c=b+this.m.t,a[c]+=this.m.am(0,d,a,b,0,this.m.t);a[c]>=a.DV;)a[c]-=a.DV,a[++c]++}a.clamp(),a.drShiftTo(this.m.t,a),a.compareTo(this.m)>=0&&a.subTo(this.m,a)}function N(a,b){a.squareTo(b),this.reduce(b)}function O(a,b,c){a.multiplyTo(b,c),this.reduce(c)}function P(){return 0==(this.t>0?1&this[0]:this.s)}function Q(a,b){if(a>4294967295||1>a)return d.ONE;var c=e(),f=e(),g=b.convert(this),h=r(a)-1;for(g.copyTo(c);--h>=0;)if(b.sqrTo(c,f),(a&1<<h)>0)b.mulTo(f,g,c);else{var i=c;c=f,f=i}return b.revert(c)}function R(a,b){var c;return c=256>a||b.isEven()?new C(b):new J(b),this.exp(a,c)}function S(){var a=e();return this.copyTo(a),a}function T(){if(this.s<0){if(1==this.t)return this[0]-this.DV;if(0==this.t)return-1}else{if(1==this.t)return this[0];if(0==this.t)return 0}return(this[1]&(1<<32-this.DB)-1)<<this.DB|this[0]}function U(){return 0==this.t?this.s:this[0]<<24>>24}function V(){return 0==this.t?this.s:this[0]<<16>>16}function W(a){return Math.floor(Math.LN2*this.DB/Math.log(a))}function X(){return this.s<0?-1:this.t<=0||1==this.t&&this[0]<=0?0:1}function Y(a){if(null==a&&(a=10),0==this.signum()||2>a||a>36)return"0";var b=this.chunkSize(a),c=Math.pow(a,b),d=k(c),f=e(),g=e(),h="";for(this.divRemTo(d,f,g);f.signum()>0;)h=(c+g.intValue()).toString(a).substr(1)+h,f.divRemTo(d,f,g);return g.intValue().toString(a)+h}function Z(a,b){this.fromInt(0),null==b&&(b=10);for(var c=this.chunkSize(b),e=Math.pow(b,c),f=!1,g=0,i=0,j=0;j<a.length;++j){var k=h(a,j);0>k?"-"==a.charAt(j)&&0==this.signum()&&(f=!0):(i=b*i+k,++g>=c&&(this.dMultiply(e),this.dAddOffset(i,0),g=0,i=0))}g>0&&(this.dMultiply(Math.pow(b,g)),this.dAddOffset(i,0)),f&&d.ZERO.subTo(this,this)}function $(a,b,c){if("number"==typeof b)if(2>a)this.fromInt(1);else for(this.fromNumber(a,c),this.testBit(a-1)||this.bitwiseTo(d.ONE.shiftLeft(a-1),ga,this),this.isEven()&&this.dAddOffset(1,0);!this.isProbablePrime(b);)this.dAddOffset(2,0),this.bitLength()>a&&this.subTo(d.ONE.shiftLeft(a-1),this);else{var e=new Array,f=7&a;e.length=(a>>3)+1,b.nextBytes(e),f>0?e[0]&=(1<<f)-1:e[0]=0,this.fromString(e,256)}}function _(){var a=this.t,b=new Array;b[0]=this.s;var c,d=this.DB-a*this.DB%8,e=0;if(a-- >0)for(d<this.DB&&(c=this[a]>>d)!=(this.s&this.DM)>>d&&(b[e++]=c|this.s<<this.DB-d);a>=0;)8>d?(c=(this[a]&(1<<d)-1)<<8-d,c|=this[--a]>>(d+=this.DB-8)):(c=this[a]>>(d-=8)&255,0>=d&&(d+=this.DB,--a)),(e>0||c!=this.s)&&(b[e++]=c);return b}function aa(a){return 0==this.compareTo(a)}function ba(a){return this.compareTo(a)<0?this:a}function ca(a){return this.compareTo(a)>0?this:a}function da(a,b,c){var d,e,f=Math.min(a.t,this.t);for(d=0;f>d;++d)c[d]=b(this[d],a[d]);if(a.t<this.t){for(e=a.s&this.DM,d=f;d<this.t;++d)c[d]=b(this[d],e);c.t=this.t}else{for(e=this.s&this.DM,d=f;d<a.t;++d)c[d]=b(e,a[d]);c.t=a.t}c.s=b(this.s,a.s),c.clamp()}function ea(a,b){return a&b}function fa(a){var b=e();return this.bitwiseTo(a,ea,b),b}function ga(a,b){return a|b}function ha(a){var b=e();return this.bitwiseTo(a,ga,b),b}function ia(a,b){return a^b}function ja(a){var b=e();return this.bitwiseTo(a,ia,b),b}function ka(a,b){return a&~b}function la(a){var b=e();return this.bitwiseTo(a,ka,b),b}function ma(){for(var a=e(),b=0;b<this.t;++b)a[b]=this.DM&~this[b];return a.t=this.t,a.s=~this.s,a}function na(a){var b=e();return 0>a?this.rShiftTo(-a,b):this.lShiftTo(a,b),b}function oa(a){var b=e();return 0>a?this.lShiftTo(-a,b):this.rShiftTo(a,b),b}function pa(a){if(0==a)return-1;var b=0;return 0==(65535&a)&&(a>>=16,b+=16),0==(255&a)&&(a>>=8,b+=8),0==(15&a)&&(a>>=4,b+=4),0==(3&a)&&(a>>=2,b+=2),0==(1&a)&&++b,b}function qa(){for(var a=0;a<this.t;++a)if(0!=this[a])return a*this.DB+pa(this[a]);return this.s<0?this.t*this.DB:-1}function ra(a){for(var b=0;0!=a;)a&=a-1,++b;return b}function sa(){for(var a=0,b=this.s&this.DM,c=0;c<this.t;++c)a+=ra(this[c]^b);return a}function ta(a){var b=Math.floor(a/this.DB);return b>=this.t?0!=this.s:0!=(this[b]&1<<a%this.DB)}function ua(a,b){var c=d.ONE.shiftLeft(a);return this.bitwiseTo(c,b,c),c}function va(a){return this.changeBit(a,ga)}function wa(a){return this.changeBit(a,ka)}function xa(a){return this.changeBit(a,ia)}function ya(a,b){for(var c=0,d=0,e=Math.min(a.t,this.t);e>c;)d+=this[c]+a[c],b[c++]=d&this.DM,d>>=this.DB;if(a.t<this.t){for(d+=a.s;c<this.t;)d+=this[c],b[c++]=d&this.DM,d>>=this.DB;d+=this.s}else{for(d+=this.s;c<a.t;)d+=a[c],b[c++]=d&this.DM,d>>=this.DB;d+=a.s}b.s=0>d?-1:0,d>0?b[c++]=d:-1>d&&(b[c++]=this.DV+d),b.t=c,b.clamp()}function za(a){var b=e();return this.addTo(a,b),b}function Aa(a){var b=e();return this.subTo(a,b),b}function Ba(a){var b=e();return this.multiplyTo(a,b),b}function Ca(){var a=e();return this.squareTo(a),a}function Da(a){var b=e();return this.divRemTo(a,b,null),b}function Ea(a){var b=e();return this.divRemTo(a,null,b),b}function Fa(a){var b=e(),c=e();return this.divRemTo(a,b,c),new Array(b,c)}function Ga(a){this[this.t]=this.am(0,a-1,this,0,0,this.t),++this.t,this.clamp()}function Ha(a,b){if(0!=a){for(;this.t<=b;)this[this.t++]=0;for(this[b]+=a;this[b]>=this.DV;)this[b]-=this.DV,++b>=this.t&&(this[this.t++]=0),++this[b]}}function Ia(){}function Ja(a){return a}function Ka(a,b,c){a.multiplyTo(b,c)}function La(a,b){a.squareTo(b)}function Ma(a){return this.exp(a,new Ia)}function Na(a,b,c){var d=Math.min(this.t+a.t,b);for(c.s=0,c.t=d;d>0;)c[--d]=0;var e;for(e=c.t-this.t;e>d;++d)c[d+this.t]=this.am(0,a[d],c,d,0,this.t);for(e=Math.min(a.t,b);e>d;++d)this.am(0,a[d],c,d,0,b-d);c.clamp()}function Oa(a,b,c){--b;var d=c.t=this.t+a.t-b;for(c.s=0;--d>=0;)c[d]=0;for(d=Math.max(b-this.t,0);d<a.t;++d)c[this.t+d-b]=this.am(b-d,a[d],c,0,0,this.t+d-b);c.clamp(),c.drShiftTo(1,c)}function Pa(a){this.r2=e(),this.q3=e(),d.ONE.dlShiftTo(2*a.t,this.r2),this.mu=this.r2.divide(a),this.m=a}function Qa(a){if(a.s<0||a.t>2*this.m.t)return a.mod(this.m);if(a.compareTo(this.m)<0)return a;var b=e();return a.copyTo(b),this.reduce(b),b}function Ra(a){return a}function Sa(a){for(a.drShiftTo(this.m.t-1,this.r2),a.t>this.m.t+1&&(a.t=this.m.t+1,a.clamp()),this.mu.multiplyUpperTo(this.r2,this.m.t+1,this.q3),this.m.multiplyLowerTo(this.q3,this.m.t+1,this.r2);a.compareTo(this.r2)<0;)a.dAddOffset(1,this.m.t+1);for(a.subTo(this.r2,a);a.compareTo(this.m)>=0;)a.subTo(this.m,a)}function Ta(a,b){a.squareTo(b),this.reduce(b)}function Ua(a,b,c){a.multiplyTo(b,c),this.reduce(c)}function Va(a,b){var c,d,f=a.bitLength(),g=k(1);if(0>=f)return g;c=18>f?1:48>f?3:144>f?4:768>f?5:6,d=8>f?new C(b):b.isEven()?new Pa(b):new J(b);var h=new Array,i=3,j=c-1,l=(1<<c)-1;if(h[1]=d.convert(this),c>1){var m=e();for(d.sqrTo(h[1],m);l>=i;)h[i]=e(),d.mulTo(m,h[i-2],h[i]),i+=2}var n,o,p=a.t-1,q=!0,s=e();for(f=r(a[p])-1;p>=0;){for(f>=j?n=a[p]>>f-j&l:(n=(a[p]&(1<<f+1)-1)<<j-f,p>0&&(n|=a[p-1]>>this.DB+f-j)),i=c;0==(1&n);)n>>=1,--i;if((f-=i)<0&&(f+=this.DB,--p),q)h[n].copyTo(g),q=!1;else{for(;i>1;)d.sqrTo(g,s),d.sqrTo(s,g),i-=2;i>0?d.sqrTo(g,s):(o=g,g=s,s=o),d.mulTo(s,h[n],g)}for(;p>=0&&0==(a[p]&1<<f);)d.sqrTo(g,s),o=g,g=s,s=o,--f<0&&(f=this.DB-1,--p)}return d.revert(g)}function Wa(a){var b=this.s<0?this.negate():this.clone(),c=a.s<0?a.negate():a.clone();if(b.compareTo(c)<0){var d=b;b=c,c=d}var e=b.getLowestSetBit(),f=c.getLowestSetBit();if(0>f)return b;for(f>e&&(f=e),f>0&&(b.rShiftTo(f,b),c.rShiftTo(f,c));b.signum()>0;)(e=b.getLowestSetBit())>0&&b.rShiftTo(e,b),(e=c.getLowestSetBit())>0&&c.rShiftTo(e,c),b.compareTo(c)>=0?(b.subTo(c,b),b.rShiftTo(1,b)):(c.subTo(b,c),c.rShiftTo(1,c));return f>0&&c.lShiftTo(f,c),c}function Xa(a){if(0>=a)return 0;var b=this.DV%a,c=this.s<0?a-1:0;if(this.t>0)if(0==b)c=this[0]%a;else for(var d=this.t-1;d>=0;--d)c=(b*c+this[d])%a;return c}function Ya(a){var b=a.isEven();if(this.isEven()&&b||0==a.signum())return d.ZERO;for(var c=a.clone(),e=this.clone(),f=k(1),g=k(0),h=k(0),i=k(1);0!=c.signum();){for(;c.isEven();)c.rShiftTo(1,c),b?(f.isEven()&&g.isEven()||(f.addTo(this,f),g.subTo(a,g)),f.rShiftTo(1,f)):g.isEven()||g.subTo(a,g),g.rShiftTo(1,g);for(;e.isEven();)e.rShiftTo(1,e),b?(h.isEven()&&i.isEven()||(h.addTo(this,h),i.subTo(a,i)),h.rShiftTo(1,h)):i.isEven()||i.subTo(a,i),i.rShiftTo(1,i);c.compareTo(e)>=0?(c.subTo(e,c),b&&f.subTo(h,f),g.subTo(i,g)):(e.subTo(c,e),b&&h.subTo(f,h),i.subTo(g,i))}return 0!=e.compareTo(d.ONE)?d.ZERO:i.compareTo(a)>=0?i.subtract(a):i.signum()<0?(i.addTo(a,i),i.signum()<0?i.add(a):i):i}function Za(a){var b,c=this.abs();if(1==c.t&&c[0]<=hb[hb.length-1]){for(b=0;b<hb.length;++b)if(c[0]==hb[b])return!0;return!1}if(c.isEven())return!1;for(b=1;b<hb.length;){for(var d=hb[b],e=b+1;e<hb.length&&ib>d;)d*=hb[e++];for(d=c.modInt(d);e>b;)if(d%hb[b++]==0)return!1}return c.millerRabin(a)}function r(a){var b,c=1;return 0!=(b=a>>>16)&&(a=b,c+=16),0!=(b=a>>8)&&(a=b,c+=8),0!=(b=a>>4)&&(a=b,c+=4),0!=(b=a>>2)&&(a=b,c+=2),0!=(b=a>>1)&&(a=b,c+=1),c}function $a(){var a=this.toByteArray(),b=8*(a.length-1)+r(a[0]),c="";return c+=String.fromCharCode((65280&b)>>8),c+=String.fromCharCode(255&b),c+=bb.bin2str(a)}function _a(a){var b=this.subtract(d.ONE),c=b.getLowestSetBit();if(0>=c)return!1;var f=b.shiftRight(c);a=a+1>>1,a>hb.length&&(a=hb.length);for(var g,h=e(),i=[],j=0;a>j;++j){for(;g=hb[Math.floor(Math.random()*hb.length)],-1!=i.indexOf(g););i.push(g),h.fromInt(g);var k=h.modPow(f,this);if(0!=k.compareTo(d.ONE)&&0!=k.compareTo(b)){for(var g=1;g++<c&&0!=k.compareTo(b);)if(k=k.modPowInt(2,this),0==k.compareTo(d.ONE))return!1;if(0!=k.compareTo(b))return!1}}return!0}var ab,bb=a("../../util.js");d.prototype.am=f,ab=26,d.prototype.DB=ab,d.prototype.DM=(1<<ab)-1,d.prototype.DV=1<<ab;var cb=52;d.prototype.FV=Math.pow(2,cb),d.prototype.F1=cb-ab,d.prototype.F2=2*ab-cb;var db,eb,fb="0123456789abcdefghijklmnopqrstuvwxyz",gb=new Array;for(db="0".charCodeAt(0),eb=0;9>=eb;++eb)gb[db++]=eb;for(db="a".charCodeAt(0),eb=10;36>eb;++eb)gb[db++]=eb;for(db="A".charCodeAt(0),eb=10;36>eb;++eb)gb[db++]=eb;C.prototype.convert=D,C.prototype.revert=E,C.prototype.reduce=F,C.prototype.mulTo=G,C.prototype.sqrTo=H,J.prototype.convert=K,J.prototype.revert=L,J.prototype.reduce=M,J.prototype.mulTo=O,J.prototype.sqrTo=N,d.prototype.copyTo=i,d.prototype.fromInt=j,d.prototype.fromString=l,d.prototype.clamp=m,d.prototype.dlShiftTo=t,d.prototype.drShiftTo=u,d.prototype.lShiftTo=v,d.prototype.rShiftTo=w,d.prototype.subTo=x,d.prototype.multiplyTo=y,d.prototype.squareTo=z,d.prototype.divRemTo=A,d.prototype.invDigit=I,d.prototype.isEven=P,d.prototype.exp=Q,d.prototype.toString=n,d.prototype.negate=o,d.prototype.abs=p,d.prototype.compareTo=q,d.prototype.bitLength=s,d.prototype.mod=B,d.prototype.modPowInt=R,d.ZERO=k(0),d.ONE=k(1),d.TWO=k(2),b.exports=d,Ia.prototype.convert=Ja,Ia.prototype.revert=Ja,Ia.prototype.mulTo=Ka,Ia.prototype.sqrTo=La,Pa.prototype.convert=Qa,Pa.prototype.revert=Ra,Pa.prototype.reduce=Sa,Pa.prototype.mulTo=Ua,Pa.prototype.sqrTo=Ta;var hb=[2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97,101,103,107,109,113,127,131,137,139,149,151,157,163,167,173,179,181,191,193,197,199,211,223,227,229,233,239,241,251,257,263,269,271,277,281,283,293,307,311,313,317,331,337,347,349,353,359,367,373,379,383,389,397,401,409,419,421,431,433,439,443,449,457,461,463,467,479,487,491,499,503,509,521,523,541,547,557,563,569,571,577,587,593,599,601,607,613,617,619,631,641,643,647,653,659,661,673,677,683,691,701,709,719,727,733,739,743,751,757,761,769,773,787,797,809,811,821,823,827,829,839,853,857,859,863,877,881,883,887,907,911,919,929,937,941,947,953,967,971,977,983,991,997],ib=(1<<26)/hb[hb.length-1],d=a("./jsbn.js");d.prototype.chunkSize=W,d.prototype.toRadix=Y,d.prototype.fromRadix=Z,d.prototype.fromNumber=$,d.prototype.bitwiseTo=da,d.prototype.changeBit=ua,d.prototype.addTo=ya,d.prototype.dMultiply=Ga,d.prototype.dAddOffset=Ha,d.prototype.multiplyLowerTo=Na,d.prototype.multiplyUpperTo=Oa,d.prototype.modInt=Xa,d.prototype.millerRabin=_a,d.prototype.clone=S,d.prototype.intValue=T,d.prototype.byteValue=U,d.prototype.shortValue=V,d.prototype.signum=X,d.prototype.toByteArray=_,d.prototype.equals=aa,d.prototype.min=ba,d.prototype.max=ca,d.prototype.and=fa,d.prototype.or=ha,d.prototype.xor=ja,d.prototype.andNot=la,d.prototype.not=ma,d.prototype.shiftLeft=na,d.prototype.shiftRight=oa,d.prototype.getLowestSetBit=qa,d.prototype.bitCount=sa,d.prototype.testBit=ta,d.prototype.setBit=va,d.prototype.clearBit=wa,d.prototype.flipBit=xa,d.prototype.add=za,d.prototype.subtract=Aa,d.prototype.multiply=Ba,d.prototype.divide=Da,d.prototype.remainder=Ea,d.prototype.divideAndRemainder=Fa,d.prototype.modPow=Va,d.prototype.modInverse=Ya,d.prototype.pow=Ma,d.prototype.gcd=Wa,d.prototype.isProbablePrime=Za,d.prototype.toMPI=$a,d.prototype.square=Ca},{"../../util.js":65,"./jsbn.js":26}],27:[function(a,b,c){function d(){function a(a){for(var b=0;b<a.length;b++)a[b]=j.getSecureRandomOctet();
	}this.nextBytes=a}function e(a,b,c){return m=m.bitLength()===b.bitLength()?m.square().mod(b):j.getRandomBigIntegerInRange(h.TWO,b),l=m.modInverse(b).modPow(c,b),a.multiply(l).mod(b)}function f(a,b){return a.multiply(m).mod(b)}function g(){function a(a,b,c,d,g,j,l){k.rsa_blinding&&(a=e(a,b,c));var m=a.mod(g).modPow(d.mod(g.subtract(h.ONE)),g),n=a.mod(j).modPow(d.mod(j.subtract(h.ONE)),j);i.print_debug("rsa.js decrypt\nxpn:"+i.hexstrdump(m.toMPI())+"\nxqn:"+i.hexstrdump(n.toMPI()));var o=n.subtract(m);return 0===o[0]?(o=m.subtract(n),o=o.multiply(l).mod(j),o=j.subtract(o)):o=o.multiply(l).mod(j),o=o.multiply(g).add(m),k.rsa_blinding&&(o=f(o,b)),o}function b(a,b,c){return a.modPowInt(b,c)}function c(a,b,c){return a.modPow(b,c)}function g(a,b,c){return a.modPowInt(b,c)}function j(){this.n=null,this.e=0,this.ee=null,this.d=null,this.p=null,this.q=null,this.dmp1=null,this.dmq1=null,this.u=null}function l(a,b){function c(a){var b=g.exportKey("jwk",a.privateKey);return"function"!=typeof b.then&&(b=f(b,"Error exporting RSA key pair.")),b}function e(a){function c(a){var b=a.replace(/\-/g,"+").replace(/_/g,"/"),c=i.hexstrdump(window.atob(b));return new h(c,16)}var d=new j;return d.n=c(a.n),d.ee=new h(b,16),d.d=c(a.d),d.p=c(a.p),d.q=c(a.q),d.u=d.p.modInverse(d.q),d}function f(a,b){return new Promise(function(c,d){a.onerror=function(a){d(new Error(b))},a.oncomplete=function(a){c(a.target.result)}})}var g=i.getWebCrypto();if(g){var k,l,m=new Uint32Array([parseInt(b,16)]),n=new Uint8Array(m.buffer);return window.crypto&&window.crypto.webkitSubtle?(k={name:"RSA-OAEP",modulusLength:a,publicExponent:n.subarray(0,3)},l=g.generateKey(k,!0,["encrypt","decrypt"])):(k={name:"RSASSA-PKCS1-v1_5",modulusLength:a,publicExponent:n.subarray(0,3),hash:{name:"SHA-1"}},l=g.generateKey(k,!0,["sign","verify"]),"function"!=typeof l.then&&(l=f(l,"Error generating RSA key pair."))),l.then(c).then(function(a){return e(a instanceof ArrayBuffer?JSON.parse(String.fromCharCode.apply(null,new Uint8Array(a))):a)})}return new Promise(function(c){var e=new j,f=new d,g=a>>1;for(e.e=parseInt(b,16),e.ee=new h(b,16);;){for(;e.p=new h(a-g,1,f),0!==e.p.subtract(h.ONE).gcd(e.ee).compareTo(h.ONE)||!e.p.isProbablePrime(10););for(;e.q=new h(g,1,f),0!==e.q.subtract(h.ONE).gcd(e.ee).compareTo(h.ONE)||!e.q.isProbablePrime(10););if(e.p.compareTo(e.q)<=0){var i=e.p;e.p=e.q,e.q=i}var k=e.p.subtract(h.ONE),l=e.q.subtract(h.ONE),m=k.multiply(l);if(0===m.gcd(e.ee).compareTo(h.ONE)){e.n=e.p.multiply(e.q),e.d=e.ee.modInverse(m),e.dmp1=e.d.mod(k),e.dmq1=e.d.mod(l),e.u=e.p.modInverse(e.q);break}}c(e)})}this.encrypt=b,this.decrypt=a,this.verify=g,this.sign=c,this.generate=l,this.keyObject=j}var h=a("./jsbn.js"),i=a("../../util.js"),j=a("../random.js"),k=a("../../config"),l=h.ZERO,m=h.ZERO;b.exports=g},{"../../config":6,"../../util.js":65,"../random.js":28,"./jsbn.js":26}],28:[function(a,b,c){function d(){this.buffer=null,this.size=null}var e=a("../type/mpi.js"),f=null;"undefined"==typeof window&&(f=a("crypto")),b.exports={getRandomBytes:function(a){for(var b="",c=0;a>c;c++)b+=String.fromCharCode(this.getSecureRandomOctet());return b},getSecureRandom:function(a,b){for(var c=this.getSecureRandomUint(),d=(b-a).toString(2).length;(c&Math.pow(2,d)-1)>b-a;)c=this.getSecureRandomUint();return a+Math.abs(c&Math.pow(2,d)-1)},getSecureRandomOctet:function(){var a=new Uint8Array(1);return this.getRandomValues(a),a[0]},getSecureRandomUint:function(){var a=new Uint8Array(4),b=new DataView(a.buffer);return this.getRandomValues(a),b.getUint32(0)},getRandomValues:function(a){if(!(a instanceof Uint8Array))throw new Error("Invalid type: buf not an Uint8Array");if("undefined"!=typeof window&&window.crypto&&window.crypto.getRandomValues)window.crypto.getRandomValues(a);else if("undefined"!=typeof window&&"object"==typeof window.msCrypto&&"function"==typeof window.msCrypto.getRandomValues)window.msCrypto.getRandomValues(a);else if(f){var b=f.randomBytes(a.length);a.set(b)}else{if(!this.randomBuffer.buffer)throw new Error("No secure random number generator available.");this.randomBuffer.get(a)}},getRandomBigInteger:function(a){if(1>a)throw new Error("Illegal parameter value: bits < 1");var b=Math.floor((a+7)/8),c=this.getRandomBytes(b);a%8>0&&(c=String.fromCharCode(Math.pow(2,a%8)-1&c.charCodeAt(0))+c.substring(1));var d=new e;return d.fromBytes(c),d.toBigInteger()},getRandomBigIntegerInRange:function(a,b){if(b.compareTo(a)<=0)throw new Error("Illegal parameter value: max <= min");for(var c=b.subtract(a),d=this.getRandomBigInteger(c.bitLength());d.compareTo(c)>0;)d=this.getRandomBigInteger(c.bitLength());return a.add(d)},randomBuffer:new d},d.prototype.init=function(a){this.buffer=new Uint8Array(a),this.size=0},d.prototype.set=function(a){if(!this.buffer)throw new Error("RandomBuffer is not initialized");if(!(a instanceof Uint8Array))throw new Error("Invalid type: buf not an Uint8Array");var b=this.buffer.length-this.size;a.length>b&&(a=a.subarray(0,b)),this.buffer.set(a,this.size),this.size+=a.length},d.prototype.get=function(a){if(!this.buffer)throw new Error("RandomBuffer is not initialized");if(!(a instanceof Uint8Array))throw new Error("Invalid type: buf not an Uint8Array");if(this.size<a.length)throw new Error("Random number buffer depleted");for(var b=0;b<a.length;b++)a[b]=this.buffer[--this.size],this.buffer[this.size]=0}},{"../type/mpi.js":63,crypto:"crypto"}],29:[function(a,b,c){var d=a("./public_key"),e=a("./pkcs1.js");a("./hash");b.exports={verify:function(a,b,c,f,g){switch(a){case 1:case 2:case 3:var h=new d.rsa,i=f[0].toBigInteger(),j=f[0].byteLength(),k=f[1].toBigInteger(),l=c[0].toBigInteger(),m=h.verify(l,k,i),n=e.emsa.encode(b,g,j);return 0===m.compareTo(n);case 16:throw new Error("signing with Elgamal is not defined in the OpenPGP standard.");case 17:var o=new d.dsa,p=c[0].toBigInteger(),q=c[1].toBigInteger(),r=f[0].toBigInteger(),s=f[1].toBigInteger(),t=f[2].toBigInteger(),u=f[3].toBigInteger(),l=g,v=o.verify(b,p,q,l,r,s,t,u);return 0===v.compareTo(p);default:throw new Error("Invalid signature algorithm.")}},sign:function(a,b,c,f){var g;switch(b){case 1:case 2:case 3:var h=new d.rsa,i=c[2].toBigInteger(),j=c[0].toBigInteger();return g=e.emsa.encode(a,f,c[0].byteLength()),h.sign(g,i,j).toMPI();case 17:var k=new d.dsa,l=c[0].toBigInteger(),m=c[1].toBigInteger(),n=c[2].toBigInteger(),o=(c[3].toBigInteger(),c[4].toBigInteger());g=f;var p=k.sign(a,g,n,l,m,o);return p[0].toString()+p[1].toString();case 16:throw new Error("Signing with Elgamal is not defined in the OpenPGP standard.");default:throw new Error("Invalid signature algorithm.")}}}},{"./hash":17,"./pkcs1.js":22,"./public_key":25}],30:[function(a,b,c){function d(a){var b=/^-----BEGIN PGP (MESSAGE, PART \d+\/\d+|MESSAGE, PART \d+|SIGNED MESSAGE|MESSAGE|PUBLIC KEY BLOCK|PRIVATE KEY BLOCK|SIGNATURE)-----$\n/m,c=a.match(b);if(!c)throw new Error("Unknown ASCII armor type");return/MESSAGE, PART \d+\/\d+/.test(c[1])?o.armor.multipart_section:/MESSAGE, PART \d+/.test(c[1])?o.armor.multipart_last:/SIGNED MESSAGE/.test(c[1])?o.armor.signed:/MESSAGE/.test(c[1])?o.armor.message:/PUBLIC KEY BLOCK/.test(c[1])?o.armor.public_key:/PRIVATE KEY BLOCK/.test(c[1])?o.armor.private_key:void 0}function e(){var a="";return p.show_version&&(a+="Version: "+p.versionstring+"\r\n"),p.show_comment&&(a+="Comment: "+p.commentstring+"\r\n"),a+="\r\n"}function f(a){var b=h(a),c=""+String.fromCharCode(b>>16)+String.fromCharCode(b>>8&255)+String.fromCharCode(255&b);return n.encode(c)}function g(a,b){var c=f(a),d=b;return c[0]==d[0]&&c[1]==d[1]&&c[2]==d[2]&&c[3]==d[3]}function h(a){for(var b=11994318,c=0;a.length-c>16;)b=b<<8^q[255&(b>>16^a.charCodeAt(c))],b=b<<8^q[255&(b>>16^a.charCodeAt(c+1))],b=b<<8^q[255&(b>>16^a.charCodeAt(c+2))],b=b<<8^q[255&(b>>16^a.charCodeAt(c+3))],b=b<<8^q[255&(b>>16^a.charCodeAt(c+4))],b=b<<8^q[255&(b>>16^a.charCodeAt(c+5))],b=b<<8^q[255&(b>>16^a.charCodeAt(c+6))],b=b<<8^q[255&(b>>16^a.charCodeAt(c+7))],b=b<<8^q[255&(b>>16^a.charCodeAt(c+8))],b=b<<8^q[255&(b>>16^a.charCodeAt(c+9))],b=b<<8^q[255&(b>>16^a.charCodeAt(c+10))],b=b<<8^q[255&(b>>16^a.charCodeAt(c+11))],b=b<<8^q[255&(b>>16^a.charCodeAt(c+12))],b=b<<8^q[255&(b>>16^a.charCodeAt(c+13))],b=b<<8^q[255&(b>>16^a.charCodeAt(c+14))],b=b<<8^q[255&(b>>16^a.charCodeAt(c+15))],c+=16;for(var d=c;d<a.length;d++)b=b<<8^q[255&(b>>16^a.charCodeAt(c++))];return 16777215&b}function i(a){var b=/^[ \f\r\t\u00a0\u2000-\u200a\u202f\u205f\u3000]*\n/m,c="",d=a,e=b.exec(a);if(null===e)throw new Error("Mandatory blank line missing between armor headers and armor data");return c=a.slice(0,e.index),d=a.slice(e.index+e[0].length),c=c.split("\n"),c.pop(),{headers:c,body:d}}function j(a){for(var b=0;b<a.length;b++)if(!/^(Version|Comment|MessageID|Hash|Charset): .+$/.test(a[b]))throw new Error("Improperly formatted armor header: "+a[b])}function k(a){var b=/^=/m,c=a,d="",e=b.exec(a);return null!==e&&(c=a.slice(0,e.index),d=a.slice(e.index+1)),{body:c,checksum:d}}function l(a){var b=/^-----[^-]+-----$\n/m;a=a.replace(/[\t\r ]+\n/g,"\n");var c,e,h,l=d(a),m=a.split(b),o=1;if(a.search(b)!=m[0].length&&(o=0),2!=l){h=i(m[o]);var p=k(h.body);c={data:n.decode(p.body),headers:h.headers,type:l},e=p.checksum}else{h=i(m[o].replace(/^- /gm,""));var q=i(m[o+1].replace(/^- /gm,""));j(q.headers);var r=k(q.body);c={text:h.body.replace(/\n$/,"").replace(/\n/g,"\r\n"),data:n.decode(r.body),headers:h.headers,type:l},e=r.checksum}if(e=e.substr(0,4),!g(c.data,e))throw new Error("Ascii armor integrity check on message failed: '"+e+"' should be '"+f(c.data)+"'");return j(c.headers),c}function m(a,b,c,d){var g=[];switch(a){case o.armor.multipart_section:g.push("-----BEGIN PGP MESSAGE, PART "+c+"/"+d+"-----\r\n"),g.push(e()),g.push(n.encode(b)),g.push("\r\n="+f(b)+"\r\n"),g.push("-----END PGP MESSAGE, PART "+c+"/"+d+"-----\r\n");break;case o.armor.multipart_last:g.push("-----BEGIN PGP MESSAGE, PART "+c+"-----\r\n"),g.push(e()),g.push(n.encode(b)),g.push("\r\n="+f(b)+"\r\n"),g.push("-----END PGP MESSAGE, PART "+c+"-----\r\n");break;case o.armor.signed:g.push("\r\n-----BEGIN PGP SIGNED MESSAGE-----\r\n"),g.push("Hash: "+b.hash+"\r\n\r\n"),g.push(b.text.replace(/\n-/g,"\n- -")),g.push("\r\n-----BEGIN PGP SIGNATURE-----\r\n"),g.push(e()),g.push(n.encode(b.data)),g.push("\r\n="+f(b.data)+"\r\n"),g.push("-----END PGP SIGNATURE-----\r\n");break;case o.armor.message:g.push("-----BEGIN PGP MESSAGE-----\r\n"),g.push(e()),g.push(n.encode(b)),g.push("\r\n="+f(b)+"\r\n"),g.push("-----END PGP MESSAGE-----\r\n");break;case o.armor.public_key:g.push("-----BEGIN PGP PUBLIC KEY BLOCK-----\r\n"),g.push(e()),g.push(n.encode(b)),g.push("\r\n="+f(b)+"\r\n"),g.push("-----END PGP PUBLIC KEY BLOCK-----\r\n\r\n");break;case o.armor.private_key:g.push("-----BEGIN PGP PRIVATE KEY BLOCK-----\r\n"),g.push(e()),g.push(n.encode(b)),g.push("\r\n="+f(b)+"\r\n"),g.push("-----END PGP PRIVATE KEY BLOCK-----\r\n")}return g.join("")}var n=a("./base64.js"),o=a("../enums.js"),p=a("../config"),q=[0,8801531,25875725,17603062,60024545,51751450,35206124,44007191,128024889,120049090,103502900,112007375,70412248,78916387,95990485,88014382,264588937,256049778,240098180,248108927,207005800,215016595,232553829,224014750,140824496,149062475,166599357,157832774,200747345,191980970,176028764,184266919,520933865,529177874,512099556,503334943,480196360,471432179,487973381,496217854,414011600,405478443,422020573,430033190,457094705,465107658,448029500,439496647,281648992,273666971,289622637,298124950,324696449,333198714,315665548,307683447,392699481,401494690,383961940,375687087,352057528,343782467,359738805,368533838,1041867730,1050668841,1066628831,1058355748,1032471859,1024199112,1006669886,1015471301,968368875,960392720,942864358,951368477,975946762,984451313,1000411399,992435708,836562267,828023200,810956886,818967725,844041146,852051777,868605623,860066380,914189410,922427545,938981743,930215316,904825475,896059e3,878993294,887231349,555053627,563297984,547333942,538569677,579245274,570480673,588005847,596249900,649392898,640860153,658384399,666397428,623318499,631331096,615366894,606833685,785398962,777416777,794487231,802989380,759421523,767923880,751374174,743392165,695319947,704115056,687564934,679289981,719477610,711202705,728272487,737067676,2083735460,2092239711,2109313705,2101337682,2141233477,2133257662,2116711496,2125215923,2073216669,2064943718,2048398224,2057199467,2013339772,2022141063,2039215473,2030942602,1945504045,1936737750,1920785440,1929023707,1885728716,1893966647,1911503553,1902736954,1951893524,1959904495,1977441561,1968902626,2009362165,2000822798,1984871416,1992881923,1665111629,1673124534,1656046400,1647513531,1621913772,1613380695,1629922721,1637935450,1688082292,1679317903,1695859321,1704103554,1728967061,1737211246,1720132760,1711368291,1828378820,1820103743,1836060105,1844855090,1869168165,1877963486,1860430632,1852155859,1801148925,1809650950,1792118e3,1784135691,1757986588,1750004711,1765960209,1774462698,1110107254,1118611597,1134571899,1126595968,1102643863,1094667884,1077139354,1085643617,1166763343,1158490548,1140961346,1149762745,1176011694,1184812885,1200772771,1192499800,1307552511,1298785796,1281720306,1289958153,1316768798,1325007077,1341561107,1332794856,1246636998,1254647613,1271201483,1262662192,1239272743,1230733788,1213667370,1221678289,1562785183,1570797924,1554833554,1546300521,1588974462,1580441477,1597965939,1605978760,1518843046,1510078557,1527603627,1535847760,1494504007,1502748348,1486784330,1478020017,1390639894,1382365165,1399434779,1408230112,1366334967,1375129868,1358579962,1350304769,1430452783,1438955220,1422405410,1414423513,1456544974,1448562741,1465633219,1474135352];b.exports={encode:m,decode:l}},{"../config":6,"../enums.js":32,"./base64.js":31}],31:[function(a,b,c){function d(a,b){var c,d,e,g=b?b:[],h=0,i=0,j=a.length;for(e=0;j>e;e++)d=a.charCodeAt(e),0===i?(g.push(f.charAt(d>>2&63)),c=(3&d)<<4):1==i?(g.push(f.charAt(c|d>>4&15)),c=(15&d)<<2):2==i&&(g.push(f.charAt(c|d>>6&3)),h+=1,h%60===0&&g.push("\n"),g.push(f.charAt(63&d))),h+=1,h%60===0&&g.push("\n"),i+=1,3==i&&(i=0);return i>0&&(g.push(f.charAt(c)),h+=1,h%60===0&&g.push("\n"),g.push("="),h+=1),1==i&&(h%60===0&&g.push("\n"),g.push("=")),b?void 0:g.join("")}function e(a){var b,c,d=[],e=0,g=0,h=a.length;for(c=0;h>c;c++)b=f.indexOf(a.charAt(c)),b>=0&&(e&&d.push(String.fromCharCode(g|b>>6-e&255)),e=e+2&7,g=b<<e&255);return d.join("")}var f="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";b.exports={encode:d,decode:e}},{}],32:[function(a,b,c){"use strict";b.exports={s2k:{simple:0,salted:1,iterated:3,gnu:101},publicKey:{rsa_encrypt_sign:1,rsa_encrypt:2,rsa_sign:3,elgamal:16,dsa:17},symmetric:{plaintext:0,idea:1,tripledes:2,cast5:3,blowfish:4,aes128:7,aes192:8,aes256:9,twofish:10},compression:{uncompressed:0,zip:1,zlib:2,bzip2:3},hash:{md5:1,sha1:2,ripemd:3,sha256:8,sha384:9,sha512:10,sha224:11},packet:{publicKeyEncryptedSessionKey:1,signature:2,symEncryptedSessionKey:3,onePassSignature:4,secretKey:5,publicKey:6,secretSubkey:7,compressed:8,symmetricallyEncrypted:9,marker:10,literal:11,trust:12,userid:13,publicSubkey:14,userAttribute:17,symEncryptedIntegrityProtected:18,modificationDetectionCode:19},literal:{binary:"b".charCodeAt(),text:"t".charCodeAt(),utf8:"u".charCodeAt()},signature:{binary:0,text:1,standalone:2,cert_generic:16,cert_persona:17,cert_casual:18,cert_positive:19,cert_revocation:48,subkey_binding:24,key_binding:25,key:31,key_revocation:32,subkey_revocation:40,timestamp:64,third_party:80},signatureSubpacket:{signature_creation_time:2,signature_expiration_time:3,exportable_certification:4,trust_signature:5,regular_expression:6,revocable:7,key_expiration_time:9,placeholder_backwards_compatibility:10,preferred_symmetric_algorithms:11,revocation_key:12,issuer:16,notation_data:20,preferred_hash_algorithms:21,preferred_compression_algorithms:22,key_server_preferences:23,preferred_key_server:24,primary_user_id:25,policy_uri:26,key_flags:27,signers_user_id:28,reason_for_revocation:29,features:30,signature_target:31,embedded_signature:32},keyFlags:{certify_keys:1,sign_data:2,encrypt_communication:4,encrypt_storage:8,split_private_key:16,authentication:32,shared_private_key:128},keyStatus:{invalid:0,expired:1,revoked:2,valid:3,no_self_cert:4},armor:{multipart_section:0,multipart_last:1,signed:2,message:3,public_key:4,private_key:5},write:function(a,b){if("number"==typeof b&&(b=this.read(a,b)),void 0!==a[b])return a[b];throw new Error("Invalid enum value.")},read:function(a,b){for(var c in a)if(a[c]==b)return c;throw new Error("Invalid enum value.")}}},{}],33:[function(a,b,c){"use strict";function d(b){this._baseUrl=b?b:e.keyserver,this._fetch="undefined"!=typeof window?window.fetch:a("node-fetch")}b.exports=d;var e=a("../config");d.prototype.lookup=function(a){var b=this._baseUrl+"/pks/lookup?op=get&options=mr&search=",c=this._fetch;if(a.keyId)b+="0x"+encodeURIComponent(a.keyId);else{if(!a.query)throw new Error("You must provide a query parameter!");b+=encodeURIComponent(a.query)}return c(b).then(function(a){return 200===a.status?a.text():void 0}).then(function(a){return!a||a.indexOf("-----END PGP PUBLIC KEY BLOCK-----")<0?void 0:a.trim()})},d.prototype.upload=function(a){var b=this._baseUrl+"/pks/add",c=this._fetch;return c(b,{method:"post",headers:{"Content-Type":"application/x-www-form-urlencoded; charset=UTF-8"},body:"keytext="+encodeURIComponent(a)})}},{"../config":6,"node-fetch":"node-fetch"}],34:[function(a,b,c){b.exports=a("./hkp.js")},{"./hkp.js":33}],35:[function(a,b,c){"use strict";b.exports=a("./openpgp.js"),b.exports.key=a("./key.js"),b.exports.message=a("./message.js"),b.exports.cleartext=a("./cleartext.js"),b.exports.util=a("./util.js"),b.exports.packet=a("./packet"),b.exports.MPI=a("./type/mpi.js"),b.exports.S2K=a("./type/s2k.js"),b.exports.Keyid=a("./type/keyid.js"),b.exports.armor=a("./encoding/armor.js"),b.exports.enums=a("./enums.js"),b.exports.config=a("./config/config.js"),b.exports.crypto=a("./crypto"),b.exports.Keyring=a("./keyring"),b.exports.AsyncProxy=a("./worker/async_proxy.js"),b.exports.HKP=a("./hkp")},{"./cleartext.js":1,"./config/config.js":5,"./crypto":21,"./encoding/armor.js":30,"./enums.js":32,"./hkp":34,"./key.js":36,"./keyring":37,"./message.js":40,"./openpgp.js":41,"./packet":44,"./type/keyid.js":62,"./type/mpi.js":63,"./type/s2k.js":64,"./util.js":65,"./worker/async_proxy.js":66}],36:[function(a,b,c){"use strict";function d(a){if(!(this instanceof d))return new d(a);if(this.primaryKey=null,this.revocationSignature=null,this.directSignatures=null,this.users=null,this.subKeys=null,this.packetlist2structure(a),!this.primaryKey||!this.users)throw new Error("Invalid key: need at least key and user ID packet")}function e(a,b){return a.algorithm!==o.read(o.publicKey,o.publicKey.dsa)&&a.algorithm!==o.read(o.publicKey,o.publicKey.rsa_sign)&&(!b.keyFlags||0!==(b.keyFlags[0]&o.keyFlags.encrypt_communication)||0!==(b.keyFlags[0]&o.keyFlags.encrypt_storage))}function f(a,b){return!(a.algorithm!=o.read(o.publicKey,o.publicKey.dsa)&&a.algorithm!=o.read(o.publicKey,o.publicKey.rsa_sign)&&a.algorithm!=o.read(o.publicKey,o.publicKey.rsa_encrypt_sign)||b.keyFlags&&0===(b.keyFlags[0]&o.keyFlags.sign_data))}function g(a,b){return 3==a.version&&0!==a.expirationTimeV3?new Date(a.created.getTime()+24*a.expirationTimeV3*3600*1e3):4==a.version&&b.keyNeverExpires===!1?new Date(a.created.getTime()+1e3*b.keyExpirationTime):null}function h(a,b,c,d){a=a[c],a&&(b[c]?a.forEach(function(a){a.isExpired()||d&&!d(a)||b[c].some(function(b){return b.signature===a.signature})||b[c].push(a)}):b[c]=a)}function i(a){return this instanceof i?(this.userId=a.tag==o.packet.userid?a:null,this.userAttribute=a.tag==o.packet.userAttribute?a:null,this.selfCertifications=null,this.otherCertifications=null,void(this.revocationCertifications=null)):new i(a)}function j(a){return this instanceof j?(this.subKey=a,this.bindingSignature=null,void(this.revocationSignature=null)):new j(a)}function k(a){var b={};b.keys=[];try{var c=p.decode(a);if(c.type!=o.armor.public_key&&c.type!=o.armor.private_key)throw new Error("Armored text not of type key");var e=new n.List;e.read(c.data);var f=e.indexOfTag(o.packet.publicKey,o.packet.secretKey);if(0===f.length)throw new Error("No key packet found in armored text");for(var g=0;g<f.length;g++){var h=e.slice(f[g],f[g+1]);try{var i=new d(h);b.keys.push(i)}catch(j){b.err=b.err||[],b.err.push(j)}}}catch(j){b.err=b.err||[],b.err.push(j)}return b}function l(a){function b(){return g=new n.SecretKey,g.algorithm=o.read(o.publicKey,a.keyType),g.generate(a.numBits)}function c(){return k=new n.SecretSubkey,k.algorithm=o.read(o.publicKey,a.keyType),k.generate(a.numBits)}function e(){return a.passphrase&&(g.encrypt(a.passphrase),k.encrypt(a.passphrase)),f=new n.List,f.push(g),a.userId.forEach(function(b,c){h=new n.Userid,h.read(b),i={},i.userid=h,i.key=g,j=new n.Signature,j.signatureType=o.signature.cert_generic,j.publicKeyAlgorithm=a.keyType,j.hashAlgorithm=q.prefer_hash_algorithm,j.keyFlags=[o.keyFlags.certify_keys|o.keyFlags.sign_data],a.keyExpirationTime&&(j.keyExpirationTime=a.keyExpirationTime,j.keyNeverExpires=!1),j.preferredSymmetricAlgorithms=[],j.preferredSymmetricAlgorithms.push(o.symmetric.aes256),j.preferredSymmetricAlgorithms.push(o.symmetric.aes192),j.preferredSymmetricAlgorithms.push(o.symmetric.aes128),j.preferredSymmetricAlgorithms.push(o.symmetric.cast5),j.preferredSymmetricAlgorithms.push(o.symmetric.tripledes),j.preferredHashAlgorithms=[],j.preferredHashAlgorithms.push(o.hash.sha256),j.preferredHashAlgorithms.push(o.hash.sha1),j.preferredHashAlgorithms.push(o.hash.sha512),j.preferredCompressionAlgorithms=[],j.preferredCompressionAlgorithms.push(o.compression.zlib),j.preferredCompressionAlgorithms.push(o.compression.zip),0===c&&(j.isPrimaryUserID=!0),q.integrity_protect&&(j.features=[],j.features.push(1)),j.sign(g,i),f.push(h),f.push(j)}),i={},i.key=g,i.bind=k,l=new n.Signature,l.signatureType=o.signature.subkey_binding,l.publicKeyAlgorithm=a.keyType,l.hashAlgorithm=q.prefer_hash_algorithm,l.keyFlags=[o.keyFlags.encrypt_communication|o.keyFlags.encrypt_storage],a.keyExpirationTime&&(l.keyExpirationTime=a.keyExpirationTime,l.keyNeverExpires=!1),l.sign(g,i),f.push(k),f.push(l),a.unlocked||(g.clearPrivateMPIs(),k.clearPrivateMPIs()),new d(f)}var f,g,h,i,j,k,l;if(a.keyType=a.keyType||o.publicKey.rsa_encrypt_sign,a.keyType!==o.publicKey.rsa_encrypt_sign)throw new Error("Only RSA Encrypt or Sign supported");a.passphrase||(a.unlocked=!0),(String.prototype.isPrototypeOf(a.userId)||"string"==typeof a.userId)&&(a.userId=[a.userId]);var m=b(),p=c();return Promise.all([m,p]).then(e)}function m(a){for(var b={},c=0;c<a.length;c++){var d=a[c].getPrimaryUser();if(!d||!d.selfCertificate.preferredSymmetricAlgorithms)return q.encryption_cipher;d.selfCertificate.preferredSymmetricAlgorithms.forEach(function(a,c){var d=b[a]||(b[a]={prio:0,count:0,algo:a});d.prio+=64>>c,d.count++})}var e={prio:0,algo:q.encryption_cipher};for(var f in b)try{f!==o.symmetric.plaintext&&f!==o.symmetric.idea&&o.read(o.symmetric,f)&&b[f].count===a.length&&b[f].prio>e.prio&&(e=b[f])}catch(g){}return e.algo}var n=a("./packet"),o=a("./enums.js"),p=a("./encoding/armor.js"),q=a("./config"),r=a("./util");d.prototype.packetlist2structure=function(a){for(var b,c,d,e=0;e<a.length;e++)switch(a[e].tag){case o.packet.publicKey:case o.packet.secretKey:this.primaryKey=a[e],c=this.primaryKey.getKeyId();break;case o.packet.userid:case o.packet.userAttribute:b=new i(a[e]),this.users||(this.users=[]),this.users.push(b);break;case o.packet.publicSubkey:case o.packet.secretSubkey:b=null,this.subKeys||(this.subKeys=[]),d=new j(a[e]),this.subKeys.push(d);break;case o.packet.signature:switch(a[e].signatureType){case o.signature.cert_generic:case o.signature.cert_persona:case o.signature.cert_casual:case o.signature.cert_positive:if(!b){r.print_debug("Dropping certification signatures without preceding user packet");continue}a[e].issuerKeyId.equals(c)?(b.selfCertifications||(b.selfCertifications=[]),b.selfCertifications.push(a[e])):(b.otherCertifications||(b.otherCertifications=[]),b.otherCertifications.push(a[e]));break;case o.signature.cert_revocation:b?(b.revocationCertifications||(b.revocationCertifications=[]),b.revocationCertifications.push(a[e])):(this.directSignatures||(this.directSignatures=[]),this.directSignatures.push(a[e]));break;case o.signature.key:this.directSignatures||(this.directSignatures=[]),this.directSignatures.push(a[e]);break;case o.signature.subkey_binding:if(!d){r.print_debug("Dropping subkey binding signature without preceding subkey packet");continue}d.bindingSignature=a[e];break;case o.signature.key_revocation:this.revocationSignature=a[e];break;case o.signature.subkey_revocation:if(!d){r.print_debug("Dropping subkey revocation signature without preceding subkey packet");continue}d.revocationSignature=a[e]}}},d.prototype.toPacketlist=function(){var a=new n.List;a.push(this.primaryKey),a.push(this.revocationSignature),a.concat(this.directSignatures);var b;for(b=0;b<this.users.length;b++)a.concat(this.users[b].toPacketlist());if(this.subKeys)for(b=0;b<this.subKeys.length;b++)a.concat(this.subKeys[b].toPacketlist());return a},d.prototype.getSubkeyPackets=function(){var a=[];if(this.subKeys)for(var b=0;b<this.subKeys.length;b++)a.push(this.subKeys[b].subKey);return a},d.prototype.getAllKeyPackets=function(){return[this.primaryKey].concat(this.getSubkeyPackets())},d.prototype.getKeyIds=function(){for(var a=[],b=this.getAllKeyPackets(),c=0;c<b.length;c++)a.push(b[c].getKeyId());return a},d.prototype.getKeyPacket=function(a){for(var b=this.getAllKeyPackets(),c=0;c<b.length;c++)for(var d=b[c].getKeyId(),e=0;e<a.length;e++)if(d.equals(a[e]))return b[c];return null},d.prototype.getUserIds=function(){for(var a=[],b=0;b<this.users.length;b++)this.users[b].userId&&a.push(this.users[b].userId.write());return a},d.prototype.isPublic=function(){return this.primaryKey.tag==o.packet.publicKey},d.prototype.isPrivate=function(){return this.primaryKey.tag==o.packet.secretKey},d.prototype.toPublic=function(){for(var a,b=new n.List,c=this.toPacketlist(),e=0;e<c.length;e++)switch(c[e].tag){case o.packet.secretKey:a=c[e].writePublicKey();var f=new n.PublicKey;f.read(a),b.push(f);break;case o.packet.secretSubkey:a=c[e].writePublicKey();var g=new n.PublicSubkey;g.read(a),b.push(g);break;default:b.push(c[e])}return new d(b)},d.prototype.armor=function(){var a=this.isPublic()?o.armor.public_key:o.armor.private_key;return p.encode(a,this.toPacketlist().write())},d.prototype.getSigningKeyPacket=function(a){var b=this.getPrimaryUser();if(b&&f(this.primaryKey,b.selfCertificate)&&(!a||this.primaryKey.getKeyId().equals(a)))return this.primaryKey;if(this.subKeys)for(var c=0;c<this.subKeys.length;c++)if(this.subKeys[c].isValidSigningKey(this.primaryKey)&&(!a||this.subKeys[c].subKey.getKeyId().equals(a)))return this.subKeys[c].subKey;return null},d.prototype.getPreferredHashAlgorithm=function(){var a=this.getPrimaryUser();return a&&a.selfCertificate.preferredHashAlgorithms?a.selfCertificate.preferredHashAlgorithms[0]:q.prefer_hash_algorithm},d.prototype.getEncryptionKeyPacket=function(){if(this.subKeys)for(var a=0;a<this.subKeys.length;a++)if(this.subKeys[a].isValidEncryptionKey(this.primaryKey))return this.subKeys[a].subKey;var b=this.getPrimaryUser();return b&&e(this.primaryKey,b.selfCertificate)?this.primaryKey:null},d.prototype.decrypt=function(a){if(!this.isPrivate())throw new Error("Nothing to decrypt in a public key");for(var b=this.getAllKeyPackets(),c=0;c<b.length;c++){var d=b[c].decrypt(a);if(!d)return!1}return!0},d.prototype.decryptKeyPacket=function(a,b){if(!this.isPrivate())throw new Error("Nothing to decrypt in a public key");for(var c=this.getAllKeyPackets(),d=0;d<c.length;d++)for(var e=c[d].getKeyId(),f=0;f<a.length;f++)if(e.equals(a[f])){var g=c[d].decrypt(b);if(!g)return!1}return!0},d.prototype.verifyPrimaryKey=function(){if(this.revocationSignature&&!this.revocationSignature.isExpired()&&(this.revocationSignature.verified||this.revocationSignature.verify(this.primaryKey,{key:this.primaryKey})))return o.keyStatus.revoked;if(3==this.primaryKey.version&&0!==this.primaryKey.expirationTimeV3&&Date.now()>this.primaryKey.created.getTime()+24*this.primaryKey.expirationTimeV3*3600*1e3)return o.keyStatus.expired;for(var a=!1,b=0;b<this.users.length;b++)this.users[b].userId&&this.users[b].selfCertifications&&(a=!0);if(!a)return o.keyStatus.no_self_cert;var c=this.getPrimaryUser();return c?4==this.primaryKey.version&&c.selfCertificate.keyNeverExpires===!1&&Date.now()>this.primaryKey.created.getTime()+1e3*c.selfCertificate.keyExpirationTime?o.keyStatus.expired:o.keyStatus.valid:o.keyStatus.invalid},d.prototype.getExpirationTime=function(){if(3==this.primaryKey.version)return g(this.primaryKey);if(4==this.primaryKey.version){var a=this.getPrimaryUser();return a?g(this.primaryKey,a.selfCertificate):null}},d.prototype.getPrimaryUser=function(){for(var a=[],b=0;b<this.users.length;b++)if(this.users[b].userId&&this.users[b].selfCertifications)for(var c=0;c<this.users[b].selfCertifications.length;c++)a.push({user:this.users[b],selfCertificate:this.users[b].selfCertifications[c]});a=a.sort(function(a,b){return a.selfCertificate.isPrimaryUserID>b.selfCertificate.isPrimaryUserID?-1:a.selfCertificate.isPrimaryUserID<b.selfCertificate.isPrimaryUserID?1:a.selfCertificate.created>b.selfCertificate.created?-1:a.selfCertificate.created<b.selfCertificate.created?1:0});for(var b=0;b<a.length;b++)if(a[b].user.isValidSelfCertificate(this.primaryKey,a[b].selfCertificate))return a[b];return null},d.prototype.update=function(a){var b=this;if(a.verifyPrimaryKey()!==o.keyStatus.invalid){if(this.primaryKey.getFingerprint()!==a.primaryKey.getFingerprint())throw new Error("Key update method: fingerprints of keys not equal");if(this.isPublic()&&a.isPrivate()){var c=(this.subKeys&&this.subKeys.length)===(a.subKeys&&a.subKeys.length)&&(!this.subKeys||this.subKeys.every(function(b){return a.subKeys.some(function(a){return b.subKey.getFingerprint()===a.subKey.getFingerprint()})}));if(!c)throw new Error("Cannot update public key with private key if subkey mismatch");this.primaryKey=a.primaryKey}this.revocationSignature||!a.revocationSignature||a.revocationSignature.isExpired()||!a.revocationSignature.verified&&!a.revocationSignature.verify(a.primaryKey,{key:a.primaryKey})||(this.revocationSignature=a.revocationSignature),h(a,this,"directSignatures"),a.users.forEach(function(a){for(var c=!1,d=0;d<b.users.length;d++)if(a.userId&&a.userId.userid===b.users[d].userId.userid||a.userAttribute&&a.userAttribute.equals(b.users[d].userAttribute)){b.users[d].update(a,b.primaryKey),c=!0;break}c||b.users.push(a)}),a.subKeys&&a.subKeys.forEach(function(a){for(var c=!1,d=0;d<b.subKeys.length;d++)if(a.subKey.getFingerprint()===b.subKeys[d].subKey.getFingerprint()){b.subKeys[d].update(a,b.primaryKey),c=!0;break}c||b.subKeys.push(a)})}},d.prototype.revoke=function(){},i.prototype.toPacketlist=function(){var a=new n.List;return a.push(this.userId||this.userAttribute),a.concat(this.revocationCertifications),a.concat(this.selfCertifications),a.concat(this.otherCertifications),a},i.prototype.isRevoked=function(a,b){if(this.revocationCertifications){var c=this;return this.revocationCertifications.some(function(d){return d.issuerKeyId.equals(a.issuerKeyId)&&!d.isExpired()&&(d.verified||d.verify(b,{userid:c.userId||c.userAttribute,key:b}))})}return!1},i.prototype.getValidSelfCertificate=function(a){if(!this.selfCertifications)return null;for(var b=this.selfCertifications.sort(function(a,b){return a=a.created,b=b.created,a>b?-1:b>a?1:0}),c=0;c<b.length;c++)if(this.isValidSelfCertificate(a,b[c]))return b[c];return null},i.prototype.isValidSelfCertificate=function(a,b){return this.isRevoked(b,a)?!1:b.isExpired()||!b.verified&&!b.verify(a,{userid:this.userId||this.userAttribute,key:a})?!1:!0},i.prototype.verify=function(a){if(!this.selfCertifications)return o.keyStatus.no_self_cert;for(var b,c=0;c<this.selfCertifications.length;c++)if(this.isRevoked(this.selfCertifications[c],a))b=o.keyStatus.revoked;else if(this.selfCertifications[c].verified||this.selfCertifications[c].verify(a,{
	userid:this.userId||this.userAttribute,key:a})){if(!this.selfCertifications[c].isExpired()){b=o.keyStatus.valid;break}b=o.keyStatus.expired}else b=o.keyStatus.invalid;return b},i.prototype.update=function(a,b){var c=this;h(a,this,"selfCertifications",function(a){return a.verified||a.verify(b,{userid:c.userId||c.userAttribute,key:b})}),h(a,this,"otherCertifications"),h(a,this,"revocationCertifications")},j.prototype.toPacketlist=function(){var a=new n.List;return a.push(this.subKey),a.push(this.revocationSignature),a.push(this.bindingSignature),a},j.prototype.isValidEncryptionKey=function(a){return this.verify(a)==o.keyStatus.valid&&e(this.subKey,this.bindingSignature)},j.prototype.isValidSigningKey=function(a){return this.verify(a)==o.keyStatus.valid&&f(this.subKey,this.bindingSignature)},j.prototype.verify=function(a){return this.revocationSignature&&!this.revocationSignature.isExpired()&&(this.revocationSignature.verified||this.revocationSignature.verify(a,{key:a,bind:this.subKey}))?o.keyStatus.revoked:3==this.subKey.version&&0!==this.subKey.expirationTimeV3&&Date.now()>this.subKey.created.getTime()+24*this.subKey.expirationTimeV3*3600*1e3?o.keyStatus.expired:this.bindingSignature?this.bindingSignature.isExpired()?o.keyStatus.expired:this.bindingSignature.verified||this.bindingSignature.verify(a,{key:a,bind:this.subKey})?4==this.subKey.version&&this.bindingSignature.keyNeverExpires===!1&&Date.now()>this.subKey.created.getTime()+1e3*this.bindingSignature.keyExpirationTime?o.keyStatus.expired:o.keyStatus.valid:o.keyStatus.invalid:o.keyStatus.invalid},j.prototype.getExpirationTime=function(){return g(this.subKey,this.bindingSignature)},j.prototype.update=function(a,b){if(a.verify(b)!==o.keyStatus.invalid){if(this.subKey.getFingerprint()!==a.subKey.getFingerprint())throw new Error("SubKey update method: fingerprints of subkeys not equal");this.subKey.tag===o.packet.publicSubkey&&a.subKey.tag===o.packet.secretSubkey&&(this.subKey=a.subKey),!this.bindingSignature&&a.bindingSignature&&(a.bindingSignature.verified||a.bindingSignature.verify(b,{key:b,bind:this.subKey}))&&(this.bindingSignature=a.bindingSignature),this.revocationSignature||!a.revocationSignature||a.revocationSignature.isExpired()||!a.revocationSignature.verified&&!a.revocationSignature.verify(b,{key:b,bind:this.subKey})||(this.revocationSignature=a.revocationSignature)}},c.Key=d,c.readArmored=k,c.generate=l,c.getPreferredSymAlgo=m},{"./config":6,"./encoding/armor.js":30,"./enums.js":32,"./packet":44,"./util":65}],37:[function(a,b,c){b.exports=a("./keyring.js"),b.exports.localstore=a("./localstore.js")},{"./keyring.js":38,"./localstore.js":39}],38:[function(a,b,c){function d(b){this.storeHandler=b||new(a("./localstore.js")),this.publicKeys=new e(this.storeHandler.loadPublic()),this.privateKeys=new e(this.storeHandler.loadPrivate())}function e(a){this.keys=a}function f(a,b){a=a.toLowerCase();for(var c=a.replace(/[.*+?^${}()|[\]\\]/g,"\\$&"),d=new RegExp("<"+c+">"),e=b.getUserIds(),f=0;f<e.length;f++){var g=e[f].toLowerCase();if(a===g||d.test(g))return!0}return!1}function g(a,b){return 16===a.length?a===b.getKeyId().toHex():a===b.getFingerprint()}var h=(a("../enums.js"),a("../key.js"));a("../util.js");b.exports=d,d.prototype.store=function(){this.storeHandler.storePublic(this.publicKeys.keys),this.storeHandler.storePrivate(this.privateKeys.keys)},d.prototype.clear=function(){this.publicKeys.keys=[],this.privateKeys.keys=[]},d.prototype.getKeysForId=function(a,b){var c=[];return c=c.concat(this.publicKeys.getForId(a,b)||[]),c=c.concat(this.privateKeys.getForId(a,b)||[]),c.length?c:null},d.prototype.removeKeysForId=function(a){var b=[];return b=b.concat(this.publicKeys.removeForId(a)||[]),b=b.concat(this.privateKeys.removeForId(a)||[]),b.length?b:null},d.prototype.getAllKeys=function(){return this.publicKeys.keys.concat(this.privateKeys.keys)},e.prototype.getForAddress=function(a){for(var b=[],c=0;c<this.keys.length;c++)f(a,this.keys[c])&&b.push(this.keys[c]);return b},e.prototype.getForId=function(a,b){for(var c=0;c<this.keys.length;c++){if(g(a,this.keys[c].primaryKey))return this.keys[c];if(b&&this.keys[c].subKeys)for(var d=0;d<this.keys[c].subKeys.length;d++)if(g(a,this.keys[c].subKeys[d].subKey))return this.keys[c]}return null},e.prototype.importKey=function(a){var b=h.readArmored(a),c=this;return b.keys.forEach(function(a){var b=a.primaryKey.getKeyId().toHex(),d=c.getForId(b);d?d.update(a):c.push(a)}),b.err?b.err:null},e.prototype.push=function(a){return this.keys.push(a)},e.prototype.removeForId=function(a){for(var b=0;b<this.keys.length;b++)if(g(a,this.keys[b].primaryKey))return this.keys.splice(b,1)[0];return null}},{"../enums.js":32,"../key.js":36,"../util.js":65,"./localstore.js":39}],39:[function(a,b,c){function d(b){b=b||"openpgp-",this.publicKeysItem=b+this.publicKeysItem,this.privateKeysItem=b+this.privateKeysItem,"undefined"!=typeof window&&window.localStorage?this.storage=window.localStorage:this.storage=new(a("node-localstorage").LocalStorage)(g.node_store)}function e(a,b){var c=JSON.parse(a.getItem(b)),d=[];if(null!==c&&0!==c.length)for(var e,f=0;f<c.length;f++)e=h.readArmored(c[f]),e.err?i.print_debug("Error reading armored key from keyring index: "+f):d.push(e.keys[0]);return d}function f(a,b,c){var d=[];if(c.length){for(var e=0;e<c.length;e++)d.push(c[e].armor());a.setItem(b,JSON.stringify(d))}else a.removeItem(b)}b.exports=d;var g=a("../config"),h=a("../key.js"),i=a("../util.js");d.prototype.publicKeysItem="public-keys",d.prototype.privateKeysItem="private-keys",d.prototype.loadPublic=function(){return e(this.storage,this.publicKeysItem)},d.prototype.loadPrivate=function(){return e(this.storage,this.privateKeysItem)},d.prototype.storePublic=function(a){f(this.storage,this.publicKeysItem,a)},d.prototype.storePrivate=function(a){f(this.storage,this.privateKeysItem,a)}},{"../config":6,"../key.js":36,"../util.js":65,"node-localstorage":"node-localstorage"}],40:[function(a,b,c){"use strict";function d(a){return this instanceof d?void(this.packets=a||new i.List):new d(a)}function e(a){var b=k.decode(a).data,c=new i.List;return c.read(b),new d(c)}function f(a,b){var c=new i.Literal;c.setBytes(a,j.read(j.literal,j.literal.binary));var e=new i.List;e.push(c);var f=k.decode(b).data;return e.read(f),new d(e)}function g(a){var b=new i.Literal;b.setText(a);var c=new i.List;return c.push(b),new d(c)}function h(a,b){var c=new i.Literal;b&&c.setFilename(b),c.setBytes(a,j.read(j.literal,j.literal.binary));var e=new i.List;return e.push(c),new d(e)}var i=a("./packet"),j=a("./enums.js"),k=a("./encoding/armor.js"),l=a("./config"),m=a("./crypto"),n=a("./key.js");d.prototype.getEncryptionKeyIds=function(){var a=[],b=this.packets.filterByTag(j.packet.publicKeyEncryptedSessionKey);return b.forEach(function(b){a.push(b.publicKeyId)}),a},d.prototype.getSigningKeyIds=function(){var a=[],b=this.unwrapCompressed(),c=b.packets.filterByTag(j.packet.onePassSignature);if(c.forEach(function(b){a.push(b.signingKeyId)}),!a.length){var d=b.packets.filterByTag(j.packet.signature);d.forEach(function(b){a.push(b.issuerKeyId)})}return a},d.prototype.decrypt=function(a){var b=this.getEncryptionKeyIds();if(!b.length)return this;var c=a.getKeyPacket(b);if(!c.isDecrypted)throw new Error("Private key is not decrypted.");for(var e,f=this.packets.filterByTag(j.packet.publicKeyEncryptedSessionKey),g=0;g<f.length;g++)if(f[g].publicKeyId.equals(c.getKeyId())){e=f[g],e.decrypt(c);break}if(e){var h=this.packets.filterByTag(j.packet.symmetricallyEncrypted,j.packet.symEncryptedIntegrityProtected);if(0!==h.length){var k=h[0];k.decrypt(e.sessionKeyAlgorithm,e.sessionKey);var l=new d(k.packets);return k.packets=new i.List,l}}},d.prototype.getLiteralData=function(){var a=this.packets.findPacket(j.packet.literal);return a&&a.data||null},d.prototype.getFilename=function(){var a=this.packets.findPacket(j.packet.literal);return a&&a.getFilename()||null},d.prototype.getText=function(){var a=this.packets.findPacket(j.packet.literal);return a?a.getText():null},d.prototype.encrypt=function(a){var b=new i.List,c=n.getPreferredSymAlgo(a),e=m.generateSessionKey(j.read(j.symmetric,c));a.forEach(function(a){var d=a.getEncryptionKeyPacket();if(!d)throw new Error("Could not find valid key packet for encryption in key "+a.primaryKey.getKeyId().toHex());var f=new i.PublicKeyEncryptedSessionKey;f.publicKeyId=d.getKeyId(),f.publicKeyAlgorithm=d.algorithm,f.sessionKey=e,f.sessionKeyAlgorithm=j.read(j.symmetric,c),f.encrypt(d),b.push(f)});var f;return f=l.integrity_protect?new i.SymEncryptedIntegrityProtected:new i.SymmetricallyEncrypted,f.packets=this.packets,f.encrypt(j.read(j.symmetric,c),e),b.push(f),f.packets=new i.List,new d(b)},d.prototype.symEncrypt=function(a){if(!a)throw new Error("The passphrase cannot be empty!");var b=j.read(j.symmetric,l.encryption_cipher),c=new i.List,e=new i.SymEncryptedSessionKey;e.sessionKeyAlgorithm=b,e.decrypt(a),c.push(e);var f=new i.SymEncryptedIntegrityProtected;return f.packets=this.packets,f.encrypt(b,e.sessionKey),c.push(f),f.packets=new i.List,new d(c)},d.prototype.symDecrypt=function(a){var b=this.packets.filterByTag(j.packet.symEncryptedSessionKey,j.packet.symEncryptedIntegrityProtected),c=b[0];c.decrypt(a);var e=b[1];e.decrypt(c.sessionKeyAlgorithm,c.sessionKey);var f=new d(e.packets);return e.packets=new i.List,f},d.prototype.sign=function(a){var b=new i.List,c=this.packets.findPacket(j.packet.literal);if(!c)throw new Error("No literal data packet to sign.");var e,f,g=j.write(j.literal,c.format),h=g==j.literal.binary?j.signature.binary:j.signature.text;for(e=0;e<a.length;e++){if(a[e].isPublic())throw new Error("Need private key for signing");var k=new i.OnePassSignature;if(k.type=h,k.hashAlgorithm=l.prefer_hash_algorithm,f=a[e].getSigningKeyPacket(),!f)throw new Error("Could not find valid key packet for signing in key "+a[e].primaryKey.getKeyId().toHex());k.publicKeyAlgorithm=f.algorithm,k.signingKeyId=f.getKeyId(),b.push(k)}for(b.push(c),e=a.length-1;e>=0;e--){var m=new i.Signature;if(m.signatureType=h,m.hashAlgorithm=l.prefer_hash_algorithm,m.publicKeyAlgorithm=f.algorithm,!f.isDecrypted)throw new Error("Private key is not decrypted.");m.sign(f,c),b.push(m)}return new d(b)},d.prototype.verify=function(a){var b=[],c=this.unwrapCompressed(),d=c.packets.filterByTag(j.packet.literal);if(1!==d.length)throw new Error("Can only verify message with one literal data packet.");for(var e=c.packets.filterByTag(j.packet.signature),f=0;f<e.length;f++){for(var g=null,h=0;h<a.length&&!(g=a[h].getSigningKeyPacket(e[f].issuerKeyId));h++);var i={};g?(i.keyid=e[f].issuerKeyId,i.valid=e[f].verify(g,d[0])):(i.keyid=e[f].issuerKeyId,i.valid=null),b.push(i)}return b},d.prototype.unwrapCompressed=function(){var a=this.packets.filterByTag(j.packet.compressed);return a.length?new d(a[0].packets):this},d.prototype.armor=function(){return k.encode(j.armor.message,this.packets.write())},c.Message=d,c.readArmored=e,c.readSignedContent=f,c.fromText=g,c.fromBinary=h},{"./config":6,"./crypto":21,"./encoding/armor.js":30,"./enums.js":32,"./key.js":36,"./packet":44}],41:[function(a,b,c){"use strict";function d(a,b){return b&&b.worker||"undefined"!=typeof window&&window.Worker?(b=b||{},b.config=this.config,x=new w(a,b),!0):!1}function e(){return x}function f(a,b,c,d){return a.length||(a=[a]),x?x.encryptMessage(a,b,c,d):m(function(){var e,f;return e=o(b,c,d),e=e.encrypt(a),f=q.encode(r.armor.message,e.packets.write())},"Error encrypting message!")}function g(a,b,c,d,e){return a.length||(a=[a]),x?x.signAndEncryptMessage(a,b,c,d,e):m(function(){var f,g;return f=o(c,d,e),f=f.sign([b]),f=f.encrypt(a),g=q.encode(r.armor.message,f.packets.write())},"Error signing and encrypting message!")}function h(a,b,c){return x?x.decryptMessage(a,b,c):m(function(){return b=b.decrypt(a),c?p(b,c):p(b).text},"Error decrypting message!")}function i(a,b,c,d){return b.length||(b=[b]),x?x.decryptAndVerifyMessage(a,b,c,d):m(function(){var e={};return c=c.decrypt(a),e=p(c,d),e.text?(e.signatures=c.verify(b),e):null},"Error decrypting and verifying message!")}function j(a,b){return a.length||(a=[a]),x?x.signClearMessage(a,b):m(function(){var c=new t.CleartextMessage(b);return c.sign(a),c.armor()},"Error signing cleartext message!")}function k(a,b){return a.length||(a=[a]),x?x.verifyClearSignedMessage(a,b):m(function(){var c={};if(!(b instanceof t.CleartextMessage))throw new Error("Parameter [message] needs to be of type CleartextMessage.");return c.text=b.getText(),c.signatures=b.verify(a),c},"Error verifying cleartext signed message!")}function l(a){return!v.getWebCrypto()&&x?x.generateKeyPair(a):u.generate(a).then(function(a){var b={};return b.key=a,b.privateKeyArmored=a.armor(),b.publicKeyArmored=a.toPublic().armor(),b})["catch"](function(b){if(console.error(b),!v.getWebCrypto())throw new Error("Error generating keypair using js fallback!");return console.log("Error generating keypair using native WebCrypto... falling back back to js!"),x.generateKeyPair(a)})["catch"](n.bind(null,"Error generating keypair!"))}function m(a,b){var c=new Promise(function(b){var c=a();b(c)});return c["catch"](n.bind(null,b))}function n(a,b){throw console.error(b.stack),new Error(a)}function o(a,b,c){var d;return d="binary"===b?s.fromBinary(a,c):s.fromText(a)}function p(a,b){return"binary"===b?{text:a.getLiteralData(),filename:a.getFilename()}:{text:a.getText()}}var q=a("./encoding/armor.js"),r=a("./enums.js"),s=a("./message.js"),t=a("./cleartext.js"),u=a("./key.js"),v=a("./util"),w=a("./worker/async_proxy.js"),x=null;c.initWorker=d,c.getWorker=e,c.encryptMessage=f,c.signAndEncryptMessage=g,c.decryptMessage=h,c.decryptAndVerifyMessage=i,c.signClearMessage=j,c.verifyClearSignedMessage=k,c.generateKeyPair=l},{"./cleartext.js":1,"./encoding/armor.js":30,"./enums.js":32,"./key.js":36,"./message.js":40,"./util":65,"./worker/async_proxy.js":66}],42:[function(a,b,c){function d(a){return a.substr(0,1).toUpperCase()+a.substr(1)}var e=a("../enums.js");b.exports={Compressed:a("./compressed.js"),SymEncryptedIntegrityProtected:a("./sym_encrypted_integrity_protected.js"),PublicKeyEncryptedSessionKey:a("./public_key_encrypted_session_key.js"),SymEncryptedSessionKey:a("./sym_encrypted_session_key.js"),Literal:a("./literal.js"),PublicKey:a("./public_key.js"),SymmetricallyEncrypted:a("./symmetrically_encrypted.js"),Marker:a("./marker.js"),PublicSubkey:a("./public_subkey.js"),UserAttribute:a("./user_attribute.js"),OnePassSignature:a("./one_pass_signature.js"),SecretKey:a("./secret_key.js"),Userid:a("./userid.js"),SecretSubkey:a("./secret_subkey.js"),Signature:a("./signature.js"),Trust:a("./trust.js"),newPacketFromTag:function(a){return new(this[d(a)])},fromStructuredClone:function(a){var b=e.read(e.packet,a.tag),c=this.newPacketFromTag(b);for(var d in a)a.hasOwnProperty(d)&&(c[d]=a[d]);return c.postCloneTypeFix&&c.postCloneTypeFix(),c}}},{"../enums.js":32,"./compressed.js":43,"./literal.js":45,"./marker.js":46,"./one_pass_signature.js":47,"./public_key.js":50,"./public_key_encrypted_session_key.js":51,"./public_subkey.js":52,"./secret_key.js":53,"./secret_subkey.js":54,"./signature.js":55,"./sym_encrypted_integrity_protected.js":56,"./sym_encrypted_session_key.js":57,"./symmetrically_encrypted.js":58,"./trust.js":59,"./user_attribute.js":60,"./userid.js":61}],43:[function(a,b,c){function d(){this.tag=e.packet.compressed,this.packets=null,this.algorithm="zip",this.compressed=null}b.exports=d;var e=a("../enums.js"),f=a("../util.js"),g=a("../compression/zlib.min.js"),h=a("../compression/rawinflate.min.js"),i=a("../compression/rawdeflate.min.js");d.prototype.read=function(a){this.algorithm=e.read(e.compression,a.charCodeAt(0)),this.compressed=a.substr(1),this.decompress()},d.prototype.write=function(){return null===this.compressed&&this.compress(),String.fromCharCode(e.write(e.compression,this.algorithm))+this.compressed},d.prototype.decompress=function(){var a;switch(this.algorithm){case"uncompressed":a=this.compressed;break;case"zip":var b=new h.Zlib.RawInflate(f.str2Uint8Array(this.compressed));a=f.Uint8Array2str(b.decompress());break;case"zlib":var b=new g.Zlib.Inflate(f.str2Uint8Array(this.compressed));a=f.Uint8Array2str(b.decompress());break;case"bzip2":throw new Error("Compression algorithm BZip2 [BZ2] is not implemented.");default:throw new Error("Compression algorithm unknown :"+this.alogrithm)}this.packets.read(a)},d.prototype.compress=function(){var a,b;switch(a=this.packets.write(),this.algorithm){case"uncompressed":this.compressed=a;break;case"zip":b=new i.Zlib.RawDeflate(f.str2Uint8Array(a)),this.compressed=f.Uint8Array2str(b.compress());break;case"zlib":b=new g.Zlib.Deflate(f.str2Uint8Array(a)),this.compressed=f.Uint8Array2str(b.compress());break;case"bzip2":throw new Error("Compression algorithm BZip2 [BZ2] is not implemented.");default:throw new Error("Compression algorithm unknown :"+this.type)}}},{"../compression/rawdeflate.min.js":2,"../compression/rawinflate.min.js":3,"../compression/zlib.min.js":4,"../enums.js":32,"../util.js":65}],44:[function(a,b,c){a("../enums.js");b.exports={List:a("./packetlist.js")};var d=a("./all_packets.js");for(var e in d)b.exports[e]=d[e]},{"../enums.js":32,"./all_packets.js":42,"./packetlist.js":49}],45:[function(a,b,c){function d(){this.tag=f.packet.literal,this.format="utf8",this.data="",this.date=new Date,this.filename="msg.txt"}b.exports=d;var e=a("../util.js"),f=a("../enums.js");d.prototype.setText=function(a){a=a.replace(/\r/g,"").replace(/\n/g,"\r\n"),this.data="utf8"==this.format?e.encode_utf8(a):a},d.prototype.getText=function(){var a=e.decode_utf8(this.data);return a.replace(/\r\n/g,"\n")},d.prototype.setBytes=function(a,b){this.format=b,this.data=a},d.prototype.getBytes=function(){return this.data},d.prototype.setFilename=function(a){this.filename=a},d.prototype.getFilename=function(){return this.filename},d.prototype.read=function(a){var b=f.read(f.literal,a.charCodeAt(0)),c=a.charCodeAt(1);this.filename=e.decode_utf8(a.substr(2,c)),this.date=e.readDate(a.substr(2+c,4));var d=a.substring(6+c);this.setBytes(d,b)},d.prototype.write=function(){var a=e.encode_utf8(this.filename),b=this.getBytes(),c="";return c+=String.fromCharCode(f.write(f.literal,this.format)),c+=String.fromCharCode(a.length),c+=a,c+=e.writeDate(this.date),c+=b}},{"../enums.js":32,"../util.js":65}],46:[function(a,b,c){function d(){this.tag=e.packet.marker}b.exports=d;var e=a("../enums.js");d.prototype.read=function(a){return 80==a.charCodeAt(0)&&71==a.charCodeAt(1)&&80==a.charCodeAt(2)?!0:!1}},{"../enums.js":32}],47:[function(a,b,c){function d(){this.tag=e.packet.onePassSignature,this.version=null,this.type=null,this.hashAlgorithm=null,this.publicKeyAlgorithm=null,this.signingKeyId=null,this.flags=null}b.exports=d;var e=a("../enums.js"),f=a("../type/keyid.js");d.prototype.read=function(a){var b=0;return this.version=a.charCodeAt(b++),this.type=e.read(e.signature,a.charCodeAt(b++)),this.hashAlgorithm=e.read(e.hash,a.charCodeAt(b++)),this.publicKeyAlgorithm=e.read(e.publicKey,a.charCodeAt(b++)),this.signingKeyId=new f,this.signingKeyId.read(a.substr(b)),b+=8,this.flags=a.charCodeAt(b++),this},d.prototype.write=function(){var a="";return a+=String.fromCharCode(3),a+=String.fromCharCode(e.write(e.signature,this.type)),a+=String.fromCharCode(e.write(e.hash,this.hashAlgorithm)),a+=String.fromCharCode(e.write(e.publicKey,this.publicKeyAlgorithm)),a+=this.signingKeyId.write(),a+=String.fromCharCode(this.flags)},d.prototype.postCloneTypeFix=function(){this.signingKeyId=f.fromClone(this.signingKeyId)}},{"../enums.js":32,"../type/keyid.js":62}],48:[function(a,b,c){var d=(a("../enums.js"),a("../util.js"));b.exports={readSimpleLength:function(a){var b,c=0,e=a.charCodeAt(0);return 192>e?(c=a.charCodeAt(0),b=1):255>e?(c=(a.charCodeAt(0)-192<<8)+a.charCodeAt(1)+192,b=2):255==e&&(c=d.readNumber(a.substr(1,4)),b=5),{len:c,offset:b}},writeSimpleLength:function(a){var b="";return 192>a?b+=String.fromCharCode(a):a>191&&8384>a?(b+=String.fromCharCode((a-192>>8)+192),b+=String.fromCharCode(a-192&255)):(b+=String.fromCharCode(255),b+=d.writeNumber(a,4)),b},writeHeader:function(a,b){var c="";return c+=String.fromCharCode(192|a),c+=this.writeSimpleLength(b)},writeOldHeader:function(a,b){var c="";return 256>b?(c+=String.fromCharCode(128|a<<2),c+=String.fromCharCode(b)):65536>b?(c+=String.fromCharCode(128|a<<2|1),c+=d.writeNumber(b,2)):(c+=String.fromCharCode(128|a<<2|2),c+=d.writeNumber(b,4)),c},read:function(a,b,c){if(null===a||a.length<=b||a.substring(b).length<2||0===(128&a.charCodeAt(b)))throw new Error("Error during parsing. This message / key is probably not containing a valid OpenPGP format.");var e,f=b,g=-1,h=-1;h=0,0!==(64&a.charCodeAt(f))&&(h=1);var i;h?g=63&a.charCodeAt(f):(g=(63&a.charCodeAt(f))>>2,i=3&a.charCodeAt(f)),f++;var j=null,k=-1;if(h)if(a.charCodeAt(f)<192)e=a.charCodeAt(f++),d.print_debug("1 byte length:"+e);else if(a.charCodeAt(f)>=192&&a.charCodeAt(f)<224)e=(a.charCodeAt(f++)-192<<8)+a.charCodeAt(f++)+192,d.print_debug("2 byte length:"+e);else if(a.charCodeAt(f)>223&&a.charCodeAt(f)<255){e=1<<(31&a.charCodeAt(f++)),d.print_debug("4 byte length:"+e);var l=f+e;j=a.substring(f,f+e);for(var m;;){if(a.charCodeAt(l)<192){m=a.charCodeAt(l++),e+=m,j+=a.substring(l,l+m),l+=m;break}if(a.charCodeAt(l)>=192&&a.charCodeAt(l)<224){m=(a.charCodeAt(l++)-192<<8)+a.charCodeAt(l++)+192,e+=m,j+=a.substring(l,l+m),l+=m;break}if(!(a.charCodeAt(l)>223&&a.charCodeAt(l)<255)){l++,m=a.charCodeAt(l++)<<24|a.charCodeAt(l++)<<16|a.charCodeAt(l++)<<8|a.charCodeAt(l++),j+=a.substring(l,l+m),e+=m,l+=m;break}m=1<<(31&a.charCodeAt(l++)),e+=m,j+=a.substring(l,l+m),l+=m}k=l-f}else f++,e=a.charCodeAt(f++)<<24|a.charCodeAt(f++)<<16|a.charCodeAt(f++)<<8|a.charCodeAt(f++);else switch(i){case 0:e=a.charCodeAt(f++);break;case 1:e=a.charCodeAt(f++)<<8|a.charCodeAt(f++);break;case 2:e=a.charCodeAt(f++)<<24|a.charCodeAt(f++)<<16|a.charCodeAt(f++)<<8|a.charCodeAt(f++);break;default:e=c}return-1==k&&(k=e),null===j&&(j=a.substring(f,f+k)),{tag:g,packet:j,offset:f+k}}}},{"../enums.js":32,"../util.js":65}],49:[function(a,b,c){function d(){this.length=0}b.exports=d;var e=a("./packet.js"),f=a("./all_packets.js"),g=a("../enums.js");d.prototype.read=function(a){for(var b=0;b<a.length;){var c=e.read(a,b,a.length-b);b=c.offset;var d=!1;try{var h=g.read(g.packet,c.tag),i=f.newPacketFromTag(h);this.push(i),d=!0,i.read(c.packet)}catch(j){d&&this.pop()}}},d.prototype.write=function(){for(var a="",b=0;b<this.length;b++){var c=this[b].write();a+=e.writeHeader(this[b].tag,c.length),a+=c}return a},d.prototype.push=function(a){a&&(a.packets=a.packets||new d,this[this.length]=a,this.length++)},d.prototype.pop=function(){if(0!==this.length){var a=this[this.length-1];return delete this[this.length-1],this.length--,a}},d.prototype.filter=function(a){for(var b=new d,c=0;c<this.length;c++)a(this[c],c,this)&&b.push(this[c]);return b},d.prototype.filterByTag=function(){for(var a=Array.prototype.slice.call(arguments),b=new d,c=this,e=0;e<this.length;e++)a.some(function(a){return c[e].tag==a})&&b.push(this[e]);return b},d.prototype.forEach=function(a){for(var b=0;b<this.length;b++)a(this[b])},d.prototype.findPacket=function(a){var b=this.filterByTag(a);if(b.length)return b[0];for(var c=null,d=0;d<this.length;d++)if(this[d].packets.length&&(c=this[d].packets.findPacket(a)))return c;return null},d.prototype.indexOfTag=function(){for(var a=Array.prototype.slice.call(arguments),b=[],c=this,d=0;d<this.length;d++)a.some(function(a){return c[d].tag==a})&&b.push(d);return b},d.prototype.slice=function(a,b){b||(b=this.length);for(var c=new d,e=a;b>e;e++)c.push(this[e]);return c},d.prototype.concat=function(a){if(a)for(var b=0;b<a.length;b++)this.push(a[b])},b.exports.fromStructuredClone=function(a){for(var b=new d,c=0;c<a.length;c++)b.push(f.fromStructuredClone(a[c])),0!==b[c].packets.length?b[c].packets=this.fromStructuredClone(b[c].packets):b[c].packets=new d;return b}},{"../enums.js":32,"./all_packets.js":42,"./packet.js":48}],50:[function(a,b,c){function d(){this.tag=h.packet.publicKey,this.version=4,this.created=new Date,this.mpi=[],this.algorithm="rsa_sign",this.expirationTimeV3=0,this.fingerprint=null,this.keyid=null}b.exports=d;var e=a("../util.js"),f=a("../type/mpi.js"),g=a("../type/keyid.js"),h=a("../enums.js"),i=a("../crypto");d.prototype.read=function(a){var b=0;if(this.version=a.charCodeAt(b++),3==this.version||4==this.version){this.created=e.readDate(a.substr(b,4)),b+=4,3==this.version&&(this.expirationTimeV3=e.readNumber(a.substr(b,2)),b+=2),this.algorithm=h.read(h.publicKey,a.charCodeAt(b++));var c=i.getPublicMpiCount(this.algorithm);this.mpi=[];for(var d=a.substr(b),g=0,j=0;c>j&&g<d.length;j++)if(this.mpi[j]=new f,g+=this.mpi[j].read(d.substr(g)),g>d.length)throw new Error("Error reading MPI @:"+g);return g+6}throw new Error("Version "+this.version+" of the key packet is unsupported.")},d.prototype.readPublicKey=d.prototype.read,d.prototype.write=function(){var a=String.fromCharCode(this.version);a+=e.writeDate(this.created),3==this.version&&(a+=e.writeNumber(this.expirationTimeV3,2)),a+=String.fromCharCode(h.write(h.publicKey,this.algorithm));for(var b=i.getPublicMpiCount(this.algorithm),c=0;b>c;c++)a+=this.mpi[c].write();return a},d.prototype.writePublicKey=d.prototype.write,d.prototype.writeOld=function(){var a=this.writePublicKey();return String.fromCharCode(153)+e.writeNumber(a.length,2)+a},d.prototype.getKeyId=function(){return this.keyid?this.keyid:(this.keyid=new g,4==this.version?this.keyid.read(e.hex2bin(this.getFingerprint()).substr(12,8)):3==this.version&&this.keyid.read(this.mpi[0].write().substr(-8)),this.keyid)},d.prototype.getFingerprint=function(){if(this.fingerprint)return this.fingerprint;var a="";if(4==this.version)a=this.writeOld(),this.fingerprint=i.hash.sha1(a);else if(3==this.version){for(var b=i.getPublicMpiCount(this.algorithm),c=0;b>c;c++)a+=this.mpi[c].toBytes();this.fingerprint=i.hash.md5(a)}return this.fingerprint=e.hexstrdump(this.fingerprint),this.fingerprint},d.prototype.getBitSize=function(){return 8*this.mpi[0].byteLength()},d.prototype.postCloneTypeFix=function(){for(var a=0;a<this.mpi.length;a++)this.mpi[a]=f.fromClone(this.mpi[a]);this.keyid&&(this.keyid=g.fromClone(this.keyid))}},{"../crypto":21,"../enums.js":32,"../type/keyid.js":62,"../type/mpi.js":63,"../util.js":65}],51:[function(a,b,c){function d(){this.tag=h.packet.publicKeyEncryptedSessionKey,this.version=3,this.publicKeyId=new e,this.publicKeyAlgorithm="rsa_encrypt",this.sessionKey=null,this.sessionKeyAlgorithm="aes256",this.encrypted=[]}b.exports=d;var e=a("../type/keyid.js"),f=a("../util.js"),g=a("../type/mpi.js"),h=a("../enums.js"),i=a("../crypto");d.prototype.read=function(a){this.version=a.charCodeAt(0),this.publicKeyId.read(a.substr(1)),this.publicKeyAlgorithm=h.read(h.publicKey,a.charCodeAt(9));var b=10,c=function(a){switch(a){case"rsa_encrypt":case"rsa_encrypt_sign":return 1;case"elgamal":return 2;default:throw new Error("Invalid algorithm.")}}(this.publicKeyAlgorithm);this.encrypted=[];for(var d=0;c>d;d++){var e=new g;b+=e.read(a.substr(b)),this.encrypted.push(e)}},d.prototype.write=function(){var a=String.fromCharCode(this.version);a+=this.publicKeyId.write(),a+=String.fromCharCode(h.write(h.publicKey,this.publicKeyAlgorithm));for(var b=0;b<this.encrypted.length;b++)a+=this.encrypted[b].write();return a},d.prototype.encrypt=function(a){var b=String.fromCharCode(h.write(h.symmetric,this.sessionKeyAlgorithm));b+=this.sessionKey;var c=f.calc_checksum(this.sessionKey);b+=f.writeNumber(c,2);var d=new g;d.fromBytes(i.pkcs1.eme.encode(b,a.mpi[0].byteLength())),this.encrypted=i.publicKeyEncrypt(this.publicKeyAlgorithm,a.mpi,d)},d.prototype.decrypt=function(a){var b=i.publicKeyDecrypt(this.publicKeyAlgorithm,a.mpi,this.encrypted).toBytes(),c=f.readNumber(b.substr(b.length-2)),d=i.pkcs1.eme.decode(b);if(a=d.substring(1,d.length-2),c!=f.calc_checksum(a))throw new Error("Checksum mismatch");this.sessionKey=a,this.sessionKeyAlgorithm=h.read(h.symmetric,d.charCodeAt(0))},d.prototype.postCloneTypeFix=function(){this.publicKeyId=e.fromClone(this.publicKeyId);for(var a=0;a<this.encrypted.length;a++)this.encrypted[a]=g.fromClone(this.encrypted[a])}},{"../crypto":21,"../enums.js":32,"../type/keyid.js":62,"../type/mpi.js":63,"../util.js":65}],52:[function(a,b,c){function d(){e.call(this),this.tag=f.packet.publicSubkey}b.exports=d;var e=a("./public_key.js"),f=a("../enums.js");d.prototype=new e,d.prototype.constructor=d},{"../enums.js":32,"./public_key.js":50}],53:[function(a,b,c){function d(){j.call(this),this.tag=k.packet.secretKey,this.encrypted=null,this.isDecrypted=!1}function e(a){return"sha1"==a?20:2}function f(a){return"sha1"==a?m.hash.sha1:function(a){return l.writeNumber(l.calc_checksum(a),2)}}function g(a,b,c){var d=e(a),g=f(a),h=b.substr(b.length-d);b=b.substr(0,b.length-d);var i=g(b);if(i!=h)return new Error("Hash mismatch.");for(var j=m.getPrivateMpiCount(c),k=0,l=[],o=0;j>o&&k<b.length;o++)l[o]=new n,k+=l[o].read(b.substr(k));return l}function h(a,b,c){for(var d="",e=m.getPublicMpiCount(b),g=e;g<c.length;g++)d+=c[g].write();return d+=f(a)(d)}function i(a,b,c){return a.produce_key(b,m.cipher[c].keySize)}b.exports=d;var j=a("./public_key.js"),k=a("../enums.js"),l=a("../util.js"),m=a("../crypto"),n=a("../type/mpi.js"),o=a("../type/s2k.js");d.prototype=new j,d.prototype.constructor=d,d.prototype.read=function(a){var b=this.readPublicKey(a);a=a.substr(b);var c=a.charCodeAt(0);if(c)this.encrypted=a;else{var d=g("mod",a.substr(1),this.algorithm);if(d instanceof Error)throw d;this.mpi=this.mpi.concat(d),this.isDecrypted=!0}},d.prototype.write=function(){var a=this.writePublicKey();return this.encrypted?a+=this.encrypted:(a+=String.fromCharCode(0),a+=h("mod",this.algorithm,this.mpi)),a},d.prototype.encrypt=function(a){if(this.isDecrypted&&!a)return void(this.encrypted=null);if(!a)throw new Error("The key must be decrypted before removing passphrase protection.");var b=new o,c="aes256",d=h("sha1",this.algorithm,this.mpi),e=i(b,a,c),f=m.cipher[c].blockSize,g=m.random.getRandomBytes(f);this.encrypted="",this.encrypted+=String.fromCharCode(254),this.encrypted+=String.fromCharCode(k.write(k.symmetric,c)),this.encrypted+=b.write(),this.encrypted+=g,this.encrypted+=m.cfb.normalEncrypt(c,e,d,g)},d.prototype.decrypt=function(a){if(this.isDecrypted)return!0;var b,c,d=0,e=this.encrypted.charCodeAt(d++);if(255==e||254==e){b=this.encrypted.charCodeAt(d++),b=k.read(k.symmetric,b);var f=new o;d+=f.read(this.encrypted.substr(d)),c=i(f,a,b)}else b=e,b=k.read(k.symmetric,b),c=m.hash.md5(a);var h=this.encrypted.substr(d,m.cipher[b].blockSize);d+=h.length;var j,l=this.encrypted.substr(d);j=m.cfb.normalDecrypt(b,c,l,h);var n=254==e?"sha1":"mod",p=g(n,j,this.algorithm);return p instanceof Error?!1:(this.mpi=this.mpi.concat(p),this.isDecrypted=!0,!0)},d.prototype.generate=function(a){var b=this;return m.generateMpi(b.algorithm,a).then(function(a){b.mpi=a,b.isDecrypted=!0})},d.prototype.clearPrivateMPIs=function(){if(!this.encrypted)throw new Error("If secret key is not encrypted, clearing private MPIs is irreversible.");this.mpi=this.mpi.slice(0,m.getPublicMpiCount(this.algorithm)),this.isDecrypted=!1}},{"../crypto":21,"../enums.js":32,"../type/mpi.js":63,"../type/s2k.js":64,"../util.js":65,"./public_key.js":50}],54:[function(a,b,c){function d(){e.call(this),this.tag=f.packet.secretSubkey}b.exports=d;var e=a("./secret_key.js"),f=a("../enums.js");d.prototype=new e,d.prototype.constructor=d},{"../enums.js":32,"./secret_key.js":53}],55:[function(a,b,c){function d(){this.tag=h.packet.signature,this.version=4,this.signatureType=null,this.hashAlgorithm=null,this.publicKeyAlgorithm=null,this.signatureData=null,this.unhashedSubpackets=null,this.signedHashValue=null,this.created=new Date,this.signatureExpirationTime=null,this.signatureNeverExpires=!0,this.exportable=null,this.trustLevel=null,this.trustAmount=null,this.regularExpression=null,this.revocable=null,this.keyExpirationTime=null,this.keyNeverExpires=null,this.preferredSymmetricAlgorithms=null,
	this.revocationKeyClass=null,this.revocationKeyAlgorithm=null,this.revocationKeyFingerprint=null,this.issuerKeyId=new k,this.notation=null,this.preferredHashAlgorithms=null,this.preferredCompressionAlgorithms=null,this.keyServerPreferences=null,this.preferredKeyServer=null,this.isPrimaryUserID=null,this.policyURI=null,this.keyFlags=null,this.signersUserId=null,this.reasonForRevocationFlag=null,this.reasonForRevocationString=null,this.features=null,this.signatureTargetPublicKeyAlgorithm=null,this.signatureTargetHashAlgorithm=null,this.signatureTargetHash=null,this.embeddedSignature=null,this.verified=!1}function e(a,b){var c="";return c+=g.writeSimpleLength(b.length+1),c+=String.fromCharCode(a),c+=b}b.exports=d;var f=a("../util.js"),g=a("./packet.js"),h=a("../enums.js"),i=a("../crypto"),j=a("../type/mpi.js"),k=a("../type/keyid.js");d.prototype.read=function(a){function b(a){for(var b=f.readNumber(a.substr(0,2)),c=2;2+b>c;){var d=g.readSimpleLength(a.substr(c));c+=d.offset,this.read_sub_packet(a.substr(c,d.len)),c+=d.len}return c}var c=0;switch(this.version=a.charCodeAt(c++),this.version){case 3:5!=a.charCodeAt(c++)&&f.print_debug("packet/signature.js\ninvalid One-octet length of following hashed material.MUST be 5. @:"+(c-1));var d=c;this.signatureType=a.charCodeAt(c++),this.created=f.readDate(a.substr(c,4)),c+=4,this.signatureData=a.substring(d,c),this.issuerKeyId.read(a.substring(c,c+8)),c+=8,this.publicKeyAlgorithm=a.charCodeAt(c++),this.hashAlgorithm=a.charCodeAt(c++);break;case 4:this.signatureType=a.charCodeAt(c++),this.publicKeyAlgorithm=a.charCodeAt(c++),this.hashAlgorithm=a.charCodeAt(c++),c+=b.call(this,a.substr(c),!0),this.signatureData=a.substr(0,c);var e=c;c+=b.call(this,a.substr(c),!1),this.unhashedSubpackets=a.substr(e,c-e);break;default:throw new Error("Version "+this.version+" of the signature is unsupported.")}this.signedHashValue=a.substr(c,2),c+=2,this.signature=a.substr(c)},d.prototype.write=function(){var a="";switch(this.version){case 3:a+=String.fromCharCode(3),a+=String.fromCharCode(5),a+=this.signatureData,a+=this.issuerKeyId.write(),a+=String.fromCharCode(this.publicKeyAlgorithm),a+=String.fromCharCode(this.hashAlgorithm);break;case 4:a+=this.signatureData,a+=this.unhashedSubpackets?this.unhashedSubpackets:f.writeNumber(0,2)}return a+=this.signedHashValue+this.signature},d.prototype.sign=function(a,b){var c=h.write(h.signature,this.signatureType),d=h.write(h.publicKey,this.publicKeyAlgorithm),e=h.write(h.hash,this.hashAlgorithm),f=String.fromCharCode(4);f+=String.fromCharCode(c),f+=String.fromCharCode(d),f+=String.fromCharCode(e),this.issuerKeyId=a.getKeyId(),f+=this.write_all_sub_packets(),this.signatureData=f;var g=this.calculateTrailer(),j=this.toSign(c,b)+this.signatureData+g,k=i.hash.digest(e,j);this.signedHashValue=k.substr(0,2),this.signature=i.signature.sign(e,d,a.mpi,j)},d.prototype.write_all_sub_packets=function(){var a=h.signatureSubpacket,b="",c="";if(null!==this.created&&(b+=e(a.signature_creation_time,f.writeDate(this.created))),null!==this.signatureExpirationTime&&(b+=e(a.signature_expiration_time,f.writeNumber(this.signatureExpirationTime,4))),null!==this.exportable&&(b+=e(a.exportable_certification,String.fromCharCode(this.exportable?1:0))),null!==this.trustLevel&&(c=String.fromCharCode(this.trustLevel)+String.fromCharCode(this.trustAmount),b+=e(a.trust_signature,c)),null!==this.regularExpression&&(b+=e(a.regular_expression,this.regularExpression)),null!==this.revocable&&(b+=e(a.revocable,String.fromCharCode(this.revocable?1:0))),null!==this.keyExpirationTime&&(b+=e(a.key_expiration_time,f.writeNumber(this.keyExpirationTime,4))),null!==this.preferredSymmetricAlgorithms&&(c=f.bin2str(this.preferredSymmetricAlgorithms),b+=e(a.preferred_symmetric_algorithms,c)),null!==this.revocationKeyClass&&(c=String.fromCharCode(this.revocationKeyClass),c+=String.fromCharCode(this.revocationKeyAlgorithm),c+=this.revocationKeyFingerprint,b+=e(a.revocation_key,c)),this.issuerKeyId.isNull()||(b+=e(a.issuer,this.issuerKeyId.write())),null!==this.notation)for(var d in this.notation)if(this.notation.hasOwnProperty(d)){var g=this.notation[d];c=String.fromCharCode(128),c+=String.fromCharCode(0),c+=String.fromCharCode(0),c+=String.fromCharCode(0),c+=f.writeNumber(d.length,2),c+=f.writeNumber(g.length,2),c+=d+g,b+=e(a.notation_data,c)}return null!==this.preferredHashAlgorithms&&(c=f.bin2str(this.preferredHashAlgorithms),b+=e(a.preferred_hash_algorithms,c)),null!==this.preferredCompressionAlgorithms&&(c=f.bin2str(this.preferredCompressionAlgorithms),b+=e(a.preferred_compression_algorithms,c)),null!==this.keyServerPreferences&&(c=f.bin2str(this.keyServerPreferences),b+=e(a.key_server_preferences,c)),null!==this.preferredKeyServer&&(b+=e(a.preferred_key_server,this.preferredKeyServer)),null!==this.isPrimaryUserID&&(b+=e(a.primary_user_id,String.fromCharCode(this.isPrimaryUserID?1:0))),null!==this.policyURI&&(b+=e(a.policy_uri,this.policyURI)),null!==this.keyFlags&&(c=f.bin2str(this.keyFlags),b+=e(a.key_flags,c)),null!==this.signersUserId&&(b+=e(a.signers_user_id,this.signersUserId)),null!==this.reasonForRevocationFlag&&(c=String.fromCharCode(this.reasonForRevocationFlag),c+=this.reasonForRevocationString,b+=e(a.reason_for_revocation,c)),null!==this.features&&(c=f.bin2str(this.features),b+=e(a.features,c)),null!==this.signatureTargetPublicKeyAlgorithm&&(c=String.fromCharCode(this.signatureTargetPublicKeyAlgorithm),c+=String.fromCharCode(this.signatureTargetHashAlgorithm),c+=this.signatureTargetHash,b+=e(a.signature_target,c)),null!==this.embeddedSignature&&(b+=e(a.embedded_signature,this.embeddedSignature.write())),b=f.writeNumber(b.length,2)+b},d.prototype.read_sub_packet=function(a){function b(a,b){this[a]=[];for(var c=0;c<b.length;c++)this[a].push(b.charCodeAt(c))}var c,e=0,g=127&a.charCodeAt(e++);switch(g){case 2:this.created=f.readDate(a.substr(e));break;case 3:c=f.readNumber(a.substr(e)),this.signatureNeverExpires=0===c,this.signatureExpirationTime=c;break;case 4:this.exportable=1==a.charCodeAt(e++);break;case 5:this.trustLevel=a.charCodeAt(e++),this.trustAmount=a.charCodeAt(e++);break;case 6:this.regularExpression=a.substr(e);break;case 7:this.revocable=1==a.charCodeAt(e++);break;case 9:c=f.readNumber(a.substr(e)),this.keyExpirationTime=c,this.keyNeverExpires=0===c;break;case 11:b.call(this,"preferredSymmetricAlgorithms",a.substr(e));break;case 12:this.revocationKeyClass=a.charCodeAt(e++),this.revocationKeyAlgorithm=a.charCodeAt(e++),this.revocationKeyFingerprint=a.substr(e,20);break;case 16:this.issuerKeyId.read(a.substr(e));break;case 20:if(128==a.charCodeAt(e)){e+=4;var h=f.readNumber(a.substr(e,2));e+=2;var j=f.readNumber(a.substr(e,2));e+=2;var k=a.substr(e,h),l=a.substr(e+h,j);this.notation=this.notation||{},this.notation[k]=l}else f.print_debug("Unsupported notation flag "+a.charCodeAt(e));break;case 21:b.call(this,"preferredHashAlgorithms",a.substr(e));break;case 22:b.call(this,"preferredCompressionAlgorithms",a.substr(e));break;case 23:b.call(this,"keyServerPreferencess",a.substr(e));break;case 24:this.preferredKeyServer=a.substr(e);break;case 25:this.isPrimaryUserID=0!==a[e++];break;case 26:this.policyURI=a.substr(e);break;case 27:b.call(this,"keyFlags",a.substr(e));break;case 28:this.signersUserId+=a.substr(e);break;case 29:this.reasonForRevocationFlag=a.charCodeAt(e++),this.reasonForRevocationString=a.substr(e);break;case 30:b.call(this,"features",a.substr(e));break;case 31:this.signatureTargetPublicKeyAlgorithm=a.charCodeAt(e++),this.signatureTargetHashAlgorithm=a.charCodeAt(e++);var m=i.getHashByteLength(this.signatureTargetHashAlgorithm);this.signatureTargetHash=a.substr(e,m);break;case 32:this.embeddedSignature=new d,this.embeddedSignature.read(a.substr(e));break;default:f.print_debug("Unknown signature subpacket type "+g+" @:"+e)}},d.prototype.toSign=function(a,b){var c=h.signature;switch(a){case c.binary:case c.text:return b.getBytes();case c.standalone:return"";case c.cert_generic:case c.cert_persona:case c.cert_casual:case c.cert_positive:case c.cert_revocation:var d,e;if(void 0!==b.userid)e=180,d=b.userid;else{if(void 0===b.userattribute)throw new Error("Either a userid or userattribute packet needs to be supplied for certification.");e=209,d=b.userattribute}var g=d.write();if(4==this.version)return this.toSign(c.key,b)+String.fromCharCode(e)+f.writeNumber(g.length,4)+g;if(3==this.version)return this.toSign(c.key,b)+g;break;case c.subkey_binding:case c.subkey_revocation:case c.key_binding:return this.toSign(c.key,b)+this.toSign(c.key,{key:b.bind});case c.key:if(void 0===b.key)throw new Error("Key packet is required for this signature.");return b.key.writeOld();case c.key_revocation:return this.toSign(c.key,b);case c.timestamp:return"";case c.third_party:throw new Error("Not implemented");default:throw new Error("Unknown signature type.")}},d.prototype.calculateTrailer=function(){var a="";return 3==this.version?a:(a+=String.fromCharCode(4),a+=String.fromCharCode(255),a+=f.writeNumber(this.signatureData.length,4))},d.prototype.verify=function(a,b){var c=h.write(h.signature,this.signatureType),d=h.write(h.publicKey,this.publicKeyAlgorithm),e=h.write(h.hash,this.hashAlgorithm),f=this.toSign(c,b),g=this.calculateTrailer(),k=0;d>0&&4>d?k=1:17==d&&(k=2);for(var l=[],m=0,n=0;k>n;n++)l[n]=new j,m+=l[n].read(this.signature.substr(m));return this.verified=i.signature.verify(d,e,l,a.mpi,f+this.signatureData+g),this.verified},d.prototype.isExpired=function(){return this.signatureNeverExpires?!1:Date.now()>this.created.getTime()+1e3*this.signatureExpirationTime},d.prototype.postCloneTypeFix=function(){this.issuerKeyId=k.fromClone(this.issuerKeyId)}},{"../crypto":21,"../enums.js":32,"../type/keyid.js":62,"../type/mpi.js":63,"../util.js":65,"./packet.js":48}],56:[function(a,b,c){function d(){this.tag=f.packet.symEncryptedIntegrityProtected,this.encrypted=null,this.modification=!1,this.packets=null}b.exports=d;var e=(a("../util.js"),a("../crypto")),f=a("../enums.js");d.prototype.read=function(a){var b=a.charCodeAt(0);if(1!=b)throw new Error("Invalid packet version.");this.encrypted=a.substr(1)},d.prototype.write=function(){return String.fromCharCode(1)+this.encrypted},d.prototype.encrypt=function(a,b){var c=this.packets.write(),d=e.getPrefixRandom(a),f=d+d.charAt(d.length-2)+d.charAt(d.length-1),g=c;g+=String.fromCharCode(211),g+=String.fromCharCode(20),g+=e.hash.sha1(f+g),this.encrypted=e.cfb.encrypt(d,a,g,b,!1),f.length+g.length!=this.encrypted.length&&(this.encrypted=this.encrypted.substring(0,f.length+g.length))},d.prototype.decrypt=function(a,b){var c=e.cfb.decrypt(a,b,this.encrypted,!1),d=c.slice(c.length-20,c.length).join("");if(c.splice(c.length-20),this.hash=e.hash.sha1(e.cfb.mdc(a,b,this.encrypted)+c.join("")),this.hash!=d)throw new Error("Modification detected.");c.splice(c.length-2),this.packets.read(c.join(""))}},{"../crypto":21,"../enums.js":32,"../util.js":65}],57:[function(a,b,c){function d(){this.tag=f.packet.symEncryptedSessionKey,this.version=4,this.sessionKeyEncryptionAlgorithm=null,this.sessionKeyAlgorithm="aes256",this.encrypted=null,this.s2k=new e}var e=a("../type/s2k.js"),f=a("../enums.js"),g=a("../crypto");b.exports=d,d.prototype.read=function(a){this.version=a.charCodeAt(0);var b=f.read(f.symmetric,a.charCodeAt(1)),c=this.s2k.read(a.substr(2)),d=c+2;d<a.length?(this.encrypted=a.substr(d),this.sessionKeyEncryptionAlgorithm=b):this.sessionKeyAlgorithm=b},d.prototype.write=function(){var a=null===this.encrypted?this.sessionKeyAlgorithm:this.sessionKeyEncryptionAlgorithm,b=String.fromCharCode(this.version)+String.fromCharCode(f.write(f.symmetric,a))+this.s2k.write();return null!==this.encrypted&&(b+=this.encrypted),b},d.prototype.decrypt=function(a){var b=null!==this.sessionKeyEncryptionAlgorithm?this.sessionKeyEncryptionAlgorithm:this.sessionKeyAlgorithm,c=g.cipher[b].keySize,d=this.s2k.produce_key(a,c);if(null===this.encrypted)this.sessionKey=d;else{var e=g.cfb.decrypt(this.sessionKeyEncryptionAlgorithm,d,this.encrypted,!0);e=e.join(""),this.sessionKeyAlgorithm=f.read(f.symmetric,e[0].keyCodeAt()),this.sessionKey=e.substr(1)}},d.prototype.encrypt=function(a){var b=g.getKeyLength(this.sessionKeyEncryptionAlgorithm),c=this.s2k.produce_key(a,b),d=String.fromCharCode(f.write(f.symmetric,this.sessionKeyAlgorithm))+g.getRandomBytes(g.getKeyLength(this.sessionKeyAlgorithm));this.encrypted=g.cfb.encrypt(g.getPrefixRandom(this.sessionKeyEncryptionAlgorithm),this.sessionKeyEncryptionAlgorithm,c,d,!0)},d.prototype.postCloneTypeFix=function(){this.s2k=e.fromClone(this.s2k)}},{"../crypto":21,"../enums.js":32,"../type/s2k.js":64}],58:[function(a,b,c){function d(){this.tag=f.packet.symmetricallyEncrypted,this.encrypted=null,this.packets=null,this.ignore_mdc_error=g.ignore_mdc_error}b.exports=d;var e=a("../crypto"),f=a("../enums.js"),g=a("../config");d.prototype.read=function(a){this.encrypted=a},d.prototype.write=function(){return this.encrypted},d.prototype.decrypt=function(a,b){var c=e.cfb.decrypt(a,b,this.encrypted,!0);if(!this.ignore_mdc_error&&("aes128"===a||"aes192"===a||"aes256"===a))throw new Error("Decryption failed due to missing MDC in combination with modern cipher.");this.packets.read(c.join(""))},d.prototype.encrypt=function(a,b){var c=this.packets.write();this.encrypted=e.cfb.encrypt(e.getPrefixRandom(a),a,c,b,!0)}},{"../config":6,"../crypto":21,"../enums.js":32}],59:[function(a,b,c){function d(){this.tag=e.packet.trust}b.exports=d;var e=a("../enums.js");d.prototype.read=function(a){}},{"../enums.js":32}],60:[function(a,b,c){function d(){this.tag=f.packet.userAttribute,this.attributes=[]}var e=(a("../util.js"),a("./packet.js")),f=a("../enums.js");b.exports=d,d.prototype.read=function(a){for(var b=0;b<a.length;){var c=e.readSimpleLength(a.substr(b));b+=c.offset,this.attributes.push(a.substr(b,c.len)),b+=c.len}},d.prototype.write=function(){for(var a="",b=0;b<this.attributes.length;b++)a+=e.writeSimpleLength(this.attributes[b].length),a+=this.attributes[b];return a},d.prototype.equals=function(a){return a&&a instanceof d?this.attributes.every(function(b,c){return b===a.attributes[c]}):!1}},{"../enums.js":32,"../util.js":65,"./packet.js":48}],61:[function(a,b,c){function d(){this.tag=f.packet.userid,this.userid=""}b.exports=d;var e=a("../util.js"),f=a("../enums.js");d.prototype.read=function(a){this.userid=e.decode_utf8(a)},d.prototype.write=function(){return e.encode_utf8(this.userid)}},{"../enums.js":32,"../util.js":65}],62:[function(a,b,c){function d(){this.bytes=""}b.exports=d;var e=a("../util.js");d.prototype.read=function(a){this.bytes=a.substr(0,8)},d.prototype.write=function(){return this.bytes},d.prototype.toHex=function(){return e.hexstrdump(this.bytes)},d.prototype.equals=function(a){return this.bytes==a.bytes},d.prototype.isNull=function(){return""===this.bytes},b.exports.mapToHex=function(a){return a.toHex()},b.exports.fromClone=function(a){var b=new d;return b.bytes=a.bytes,b},b.exports.fromId=function(a){var b=new d;return b.read(e.hex2bin(a)),b}},{"../util.js":65}],63:[function(a,b,c){function d(){this.data=null}b.exports=d;var e=a("../crypto/public_key/jsbn.js"),f=a("../util.js");d.prototype.read=function(a){var b=a.charCodeAt(0)<<8|a.charCodeAt(1),c=Math.ceil(b/8),d=a.substr(2,c);return this.fromBytes(d),2+c},d.prototype.fromBytes=function(a){this.data=new e(f.hexstrdump(a),16)},d.prototype.toBytes=function(){return this.write().substr(2)},d.prototype.byteLength=function(){return this.toBytes().length},d.prototype.write=function(){return this.data.toMPI()},d.prototype.toBigInteger=function(){return this.data.clone()},d.prototype.fromBigInteger=function(a){this.data=a.clone()},b.exports.fromClone=function(a){a.data.copyTo=e.prototype.copyTo;var b=new e;a.data.copyTo(b);var c=new d;return c.data=b,c}},{"../crypto/public_key/jsbn.js":26,"../util.js":65}],64:[function(a,b,c){function d(){this.algorithm="sha256",this.type="iterated",this.c=96,this.salt=g.random.getRandomBytes(8)}b.exports=d;var e=a("../enums.js"),f=a("../util.js"),g=a("../crypto");d.prototype.get_count=function(){var a=6;return 16+(15&this.c)<<(this.c>>4)+a},d.prototype.read=function(a){var b=0;switch(this.type=e.read(e.s2k,a.charCodeAt(b++)),this.algorithm=e.read(e.hash,a.charCodeAt(b++)),this.type){case"simple":break;case"salted":this.salt=a.substr(b,8),b+=8;break;case"iterated":this.salt=a.substr(b,8),b+=8,this.c=a.charCodeAt(b++);break;case"gnu":if("GNU"!=a.substr(b,3))throw new Error("Unknown s2k type.");b+=3;var c=1e3+a.charCodeAt(b++);if(1001!=c)throw new Error("Unknown s2k gnu protection mode.");this.type=c;break;default:throw new Error("Unknown s2k type.")}return b},d.prototype.write=function(){var a=String.fromCharCode(e.write(e.s2k,this.type));switch(a+=String.fromCharCode(e.write(e.hash,this.algorithm)),this.type){case"simple":break;case"salted":a+=this.salt;break;case"iterated":a+=this.salt,a+=String.fromCharCode(this.c);break;case"gnu":throw new Error("GNU s2k type not supported.");default:throw new Error("Unknown s2k type.")}return a},d.prototype.produce_key=function(a,b){function c(b,c){var d=e.write(e.hash,c.algorithm);switch(c.type){case"simple":return g.hash.digest(d,b+a);case"salted":return g.hash.digest(d,b+c.salt+a);case"iterated":for(var f=[],h=c.get_count(),i=c.salt+a;f.length*i.length<h;)f.push(i);return f=f.join(""),f.length>h&&(f=f.substr(0,h)),g.hash.digest(d,b+f);case"gnu":throw new Error("GNU s2k type not supported.");default:throw new Error("Unknown s2k type.")}}a=f.encode_utf8(a);for(var d="",h="";d.length<=b;)d+=c(h,this),h+=String.fromCharCode(0);return d.substr(0,b)},b.exports.fromClone=function(a){var b=new d;return this.algorithm=a.algorithm,this.type=a.type,this.c=a.c,this.salt=a.salt,b}},{"../crypto":21,"../enums.js":32,"../util.js":65}],65:[function(a,b,c){"use strict";var d=a("./config");b.exports={readNumber:function(a){for(var b=0,c=0;c<a.length;c++)b<<=8,b+=a.charCodeAt(c);return b},writeNumber:function(a,b){for(var c="",d=0;b>d;d++)c+=String.fromCharCode(a>>8*(b-d-1)&255);return c},readDate:function(a){var b=this.readNumber(a),c=new Date;return c.setTime(1e3*b),c},writeDate:function(a){var b=Math.round(a.getTime()/1e3);return this.writeNumber(b,4)},emailRegEx:/^[+a-zA-Z0-9_.-]+@([a-zA-Z0-9-]+\.)+[a-zA-Z0-9]{2,6}$/,hexdump:function(a){for(var b,c=[],d=a.length,e=0,f=0;d>e;){for(b=a.charCodeAt(e++).toString(16);b.length<2;)b="0"+b;c.push(" "+b),f++,f%32===0&&c.push("\n           ")}return c.join("")},hexstrdump:function(a){if(null===a)return"";for(var b,c=[],d=a.length,e=0;d>e;){for(b=a.charCodeAt(e++).toString(16);b.length<2;)b="0"+b;c.push(""+b)}return c.join("")},hex2bin:function(a){for(var b="",c=0;c<a.length;c+=2)b+=String.fromCharCode(parseInt(a.substr(c,2),16));return b},hexidump:function(a){for(var b,c=[],d=a.length,e=0;d>e;){for(b=a[e++].toString(16);b.length<2;)b="0"+b;c.push(""+b)}return c.join("")},encode_utf8:function(a){return unescape(encodeURIComponent(a))},decode_utf8:function(a){if("string"!=typeof a)throw new Error('Parameter "utf8" is not of type string');try{return decodeURIComponent(escape(a))}catch(b){return a}},bin2str:function(a){for(var b=[],c=0;c<a.length;c++)b[c]=String.fromCharCode(a[c]);return b.join("")},str2bin:function(a){for(var b=[],c=0;c<a.length;c++)b[c]=a.charCodeAt(c);return b},str2Uint8Array:function(a){for(var b=new Uint8Array(a.length),c=0;c<a.length;c++)b[c]=a.charCodeAt(c);return b},Uint8Array2str:function(a){for(var b=[],c=0;c<a.length;c++)b[c]=String.fromCharCode(a[c]);return b.join("")},calc_checksum:function(a){for(var b={s:0,add:function(a){this.s=(this.s+a)%65536}},c=0;c<a.length;c++)b.add(a.charCodeAt(c));return b.s},print_debug:function(a){d.debug&&console.log(a)},print_debug_hexstr_dump:function(a,b){d.debug&&(a+=this.hexstrdump(b),console.log(a))},getLeftNBits:function(a,b){var c=b%8;if(0===c)return a.substring(0,b/8);var d=(b-c)/8+1,e=a.substring(0,d);return this.shiftRight(e,8-c)},shiftRight:function(a,b){var c=util.str2bin(a);if(b%8===0)return a;for(var d=c.length-1;d>=0;d--)c[d]>>=b%8,d>0&&(c[d]|=c[d-1]<<8-b%8&255);return util.bin2str(c)},get_hashAlgorithmString:function(a){switch(a){case 1:return"MD5";case 2:return"SHA1";case 3:return"RIPEMD160";case 8:return"SHA256";case 9:return"SHA384";case 10:return"SHA512";case 11:return"SHA224"}return"unknown"},getWebCrypto:function(){if(d.useWebCrypto!==!1&&"undefined"!=typeof window){if(window.crypto)return window.crypto.subtle||window.crypto.webkitSubtle;if(window.msCrypto)return window.msCrypto.subtle}}}},{"./config":6}],66:[function(a,b,c){"use strict";function d(a,b){b&&b.worker?this.worker=b.worker:this.worker=new Worker(a||"openpgp.worker.js"),this.worker.onmessage=this.onMessage.bind(this),this.worker.onerror=function(a){throw new Error("Unhandled error in openpgp worker: "+a.message+" ("+a.filename+":"+a.lineno+")")},this.seedRandom(i),this.tasks=[],b&&b.config&&this.worker.postMessage({event:"configure",config:b.config})}var e=a("../crypto"),f=a("../packet"),g=a("../key.js"),h=a("../type/keyid.js"),i=5e4,j=2e4;d.prototype.execute=function(a){var b=this,c=new Promise(function(c,d){a(),b.tasks.push({resolve:c,reject:d})});return c},d.prototype.onMessage=function(a){var b=a.data;switch(b.event){case"method-return":b.err?this.tasks.shift().reject(new Error(b.err)):this.tasks.shift().resolve(b.data);break;case"request-seed":this.seedRandom(j);break;default:throw new Error("Unknown Worker Event.")}},d.prototype.seedRandom=function(a){var b=this.getRandomBuffer(a);this.worker.postMessage({event:"seed-random",buf:b})},d.prototype.getRandomBuffer=function(a){if(!a)return null;var b=new Uint8Array(a);return e.random.getRandomValues(b),b},d.prototype.terminate=function(){this.worker.terminate()},d.prototype.encryptMessage=function(a,b,c,d){var e=this;return e.execute(function(){a.length||(a=[a]),a=a.map(function(a){return a.toPacketlist()}),e.worker.postMessage({event:"encrypt-message",keys:a,text:b,format:c,filename:d})})},d.prototype.signAndEncryptMessage=function(a,b,c,d,e){var f=this;return f.execute(function(){a.length||(a=[a]),a=a.map(function(a){return a.toPacketlist()}),b=b.toPacketlist(),f.worker.postMessage({event:"sign-and-encrypt-message",publicKeys:a,privateKey:b,text:c,format:d,filename:e})})},d.prototype.decryptMessage=function(a,b,c){var d=this;return d.execute(function(){a=a.toPacketlist(),d.worker.postMessage({event:"decrypt-message",privateKey:a,message:b,format:c})})},d.prototype.decryptAndVerifyMessage=function(a,b,c,d){var e=this,f=new Promise(function(f,g){a=a.toPacketlist(),b.length||(b=[b]),b=b.map(function(a){return a.toPacketlist()}),e.worker.postMessage({event:"decrypt-and-verify-message",privateKey:a,publicKeys:b,message:c,format:d}),e.tasks.push({resolve:function(a){a.signatures=a.signatures.map(function(a){return a.keyid=h.fromClone(a.keyid),a}),f(a)},reject:g})});return f},d.prototype.signClearMessage=function(a,b){var c=this;return c.execute(function(){a.length||(a=[a]),a=a.map(function(a){return a.toPacketlist()}),c.worker.postMessage({event:"sign-clear-message",privateKeys:a,text:b})})},d.prototype.verifyClearSignedMessage=function(a,b){var c=this,d=new Promise(function(d,e){a.length||(a=[a]),a=a.map(function(a){return a.toPacketlist()}),c.worker.postMessage({event:"verify-clear-signed-message",publicKeys:a,message:b}),c.tasks.push({resolve:function(a){a.signatures=a.signatures.map(function(a){return a.keyid=h.fromClone(a.keyid),a}),d(a)},reject:e})});return d},d.prototype.generateKeyPair=function(a){var b=this,c=new Promise(function(c,d){b.worker.postMessage({event:"generate-key-pair",options:a}),b.tasks.push({resolve:function(a){var b=f.List.fromStructuredClone(a.key);a.key=new g.Key(b),c(a)},reject:d})});return c},d.prototype.decryptKey=function(a,b){var c=this,d=new Promise(function(d,e){a=a.toPacketlist(),c.worker.postMessage({event:"decrypt-key",privateKey:a,password:b}),c.tasks.push({resolve:function(a){var b=f.List.fromStructuredClone(a),a=new g.Key(b);d(a)},reject:e})});return d},d.prototype.decryptKeyPacket=function(a,b,c){var d=this,e=new Promise(function(e,h){a=a.toPacketlist(),d.worker.postMessage({event:"decrypt-key-packet",privateKey:a,keyIds:b,password:c}),d.tasks.push({resolve:function(a){var b=f.List.fromStructuredClone(a),a=new g.Key(b);e(a)},reject:h})});return e},b.exports=d},{"../crypto":21,"../key.js":36,"../packet":44,"../type/keyid.js":62}]},{},[35])(35)});

/***/ },
/* 23 */
/*!***********************************!*\
  !*** ./src/firefox/lib/window.js ***!
  \***********************************/
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var addonWindow = __webpack_require__(/*! sdk/addon/window */ 11);
	var ss = __webpack_require__(/*! sdk/simple-storage */ 1);

	function LocalStorage() {
	  this.storage = ss.storage;
	}

	LocalStorage.prototype.getItem = function(keyStr) {
	  return this.storage[keyStr] || null;
	};

	LocalStorage.prototype.setItem = function(keyStr, valueStr) {
	  this.storage[keyStr] = valueStr;
	};

	LocalStorage.prototype.removeItem = function(keyStr) {
	  delete this.storage[keyStr];
	};

	exports.crypto = addonWindow.window.crypto;

	exports.atob = addonWindow.window.atob.bind(addonWindow.window);

	exports.localStorage = new LocalStorage();


/***/ },
/* 24 */
/*!*********************************!*\
  !*** ./src/modules/defaults.js ***!
  \*********************************/
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Mailvelope - secure email with OpenPGP encryption for Webmail
	 * Copyright (C) 2012-2015 Mailvelope GmbH
	 *
	 * This program is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU Affero General Public License version 3
	 * as published by the Free Software Foundation.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU Affero General Public License for more details.
	 *
	 * You should have received a copy of the GNU Affero General Public License
	 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	'use strict';


	var mvelo = __webpack_require__(/*! lib-mvelo */ 8);
	var model = __webpack_require__(/*! ./pgpModel */ 21);
	var openpgp = __webpack_require__(/*! openpgp */ 22);
	var defaults = __webpack_require__(/*! ../res/defaults.json */ 25)

	function getRandomAngle() {
	  var angle = openpgp.crypto.random.getSecureRandom(0, 120) - 60;
	  if (angle < 0) {
	    angle += 360;
	  }
	  return angle;
	}

	function initSecurityBgnd(pref) {
	  pref.security.secureBgndScaling     = pref.security.secureBgndScaling    || (openpgp.crypto.random.getSecureRandom(9, 20) / 10);
	  pref.security.secureBgndWidth       = pref.security.secureBgndWidth      || 45;
	  pref.security.secureBgndHeight      = pref.security.secureBgndHeight     || 45;
	  pref.security.secureBgndColor       = pref.security.secureBgndColor      || defaults.preferences.security.secureBgndColor;
	  pref.security.secureBgndIconColor   = pref.security.secureBgndIconColor  || defaults.preferences.security.secureBgndIconColor;

	  if (typeof pref.security.secureBgndAngle === 'undefined') {
	    pref.security.secureBgndAngle = getRandomAngle();
	  }

	  if (typeof pref.security.secureBgndColorId === 'undefined') {
	    pref.security.secureBgndColorId = defaults.preferences.security.secureBgndColorId;
	  }
	}

	function init() {
	  var prefs = model.getPreferences();
	  if (!prefs) {
	    prefs = defaults.preferences;
	    prefs.version = defaults.version;
	    initSecurityBgnd(prefs);
	    model.setWatchList(defaults.watch_list);
	  } else {
	    if (prefs.version !== defaults.version) {
	      prefs.version = defaults.version;
	      prefs.general.editor_type = mvelo.PLAIN_TEXT;

	      initSecurityBgnd(prefs);

	      // add default values for new settings
	      if (typeof prefs.main_active == 'undefined') {
	        prefs.main_active = defaults.preferences.main_active;
	      }
	      if (typeof prefs.keyserver == 'undefined') {
	        prefs.keyserver = defaults.preferences.keyserver;
	      }
	      if (typeof prefs.keyserver.mvelo_tofu_lookup == 'undefined') {
	        prefs.keyserver.mvelo_tofu_lookup = defaults.preferences.keyserver.mvelo_tofu_lookup;
	      }

	      // merge watchlist on version change
	      mergeWatchlist(defaults);
	    }
	  }
	  model.setPreferences(prefs);
	}

	function mergeWatchlist(defaults) {
	  var mod = false;
	  var localList = model.getWatchList() || [];
	  defaults.watch_list.forEach(function(defaultSite) {
	    var localSite = localList.find(function(localSite) {
	      return localSite.site === defaultSite.site;
	    });
	    if (localSite) {
	      defaultSite.frames.forEach(function(defaultFrame) {
	        localSite.frames = localSite.frames || [];
	        var localFrame = localSite.frames.find(function(localFrame) {
	          return localFrame.frame === defaultFrame.frame;
	        });
	        if (!localFrame) {
	          localSite.frames.push(defaultFrame);
	          mod = true;
	        } else {
	          if (typeof localFrame.api === 'undefined') {
	            localFrame.api = false;
	            mod = true;
	          }
	        }
	      });
	    } else {
	      localList.push(defaultSite);
	      mod = true;
	    }
	  });
	  if (mod) {
	    model.setWatchList(localList);
	  }
	}

	function getVersion() {
	  return defaults.version;
	}

	exports.init = init;
	exports.getVersion = getVersion;


/***/ },
/* 25 */
/*!*******************************!*\
  !*** ./src/res/defaults.json ***!
  \*******************************/
/***/ function(module, exports) {

	module.exports = {
		"version": "1.7.0",
		"watch_list": [
			{
				"active": true,
				"site": "GMX",
				"frames": [
					{
						"scan": true,
						"frame": "*.gmx.net",
						"api": true
					},
					{
						"scan": true,
						"frame": "*.gmx.com",
						"api": true
					},
					{
						"scan": true,
						"frame": "*.gmx.co.uk",
						"api": true
					},
					{
						"scan": true,
						"frame": "*.gmx.fr",
						"api": true
					},
					{
						"scan": true,
						"frame": "*.gmx.es",
						"api": true
					}
				]
			},
			{
				"active": true,
				"site": "WEB.DE",
				"frames": [
					{
						"scan": true,
						"frame": "*.web.de",
						"api": true
					}
				]
			},
			{
				"active": true,
				"site": "mail.google.com",
				"frames": [
					{
						"scan": true,
						"frame": "*.mail.google.com",
						"api": false
					},
					{
						"scan": true,
						"frame": "*.inbox.google.com",
						"api": false
					}
				]
			},
			{
				"active": true,
				"site": "mail.live.com",
				"frames": [
					{
						"scan": true,
						"frame": "*.mail.live.com",
						"api": false
					},
					{
						"scan": true,
						"frame": "*.outlook.live.com",
						"api": false
					}
				]
			},
			{
				"active": true,
				"site": "mail.yahoo.com",
				"frames": [
					{
						"scan": true,
						"frame": "*.mail.yahoo.com",
						"api": false
					},
					{
						"scan": true,
						"frame": "*.mail.yahoo.net",
						"api": false
					}
				]
			},
			{
				"active": true,
				"site": "posteo.de",
				"frames": [
					{
						"scan": true,
						"frame": "*.posteo.de",
						"api": true
					}
				]
			},
			{
				"active": true,
				"site": "mailbox.org",
				"frames": [
					{
						"scan": true,
						"frame": "*.office.mailbox.org",
						"api": true
					}
				]
			},
			{
				"active": true,
				"site": "mail.ru",
				"frames": [
					{
						"scan": true,
						"frame": "*.mail.ru",
						"api": false
					}
				]
			},
			{
				"active": true,
				"site": "1und1 De-Mail",
				"frames": [
					{
						"scan": true,
						"frame": "*.de-mail.1und1.de",
						"api": true
					}
				]
			},
			{
				"active": true,
				"site": "GMX De-Mail",
				"frames": [
					{
						"scan": true,
						"frame": "*.de-mail.gmx.net",
						"api": true
					}
				]
			},
			{
				"active": true,
				"site": "Telekom De-Mail",
				"frames": [
					{
						"scan": true,
						"frame": "*.de-mail.t-online.de",
						"api": true
					}
				]
			},
			{
				"active": true,
				"site": "T-Systems De-Mail",
				"frames": [
					{
						"scan": true,
						"frame": "*.de-mail.t-systems.de",
						"api": true
					}
				]
			},
			{
				"active": true,
				"site": "WEB.DE De-Mail",
				"frames": [
					{
						"scan": true,
						"frame": "*.de-mail.web.de",
						"api": true
					}
				]
			},
			{
				"active": true,
				"site": "FP Mentana-Claimsoft De-Mail",
				"frames": [
					{
						"scan": true,
						"frame": "*.fp-demail.de",
						"api": true
					}
				]
			},
			{
				"active": true,
				"site": "Mailvelope Demo",
				"frames": [
					{
						"scan": true,
						"frame": "*.demo.mailvelope.com",
						"api": true
					}
				]
			},
			{
				"active": true,
				"site": "HKP Key Server",
				"frames": [
					{
						"scan": true,
						"frame": "*.keyserver.ubuntu.com",
						"api": false
					}
				]
			}
		],
		"preferences": {
			"security": {
				"display_decrypted": "inline",
				"secureBgndColor": "#f5f5f5",
				"secureBgndIconColor": "#e9e9e9",
				"secureBgndColorId": 0,
				"password_cache": true,
				"password_timeout": 30
			},
			"general": {
				"editor_type": "plain",
				"auto_add_primary": true,
				"auto_sign_msg": false
			},
			"keyserver": {
				"hkp_base_url": "https://keyserver.ubuntu.com",
				"mvelo_tofu_lookup": true
			},
			"main_active": true
		}
	};

/***/ },
/* 26 */
/*!******************************!*\
  !*** ./src/modules/prefs.js ***!
  \******************************/
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Mailvelope - secure email with OpenPGP encryption for Webmail
	 * Copyright (C) 2012-2015 Mailvelope GmbH
	 *
	 * This program is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU Affero General Public License version 3
	 * as published by the Free Software Foundation.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU Affero General Public License for more details.
	 *
	 * You should have received a copy of the GNU Affero General Public License
	 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	'use strict';


	var mvelo = __webpack_require__(/*! lib-mvelo */ 8);
	var model = __webpack_require__(/*! ./pgpModel */ 21);
	var prefs = null;
	var updateHandlers = [];

	function init() {
	  prefs = model.getPreferences();
	}

	/**
	 * Update preferences
	 * @param  {Object} obj preferences object or properties of it
	 */
	function update(obj) {
	  prefs = model.getPreferences();

	  if (obj.security) {
	    prefs.security = mvelo.util.extend(prefs.security, obj.security);
	  }
	  if (obj.general) {
	    prefs.general = mvelo.util.extend(prefs.general, obj.general);
	  }
	  if (obj.keyserver) {
	    prefs.keyserver = mvelo.util.extend(prefs.keyserver, obj.keyserver);
	  }
	  if (typeof obj.main_active !== 'undefined') {
	    prefs.main_active = obj.main_active;
	  }
	  model.setPreferences(prefs);
	  // notifiy update handlers
	  updateHandlers.forEach(function(fn) {
	    fn();
	  });
	}

	/**
	 * Register for preferences updates
	 * @param {Function} fn handler
	 */
	function addUpdateHandler(fn) {
	  updateHandlers.push(fn);
	}

	function data() {
	  return prefs;
	}

	exports.init = init;
	exports.update = update;
	exports.addUpdateHandler = addUpdateHandler;
	exports.data = data;


/***/ },
/* 27 */
/*!*********************************!*\
  !*** ./src/modules/pwdCache.js ***!
  \*********************************/
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Mailvelope - secure email with OpenPGP encryption for Webmail
	 * Copyright (C) 2012-2015 Mailvelope GmbH
	 *
	 * This program is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU Affero General Public License version 3
	 * as published by the Free Software Foundation.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU Affero General Public License for more details.
	 *
	 * You should have received a copy of the GNU Affero General Public License
	 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	'use strict';


	var mvelo = __webpack_require__(/*! lib-mvelo */ 8);
	var prefs = __webpack_require__(/*! ./prefs */ 26);
	var model = __webpack_require__(/*! ./pgpModel */ 21);

	// password and key cache
	var cache;
	// caching active
	var active;
	// timeout in minutes
	var timeout;
	// max. number of operations per key
	var RATE_LIMIT = 1000;

	function init() {
	  active = prefs.data().security.password_cache;
	  timeout = prefs.data().security.password_timeout;
	  cache = {};
	  // register for updates
	  prefs.addUpdateHandler(update);
	}

	function clearTimeouts() {
	  // clear timeout functions
	  for (var entry in cache) {
	    if (cache.hasOwnProperty(entry)) {
	      mvelo.util.clearTimeout(entry.timer);
	    }
	  }
	}

	function update() {
	  if (active != prefs.data().security.password_cache ||
	      timeout != prefs.data().security.password_timeout) {
	    // init cache
	    clearTimeouts();
	    cache = {};
	    active = prefs.data().security.password_cache;
	    timeout = prefs.data().security.password_timeout;
	  }
	}

	/**
	 * Get password and unlocked key from cache
	 * @param  {String} primkeyid primary key id
	 * @param  {String} keyid     requested unlocked key
	 * @return {Object}           password of key, if available unlocked key for keyid
	 */
	function get(primkeyid, keyid) {
	  if (cache[primkeyid]) {
	    cache[primkeyid].operations--;
	    if (cache[primkeyid].operations) {
	      return {
	        password: cache[primkeyid].password,
	        key: cache[primkeyid][keyid]
	      };
	    } else {
	      // number of allowed operations exhausted
	      delete cache[primkeyid];
	    }
	  }
	}

	/**
	 * Return true if key is cached
	 * @param  {String}  primkeyid primary key id
	 * @return {Boolean}           true if cached
	 */
	function isCached(primkeyid) {
	  return Boolean(cache[primkeyid]);
	}

	/**
	 * Delete key from cache
	 * @param  {String} primkeyid primary key id
	 */
	function deleteEntry(primkeyid) {
	  delete cache[primkeyid];
	}

	/**
	 * Set key and password in cache, start timeout
	 * @param {Object} message
	 * @param {String} [message.keyid] - key ID of key that should be cached
	 * @param {openpgp.key.Key} message.key - private key, packet of keyid expected unlocked
	 * @param {String} message.pwd - password
	 * @param {Number} [message.cacheTime] - timeout in minutes
	 */
	function set(message, pwd, cacheTime) {
	  // primary key id is main key of cache
	  var primKeyIdHex = message.key.primaryKey.getKeyId().toHex();
	  var entry = cache[primKeyIdHex];
	  if (entry) {
	    // set unlocked private key for this keyid
	    if (message.keyid && !entry[message.keyid]) {
	      entry[message.keyid] = message.key;
	    }
	  } else {
	    var newEntry = cache[primKeyIdHex] = {};
	    newEntry.password = pwd;
	    if (message.keyid) {
	      newEntry[message.keyid] = message.key;
	    }
	    // clear after timeout
	    newEntry.timer = mvelo.util.setTimeout(function() {
	      delete cache[primKeyIdHex];
	    }, (cacheTime || timeout) * 60 * 1000);
	    // set max. number of operations
	    newEntry.operations = RATE_LIMIT;
	  }
	}

	/**
	 * Unlocked key if required and update cache
	 * @param {Object} options
	 * @param {openpgp.key.Key} options.key - key to unlock
	 * @param {String} options.keyid - keyid of required key packet
	 * @param {String} options.password - password to unlock key
	 * @return {Promise<undefined, Error>}
	 */
	function unlock(options) {
	  return model.unlockKey(options.key, options.keyid, options.password)
	    .then(function(key) {
	      options.key = key;
	      // set unlocked key in cache
	      set(options);
	    })
	    .catch(function() {
	      throw {
	        message: 'Password caching does not support different passphrases for primary key and subkeys'
	      };
	    });
	}

	exports.init = init;
	exports.get = get;
	exports.isCached = isCached;
	exports.delete = deleteEntry;
	exports.set = set;
	exports.unlock = unlock;


/***/ },
/* 28 */
/*!*******************************!*\
  !*** ./src/modules/crypto.js ***!
  \*******************************/
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Mailvelope - secure email with OpenPGP encryption for Webmail
	 * Copyright (C) 2015 Mailvelope GmbH
	 *
	 * This program is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU Affero General Public License version 3
	 * as published by the Free Software Foundation.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU Affero General Public License for more details.
	 *
	 * You should have received a copy of the GNU Affero General Public License
	 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	'use strict';


	var mvelo = __webpack_require__(/*! lib-mvelo */ 8);

	function randomString(length) {
	  var result = '';
	  var base = 32;
	  var buf = new Uint8Array(length);
	  mvelo.util.getDOMWindow().crypto.getRandomValues(buf);
	  for (var i = 0; i < buf.length; i++) {
	    result += (buf[i] % base).toString(base);
	  }
	  return result;
	}

	exports.randomString = randomString;


/***/ },
/* 29 */
/*!******************************!*\
  !*** ./src/modules/uiLog.js ***!
  \******************************/
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Mailvelope - secure email with OpenPGP encryption for Webmail
	 * Copyright (C) 2015 Mailvelope GmbH
	 *
	 * This program is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU Affero General Public License version 3
	 * as published by the Free Software Foundation.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU Affero General Public License for more details.
	 *
	 * You should have received a copy of the GNU Affero General Public License
	 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	'use strict';


	var mvelo = __webpack_require__(/*! lib-mvelo */ 8);
	var l10n = mvelo.l10n.get;

	var log = [];
	var logTimer = 0;

	/**
	 * @param {String} source = 'security_log_editor' <br>
	 *                 source = 'security_log_key_generator' <br>
	 *                 source = 'security_log_key_backup' <br>
	 *                 source = 'security_log_email_viewer' <br>
	 *                 source = 'security_log_password_dialog' <br>
	 *                 source = 'security_log_import_dialog' <br>
	 *                 source = 'security_log_verify_dialog' <br>
	 *                 source = 'security_log_sign_dialog' <br>
	 *                 source = 'security_log_encrypt_dialog' <br>
	 * @param {String} type = 'security_log_textarea_input' <br>
	 *                 type = 'security_log_textarea_select' <br>
	 *                 type = 'security_log_textarea_click' <br>
	 *                 type = 'security_log_text_input' <br>
	 *                 type = 'security_log_password_input' <br>
	 *                 type = 'security_log_restore_backup_click' <br>
	 *                 type = 'security_log_password_click' <br>
	 *                 type = 'security_log_attachment_added' <br>
	 *                 type = 'security_log_attachment_download' <br>
	 *                 type = 'security_log_add_attachment' <br>
	 *                 type = 'security_log_remove_attachment' <br>
	 *                 type = 'security_log_backup_create' <br>
	 *                 type = 'security_log_backup_restore' <br>
	 *                 type = 'security_log_backup_code_input' <br>
	 *                 type = 'security_log_dialog_ok' <br>
	 *                 type = 'security_log_dialog_cancel' <br>
	 *                 type = 'security_log_dialog_undo' <br>
	 *                 type = 'security_log_dialog_transfer' <br>
	 *                 type = 'security_log_dialog_sign' <br>
	 *                 type = 'security_log_dialog_encrypt' <br>
	 *                 type = 'security_log_content_copy' <br>
	 *                 type = 'security_log_signature_modal_open' <br>
	 *                 type = 'security_log_signature_modal_close' <br>
	 */
	function push(source, type) {
	  var entry = {
	    source: source,
	    sourcei18n: l10n(source),
	    type: type,
	    typei18n: l10n(type) || type,
	    timestamp: (new Date()).toISOString()
	  };
	  var lastEntry = log[log.length - 1];
	  if (lastEntry &&
	      source === lastEntry.source &&
	      type === lastEntry.type &&
	      (type === 'security_log_textarea_input' || type === 'security_log_password_input')) {
	    // aggregate text input events
	    log[log.length - 1] = entry;
	  } else {
	    log.push(entry);
	  }
	  if (logTimer) {
	    mvelo.util.clearTimeout(logTimer);
	  } else {
	    setBadge();
	  }
	  logTimer = mvelo.util.setTimeout(clearBadge, 2000);
	}

	function setBadge() {
	  mvelo.browserAction.state({
	    badge: 'Ok',
	    badgeColor: '#29A000'
	  });
	}

	function clearBadge() {
	  logTimer = 0;
	  mvelo.browserAction.state({
	    badge: ''
	  });
	}

	function getAll() {
	  return log;
	}

	function getLatest(size) {
	  log.slice(-size);
	}

	exports.push = push;
	exports.getAll = getAll;
	exports.getLatest = getLatest;


/***/ },
/* 30 */
/*!******************************************************************!*\
  !*** ./src/modules/closure-library/closure/goog/emailaddress.js ***!
  \******************************************************************/
/***/ function(module, exports, __webpack_require__) {

	var __WEBPACK_AMD_DEFINE_RESULT__;// Copyright 2010 The Closure Library Authors. All Rights Reserved.
	//
	// Licensed under the Apache License, Version 2.0 (the "License");
	// you may not use this file except in compliance with the License.
	// You may obtain a copy of the License at
	//
	//      http://www.apache.org/licenses/LICENSE-2.0
	//
	// Unless required by applicable law or agreed to in writing, software
	// distributed under the License is distributed on an "AS-IS" BASIS,
	// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	// See the License for the specific language governing permissions and
	// limitations under the License.

	/**
	 * @fileoverview Provides functions to parse and manipulate email addresses.
	 *
	 */

	!(__WEBPACK_AMD_DEFINE_RESULT__ = function (require, exports, module) {

	var goog = {};

	goog.string = __webpack_require__(/*! ./string */ 31).goog.string;

	goog.format = {};

	/**
	 * Formats an email address string for display, and allows for extraction of
	 * The individual componants of the address.
	 * @param {string=} opt_address The email address.
	 * @param {string=} opt_name The name associated with the email address.
	 * @constructor
	 */
	goog.format.EmailAddress = function(opt_address, opt_name) {
	  /**
	   * The name or personal string associated with the address.
	   * @type {string}
	   * @private
	   */
	  this.name_ = opt_name || '';

	  /**
	   * The email address.
	   * @type {string}
	   * @private
	   */
	  this.address_ = opt_address || '';
	};


	/**
	 * Match string for opening tokens.
	 * @type {string}
	 * @private
	 */
	goog.format.EmailAddress.OPENERS_ = '"<([';


	/**
	 * Match string for closing tokens.
	 * @type {string}
	 * @private
	 */
	goog.format.EmailAddress.CLOSERS_ = '">)]';


	/**
	 * A RegExp to check special characters to be quoted.  Used in cleanAddress().
	 * @type {RegExp}
	 * @private
	 */
	goog.format.EmailAddress.SPECIAL_CHARS_RE_ = /[()<>@,;:\\\".\[\]]/;


	/**
	 * A RegExp to match all double quotes.  Used in cleanAddress().
	 * @type {RegExp}
	 * @private
	 */
	goog.format.EmailAddress.ALL_DOUBLE_QUOTES_ = /\"/g;


	/**
	 * A RegExp to match escaped double quotes.  Used in parse().
	 * @type {RegExp}
	 * @private
	 */
	goog.format.EmailAddress.ESCAPED_DOUBLE_QUOTES_ = /\\\"/g;


	/**
	 * A RegExp to match all backslashes.  Used in cleanAddress().
	 * @type {RegExp}
	 * @private
	 */
	goog.format.EmailAddress.ALL_BACKSLASHES_ = /\\/g;


	/**
	 * A RegExp to match escaped backslashes.  Used in parse().
	 * @type {RegExp}
	 * @private
	 */
	goog.format.EmailAddress.ESCAPED_BACKSLASHES_ = /\\\\/g;

	/**
	 * A string representing the RegExp for the local part of an email address.
	 * @private {string}
	 */
	goog.format.EmailAddress.LOCAL_PART_REGEXP_STR_ =
	    '[+a-zA-Z0-9_.!#$%&\'*\\/=?^`{|}~-]+';


	/**
	 * A string representing the RegExp for the domain part of an email address.
	 * @private {string}
	 */
	goog.format.EmailAddress.DOMAIN_PART_REGEXP_STR_ =
	    '([a-zA-Z0-9-]+\\.)+[a-zA-Z0-9]{2,63}';


	/**
	 * A RegExp to match the local part of an email address.
	 * @private {!RegExp}
	 */
	goog.format.EmailAddress.LOCAL_PART_ =
	    new RegExp('^' + goog.format.EmailAddress.LOCAL_PART_REGEXP_STR_ + '$');


	/**
	 * A RegExp to match the domain part of an email address.
	 * @private {!RegExp}
	 */
	goog.format.EmailAddress.DOMAIN_PART_ =
	    new RegExp('^' + goog.format.EmailAddress.DOMAIN_PART_REGEXP_STR_ + '$');


	/**
	 * A RegExp to match an email address.
	 * @private {!RegExp}
	 */
	goog.format.EmailAddress.EMAIL_ADDRESS_ = new RegExp(
	    '^' + goog.format.EmailAddress.LOCAL_PART_REGEXP_STR_ + '@' +
	    goog.format.EmailAddress.DOMAIN_PART_REGEXP_STR_ + '$');


	/**
	 * Get the name associated with the email address.
	 * @return {string} The name or personal portion of the address.
	 */
	goog.format.EmailAddress.prototype.getName = function() {
	  return this.name_;
	};


	/**
	 * Get the email address.
	 * @return {string} The email address.
	 */
	goog.format.EmailAddress.prototype.getAddress = function() {
	  return this.address_;
	};


	/**
	 * Set the name associated with the email address.
	 * @param {string} name The name to associate.
	 */
	goog.format.EmailAddress.prototype.setName = function(name) {
	  this.name_ = name;
	};


	/**
	 * Set the email address.
	 * @param {string} address The email address.
	 */
	goog.format.EmailAddress.prototype.setAddress = function(address) {
	  this.address_ = address;
	};


	/**
	 * Return the address in a standard format:
	 *  - remove extra spaces.
	 *  - Surround name with quotes if it contains special characters.
	 * @return {string} The cleaned address.
	 */
	goog.format.EmailAddress.prototype.toString = function() {
	  var name = this.getName();

	  // We intentionally remove double quotes in the name because escaping
	  // them to \" looks ugly.
	  name = name.replace(goog.format.EmailAddress.ALL_DOUBLE_QUOTES_, '');

	  // If the name has special characters, we need to quote it and escape \'s.
	  var quoteNeeded = goog.format.EmailAddress.SPECIAL_CHARS_RE_.test(name);
	  if (quoteNeeded) {
	    name = '"' +
	        name.replace(goog.format.EmailAddress.ALL_BACKSLASHES_, '\\\\') + '"';
	  }

	  if (name == '') {
	    return this.address_;
	  }
	  if (this.address_ == '') {
	    return name;
	  }
	  return name + ' <' + this.address_ + '>';
	};


	/**
	 * Determines is the current object is a valid email address.
	 * @return {boolean} Whether the email address is valid.
	 */
	goog.format.EmailAddress.prototype.isValid = function() {
	  return goog.format.EmailAddress.isValidAddrSpec(this.address_);
	};


	/**
	 * Checks if the provided string is a valid email address. Supports both
	 * simple email addresses (address specs) and addresses that contain display
	 * names.
	 * @param {string} str The email address to check.
	 * @return {boolean} Whether the provided string is a valid address.
	 */
	goog.format.EmailAddress.isValidAddress = function(str) {
	  return goog.format.EmailAddress.parse(str).isValid();
	};


	/**
	 * Checks if the provided string is a valid address spec (local@domain.com).
	 * @param {string} str The email address to check.
	 * @return {boolean} Whether the provided string is a valid address spec.
	 */
	goog.format.EmailAddress.isValidAddrSpec = function(str) {
	  // This is a fairly naive implementation, but it covers 99% of use cases.
	  // For more details, see http://en.wikipedia.org/wiki/Email_address#Syntax
	  return goog.format.EmailAddress.EMAIL_ADDRESS_.test(str);
	};


	/**
	 * Parse an email address of the form "name" &lt;address&gt; into
	 * an email address.
	 * @param {string} addr The address string.
	 * @return {goog.format.EmailAddress} The parsed address.
	 */
	goog.format.EmailAddress.parse = function(addr) {
	  // TODO(ecattell): Strip bidi markers.
	  var name = '';
	  var address = '';
	  for (var i = 0; i < addr.length;) {
	    var token = goog.format.EmailAddress.getToken_(addr, i);
	    if (token.charAt(0) == '<' && token.indexOf('>') != -1) {
	      var end = token.indexOf('>');
	      address = token.substring(1, end);
	    } else if (address == '') {
	      name += token;
	    }
	    i += token.length;
	  }

	  // Check if it's a simple email address of the form "jlim@google.com".
	  if (address == '' && name.indexOf('@') != -1) {
	    address = name;
	    name = '';
	  }

	  name = goog.string.collapseWhitespace(name);
	  name = goog.string.stripQuotes(name, '\'');
	  name = goog.string.stripQuotes(name, '"');
	  // Replace escaped quotes and slashes.
	  name = name.replace(goog.format.EmailAddress.ESCAPED_DOUBLE_QUOTES_, '"');
	  name = name.replace(goog.format.EmailAddress.ESCAPED_BACKSLASHES_, '\\');
	  address = goog.string.collapseWhitespace(address);
	  return new goog.format.EmailAddress(address, name);
	};


	/**
	 * Parse a string containing email addresses of the form
	 * "name" &lt;address&gt; into an array of email addresses.
	 * @param {string} str The address list.
	 * @return {Array.<goog.format.EmailAddress>} The parsed emails.
	 */
	goog.format.EmailAddress.parseList = function(str) {
	  var result = [];
	  var email = '';
	  var token;

	  for (var i = 0; i < str.length; ) {
	    token = goog.format.EmailAddress.getToken_(str, i);
	    if (token == ',' || token == ';') {
	      if (!goog.string.isEmpty(email)) {
	        result.push(goog.format.EmailAddress.parse(email));
	      }
	      email = '';
	      i++;
	      continue;
	    }
	    email += token;
	    i += token.length;
	  }

	  // Add the final token.
	  if (!goog.string.isEmpty(email)) {
	    result.push(goog.format.EmailAddress.parse(email));
	  }
	  return result;
	};


	/**
	 * Get the next token from a position in an address string.
	 * @param {string} str the string.
	 * @param {number} pos the position.
	 * @return {string} the token.
	 * @private
	 */
	goog.format.EmailAddress.getToken_ = function(str, pos) {
	  var ch = str.charAt(pos);
	  var p = goog.format.EmailAddress.OPENERS_.indexOf(ch);
	  if (p == -1) {
	    return ch;
	  }
	  if (goog.format.EmailAddress.isEscapedDlQuote_(str, pos)) {

	    // If an opener is an escaped quote we do not treat it as a real opener
	    // and keep accumulating the token.
	    return ch;
	  }
	  var closerChar = goog.format.EmailAddress.CLOSERS_.charAt(p);
	  var endPos = str.indexOf(closerChar, pos + 1);

	  // If the closer is a quote we go forward skipping escaped quotes until we
	  // hit the real closing one.
	  while (endPos >= 0 &&
	         goog.format.EmailAddress.isEscapedDlQuote_(str, endPos)) {
	    endPos = str.indexOf(closerChar, endPos + 1);
	  }
	  var token = (endPos >= 0) ? str.substring(pos, endPos + 1) : ch;
	  return token;
	};


	/**
	 * Checks if the character in the current position is an escaped double quote
	 * ( \" ).
	 * @param {string} str the string.
	 * @param {number} pos the position.
	 * @return {boolean} true if the char is escaped double quote.
	 * @private
	 */
	goog.format.EmailAddress.isEscapedDlQuote_ = function(str, pos) {
	  if (str.charAt(pos) != '"') {
	    return false;
	  }
	  var slashCount = 0;
	  for (var idx = pos - 1; idx >= 0 && str.charAt(idx) == '\\'; idx--) {
	    slashCount++;
	  }
	  return ((slashCount % 2) != 0);
	};

	  exports.goog = goog;

	}.call(exports, __webpack_require__, exports, module), __WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));


/***/ },
/* 31 */
/*!************************************************************!*\
  !*** ./src/modules/closure-library/closure/goog/string.js ***!
  \************************************************************/
/***/ function(module, exports, __webpack_require__) {

	var __WEBPACK_AMD_DEFINE_RESULT__;// Copyright 2006 The Closure Library Authors. All Rights Reserved.
	//
	// Licensed under the Apache License, Version 2.0 (the "License");
	// you may not use this file except in compliance with the License.
	// You may obtain a copy of the License at
	//
	//      http://www.apache.org/licenses/LICENSE-2.0
	//
	// Unless required by applicable law or agreed to in writing, software
	// distributed under the License is distributed on an "AS-IS" BASIS,
	// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	// See the License for the specific language governing permissions and
	// limitations under the License.

	/**
	 * @fileoverview Utilities for string manipulation.
	 */


	!(__WEBPACK_AMD_DEFINE_RESULT__ = function (require, exports, module) {

	var goog = {};

	goog.string = {};

	/**
	 * Common Unicode string characters.
	 * @enum {string}
	 */
	goog.string.Unicode = {
	  NBSP: '\xa0'
	};


	/**
	 * Fast prefix-checker.
	 * @param {string} str The string to check.
	 * @param {string} prefix A string to look for at the start of {@code str}.
	 * @return {boolean} True if {@code str} begins with {@code prefix}.
	 */
	goog.string.startsWith = function(str, prefix) {
	  return str.lastIndexOf(prefix, 0) == 0;
	};


	/**
	 * Fast suffix-checker.
	 * @param {string} str The string to check.
	 * @param {string} suffix A string to look for at the end of {@code str}.
	 * @return {boolean} True if {@code str} ends with {@code suffix}.
	 */
	goog.string.endsWith = function(str, suffix) {
	  var l = str.length - suffix.length;
	  return l >= 0 && str.indexOf(suffix, l) == l;
	};


	/**
	 * Case-insensitive prefix-checker.
	 * @param {string} str The string to check.
	 * @param {string} prefix  A string to look for at the end of {@code str}.
	 * @return {boolean} True if {@code str} begins with {@code prefix} (ignoring
	 *     case).
	 */
	goog.string.caseInsensitiveStartsWith = function(str, prefix) {
	  return goog.string.caseInsensitiveCompare(
	      prefix, str.substr(0, prefix.length)) == 0;
	};


	/**
	 * Case-insensitive suffix-checker.
	 * @param {string} str The string to check.
	 * @param {string} suffix A string to look for at the end of {@code str}.
	 * @return {boolean} True if {@code str} ends with {@code suffix} (ignoring
	 *     case).
	 */
	goog.string.caseInsensitiveEndsWith = function(str, suffix) {
	  return goog.string.caseInsensitiveCompare(
	      suffix, str.substr(str.length - suffix.length, suffix.length)) == 0;
	};


	/**
	 * Does simple python-style string substitution.
	 * subs("foo%s hot%s", "bar", "dog") becomes "foobar hotdog".
	 * @param {string} str The string containing the pattern.
	 * @param {...*} var_args The items to substitute into the pattern.
	 * @return {string} A copy of {@code str} in which each occurrence of
	 *     {@code %s} has been replaced an argument from {@code var_args}.
	 */
	goog.string.subs = function(str, var_args) {
	  // This appears to be slow, but testing shows it compares more or less
	  // equivalent to the regex.exec method.
	  for (var i = 1; i < arguments.length; i++) {
	    // We cast to String in case an argument is a Function.  Replacing $&, for
	    // example, with $$$& stops the replace from subsituting the whole match
	    // into the resultant string.  $$$& in the first replace becomes $$& in the
	    //  second, which leaves $& in the resultant string.  Also:
	    // $$, $`, $', $n $nn
	    var replacement = String(arguments[i]).replace(/\$/g, '$$$$');
	    str = str.replace(/\%s/, replacement);
	  }
	  return str;
	};


	/**
	 * Converts multiple whitespace chars (spaces, non-breaking-spaces, new lines
	 * and tabs) to a single space, and strips leading and trailing whitespace.
	 * @param {string} str Input string.
	 * @return {string} A copy of {@code str} with collapsed whitespace.
	 */
	goog.string.collapseWhitespace = function(str) {
	  // Since IE doesn't include non-breaking-space (0xa0) in their \s character
	  // class (as required by section 7.2 of the ECMAScript spec), we explicitly
	  // include it in the regexp to enforce consistent cross-browser behavior.
	  return str.replace(/[\s\xa0]+/g, ' ').replace(/^\s+|\s+$/g, '');
	};


	/**
	 * Checks if a string is empty or contains only whitespaces.
	 * @param {string} str The string to check.
	 * @return {boolean} True if {@code str} is empty or whitespace only.
	 */
	goog.string.isEmpty = function(str) {
	  // testing length == 0 first is actually slower in all browsers (about the
	  // same in Opera).
	  // Since IE doesn't include non-breaking-space (0xa0) in their \s character
	  // class (as required by section 7.2 of the ECMAScript spec), we explicitly
	  // include it in the regexp to enforce consistent cross-browser behavior.
	  return /^[\s\xa0]*$/.test(str);
	};


	/**
	 * Checks if a string is null, empty or contains only whitespaces.
	 * @param {*} str The string to check.
	 * @return {boolean} True if{@code str} is null, empty, or whitespace only.
	 */
	goog.string.isEmptySafe = function(str) {
	  return goog.string.isEmpty(goog.string.makeSafe(str));
	};


	/**
	 * Checks if a string is all breaking whitespace.
	 * @param {string} str The string to check.
	 * @return {boolean} Whether the string is all breaking whitespace.
	 */
	goog.string.isBreakingWhitespace = function(str) {
	  return !/[^\t\n\r ]/.test(str);
	};


	/**
	 * Checks if a string contains all letters.
	 * @param {string} str string to check.
	 * @return {boolean} True if {@code str} consists entirely of letters.
	 */
	goog.string.isAlpha = function(str) {
	  return !/[^a-zA-Z]/.test(str);
	};


	/**
	 * Checks if a string contains only numbers.
	 * @param {*} str string to check. If not a string, it will be
	 *     casted to one.
	 * @return {boolean} True if {@code str} is numeric.
	 */
	goog.string.isNumeric = function(str) {
	  return !/[^0-9]/.test(str);
	};


	/**
	 * Checks if a string contains only numbers or letters.
	 * @param {string} str string to check.
	 * @return {boolean} True if {@code str} is alphanumeric.
	 */
	goog.string.isAlphaNumeric = function(str) {
	  return !/[^a-zA-Z0-9]/.test(str);
	};


	/**
	 * Checks if a character is a space character.
	 * @param {string} ch Character to check.
	 * @return {boolean} True if {code ch} is a space.
	 */
	goog.string.isSpace = function(ch) {
	  return ch == ' ';
	};


	/**
	 * Checks if a character is a valid unicode character.
	 * @param {string} ch Character to check.
	 * @return {boolean} True if {code ch} is a valid unicode character.
	 */
	goog.string.isUnicodeChar = function(ch) {
	  return ch.length == 1 && ch >= ' ' && ch <= '~' ||
	         ch >= '\u0080' && ch <= '\uFFFD';
	};


	/**
	 * Takes a string and replaces newlines with a space. Multiple lines are
	 * replaced with a single space.
	 * @param {string} str The string from which to strip newlines.
	 * @return {string} A copy of {@code str} stripped of newlines.
	 */
	goog.string.stripNewlines = function(str) {
	  return str.replace(/(\r\n|\r|\n)+/g, ' ');
	};


	/**
	 * Replaces Windows and Mac new lines with unix style: \r or \r\n with \n.
	 * @param {string} str The string to in which to canonicalize newlines.
	 * @return {string} {@code str} A copy of {@code} with canonicalized newlines.
	 */
	goog.string.canonicalizeNewlines = function(str) {
	  return str.replace(/(\r\n|\r|\n)/g, '\n');
	};


	/**
	 * Normalizes whitespace in a string, replacing all whitespace chars with
	 * a space.
	 * @param {string} str The string in which to normalize whitespace.
	 * @return {string} A copy of {@code str} with all whitespace normalized.
	 */
	goog.string.normalizeWhitespace = function(str) {
	  return str.replace(/\xa0|\s/g, ' ');
	};


	/**
	 * Normalizes spaces in a string, replacing all consecutive spaces and tabs
	 * with a single space. Replaces non-breaking space with a space.
	 * @param {string} str The string in which to normalize spaces.
	 * @return {string} A copy of {@code str} with all consecutive spaces and tabs
	 *    replaced with a single space.
	 */
	goog.string.normalizeSpaces = function(str) {
	  return str.replace(/\xa0|[ \t]+/g, ' ');
	};


	/**
	 * Removes the breaking spaces from the left and right of the string and
	 * collapses the sequences of breaking spaces in the middle into single spaces.
	 * The original and the result strings render the same way in HTML.
	 * @param {string} str A string in which to collapse spaces.
	 * @return {string} Copy of the string with normalized breaking spaces.
	 */
	goog.string.collapseBreakingSpaces = function(str) {
	  return str.replace(/[\t\r\n ]+/g, ' ').replace(
	      /^[\t\r\n ]+|[\t\r\n ]+$/g, '');
	};


	/**
	 * Trims white spaces to the left and right of a string.
	 * @param {string} str The string to trim.
	 * @return {string} A trimmed copy of {@code str}.
	 */
	goog.string.trim = function(str) {
	  // Since IE doesn't include non-breaking-space (0xa0) in their \s character
	  // class (as required by section 7.2 of the ECMAScript spec), we explicitly
	  // include it in the regexp to enforce consistent cross-browser behavior.
	  return str.replace(/^[\s\xa0]+|[\s\xa0]+$/g, '');
	};


	/**
	 * Trims whitespaces at the left end of a string.
	 * @param {string} str The string to left trim.
	 * @return {string} A trimmed copy of {@code str}.
	 */
	goog.string.trimLeft = function(str) {
	  // Since IE doesn't include non-breaking-space (0xa0) in their \s character
	  // class (as required by section 7.2 of the ECMAScript spec), we explicitly
	  // include it in the regexp to enforce consistent cross-browser behavior.
	  return str.replace(/^[\s\xa0]+/, '');
	};


	/**
	 * Trims whitespaces at the right end of a string.
	 * @param {string} str The string to right trim.
	 * @return {string} A trimmed copy of {@code str}.
	 */
	goog.string.trimRight = function(str) {
	  // Since IE doesn't include non-breaking-space (0xa0) in their \s character
	  // class (as required by section 7.2 of the ECMAScript spec), we explicitly
	  // include it in the regexp to enforce consistent cross-browser behavior.
	  return str.replace(/[\s\xa0]+$/, '');
	};


	/**
	 * A string comparator that ignores case.
	 * -1 = str1 less than str2
	 *  0 = str1 equals str2
	 *  1 = str1 greater than str2
	 *
	 * @param {string} str1 The string to compare.
	 * @param {string} str2 The string to compare {@code str1} to.
	 * @return {number} The comparator result, as described above.
	 */
	goog.string.caseInsensitiveCompare = function(str1, str2) {
	  var test1 = String(str1).toLowerCase();
	  var test2 = String(str2).toLowerCase();

	  if (test1 < test2) {
	    return -1;
	  } else if (test1 == test2) {
	    return 0;
	  } else {
	    return 1;
	  }
	};


	/**
	 * Regular expression used for splitting a string into substrings of fractional
	 * numbers, integers, and non-numeric characters.
	 * @type {RegExp}
	 * @private
	 */
	goog.string.numerateCompareRegExp_ = /(\.\d+)|(\d+)|(\D+)/g;


	/**
	 * String comparison function that handles numbers in a way humans might expect.
	 * Using this function, the string "File 2.jpg" sorts before "File 10.jpg". The
	 * comparison is mostly case-insensitive, though strings that are identical
	 * except for case are sorted with the upper-case strings before lower-case.
	 *
	 * This comparison function is significantly slower (about 500x) than either
	 * the default or the case-insensitive compare. It should not be used in
	 * time-critical code, but should be fast enough to sort several hundred short
	 * strings (like filenames) with a reasonable delay.
	 *
	 * @param {string} str1 The string to compare in a numerically sensitive way.
	 * @param {string} str2 The string to compare {@code str1} to.
	 * @return {number} less than 0 if str1 < str2, 0 if str1 == str2, greater than
	 *     0 if str1 > str2.
	 */
	goog.string.numerateCompare = function(str1, str2) {
	  if (str1 == str2) {
	    return 0;
	  }
	  if (!str1) {
	    return -1;
	  }
	  if (!str2) {
	    return 1;
	  }

	  // Using match to split the entire string ahead of time turns out to be faster
	  // for most inputs than using RegExp.exec or iterating over each character.
	  var tokens1 = str1.toLowerCase().match(goog.string.numerateCompareRegExp_);
	  var tokens2 = str2.toLowerCase().match(goog.string.numerateCompareRegExp_);

	  var count = Math.min(tokens1.length, tokens2.length);

	  for (var i = 0; i < count; i++) {
	    var a = tokens1[i];
	    var b = tokens2[i];

	    // Compare pairs of tokens, returning if one token sorts before the other.
	    if (a != b) {

	      // Only if both tokens are integers is a special comparison required.
	      // Decimal numbers are sorted as strings (e.g., '.09' < '.1').
	      var num1 = parseInt(a, 10);
	      if (!isNaN(num1)) {
	        var num2 = parseInt(b, 10);
	        if (!isNaN(num2) && num1 - num2) {
	          return num1 - num2;
	        }
	      }
	      return a < b ? -1 : 1;
	    }
	  }

	  // If one string is a substring of the other, the shorter string sorts first.
	  if (tokens1.length != tokens2.length) {
	    return tokens1.length - tokens2.length;
	  }

	  // The two strings must be equivalent except for case (perfect equality is
	  // tested at the head of the function.) Revert to default ASCII-betical string
	  // comparison to stablize the sort.
	  return str1 < str2 ? -1 : 1;
	};


	/**
	 * URL-encodes a string
	 * @param {*} str The string to url-encode.
	 * @return {string} An encoded copy of {@code str} that is safe for urls.
	 *     Note that '#', ':', and other characters used to delimit portions
	 *     of URLs *will* be encoded.
	 */
	goog.string.urlEncode = function(str) {
	  return encodeURIComponent(String(str));
	};


	/**
	 * URL-decodes the string. We need to specially handle '+'s because
	 * the javascript library doesn't convert them to spaces.
	 * @param {string} str The string to url decode.
	 * @return {string} The decoded {@code str}.
	 */
	goog.string.urlDecode = function(str) {
	  return decodeURIComponent(str.replace(/\+/g, ' '));
	};


	/**
	 * Converts \n to <br>s or <br />s.
	 * @param {string} str The string in which to convert newlines.
	 * @param {boolean=} opt_xml Whether to use XML compatible tags.
	 * @return {string} A copy of {@code str} with converted newlines.
	 */
	goog.string.newLineToBr = function(str, opt_xml) {
	  return str.replace(/(\r\n|\r|\n)/g, opt_xml ? '<br />' : '<br>');
	};


	/**
	 * Escape double quote '"' characters in addition to '&', '<', and '>' so that a
	 * string can be included in an HTML tag attribute value within double quotes.
	 *
	 * It should be noted that > doesn't need to be escaped for the HTML or XML to
	 * be valid, but it has been decided to escape it for consistency with other
	 * implementations.
	 *
	 * NOTE(user):
	 * HtmlEscape is often called during the generation of large blocks of HTML.
	 * Using statics for the regular expressions and strings is an optimization
	 * that can more than half the amount of time IE spends in this function for
	 * large apps, since strings and regexes both contribute to GC allocations.
	 *
	 * Testing for the presence of a character before escaping increases the number
	 * of function calls, but actually provides a speed increase for the average
	 * case -- since the average case often doesn't require the escaping of all 4
	 * characters and indexOf() is much cheaper than replace().
	 * The worst case does suffer slightly from the additional calls, therefore the
	 * opt_isLikelyToContainHtmlChars option has been included for situations
	 * where all 4 HTML entities are very likely to be present and need escaping.
	 *
	 * Some benchmarks (times tended to fluctuate +-0.05ms):
	 *                                     FireFox                     IE6
	 * (no chars / average (mix of cases) / all 4 chars)
	 * no checks                     0.13 / 0.22 / 0.22         0.23 / 0.53 / 0.80
	 * indexOf                       0.08 / 0.17 / 0.26         0.22 / 0.54 / 0.84
	 * indexOf + re test             0.07 / 0.17 / 0.28         0.19 / 0.50 / 0.85
	 *
	 * An additional advantage of checking if replace actually needs to be called
	 * is a reduction in the number of object allocations, so as the size of the
	 * application grows the difference between the various methods would increase.
	 *
	 * @param {string} str string to be escaped.
	 * @param {boolean=} opt_isLikelyToContainHtmlChars Don't perform a check to see
	 *     if the character needs replacing - use this option if you expect each of
	 *     the characters to appear often. Leave false if you expect few html
	 *     characters to occur in your strings, such as if you are escaping HTML.
	 * @return {string} An escaped copy of {@code str}.
	 */
	goog.string.htmlEscape = function(str, opt_isLikelyToContainHtmlChars) {

	  if (opt_isLikelyToContainHtmlChars) {
	    return str.replace(goog.string.amperRe_, '&amp;')
	          .replace(goog.string.ltRe_, '&lt;')
	          .replace(goog.string.gtRe_, '&gt;')
	          .replace(goog.string.quotRe_, '&quot;');

	  } else {
	    // quick test helps in the case when there are no chars to replace, in
	    // worst case this makes barely a difference to the time taken
	    if (!goog.string.allRe_.test(str)) return str;

	    // str.indexOf is faster than regex.test in this case
	    if (str.indexOf('&') != -1) {
	      str = str.replace(goog.string.amperRe_, '&amp;');
	    }
	    if (str.indexOf('<') != -1) {
	      str = str.replace(goog.string.ltRe_, '&lt;');
	    }
	    if (str.indexOf('>') != -1) {
	      str = str.replace(goog.string.gtRe_, '&gt;');
	    }
	    if (str.indexOf('"') != -1) {
	      str = str.replace(goog.string.quotRe_, '&quot;');
	    }
	    return str;
	  }
	};


	/**
	 * Regular expression that matches an ampersand, for use in escaping.
	 * @type {RegExp}
	 * @private
	 */
	goog.string.amperRe_ = /&/g;


	/**
	 * Regular expression that matches a less than sign, for use in escaping.
	 * @type {RegExp}
	 * @private
	 */
	goog.string.ltRe_ = /</g;


	/**
	 * Regular expression that matches a greater than sign, for use in escaping.
	 * @type {RegExp}
	 * @private
	 */
	goog.string.gtRe_ = />/g;


	/**
	 * Regular expression that matches a double quote, for use in escaping.
	 * @type {RegExp}
	 * @private
	 */
	goog.string.quotRe_ = /\"/g;


	/**
	 * Regular expression that matches any character that needs to be escaped.
	 * @type {RegExp}
	 * @private
	 */
	goog.string.allRe_ = /[&<>\"]/;


	/**
	 * Unescapes an HTML string.
	 *
	 * @param {string} str The string to unescape.
	 * @return {string} An unescaped copy of {@code str}.
	 */
	goog.string.unescapeEntities = function(str) {
	  if (goog.string.contains(str, '&')) {
	    // We are careful not to use a DOM if we do not have one. We use the []
	    // notation so that the JSCompiler will not complain about these objects and
	    // fields in the case where we have no DOM.
	    if ('document' in goog.global) {
	      return goog.string.unescapeEntitiesUsingDom_(str);
	    } else {
	      // Fall back on pure XML entities
	      return goog.string.unescapePureXmlEntities_(str);
	    }
	  }
	  return str;
	};


	/**
	 * Unescapes an HTML string using a DOM to resolve non-XML, non-numeric
	 * entities. This function is XSS-safe and whitespace-preserving.
	 * @private
	 * @param {string} str The string to unescape.
	 * @return {string} The unescaped {@code str} string.
	 */
	goog.string.unescapeEntitiesUsingDom_ = function(str) {
	  var seen = {'&amp;': '&', '&lt;': '<', '&gt;': '>', '&quot;': '"'};
	  var div = document.createElement('div');
	  // Match as many valid entity characters as possible. If the actual entity
	  // happens to be shorter, it will still work as innerHTML will return the
	  // trailing characters unchanged. Since the entity characters do not include
	  // open angle bracket, there is no chance of XSS from the innerHTML use.
	  // Since no whitespace is passed to innerHTML, whitespace is preserved.
	  return str.replace(goog.string.HTML_ENTITY_PATTERN_, function(s, entity) {
	    // Check for cached entity.
	    var value = seen[s];
	    if (value) {
	      return value;
	    }
	    // Check for numeric entity.
	    if (entity.charAt(0) == '#') {
	      // Prefix with 0 so that hex entities (e.g. &#x10) parse as hex numbers.
	      var n = Number('0' + entity.substr(1));
	      if (!isNaN(n)) {
	        value = String.fromCharCode(n);
	      }
	    }
	    // Fall back to innerHTML otherwise.
	    if (!value) {
	      // Append a non-entity character to avoid a bug in Webkit that parses
	      // an invalid entity at the end of innerHTML text as the empty string.
	      div.innerHTML = s + ' ';
	      // Then remove the trailing character from the result.
	      value = div.firstChild.nodeValue.slice(0, -1);
	    }
	    // Cache and return.
	    return seen[s] = value;
	  });
	};


	/**
	 * Unescapes XML entities.
	 * @private
	 * @param {string} str The string to unescape.
	 * @return {string} An unescaped copy of {@code str}.
	 */
	goog.string.unescapePureXmlEntities_ = function(str) {
	  return str.replace(/&([^;]+);/g, function(s, entity) {
	    switch (entity) {
	      case 'amp':
	        return '&';
	      case 'lt':
	        return '<';
	      case 'gt':
	        return '>';
	      case 'quot':
	        return '"';
	      default:
	        if (entity.charAt(0) == '#') {
	          // Prefix with 0 so that hex entities (e.g. &#x10) parse as hex.
	          var n = Number('0' + entity.substr(1));
	          if (!isNaN(n)) {
	            return String.fromCharCode(n);
	          }
	        }
	        // For invalid entities we just return the entity
	        return s;
	    }
	  });
	};


	/**
	 * Regular expression that matches an HTML entity.
	 * See also HTML5: Tokenization / Tokenizing character references.
	 * @private
	 * @type {!RegExp}
	 */
	goog.string.HTML_ENTITY_PATTERN_ = /&([^;\s<&]+);?/g;


	/**
	 * Do escaping of whitespace to preserve spatial formatting. We use character
	 * entity #160 to make it safer for xml.
	 * @param {string} str The string in which to escape whitespace.
	 * @param {boolean=} opt_xml Whether to use XML compatible tags.
	 * @return {string} An escaped copy of {@code str}.
	 */
	goog.string.whitespaceEscape = function(str, opt_xml) {
	  return goog.string.newLineToBr(str.replace(/  /g, ' &#160;'), opt_xml);
	};


	/**
	 * Strip quote characters around a string.  The second argument is a string of
	 * characters to treat as quotes.  This can be a single character or a string of
	 * multiple character and in that case each of those are treated as possible
	 * quote characters. For example:
	 *
	 * <pre>
	 * goog.string.stripQuotes('"abc"', '"`') --> 'abc'
	 * goog.string.stripQuotes('`abc`', '"`') --> 'abc'
	 * </pre>
	 *
	 * @param {string} str The string to strip.
	 * @param {string} quoteChars The quote characters to strip.
	 * @return {string} A copy of {@code str} without the quotes.
	 */
	goog.string.stripQuotes = function(str, quoteChars) {
	  var length = quoteChars.length;
	  for (var i = 0; i < length; i++) {
	    var quoteChar = length == 1 ? quoteChars : quoteChars.charAt(i);
	    if (str.charAt(0) == quoteChar && str.charAt(str.length - 1) == quoteChar) {
	      return str.substring(1, str.length - 1);
	    }
	  }
	  return str;
	};


	/**
	 * Truncates a string to a certain length and adds '...' if necessary.  The
	 * length also accounts for the ellipsis, so a maximum length of 10 and a string
	 * 'Hello World!' produces 'Hello W...'.
	 * @param {string} str The string to truncate.
	 * @param {number} chars Max number of characters.
	 * @param {boolean=} opt_protectEscapedCharacters Whether to protect escaped
	 *     characters from being cut off in the middle.
	 * @return {string} The truncated {@code str} string.
	 */
	goog.string.truncate = function(str, chars, opt_protectEscapedCharacters) {
	  if (opt_protectEscapedCharacters) {
	    str = goog.string.unescapeEntities(str);
	  }

	  if (str.length > chars) {
	    str = str.substring(0, chars - 3) + '...';
	  }

	  if (opt_protectEscapedCharacters) {
	    str = goog.string.htmlEscape(str);
	  }

	  return str;
	};


	/**
	 * Truncate a string in the middle, adding "..." if necessary,
	 * and favoring the beginning of the string.
	 * @param {string} str The string to truncate the middle of.
	 * @param {number} chars Max number of characters.
	 * @param {boolean=} opt_protectEscapedCharacters Whether to protect escaped
	 *     characters from being cutoff in the middle.
	 * @param {number=} opt_trailingChars Optional number of trailing characters to
	 *     leave at the end of the string, instead of truncating as close to the
	 *     middle as possible.
	 * @return {string} A truncated copy of {@code str}.
	 */
	goog.string.truncateMiddle = function(str, chars,
	    opt_protectEscapedCharacters, opt_trailingChars) {
	  if (opt_protectEscapedCharacters) {
	    str = goog.string.unescapeEntities(str);
	  }

	  if (opt_trailingChars && str.length > chars) {
	    if (opt_trailingChars > chars) {
	      opt_trailingChars = chars;
	    }
	    var endPoint = str.length - opt_trailingChars;
	    var startPoint = chars - opt_trailingChars;
	    str = str.substring(0, startPoint) + '...' + str.substring(endPoint);
	  } else if (str.length > chars) {
	    // Favor the beginning of the string:
	    var half = Math.floor(chars / 2);
	    var endPos = str.length - half;
	    half += chars % 2;
	    str = str.substring(0, half) + '...' + str.substring(endPos);
	  }

	  if (opt_protectEscapedCharacters) {
	    str = goog.string.htmlEscape(str);
	  }

	  return str;
	};


	/**
	 * Special chars that need to be escaped for goog.string.quote.
	 * @private
	 * @type {Object}
	 */
	goog.string.specialEscapeChars_ = {
	  '\0': '\\0',
	  '\b': '\\b',
	  '\f': '\\f',
	  '\n': '\\n',
	  '\r': '\\r',
	  '\t': '\\t',
	  '\x0B': '\\x0B', // '\v' is not supported in JScript
	  '"': '\\"',
	  '\\': '\\\\'
	};


	/**
	 * Character mappings used internally for goog.string.escapeChar.
	 * @private
	 * @type {Object}
	 */
	goog.string.jsEscapeCache_ = {
	  '\'': '\\\''
	};


	/**
	 * Encloses a string in double quotes and escapes characters so that the
	 * string is a valid JS string.
	 * @param {string} s The string to quote.
	 * @return {string} A copy of {@code s} surrounded by double quotes.
	 */
	goog.string.quote = function(s) {
	  s = String(s);
	  if (s.quote) {
	    return s.quote();
	  } else {
	    var sb = ['"'];
	    for (var i = 0; i < s.length; i++) {
	      var ch = s.charAt(i);
	      var cc = ch.charCodeAt(0);
	      sb[i + 1] = goog.string.specialEscapeChars_[ch] ||
	          ((cc > 31 && cc < 127) ? ch : goog.string.escapeChar(ch));
	    }
	    sb.push('"');
	    return sb.join('');
	  }
	};


	/**
	 * Takes a string and returns the escaped string for that character.
	 * @param {string} str The string to escape.
	 * @return {string} An escaped string representing {@code str}.
	 */
	goog.string.escapeString = function(str) {
	  var sb = [];
	  for (var i = 0; i < str.length; i++) {
	    sb[i] = goog.string.escapeChar(str.charAt(i));
	  }
	  return sb.join('');
	};


	/**
	 * Takes a character and returns the escaped string for that character. For
	 * example escapeChar(String.fromCharCode(15)) -> "\\x0E".
	 * @param {string} c The character to escape.
	 * @return {string} An escaped string representing {@code c}.
	 */
	goog.string.escapeChar = function(c) {
	  if (c in goog.string.jsEscapeCache_) {
	    return goog.string.jsEscapeCache_[c];
	  }

	  if (c in goog.string.specialEscapeChars_) {
	    return goog.string.jsEscapeCache_[c] = goog.string.specialEscapeChars_[c];
	  }

	  var rv = c;
	  var cc = c.charCodeAt(0);
	  if (cc > 31 && cc < 127) {
	    rv = c;
	  } else {
	    // tab is 9 but handled above
	    if (cc < 256) {
	      rv = '\\x';
	      if (cc < 16 || cc > 256) {
	        rv += '0';
	      }
	    } else {
	      rv = '\\u';
	      if (cc < 4096) { // \u1000
	        rv += '0';
	      }
	    }
	    rv += cc.toString(16).toUpperCase();
	  }

	  return goog.string.jsEscapeCache_[c] = rv;
	};


	/**
	 * Takes a string and creates a map (Object) in which the keys are the
	 * characters in the string. The value for the key is set to true. You can
	 * then use goog.object.map or goog.array.map to change the values.
	 * @param {string} s The string to build the map from.
	 * @return {Object} The map of characters used.
	 */
	// TODO(arv): It seems like we should have a generic goog.array.toMap. But do
	//            we want a dependency on goog.array in goog.string?
	goog.string.toMap = function(s) {
	  var rv = {};
	  for (var i = 0; i < s.length; i++) {
	    rv[s.charAt(i)] = true;
	  }
	  return rv;
	};


	/**
	 * Checks whether a string contains a given substring.
	 * @param {string} s The string to test.
	 * @param {string} ss The substring to test for.
	 * @return {boolean} True if {@code s} contains {@code ss}.
	 */
	goog.string.contains = function(s, ss) {
	  return s.indexOf(ss) != -1;
	};


	/**
	 * Returns the non-overlapping occurrences of ss in s.
	 * If either s or ss evalutes to false, then returns zero.
	 * @param {string} s The string to look in.
	 * @param {string} ss The string to look for.
	 * @return {number} Number of occurrences of ss in s.
	 */
	goog.string.countOf = function(s, ss) {
	  return s && ss ? s.split(ss).length - 1 : 0;
	};


	/**
	 * Removes a substring of a specified length at a specific
	 * index in a string.
	 * @param {string} s The base string from which to remove.
	 * @param {number} index The index at which to remove the substring.
	 * @param {number} stringLength The length of the substring to remove.
	 * @return {string} A copy of {@code s} with the substring removed or the full
	 *     string if nothing is removed or the input is invalid.
	 */
	goog.string.removeAt = function(s, index, stringLength) {
	  var resultStr = s;
	  // If the index is greater or equal to 0 then remove substring
	  if (index >= 0 && index < s.length && stringLength > 0) {
	    resultStr = s.substr(0, index) +
	        s.substr(index + stringLength, s.length - index - stringLength);
	  }
	  return resultStr;
	};


	/**
	 *  Removes the first occurrence of a substring from a string.
	 *  @param {string} s The base string from which to remove.
	 *  @param {string} ss The string to remove.
	 *  @return {string} A copy of {@code s} with {@code ss} removed or the full
	 *      string if nothing is removed.
	 */
	goog.string.remove = function(s, ss) {
	  var re = new RegExp(goog.string.regExpEscape(ss), '');
	  return s.replace(re, '');
	};


	/**
	 *  Removes all occurrences of a substring from a string.
	 *  @param {string} s The base string from which to remove.
	 *  @param {string} ss The string to remove.
	 *  @return {string} A copy of {@code s} with {@code ss} removed or the full
	 *      string if nothing is removed.
	 */
	goog.string.removeAll = function(s, ss) {
	  var re = new RegExp(goog.string.regExpEscape(ss), 'g');
	  return s.replace(re, '');
	};


	/**
	 * Escapes characters in the string that are not safe to use in a RegExp.
	 * @param {*} s The string to escape. If not a string, it will be casted
	 *     to one.
	 * @return {string} A RegExp safe, escaped copy of {@code s}.
	 */
	goog.string.regExpEscape = function(s) {
	  return String(s).replace(/([-()\[\]{}+?*.$\^|,:#<!\\])/g, '\\$1').
	      replace(/\x08/g, '\\x08');
	};


	/**
	 * Repeats a string n times.
	 * @param {string} string The string to repeat.
	 * @param {number} length The number of times to repeat.
	 * @return {string} A string containing {@code length} repetitions of
	 *     {@code string}.
	 */
	goog.string.repeat = function(string, length) {
	  return new Array(length + 1).join(string);
	};


	/**
	 * Pads number to given length and optionally rounds it to a given precision.
	 * For example:
	 * <pre>padNumber(1.25, 2, 3) -> '01.250'
	 * padNumber(1.25, 2) -> '01.25'
	 * padNumber(1.25, 2, 1) -> '01.3'
	 * padNumber(1.25, 0) -> '1.25'</pre>
	 *
	 * @param {number} num The number to pad.
	 * @param {number} length The desired length.
	 * @param {number=} opt_precision The desired precision.
	 * @return {string} {@code num} as a string with the given options.
	 */
	goog.string.padNumber = function(num, length, opt_precision) {
	  var s = goog.isDef(opt_precision) ? num.toFixed(opt_precision) : String(num);
	  var index = s.indexOf('.');
	  if (index == -1) {
	    index = s.length;
	  }
	  return goog.string.repeat('0', Math.max(0, length - index)) + s;
	};


	/**
	 * Returns a string representation of the given object, with
	 * null and undefined being returned as the empty string.
	 *
	 * @param {*} obj The object to convert.
	 * @return {string} A string representation of the {@code obj}.
	 */
	goog.string.makeSafe = function(obj) {
	  return obj == null ? '' : String(obj);
	};


	/**
	 * Concatenates string expressions. This is useful
	 * since some browsers are very inefficient when it comes to using plus to
	 * concat strings. Be careful when using null and undefined here since
	 * these will not be included in the result. If you need to represent these
	 * be sure to cast the argument to a String first.
	 * For example:
	 * <pre>buildString('a', 'b', 'c', 'd') -> 'abcd'
	 * buildString(null, undefined) -> ''
	 * </pre>
	 * @param {...*} var_args A list of strings to concatenate. If not a string,
	 *     it will be casted to one.
	 * @return {string} The concatenation of {@code var_args}.
	 */
	goog.string.buildString = function(var_args) {
	  return Array.prototype.join.call(arguments, '');
	};


	/**
	 * Returns a string with at least 64-bits of randomness.
	 *
	 * Doesn't trust Javascript's random function entirely. Uses a combination of
	 * random and current timestamp, and then encodes the string in base-36 to
	 * make it shorter.
	 *
	 * @return {string} A random string, e.g. sn1s7vb4gcic.
	 */
	goog.string.getRandomString = function() {
	  var x = 2147483648;
	  return Math.floor(Math.random() * x).toString(36) +
	         Math.abs(Math.floor(Math.random() * x) ^ goog.now()).toString(36);
	};


	/**
	 * Compares two version numbers.
	 *
	 * @param {string|number} version1 Version of first item.
	 * @param {string|number} version2 Version of second item.
	 *
	 * @return {number}  1 if {@code version1} is higher.
	 *                   0 if arguments are equal.
	 *                  -1 if {@code version2} is higher.
	 */
	goog.string.compareVersions = function(version1, version2) {
	  var order = 0;
	  // Trim leading and trailing whitespace and split the versions into
	  // subversions.
	  var v1Subs = goog.string.trim(String(version1)).split('.');
	  var v2Subs = goog.string.trim(String(version2)).split('.');
	  var subCount = Math.max(v1Subs.length, v2Subs.length);

	  // Iterate over the subversions, as long as they appear to be equivalent.
	  for (var subIdx = 0; order == 0 && subIdx < subCount; subIdx++) {
	    var v1Sub = v1Subs[subIdx] || '';
	    var v2Sub = v2Subs[subIdx] || '';

	    // Split the subversions into pairs of numbers and qualifiers (like 'b').
	    // Two different RegExp objects are needed because they are both using
	    // the 'g' flag.
	    var v1CompParser = new RegExp('(\\d*)(\\D*)', 'g');
	    var v2CompParser = new RegExp('(\\d*)(\\D*)', 'g');
	    do {
	      var v1Comp = v1CompParser.exec(v1Sub) || ['', '', ''];
	      var v2Comp = v2CompParser.exec(v2Sub) || ['', '', ''];
	      // Break if there are no more matches.
	      if (v1Comp[0].length == 0 && v2Comp[0].length == 0) {
	        break;
	      }

	      // Parse the numeric part of the subversion. A missing number is
	      // equivalent to 0.
	      var v1CompNum = v1Comp[1].length == 0 ? 0 : parseInt(v1Comp[1], 10);
	      var v2CompNum = v2Comp[1].length == 0 ? 0 : parseInt(v2Comp[1], 10);

	      // Compare the subversion components. The number has the highest
	      // precedence. Next, if the numbers are equal, a subversion without any
	      // qualifier is always higher than a subversion with any qualifier. Next,
	      // the qualifiers are compared as strings.
	      order = goog.string.compareElements_(v1CompNum, v2CompNum) ||
	          goog.string.compareElements_(v1Comp[2].length == 0,
	              v2Comp[2].length == 0) ||
	          goog.string.compareElements_(v1Comp[2], v2Comp[2]);
	      // Stop as soon as an inequality is discovered.
	    } while (order == 0);
	  }

	  return order;
	};


	/**
	 * Compares elements of a version number.
	 *
	 * @param {string|number|boolean} left An element from a version number.
	 * @param {string|number|boolean} right An element from a version number.
	 *
	 * @return {number}  1 if {@code left} is higher.
	 *                   0 if arguments are equal.
	 *                  -1 if {@code right} is higher.
	 * @private
	 */
	goog.string.compareElements_ = function(left, right) {
	  if (left < right) {
	    return -1;
	  } else if (left > right) {
	    return 1;
	  }
	  return 0;
	};


	/**
	 * Maximum value of #goog.string.hashCode, exclusive. 2^32.
	 * @type {number}
	 * @private
	 */
	goog.string.HASHCODE_MAX_ = 0x100000000;


	/**
	 * String hash function similar to java.lang.String.hashCode().
	 * The hash code for a string is computed as
	 * s[0] * 31 ^ (n - 1) + s[1] * 31 ^ (n - 2) + ... + s[n - 1],
	 * where s[i] is the ith character of the string and n is the length of
	 * the string. We mod the result to make it between 0 (inclusive) and 2^32
	 * (exclusive).
	 * @param {string} str A string.
	 * @return {number} Hash value for {@code str}, between 0 (inclusive) and 2^32
	 *  (exclusive). The empty string returns 0.
	 */
	goog.string.hashCode = function(str) {
	  var result = 0;
	  for (var i = 0; i < str.length; ++i) {
	    result = 31 * result + str.charCodeAt(i);
	    // Normalize to 4 byte range, 0 ... 2^32.
	    result %= goog.string.HASHCODE_MAX_;
	  }
	  return result;
	};


	/**
	 * The most recent unique ID. |0 is equivalent to Math.floor in this case.
	 * @type {number}
	 * @private
	 */
	goog.string.uniqueStringCounter_ = Math.random() * 0x80000000 | 0;


	/**
	 * Generates and returns a string which is unique in the current document.
	 * This is useful, for example, to create unique IDs for DOM elements.
	 * @return {string} A unique id.
	 */
	goog.string.createUniqueString = function() {
	  return 'goog_' + goog.string.uniqueStringCounter_++;
	};


	/**
	 * Converts the supplied string to a number, which may be Ininity or NaN.
	 * This function strips whitespace: (toNumber(' 123') === 123)
	 * This function accepts scientific notation: (toNumber('1e1') === 10)
	 *
	 * This is better than Javascript's built-in conversions because, sadly:
	 *     (Number(' ') === 0) and (parseFloat('123a') === 123)
	 *
	 * @param {string} str The string to convert.
	 * @return {number} The number the supplied string represents, or NaN.
	 */
	goog.string.toNumber = function(str) {
	  var num = Number(str);
	  if (num == 0 && goog.string.isEmpty(str)) {
	    return NaN;
	  }
	  return num;
	};


	/**
	 * Converts a string from selector-case to camelCase (e.g. from
	 * "multi-part-string" to "multiPartString"), useful for converting
	 * CSS selectors and HTML dataset keys to their equivalent JS properties.
	 * @param {string} str The string in selector-case form.
	 * @return {string} The string in camelCase form.
	 */
	goog.string.toCamelCase = function(str) {
	  return String(str).replace(/\-([a-z])/g, function(all, match) {
	    return match.toUpperCase();
	  });
	};


	/**
	 * Converts a string from camelCase to selector-case (e.g. from
	 * "multiPartString" to "multi-part-string"), useful for converting JS
	 * style and dataset properties to equivalent CSS selectors and HTML keys.
	 * @param {string} str The string in camelCase form.
	 * @return {string} The string in selector-case form.
	 */
	goog.string.toSelectorCase = function(str) {
	  return String(str).replace(/([A-Z])/g, '-$1').toLowerCase();
	};


	/**
	 * Converts a string into TitleCase. First character of the string is always
	 * capitalized in addition to the first letter of every subsequent word.
	 * Words are delimited by one or more whitespaces by default. Custom delimiters
	 * can optionally be specified to replace the default, which doesn't preserve
	 * whitespace delimiters and instead must be explicitly included if needed.
	 *
	 * Default delimiter => " ":
	 *    goog.string.toTitleCase('oneTwoThree')    => 'OneTwoThree'
	 *    goog.string.toTitleCase('one two three')  => 'One Two Three'
	 *    goog.string.toTitleCase('  one   two   ') => '  One   Two   '
	 *    goog.string.toTitleCase('one_two_three')  => 'One_two_three'
	 *    goog.string.toTitleCase('one-two-three')  => 'One-two-three'
	 *
	 * Custom delimiter => "_-.":
	 *    goog.string.toTitleCase('oneTwoThree', '_-.')       => 'OneTwoThree'
	 *    goog.string.toTitleCase('one two three', '_-.')     => 'One two three'
	 *    goog.string.toTitleCase('  one   two   ', '_-.')    => '  one   two   '
	 *    goog.string.toTitleCase('one_two_three', '_-.')     => 'One_Two_Three'
	 *    goog.string.toTitleCase('one-two-three', '_-.')     => 'One-Two-Three'
	 *    goog.string.toTitleCase('one...two...three', '_-.') => 'One...Two...Three'
	 *    goog.string.toTitleCase('one. two. three', '_-.')   => 'One. two. three'
	 *    goog.string.toTitleCase('one-two.three', '_-.')     => 'One-Two.Three'
	 *
	 * @param {string} str String value in camelCase form.
	 * @param {string=} opt_delimiters Custom delimiter character set used to
	 *      distinguish words in the string value. Each character represents a
	 *      single delimiter. When provided, default whitespace delimiter is
	 *      overridden and must be explicitly included if needed.
	 * @return {string} String value in TitleCase form.
	 */
	goog.string.toTitleCase = function(str, opt_delimiters) {
	  var delimiters = goog.isString(opt_delimiters) ?
	      goog.string.regExpEscape(opt_delimiters) : '\\s';

	  // For IE8, we need to prevent using an empty character set. Otherwise,
	  // incorrect matching will occur.
	  delimiters = delimiters ? '|[' + delimiters + ']+' : '';

	  var regexp = new RegExp('(^' + delimiters + ')([a-z])', 'g');
	  return str.replace(regexp, function(all, p1, p2) {
	    return p1 + p2.toUpperCase();
	  });
	};


	/**
	 * Parse a string in decimal or hexidecimal ('0xFFFF') form.
	 *
	 * To parse a particular radix, please use parseInt(string, radix) directly. See
	 * https://developer.mozilla.org/en/JavaScript/Reference/Global_Objects/parseInt
	 *
	 * This is a wrapper for the built-in parseInt function that will only parse
	 * numbers as base 10 or base 16.  Some JS implementations assume strings
	 * starting with "0" are intended to be octal. ES3 allowed but discouraged
	 * this behavior. ES5 forbids it.  This function emulates the ES5 behavior.
	 *
	 * For more information, see Mozilla JS Reference: http://goo.gl/8RiFj
	 *
	 * @param {string|number|null|undefined} value The value to be parsed.
	 * @return {number} The number, parsed. If the string failed to parse, this
	 *     will be NaN.
	 */
	goog.string.parseInt = function(value) {
	  // Force finite numbers to strings.
	  if (isFinite(value)) {
	    value = String(value);
	  }

	  if (goog.isString(value)) {
	    // If the string starts with '0x' or '-0x', parse as hex.
	    return /^\s*-?0x/i.test(value) ?
	        parseInt(value, 16) : parseInt(value, 10);
	  }

	  return NaN;
	};

	  exports.goog = goog;

	}.call(exports, __webpack_require__, exports, module), __WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));


/***/ },
/* 32 */
/*!********************************!*\
  !*** ./src/modules/keyring.js ***!
  \********************************/
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Mailvelope - secure email with OpenPGP encryption for Webmail
	 * Copyright (C) 2015 Mailvelope GmbH
	 *
	 * This program is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU Affero General Public License version 3
	 * as published by the Free Software Foundation.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU Affero General Public License for more details.
	 *
	 * You should have received a copy of the GNU Affero General Public License
	 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	'use strict';


	var mvelo = __webpack_require__(/*! lib-mvelo */ 8);
	var openpgp = __webpack_require__(/*! openpgp */ 22);
	var goog = __webpack_require__(/*! ./closure-library/closure/goog/emailaddress */ 30).goog;
	var prefs = __webpack_require__(/*! ./prefs */ 26);
	var l10n = mvelo.l10n.get;
	var keyringSync = __webpack_require__(/*! ./keyringSync */ 33);
	var keyringAttr = null;
	var keyringMap = new Map();
	var trustKey = __webpack_require__(/*! ./trustKey */ 36);
	var KeyServer = __webpack_require__(/*! ./keyserver */ 38);
	var keyServer = new KeyServer(mvelo);

	function init() {
	  keyringAttr = getAllKeyringAttr();
	  if (keyringAttr && keyringAttr[mvelo.LOCAL_KEYRING_ID]) {
	    for (var keyringId in keyringAttr) {
	      if (keyringAttr.hasOwnProperty(keyringId)) {
	        keyringMap.set(keyringId, _getKeyring(keyringId));
	      }
	    }
	  } else {
	    createKeyring(mvelo.LOCAL_KEYRING_ID);
	    // migrate primary_key attribute
	    if (prefs.data().general.primary_key) {
	      setKeyringAttr(mvelo.LOCAL_KEYRING_ID, {primary_key: prefs.data().general.primary_key});
	    }
	  }
	}

	function createKeyring(keyringId, options) {
	  // init keyring attributes
	  if (!keyringAttr) {
	    keyringAttr = {};
	  }
	  if (keyringAttr[keyringId]) {
	    var error = new Error('Keyring for id ' + keyringId + ' already exists.');
	    error.code = 'KEYRING_ALREADY_EXISTS';
	    throw error;
	  }
	  keyringAttr[keyringId] = {};
	  // instantiate keyring
	  var keyRng = _getKeyring(keyringId);
	  keyringMap.set(keyringId, keyRng);
	  setKeyringAttr(keyringId, {} || options);
	  return keyRng;
	}

	/**
	 * Instantiate a new keyring object
	 * @param  {String} keyringId
	 * @return {Keyring}
	 */
	function _getKeyring(keyringId) {
	  // resolve keyring dependencies
	  var localstore = null;
	  if (keyringId !== mvelo.LOCAL_KEYRING_ID) {
	    localstore = new openpgp.Keyring.localstore(keyringId);
	  }
	  var pgpKeyring = new openpgp.Keyring(localstore);
	  var krSync = new keyringSync.KeyringSync(keyringId);
	  // instantiate keyring
	  return new Keyring(keyringId, pgpKeyring, krSync);
	}

	function deleteKeyring(keyringId) {
	  if (!keyringAttr[keyringId]) {
	    var error = new Error('Keyring for id ' + keyringId + ' does not exist.');
	    error.code = 'NO_KEYRING_FOR_ID';
	    throw error;
	  }
	  var keyRng = keyringMap.get(keyringId);
	  keyRng.keyring.clear();
	  keyRng.keyring.store();
	  keyRng.keyring.storeHandler.storage.removeItem(keyRng.keyring.storeHandler.publicKeysItem);
	  keyRng.keyring.storeHandler.storage.removeItem(keyRng.keyring.storeHandler.privateKeysItem);
	  keyringMap.delete(keyringId);
	  delete keyringAttr[keyringId];
	  mvelo.storage.set('mailvelopeKeyringAttr', keyringAttr);
	}

	function getById(keyringId) {
	  var keyring = keyringMap.get(keyringId);
	  if (keyring) {
	    return keyring;
	  } else {
	    var error = new Error('No keyring found for this identifier.');
	    error.code = 'NO_KEYRING_FOR_ID';
	    throw error;
	  }
	}

	function getAll() {
	  var result = [];
	  for (var keyringId in keyringAttr) {
	    if (keyringAttr.hasOwnProperty(keyringId)) {
	      result.push(keyringMap.get(keyringId));
	    }
	  }
	  return result;
	}

	function getAllKeyringAttr() {
	  return mvelo.storage.get('mailvelopeKeyringAttr');
	}

	function setKeyringAttr(keyringId, attr) {
	  if (!keyringAttr[keyringId]) {
	    throw new Error('Keyring does not exist for id: ' + keyringId);
	  }
	  mvelo.util.extend(keyringAttr[keyringId], attr);
	  mvelo.storage.set('mailvelopeKeyringAttr', keyringAttr);
	}

	function getKeyringAttr(keyringId, attr) {
	  if (!keyringAttr[keyringId]) {
	    throw new Error('Keyring does not exist for id: ' + keyringId);
	  }
	  return keyringAttr[keyringId][attr];
	}

	/**
	 * Get primary or first available user id of key
	 * @param  {openpgp.Key} key
	 * @param  {Boolean} [validityCheck=true] - only return valid user ids, e.g. for expired keys you would want to set to false to still get a result
	 * @return {String} user id
	 */
	function getUserId(key, validityCheck) {
	  validityCheck = typeof validityCheck === 'undefined' ? true : false;
	  var primaryUser = key.getPrimaryUser();
	  if (primaryUser) {
	    return primaryUser.user.userId.userid;
	  } else {
	    // there is no valid user id on this key
	    if (!validityCheck) {
	      // take first available user ID
	      for (var i = 0; i < key.users.length; i++) {
	        if (key.users[i].userId) {
	          return key.users[i].userId.userid;
	        }
	      }
	    }
	    return l10n('keygrid_invalid_userid');
	  }
	}

	function getAllKeyUserId() {
	  var allKeyrings = getAll();
	  var result = [];
	  allKeyrings.forEach(function(keyring) {
	    result = result.concat(keyring.getKeyUserIDs().map(function(key) {
	      key.keyringId = keyring.id;
	      return key;
	    }));
	  });
	  // remove duplicate keys
	  result = mvelo.util.sortAndDeDup(result, function(a, b) {
	    return a.keyid.localeCompare(b.keyid);
	  });
	  // sort by name
	  result = result.sort(function(a, b) {
	    return a.name.localeCompare(b.name);
	  });
	  return result;
	}

	function readKey(armored) {
	  var parsedKey = openpgp.key.readArmored(armored);
	  if (parsedKey.err) {
	    return parsedKey;
	  }
	  parsedKey.keys = mapKeys(parsedKey.keys);
	  return parsedKey;
	}

	function cloneKey(key) {
	  var binary = key.toPacketlist().write();
	  var packetList = new openpgp.packet.List();
	  packetList.read(binary);
	  return new openpgp.key.Key(packetList);
	}

	exports.init = init;
	exports.createKeyring = createKeyring;
	exports.deleteKeyring = deleteKeyring;
	exports.getAll = getAll;
	exports.getAllKeyringAttr = getAllKeyringAttr;
	exports.setKeyringAttr = setKeyringAttr;
	exports.getKeyringAttr = getKeyringAttr;
	exports.getById = getById;
	exports.getUserId = getUserId;
	exports.getAllKeyUserId = getAllKeyUserId;
	exports.readKey = readKey;
	exports.mapKeys = mapKeys;
	exports.cloneKey = cloneKey;
	exports.Keyring = Keyring;

	function Keyring(keyringId, pgpKeyring, krSync) {
	  this.id = keyringId;
	  this.keyring = pgpKeyring;
	  this.sync = krSync;
	}

	Keyring.prototype.getKeys = function() {
	  // map keys to UI format
	  var keys = this.getPublicKeys().concat(this.getPrivateKeys());
	  // sort by key type and name
	  keys = keys.sort(function(a, b) {
	    var compType = a.type.localeCompare(b.type);
	    if (compType === 0) {
	      return a.name.localeCompare(b.name);
	    } else {
	      return compType;
	    }
	  });
	  return keys;
	};

	Keyring.prototype.getPublicKeys = function() {
	  return mapKeys(this.keyring.publicKeys.keys);
	};

	Keyring.prototype.getPrivateKeys = function() {
	  return mapKeys(this.keyring.privateKeys.keys);
	};

	Keyring.prototype.getValidSigningKeys = function() {
	  return mapKeys(this.keyring.privateKeys.keys.filter(key => this.validatePrimaryKey(key)))
	  .sort((a, b) => a.name.localeCompare(b.name));
	};

	function mapKeys(keys) {
	  var result = [];
	  keys.forEach(function(key) {
	    var uiKey = {};
	    if (key.isPublic()) {
	      uiKey.type = 'public';
	    } else {
	      uiKey.type = 'private';
	    }
	    try {
	      uiKey.validity = key.verifyPrimaryKey() === openpgp.enums.keyStatus.valid;
	    } catch (e) {
	      uiKey.validity = false;
	      console.log('Exception in verifyPrimaryKey', e);
	    }
	    uiKey.id = key.primaryKey.getKeyId().toHex().toUpperCase();
	    uiKey.fingerprint = key.primaryKey.getFingerprint().toUpperCase();
	    // primary user
	    try {
	      uiKey.userId = getUserId(key, false);
	      var address = goog.format.EmailAddress.parse(uiKey.userId);
	      uiKey.name = address.getName();
	      uiKey.email = address.getAddress();
	      uiKey.exDate = key.getExpirationTime();
	      if (uiKey.exDate) {
	        uiKey.exDate = uiKey.exDate.toISOString();
	      } else {
	        uiKey.exDate = false;
	      }
	    } catch (e) {
	      uiKey.name = uiKey.name || 'NO USERID FOUND';
	      uiKey.email = uiKey.email || 'UNKNOWN';
	      uiKey.exDate = uiKey.exDate || 'UNKNOWN';
	      console.log('Exception map primary user', e);
	    }
	    uiKey.crDate = key.primaryKey.created.toISOString();
	    uiKey.algorithm = getAlgorithmString(key.primaryKey.algorithm);
	    uiKey.bitLength = key.primaryKey.getBitSize();
	    result.push(uiKey);
	  });
	  return result;
	}

	function getAlgorithmString(keyType) {
	  var result = '';
	  switch (keyType) {
	  case 'rsa_encrypt_sign':
	    result = "RSA (Encrypt or Sign)";
	    break;
	  case 'rsa_encrypt':
	    result = "RSA Encrypt-Only";
	    break;
	  case 'rsa_sign':
	    result = "RSA Sign-Only";
	    break;
	  case 'elgamal':
	    result = "Elgamal (Encrypt-Only)";
	    break;
	  case 'dsa':
	    result = "DSA (Digital Signature Algorithm)";
	    break;
	  default:
	    result = "UNKNOWN";
	  }
	  return result;
	}

	/*
	function getKeyType(algorithm) {
	  var result;
	  switch (algorithm) {
	  case "RSA/RSA":
	    result = openpgp.enums.publicKey.rsa_encrypt_sign;
	    break;
	  case "DSA/ElGamal":
	    result = openpgp.enums.publicKey.dsa;
	    break;
	  default:
	    throw new Error('Key type not supported');
	  }
	  return result;
	}
	*/

	Keyring.prototype.getKeyDetails = function(fingerprint) {
	  var details = {};
	  fingerprint = fingerprint.toLowerCase();
	  var keys = this.keyring.getKeysForId(fingerprint);
	  if (keys) {
	    var key = keys[0];
	    // subkeys
	    mapSubKeys(key.subKeys, details);
	    // users
	    mapUsers(key.users, details, this.keyring, key.primaryKey);
	    // key is valid primary key
	    details.validPrimaryKey = this.validatePrimaryKey(key);
	    return details;
	  } else {
	    throw new Error('Key with this fingerprint not found: ', fingerprint);
	  }
	};

	function mapSubKeys(subkeys, toKey) {
	  toKey.subkeys = [];
	  subkeys && subkeys.forEach(function(subkey) {
	    try {
	      var skey = {};
	      skey.crDate = subkey.subKey.created.toISOString();
	      skey.exDate = subkey.getExpirationTime();
	      if (skey.exDate) {
	        skey.exDate = skey.exDate.toISOString();
	      } else {
	        skey.exDate = false;
	      }
	      skey.id = subkey.subKey.getKeyId().toHex().toUpperCase();
	      skey.algorithm = getAlgorithmString(subkey.subKey.algorithm);
	      skey.bitLength = subkey.subKey.getBitSize();
	      skey.fingerprint = subkey.subKey.getFingerprint().toUpperCase();
	      toKey.subkeys.push(skey);
	    } catch (e) {
	      console.log('Exception in mapSubKeys', e);
	    }
	  });
	}

	function mapUsers(users, toKey, keyring, primaryKey) {
	  toKey.users = [];
	  users && users.forEach(function(user) {
	    try {
	      var uiUser = {};
	      uiUser.userID = user.userId.userid;
	      uiUser.signatures = [];
	      user.selfCertifications && user.selfCertifications.forEach(function(selfCert) {
	        if (!user.isValidSelfCertificate(primaryKey, selfCert)) {
	          return;
	        }
	        var sig = {};
	        sig.signer = user.userId.userid;
	        sig.id = selfCert.issuerKeyId.toHex().toUpperCase();
	        sig.crDate = selfCert.created.toISOString();
	        uiUser.signatures.push(sig);
	      });
	      user.otherCertifications && user.otherCertifications.forEach(function(otherCert) {
	        var sig = {};
	        var keyidHex = otherCert.issuerKeyId.toHex();
	        var issuerKeys = keyring.getKeysForId(keyidHex);
	        if (issuerKeys) {
	          var signingKeyPacket = issuerKeys[0].getKeyPacket([otherCert.issuerKeyId]);
	          if (signingKeyPacket && (otherCert.verified || otherCert.verify(signingKeyPacket, {userid: user.userId, key: primaryKey}))) {
	            sig.signer = getUserId(issuerKeys[0]);
	          } else {
	            // invalid signature
	            return;
	          }
	        } else {
	          sig.signer = l10n("keygrid_signer_unknown");
	        }
	        sig.id = otherCert.issuerKeyId.toHex().toUpperCase();
	        sig.crDate = otherCert.created.toISOString();
	        uiUser.signatures.push(sig);
	      });
	      toKey.users.push(uiUser);
	    } catch (e) {
	      console.log('Exception in mapUsers', e);
	    }
	  });
	}

	/**
	 * Get user id, email and name for all keys
	 * @param {Object} [options]
	 * @param {Boolean} [options.allUsers] return separate entry for all user ids of key
	 * @return {Array<Object>} list of key meta data objects
	 */
	Keyring.prototype.getKeyUserIDs = function(options) {
	  var that = this;
	  options = options || {};
	  var result = [];
	  this.keyring.getAllKeys().forEach(function(key) {
	    if (key.verifyPrimaryKey() !== openpgp.enums.keyStatus.valid ||
	        trustKey.isKeyPseudoRevoked(that.id, key)) {
	      return;
	    }
	    var user;
	    var keyid = key.primaryKey.getKeyId().toHex();
	    if (options.allUsers) {
	      // consider all user ids of key
	      var users = [];
	      key.users.forEach(function(keyUser) {
	        if (keyUser.userId && keyUser.verify(key.primaryKey) === openpgp.enums.keyStatus.valid) {
	          user = {};
	          user.keyid = keyid;
	          user.userid = keyUser.userId.userid;
	          // check for duplicates
	          if (users.some(function(existingUser) {
	            return existingUser.userid === user.userid;
	          })) {
	            return;
	          }
	          that._mapKeyUserIds(user);
	          // check for valid email address
	          if (!user.email) {
	            return;
	          }
	          users.push(user);
	        }
	      });
	      result = result.concat(users);
	    } else {
	      // only consider primary user
	      user = {};
	      user.keyid = keyid;
	      user.userid = getUserId(key);
	      that._mapKeyUserIds(user);
	      result.push(user);
	    }
	  });
	  // sort by user id
	  result = result.sort(function(a, b) {
	    return a.userid.localeCompare(b.userid);
	  });
	  return result;
	};

	Keyring.prototype._mapKeyUserIds = function(user) {
	  try {
	    var emailAddress = goog.format.EmailAddress.parse(user.userid);
	    if (emailAddress.isValid()) {
	      user.email = emailAddress.getAddress();
	    } else {
	      user.email = '';
	    }
	    user.name = emailAddress.getName();
	  } catch (e) {
	    user.userid = l10n('keygrid_invalid_userid');
	    user.email = '';
	    user.name = '';
	  }
	};

	Keyring.prototype.getKeyIdByAddress = function(emailAddr, options) {
	  var addressMap = this.getKeyByAddress(emailAddr, options);
	  for (var address in addressMap) {
	    addressMap[address] = addressMap[address] && addressMap[address].map(function(key) {
	      if (options.fingerprint) {
	        return key.primaryKey.getFingerprint();
	      }
	      return key.primaryKey.getKeyId().toHex();
	    });
	  }
	  return addressMap;
	};

	Keyring.prototype.getKeyByAddress = function(emailAddr, options) {
	  var that = this;
	  if (typeof options.pub === 'undefined') {
	    options.pub = true;
	  }
	  if (typeof options.priv === 'undefined') {
	    options.priv = true;
	  }
	  var result = Object.create(null);
	  emailAddr.forEach(function(emailAddr) {
	    result[emailAddr] = [];
	    if (options.pub) {
	      result[emailAddr] = result[emailAddr].concat(that.keyring.publicKeys.getForAddress(emailAddr));
	    }
	    if (options.priv) {
	      result[emailAddr] = result[emailAddr].concat(that.keyring.privateKeys.getForAddress(emailAddr));
	    }
	    result[emailAddr] = result[emailAddr].filter(function(key) {
	      if (options.validity && (
	          key.verifyPrimaryKey() !== openpgp.enums.keyStatus.valid ||
	          key.getEncryptionKeyPacket() === null) ||
	          trustKey.isKeyPseudoRevoked(that.id, key)) {
	        return;
	      }
	      return true;
	    });
	    if (!result[emailAddr].length) {
	      result[emailAddr] = false;
	    } else if (options.sort) {
	      // sort by key creation date and primary key status
	      var primaryKeyId = that.getAttributes().primary_key;
	      result[emailAddr].sort(function(a, b) {
	        if (primaryKeyId) {
	          primaryKeyId = primaryKeyId.toLowerCase();
	          if (primaryKeyId === a.primaryKey.getKeyId().toHex()) {
	            return -1;
	          }
	          if (primaryKeyId === b.primaryKey.getKeyId().toHex()) {
	            return 1;
	          }
	        }
	        return b.primaryKey.created - a.primaryKey.created;
	      });
	    }
	  });
	  return result;
	};

	Keyring.prototype.getArmoredKeys = function(keyids, options) {
	  var that = this;
	  var result = [];
	  var keys = null;
	  if (options.all) {
	    keys = this.keyring.getAllKeys();
	  } else {
	    keys = keyids.map(function(keyid) {
	      keyid = keyid.toLowerCase();
	      return that.keyring.getKeysForId(keyid)[0];
	    });
	  }
	  keys.forEach(function(key) {
	    var armored = {};
	    if (options.pub) {
	      armored.armoredPublic = key.toPublic().armor();
	    }
	    if (options.priv && key.isPrivate()) {
	      armored.armoredPrivate = key.armor();
	    }
	    result.push(armored);
	  });
	  return result;
	};

	Keyring.prototype.hasPrimaryKey = function() {
	  return this.getAttributes().primary_key ? true : false;
	};

	Keyring.prototype.getPrimaryKey = function() {
	  let primaryKey;
	  const primaryKeyid = this.getAttributes().primary_key;
	  if (primaryKeyid) {
	    primaryKey = this.keyring.privateKeys.getForId(primaryKeyid.toLowerCase());
	    if (!(primaryKey && this.validatePrimaryKey(primaryKey))) {
	      // primary key with this id does not exist or is invalid
	      setKeyringAttr(this.id, {primary_key: ''}); // clear primary key
	      primaryKey = null;
	    }
	  }
	  if (!primaryKey) {
	    // get newest private key that is valid
	    this.keyring.privateKeys.keys.forEach(key => {
	      if ((!primaryKey || primaryKey.primaryKey.created < key.primaryKey.created) &&
	          this.validatePrimaryKey(key)) {
	        primaryKey = key;
	      }
	    });
	  }
	  if (!primaryKey) {
	    return null;
	  }
	  return {
	    key: primaryKey,
	    keyid: primaryKey.primaryKey.getKeyId().toHex(),
	    userid: getUserId(primaryKey)
	  };
	};

	Keyring.prototype.validatePrimaryKey = function(primaryKey) {
	  return primaryKey.verifyPrimaryKey() === openpgp.enums.keyStatus.valid &&
	         primaryKey.getEncryptionKeyPacket() &&
	         primaryKey.getSigningKeyPacket() &&
	         !trustKey.isKeyPseudoRevoked(this.id, primaryKey);
	}

	Keyring.prototype.importKeys = function(armoredKeys) {
	  var that = this;
	  var result = [];
	  // sort, public keys first
	  armoredKeys = armoredKeys.sort(function(a, b) {
	    return b.type.localeCompare(a.type);
	  });
	  // import
	  armoredKeys.forEach(function(key) {
	    try {
	      if (key.type === 'public') {
	        result = result.concat(that.importPublicKey(key.armored, that.keyring));
	      } else if (key.type === 'private') {
	        result = result.concat(that.importPrivateKey(key.armored, that.keyring));
	      }
	    } catch (e) {
	      result.push({
	        type: 'error',
	        message: l10n('key_import_unable', [e])
	      });
	    }
	  });
	  // store if import succeeded
	  if (result.some(function(message) { return message.type === 'success'; })) {
	    this.keyring.store();
	    this.sync.commit();
	    // by no primary key in the keyring set the first found private keys as primary for the keyring
	    if (!that.hasPrimaryKey() && that.keyring.privateKeys.keys.length > 0) {
	      setKeyringAttr(that.id, {primary_key: that.keyring.privateKeys.keys[0].primaryKey.keyid.toHex().toUpperCase()});
	    }
	  }
	  return result;
	};

	Keyring.prototype.importPublicKey = function(armored) {
	  var that = this;
	  var result = [];
	  var imported = openpgp.key.readArmored(armored);
	  if (imported.err) {
	    imported.err.forEach(function(error) {
	      console.log('Error on key.readArmored', error);
	      result.push({
	        type: 'error',
	        message: l10n('key_import_public_read', [error.message])
	      });
	    });
	  }
	  imported.keys.forEach(function(pubKey) {
	    // check for existing keys
	    checkKeyId(pubKey, that.keyring);
	    var fingerprint = pubKey.primaryKey.getFingerprint();
	    var key = that.keyring.getKeysForId(fingerprint);
	    var keyid = pubKey.primaryKey.getKeyId().toHex().toUpperCase();
	    if (key) {
	      key = key[0];
	      key.update(pubKey);
	      result.push({
	        type: 'success',
	        message: l10n('key_import_public_update', [keyid, getUserId(pubKey)])
	      });
	      that.sync.add(fingerprint, keyringSync.UPDATE);
	    } else {
	      that.keyring.publicKeys.push(pubKey);
	      result.push({
	        type: 'success',
	        message: l10n('key_import_public_success', [keyid, getUserId(pubKey)])
	      });
	      that.sync.add(fingerprint, keyringSync.INSERT);
	    }
	  });
	  return result;
	};

	Keyring.prototype.importPrivateKey = function(armored) {
	  var that = this;
	  var result = [];
	  var imported = openpgp.key.readArmored(armored);
	  if (imported.err) {
	    imported.err.forEach(function(error) {
	      console.log('Error on key.readArmored', error);
	      result.push({
	        type: 'error',
	        message: l10n('key_import_private_read', [error.message])
	      });
	    });
	  }
	  imported.keys.forEach(function(privKey) {
	    // check for existing keys
	    checkKeyId(privKey, that.keyring);
	    var fingerprint = privKey.primaryKey.getFingerprint();
	    var key = that.keyring.getKeysForId(fingerprint);
	    var keyid = privKey.primaryKey.getKeyId().toHex().toUpperCase();
	    if (key) {
	      key = key[0];
	      if (key.isPublic()) {
	        privKey.update(key);
	        that.keyring.publicKeys.removeForId(fingerprint);
	        that.keyring.privateKeys.push(privKey);
	        result.push({
	          type: 'success',
	          message: l10n('key_import_private_exists', [keyid, getUserId(privKey)])
	        });
	        that.sync.add(fingerprint, keyringSync.UPDATE);
	      } else {
	        key.update(privKey);
	        result.push({
	          type: 'success',
	          message: l10n('key_import_private_update', [keyid, getUserId(privKey)])
	        });
	        that.sync.add(fingerprint, keyringSync.UPDATE);
	      }
	    } else {
	      that.keyring.privateKeys.push(privKey);
	      result.push({
	        type: 'success',
	        message: l10n('key_import_private_success', [keyid, getUserId(privKey)])
	      });
	      that.sync.add(fingerprint, keyringSync.INSERT);
	    }
	  });
	  return result;
	};

	function checkKeyId(sourceKey, keyring) {
	  var primKeyId = sourceKey.primaryKey.getKeyId();
	  var keys = keyring.getKeysForId(primKeyId.toHex(), true);
	  if (keys) {
	    keys.forEach(function(key) {
	      if (!key.primaryKey.getKeyId().equals(primKeyId)) {
	        throw new Error('Primary keyId equals existing sub keyId.');
	      }
	    });
	  }
	  sourceKey.getSubkeyPackets().forEach(function(subKey) {
	    var subKeyId = subKey.getKeyId();
	    var keys = keyring.getKeysForId(subKeyId.toHex(), true);
	    if (keys) {
	      keys.forEach(function(key) {
	        if (key.primaryKey.getKeyId().equals(subKeyId)) {
	          throw new Error('Sub keyId equals existing primary keyId.');
	        }
	        if (!key.primaryKey.getKeyId().equals(primKeyId)) {
	          throw new Error('Sub keyId equals existing sub keyId in key with different primary keyId.');
	        }
	      });
	    }
	  });
	}

	Keyring.prototype.removeKey = function(fingerprint, type) {
	  var removedKey;
	  fingerprint = fingerprint.toLowerCase();
	  if (type === 'public') {
	    removedKey = this.keyring.publicKeys.removeForId(fingerprint);
	  } else if (type === 'private') {
	    removedKey = this.keyring.privateKeys.removeForId(fingerprint);
	  }
	  if (!removedKey) {
	    return;
	  }
	  if (type === 'private') {
	    var primaryKey = this.getAttributes().primary_key;
	    // Remove the key from the keyring attributes if primary
	    if (primaryKey && primaryKey.toLowerCase() === removedKey.primaryKey.keyid.toHex()) {
	      setKeyringAttr(this.id, {primary_key: ''});
	    }
	  }
	  this.sync.add(removedKey.primaryKey.getFingerprint(), keyringSync.DELETE);
	  this.keyring.store();
	  this.sync.commit();
	};

	/**
	 * Generate a new PGP keypair and optionally upload the public key to the
	 * key server.
	 * @param {number}  options.numBits           The keysize in bits
	 * @param {Array}   options.userIds           Email addresses and names
	 * @param {string}  options.passphrase        To protect the private key on disk
	 * @param {boolean} options.uploadPublicKey   If upload to key server is desired
	 * @yield {Object}                            The generated key pair
	 */
	Keyring.prototype.generateKey = function(options) {
	  var that = this;
	  options.userIds = options.userIds.map(function(userId) {
	    if (userId.fullName) {
	      return (new goog.format.EmailAddress(userId.email, userId.fullName)).toString();
	    } else {
	      return '<' + userId.email + '>';
	    }
	  });
	  return openpgp.generateKeyPair({numBits: parseInt(options.numBits), userId: options.userIds, passphrase: options.passphrase, keyExpirationTime: options.keyExpirationTime})
	    .then(function(data) {
	      if (data) {
	        that.keyring.privateKeys.push(data.key);
	        that.sync.add(data.key.primaryKey.getFingerprint(), keyringSync.INSERT);
	        that.keyring.store();
	        that.sync.commit();
	        // by no primary key in the keyring set the generated key as primary
	        if (!that.hasPrimaryKey()) {
	          setKeyringAttr(that.id, {primary_key: data.key.primaryKey.keyid.toHex().toUpperCase()});
	        }
	        // upload public key
	        if (options.uploadPublicKey) {
	          return keyServer.upload({publicKeyArmored: data.publicKeyArmored}).then(function() {
	            return data;
	          });
	        }
	      }
	      return data;
	    });
	};

	Keyring.prototype.getKeyForSigning = function(keyIdHex) {
	  var key = this.keyring.privateKeys.getForId(keyIdHex);
	  if (!key) {
	    return null;
	  }
	  return {
	    key: key,
	    keyid: key.primaryKey.getKeyId().toHex(),
	    userid: getUserId(key)
	  };
	};

	Keyring.prototype.getAttributes = function() {
	  return keyringAttr[this.id];
	};


/***/ },
/* 33 */
/*!************************************!*\
  !*** ./src/modules/keyringSync.js ***!
  \************************************/
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Mailvelope - secure email with OpenPGP encryption for Webmail
	 * Copyright (C) 2015 Mailvelope GmbH
	 *
	 * This program is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU Affero General Public License version 3
	 * as published by the Free Software Foundation.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU Affero General Public License for more details.
	 *
	 * You should have received a copy of the GNU Affero General Public License
	 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	'use strict';


	var keyringMod = __webpack_require__(/*! ./keyring */ 32);
	var syncCtrl = __webpack_require__(/*! ../controller/sync.controller */ 34);

	var INSERT = 'INSERT';
	var DELETE = 'DELETE';
	var UPDATE = 'UPDATE';

	function KeyringSync(keyringId) {
	  this.keyringId = keyringId;
	  this.SYNC_DATA = 'sync_data';
	  this.data = keyringMod.getKeyringAttr(this.keyringId, this.SYNC_DATA);
	  this.muted = false;
	}

	KeyringSync.prototype.activate = function() {
	  if (!this.data) {
	    this.data = {
	      eTag: '',
	      changeLog: {},
	      modified: false
	    };
	  }
	  this.save();
	};

	KeyringSync.prototype.add = function(keyid, type) {
	  if (!this.data || this.muted) {
	    return;
	  }
	  if (!(type === INSERT || type === DELETE || type === UPDATE)) {
	    throw new Error('Unknown log entry type');
	  }
	  this.data.modified = true;
	  if (type === UPDATE) {
	    return;
	  }
	  keyid = keyid.toLowerCase();
	  this.data.changeLog[keyid] = {
	    type: type,
	    time: Math.floor(Date.now() / 1000)
	  };
	};

	KeyringSync.prototype.save = function() {
	  if (!this.data) {
	    return;
	  }
	  var data = {};
	  data[this.SYNC_DATA] = this.data;
	  keyringMod.setKeyringAttr(this.keyringId, data);
	};

	KeyringSync.prototype.commit = function() {
	  if (!this.data || this.muted) {
	    return;
	  }
	  this.save();
	  syncCtrl.triggerSync({keyringId: this.keyringId});
	};

	KeyringSync.prototype.merge = function(update) {
	  if (!this.data) {
	    return;
	  }
	  for (var fingerprint in update) {
	    if (!this.data.changeLog[fingerprint] || (this.data.changeLog[fingerprint].time < update[fingerprint].time)) {
	      this.data.changeLog[fingerprint] = update[fingerprint];
	    }
	  }
	};

	KeyringSync.prototype.getDeleteEntries = function() {
	  var result = [];
	  for (var fingerprint in this.data.changeLog) {
	    if (this.data.changeLog[fingerprint].type === DELETE) {
	      result.push(fingerprint);
	    }
	  }
	  return result;
	};

	KeyringSync.prototype.mute = function(muted) {
	  this.muted = muted;
	};

	exports.KeyringSync = KeyringSync;
	exports.INSERT = INSERT;
	exports.DELETE = DELETE;
	exports.UPDATE = UPDATE;


/***/ },
/* 34 */
/*!*******************************************!*\
  !*** ./src/controller/sync.controller.js ***!
  \*******************************************/
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Mailvelope - secure email with OpenPGP encryption for Webmail
	 * Copyright (C) 2015 Mailvelope GmbH
	 *
	 * This program is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU Affero General Public License version 3
	 * as published by the Free Software Foundation.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU Affero General Public License for more details.
	 *
	 * You should have received a copy of the GNU Affero General Public License
	 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	'use strict';


	var sub = __webpack_require__(/*! ./sub.controller */ 35);
	var keyringMod = __webpack_require__(/*! ../modules/keyring */ 32);
	var pwdCache = __webpack_require__(/*! ../modules/pwdCache */ 27);
	var mvelo = __webpack_require__(/*! lib-mvelo */ 8);

	function SyncController(port) {
	  sub.SubController.call(this, port);
	  this.keyringId = null;
	  this.keyring = null;
	  this.syncDoneHandler = {};
	  this.pwdControl = null;
	  this.syncRunning = false;
	  this.repeatSync = null;
	  this.TIMEOUT = 8; // sync timeout in seconds
	  this.modified = false;
	  this.singleton = true;
	}

	SyncController.prototype = Object.create(sub.SubController.prototype);

	SyncController.prototype.init = function(keyringId) {
	  this.keyringId = keyringId;
	  this.keyring = keyringMod.getById(this.keyringId);
	};

	/**
	 * @param {Object} options - either undefined, force set or key and password provided
	 * @param {Boolean} [options.force] - if newer version on server available force sync
	 * @param {openpgp.key.Key} [options.key] - key to decrypt and sign sync message
	 * @param {String} [options.password] - password for options.key
	 */
	SyncController.prototype.triggerSync = function(options) {
	  var that = this;
	  options = options || {};
	  if (this.syncRunning) {
	    this.repeatSync = options;
	    return;
	  }
	  this.modified = this.keyring.sync.data.modified;
	  var primKey = this.keyring.getPrimaryKey();
	  if (!options.key) {
	    // if no key provided we take the primary key
	    if (primKey) {
	      options.key = primKey.key;
	    } else {
	      return; // no private key for sync
	    }
	  } else {
	    // check if provided key is primary key, otherwise no sync
	    if (!options.key.primaryKey.getKeyId().equals(primKey.key.primaryKey.getKeyId())) {
	      return;
	    }
	  }
	  if (!(options.force || this.canUnlockKey('decrypt', options))) {
	    return;
	  }
	  this.syncRunning = true;
	  // reset modified to detect further modification
	  this.keyring.sync.data.modified = false;
	  this.downloadSyncMessage(options)
	    .then(function() {
	      if (!that.modified) {
	        return;
	      }
	      if (that.canUnlockKey('sign', options)) {
	        return that.uploadSyncMessage(options);
	      }
	      // upload didn't happen, reset modified flag
	      that.keyring.sync.data.modified = true;
	    })
	    .then(function() {
	      that.keyring.sync.save();
	      that.checkRepeat();
	    })
	    .catch(function(err) {
	      console.log('Sync error', err);
	      if (that.modified || that.keyring.sync.data.modified) {
	        that.keyring.sync.data.modified = true;
	      }
	      that.checkRepeat();
	    });
	};

	SyncController.prototype.checkRepeat = function() {
	  this.syncRunning = false;
	  if (this.repeatSync) {
	    var repeat = this.repeatSync;
	    this.repeatSync = null;
	    this.triggerSync(repeat);
	  }
	};

	/**
	 * @param {Object} options
	 * @param  {Boolean} [options.force] - if newer version on server available force download
	 * @param  {openpgp.key.Key} options.key - key to decrypt sync message
	 * @param {String} [options.password] - password for options.key
	 * @return {Promise<undefined, Error}
	 */
	SyncController.prototype.downloadSyncMessage = function(options) {
	  var that = this;
	  return this.download({eTag: this.keyring.sync.data.eTag})
	    .then(function(download) {
	      if (!download.eTag) {
	        if (that.keyring.sync.data.eTag) {
	          // initialize eTag
	          that.keyring.sync.data.eTag = '';
	          // set modified flag to trigger upload
	          that.modified = true;
	        }
	        return;
	      }
	      if (!download.keyringMsg) {
	        return;
	      }
	      // new version available on server
	      return that.model.readMessage(download.keyringMsg, that.keyringId)
	        .then(function(message) {
	          message.keyringId = that.keyringId;
	          message.reason = 'PWD_DIALOG_REASON_EDITOR';
	          if (!message.key.primaryKey.getKeyId().equals(options.key.primaryKey.getKeyId())) {
	            console.log('Key used for sync packet from server is not primary key on client');
	            if (!options.force && !this.canUnlockKey('decrypt', {key: message.key})) {
	              throw new Error('Key used for sync packet is locked');
	            }
	          } else {
	            message.key = options.key;
	            message.password = options.password;
	          }
	          // unlock key if still locked
	          that.pwdControl = sub.factory.get('pwdDialog');
	          return that.pwdControl.unlockKey(message);
	        })
	        .then(function(message) {
	          return that.model.decryptSyncMessage(message.key, message.message);
	        })
	        .then(function(syncPacket) {
	          // merge keys
	          that.keyring.sync.mute(true);
	          that.keyring.importKeys(syncPacket.keys);
	          that.keyring.sync.merge(syncPacket.changeLog);
	          // remove keys with change log delete entry
	          that.keyring.sync.getDeleteEntries().forEach(function(fingerprint) {
	            that.keyring.removeKey(fingerprint, 'public');
	          });
	          that.keyring.sync.mute(false);
	          // set eTag
	          that.keyring.sync.data.eTag = download.eTag;
	        });
	    });
	};

	SyncController.prototype.uploadSyncMessage = function(options) {
	  var that = this;
	  // if key is in cache, specific unlock of sign key packet might be required
	  var keyOptions = {
	    key: options.key,
	    password: options.password,
	    keyid: options.key.getSigningKeyPacket().getKeyId().toHex(),
	    userid: keyringMod.getUserId(options.key),
	    reason: 'PWD_DIALOG_REASON_EDITOR',
	    keyringId: this.keyringId
	  };
	  this.pwdControl = this.pwdControl || sub.factory.get('pwdDialog');
	  return this.pwdControl.unlockKey(keyOptions)
	    .then(function(message) {
	      // encrypt keyring sync message
	      return that.model.encryptSyncMessage(message.key, that.keyring.sync.data.changeLog, that.keyringId);
	    })
	    // upload
	    .then(function(armored) {
	      return that.upload({eTag: that.keyring.sync.data.eTag, keyringMsg: armored});
	    })
	    .then(function(result) {
	      that.keyring.sync.data.eTag = result.eTag;
	    });
	};

	/**
	 * Check if key can be unlocked without requesting the password from the user
	 * @param  {String} operation - 'decrypt' or 'sign', the operation for which the key is required
	 * @param  {Object} options - mandatory
	 * @param {openpgp.key.Key} options.key
	 * @param {String} [options.password]
	 * @return {Boolean} - true if key can be unlocked
	 */
	SyncController.prototype.canUnlockKey = function(operation, options) {
	  if (options.password) {
	    // key can always be unlocked with password
	    return true;
	  }
	  var isCached = pwdCache.isCached(options.key.primaryKey.getKeyId().toHex());
	  if (isCached) {
	    return true;
	  }
	  var keyPacket;
	  if (operation === 'sign') {
	    keyPacket = options.key.getSigningKeyPacket();
	    return keyPacket && keyPacket.isDecrypted;
	  } else if (operation === 'decrypt') {
	    keyPacket = options.key.getEncryptionKeyPacket();
	    return keyPacket && keyPacket.isDecrypted;
	  }
	};

	SyncController.prototype.sync = function(type, data) {
	  var that = this;
	  return new Promise(function(resolve, reject) {
	    var id = that.mvelo.util.getHash();
	    that.ports.syncHandler.postMessage({
	      event: 'sync-event',
	      type: type,
	      data: data,
	      id: id
	    });
	    that.syncDoneHandler[id] = function(err, data) {
	      if (timeout) {
	        that.mvelo.util.clearTimeout(timeout);
	      }
	      if (err) {
	        reject(err);
	      } else {
	        resolve(data);
	      }
	    };
	    var timeout = that.mvelo.util.setTimeout(function() {
	      delete that.syncDoneHandler[id];
	      reject(new Error('Sync timeout'));
	    }, that.TIMEOUT * 1000);
	  });
	};

	SyncController.prototype.syncDone = function(data) {
	  if (this.syncDoneHandler[data.id]) {
	    this.syncDoneHandler[data.id](data.error, data.syncData);
	    delete this.syncDoneHandler[data.id];
	  }
	};

	SyncController.prototype.upload = function(uploadObj) {
	  return this.sync('upload', uploadObj);
	};

	SyncController.prototype.download = function(downloadObj) {
	  return this.sync('download', downloadObj);
	};

	SyncController.prototype.backup = function(backupObj) {
	  return this.sync('backup', backupObj);
	};

	SyncController.prototype.restore = function() {
	  return this.sync('restore');
	};

	SyncController.prototype.handlePortMessage = function(msg) {
	  //console.log('sync.controller handlePortMessage msg', msg);
	  switch (msg.event) {
	    case 'init':
	      this.init(msg.keyringId);
	      break;
	    case 'sync-done':
	      this.syncDone(msg.data);
	      break;
	    default:
	      console.log('unknown event', msg);
	  }
	};

	function getByKeyring(keyringId) {
	  return sub.getByMainType('syncHandler').filter(function(obj) {
	    return obj.keyringId === keyringId;
	  })[0];
	}

	/**
	 * @param {Object} options
	 * @param {String} options.keyringId identifies the keyring to sync
	 * @param {boolean} [options.force] - if newer version on server available force sync
	 * @param {Key} [options.key] - unlocked private key used for sync
	 * @param {String} [options.password] - password for options.key
	 */
	function triggerSync(options) {
	  var syncCtrl = getByKeyring(options.keyringId);
	  if (syncCtrl) {
	    mvelo.util.setTimeout(function() {
	      syncCtrl.triggerSync(options);
	    }, 20);
	  }
	}

	exports.SyncController = SyncController;
	exports.getByKeyring = getByKeyring;
	exports.triggerSync = triggerSync;


/***/ },
/* 35 */
/*!******************************************!*\
  !*** ./src/controller/sub.controller.js ***!
  \******************************************/
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Mailvelope - secure email with OpenPGP encryption for Webmail
	 * Copyright (C) 2014-2015 Mailvelope GmbH
	 *
	 * This program is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU Affero General Public License version 3
	 * as published by the Free Software Foundation.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU Affero General Public License for more details.
	 *
	 * You should have received a copy of the GNU Affero General Public License
	 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	'use strict';


	var mvelo = __webpack_require__(/*! lib-mvelo */ 8);

	function SubController(port) {
	  this.mvelo = mvelo;
	  this.prefs = __webpack_require__(/*! ../modules/prefs */ 26);
	  this.model = __webpack_require__(/*! ../modules/pgpModel */ 21);
	  this.ports = {};
	  if (port) {
	    var sender = this.parseViewName(port.name);
	    this.mainType = sender.type;
	    this.id = sender.id;
	    this.ports[this.mainType] = port;
	  }
	}

	SubController.prototype = Object.create(mvelo.EventHandler.prototype); // add new event api functions

	SubController.prototype.addPort = function(port) {
	  var type = this.parseViewName(port.name).type;
	  this.ports[type] = port;
	};

	SubController.prototype.removePort = function(port) {
	  if (Object.keys(this.ports).length === 0) {
	    // controllers instantiated without port should not be deleted
	    return false;
	  }
	  if (port.name) {
	    var view = this.parseViewName(port.name);
	    if (view.id !== this.id) {
	      throw new Error('View ID mismatch.');
	    }
	    delete this.ports[view.type];
	  } else {
	    var that = this;
	    Object.keys(this.ports).forEach(function(type) {
	      if (that.ports[type].ref === port) {
	        delete that.ports[type];
	      }
	    });
	  }
	  return Object.keys(this.ports).length === 0;
	};

	SubController.prototype.parseViewName = parseViewName;

	SubController.prototype.openSecuritySettings = function() {
	  var hash = '#security';
	  var that = this;

	  this.mvelo.tabs.loadOptionsTab(hash, function(old, tab) {
	    if (old) {
	      that.mvelo.tabs.sendMessage(tab, {
	        event: 'reload-options',
	        hash: hash
	      });
	    }
	  });
	};

	SubController.prototype.openApp = function({fragment}) {
	  let hash = `#${fragment}`;

	  this.mvelo.tabs.loadOptionsTab(hash, (old, tab) => {
	    if (old) {
	      this.mvelo.tabs.sendMessage(tab, {
	        event: 'reload-options',
	        hash: hash
	      });
	    }
	  });
	};


	var factory = {};

	factory.repo = new Map();

	factory.get = function(type, port) {
	  if (factory.repo.has(type)) {
	    let contrConstructor = factory.repo.get(type);
	    let subContr = new contrConstructor(port);
	    if (subContr.singleton) {
	      // there should be only one instance for this type, new instance overwrites old
	      let existingController = getByMainType(type)[0];
	      if (existingController) {
	        controllers.delete(existingController.id);
	      }
	    }
	    if (!port) {
	      if (!subContr.id) {
	        throw new Error('Subcontroller instantiated without port requires id.');
	      }
	      controllers.set(subContr.id, subContr);
	    }
	    return subContr;
	  } else {
	    throw new Error('No controller found for view type: ' + type);
	  }
	};

	factory.register = function(type, contrConstructor) {
	  if (factory.repo.has(type)) {
	    throw new Error('Subcontroller class already registered.');
	  } else {
	    factory.repo.set(type, contrConstructor);
	  }
	};

	let controllers = new Map();

	function addPort(port) {
	  var sender = parseViewName(port.name);
	  var subContr = controllers.get(sender.id);
	  if (subContr) {
	    subContr.addPort(port);
	  } else {
	    var newContr = factory.get(sender.type, port);
	    controllers.set(sender.id, newContr);
	  }
	}

	function removePort(port) {
	  if (port.name) {
	    let id = parseViewName(port.name).id;
	    removeId(id, port);
	  } else {
	    for (let id of controllers.keys()) {
	      removeId(id, port);
	    }
	  }
	}

	function removeId(id, port) {
	  let del = controllers.has(id) && controllers.get(id).removePort(port);
	  if (del) {
	    // last port removed from controller, delete controller
	    controllers.delete(id);
	  }
	}

	function handlePortMessage(msg) {
	  var id = parseViewName(msg.sender).id;
	  getByID(id).handlePortMessage(msg);
	}

	function getByID(id) {
	  return controllers.get(id);
	}

	function getByMainType(type) {
	  let result = [];
	  controllers.forEach(contr => {
	    if (contr.mainType === type) {
	      result.push(contr);
	    }
	  });
	  return result;
	}

	function isActive(type) {
	  return getByMainType(type).length !== 0;
	}

	function parseViewName(viewName) {
	  var pair = viewName.split('-');
	  return { type: pair[0], id: pair[1] };
	}

	var activeKeyringId = mvelo.LOCAL_KEYRING_ID;

	function setActiveKeyringId(keyringId) {
	  activeKeyringId = keyringId;
	}

	function getActiveKeyringId() {
	  return activeKeyringId;
	}

	exports.SubController = SubController;
	exports.addPort = addPort;
	exports.removePort = removePort;
	exports.handlePortMessage = handlePortMessage;
	exports.factory = factory;
	exports.getByID = getByID;
	exports.getByMainType = getByMainType;
	exports.isActive = isActive;
	exports.setActiveKeyringId = setActiveKeyringId;
	exports.getActiveKeyringId = getActiveKeyringId;


/***/ },
/* 36 */
/*!*********************************!*\
  !*** ./src/modules/trustKey.js ***!
  \*********************************/
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Mailvelope - secure email with OpenPGP encryption for Webmail
	 * Copyright (C) 2015 Mailvelope GmbH
	 *
	 * This program is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU Affero General Public License version 3
	 * as published by the Free Software Foundation.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU Affero General Public License for more details.
	 *
	 * You should have received a copy of the GNU Affero General Public License
	 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	'use strict';


	var mvelo = __webpack_require__(/*! lib-mvelo */ 8);
	var openpgp = __webpack_require__(/*! openpgp */ 22);
	var certs = __webpack_require__(/*! ./certs */ 37);

	var keyMap = new Map();

	function init() {
	  var key = openpgp.key.readArmored(certs.c1und1).keys[0];
	  keyMap.set('gmx.net', key);
	  keyMap.set('web.de', key);
	}

	function getTrustKey(keyringId) {
	  var domain = keyringId.split(mvelo.KEYRING_DELIMITER)[0];
	  return keyMap.get(domain);
	}

	function isKeyPseudoRevoked(keyringId, key) {
	  var trustKey = getTrustKey(keyringId);
	  if (!trustKey) {
	    return false;
	  }
	  return key.users.some(function(user) {
	    return isUserPseudoRevoked(user, trustKey, key.primaryKey);
	  });
	}

	function isUserPseudoRevoked(user, trustKey, primaryKey) {
	  if (!user.revocationCertifications || !user.userId) {
	    return false;
	  }
	  return user.revocationCertifications.some(function(revCert) {
	    return revCert.reasonForRevocationFlag === 101 &&
	           verifyCert(revCert, user.userId, trustKey, primaryKey) &&
	           !hasNewerCert(user, trustKey, primaryKey, revCert.created);
	  });
	}

	function hasNewerCert(user, trustKey, primaryKey, sigDate) {
	  if (!user.otherCertifications) {
	    return false;
	  }
	  return user.otherCertifications.some(function(otherCert) {
	    return verifyCert(otherCert, user.userId, trustKey, primaryKey) &&
	           otherCert.created > sigDate;
	  });
	}

	function verifyCert(cert, userId, trustKey, primaryKey) {
	  return cert.issuerKeyId.equals(trustKey.primaryKey.getKeyId()) &&
	         !cert.isExpired() &&
	         (cert.verified ||
	          cert.verify(trustKey.primaryKey, {userid: userId, key: primaryKey}));
	}

	exports.init = init;
	exports.getTrustKey = getTrustKey;
	exports.isKeyPseudoRevoked = isKeyPseudoRevoked;


/***/ },
/* 37 */
/*!******************************!*\
  !*** ./src/modules/certs.js ***!
  \******************************/
/***/ function(module, exports) {

	
	'use strict';


	var c1und1 =
	  ['-----BEGIN PGP PUBLIC KEY BLOCK-----',
	  'Version: GnuPG v2',
	  '',
	  'mQINBFXN6cIBEADO5yr/f4p+KQacn6Op+ghIhoxz6ASANCqbMCiPV5+mUw7PFD6z',
	  'eUVql++M57i8l1EXNvs+0rdkVwQ1qWvW6Xb9vWmcpK1xksk4B9YFx+k9MnxJMmXJ',
	  'E6WVybXdbHABj5eITWSHQCWSnIGKYoyA7tioXJ4OG8mFj1YoVYU+OtEJBpGvROyv',
	  'ivD7RwV5OWMoobWbMKvcwBoSEgHMxCFhqBc9+1wl3fXOVNsld7aTUagiNB2LVgFA',
	  'qMyqeuJhEdsiyesm6T0BFDMQDYxK9IdtVxa7eUGTUtSYFkEyLIb/1A9DxFAnwJxA',
	  'wgyZxQpbYRSqQFJO8fGCnmXZhah03K4LLcdL3i2f0TGjSCEODWC2JkEGFtXsFUMe',
	  'sp/cwi0NtOOl1D1xy2qhAHTWdbDLyL1B1bdFOK+hRLKnXmt/v8ms86OGjDEsWGVb',
	  'YOvTMjlJMHuM1f7sd0FcpPiCRDwVi7udJNL0R/0FFCSHFqKLqA8jFh2Pd2/RS/Ir',
	  'J4aI0PCXxtKocshW8Sduir2ZqA+LH48FtXMfMglEw+IQI6B+7CGINnbH46RJBuNb',
	  'tPkTWyChQrPW/zg1N1jr42BRuUIhyW8C9CjXZqfJobIuDWhq7OkLGI3dsdEBV7NE',
	  'vHuGeog2hHpPxB/07rbm00QlkFc+6wr/vsZS1SPqcg0gPEB/0TB3I4m7aQARAQAB',
	  'tBMxJjEgTWFpbCZNZWRpYSBHbWJIiQKBBBMBCgBrBQJVzenCAhsDBQkS187+BQsJ',
	  'CAcDBRUKCQgLBRYCAwEAAh4BAheAQxhodHRwOi8vdHJ1c3Qud2ViLmRlL3B1Ymtl',
	  'eW1hbS8xYW5kMV9tYWlsX2FuZF9tZWRpYV9nbWJoX3B1YmtleS5hc2MACgkQHaQX',
	  'E5VT4bnRTA//eN8zGAAfKH7OlB13kYtZZzro+lrqr+VQuMYXv+oFSmRHVlar0Za8',
	  'Ltumn3eFncT+7S7w+IQrcKUdB6MjgJCQJK+MbRy2sopTnF6ZCrIyk0sjBYAs5XwS',
	  '6JT+u1FhEyzicS7Wr/G06AjlBn9n8Tyl8PIXc3bR0JpU0CCEo4jE+I9KcT0mPPT7',
	  'm+f2por9xBPKCja16BwEon+bhg6j+auvNuaWCet2WYPa0dWcyLM53Bdc+XpAdnCX',
	  '/0XdzLGwqMR4pqgYJ/TJgynFrjKS+jf/HAhO6+cCKXDQP3pRznu3U3fq5RPNLZ5Y',
	  '2AFjP5RcTmalwXc8A1rq4046cnXjzGOqTOSzQU2LTOf2UWa0738SQL3bQCEc5uER',
	  'egtnrjveDiGvdDlUsWinsDHmQWOWK2LAmzhFxx6j9g/Vin6/SqanZpD4EY/iI2F4',
	  'iPTZyjqDXu8Gy9h0uuSLrvV4HAxNwP1sQPx+JSTqSGOSkHjV6TvwJOuuFp1aLRMQ',
	  'XR179S48HUoGSVSfsyX4y5CVjBy9tWqBQ7IQza/G8S9VbV4HinX9bFkUyMjLzhRL',
	  'OEtSTXD0d8vumgbn35q5cm4YnD42u+casdRy8k37U1Zh1jqVBfojLpB0MuKkDtGJ',
	  'mYSVoP6g/EB13wa7F20IbYBLHKZMMuCK/8ZHvnXzzHkBe9I2JCNji4Q=',
	  '=nF4m',
	  '-----END PGP PUBLIC KEY BLOCK-----'].join('\n');

	exports.c1und1 = c1und1;


/***/ },
/* 38 */
/*!**********************************!*\
  !*** ./src/modules/keyserver.js ***!
  \**********************************/
/***/ function(module, exports) {

	/**
	 * Mailvelope - secure email with OpenPGP encryption for Webmail
	 * Copyright (C) 2012-2015 Mailvelope GmbH
	 *
	 * This program is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU Affero General Public License version 3
	 * as published by the Free Software Foundation.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU Affero General Public License for more details.
	 *
	 * You should have received a copy of the GNU Affero General Public License
	 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	/**
	 * @fileOverview A simple HTTP client for Mailvelope Key Server's REST api.
	 */

	'use strict';


	/**
	 * Creates an instance of the keyserver client.
	 * @param {Object} mvelo      An instance of the mvelo lib
	 * @param {String} baseUrl    (optional) The server's base url
	 */
	function KeyServer(mvelo, baseUrl) {
	  this._mvelo = mvelo;
	  this._baseUrl = baseUrl || 'https://keys.mailvelope.com';
	}

	/**
	 * Check the user's preferences if TOFU/auto-lookup is enabled.
	 * @return {boolean}   If TOFU is enabled or not
	 */
	KeyServer.prototype.getTOFUPreference = function() {
	  var prefs = this._mvelo.storage.get('mailvelopePreferences');
	  return prefs && prefs.keyserver && prefs.keyserver.mvelo_tofu_lookup === true;
	};

	/**
	 * Get a verified public key either from the server by either email address,
	 * key id, or fingerprint.
	 * @param {string} options.email         (optional) The user id's email address
	 * @param {string} options.keyId         (optional) The long 16 char key id
	 * @param {string} options.fingerprint   (optional) The 40 char v4 fingerprint
	 * @yield {Object}                       The public key object
	 */
	KeyServer.prototype.lookup = function(options) {
	  return this._mvelo.util.fetch(this._url(options))
	  .then(function(response) {
	    if (response.status === 200) {
	      return response.json();
	    }
	  });
	};

	/**
	 * Upload a public key to the server for verification by the user. Normally
	 * a verification mail is sent out to all of the key's user ids, unless a primary
	 * email attribute is supplied. In which case only one email is sent.
	 * @param {string} options.publicKeyArmored   The ascii armored key block
	 * @param {string} options.primaryEmail       (optional) user's primary email address
	 * @yield {undefined}
	 */
	KeyServer.prototype.upload = function(options) {
	  var payload = {publicKeyArmored: options.publicKeyArmored};
	  if (options.primaryEmail) {
	    payload.primaryEmail = options.primaryEmail;
	  }
	  return this._mvelo.util.fetch(this._url(), {
	    method: 'POST',
	    body: JSON.stringify(payload)
	  })
	  .then(this._checkStatus);
	};

	/**
	 * Request deletion of a user's key from the keyserver. Either an email address or
	 * the key id have to be specified. The user will receive a verification email
	 * after the request to confirm deletion.
	 * @param {string} options.email   (optional) The user id's email address
	 * @param {string} options.keyId   (optional) The long 16 char key id
	 * @yield {undefined}
	 */
	KeyServer.prototype.remove = function(options) {
	  return this._mvelo.util.fetch(this._url(options), {
	    method: 'DELETE'
	  })
	  .then(this._checkStatus);
	};

	/**
	 * Helper function to create a url with the proper query string for an
	 * api request.
	 * @param  {string} options.email         (optional) The user id's email address
	 * @param  {string} options.keyId         (optional) The long 16 char key id
	 * @param  {string} options.fingerprint   (optional) The 40 char v4 fingerprint
	 * @return {string}                       The complete request url
	 */
	KeyServer.prototype._url = function(options) {
	  var url = this._baseUrl + '/api/v1/key';
	  if (options && options.email) {
	    url += '?email=' + encodeURIComponent(options.email);
	  } else if (options && options.fingerprint) {
	    url += '?fingerprint=' + encodeURIComponent(options.fingerprint);
	  } else if (options && options.keyId) {
	    url += '?keyId=' + encodeURIComponent(options.keyId);
	  }
	  return url;
	};

	/**
	 * Helper function to deal with the HTTP response status
	 * @param  {Object} response   The fetch api's response object
	 * @return {Object|Error}      Either the response object in case of a successful
	 *                             request or an Error containing the statusText
	 */
	KeyServer.prototype._checkStatus = function(response) {
	  if (response.status >= 200 && response.status < 300) {
	    return response;
	  } else {
	    var error = new Error(response.statusText);
	    error.response = response;
	    throw error;
	  }
	};

	module.exports = KeyServer;


/***/ },
/* 39 */
/*!******************************************!*\
  !*** ./src/controller/api.controller.js ***!
  \******************************************/
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Mailvelope - secure email with OpenPGP encryption for Webmail
	 * Copyright (C) 2015 Mailvelope GmbH
	 *
	 * This program is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU Affero General Public License version 3
	 * as published by the Free Software Foundation.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU Affero General Public License for more details.
	 *
	 * You should have received a copy of the GNU Affero General Public License
	 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	'use strict';


	var mvelo = __webpack_require__(/*! lib-mvelo */ 8);
	var keyring = __webpack_require__(/*! ../modules/keyring */ 32);
	var sub = __webpack_require__(/*! ./sub.controller */ 35);
	var openpgp = __webpack_require__(/*! openpgp */ 22);
	var model = __webpack_require__(/*! ../modules/pgpModel */ 21);

	function handleApiEvent(request, sender, sendResponse) {
	  var keyRing, attr;
	  try {
	    switch (request.event) {
	      case 'get-keyring':
	        keyRing = keyring.getById(request.keyringId);
	        if (keyRing) {
	          attr = keyRing.getAttributes();
	          sendResponse({data: {revision: attr.logo_revision}});
	          sub.setActiveKeyringId(request.keyringId);
	        }
	        break;
	      case 'create-keyring':
	        keyRing = keyring.createKeyring(request.keyringId);
	        if (keyRing) {
	          keyRing.sync.activate();
	          sendResponse({data: {}});
	          sub.setActiveKeyringId(request.keyringId);
	        }
	        break;
	      case 'query-valid-key':
	        var keyMap = keyring.getById(request.keyringId).getKeyByAddress(request.recipients, {validity: true, fingerprint: true, sort: true});
	        Object.keys(keyMap).forEach(function(email) {
	          if (keyMap[email]) {
	            keyMap[email] = {
	              keys: keyMap[email].map(function(key) {
	                return {
	                  fingerprint: key.primaryKey.getFingerprint(),
	                  lastModified: model.getLastModifiedDate(key).toISOString()
	                };
	              })
	            };
	          }
	        });
	        sendResponse({error: null, data: keyMap});
	        break;
	      case 'export-own-pub-key':
	        var keyIdMap = keyring.getById(request.keyringId).getKeyIdByAddress([request.emailAddr], {validity: true, pub: false, priv: true, sort: true});
	        if (!keyIdMap[request.emailAddr]) {
	          sendResponse({error: {message: 'No key pair found for this email address.', code: 'NO_KEY_FOR_ADDRESS'}});
	          return;
	        }
	        // only take first valid key
	        if (keyIdMap[request.emailAddr].length > 1) {
	          keyIdMap[request.emailAddr].length = 1;
	        }
	        var armored = keyring.getById(request.keyringId).getArmoredKeys(keyIdMap[request.emailAddr], {pub: true});
	        sendResponse({error: null, data: armored[0].armoredPublic});
	        break;
	      case 'import-pub-key':
	        sub.factory.get('importKeyDialog').importKey(request.keyringId, request.armored, function(err, status) {
	          sendResponse({error: err, data: status});
	        });
	        return true;
	      case 'set-logo':
	        attr = keyring.getById(request.keyringId).getAttributes();
	        if (attr.logo_revision && attr.logo_revision > request.revision) {
	          sendResponse({error: {message: 'New logo revision < existing revision.', code: 'REVISION_INVALID'}});
	          return;
	        }
	        keyring.setKeyringAttr(request.keyringId, {logo_revision: request.revision, logo_data_url: request.dataURL});
	        sendResponse({error: null, data: null});
	        break;
	      case 'has-private-key':
	        var fingerprint = request.fingerprint.toLowerCase().replace(/\s/g, '');
	        var key = keyring.getById(request.keyringId).keyring.privateKeys.getForId(fingerprint);
	        var valid = key && key.verifyPrimaryKey() === openpgp.enums.keyStatus.valid;
	        sendResponse({error: null, data: (key && valid ? true : false)});
	        break;
	      case 'open-settings':
	        request.keyringId = request.keyringId || mvelo.LOCAL_KEYRING_ID;
	        var hash = '?krid=' + encodeURIComponent(request.keyringId) + '#settings';
	        mvelo.tabs.loadOptionsTab(hash, function(old, tab) {
	          if (old) {
	            mvelo.tabs.sendMessage(tab, {
	              event: 'reload-options',
	              hash: hash
	            });
	          }
	        });

	        sendResponse({error: null, data: null});
	        break;
	      default:
	        console.log('unknown event:', request);
	    }
	  } catch (err) {
	    sendResponse({error: {message: err.message, code: err.code  || 'INTERNAL_ERROR'}});
	  }
	}

	exports.handleApiEvent = handleApiEvent;


/***/ },
/* 40 */
/*!**********************************************!*\
  !*** ./src/controller/decrypt.controller.js ***!
  \**********************************************/
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Mailvelope - secure email with OpenPGP encryption for Webmail
	 * Copyright (C) 2014-2015 Mailvelope GmbH
	 *
	 * This program is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU Affero General Public License version 3
	 * as published by the Free Software Foundation.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU Affero General Public License for more details.
	 *
	 * You should have received a copy of the GNU Affero General Public License
	 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	'use strict';


	var sub = __webpack_require__(/*! ./sub.controller */ 35);
	var uiLog = __webpack_require__(/*! ../modules/uiLog */ 29);
	var syncCtrl = __webpack_require__(/*! ./sync.controller */ 34);

	function DecryptController(port) {
	  sub.SubController.call(this, port);
	  this.pwdControl = null;
	  this.decryptPopup = null;
	  this.mailreader = __webpack_require__(/*! mailreader-parser */ 41);
	  this.options = {};
	  this.keyringId = this.mvelo.LOCAL_KEYRING_ID;
	  this.isContainer = this.mainType === 'decryptCont'; // main view is a container component
	}

	DecryptController.prototype = Object.create(sub.SubController.prototype);

	DecryptController.prototype.handlePortMessage = function(msg) {
	  var that = this;
	  switch (msg.event) {
	    // done
	    case 'decrypt-dialog-cancel':
	      this.dialogCancel();
	      break;
	    // done
	    case 'decrypt-inline-init':
	      if (this.mvelo.windows.modalActive && !this.decryptPopup) {
	        // password dialog or modal dialog already open from other component
	        if (this.ports.dFrame) {
	          this.ports.dFrame.postMessage({event: 'remove-dialog'});
	        } else if (this.ports.decryptCont) {
	          this.ports.decryptCont.postMessage({event: 'error-message', error: 'modal-active'});
	        }
	      } else {
	        var port = this.ports.dFrame || this.ports.decryptCont;
	        // get armored message
	        port.postMessage({event: 'get-armored'});
	      }
	      break;
	    case 'dframe-display-popup':
	      // decrypt popup potentially needs pwd dialog
	      if (this.mvelo.windows.modalActive) {
	        // password dialog or modal dialog already open
	        this.ports.dFrame.postMessage({event: 'remove-dialog'});
	      } else {
	        this.mvelo.windows.openPopup('components/decrypt-popup/decryptPopup.html?id=' + this.id, {width: 742, height: 550, modal: true}, function(window) {
	          that.decryptPopup = window;
	        });
	      }
	      break;
	    case 'set-armored':
	      this.options = msg.options;
	      if (msg.keyringId) {
	        this.keyringId = msg.keyringId;
	      }
	      this.decrypt(msg.data, this.keyringId);
	      break;
	    case 'decrypt-inline-user-input':
	      uiLog.push(msg.source, msg.type);
	      break;
	    case 'open-security-settings':
	      this.openSecuritySettings();
	      break;
	    default:
	      console.log('unknown event', msg);
	  }
	};

	DecryptController.prototype.dialogCancel = function() {
	  // forward event to decrypt frame
	  this.ports.dFrame.postMessage({event: 'dialog-cancel'});
	  if (this.decryptPopup) {
	    try {
	      this.decryptPopup.close();
	    } catch (e) {}
	    this.decryptPopup = null;
	  }
	};

	DecryptController.prototype.decrypt = function(armored, keyringId) {
	  var that = this;
	  this.model.readMessage(armored, keyringId)
	    .then(function(message) {
	      return that.prepareKey(message);
	    })
	    .then(function(message) {
	      syncCtrl.triggerSync(message);
	      return that.decryptMessage(message);
	    })
	    .then(function(content) {
	      var handlers = {
	        noEvent: true,
	        onMessage: function(msg) {
	          this.noEvent = false;
	          that.ports.dDialog.postMessage({event: 'decrypted-message', message: msg});
	        },
	        onAttachment: function(part) {
	          this.noEvent = false;
	          that.ports.dDialog.postMessage({event: 'add-decrypted-attachment', message: part});
	        }
	      };
	      if (that.ports.dDialog && content.signatures) {
	        that.ports.dDialog.postMessage({event: 'signature-verification', signers: content.signatures, isContainer: that.isContainer});
	      }
	      return that.parseMessage(content.text, handlers, 'html');
	    })
	    .then(function() {
	      if (that.ports.decryptCont) {
	        that.ports.decryptCont.postMessage({event: 'decrypt-done'});
	      }
	    })
	    .catch(function(error) {
	      if (error.code === 'PWD_DIALOG_CANCEL') {
	        if (that.ports.dFrame) {
	          return that.dialogCancel();
	        }
	      }
	      if (that.ports.dDialog) {
	        that.ports.dDialog.postMessage({event: 'error-message', error: error.message});
	      }
	      if (that.ports.decryptCont) {
	        error = error || {};
	        switch (error.code) {
	          case 'ARMOR_PARSE_ERROR':
	          case 'PWD_DIALOG_CANCEL':
	          case 'NO_KEY_FOUND':
	            error = that.mvelo.util.mapError(error);
	            break;
	          default:
	            error = {
	              // don't expose internal errors to API
	              code: 'DECRYPT_ERROR',
	              message: 'Generic decrypt error'
	            };
	        }
	        that.ports.decryptCont.postMessage({event: 'error-message', error: error});
	      }
	    })
	    .then(() => {
	      this.ports.dPopup && this.ports.dPopup.postMessage({event: 'show-message'});
	    });
	};

	DecryptController.prototype.prepareKey = function(message, openPopup) {
	  this.pwdControl = sub.factory.get('pwdDialog');
	  message.reason = 'PWD_DIALOG_REASON_DECRYPT';
	  message.openPopup = openPopup !== undefined ? openPopup : this.ports.decryptCont || this.prefs.data().security.display_decrypted == this.mvelo.DISPLAY_INLINE;
	  message.beforePasswordRequest = () => {
	    this.ports.dPopup && this.ports.dPopup.postMessage({event: 'show-pwd-dialog', id: this.pwdControl.id});
	  };
	  message.keyringId = this.keyringId;
	  return this.pwdControl.unlockKey(message);
	};

	DecryptController.prototype.decryptMessage = function(message) {
	  var that = this;
	  return new Promise(function(resolve, reject) {
	    message.options = message.options || that.options;
	    that.model.decryptMessage(message, that.keyringId, function(err, content) {
	      if (err) {
	        return reject(err);
	      }
	      resolve(content);
	    });
	  });
	};

	// attribution: https://github.com/whiteout-io/mail-html5
	DecryptController.prototype.filterBodyParts = function(bodyParts, type, result) {
	  var that = this;
	  result = result || [];
	  bodyParts.forEach(function(part) {
	    if (part.type === type) {
	      result.push(part);
	    } else if (Array.isArray(part.content)) {
	      that.filterBodyParts(part.content, type, result);
	    }
	  });
	  return result;
	};

	/**
	 * handlers: onAttachment, onMessage
	 */
	DecryptController.prototype.parseMessage = function(rawText, handlers, encoding) {
	  if (/^\s*(MIME-Version|Content-Type|Content-Transfer-Encoding|From|Date):/.test(rawText)) {
	    return this.parseMIME(rawText, handlers, encoding);
	  } else {
	    return this.parseInline(rawText, handlers, encoding);
	  }
	};

	DecryptController.prototype.parseMIME = function(rawText, handlers, encoding) {
	  var that = this;
	  return new Promise(function(resolve) {
	    // mailreader expects rawText in pseudo-binary
	    rawText = unescape(encodeURIComponent(rawText));
	    that.mailreader.parse([{raw: rawText}], function(parsed) {
	      if (parsed && parsed.length > 0) {
	        var htmlParts = [];
	        var textParts = [];
	        if (encoding === 'html') {
	          that.filterBodyParts(parsed, 'html', htmlParts);
	          if (htmlParts.length) {
	            that.mvelo.util.parseHTML(htmlParts[0].content, function(sanitized) {
	              handlers.onMessage(sanitized);
	            });
	          } else {
	            that.filterBodyParts(parsed, 'text', textParts);
	            if (textParts.length) {
	              handlers.onMessage(that.mvelo.util.text2html(textParts[0].content));
	            }
	          }
	        } else if (encoding === 'text') {
	          that.filterBodyParts(parsed, 'text', textParts);
	          if (textParts.length) {
	            handlers.onMessage(textParts[0].content);
	          } else {
	            that.filterBodyParts(parsed, 'html', htmlParts);
	            if (htmlParts.length) {
	              handlers.onMessage(that.mvelo.util.html2text(textParts[0].content));
	            }
	          }
	        }
	        var attachmentParts = [];
	        that.filterBodyParts(parsed, 'attachment', attachmentParts);
	        attachmentParts.forEach(function(part) {
	          part.filename = that.mvelo.util.encodeHTML(part.filename);
	          part.content = that.mvelo.util.ab2str(part.content.buffer);
	          handlers.onAttachment(part);
	        });
	      }
	      if (handlers.noEvent) {
	        handlers.onMessage('');
	      }
	      resolve();
	    });
	  });
	};

	DecryptController.prototype.parseInline = function(rawText, handlers, encoding) {
	  var that = this;
	  return new Promise(function(resolve) {
	    if (/(<\/a>|<br>|<\/div>|<\/p>|<\/b>|<\/u>|<\/i>|<\/ul>|<\/li>)/.test(rawText)) {
	      // legacy html mode
	      if (encoding === 'html') {
	        that.mvelo.util.parseHTML(rawText, function(sanitized) {
	          handlers.onMessage(sanitized);
	          resolve();
	        });
	      } else if (encoding === 'text') {
	        handlers.onMessage(that.mvelo.util.html2text(rawText));
	        resolve();
	      }
	    } else {
	      // plain text
	      if (encoding === 'html') {
	        handlers.onMessage(that.mvelo.util.text2html(rawText));
	      } else if (encoding === 'text') {
	        handlers.onMessage(rawText);
	      }
	      resolve();
	    }
	  });
	};

	exports.DecryptController = DecryptController;


/***/ },
/* 41 */
/*!***********************************************!*\
  !*** ./~/mailreader/src/mailreader-parser.js ***!
  \***********************************************/
/***/ function(module, exports, __webpack_require__) {

	var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;(function(factory) {
	    'use strict';

	    if (true) {
	        !(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(/*! emailjs-mime-parser */ 42), __webpack_require__(/*! emailjs-stringencoding */ 44)], __WEBPACK_AMD_DEFINE_FACTORY__ = (factory), __WEBPACK_AMD_DEFINE_RESULT__ = (typeof __WEBPACK_AMD_DEFINE_FACTORY__ === 'function' ? (__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__)) : __WEBPACK_AMD_DEFINE_FACTORY__), __WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
	    } else if (typeof exports === 'object') {
	        module.exports = factory(require('emailjs-mime-parser'), require('emailjs-stringencoding'));
	    }
	})(function(MimeParser, stringencoding) {
	    'use strict';

	    var TextDecoder = stringencoding.TextDecoder;

	    var parser = {};

	    // parse the body parts and handle the results for the individual mime nodes
	    parser.parse = function(bodyParts, cb) {
	        var parsedCounter = 0;

	        // feed each body part to the mimeparser
	        bodyParts.forEach(function(bodyPart) {
	            var parser = new MimeParser();

	            // body part has been parsed
	            parser.onend = function() {
	                delete bodyPart.raw; // part has been parsed, we can remove the raw attribute

	                bodyPart.content = []; // holds subparts, e.g. for encrypted and/or signed nodes

	                // traverse through the parsed result
	                walkMimeTree(parser.node, bodyPart);

	                // we're done with a body part, are we done with all parts?
	                parsedCounter++;
	                if (parsedCounter < bodyParts.length) {
	                    // nope, more body parts left to parse
	                    return;
	                }

	                // we're done
	                cb(bodyParts);
	            };

	            // parse the body part
	            parser.end(bodyPart.raw);
	        });
	    };

	    // functions that return true/false if they were able to handle a certain kind of body part
	    var mimeTreeMatchers = [matchEncrypted, matchSigned, matchAttachment, matchText, matchHtml];

	    // do a depth-first traversal of the body part, check for each node if it matches
	    // a certain type, then poke into its child nodes. not a pure inorder traversal b/c
	    // lookup is terminated when higher-up node can already be matched, e.g. encrypted/signed
	    // multipart nodes
	    function walkMimeTree(mimeNode, bodyPart) {
	        // normalize the mime node
	        normalize(mimeNode);

	        // iterate through the matchers and see how to best take care of the mime node
	        var i = mimeTreeMatchers.length;
	        while (i--) {
	            if (mimeTreeMatchers[i](mimeNode, bodyPart)) {
	                return;
	            }
	        }

	        // depth-first traverse the child nodes
	        if (mimeNode._childNodes) {
	            mimeNode._childNodes.forEach(function(childNode) {
	                walkMimeTree(childNode, bodyPart);
	            });
	        }
	    }

	    /**
	     * Matches encrypted PGP/MIME nodes
	     *
	     * multipart/encrypted
	     * |
	     * |-- application/pgp-encrypted
	     * |-- application/octet-stream <-- ciphertext
	     */
	    function matchEncrypted(node, bodyPart) {
	        var isEncrypted = /^multipart\/encrypted/i.test(node.contentType.value) && node._childNodes && node._childNodes[1];
	        if (!isEncrypted) {
	            return false;
	        }

	        // normalize the child node
	        normalize(node._childNodes[1]);

	        bodyPart.content = new TextDecoder('utf-8').decode(node._childNodes[1].content);
	        return true;
	    }

	    /**
	     * Matches signed PGP/MIME nodes
	     *
	     * multipart/signed
	     * |
	     * |-- *** (signed mime sub-tree)
	     * |-- application/pgp-signature
	     */
	    function matchSigned(node, bodyPart) {
	        // does the content type fit?
	        var isSigned = /^multipart\/signed/i.test(node.contentType.value);

	        // does the mime node have child nodes?
	        isSigned = isSigned && node._childNodes && node._childNodes[0] && node._childNodes[1];

	        // normalize the child nodes
	        isSigned && normalize(node._childNodes[0]);
	        isSigned && normalize(node._childNodes[1]);

	        // do the child nodes fit?
	        isSigned = isSigned && /^application\/pgp-signature/i.test(node._childNodes[1].contentType.value);

	        if (!isSigned) {
	            return false;
	        }

	        // remember the correct node to do the parsing of the nested nodes
	        var part;
	        if (bodyPart.type === 'signed') {
	            // this mime node is the signed node we gave to the mimeparser
	            part = bodyPart;
	        } else {
	            // this parsed mime node is part of an encrypted node
	            part = {
	                type: 'signed',
	                content: []
	            };
	            bodyPart.content.push(part);
	        }

	        // email.js automatically converts \r\n to \n ... normalize to \r\n for signature check!
	        part.signedMessage = node._childNodes[0].raw.replace(/\r/g, '').replace(/\n/g, '\r\n');
	        part.signature = new TextDecoder('utf-8').decode(node._childNodes[1].content);

	        // walk the mime tree to find the nested nodes
	        walkMimeTree(node._childNodes[0], part);

	        return true;
	    }

	    /**
	     * Matches non-attachment text/plain nodes
	     */
	    function matchText(node, bodyPart) {
	        var disposition = node.headers['content-disposition'],
	            isText = (/^text\/plain/i.test(node.contentType.value) && (!disposition || (disposition && disposition[0].value !== 'attachment')));

	        if (!isText) {
	            return false;
	        }

	        var content = new TextDecoder('utf-8').decode(node.content).replace(/([\r]?\n)*$/g, '');
	        if (bodyPart.type === 'text') {
	            // this mime node is the text node we gave to the mimeparser
	            bodyPart.content = content;
	        } else {
	            // this mime node is part of a signed or encrypted node
	            bodyPart.content.push({
	                type: 'text',
	                content: content
	            });
	        }

	        return true;
	    }

	    /**
	     * Matches non-attachment text/html nodes
	     */
	    function matchHtml(node, bodyPart) {
	        var disposition = node.headers['content-disposition'],
	            isHtml = (/^text\/html/i.test(node.contentType.value) && (!disposition || (disposition && disposition[0].value !== 'attachment')));

	        if (!isHtml) {
	            return false;
	        }

	        var content = new TextDecoder('utf-8').decode(node.content).replace(/([\r]?\n)*$/g, '');
	        if (bodyPart.type === 'html') {
	            // this mime node is the html node we gave to the mimeparser
	            bodyPart.content = content;
	        } else {
	            // this mime node is part of a signed or encrypted node
	            bodyPart.content.push({
	                type: 'html',
	                content: content
	            });
	        }

	        return true;
	    }

	    /**
	     * Matches non-attachment text/html nodes
	     */
	    function matchAttachment(node, bodyPart) {
	        var disposition = node.headers['content-disposition'],
	            contentType = node.contentType.value,
	            isTextAttachment = /^text\//i.test(contentType) && disposition && disposition[0].value === 'attachment',
	            isOtherAttachment = !/^text\//i.test(contentType) && !/^multipart\//i.test(contentType);

	        if (!isTextAttachment && !isOtherAttachment) {
	            return false;
	        }

	        var part;
	        if (bodyPart.type === 'attachment') {
	            // this mime node is the attachment node we gave to the mimeparser
	            part = bodyPart;
	        } else {
	            // this mime node is part of a signed or encrypted node
	            part = {
	                type: 'attachment'
	            };
	            bodyPart.content.push(part);
	        }

	        part.content = node.content;
	        part.id = part.id || (node.headers['content-id'] && node.headers['content-id'][0].value.replace(/[<>]/g, ''));
	        part.mimeType = part.mimeType || contentType;
	        part.filename = part.filename || (disposition && disposition[0].params.filename) || node.contentType.params.name || 'attachment';

	        return true;
	    }


	    /**
	     * Normalizes a mime node where necessary
	     * - add contentType
	     * - add contentType params
	     * - add content
	     * - add raw
	     * - normalize content-id
	     * - normalize content-disposition
	     */
	    function normalize(node) {
	        // normalize the optional content-type, fallback to 'application/octet-stream'
	        node.contentType = node.contentType || {};
	        node.contentType.value = node.contentType.value || 'application/octet-stream';
	        node.contentType.params = node.contentType.params || {};

	        // normalize the contents
	        node.raw = node.raw || '';
	        node.content = node.content || '';

	        // optional
	        if (node.headers['content-id']) {
	            // node has content-id set, let's normalize it
	            var cid = node.headers['content-id'][0] = node.headers['content-id'][0] || {};
	            cid.value = cid.value || '';
	        }

	        // optional
	        if (node.headers['content-disposition']) {
	            // this is an attachment node, let's normalize node.headers['content-disposition']
	            var disposition = node.headers['content-disposition'][0] = node.headers['content-disposition'][0] || {};
	            disposition.value = disposition.value || '';
	            disposition.params = disposition.params || {};
	        }
	    }

	    return parser;
	});

/***/ },
/* 42 */
/*!**********************************************************!*\
  !*** ./~/emailjs-mime-parser/src/emailjs-mime-parser.js ***!
  \**********************************************************/
/***/ function(module, exports, __webpack_require__) {

	var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;// Copyright (c) 2013 Andris Reinman
	//
	// Permission is hereby granted, free of charge, to any person obtaining a copy
	// of this software and associated documentation files (the "Software"), to deal
	// in the Software without restriction, including without limitation the rights
	// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
	// copies of the Software, and to permit persons to whom the Software is
	// furnished to do so, subject to the following conditions:

	// The above copyright notice and this permission notice shall be included in
	// all copies or substantial portions of the Software.

	// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
	// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
	// THE SOFTWARE.

	(function(root, factory) {
	    'use strict';

	    if (true) {
	        !(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(/*! emailjs-mime-codec */ 43), __webpack_require__(/*! emailjs-addressparser */ 46)], __WEBPACK_AMD_DEFINE_FACTORY__ = (factory), __WEBPACK_AMD_DEFINE_RESULT__ = (typeof __WEBPACK_AMD_DEFINE_FACTORY__ === 'function' ? (__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__)) : __WEBPACK_AMD_DEFINE_FACTORY__), __WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
	    } else if (typeof exports === 'object') {
	        module.exports = factory(require('emailjs-mime-codec'), require('emailjs-addressparser'));
	    } else {
	        root['emailjs-mime-parser'] = factory(root['emailjs-mime-codec'], root['emailjs-addressparser']);
	    }

	}(this, function(mimecodec, addressparser) {
	    'use strict';

	    var TIMEZONE_ABBREVATIONS = {
	        "ACDT": "+1030",
	        "ACST": "+0930",
	        "ACT": "+0800",
	        "ADT": "-0300",
	        "AEDT": "+1100",
	        "AEST": "+1000",
	        "AFT": "+0430",
	        "AKDT": "-0800",
	        "AKST": "-0900",
	        "AMST": "-0300",
	        "AMT": "+0400",
	        "ART": "-0300",
	        "AST": "+0300",
	        "AWDT": "+0900",
	        "AWST": "+0800",
	        "AZOST": "-0100",
	        "AZT": "+0400",
	        "BDT": "+0800",
	        "BIOT": "+0600",
	        "BIT": "-1200",
	        "BOT": "-0400",
	        "BRT": "-0300",
	        "BST": "+0600",
	        "BTT": "+0600",
	        "CAT": "+0200",
	        "CCT": "+0630",
	        "CDT": "-0500",
	        "CEDT": "+0200",
	        "CEST": "+0200",
	        "CET": "+0100",
	        "CHADT": "+1345",
	        "CHAST": "+1245",
	        "CHOT": "+0800",
	        "CHST": "+1000",
	        "CHUT": "+1000",
	        "CIST": "-0800",
	        "CIT": "+0800",
	        "CKT": "-1000",
	        "CLST": "-0300",
	        "CLT": "-0400",
	        "COST": "-0400",
	        "COT": "-0500",
	        "CST": "-0600",
	        "CT": "+0800",
	        "CVT": "-0100",
	        "CWST": "+0845",
	        "CXT": "+0700",
	        "DAVT": "+0700",
	        "DDUT": "+1000",
	        "DFT": "+0100",
	        "EASST": "-0500",
	        "EAST": "-0600",
	        "EAT": "+0300",
	        "ECT": "-0500",
	        "EDT": "-0400",
	        "EEDT": "+0300",
	        "EEST": "+0300",
	        "EET": "+0200",
	        "EGST": "+0000",
	        "EGT": "-0100",
	        "EIT": "+0900",
	        "EST": "-0500",
	        "FET": "+0300",
	        "FJT": "+1200",
	        "FKST": "-0300",
	        "FKT": "-0400",
	        "FNT": "-0200",
	        "GALT": "-0600",
	        "GAMT": "-0900",
	        "GET": "+0400",
	        "GFT": "-0300",
	        "GILT": "+1200",
	        "GIT": "-0900",
	        "GMT": "+0000",
	        "GST": "+0400",
	        "GYT": "-0400",
	        "HADT": "-0900",
	        "HAEC": "+0200",
	        "HAST": "-1000",
	        "HKT": "+0800",
	        "HMT": "+0500",
	        "HOVT": "+0700",
	        "HST": "-1000",
	        "ICT": "+0700",
	        "IDT": "+0300",
	        "IOT": "+0300",
	        "IRDT": "+0430",
	        "IRKT": "+0900",
	        "IRST": "+0330",
	        "IST": "+0530",
	        "JST": "+0900",
	        "KGT": "+0600",
	        "KOST": "+1100",
	        "KRAT": "+0700",
	        "KST": "+0900",
	        "LHST": "+1030",
	        "LINT": "+1400",
	        "MAGT": "+1200",
	        "MART": "-0930",
	        "MAWT": "+0500",
	        "MDT": "-0600",
	        "MET": "+0100",
	        "MEST": "+0200",
	        "MHT": "+1200",
	        "MIST": "+1100",
	        "MIT": "-0930",
	        "MMT": "+0630",
	        "MSK": "+0400",
	        "MST": "-0700",
	        "MUT": "+0400",
	        "MVT": "+0500",
	        "MYT": "+0800",
	        "NCT": "+1100",
	        "NDT": "-0230",
	        "NFT": "+1130",
	        "NPT": "+0545",
	        "NST": "-0330",
	        "NT": "-0330",
	        "NUT": "-1100",
	        "NZDT": "+1300",
	        "NZST": "+1200",
	        "OMST": "+0700",
	        "ORAT": "+0500",
	        "PDT": "-0700",
	        "PET": "-0500",
	        "PETT": "+1200",
	        "PGT": "+1000",
	        "PHOT": "+1300",
	        "PHT": "+0800",
	        "PKT": "+0500",
	        "PMDT": "-0200",
	        "PMST": "-0300",
	        "PONT": "+1100",
	        "PST": "-0800",
	        "PYST": "-0300",
	        "PYT": "-0400",
	        "RET": "+0400",
	        "ROTT": "-0300",
	        "SAKT": "+1100",
	        "SAMT": "+0400",
	        "SAST": "+0200",
	        "SBT": "+1100",
	        "SCT": "+0400",
	        "SGT": "+0800",
	        "SLST": "+0530",
	        "SRT": "-0300",
	        "SST": "+0800",
	        "SYOT": "+0300",
	        "TAHT": "-1000",
	        "THA": "+0700",
	        "TFT": "+0500",
	        "TJT": "+0500",
	        "TKT": "+1300",
	        "TLT": "+0900",
	        "TMT": "+0500",
	        "TOT": "+1300",
	        "TVT": "+1200",
	        "UCT": "+0000",
	        "ULAT": "+0800",
	        "UTC": "+0000",
	        "UYST": "-0200",
	        "UYT": "-0300",
	        "UZT": "+0500",
	        "VET": "-0430",
	        "VLAT": "+1000",
	        "VOLT": "+0400",
	        "VOST": "+0600",
	        "VUT": "+1100",
	        "WAKT": "+1200",
	        "WAST": "+0200",
	        "WAT": "+0100",
	        "WEDT": "+0100",
	        "WEST": "+0100",
	        "WET": "+0000",
	        "WST": "+0800",
	        "YAKT": "+1000",
	        "YEKT": "+0600",
	        "Z": "+0000"
	    };

	    /**
	     * Creates a parser for a mime stream
	     *
	     * @constructor
	     */
	    function MimeParser() {
	        /**
	         * Returned to the write calls
	         */
	        this.running = true;

	        /**
	         * Cache for parsed node objects
	         */
	        this.nodes = {};

	        /**
	         * Root node object
	         */
	        this.node = new MimeNode(null, this);

	        /**
	         * Data is written to nodes one line at the time. If entire line
	         * is not received yet, buffer it before passing on
	         */
	        this._remainder = '';
	    }

	    /**
	     * Writes a chunk of data to the processing queue. Splits data to lines and feeds
	     * complete lines to the current node element
	     *
	     * @param {Uint8Array|String} chunk Chunk to be processed. Either an Uint8Array value or a 'binary' string
	     */
	    MimeParser.prototype.write = function(chunk) {
	        if (!chunk || !chunk.length) {
	            return !this.running;
	        }

	        var lines = (this._remainder + (typeof chunk === 'object' ?
	            mimecodec.fromTypedArray(chunk) : chunk)).split(/\r?\n/g);
	        this._remainder = lines.pop();

	        for (var i = 0, len = lines.length; i < len; i++) {
	            this.node.writeLine(lines[i]);
	        }

	        return !this.running;
	    };

	    /**
	     * Indicates that there is no more data coming
	     *
	     * @param {Uint8Array|String} [chunk] Final chunk to be processed
	     */
	    MimeParser.prototype.end = function(chunk) {
	        if (chunk && chunk.length) {
	            this.write(chunk);
	        }

	        if (this.node._lineCount || this._remainder) {
	            this.node.writeLine(this._remainder);
	            this._remainder = '';
	        }

	        if (this.node) {
	            this.node.finalize();
	        }

	        this.onend();
	    };

	    /**
	     * Retrieves a mime part object for specified path
	     *
	     *   parser.getNode('1.2.3')
	     *
	     * @param {String} path Path to the node
	     */
	    MimeParser.prototype.getNode = function(path) {
	        path = path || '';
	        return this.nodes['node' + path] || null;
	    };

	    // PARSER EVENTS

	    /**
	     * Override this function.
	     * Called when the parsing is ended
	     * @event
	     */
	    MimeParser.prototype.onend = function() {};

	    /**
	     * Override this function.
	     * Called when the parsing is ended
	     * @event
	     * @param {Object} node Current mime part. See node.header for header lines
	     */
	    MimeParser.prototype.onheader = function() {};

	    /**
	     * Override this function.
	     * Called when a body chunk is emitted
	     * @event
	     * @param {Object} node Current mime part
	     * @param {Uint8Array} chunk Body chunk
	     */
	    MimeParser.prototype.onbody = function() {};

	    // NODE PROCESSING

	    /**
	     * Creates an object that holds and manages one part of the multipart message
	     *
	     * @constructor
	     * @param {Object} parentNode Reference to the parent element. If not specified, then this is root node
	     * @param {Object} parser MimeParser object
	     */
	    function MimeNode(parentNode, parser) {

	        // Public properties

	        /**
	         * An array of unfolded header lines
	         */
	        this.header = [];

	        /**
	         * An object that holds header key=value pairs
	         */
	        this.headers = {};

	        /**
	         * Path for this node
	         */
	        this.path = parentNode ? parentNode.path.concat(parentNode._childNodes.length + 1) : [];

	        // Private properties

	        /**
	         * Reference to the 'master' parser object
	         */
	        this._parser = parser;

	        /**
	         * Parent node for this specific node
	         */
	        this._parentNode = parentNode;

	        /**
	         * Current state, always starts out with HEADER
	         */
	        this._state = 'HEADER';

	        /**
	         * Body buffer
	         */
	        this._bodyBuffer = '';

	        /**
	         * Line counter bor the body part
	         */
	        this._lineCount = 0;

	        /**
	         * If this is a multipart or message/rfc822 mime part, the value
	         * will be converted to array and hold all child nodes for this node
	         */
	        this._childNodes = false;

	        /**
	         * Active child node (if available)
	         */
	        this._currentChild = false;

	        /**
	         * Remainder string when dealing with base64 and qp values
	         */
	        this._lineRemainder = '';

	        /**
	         * Indicates if this is a multipart node
	         */
	        this._isMultipart = false;

	        /**
	         * Stores boundary value for current multipart node
	         */
	        this._multipartBoundary = false;

	        /**
	         * Indicates if this is a message/rfc822 node
	         */
	        this._isRfc822 = false;

	        /**
	         * Stores the raw content of this node
	         */
	        this.raw = '';

	        // Att this node to the path cache
	        this._parser.nodes['node' + this.path.join('.')] = this;
	    }

	    // Public methods

	    /**
	     * Processes an enitre input line
	     *
	     * @param {String} line Entire input line as 'binary' string
	     */
	    MimeNode.prototype.writeLine = function(line) {

	        this.raw += (this.raw ? '\n' : '') + line;

	        if (this._state === 'HEADER') {
	            this._processHeaderLine(line);
	        } else if (this._state === 'BODY') {
	            this._processBodyLine(line);
	        }
	    };

	    /**
	     * Processes any remainders
	     */
	    MimeNode.prototype.finalize = function() {
	        if (this._isRfc822) {
	            this._currentChild.finalize();
	        } else {
	            this._emitBody(true);
	        }
	    };

	    // Private methods

	    /**
	     * Processes a line in the HEADER state. It the line is empty, change state to BODY
	     *
	     * @param {String} line Entire input line as 'binary' string
	     */
	    MimeNode.prototype._processHeaderLine = function(line) {
	        if (!line) {
	            this._parseHeaders();
	            this._parser.onheader(this);
	            this._state = 'BODY';
	            return;
	        }

	        if (line.match(/^\s/) && this.header.length) {
	            this.header[this.header.length - 1] += '\n' + line;
	        } else {
	            this.header.push(line);
	        }
	    };

	    /**
	     * Joins folded header lines and calls Content-Type and Transfer-Encoding processors
	     */
	    MimeNode.prototype._parseHeaders = function() {

	        // Join header lines
	        var key, value, hasBinary;

	        for (var i = 0, len = this.header.length; i < len; i++) {
	            value = this.header[i].split(':');
	            key = (value.shift() || '').trim().toLowerCase();
	            value = (value.join(':') || '').replace(/\n/g, '').trim();

	            if (value.match(/[\u0080-\uFFFF]/)) {
	                if (!this.charset) {
	                    hasBinary = true;
	                }
	                // use default charset at first and if the actual charset is resolved, the conversion is re-run
	                value = mimecodec.charset.decode(mimecodec.charset.convert(mimecodec.toTypedArray(value), this.charset || 'iso-8859-1'));
	            }

	            if (!this.headers[key]) {
	                this.headers[key] = [this._parseHeaderValue(key, value)];
	            } else {
	                this.headers[key].push(this._parseHeaderValue(key, value));
	            }

	            if (!this.charset && key === 'content-type') {
	                this.charset = this.headers[key][this.headers[key].length - 1].params.charset;
	            }

	            if (hasBinary && this.charset) {
	                // reset values and start over once charset has been resolved and 8bit content has been found
	                hasBinary = false;
	                this.headers = {};
	                i = -1; // next iteration has i == 0
	            }
	        }

	        this._processContentType();
	        this._processContentTransferEncoding();
	    };

	    /**
	     * Parses single header value
	     * @param {String} key Header key
	     * @param {String} value Value for the key
	     * @return {Object} parsed header
	     */
	    MimeNode.prototype._parseHeaderValue = function(key, value) {
	        var parsedValue, isAddress = false;

	        switch (key) {
	            case 'content-type':
	            case 'content-transfer-encoding':
	            case 'content-disposition':
	            case 'dkim-signature':
	                parsedValue = mimecodec.parseHeaderValue(value);
	                break;
	            case 'from':
	            case 'sender':
	            case 'to':
	            case 'reply-to':
	            case 'cc':
	            case 'bcc':
	            case 'abuse-reports-to':
	            case 'errors-to':
	            case 'return-path':
	            case 'delivered-to':
	                isAddress = true;
	                parsedValue = {
	                    value: [].concat(addressparser.parse(value) || [])
	                };
	                break;
	            case 'date':
	                parsedValue = {
	                    value: this._parseDate(value)
	                };
	                break;
	            default:
	                parsedValue = {
	                    value: value
	                };
	        }
	        parsedValue.initial = value;

	        this._decodeHeaderCharset(parsedValue, {
	            isAddress: isAddress
	        });

	        return parsedValue;
	    };

	    /**
	     * Checks if a date string can be parsed. Falls back replacing timezone
	     * abbrevations with timezone values
	     *
	     * @param {String} str Date header
	     * @returns {String} UTC date string if parsing succeeded, otherwise returns input value
	     */
	    MimeNode.prototype._parseDate = function(str) {
	        str = (str || '').toString().trim();

	        var date = new Date(str);

	        if (this._isValidDate(date)) {
	            return date.toUTCString().replace(/GMT/, '+0000');
	        }

	        // Assume last alpha part is a timezone
	        // Ex: "Date: Thu, 15 May 2014 13:53:30 EEST"
	        str = str.replace(/\b[a-z]+$/i, function(tz) {
	            tz = tz.toUpperCase();
	            if (TIMEZONE_ABBREVATIONS.hasOwnProperty(tz)) {
	                return TIMEZONE_ABBREVATIONS[tz];
	            }
	            return tz;
	        });

	        date = new Date(str);

	        if (this._isValidDate(date)) {
	            return date.toUTCString().replace(/GMT/, '+0000');
	        } else {
	            return str;
	        }
	    };

	    /**
	     * Checks if a value is a Date object and it contains an actual date value
	     * @param {Date} date Date object to check
	     * @returns {Boolean} True if the value is a valid date
	     */
	    MimeNode.prototype._isValidDate = function(date) {
	        return Object.prototype.toString.call(date) === '[object Date]' && date.toString() !== 'Invalid Date';
	    };

	    MimeNode.prototype._decodeHeaderCharset = function(parsed, options) {
	        options = options || {};

	        // decode default value
	        if (typeof parsed.value === 'string') {
	            parsed.value = mimecodec.mimeWordsDecode(parsed.value);
	        }

	        // decode possible params
	        Object.keys(parsed.params || {}).forEach(function(key) {
	            if (typeof parsed.params[key] === 'string') {
	                parsed.params[key] = mimecodec.mimeWordsDecode(parsed.params[key]);
	            }
	        });

	        // decode addresses
	        if (options.isAddress && Array.isArray(parsed.value)) {
	            parsed.value.forEach(function(addr) {
	                if (addr.name) {
	                    addr.name = mimecodec.mimeWordsDecode(addr.name);
	                    if (Array.isArray(addr.group)) {
	                        this._decodeHeaderCharset({
	                            value: addr.group
	                        }, {
	                            isAddress: true
	                        });
	                    }
	                }
	            }.bind(this));
	        }

	        return parsed;
	    };

	    /**
	     * Parses Content-Type value and selects following actions.
	     */
	    MimeNode.prototype._processContentType = function() {
	        var contentDisposition;

	        this.contentType = this.headers['content-type'] && this.headers['content-type'][0] ||
	            mimecodec.parseHeaderValue('text/plain');
	        this.contentType.value = (this.contentType.value || '').toLowerCase().trim();
	        this.contentType.type = (this.contentType.value.split('/').shift() || 'text');

	        if (this.contentType.params && this.contentType.params.charset && !this.charset) {
	            this.charset = this.contentType.params.charset;
	        }

	        if (this.contentType.type === 'multipart' && this.contentType.params.boundary) {
	            this._childNodes = [];
	            this._isMultipart = (this.contentType.value.split('/').pop() || 'mixed');
	            this._multipartBoundary = this.contentType.params.boundary;
	        }

	        if (this.contentType.value === 'message/rfc822') {
	            /**
	             * Parse message/rfc822 only if the mime part is not marked with content-disposition: attachment,
	             * otherwise treat it like a regular attachment
	             */
	            contentDisposition = this.headers['content-disposition'] && this.headers['content-disposition'][0] ||
	                mimecodec.parseHeaderValue('');
	            if ((contentDisposition.value || '').toLowerCase().trim() !== 'attachment') {
	                this._childNodes = [];
	                this._currentChild = new MimeNode(this, this._parser);
	                this._childNodes.push(this._currentChild);
	                this._isRfc822 = true;
	            }
	        }
	    };

	    /**
	     * Parses Content-Trasnfer-Encoding value to see if the body needs to be converted
	     * before it can be emitted
	     */
	    MimeNode.prototype._processContentTransferEncoding = function() {
	        this.contentTransferEncoding = this.headers['content-transfer-encoding'] && this.headers['content-transfer-encoding'][0] ||
	            mimecodec.parseHeaderValue('7bit');
	        this.contentTransferEncoding.value = (this.contentTransferEncoding.value || '').toLowerCase().trim();
	    };

	    /**
	     * Processes a line in the BODY state. If this is a multipart or rfc822 node,
	     * passes line value to child nodes.
	     *
	     * @param {String} line Entire input line as 'binary' string
	     */
	    MimeNode.prototype._processBodyLine = function(line) {
	        var curLine, match;

	        this._lineCount++;

	        if (this._isMultipart) {
	            if (line === '--' + this._multipartBoundary) {
	                if (this._currentChild) {
	                    this._currentChild.finalize();
	                }
	                this._currentChild = new MimeNode(this, this._parser);
	                this._childNodes.push(this._currentChild);
	            } else if (line === '--' + this._multipartBoundary + '--') {
	                if (this._currentChild) {
	                    this._currentChild.finalize();
	                }
	                this._currentChild = false;
	            } else if (this._currentChild) {
	                this._currentChild.writeLine(line);
	            } else {
	                // Ignore body for multipart
	            }
	        } else if (this._isRfc822) {
	            this._currentChild.writeLine(line);
	        } else {
	            switch (this.contentTransferEncoding.value) {
	                case 'base64':
	                    curLine = this._lineRemainder + line.trim();

	                    if (curLine.length % 4) {
	                        this._lineRemainder = curLine.substr(-curLine.length % 4);
	                        curLine = curLine.substr(0, curLine.length - this._lineRemainder.length);
	                    } else {
	                        this._lineRemainder = '';
	                    }

	                    if (curLine.length) {
	                        this._bodyBuffer += mimecodec.fromTypedArray(mimecodec.base64.decode(curLine));
	                    }

	                    break;
	                case 'quoted-printable':
	                    curLine = this._lineRemainder + (this._lineCount > 1 ? '\n' : '') + line;

	                    if ((match = curLine.match(/=[a-f0-9]{0,1}$/i))) {
	                        this._lineRemainder = match[0];
	                        curLine = curLine.substr(0, curLine.length - this._lineRemainder.length);
	                    } else {
	                        this._lineRemainder = '';
	                    }

	                    this._bodyBuffer += curLine.replace(/\=(\r?\n|$)/g, '').replace(/=([a-f0-9]{2})/ig, function(m, code) {
	                        return String.fromCharCode(parseInt(code, 16));
	                    });
	                    break;
	                    // case '7bit':
	                    // case '8bit':
	                default:
	                    this._bodyBuffer += (this._lineCount > 1 ? '\n' : '') + line;
	                    break;
	            }
	        }
	    };

	    /**
	     * Emits a chunk of the body
	     *
	     * @param {Boolean} forceEmit If set to true does not keep any remainders
	     */
	    MimeNode.prototype._emitBody = function() {
	        var contentDisposition = this.headers['content-disposition'] && this.headers['content-disposition'][0] ||
	            mimecodec.parseHeaderValue('');
	        var delSp;

	        if (this._isMultipart || !this._bodyBuffer) {
	            return;
	        }

	        // Process flowed text before emitting it
	        if (/^text\/(plain|html)$/i.test(this.contentType.value) &&
	            this.contentType.params && /^flowed$/i.test(this.contentType.params.format)) {

	            delSp = /^yes$/i.test(this.contentType.params.delsp);

	            this._bodyBuffer = this._bodyBuffer.
	            split('\n').
	            // remove soft linebreaks
	            // soft linebreaks are added after space symbols
	            reduce(function(previousValue, currentValue) {
	                var body = previousValue;
	                if (delSp) {
	                    // delsp adds spaces to text to be able to fold it
	                    // these spaces can be removed once the text is unfolded
	                    body = body.replace(/[ ]+$/, '');
	                }
	                if (/ $/.test(previousValue) && !/(^|\n)\-\- $/.test(previousValue)) {
	                    return body + currentValue;
	                } else {
	                    return body + '\n' + currentValue;
	                }
	            }).
	            // remove whitespace stuffing
	            // http://tools.ietf.org/html/rfc3676#section-4.4
	            replace(/^ /gm, '');
	        }

	        this.content = mimecodec.toTypedArray(this._bodyBuffer);

	        if (/^text\/(plain|html)$/i.test(this.contentType.value) && !/^attachment$/i.test(contentDisposition.value)) {

	            if (!this.charset && /^text\/html$/i.test(this.contentType.value)) {
	                this.charset = this._detectHTMLCharset(this._bodyBuffer);
	            }

	            // decode "binary" string to an unicode string
	            if (!/^utf[\-_]?8$/i.test(this.charset)) {
	                this.content = mimecodec.charset.convert(mimecodec.toTypedArray(this._bodyBuffer), this.charset || 'iso-8859-1');
	            }

	            // override charset for text nodes
	            this.charset = this.contentType.params.charset = 'utf-8';
	        }
	        this._bodyBuffer = '';

	        this._parser.onbody(this, this.content);
	    };

	    /**
	     * Detect charset from a html file
	     *
	     * @param {String} html Input HTML
	     * @returns {String} Charset if found or undefined
	     */
	    MimeNode.prototype._detectHTMLCharset = function(html) {
	        var charset, input, meta;

	        if (typeof html !== 'string') {
	            html = html.toString('ascii');
	        }

	        html = html.replace(/\r?\n|\r/g, " ");

	        if ((meta = html.match(/<meta\s+http-equiv=["'\s]*content-type[^>]*?>/i))) {
	            input = meta[0];
	        }

	        if (input) {
	            charset = input.match(/charset\s?=\s?([a-zA-Z\-_:0-9]*);?/);
	            if (charset) {
	                charset = (charset[1] || '').trim().toLowerCase();
	            }
	        }

	        if (!charset && (meta = html.match(/<meta\s+charset=["'\s]*([^"'<>\/\s]+)/i))) {
	            charset = (meta[1] || '').trim().toLowerCase();
	        }

	        return charset;
	    };

	    return MimeParser;
	}));


/***/ },
/* 43 */
/*!********************************************************!*\
  !*** ./~/emailjs-mime-codec/src/emailjs-mime-codec.js ***!
  \********************************************************/
/***/ function(module, exports, __webpack_require__) {

	var __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;// Copyright (c) 2013 Andris Reinman
	//
	// Permission is hereby granted, free of charge, to any person obtaining a copy
	// of this software and associated documentation files (the "Software"), to deal
	// in the Software without restriction, including without limitation the rights
	// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
	// copies of the Software, and to permit persons to whom the Software is
	// furnished to do so, subject to the following conditions:

	// The above copyright notice and this permission notice shall be included in
	// all copies or substantial portions of the Software.

	// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
	// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
	// THE SOFTWARE.

	(function(root, factory) {
	    'use strict';

	    var encoding;

	    if (true) {
	        // amd for browser
	        !(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(/*! emailjs-stringencoding */ 44)], __WEBPACK_AMD_DEFINE_RESULT__ = function(encoding) {
	            return factory(encoding.TextEncoder, encoding.TextDecoder, root.btoa);
	        }.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__), __WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
	    } else if (typeof exports === 'object' && typeof navigator !== 'undefined') {
	        // common.js for browser
	        encoding = require('emailjs-stringencoding');
	        module.exports = factory(encoding.TextEncoder, encoding.TextDecoder, root.btoa);
	    } else if (typeof exports === 'object') {
	        // common.js for node.js
	        encoding = require('emailjs-stringencoding');
	        module.exports = factory(encoding.TextEncoder, encoding.TextDecoder, function(str) {
	            var NodeBuffer = require('buffer').Buffer;
	            return new NodeBuffer(str, 'binary').toString("base64");
	        });
	    } else {
	        // global for browser
	        root['emailjs-mime-codec'] = factory(root.TextEncoder, root.TextDecoder, root.btoa);
	    }
	}(this, function(TextEncoder, TextDecoder, btoa) {
	    'use strict';

	    btoa = btoa || base64Encode;

	    var mimecodec = {
	        /**
	         * Encodes all non printable and non ascii bytes to =XX form, where XX is the
	         * byte value in hex. This function does not convert linebreaks etc. it
	         * only escapes character sequences
	         *
	         * @param {String|Uint8Array} data Either a string or an Uint8Array
	         * @param {String} [fromCharset='UTF-8'] Source encoding
	         * @return {String} Mime encoded string
	         */
	        mimeEncode: function(data, fromCharset) {
	            fromCharset = fromCharset || 'UTF-8';

	            var buffer = mimecodec.charset.convert(data || '', fromCharset),
	                ranges = [
	                    // https://tools.ietf.org/html/rfc2045#section-6.7
	                    [0x09], // <TAB>
	                    [0x0A], // <LF>
	                    [0x0D], // <CR>
	                    [0x20, 0x3C], // <SP>!"#$%&'()*+,-./0123456789:;
	                    [0x3E, 0x7E] // >?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}
	                ],
	                result = '',
	                ord;

	            for (var i = 0, len = buffer.length; i < len; i++) {
	                ord = buffer[i];
	                // if the char is in allowed range, then keep as is, unless it is a ws in the end of a line
	                if (mimecodec._checkRanges(ord, ranges) && !((ord === 0x20 || ord === 0x09) && (i === len - 1 || buffer[i + 1] === 0x0a || buffer[i + 1] === 0x0d))) {
	                    result += String.fromCharCode(ord);
	                    continue;
	                }
	                result += '=' + (ord < 0x10 ? '0' : '') + ord.toString(16).toUpperCase();
	            }

	            return result;
	        },

	        /**
	         * Decodes mime encoded string to an unicode string
	         *
	         * @param {String} str Mime encoded string
	         * @param {String} [fromCharset='UTF-8'] Source encoding
	         * @return {String} Decoded unicode string
	         */
	        mimeDecode: function(str, fromCharset) {
	            str = (str || '').toString();

	            fromCharset = fromCharset || 'UTF-8';

	            var encodedBytesCount = (str.match(/\=[\da-fA-F]{2}/g) || []).length,
	                bufferLength = str.length - encodedBytesCount * 2,
	                chr, hex,
	                buffer = new Uint8Array(bufferLength),
	                bufferPos = 0;

	            for (var i = 0, len = str.length; i < len; i++) {
	                chr = str.charAt(i);
	                if (chr === '=' && (hex = str.substr(i + 1, 2)) && /[\da-fA-F]{2}/.test(hex)) {
	                    buffer[bufferPos++] = parseInt(hex, 16);
	                    i += 2;
	                    continue;
	                }
	                buffer[bufferPos++] = chr.charCodeAt(0);
	            }

	            return mimecodec.charset.decode(buffer, fromCharset);
	        },

	        /**
	         * Encodes a string or an typed array of given charset into unicode
	         * base64 string. Also adds line breaks
	         *
	         * @param {String|Uint8Array} data String to be base64 encoded
	         * @param {String} [fromCharset='UTF-8']
	         * @return {String} Base64 encoded string
	         */
	        base64Encode: function(data, fromCharset) {
	            var buf, b64;

	            if (fromCharset !== 'binary' && typeof data !== 'string') {
	                buf = mimecodec.charset.convert(data || '', fromCharset);
	            } else {
	                buf = data;
	            }

	            b64 = mimecodec.base64.encode(buf);
	            return mimecodec._addSoftLinebreaks(b64, 'base64');
	        },

	        /**
	         * Decodes a base64 string of any charset into an unicode string
	         *
	         * @param {String} str Base64 encoded string
	         * @param {String} [fromCharset='UTF-8'] Original charset of the base64 encoded string
	         * @return {String} Decoded unicode string
	         */
	        base64Decode: function(str, fromCharset) {
	            var buf = mimecodec.base64.decode(str || '', 'buffer');
	            return mimecodec.charset.decode(buf, fromCharset);
	        },

	        /**
	         * Encodes a string or an Uint8Array into a quoted printable encoding
	         * This is almost the same as mimeEncode, except line breaks will be changed
	         * as well to ensure that the lines are never longer than allowed length
	         *
	         * @param {String|Uint8Array} data String or an Uint8Array to mime encode
	         * @param {String} [fromCharset='UTF-8'] Original charset of the string
	         * @return {String} Mime encoded string
	         */
	        quotedPrintableEncode: function(data, fromCharset) {
	            var mimeEncodedStr = mimecodec.mimeEncode(data, fromCharset);

	            mimeEncodedStr = mimeEncodedStr.
	                // fix line breaks, ensure <CR><LF>
	            replace(/\r?\n|\r/g, '\r\n').
	                // replace spaces in the end of lines
	            replace(/[\t ]+$/gm, function(spaces) {
	                return spaces.replace(/ /g, '=20').replace(/\t/g, '=09');
	            });

	            // add soft line breaks to ensure line lengths sjorter than 76 bytes
	            return mimecodec._addSoftLinebreaks(mimeEncodedStr, 'qp');
	        },

	        /**
	         * Decodes a string from a quoted printable encoding. This is almost the
	         * same as mimeDecode, except line breaks will be changed as well
	         *
	         * @param {String} str Mime encoded string to decode
	         * @param {String} [fromCharset='UTF-8'] Original charset of the string
	         * @return {String} Mime decoded string
	         */
	        quotedPrintableDecode: function(str, fromCharset) {
	            str = (str || '').toString();

	            str = str.
	                // remove invalid whitespace from the end of lines
	            replace(/[\t ]+$/gm, '').
	                // remove soft line breaks
	            replace(/\=(?:\r?\n|$)/g, '');

	            return mimecodec.mimeDecode(str, fromCharset);
	        },

	        /**
	         * Encodes a string or an Uint8Array to an UTF-8 MIME Word (rfc2047)
	         *
	         * @param {String|Uint8Array} data String to be encoded
	         * @param {String} mimeWordEncoding='Q' Encoding for the mime word, either Q or B
	         * @param {Number} [maxLength=0] If set, split mime words into several chunks if needed
	         * @param {String} [fromCharset='UTF-8'] Source sharacter set
	         * @return {String} Single or several mime words joined together
	         */
	        mimeWordEncode: function(data, mimeWordEncoding, maxLength, fromCharset) {
	            mimeWordEncoding = (mimeWordEncoding || 'Q').toString().toUpperCase().trim().charAt(0);

	            if (!fromCharset && typeof maxLength === 'string' && !maxLength.match(/^[0-9]+$/)) {
	                fromCharset = maxLength;
	                maxLength = undefined;
	            }

	            maxLength = maxLength || 0;

	            var encodedStr,
	                toCharset = 'UTF-8',
	                i, len, parts;

	            if (maxLength && maxLength > 7 + toCharset.length) {
	                maxLength -= (7 + toCharset.length);
	            }

	            if (mimeWordEncoding === 'Q') {
	                encodedStr = mimecodec.mimeEncode(data, fromCharset);
	                // https://tools.ietf.org/html/rfc2047#section-5 rule (3)
	                encodedStr = encodedStr.replace(/[^a-z0-9!*+\-\/=]/ig, function(chr) {
	                    var code = chr.charCodeAt(0);
	                    if(chr === ' '){
	                        return '_';
	                    }else{
	                        return '=' + (code < 0x10 ? '0' : '') + code.toString(16).toUpperCase();
	                    }
	                });
	            } else if (mimeWordEncoding === 'B') {
	                encodedStr = typeof data === 'string' ? data : mimecodec.decode(data, fromCharset);
	                maxLength = Math.max(3, (maxLength - maxLength % 4) / 4 * 3);
	            }

	            if (maxLength && encodedStr.length > maxLength) {
	                if (mimeWordEncoding === 'Q') {
	                    encodedStr = mimecodec._splitMimeEncodedString(encodedStr, maxLength).join('?= =?' + toCharset + '?' + mimeWordEncoding + '?');
	                } else {

	                    // RFC2047 6.3 (2) states that encoded-word must include an integral number of characters, so no chopping unicode sequences
	                    parts = [];
	                    for (i = 0, len = encodedStr.length; i < len; i += maxLength) {
	                        parts.push(mimecodec.base64.encode(encodedStr.substr(i, maxLength)));
	                    }

	                    if (parts.length > 1) {
	                        return '=?' + toCharset + '?' + mimeWordEncoding + '?' + parts.join('?= =?' + toCharset + '?' + mimeWordEncoding + '?') + '?=';
	                    } else {
	                        encodedStr = parts.join('');
	                    }
	                }
	            } else if (mimeWordEncoding === 'B') {
	                encodedStr = mimecodec.base64.encode(encodedStr);
	            }

	            return '=?' + toCharset + '?' + mimeWordEncoding + '?' + encodedStr + (encodedStr.substr(-2) === '?=' ? '' : '?=');
	        },

	        /**
	         * Finds word sequences with non ascii text and converts these to mime words
	         *
	         * @param {String|Uint8Array} data String to be encoded
	         * @param {String} mimeWordEncoding='Q' Encoding for the mime word, either Q or B
	         * @param {Number} [maxLength=0] If set, split mime words into several chunks if needed
	         * @param {String} [fromCharset='UTF-8'] Source sharacter set
	         * @return {String} String with possible mime words
	         */
	        mimeWordsEncode: function(data, mimeWordEncoding, maxLength, fromCharset) {
	            if (!fromCharset && typeof maxLength === 'string' && !maxLength.match(/^[0-9]+$/)) {
	                fromCharset = maxLength;
	                maxLength = undefined;
	            }

	            maxLength = maxLength || 0;

	            var decodedValue = mimecodec.charset.decode(mimecodec.charset.convert((data || ''), fromCharset)),
	                encodedValue;

	            encodedValue = decodedValue.replace(/([^\s\u0080-\uFFFF]*[\u0080-\uFFFF]+[^\s\u0080-\uFFFF]*(?:\s+[^\s\u0080-\uFFFF]*[\u0080-\uFFFF]+[^\s\u0080-\uFFFF]*\s*)?)+/g, function(match) {
	                return match.length ? mimecodec.mimeWordEncode(match, mimeWordEncoding || 'Q', maxLength) : '';
	            });

	            return encodedValue;
	        },

	        /**
	         * Decode a complete mime word encoded string
	         *
	         * @param {String} str Mime word encoded string
	         * @return {String} Decoded unicode string
	         */
	        mimeWordDecode: function(str) {
	            str = (str || '').toString().trim();

	            var fromCharset, encoding, match;

	            match = str.match(/^\=\?([\w_\-\*]+)\?([QqBb])\?([^\?]+)\?\=$/i);
	            if (!match) {
	                return str;
	            }

	            // RFC2231 added language tag to the encoding
	            // see: https://tools.ietf.org/html/rfc2231#section-5
	            // this implementation silently ignores this tag
	            fromCharset = match[1].split('*').shift();

	            encoding = (match[2] || 'Q').toString().toUpperCase();
	            str = (match[3] || '').replace(/_/g, ' ');

	            if (encoding === 'B') {
	                return mimecodec.base64Decode(str, fromCharset);
	            } else if (encoding === 'Q') {
	                return mimecodec.mimeDecode(str, fromCharset);
	            } else {
	                return str;
	            }

	        },

	        /**
	         * Decode a string that might include one or several mime words
	         *
	         * @param {String} str String including some mime words that will be encoded
	         * @return {String} Decoded unicode string
	         */
	        mimeWordsDecode: function(str) {
	            str = (str || '').toString();
	            str = str.
	            replace(/(=\?[^?]+\?[QqBb]\?[^?]+\?=)\s+(?==\?[^?]+\?[QqBb]\?[^?]+\?=)/g, '$1').
	            replace(/\=\?([\w_\-\*]+)\?([QqBb])\?[^\?]+\?\=/g, function(mimeWord) {
	                return mimecodec.mimeWordDecode(mimeWord);
	            });

	            return str;
	        },

	        /**
	         * Folds long lines, useful for folding header lines (afterSpace=false) and
	         * flowed text (afterSpace=true)
	         *
	         * @param {String} str String to be folded
	         * @param {Number} [lineLengthMax=76] Maximum length of a line
	         * @param {Boolean} afterSpace If true, leave a space in th end of a line
	         * @return {String} String with folded lines
	         */
	        foldLines: function(str, lineLengthMax, afterSpace) {
	            str = (str || '').toString();
	            lineLengthMax = lineLengthMax || 76;

	            var pos = 0,
	                len = str.length,
	                result = '',
	                line, match;

	            while (pos < len) {
	                line = str.substr(pos, lineLengthMax);
	                if (line.length < lineLengthMax) {
	                    result += line;
	                    break;
	                }
	                if ((match = line.match(/^[^\n\r]*(\r?\n|\r)/))) {
	                    line = match[0];
	                    result += line;
	                    pos += line.length;
	                    continue;
	                } else if ((match = line.match(/(\s+)[^\s]*$/)) && match[0].length - (afterSpace ? (match[1] || '').length : 0) < line.length) {
	                    line = line.substr(0, line.length - (match[0].length - (afterSpace ? (match[1] || '').length : 0)));
	                } else if ((match = str.substr(pos + line.length).match(/^[^\s]+(\s*)/))) {
	                    line = line + match[0].substr(0, match[0].length - (!afterSpace ? (match[1] || '').length : 0));
	                }

	                result += line;
	                pos += line.length;
	                if (pos < len) {
	                    result += '\r\n';
	                }
	            }

	            return result;
	        },

	        /**
	         * Encodes and folds a header line for a MIME message header.
	         * Shorthand for mimeWordsEncode + foldLines
	         *
	         * @param {String} key Key name, will not be encoded
	         * @param {String|Uint8Array} value Value to be encoded
	         * @param {String} [fromCharset='UTF-8'] Character set of the value
	         * @return {String} encoded and folded header line
	         */
	        headerLineEncode: function(key, value, fromCharset) {
	            var encodedValue = mimecodec.mimeWordsEncode(value, 'Q', 52, fromCharset);
	            return mimecodec.foldLines(key + ': ' + encodedValue, 76);
	        },

	        /**
	         * Splits a string by :
	         * The result is not mime word decoded, you need to do your own decoding based
	         * on the rules for the specific header key
	         *
	         * @param {String} headerLine Single header line, might include linebreaks as well if folded
	         * @return {Object} And object of {key, value}
	         */
	        headerLineDecode: function(headerLine) {
	            var line = (headerLine || '').toString().replace(/(?:\r?\n|\r)[ \t]*/g, ' ').trim(),
	                match = line.match(/^\s*([^:]+):(.*)$/),
	                key = (match && match[1] || '').trim(),
	                value = (match && match[2] || '').trim();

	            return {
	                key: key,
	                value: value
	            };
	        },

	        /**
	         * Parses a block of header lines. Does not decode mime words as every
	         * header might have its own rules (eg. formatted email addresses and such)
	         *
	         * @param {String} headers Headers string
	         * @return {Object} An object of headers, where header keys are object keys. NB! Several values with the same key make up an Array
	         */
	        headerLinesDecode: function(headers) {
	            var lines = headers.split(/\r?\n|\r/),
	                headersObj = {},
	                key, value,
	                header,
	                i, len;

	            for (i = lines.length - 1; i >= 0; i--) {
	                if (i && lines[i].match(/^\s/)) {
	                    lines[i - 1] += '\r\n' + lines[i];
	                    lines.splice(i, 1);
	                }
	            }

	            for (i = 0, len = lines.length; i < len; i++) {
	                header = mimecodec.headerLineDecode(lines[i]);
	                key = (header.key || '').toString().toLowerCase().trim();
	                value = header.value || '';

	                if (!headersObj[key]) {
	                    headersObj[key] = value;
	                } else {
	                    headersObj[key] = [].concat(headersObj[key], value);
	                }
	            }

	            return headersObj;
	        },

	        /**
	         * Converts 'binary' string to an Uint8Array
	         *
	         * @param {String} 'binary' string
	         * @return {Uint8Array} Octet stream buffer
	         */
	        toTypedArray: function(binaryString) {
	            var buf = new Uint8Array(binaryString.length);
	            for (var i = 0, len = binaryString.length; i < len; i++) {
	                buf[i] = binaryString.charCodeAt(i);
	            }
	            return buf;
	        },

	        /**
	         * Converts an Uint8Array to 'binary' string
	         *
	         * @param {Uint8Array} buf Octet stream buffer
	         * @return {String} 'binary' string
	         */
	        fromTypedArray: function(buf) {
	            var i, l;

	            // ensure the value is a Uint8Array, not ArrayBuffer if used
	            if (!buf.buffer) {
	                buf = new Uint8Array(buf);
	            }

	            var sbits = new Array(buf.length);
	            for (i = 0, l = buf.length; i < l; i++) {
	                sbits[i] = String.fromCharCode(buf[i]);
	            }

	            return sbits.join('');
	        },

	        /**
	         * Parses a header value with key=value arguments into a structured
	         * object.
	         *
	         *   parseHeaderValue('content-type: text/plain; CHARSET='UTF-8'') ->
	         *   {
	         *     'value': 'text/plain',
	         *     'params': {
	         *       'charset': 'UTF-8'
	         *     }
	         *   }
	         *
	         * @param {String} str Header value
	         * @return {Object} Header value as a parsed structure
	         */
	        parseHeaderValue: function(str) {
	            var response = {
	                    value: false,
	                    params: {}
	                },
	                key = false,
	                value = '',
	                type = 'value',
	                quote = false,
	                escaped = false,
	                chr;

	            for (var i = 0, len = str.length; i < len; i++) {
	                chr = str.charAt(i);
	                if (type === 'key') {
	                    if (chr === '=') {
	                        key = value.trim().toLowerCase();
	                        type = 'value';
	                        value = '';
	                        continue;
	                    }
	                    value += chr;
	                } else {
	                    if (escaped) {
	                        value += chr;
	                    } else if (chr === '\\') {
	                        escaped = true;
	                        continue;
	                    } else if (quote && chr === quote) {
	                        quote = false;
	                    } else if (!quote && chr === '"') {
	                        quote = chr;
	                    } else if (!quote && chr === ';') {
	                        if (key === false) {
	                            response.value = value.trim();
	                        } else {
	                            response.params[key] = value.trim();
	                        }
	                        type = 'key';
	                        value = '';
	                    } else {
	                        value += chr;
	                    }
	                    escaped = false;

	                }
	            }

	            if (type === 'value') {
	                if (key === false) {
	                    response.value = value.trim();
	                } else {
	                    response.params[key] = value.trim();
	                }
	            } else if (value.trim()) {
	                response.params[value.trim().toLowerCase()] = '';
	            }

	            // handle parameter value continuations
	            // https://tools.ietf.org/html/rfc2231#section-3

	            // preprocess values
	            Object.keys(response.params).forEach(function(key) {
	                var actualKey, nr, match, value;
	                if ((match = key.match(/(\*(\d+)|\*(\d+)\*|\*)$/))) {
	                    actualKey = key.substr(0, match.index);
	                    nr = Number(match[2] || match[3]) || 0;

	                    if (!response.params[actualKey] || typeof response.params[actualKey] !== 'object') {
	                        response.params[actualKey] = {
	                            charset: false,
	                            values: []
	                        };
	                    }

	                    value = response.params[key];

	                    if (nr === 0 && match[0].substr(-1) === '*' && (match = value.match(/^([^']*)'[^']*'(.*)$/))) {
	                        response.params[actualKey].charset = match[1] || 'iso-8859-1';
	                        value = match[2];
	                    }

	                    response.params[actualKey].values[nr] = value;

	                    // remove the old reference
	                    delete response.params[key];
	                }
	            });

	            // concatenate split rfc2231 strings and convert encoded strings to mime encoded words
	            Object.keys(response.params).forEach(function(key) {
	                var value;
	                if (response.params[key] && Array.isArray(response.params[key].values)) {
	                    value = response.params[key].values.map(function(val) {
	                        return val || '';
	                    }).join('');

	                    if (response.params[key].charset) {
	                        // convert "%AB" to "=?charset?Q?=AB?="
	                        response.params[key] = '=?' +
	                            response.params[key].charset +
	                            '?Q?' +
	                            value.
	                            // fix invalidly encoded chars
	                        replace(/[=\?_\s]/g, function(s) {
	                                var c = s.charCodeAt(0).toString(16);
	                                if (s === ' ') {
	                                    return '_';
	                                } else {
	                                    return '%' + (c.length < 2 ? '0' : '') + c;
	                                }
	                            }).
	                            // change from urlencoding to percent encoding
	                        replace(/%/g, '=') +
	                            '?=';
	                    } else {
	                        response.params[key] = value;
	                    }
	                }
	            }.bind(this));

	            return response;
	        },

	        /**
	         * Encodes a string or an Uint8Array to an UTF-8 Parameter Value Continuation encoding (rfc2231)
	         * Useful for splitting long parameter values.
	         *
	         * For example
	         *      title="unicode string"
	         * becomes
	         *     title*0*="utf-8''unicode"
	         *     title*1*="%20string"
	         *
	         * @param {String|Uint8Array} data String to be encoded
	         * @param {Number} [maxLength=50] Max length for generated chunks
	         * @param {String} [fromCharset='UTF-8'] Source sharacter set
	         * @return {Array} A list of encoded keys and headers
	         */
	        continuationEncode: function(key, data, maxLength, fromCharset) {
	            var list = [];
	            var encodedStr = typeof data === 'string' ? data : mimecodec.decode(data, fromCharset);
	            var chr;
	            var line;
	            var startPos = 0;
	            var isEncoded = false;

	            maxLength = maxLength || 50;

	            // process ascii only text
	            if (/^[\w.\- ]*$/.test(data)) {

	                // check if conversion is even needed
	                if (encodedStr.length <= maxLength) {
	                    return [{
	                        key: key,
	                        value: /[\s";=]/.test(encodedStr) ? '"' + encodedStr + '"' : encodedStr
	                    }];
	                }

	                encodedStr = encodedStr.replace(new RegExp('.{' + maxLength + '}', 'g'), function(str) {
	                    list.push({
	                        line: str
	                    });
	                    return '';
	                });

	                if (encodedStr) {
	                    list.push({
	                        line: encodedStr
	                    });
	                }

	            } else {

	                // first line includes the charset and language info and needs to be encoded
	                // even if it does not contain any unicode characters
	                line = 'utf-8\'\'';
	                isEncoded = true;
	                startPos = 0;
	                // process text with unicode or special chars
	                for (var i = 0, len = encodedStr.length; i < len; i++) {

	                    chr = encodedStr[i];

	                    if (isEncoded) {
	                        chr = encodeURIComponent(chr);
	                    } else {
	                        // try to urlencode current char
	                        chr = chr === ' ' ? chr : encodeURIComponent(chr);
	                        // By default it is not required to encode a line, the need
	                        // only appears when the string contains unicode or special chars
	                        // in this case we start processing the line over and encode all chars
	                        if (chr !== encodedStr[i]) {
	                            // Check if it is even possible to add the encoded char to the line
	                            // If not, there is no reason to use this line, just push it to the list
	                            // and start a new line with the char that needs encoding
	                            if ((encodeURIComponent(line) + chr).length >= maxLength) {
	                                list.push({
	                                    line: line,
	                                    encoded: isEncoded
	                                });
	                                line = '';
	                                startPos = i - 1;
	                            } else {
	                                isEncoded = true;
	                                i = startPos;
	                                line = '';
	                                continue;
	                            }
	                        }
	                    }

	                    // if the line is already too long, push it to the list and start a new one
	                    if ((line + chr).length >= maxLength) {
	                        list.push({
	                            line: line,
	                            encoded: isEncoded
	                        });
	                        line = chr = encodedStr[i] === ' ' ? ' ' : encodeURIComponent(encodedStr[i]);
	                        if (chr === encodedStr[i]) {
	                            isEncoded = false;
	                            startPos = i - 1;
	                        } else {
	                            isEncoded = true;
	                        }
	                    } else {
	                        line += chr;
	                    }
	                }

	                if (line) {
	                    list.push({
	                        line: line,
	                        encoded: isEncoded
	                    });
	                }
	            }

	            return list.map(function(item, i) {
	                return {
	                    // encoded lines: {name}*{part}*
	                    // unencoded lines: {name}*{part}
	                    // if any line needs to be encoded then the first line (part==0) is always encoded
	                    key: key + '*' + i + (item.encoded ? '*' : ''),
	                    value: /[\s";=]/.test(item.line) ? '"' + item.line + '"' : item.line
	                };
	            });
	        },

	        /**
	         * Splits a mime encoded string. Needed for dividing mime words into smaller chunks
	         *
	         * @param {String} str Mime encoded string to be split up
	         * @param {Number} maxlen Maximum length of characters for one part (minimum 12)
	         * @return {Array} Split string
	         */
	        _splitMimeEncodedString: function(str, maxlen) {
	            var curLine, match, chr, done,
	                lines = [];

	            // require at least 12 symbols to fit possible 4 octet UTF-8 sequences
	            maxlen = Math.max(maxlen || 0, 12);

	            while (str.length) {
	                curLine = str.substr(0, maxlen);

	                // move incomplete escaped char back to main
	                if ((match = curLine.match(/\=[0-9A-F]?$/i))) {
	                    curLine = curLine.substr(0, match.index);
	                }

	                done = false;
	                while (!done) {
	                    done = true;
	                    // check if not middle of a unicode char sequence
	                    if ((match = str.substr(curLine.length).match(/^\=([0-9A-F]{2})/i))) {
	                        chr = parseInt(match[1], 16);
	                        // invalid sequence, move one char back anc recheck
	                        if (chr < 0xC2 && chr > 0x7F) {
	                            curLine = curLine.substr(0, curLine.length - 3);
	                            done = false;
	                        }
	                    }
	                }

	                if (curLine.length) {
	                    lines.push(curLine);
	                }
	                str = str.substr(curLine.length);
	            }

	            return lines;
	        },

	        /**
	         * Adds soft line breaks (the ones that will be stripped out when decoding) to
	         * ensure that no line in the message is never longer than 76 symbols
	         *
	         * Lines can't be longer than 76 + <CR><LF> = 78 bytes
	         * http://tools.ietf.org/html/rfc2045#section-6.7
	         *
	         * @param {String} str Encoded string
	         * @param {String} encoding Either "qp" or "base64" (the default)
	         * @return {String} String with forced line breaks
	         */
	        _addSoftLinebreaks: function(str, encoding) {
	            var lineLengthMax = 76;

	            encoding = (encoding || 'base64').toString().toLowerCase().trim();

	            if (encoding === 'qp') {
	                return mimecodec._addQPSoftLinebreaks(str, lineLengthMax);
	            } else {
	                return mimecodec._addBase64SoftLinebreaks(str, lineLengthMax);
	            }
	        },

	        /**
	         * Adds soft line breaks (the ones that will be stripped out when decoding base64) to
	         * ensure that no line in the message is never longer than lineLengthMax
	         *
	         * @param {String} base64EncodedStr String in BASE64 encoding
	         * @param {Number} lineLengthMax Maximum length of a line
	         * @return {String} String with forced line breaks
	         */
	        _addBase64SoftLinebreaks: function(base64EncodedStr, lineLengthMax) {
	            base64EncodedStr = (base64EncodedStr || '').toString().trim();
	            return base64EncodedStr.replace(new RegExp('.{' + lineLengthMax + '}', 'g'), '$&\r\n').trim();
	        },

	        /**
	         * Adds soft line breaks(the ones that will be stripped out when decoding QP) to * ensure that no line in the message is never longer than lineLengthMax * * Not sure of how and why this works, but at least it seems to be working: /
	         *
	         * @param {String} qpEncodedStr String in Quoted-Printable encoding
	         * @param {Number} lineLengthMax Maximum length of a line
	         * @return {String} String with forced line breaks
	         */
	        _addQPSoftLinebreaks: function(qpEncodedStr, lineLengthMax) {
	            qpEncodedStr = (qpEncodedStr || '').toString();

	            lineLengthMax = lineLengthMax || 76;

	            var pos = 0,
	                len = qpEncodedStr.length,
	                match, code, line,
	                lineMargin = Math.floor(lineLengthMax / 3),
	                result = '';

	            // insert soft linebreaks where needed
	            while (pos < len) {
	                line = qpEncodedStr.substr(pos, lineLengthMax);
	                if ((match = line.match(/\r\n/))) {
	                    line = line.substr(0, match.index + match[0].length);
	                    result += line;
	                    pos += line.length;
	                    continue;
	                }

	                if (line.substr(-1) === '\n') {
	                    // nothing to change here
	                    result += line;
	                    pos += line.length;
	                    continue;
	                } else if ((match = line.substr(-lineMargin).match(/\n.*?$/))) {
	                    // truncate to nearest line break
	                    line = line.substr(0, line.length - (match[0].length - 1));
	                    result += line;
	                    pos += line.length;
	                    continue;
	                } else if (line.length > lineLengthMax - lineMargin && (match = line.substr(-lineMargin).match(/[ \t\.,!\?][^ \t\.,!\?]*$/))) {
	                    // truncate to nearest space
	                    line = line.substr(0, line.length - (match[0].length - 1));
	                } else if (line.substr(-1) === '\r') {
	                    line = line.substr(0, line.length - 1);
	                } else {
	                    if (line.match(/\=[\da-f]{0,2}$/i)) {

	                        // push incomplete encoding sequences to the next line
	                        if ((match = line.match(/\=[\da-f]{0,1}$/i))) {
	                            line = line.substr(0, line.length - match[0].length);
	                        }

	                        // ensure that utf-8 sequences are not split
	                        while (line.length > 3 && line.length < len - pos && !line.match(/^(?:=[\da-f]{2}){1,4}$/i) && (match = line.match(/\=[\da-f]{2}$/ig))) {
	                            code = parseInt(match[0].substr(1, 2), 16);
	                            if (code < 128) {
	                                break;
	                            }

	                            line = line.substr(0, line.length - 3);

	                            if (code >= 0xC0) {
	                                break;
	                            }
	                        }

	                    }
	                }

	                if (pos + line.length < len && line.substr(-1) !== '\n') {
	                    if (line.length === lineLengthMax && line.match(/\=[\da-f]{2}$/i)) {
	                        line = line.substr(0, line.length - 3);
	                    } else if (line.length === lineLengthMax) {
	                        line = line.substr(0, line.length - 1);
	                    }
	                    pos += line.length;
	                    line += '=\r\n';
	                } else {
	                    pos += line.length;
	                }

	                result += line;
	            }

	            return result;
	        },

	        /**
	         * Checks if a number is in specified ranges or not
	         *
	         * @param {Number} nr Number to check for
	         * @ranges {Array} ranges Array of range duples
	         * @return {Boolean} Returns true, if nr was found to be at least one of the specified ranges
	         */
	        _checkRanges: function(nr, ranges) {
	            for (var i = ranges.length - 1; i >= 0; i--) {
	                if (!ranges[i].length) {
	                    continue;
	                }
	                if (ranges[i].length === 1 && nr === ranges[i][0]) {
	                    return true;
	                }
	                if (ranges[i].length === 2 && nr >= ranges[i][0] && nr <= ranges[i][1]) {
	                    return true;
	                }
	            }
	            return false;
	        }
	    };

	    /**
	     * Character set encoding and decoding functions
	     */
	    mimecodec.charset = {

	        /**
	         * Encodes an unicode string into an Uint8Array object as UTF-8
	         *
	         * TextEncoder only supports unicode encodings (utf-8, utf16le/be) but no other,
	         * so we force UTF-8 here.
	         *
	         * @param {String} str String to be encoded
	         * @return {Uint8Array} UTF-8 encoded typed array
	         */
	        encode: function(str) {
	            return new TextEncoder('UTF-8').encode(str);
	        },

	        /**
	         * Decodes a string from Uint8Array to an unicode string using specified encoding
	         *
	         * @param {Uint8Array} buf Binary data to be decoded
	         * @param {String} [fromCharset='UTF-8'] Binary data is decoded into string using this charset
	         * @return {String} Decded string
	         */
	        decode: function(buf, fromCharset) {
	            fromCharset = mimecodec.charset.normalizeCharset(fromCharset || 'UTF-8');

	            // ensure the value is a Uint8Array, not ArrayBuffer if used
	            if (!buf.buffer) {
	                buf = new Uint8Array(buf);
	            }

	            try {
	                return new TextDecoder(fromCharset).decode(buf);
	            } catch (E) {
	                try {
	                    return new TextDecoder('utf-8', {
	                        fatal: true // if the input is not a valid utf-8 the decoder will throw
	                    }).decode(buf);
	                } catch (E) {
	                    try {
	                        return new TextDecoder('iso-8859-15').decode(buf);
	                    } catch (E) {
	                        // should not happen as there is something matching for every byte (non character bytes are allowed)
	                        return mimecodec.fromTypedArray(buf);
	                    }
	                }
	            }

	        },

	        /**
	         * Convert a string from specific encoding to UTF-8 Uint8Array
	         *
	         * @param {String|Uint8Array} str String to be encoded
	         * @param {String} [fromCharset='UTF-8'] Source encoding for the string
	         * @return {Uint8Array} UTF-8 encoded typed array
	         */
	        convert: function(data, fromCharset) {
	            fromCharset = mimecodec.charset.normalizeCharset(fromCharset || 'UTF-8');

	            var bufString;

	            if (typeof data !== 'string') {
	                if (fromCharset.match(/^utf[\-_]?8$/)) {
	                    return data;
	                }
	                bufString = mimecodec.charset.decode(data, fromCharset);
	                return mimecodec.charset.encode(bufString);
	            }
	            return mimecodec.charset.encode(data);
	        },

	        /**
	         * Converts well known invalid character set names to proper names.
	         * eg. win-1257 will be converted to WINDOWS-1257
	         *
	         * @param {String} charset Charset name to convert
	         * @return {String} Canoninicalized charset name
	         */
	        normalizeCharset: function(charset) {
	            var match;

	            if ((match = charset.match(/^utf[\-_]?(\d+)$/i))) {
	                return 'UTF-' + match[1];
	            }

	            if ((match = charset.match(/^win[\-_]?(\d+)$/i))) {
	                return 'WINDOWS-' + match[1];
	            }

	            if ((match = charset.match(/^latin[\-_]?(\d+)$/i))) {
	                return 'ISO-8859-' + match[1];
	            }

	            return charset;
	        }
	    };

	    /**
	     * Base64 encoding and decoding functions
	     */
	    mimecodec.base64 = {

	        /**
	         * Encodes input into base64
	         *
	         * @param {String|Uint8Array} data Data to be encoded into base64
	         * @return {String} Base64 encoded string
	         */
	        encode: function(data) {
	            if (!data) {
	                return '';
	            }

	            if (typeof data === 'string') {
	                // check for data URL
	                if (/^data:/.test(data)) {
	                    var base64 = data.split('base64,')[1];
	                    if (base64) {
	                        return base64;
	                    }
	                }
	                // window.btoa uses pseudo binary encoding, so unicode strings
	                // need to be converted before encoding
	                return btoa(unescape(encodeURIComponent(data)));
	            }

	            var len = data.byteLength,
	                binStr = '';

	            if (!data.buffer) {
	                data.buffer = new Uint8Array(data);
	            }

	            for (var i = 0; i < len; i++) {
	                binStr += String.fromCharCode(data[i]);
	            }

	            return btoa(binStr);
	        },

	        /**
	         * Decodes base64 encoded string into an unicode string or Uint8Array
	         *
	         * @param {String} data Base64 encoded data
	         * @param {String} [outputEncoding='buffer'] Output encoding, either 'string' or 'buffer' (Uint8Array)
	         * @return {String|Uint8Array} Decoded string
	         */
	        decode: function(data, outputEncoding) {
	            outputEncoding = (outputEncoding || 'buffer').toLowerCase().trim();

	            var buf = mimecodec.base64.toTypedArray(data);

	            if (outputEncoding === 'string') {
	                return mimecodec.charset.decode(buf);
	            } else {
	                return buf;
	            }
	        },

	        /**
	         * Safe base64 decoding. Does not throw on unexpected input.
	         *
	         * Implementation from the MDN docs:
	         * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Base64_encoding_and_decoding
	         * (MDN code samples are MIT licensed)
	         *
	         * @param {String} base64Str Base64 encoded string
	         * @returns {Uint8Array} Decoded binary blob
	         */
	        toTypedArray: function(base64Str) {
	            var bitsSoFar = 0;
	            var validBits = 0;
	            var iOut = 0;
	            var arr = new Uint8Array(Math.ceil(base64Str.length * 3 / 4));
	            var c;
	            var bits;

	            for (var i = 0, len = base64Str.length; i < len; i++) {
	                c = base64Str.charCodeAt(i);
	                if (c >= 0x41 && c <= 0x5a) { // [A-Z]
	                    bits = c - 0x41;
	                } else if (c >= 0x61 && c <= 0x7a) { // [a-z]
	                    bits = c - 0x61 + 0x1a;
	                } else if (c >= 0x30 && c <= 0x39) { // [0-9]
	                    bits = c - 0x30 + 0x34;
	                } else if (c === 0x2b) { // +
	                    bits = 0x3e;
	                } else if (c === 0x2f) { // /
	                    bits = 0x3f;
	                } else if (c === 0x3d) { // =
	                    validBits = 0;
	                    continue;
	                } else {
	                    // ignore all other characters!
	                    continue;
	                }
	                bitsSoFar = (bitsSoFar << 6) | bits;
	                validBits += 6;
	                if (validBits >= 8) {
	                    validBits -= 8;
	                    arr[iOut++] = bitsSoFar >> validBits;
	                    if (validBits === 2) {
	                        bitsSoFar &= 0x03;
	                    } else if (validBits === 4) {
	                        bitsSoFar &= 0x0f;
	                    }
	                }
	            }

	            if (iOut < arr.length) {
	                return arr.subarray(0, iOut);
	            }
	            return arr;
	        }
	    };

	    /*
	     * Encodes a string in base 64. DedicatedWorkerGlobalScope for Safari does not provide btoa.
	     * https://github.com/davidchambers/Base64.js
	     */
	    function base64Encode(input) {
	        var str = String(input);
	        var chars = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=';
	        for (var block, charCode, idx = 0, map = chars, output = ''; str.charAt(idx | 0) || (map = '=', idx % 1); output += map.charAt(63 & block >> 8 - idx % 1 * 8)) {
	            charCode = str.charCodeAt(idx += 3 / 4);
	            if (charCode > 0xFF) {
	                throw new Error("'btoa' failed: The string to be encoded contains characters outside of the Latin1 range.");
	            }
	            block = block << 8 | charCode;
	        }
	        return output;
	    }

	    return mimecodec;
	}));


/***/ },
/* 44 */
/*!***************************************************!*\
  !*** ./src/firefox/lib/emailjs-stringencoding.js ***!
  \***************************************************/
/***/ function(module, exports, __webpack_require__) {

	
	'use strict';

	var textEncoder = __webpack_require__(/*! sdk/io/buffer */ 45).TextEncoder;
	var textDecoder = __webpack_require__(/*! sdk/io/buffer */ 45).TextDecoder;

	exports.TextEncoder = textEncoder;
	exports.TextDecoder = textDecoder;


/***/ },
/* 45 */
/*!********************************!*\
  !*** external "sdk/io/buffer" ***!
  \********************************/
/***/ function(module, exports) {

	module.exports = require("sdk/io/buffer");

/***/ },
/* 46 */
/*!**************************************************************!*\
  !*** ./~/emailjs-addressparser/src/emailjs-addressparser.js ***!
  \**************************************************************/
/***/ function(module, exports, __webpack_require__) {

	var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_RESULT__;// Copyright (c) 2013 Andris Reinman
	//
	// Permission is hereby granted, free of charge, to any person obtaining a copy
	// of this software and associated documentation files (the "Software"), to deal
	// in the Software without restriction, including without limitation the rights
	// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
	// copies of the Software, and to permit persons to whom the Software is
	// furnished to do so, subject to the following conditions:

	// The above copyright notice and this permission notice shall be included in
	// all copies or substantial portions of the Software.

	// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
	// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
	// THE SOFTWARE.

	(function(root, factory) {
	    "use strict";

	    if (true) {
	        !(__WEBPACK_AMD_DEFINE_FACTORY__ = (factory), __WEBPACK_AMD_DEFINE_RESULT__ = (typeof __WEBPACK_AMD_DEFINE_FACTORY__ === 'function' ? (__WEBPACK_AMD_DEFINE_FACTORY__.call(exports, __webpack_require__, exports, module)) : __WEBPACK_AMD_DEFINE_FACTORY__), __WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
	    } else if (typeof exports === 'object') {
	        module.exports = factory();
	    } else {
	        root['emailjs-addressparser'] = factory();
	    }
	}(this, function() {
	    "use strict";

	    /**
	     * Defines an object as a namespace for the parsing function
	     */
	    var addressparser = {};

	    /**
	     * Parses structured e-mail addresses from an address field
	     *
	     * Example:
	     *
	     *    "Name <address@domain>"
	     *
	     * will be converted to
	     *
	     *     [{name: "Name", address: "address@domain"}]
	     *
	     * @param {String} str Address field
	     * @return {Array} An array of address objects
	     */
	    addressparser.parse = function(str) {
	        var tokenizer = new addressparser.Tokenizer(str),
	            tokens = tokenizer.tokenize();

	        var addresses = [],
	            address = [],
	            parsedAddresses = [];

	        tokens.forEach(function(token) {
	            if (token.type === "operator" && (token.value === "," || token.value === ";")) {
	                if (address.length) {
	                    addresses.push(address);
	                }
	                address = [];
	            } else {
	                address.push(token);
	            }
	        });

	        if (address.length) {
	            addresses.push(address);
	        }

	        addresses.forEach(function(address) {
	            address = addressparser._handleAddress(address);
	            if (address.length) {
	                parsedAddresses = parsedAddresses.concat(address);
	            }
	        });

	        return parsedAddresses;
	    };

	    /**
	     * Converts tokens for a single address into an address object
	     *
	     * @param {Array} tokens Tokens object
	     * @return {Object} Address object
	     */
	    addressparser._handleAddress = function(tokens) {
	        var token,
	            isGroup = false,
	            state = "text",
	            address,
	            addresses = [],
	            data = {
	                address: [],
	                comment: [],
	                group: [],
	                text: []
	            },
	            i, len;

	        // Filter out <addresses>, (comments) and regular text
	        for (i = 0, len = tokens.length; i < len; i++) {
	            token = tokens[i];

	            if (token.type === "operator") {
	                switch (token.value) {
	                    case "<":
	                        state = "address";
	                        break;
	                    case "(":
	                        state = "comment";
	                        break;
	                    case ":":
	                        state = "group";
	                        isGroup = true;
	                        break;
	                    default:
	                        state = "text";
	                }
	            } else {
	                if (token.value) {
	                    data[state].push(token.value);
	                }
	            }
	        }

	        // If there is no text but a comment, replace the two
	        if (!data.text.length && data.comment.length) {
	            data.text = data.comment;
	            data.comment = [];
	        }

	        if (isGroup) {
	            // http://tools.ietf.org/html/rfc2822#appendix-A.1.3
	            data.text = data.text.join(" ");
	            addresses.push({
	                name: data.text || (address && address.name),
	                group: data.group.length ? addressparser.parse(data.group.join(",")) : []
	            });
	        } else {
	            // If no address was found, try to detect one from regular text
	            if (!data.address.length && data.text.length) {
	                for (i = data.text.length - 1; i >= 0; i--) {
	                    if (data.text[i].match(/^[^@\s]+@[^@\s]+$/)) {
	                        data.address = data.text.splice(i, 1);
	                        break;
	                    }
	                }

	                var _regexHandler = function(address) {
	                    if (!data.address.length) {
	                        data.address = [address.trim()];
	                        return " ";
	                    } else {
	                        return address;
	                    }
	                };

	                // still no address
	                if (!data.address.length) {
	                    for (i = data.text.length - 1; i >= 0; i--) {
	                        data.text[i] = data.text[i].replace(/\s*\b[^@\s]+@[^@\s]+\b\s*/, _regexHandler).trim();
	                        if (data.address.length) {
	                            break;
	                        }
	                    }
	                }
	            }

	            // If there's still is no text but a comment exixts, replace the two
	            if (!data.text.length && data.comment.length) {
	                data.text = data.comment;
	                data.comment = [];
	            }

	            // Keep only the first address occurence, push others to regular text
	            if (data.address.length > 1) {
	                data.text = data.text.concat(data.address.splice(1));
	            }

	            // Join values with spaces
	            data.text = data.text.join(" ");
	            data.address = data.address.join(" ");

	            if (!data.address && isGroup) {
	                return [];
	            } else {
	                address = {
	                    address: data.address || data.text || "",
	                    name: data.text || data.address || ""
	                };

	                if (address.address === address.name) {
	                    if ((address.address || "").match(/@/)) {
	                        address.name = "";
	                    } else {
	                        address.address = "";
	                    }

	                }

	                addresses.push(address);
	            }
	        }

	        return addresses;
	    };

	    /**
	     * Creates a Tokenizer object for tokenizing address field strings
	     *
	     * @constructor
	     * @param {String} str Address field string
	     */
	    addressparser.Tokenizer = function(str) {

	        this.str = (str || "").toString();
	        this.operatorCurrent = "";
	        this.operatorExpecting = "";
	        this.node = null;
	        this.escaped = false;

	        this.list = [];

	    };

	    /**
	     * Operator tokens and which tokens are expected to end the sequence
	     */
	    addressparser.Tokenizer.prototype.operators = {
	        "\"": "\"",
	        "(": ")",
	        "<": ">",
	        ",": "",
	        // Groups are ended by semicolons
	        ":": ";",
	        // Semicolons are not a legal delimiter per the RFC2822 grammar other
	        // than for terminating a group, but they are also not valid for any
	        // other use in this context.  Given that some mail clients have
	        // historically allowed the semicolon as a delimiter equivalent to the
	        // comma in their UI, it makes sense to treat them the same as a comma
	        // when used outside of a group.
	        ";": ""
	    };

	    /**
	     * Tokenizes the original input string
	     *
	     * @return {Array} An array of operator|text tokens
	     */
	    addressparser.Tokenizer.prototype.tokenize = function() {
	        var chr, list = [];
	        for (var i = 0, len = this.str.length; i < len; i++) {
	            chr = this.str.charAt(i);
	            this.checkChar(chr);
	        }

	        this.list.forEach(function(node) {
	            node.value = (node.value || "").toString().trim();
	            if (node.value) {
	                list.push(node);
	            }
	        });

	        return list;
	    };

	    /**
	     * Checks if a character is an operator or text and acts accordingly
	     *
	     * @param {String} chr Character from the address field
	     */
	    addressparser.Tokenizer.prototype.checkChar = function(chr) {
	        if ((chr in this.operators || chr === "\\") && this.escaped) {
	            this.escaped = false;
	        } else if (this.operatorExpecting && chr === this.operatorExpecting) {
	            this.node = {
	                type: "operator",
	                value: chr
	            };
	            this.list.push(this.node);
	            this.node = null;
	            this.operatorExpecting = "";
	            this.escaped = false;
	            return;
	        } else if (!this.operatorExpecting && chr in this.operators) {
	            this.node = {
	                type: "operator",
	                value: chr
	            };
	            this.list.push(this.node);
	            this.node = null;
	            this.operatorExpecting = this.operators[chr];
	            this.escaped = false;
	            return;
	        }

	        if (!this.escaped && chr === "\\") {
	            this.escaped = true;
	            return;
	        }

	        if (!this.node) {
	            this.node = {
	                type: "text",
	                value: ""
	            };
	            this.list.push(this.node);
	        }

	        if (this.escaped && chr !== "\\") {
	            this.node.value += "\\";
	        }

	        this.node.value += chr;
	        this.escaped = false;
	    };

	    return addressparser;
	}));


/***/ },
/* 47 */
/*!**********************************************!*\
  !*** ./src/controller/encrypt.controller.js ***!
  \**********************************************/
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Mailvelope - secure email with OpenPGP encryption for Webmail
	 * Copyright (C) 2014-2015 Mailvelope GmbH
	 *
	 * This program is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU Affero General Public License version 3
	 * as published by the Free Software Foundation.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU Affero General Public License for more details.
	 *
	 * You should have received a copy of the GNU Affero General Public License
	 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	/**
	 * @fileOverview This controller handles events from the encryptFrame and
	 * create an editor controller to encrypt plaintext to a list of recipients.
	 */

	'use strict';


	var sub = __webpack_require__(/*! ./sub.controller */ 35);

	function EncryptController(port) {
	  sub.SubController.call(this, port);
	  this.editorControl = null;
	  this.recipientsCallback = null;
	  // register event handlers
	  this.on('eframe-recipients', this.displayRecipientProposal);
	  this.on('eframe-display-editor', this.openEditor);
	}

	EncryptController.prototype = Object.create(sub.SubController.prototype);

	/**
	 * Opens a new editor control and gets the recipients to encrypt plaintext
	 * input to their public keys.
	 * @param  {String} options.text   The plaintext input to encrypt
	 */
	EncryptController.prototype.openEditor = function(options) {
	  if (this.mvelo.windows.modalActive) {
	    // modal dialog already open
	    // TODO show error, fix modalActive on FF
	    return;
	  }

	  var that = this;
	  this.editorControl = sub.factory.get('editor');
	  this.editorControl.encrypt({
	    initText: options.text,
	    getRecipientProposal: this.getRecipientProposal.bind(this)
	  }, function(err, armored, recipients) {
	    if (err) {
	      // error message handled in editor controller
	      return;
	    }
	    // sanitize if content from plain text, rich text already sanitized by editor
	    if (that.prefs.data().general.editor_type == that.mvelo.PLAIN_TEXT) {
	      that.mvelo.util.parseHTML(armored, function(parsed) {
	        that.emit('set-editor-output', {text: parsed, recipients: recipients});
	      });
	    } else {
	      that.emit('set-editor-output', {text: armored, recipients: recipients});
	    }
	  });
	};

	/**
	 * Signal the encrypt frame to  call currentProvider.getRecipients().
	 * @param  {Function} callback   Will be called once recipients are set later
	 */
	EncryptController.prototype.getRecipientProposal = function(callback) {
	  if (this.recipientsCallback) {
	    throw new Error('Waiting for recipients result.');
	  }
	  this.emit('get-recipients');
	  this.recipientsCallback = callback;
	};

	/**
	 * Handles gotten recipients after calling currentProvider.getRecipients() in
	 * the encrypt frame.
	 * @param  {Array} options.recipients   The recipient objects in the form: [{ email: 'jon@example.com' }]
	 */
	EncryptController.prototype.displayRecipientProposal = function(options) {
	  if (this.recipientsCallback) {
	    this.recipientsCallback(options.recipients);
	    this.recipientsCallback = null;
	  }
	};

	exports.EncryptController = EncryptController;


/***/ },
/* 48 */
/*!*********************************************!*\
  !*** ./src/controller/import.controller.js ***!
  \*********************************************/
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Mailvelope - secure email with OpenPGP encryption for Webmail
	 * Copyright (C) 2014-2015 Mailvelope GmbH
	 *
	 * This program is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU Affero General Public License version 3
	 * as published by the Free Software Foundation.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU Affero General Public License for more details.
	 *
	 * You should have received a copy of the GNU Affero General Public License
	 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	'use strict';


	var sub = __webpack_require__(/*! ./sub.controller */ 35);
	var keyringMod = __webpack_require__(/*! ../modules/keyring */ 32);
	var keyringSync = __webpack_require__(/*! ../modules/keyringSync */ 33);
	var openpgp = __webpack_require__(/*! openpgp */ 22);
	var uiLog = __webpack_require__(/*! ../modules/uiLog */ 29);

	function ImportController(port) {
	  sub.SubController.call(this, port);
	  if (!port) {
	    this.mainType = 'importKeyDialog';
	    this.id = this.mvelo.util.getHash();
	  }
	  this.armored = '';
	  this.done = null;
	  this.importPopup = null;
	  this.keyringId = '';
	  this.keyring = null;
	  this.key = null;
	  this.keyDetails = null;
	  this.importError = false;
	  this.invalidated = false;
	}

	ImportController.prototype = Object.create(sub.SubController.prototype);

	ImportController.prototype.handlePortMessage = function(msg) {
	  var that = this;
	  switch (msg.event) {
	    case 'imframe-armored-key':
	      this.mvelo.tabs.loadOptionsTab('#importKey', function(old, tab) {
	        that.mvelo.tabs.sendMessage(tab, {
	          event: 'import-key',
	          armored: msg.data,
	          id: that.id
	        }, function(msg) {
	          var resultType = {};
	          for (var i = 0; i < msg.result.length; i++) {
	            resultType[msg.result[i].type] = true;
	          }
	          that.ports.imFrame.postMessage({event: 'import-result', resultType: resultType});
	        });
	      });
	      break;
	    case 'key-import-dialog-init':
	      this.ports.importKeyDialog.postMessage({event: 'key-details', key: this.keyDetails, invalidated: this.invalidated});
	      break;
	    case 'key-import-dialog-ok':
	      var importResult = this.keyring.importKeys([{type: 'public', armored: this.armored}])[0];
	      if (importResult.type === 'error') {
	        this.ports.importKeyDialog.postMessage({event: 'import-error', message: importResult.message});
	        this.importError = true;
	      } else {
	        this.closePopup();
	        this.done(null, 'IMPORTED');
	      }
	      break;
	    case 'key-import-dialog-cancel':
	      this.closePopup();
	      if (this.invalidated) {
	        this.done(null, 'INVALIDATED');
	      } else if (this.importError) {
	        this.done({message: 'An error occured during key import', code: 'IMPORT_ERROR'});
	      } else {
	        this.done(null, 'REJECTED');
	      }
	      break;
	    case 'key-import-user-input':
	      uiLog.push(msg.source, msg.type);
	      break;
	    default:
	      console.log('unknown event', msg);
	  }
	};

	ImportController.prototype.closePopup = function() {
	  if (this.importPopup) {
	    try {
	      this.importPopup.close();
	    } catch (e) {}
	    this.importPopup = null;
	  }
	};

	ImportController.prototype.importKey = function(keyringId, armored, callback) {
	  try {
	    this.keyringId = keyringId;
	    // check keyringId
	    this.keyring = keyringMod.getById(keyringId);
	    this.armored = armored;
	    this.done = callback;

	    this.keys = openpgp.key.readArmored(this.armored);
	    if (this.keys.err) {
	      throw new Error(this.keys.err[0].message);
	    }
	    this.key = this.keys.keys[0];
	    this.keyDetails = keyringMod.mapKeys(this.keys.keys)[0];
	    if (this.keyDetails.type === 'private') {
	      throw new Error('Import of private keys not allowed.');
	    }
	    if (this.keys.keys.length > 1) {
	      console.log('Multiple keys detected during key import, only first key is imported.');
	      // only import first key in armored block
	      this.armored = this.key.armor();
	    }
	    if (this.key.verifyPrimaryKey() === openpgp.enums.keyStatus.invalid) {
	      throw new Error('Key is invalid.');
	    }
	    // check if key already in keyring
	    var fingerprint = this.key.primaryKey.getFingerprint();
	    var stockKey = this.keyring.keyring.getKeysForId(fingerprint);
	    if (stockKey) {
	      stockKey = stockKey[0];
	      this.updateKey(fingerprint, stockKey, this.key, callback);
	    } else {
	      this.openPopup();
	    }
	  } catch (err) {
	    callback({message: err.message, code: 'IMPORT_ERROR'});
	  }
	};

	ImportController.prototype.updateKey = function(fingerprint, stockKey, newKey, callback) {
	  var statusBefore = stockKey.verifyPrimaryKey();
	  var beforeLastModified = this.model.getLastModifiedDate(stockKey);
	  var stockKeyClone = keyringMod.cloneKey(stockKey);
	  stockKeyClone.update(newKey);
	  var statusAfter = stockKeyClone.verifyPrimaryKey();
	  var afterLastModified = this.model.getLastModifiedDate(stockKeyClone);
	  if (beforeLastModified.valueOf() === afterLastModified.valueOf()) {
	    // key does not change, we still reply with status UPDATED
	    // -> User will no be notified
	    callback(null, 'UPDATED');
	    return;
	  }
	  if (statusBefore !== openpgp.enums.keyStatus.valid &&
	      statusAfter === openpgp.enums.keyStatus.valid) {
	    // an invalid key gets status valid due to this key import
	    // -> User confirmation required
	    this.openPopup();
	    return;
	  }
	  stockKey.update(newKey);
	  this.keyring.sync.add(fingerprint, keyringSync.UPDATE);
	  this.keyring.keyring.store();
	  this.keyring.sync.commit();
	  if (statusBefore === openpgp.enums.keyStatus.valid &&
	      statusAfter !== openpgp.enums.keyStatus.valid) {
	    // the key import changes the status of the key to not valid
	    // -> User will be notified
	    this.invalidated = true;
	    this.openPopup();
	  } else {
	    // update is non-critical, no user confirmation required
	    callback(null, 'UPDATED');
	  }
	};

	ImportController.prototype.openPopup = function() {
	  var that = this;
	  this.mvelo.windows.openPopup('components/import-key/importKeyDialog.html?id=' + this.id, {width: 535, height: 458, modal: false}, function(window) {
	    that.importPopup = window;
	  });
	};

	exports.ImportController = ImportController;


/***/ },
/* 49 */
/*!*********************************************!*\
  !*** ./src/controller/mainCs.controller.js ***!
  \*********************************************/
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Mailvelope - secure email with OpenPGP encryption for Webmail
	 * Copyright (C) 2014-2015 Mailvelope GmbH
	 *
	 * This program is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU Affero General Public License version 3
	 * as published by the Free Software Foundation.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU Affero General Public License for more details.
	 *
	 * You should have received a copy of the GNU Affero General Public License
	 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	'use strict';


	var sub = __webpack_require__(/*! ./sub.controller */ 35);

	class MainCsController extends sub.SubController {
	  constructor(port) {
	    super(port);
	    this.on('ready', this.handleContentReady);
	  }

	  handleContentReady() {
	    this.emit('init', {
	      prefs: this.prefs.data(),
	      watchList: this.model.getWatchList()
	    });
	  }

	  updatePrefs() {
	    this.emit('set-prefs', {
	      prefs: this.prefs.data()
	    });
	  }
	}

	exports.MainCsController = MainCsController;


/***/ },
/* 50 */
/*!*********************************************!*\
  !*** ./src/controller/verify.controller.js ***!
  \*********************************************/
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Mailvelope - secure email with OpenPGP encryption for Webmail
	 * Copyright (C) 2014-2015 Mailvelope GmbH
	 *
	 * This program is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU Affero General Public License version 3
	 * as published by the Free Software Foundation.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU Affero General Public License for more details.
	 *
	 * You should have received a copy of the GNU Affero General Public License
	 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	'use strict';


	var sub = __webpack_require__(/*! ./sub.controller */ 35);
	var uiLog = __webpack_require__(/*! ../modules/uiLog */ 29);

	function VerifyController(port) {
	  sub.SubController.call(this, port);
	  this.verifyPopup = null;
	}

	VerifyController.prototype = Object.create(sub.SubController.prototype);

	VerifyController.prototype.handlePortMessage = function(msg) {
	  var that = this;
	  switch (msg.event) {
	    case 'verify-inline-init':
	    case 'verify-popup-init':
	      // get armored message from vFrame
	      this.ports.vFrame.postMessage({event: 'armored-message'});
	      break;
	    case 'vframe-display-popup':
	      // prevent two open modal dialogs
	      if (this.mvelo.windows.modalActive) {
	        // password dialog or modal dialog already open
	        this.ports.vFrame.postMessage({event: 'remove-dialog'});
	      } else {
	        this.mvelo.windows.openPopup('components/verify-popup/verifyPopup.html?id=' + this.id, {width: 742, height: 550, modal: true}, function(window) {
	          that.verifyPopup = window;
	        });
	      }
	      break;
	    case 'vframe-armored-message':
	      var result;
	      try {
	        result = this.model.readCleartextMessage(msg.data, this.mvelo.LOCAL_KEYRING_ID);
	      } catch (e) {
	        this.ports.vDialog.postMessage({
	          event: 'error-message',
	          error: e.message
	        });
	        return;
	      }
	      this.model.verifyMessage(result.message, result.signers, function(err, verified) {
	        if (err) {
	          that.ports.vDialog.postMessage({
	            event: 'error-message',
	            error: err.message
	          });
	        } else {
	          that.ports.vDialog.postMessage({
	            event: 'verified-message',
	            message: result.message.getText(),
	            signers: verified
	          });
	        }
	      });
	      break;
	    case 'verify-dialog-cancel':
	      if (this.ports.vFrame) {
	        this.ports.vFrame.postMessage({
	          event: 'remove-dialog'
	        });
	      }
	      this.closePopup();
	      break;
	    case 'verify-user-input':
	      uiLog.push(msg.source, msg.type);
	      break;
	    default:
	      console.log('unknown event', msg);
	  }
	};

	VerifyController.prototype.closePopup = function() {
	  if (this.verifyPopup) {
	    try {
	      this.verifyPopup.close();
	    } catch (e) {}
	    this.verifyPopup = null;
	  }
	};

	exports.VerifyController = VerifyController;


/***/ },
/* 51 */
/*!******************************************!*\
  !*** ./src/controller/pwd.controller.js ***!
  \******************************************/
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Mailvelope - secure email with OpenPGP encryption for Webmail
	 * Copyright (C) 2014-2015 Mailvelope GmbH
	 *
	 * This program is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU Affero General Public License version 3
	 * as published by the Free Software Foundation.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU Affero General Public License for more details.
	 *
	 * You should have received a copy of the GNU Affero General Public License
	 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	'use strict';


	var sub = __webpack_require__(/*! ./sub.controller */ 35);
	var uiLog = __webpack_require__(/*! ../modules/uiLog */ 29);
	var openpgp = __webpack_require__(/*! openpgp */ 22);

	function PwdController(port) {
	  if (port) {
	    throw new Error('Do not instantiate PwdController with a port');
	  }
	  sub.SubController.call(this, null);
	  this.mainType = 'pwdDialog';
	  this.id = this.mvelo.util.getHash();
	  this.pwdPopup = null;
	  this.options = null;
	  this.resolve = null;
	  this.reject = null;
	  this.pwdCache = __webpack_require__(/*! ../modules/pwdCache */ 27);
	}

	PwdController.prototype = Object.create(sub.SubController.prototype);

	PwdController.prototype.handlePortMessage = function(msg) {
	  var that = this;
	  //console.log('pwd.controller handlePortMessage msg', msg);
	  switch (msg.event) {
	    case 'pwd-dialog-init':
	      // pass over keyid and userid to dialog
	      this.ports.pwdDialog.postMessage({event: 'set-init-data', data: {
	        userid: this.options.userid,
	        keyid: this.options.key.primaryKey.getKeyId().toHex(),
	        cache: this.prefs.data().security.password_cache,
	        reason: this.options.reason
	      }});
	      break;
	    case 'pwd-dialog-cancel':
	      this.closePopup();
	      var error = new Error(this.mvelo.l10n.get('pwd_dialog_cancel'));
	      error.code = 'PWD_DIALOG_CANCEL';
	      this.reject(error);
	      break;
	    case 'pwd-dialog-ok':
	      this.model.unlockKey(this.options.key, this.options.keyid, msg.password)
	        .then(function(key) {
	          // password correct
	          that.options.key = key;
	          that.options.password = msg.password;
	          if (msg.cache != that.prefs.data().security.password_cache) {
	            // update pwd cache status
	            that.prefs.update({security: {password_cache: msg.cache}});
	          }
	          if (msg.cache) {
	            // set unlocked key and password in cache
	            that.pwdCache.set(that.options, msg.password);
	          }
	          that.closePopup();
	          that.resolve(that.options);
	        })
	        .catch(function(err) {
	          if (err.message == 'Wrong password') {
	            that.ports.pwdDialog.postMessage({event: 'wrong-password'});
	          } else {
	            if (that.ports.dDialog) {
	              that.ports.dDialog.postMessage({event: 'error-message', error: err.message});
	            }
	            that.closePopup();
	            that.reject(err);
	          }
	        });
	      break;
	    case 'pwd-user-input':
	      uiLog.push(msg.source, msg.type);
	      break;
	    default:
	      console.log('unknown event', msg);
	  }
	};

	PwdController.prototype.closePopup = function() {
	  if (this.pwdPopup) {
	    try {
	      this.pwdPopup.close();
	    } catch (e) {}
	    this.pwdPopup = null;
	  }
	};

	/**
	 * @param {Object} options
	 * @param {openpgp.key.Key} options.key - key to unlock
	 * @param {String} options.keyid - keyid of key packet that needs to be unlocked
	 * @param {String} options.userid - userid of key that needs to be unlocked
	 * @param {String} options.keyringId - keyring assignment of provided key
	 * @param {String} [options.reason] - optional explanation for password dialog
	 * @param {Boolean} [options.openPopup=true] - password popup required (false if dialog appears integrated)
	 * @param {Function} [options.beforePasswordRequest] - called before password entry required
	 * @param {String} [options.password] - password to unlock key
	 * @return {Promise<Object, Error>} - resolves with unlocked key and password
	 */
	PwdController.prototype.unlockKey = function(options) {
	  var that = this;
	  this.options = options;
	  if (typeof options.reason == 'undefined') {
	    this.options.reason = '';
	  }
	  if (typeof this.options.openPopup == 'undefined') {
	    this.options.openPopup = true;
	  }
	  var cacheEntry = this.pwdCache.get(this.options.key.primaryKey.getKeyId().toHex(), this.options.keyid);
	  if (cacheEntry) {
	    return new Promise(function(resolve) {
	      that.options.password = cacheEntry.password;
	      if (!cacheEntry.key) {
	        that.pwdCache.unlock(that.options)
	          .then(function() {
	            resolve(that.options);
	          });
	      } else {
	        that.options.key = cacheEntry.key;
	        resolve(that.options);
	      }
	    });
	  } else {
	    return new Promise(function(resolve, reject) {
	      if (that.keyIsDecrypted(that.options)) {
	        // secret-key data is not encrypted, nothing to do
	        return resolve(that.options);
	      }
	      if (that.options.password) {
	        // secret-key data is encrypted, but we have password
	        return that.model.unlockKey(that.options.key, that.options.keyid, that.options.password)
	          .then(function(key) {
	            that.options.key = key;
	            resolve(that.options);
	          });
	      }
	      if (that.options.beforePasswordRequest) {
	        that.options.beforePasswordRequest();
	      }
	      if (that.options.openPopup) {
	        that.mvelo.windows.openPopup('components/enter-password/pwdDialog.html?id=' + that.id, {width: 470, height: 445, modal: false}, function(window) {
	          that.pwdPopup = window;
	        });
	      }
	      that.resolve = resolve;
	      that.reject = reject;
	    });
	  }
	};

	PwdController.prototype.keyIsDecrypted = function(options) {
	  var keyPacket = options.key.getKeyPacket([openpgp.Keyid.fromId(options.keyid)]);
	  if (keyPacket) {
	    return keyPacket.isDecrypted;
	  }
	};

	exports.PwdController = PwdController;


/***/ },
/* 52 */
/*!*********************************************!*\
  !*** ./src/controller/editor.controller.js ***!
  \*********************************************/
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Mailvelope - secure email with OpenPGP encryption for Webmail
	 * Copyright (C) 2014-2015 Mailvelope GmbH
	 *
	 * This program is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU Affero General Public License version 3
	 * as published by the Free Software Foundation.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU Affero General Public License for more details.
	 *
	 * You should have received a copy of the GNU Affero General Public License
	 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	/**
	 * @fileOverview This controller implements handling of state and events
	 * for the encryption editor like handling message data and recipients.
	 */

	'use strict';


	var sub = __webpack_require__(/*! ./sub.controller */ 35);
	var DecryptController = __webpack_require__(/*! ./decrypt.controller */ 40).DecryptController;
	var uiLog = __webpack_require__(/*! ../modules/uiLog */ 29);
	var syncCtrl = __webpack_require__(/*! ./sync.controller */ 34);
	var KeyServer = __webpack_require__(/*! ../modules/keyserver */ 38);

	function EditorController(port) {
	  sub.SubController.call(this, port);
	  if (!port) {
	    this.mainType = 'editor';
	    this.id = this.mvelo.util.getHash();
	  }
	  this.encryptCallback = null;
	  this.encryptTimer = null;
	  this.keyringId = null;
	  this.editorPopup = null;
	  this.keyidBuffer = null;
	  this.signBuffer = null;
	  this.pwdControl = null;
	  this.keyring = __webpack_require__(/*! ../modules/keyring */ 32);
	  this.keyserver = new KeyServer(this.mvelo);
	  this.mailbuild = __webpack_require__(/*! emailjs-mime-builder */ 53);
	  this.pgpMIME = false;
	  this.signMsg = null;
	  this.options = {};

	  // register event handlers
	  this.on('editor-init', this._onEditorInit);
	  this.on('editor-plaintext', this._onSignAndEncrypt);
	  this.on('editor-user-input', this._onEditorUserInput);
	  this.on('keyserver-lookup', this.lookupKeyOnServer);
	  // standalone editor only
	  this.on('editor-cancel', this._onEditorCancel);
	  this.on('sign-only', this._onSignOnly);
	  // API only
	  this.on('editor-container-encrypt', this._onEditorContainerEncrypt);
	  this.on('editor-container-create-draft', this._onEditorContainerCreateDraft);
	  this.on('editor-options', this._onEditorOptions);
	  this.on('open-security-settings', this.openSecuritySettings);
	  this.on('open-app', this.openApp);
	  this.on('editor-error', this.onEditorError);
	}

	EditorController.prototype = Object.create(sub.SubController.prototype);

	EditorController.prototype._onEditorInit = function() {
	  if (this.ports.editorCont) {
	    this.emit('editor-ready', undefined, this.ports.editorCont);
	  } else {
	    // non-container case, send options to editor
	    let keyring = this.keyring.getById(this.keyringId);
	    let primaryKey =  keyring.getPrimaryKey();
	    let primaryKeyId = primaryKey && primaryKey.keyid.toUpperCase() || '';
	    let data = {
	      text: this.options.initText,
	      signMsg: this.prefs.data().general.auto_sign_msg,
	      primary: primaryKeyId,
	      privKeys: keyring.getValidSigningKeys()
	    };
	    this.emit('set-init-data', {data: data}, this.ports.editor);
	  }
	  // display recipient proposal in the editor
	  if (this.options.getRecipientProposal) {
	    this.options.getRecipientProposal(this.displayRecipientProposal.bind(this));
	  }
	};

	EditorController.prototype._onEditorCancel = function() {
	  this.editorPopup.close();
	  this.editorPopup = null;
	};

	EditorController.prototype.onEditorError = function(msg) {
	  this.emit('error-message', {error: msg.error}, this.ports.editorCont);
	};

	EditorController.prototype._onEditorContainerEncrypt = function(msg) {
	  this.pgpMIME = true;
	  this.keyringId = msg.keyringId;
	  var keyIdMap = this.keyring.getById(this.keyringId).getKeyIdByAddress(msg.recipients, {validity: true});
	  if (Object.keys(keyIdMap).some(function(keyId) {
	    return keyIdMap[keyId] === false;
	  })) {
	    var error = {
	      message: 'No valid encryption key for recipient address',
	      code: 'NO_KEY_FOR_RECIPIENT'
	    };
	    this.emit('error-message', {error: error}, this.ports.editorCont);
	    return;
	  }
	  var keyIds = [];
	  msg.recipients.forEach(function(recipient) {
	    keyIds = keyIds.concat(keyIdMap[recipient]);
	  });
	  if (this.prefs.data().general.auto_add_primary) {
	    let primary = this.keyring.getById(this.keyringId).getPrimaryKey();
	    if (primary) {
	      keyIds.push(primary.keyid.toLowerCase());
	    }
	  }
	  this.keyidBuffer = this.mvelo.util.sortAndDeDup(keyIds);
	  this.emit('get-plaintext', {action: 'encrypt'}, this.ports.editor);
	};

	EditorController.prototype._onEditorContainerCreateDraft = function(msg) {
	  this.pgpMIME = true;
	  this.signMsg = true;
	  this.keyringId = msg.keyringId;
	  this.options.reason = 'PWD_DIALOG_REASON_CREATE_DRAFT';
	  var primary = this.keyring.getById(this.keyringId).getPrimaryKey();
	  if (primary) {
	    this.keyidBuffer = [primary.keyid.toLowerCase()];
	  } else {
	    var error = {
	      message: 'No private key found for creating draft.',
	      code: 'NO_KEY_FOR_ENCRYPTION'
	    };
	    this.emit('error-message', {error: error}, this.ports.editorCont);
	    return;
	  }
	  this.emit('get-plaintext', {action: 'encrypt', draft: true}, this.ports.editor);
	};

	EditorController.prototype._onEditorOptions = function(msg) {
	  this.keyringId = msg.keyringId;
	  this.options = msg.options;
	  this.signMsg = msg.options.signMsg;
	  let primaryKey = this.keyring.getById(this.keyringId).getPrimaryKey();
	  let primaryKeyId = primaryKey && primaryKey.keyid.toUpperCase() || '';
	  var data = {
	    signMsg: this.signMsg,
	    primary: primaryKeyId
	  };
	  if (this.options.armoredDraft) {
	    this.options.keepAttachments = true;
	    this.scheduleDecrypt(this.options.armoredDraft);
	  } else {
	    if (this.options.quotedMail) {
	      this.scheduleDecrypt(this.options.quotedMail);
	    } else if (this.options.predefinedText) {
	      data.text = this.options.predefinedText;
	    }
	  }
	  syncCtrl.triggerSync({keyringId: this.keyringId, force: true});
	  this.emit('set-init-data', {data: data}, this.ports.editor);
	};

	EditorController.prototype._onSignOnly = function(msg) {
	  this.signBuffer = {};
	  var key = this.keyring.getById(this.mvelo.LOCAL_KEYRING_ID).getKeyForSigning(msg.signKeyId);
	  // add key in buffer
	  this.signBuffer.key = key.key;
	  this.signBuffer.keyid = msg.signKeyId;
	  this.signBuffer.userid = key.userid;
	  this.signBuffer.openPopup = false;
	  this.signBuffer.reason = 'PWD_DIALOG_REASON_SIGN';
	  this.signBuffer.beforePasswordRequest = () => this.emit('show-pwd-dialog', {id: this.pwdControl.id});
	  this.signBuffer.keyringId = this.keyringId;
	  this.pwdControl = sub.factory.get('pwdDialog');
	  this.pwdControl.unlockKey(this.signBuffer)
	  .then(() => this.emit('get-plaintext', {action: 'sign'}))
	  .catch(err => {
	    if (err.code === 'PWD_DIALOG_CANCEL') {
	      this.emit('hide-pwd-dialog');
	      return;
	    }
	    err = this.mvelo.util.mapError(err);
	    this.emit('error-message', {error: err});
	  });
	};

	EditorController.prototype._onEditorUserInput = function(msg) {
	  uiLog.push(msg.source, msg.type);
	};

	/**
	 * Lookup a recipient's public key on the Mailvelope Key Server and
	 * store it locally using a TOFU (trust on first use) mechanic.
	 * @param  {Object} msg   The event message object
	 * @return {undefined}
	 */
	EditorController.prototype.lookupKeyOnServer = function(msg) {
	  return this.keyserver.lookup(msg.recipient).then(key => {
	    // persist key in local keyring
	    let localKeyring = this.keyring.getById(this.mvelo.LOCAL_KEYRING_ID);
	    if (key && key.publicKeyArmored) {
	      localKeyring.importKeys([{type: 'public', armored: key.publicKeyArmored}]);
	    }
	    this.sendKeyUpdate();
	  });
	};

	EditorController.prototype.sendKeyUpdate = function() {
	  // send updated key cache to editor
	  let localKeyring = this.keyring.getById(this.mvelo.LOCAL_KEYRING_ID);
	  let keys = localKeyring.getKeyUserIDs({allUsers: true});
	  this.emit('key-update', {keys: keys}, this.ports.editor);
	};

	/**
	 * @param {Object} options
	 * @param {String} options.initText
	 * @param {String} options.keyringId
	 * @param {Function} options.getRecipientProposal
	 * @param {Function} callback
	 */
	EditorController.prototype.encrypt = function(options, callback) {
	  this.options = options;
	  this.keyringId = options.keyringId || this.mvelo.LOCAL_KEYRING_ID;
	  this.encryptCallback = callback;
	  this.mvelo.windows.openPopup('components/editor/editor.html?id=' + this.id + '&editor_type=' + this.prefs.data().general.editor_type, {width: 820, height: 550, modal: false}, (window) => {
	    this.editorPopup = window;
	  });
	};

	/**
	 * Displays the recipient proposal in the editor.
	 * @param  {Array} recipients   A list of potential recipient from the webmail ui
	 */
	EditorController.prototype.displayRecipientProposal = function(recipients) {
	  // deduplicate email addresses
	  var emails = (recipients || []).map(function(recipient) { return recipient.email; });
	  emails = this.mvelo.util.deDup(emails); // just dedup, dont change order of user input
	  recipients = emails.map(function(e) { return {email: e}; });
	  // get all public keys in the local keyring
	  var localKeyring = this.keyring.getById(this.mvelo.LOCAL_KEYRING_ID);
	  var keys = localKeyring.getKeyUserIDs({allUsers: true});
	  var tofu = this.keyserver.getTOFUPreference();
	  this.emit('public-key-userids', {keys: keys, recipients: recipients, tofu: tofu});
	};

	/**
	 * @param {String} message
	 * @param {Map} attachments
	 * @param {String} attachments.filename
	 * @param {String} attachments.content
	 * @param {Integer} attachments.size
	 * @param {String} attachments.type
	 * @returns {String | null}
	 */
	EditorController.prototype.buildMail = function(message, attachments) {
	  //var t0 = Date.now();
	  var that = this;
	  var mainMessage = new this.mailbuild("multipart/mixed");
	  var composedMessage = null;
	  var hasAttachment;
	  var quotaSize = 0;

	  if (message) {
	    quotaSize += this.mvelo.util.byteCount(message);
	    var textMime = new this.mailbuild("text/plain")
	      .setHeader("Content-Type", "text/plain; charset=utf-8")
	      .addHeader("Content-Transfer-Encoding", "quoted-printable")
	      .setContent(message);
	    mainMessage.appendChild(textMime);
	  }
	  if (attachments && attachments.length > 0) {
	    hasAttachment = true;
	    attachments.forEach(function(attachment) {
	      quotaSize += attachment.size;
	      var attachmentMime = new that.mailbuild("text/plain")
	        .createChild(false, {filename: attachment.name})
	        //.setHeader("Content-Type", attachment.type + "; charset=utf-8")
	        .addHeader("Content-Transfer-Encoding", "base64")
	        .addHeader("Content-Disposition", "attachment") // ; filename="attachment.filename
	        .setContent(attachment.content);
	      mainMessage.appendChild(attachmentMime);
	    });
	  }

	  if (this.options.quota && (quotaSize > this.options.quota)) {
	    var error = {
	      code: 'ENCRYPT_QUOTA_SIZE',
	      message: 'Mail content exceeds quota limit.'
	    };

	    if (this.ports.editorCont) {
	      this.emit('error-message', {error: error}, this.ports.editorCont);
	    }
	    return composedMessage;
	  }

	  if (hasAttachment || this.pgpMIME) {
	    composedMessage = mainMessage.build();
	  } else {
	    composedMessage = message;
	  }
	  //var t1 = Date.now();
	  //console.log("Building mime message took " + (t1 - t0) + " milliseconds. Current time: " + t1);
	  return composedMessage;
	};

	EditorController.prototype.scheduleDecrypt = function(armored) {
	  var that = this;
	  if (armored.length > 400000) {
	    // show spinner for large messages
	    this.emit('decrypt-in-progress', null, this.ports.editor);
	  }
	  this.mvelo.util.setTimeout(function() {
	    that.decryptArmored(armored);
	  }, 50);
	};

	/**
	 * @param {String} armored
	 * @returns {undefined}
	 */
	EditorController.prototype.decryptArmored = function(armored) {
	  var that = this;
	  var decryptCtrl = new DecryptController();
	  decryptCtrl.keyringId = this.keyringId;
	  this.model.readMessage(armored, this.keyringId)
	    .then(function(message) {
	      return decryptCtrl.prepareKey(message, !that.editorPopup);
	    })
	    .then(function(message) {
	      message.options = message.options || {};
	      message.options.selfSigned = Boolean(that.options.armoredDraft);
	      return decryptCtrl.decryptMessage(message);
	    })
	    .then(function(content) {
	      var handlers = {
	        onMessage: function(msg) {
	          if (that.options.quotedMailIndent) {
	            msg = msg.replace(/^(.|\n)/gm, '> $&');
	          }
	          if (that.options.quotedMailHeader) {
	            msg = '> ' + that.options.quotedMailHeader + '\n' + msg;
	          }
	          if (that.options.quotedMailIndent || that.options.quotedMailHeader) {
	            msg = '\n\n' + msg;
	          }
	          if (that.options.predefinedText) {
	            msg = msg + '\n\n' + that.options.predefinedText;
	          }
	          that.emit('set-text', {text: msg}, that.ports.editor);
	        },
	        onAttachment: function(part) {
	          if (that.options.keepAttachments) {
	            that.emit('set-attachment', {attachment: part}, that.ports.editor);
	          }
	        }
	      };
	      if (that.options.armoredDraft) {
	        if (!(content.signatures && content.signatures[0].valid)) {
	          throw { message: 'Restoring of the draft failed due to invalid signature.' };
	        }
	      }
	      return decryptCtrl.parseMessage(content.text, handlers, 'text');
	    })
	    .then(function() {
	      that.emit('decrypt-end', null, that.ports.editor);
	    })
	    .catch(function(error) {
	      error = that.mvelo.util.mapError(error);
	      that.emit('decrypt-failed', {error: error}, that.ports.editor);
	    });
	};

	/**
	 * @param {Object} options
	 * @param {String} options.message
	 * @param {Array} options.keyIdsHex
	 * @param {String} options.signKeyIdHex
	 * @return {Promise}
	 */
	EditorController.prototype.signAndEncryptMessage = function(options) {
	  let signKey;
	  return Promise.resolve()
	  .then(() => {
	    this.encryptTimer = null;
	    if (options.signKeyIdHex) {
	      signKey = this.keyring.getById(this.keyringId).getKeyForSigning(options.signKeyIdHex);
	    } else {
	      signKey = this.keyring.getById(this.keyringId).getPrimaryKey();
	    }

	    if (!signKey) {
	      this.mvelo.util.throwError('No primary key found', 'NO_PRIMARY_KEY_FOUND');
	    }

	    let signKeyPacket = signKey.key.getSigningKeyPacket();
	    let signKeyid = signKeyPacket && signKeyPacket.getKeyId().toHex();
	    if (!signKeyid) {
	      this.mvelo.util.throwError('No valid signing key packet found', 'NO_SIGN_KEY_FOUND');
	    }

	    signKey.keyid = signKeyid;
	    signKey.keyringId = this.keyringId;
	    signKey.reason = this.options.reason || 'PWD_DIALOG_REASON_SIGN';

	    if (this.editorPopup) {
	      signKey.openPopup = false;
	      signKey.beforePasswordRequest = () => this.emit('show-pwd-dialog', {id: this.pwdControl.id});
	    }
	  })
	  .then(() => {
	    this.pwdControl = sub.factory.get('pwdDialog');
	    return this.pwdControl.unlockKey(signKey);
	  })
	  .then(() => {
	    this.encryptTimer = this.mvelo.util.setTimeout(() => {
	      this.emit('encrypt-in-progress', null, this.ports.editor);
	    }, 800);

	    if (!this.prefs.data().security.password_cache) {
	      syncCtrl.triggerSync(signKey);
	    }

	    return this.model.signAndEncryptMessage({
	      keyIdsHex: options.keyIdsHex,
	      keyringId: this.keyringId,
	      primaryKey: signKey,
	      message: options.message,
	      uiLogSource: 'security_log_editor'
	    });
	  });
	};

	/**
	 * @param {Object} options
	 * @param {String} options.message
	 * @param {String} options.keyringId
	 * @param {Array} options.keyIdsHex
	 * @return {Promise}
	 */
	EditorController.prototype.encryptMessage = function(options) {
	  this.encryptTimer = this.mvelo.util.setTimeout(function() {
	    this.emit('encrypt-in-progress', null, this.ports.editor);
	  }.bind(this), 800);

	  options.uiLogSource = 'security_log_editor';

	  return this.model.encryptMessage(options);
	};

	/**
	 * @param {String} message
	 * @return {Promise}
	 */
	EditorController.prototype.signMessage = function(message) {
	  this.encryptTimer = this.mvelo.util.setTimeout(function() {
	    this.emit('encrypt-in-progress');
	  }.bind(this), 800);

	  return this.model.signMessage(message, this.signBuffer.key);
	};

	/**
	 * Closes the editor popup and transfer the encrypted/signed armored
	 * message and recipients back to the webmail interface.
	 * @param  {String} options.armored   The encrypted/signed message
	 * @param  {Array}  options.keys      The keys used to encrypt the message
	 */
	EditorController.prototype.transferEncrypted = function(options) {
	  if (this.ports.editorCont) {
	    this.emit('encrypted-message', { message: options.armored }, this.ports.editorCont);
	  } else {
	    var recipients = (options.keys || []).map(function(k) {
	      return {name: k.name, email: k.email};
	    });
	    this.encryptCallback(null, options.armored, recipients);
	  }
	};

	/**
	 * @param {Object} options
	 * @param {String} options.action
	 * @param {String} options.message
	 * @param {String} options.keys
	 * @param {Array} options.attachment
	 * @return {undefined}
	 * @error {Error}
	 */
	EditorController.prototype._onSignAndEncrypt = function(options) {
	  options.keys = options.keys || [];
	  this.signAndEncrypt(options)
	  .then(function(armored) {
	    this.emit('encrypt-end', null, this.ports.editor);
	    if (this.editorPopup) {
	      this.editorPopup.close();
	      this.editorPopup = null;
	    }
	    this.transferEncrypted({armored: armored, keys: options.keys});
	  }.bind(this))
	  .catch(function(error) {
	    if (this.editorPopup && error.code === 'PWD_DIALOG_CANCEL') {
	      // popup case
	      this.emit('hide-pwd-dialog');
	      return;
	    }
	    console.log(error);
	    error = this.mvelo.util.mapError(error);
	    this.emit('error-message', {error: error}, this.ports.editor);
	    if (this.ports.editorCont) {
	      this.emit('error-message', {error: error}, this.ports.editorCont);
	    } else {
	      this.encryptCallback(error);
	    }
	    this.emit('encrypt-failed', null, this.ports.editor);
	  }.bind(this))
	  .then(function() {
	    this.mvelo.util.clearTimeout(this.encryptTimer);
	  }.bind(this));
	};

	/**
	 * @param {Object} options
	 * @param {String} options.action
	 * @param {String} options.message
	 * @param {String} options.keys
	 * @param {Array} options.attachment
	 * @return {Promise}
	 */
	EditorController.prototype.signAndEncrypt = function(options) {
	  return Promise.resolve()
	  .then(function() {
	    if (options.action === 'encrypt') {
	      var data = this.buildMail(options.message, options.attachments);

	      if (data === null) {
	        this.mvelo.util.throwError('MIME building failed.');
	      }

	      var keyIdsHex = this.getPublicKeyIds(options.keys);
	      if (this.signMsg || options.signMsg) {
	        return this.signAndEncryptMessage({
	          message: data,
	          keyIdsHex: keyIdsHex,
	          signKeyIdHex: options.signKey
	        });
	      } else {
	        return this.encryptMessage({
	          message: data,
	          keyringId: this.keyringId,
	          keyIdsHex: keyIdsHex
	        });
	      }

	    } else if (options.action === 'sign') {
	      return this.signMessage(options.message);
	    }
	  }.bind(this));
	};

	/**
	 * Collect all the key ids to encrypto to, including the sender's key id.
	 * @param  {Array} keys   The public key objects containing the key id
	 * @return {Array}        A collection of all key ids to encrypt to
	 */
	EditorController.prototype.getPublicKeyIds = function(keys) {
	  var keyIdsHex;
	  // prefer keyidBuffer
	  if (this.keyidBuffer) {
	    keyIdsHex = this.keyidBuffer;
	  } else {
	    keyIdsHex = keys.map(function(key) { return key.keyid; });
	    // get the sender key id
	    if (this.prefs.data().general.auto_add_primary) {
	      var localKeyring = this.keyring.getById(this.mvelo.LOCAL_KEYRING_ID);
	      var primary = localKeyring.getPrimaryKey();
	      if (primary) {
	        keyIdsHex.push(primary.keyid.toLowerCase());
	      }
	    }
	  }
	  // deduplicate
	  return this.mvelo.util.sortAndDeDup(keyIdsHex);
	};

	exports.EditorController = EditorController;


/***/ },
/* 53 */
/*!************************************************************!*\
  !*** ./~/emailjs-mime-builder/src/emailjs-mime-builder.js ***!
  \************************************************************/
/***/ function(module, exports, __webpack_require__) {

	var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_ARRAY__, __WEBPACK_AMD_DEFINE_RESULT__;// Copyright (c) 2013 Andris Reinman
	//
	// Permission is hereby granted, free of charge, to any person obtaining a copy
	// of this software and associated documentation files (the "Software"), to deal
	// in the Software without restriction, including without limitation the rights
	// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
	// copies of the Software, and to permit persons to whom the Software is
	// furnished to do so, subject to the following conditions:

	// The above copyright notice and this permission notice shall be included in
	// all copies or substantial portions of the Software.

	// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
	// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
	// THE SOFTWARE.

	(function(root, factory) {
	    'use strict';

	    if (true) {
	        !(__WEBPACK_AMD_DEFINE_ARRAY__ = [__webpack_require__(/*! emailjs-mime-codec */ 43), __webpack_require__(/*! emailjs-mime-types */ 54), __webpack_require__(/*! punycode */ 55), __webpack_require__(/*! emailjs-addressparser */ 46)], __WEBPACK_AMD_DEFINE_FACTORY__ = (factory), __WEBPACK_AMD_DEFINE_RESULT__ = (typeof __WEBPACK_AMD_DEFINE_FACTORY__ === 'function' ? (__WEBPACK_AMD_DEFINE_FACTORY__.apply(exports, __WEBPACK_AMD_DEFINE_ARRAY__)) : __WEBPACK_AMD_DEFINE_FACTORY__), __WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
	    } else if (typeof exports === 'object') {
	        module.exports = factory(require('emailjs-mime-codec'), require('emailjs-mime-types'), require('punycode'), require('emailjs-addressparser'));
	    } else {
	        root['emailjs-mime-builder'] = factory(root['emailjs-mime-codec'], root['emailjs-mime-types'], root.punycode, root['emailjs-addressparser']);
	    }
	}(this, function(mimecodec, mimetypes, punycode, addressparser) {
	    'use strict';

	    /**
	     * Creates a new mime tree node. Assumes 'multipart/*' as the content type
	     * if it is a branch, anything else counts as leaf. If rootNode is missing from
	     * the options, assumes this is the root.
	     *
	     * @param {String} contentType Define the content type for the node. Can be left blank for attachments (derived from filename)
	     * @param {Object} [options] optional options
	     * @param {Object} [options.rootNode] root node for this tree
	     * @param {Object} [options.parentNode] immediate parent for this node
	     * @param {Object} [options.filename] filename for an attachment node
	     * @param {String} [options.baseBoundary] shared part of the unique multipart boundary
	     */
	    function MimeNode(contentType, options) {
	        this.nodeCounter = 0;

	        options = options || {};

	        /**
	         * shared part of the unique multipart boundary
	         */
	        this.baseBoundary = options.baseBoundary || Date.now().toString() + Math.random();

	        /**
	         * If date headers is missing and current node is the root, this value is used instead
	         */
	        this.date = new Date();

	        /**
	         * Root node for current mime tree
	         */
	        this.rootNode = options.rootNode || this;

	        /**
	         * If filename is specified but contentType is not (probably an attachment)
	         * detect the content type from filename extension
	         */
	        if (options.filename) {
	            /**
	             * Filename for this node. Useful with attachments
	             */
	            this.filename = options.filename;
	            if (!contentType) {
	                contentType = mimetypes.detectMimeType(this.filename.split('.').pop());
	            }
	        }

	        /**
	         * Immediate parent for this node (or undefined if not set)
	         */
	        this.parentNode = options.parentNode;

	        /**
	         * Used for generating unique boundaries (prepended to the shared base)
	         */
	        this._nodeId = ++this.rootNode.nodeCounter;

	        /**
	         * An array for possible child nodes
	         */
	        this._childNodes = [];

	        /**
	         * A list of header values for this node in the form of [{key:'', value:''}]
	         */
	        this._headers = [];

	        /**
	         * If content type is set (or derived from the filename) add it to headers
	         */
	        if (contentType) {
	            this.setHeader('content-type', contentType);
	        }
	    }

	    /////// PUBLIC METHODS

	    /**
	     * Creates and appends a child node. Arguments provided are passed to MimeNode constructor
	     *
	     * @param {String} [contentType] Optional content type
	     * @param {Object} [options] Optional options object
	     * @return {Object} Created node object
	     */
	    MimeNode.prototype.createChild = function(contentType, options) {
	        if (!options && typeof contentType === 'object') {
	            options = contentType;
	            contentType = undefined;
	        }
	        var node = new MimeNode(contentType, options);
	        this.appendChild(node);
	        return node;
	    };

	    /**
	     * Appends an existing node to the mime tree. Removes the node from an existing
	     * tree if needed
	     *
	     * @param {Object} childNode node to be appended
	     * @return {Object} Appended node object
	     */
	    MimeNode.prototype.appendChild = function(childNode) {

	        if (childNode.rootNode !== this.rootNode) {
	            childNode.rootNode = this.rootNode;
	            childNode._nodeId = ++this.rootNode.nodeCounter;
	        }

	        childNode.parentNode = this;

	        this._childNodes.push(childNode);
	        return childNode;
	    };

	    /**
	     * Replaces current node with another node
	     *
	     * @param {Object} node Replacement node
	     * @return {Object} Replacement node
	     */
	    MimeNode.prototype.replace = function(node) {
	        if (node === this) {
	            return this;
	        }

	        this.parentNode._childNodes.forEach(function(childNode, i) {
	            if (childNode === this) {

	                node.rootNode = this.rootNode;
	                node.parentNode = this.parentNode;
	                node._nodeId = this._nodeId;

	                this.rootNode = this;
	                this.parentNode = undefined;

	                node.parentNode._childNodes[i] = node;
	            }
	        }.bind(this));

	        return node;
	    };

	    /**
	     * Removes current node from the mime tree
	     *
	     * @return {Object} removed node
	     */
	    MimeNode.prototype.remove = function() {
	        if (!this.parentNode) {
	            return this;
	        }

	        for (var i = this.parentNode._childNodes.length - 1; i >= 0; i--) {
	            if (this.parentNode._childNodes[i] === this) {
	                this.parentNode._childNodes.splice(i, 1);
	                this.parentNode = undefined;
	                this.rootNode = this;
	                return this;
	            }
	        }
	    };

	    /**
	     * Sets a header value. If the value for selected key exists, it is overwritten.
	     * You can set multiple values as well by using [{key:'', value:''}] or
	     * {key: 'value'} as the first argument.
	     *
	     * @param {String|Array|Object} key Header key or a list of key value pairs
	     * @param {String} value Header value
	     * @return {Object} current node
	     */
	    MimeNode.prototype.setHeader = function(key, value) {
	        var added = false,
	            headerValue;

	        // Allow setting multiple headers at once
	        if (!value && key && typeof key === 'object') {
	            // allow {key:'content-type', value: 'text/plain'}
	            if (key.key && key.value) {
	                this.setHeader(key.key, key.value);
	            }
	            // allow [{key:'content-type', value: 'text/plain'}]
	            else if (Array.isArray(key)) {
	                key.forEach(function(i) {
	                    this.setHeader(i.key, i.value);
	                }.bind(this));
	            }
	            // allow {'content-type': 'text/plain'}
	            else {
	                Object.keys(key).forEach(function(i) {
	                    this.setHeader(i, key[i]);
	                }.bind(this));
	            }
	            return this;
	        }

	        key = this._normalizeHeaderKey(key);

	        headerValue = {
	            key: key,
	            value: value
	        };

	        // Check if the value exists and overwrite
	        for (var i = 0, len = this._headers.length; i < len; i++) {
	            if (this._headers[i].key === key) {
	                if (!added) {
	                    // replace the first match
	                    this._headers[i] = headerValue;
	                    added = true;
	                } else {
	                    // remove following matches
	                    this._headers.splice(i, 1);
	                    i--;
	                    len--;
	                }
	            }
	        }

	        // match not found, append the value
	        if (!added) {
	            this._headers.push(headerValue);
	        }

	        return this;
	    };

	    /**
	     * Adds a header value. If the value for selected key exists, the value is appended
	     * as a new field and old one is not touched.
	     * You can set multiple values as well by using [{key:'', value:''}] or
	     * {key: 'value'} as the first argument.
	     *
	     * @param {String|Array|Object} key Header key or a list of key value pairs
	     * @param {String} value Header value
	     * @return {Object} current node
	     */
	    MimeNode.prototype.addHeader = function(key, value) {

	        // Allow setting multiple headers at once
	        if (!value && key && typeof key === 'object') {
	            // allow {key:'content-type', value: 'text/plain'}
	            if (key.key && key.value) {
	                this.addHeader(key.key, key.value);
	            }
	            // allow [{key:'content-type', value: 'text/plain'}]
	            else if (Array.isArray(key)) {
	                key.forEach(function(i) {
	                    this.addHeader(i.key, i.value);
	                }.bind(this));
	            }
	            // allow {'content-type': 'text/plain'}
	            else {
	                Object.keys(key).forEach(function(i) {
	                    this.addHeader(i, key[i]);
	                }.bind(this));
	            }
	            return this;
	        }

	        this._headers.push({
	            key: this._normalizeHeaderKey(key),
	            value: value
	        });

	        return this;
	    };

	    /**
	     * Retrieves the first mathcing value of a selected key
	     *
	     * @param {String} key Key to search for
	     * @retun {String} Value for the key
	     */
	    MimeNode.prototype.getHeader = function(key) {
	        key = this._normalizeHeaderKey(key);
	        for (var i = 0, len = this._headers.length; i < len; i++) {
	            if (this._headers[i].key === key) {
	                return this._headers[i].value;
	            }
	        }
	    };

	    /**
	     * Sets body content for current node. If the value is a string, charset is added automatically
	     * to Content-Type (if it is text/*). If the value is a Typed Array, you need to specify
	     * the charset yourself
	     *
	     * @param (String|Uint8Array) content Body content
	     * @return {Object} current node
	     */
	    MimeNode.prototype.setContent = function(content) {
	        this.content = content;
	        return this;
	    };

	    /**
	     * Builds the rfc2822 message from the current node. If this is a root node,
	     * mandatory header fields are set if missing (Date, Message-Id, MIME-Version)
	     *
	     * @return {String} Compiled message
	     */
	    MimeNode.prototype.build = function() {
	        var lines = [],
	            contentType = (this.getHeader('Content-Type') || '').toString().toLowerCase().trim(),
	            transferEncoding, flowed;

	        if (this.content) {
	            transferEncoding = (this.getHeader('Content-Transfer-Encoding') || '').toString().toLowerCase().trim();
	            if (!transferEncoding || ['base64', 'quoted-printable'].indexOf(transferEncoding) < 0) {
	                if (/^text\//i.test(contentType)) {
	                    // If there are no special symbols, no need to modify the text
	                    if (this._isPlainText(this.content)) {
	                        // If there are lines longer than 76 symbols/bytes, make the text 'flowed'
	                        if (/^.{77,}/m.test(this.content)) {
	                            flowed = true;
	                        }
	                        transferEncoding = '7bit';
	                    } else {
	                        transferEncoding = 'quoted-printable';
	                    }
	                } else if (!/^multipart\//i.test(contentType)) {
	                    transferEncoding = transferEncoding || 'base64';
	                }
	            }

	            if (transferEncoding) {
	                this.setHeader('Content-Transfer-Encoding', transferEncoding);
	            }
	        }

	        if (this.filename && !this.getHeader('Content-Disposition')) {
	            this.setHeader('Content-Disposition', 'attachment');
	        }

	        this._headers.forEach(function(header) {
	            var key = header.key,
	                value = header.value,
	                structured;

	            switch (header.key) {
	                case 'Content-Disposition':
	                    structured = mimecodec.parseHeaderValue(value);
	                    if (this.filename) {
	                        structured.params.filename = this.filename;
	                    }
	                    value = this._buildHeaderValue(structured);
	                    break;
	                case 'Content-Type':
	                    structured = mimecodec.parseHeaderValue(value);

	                    this._handleContentType(structured);

	                    if (flowed) {
	                        structured.params.format = 'flowed';
	                    }
	                    if (String(structured.params.format).toLowerCase().trim() === 'flowed') {
	                        flowed = true;
	                    }

	                    if (structured.value.match(/^text\//) && typeof this.content === 'string' && /[\u0080-\uFFFF]/.test(this.content)) {
	                        structured.params.charset = 'utf-8';
	                    }

	                    value = this._buildHeaderValue(structured);
	                    break;
	                case 'Bcc':
	                    // skip BCC values
	                    return;
	            }

	            // skip empty lines
	            value = this._encodeHeaderValue(key, value);
	            if (!(value || '').toString().trim()) {
	                return;
	            }

	            lines.push(mimecodec.foldLines(key + ': ' + value, 76));
	        }.bind(this));

	        // Ensure mandatory header fields
	        if (this.rootNode === this) {
	            if (!this.getHeader('Date')) {
	                lines.push('Date: ' + this.date.toUTCString().replace(/GMT/, '+0000'));
	            }
	            // You really should define your own Message-Id field
	            if (!this.getHeader('Message-Id')) {
	                lines.push('Message-Id: <' +
	                    // crux to generate random strings like this:
	                    // "1401391905590-58aa8c32-d32a065c-c1a2aad2"
	                    [0, 0, 0].reduce(function(prev) {
	                        return prev + '-' + Math.floor((1 + Math.random()) * 0x100000000).
	                        toString(16).
	                        substring(1);
	                    }, Date.now()) +
	                    '@' +
	                    // try to use the domain of the FROM address or fallback localhost
	                    (this.getEnvelope().from || 'localhost').split('@').pop() +
	                    '>');
	            }
	            if (!this.getHeader('MIME-Version')) {
	                lines.push('MIME-Version: 1.0');
	            }
	        }
	        lines.push('');

	        if (this.content) {

	            switch (transferEncoding) {
	                case 'quoted-printable':
	                    lines.push(mimecodec.quotedPrintableEncode(this.content));
	                    break;
	                case 'base64':
	                    lines.push(mimecodec.base64Encode(this.content, typeof this.content === 'object' && 'binary' || false));
	                    break;
	                default:
	                    if (flowed) {
	                        lines.push(mimecodec.foldLines(this.content.replace(/\r?\n/g, '\r\n').
	                            // space stuffing http://tools.ietf.org/html/rfc3676#section-4.2
	                            replace(/^( |From|>)/igm, ' $1'),
	                            76, true));
	                    } else {
	                        lines.push(this.content.replace(/\r?\n/g, '\r\n'));
	                    }
	            }
	            if (this.multipart) {
	                lines.push('');
	            }
	        }

	        if (this.multipart) {
	            this._childNodes.forEach(function(node) {
	                lines.push('--' + this.boundary);
	                lines.push(node.build());
	            }.bind(this));
	            lines.push('--' + this.boundary + '--');
	            lines.push('');
	        }

	        return lines.join('\r\n');
	    };

	    /**
	     * Generates and returns SMTP envelope with the sender address and a list of recipients addresses
	     *
	     * @return {Object} SMTP envelope in the form of {from: 'from@example.com', to: ['to@example.com']}
	     */
	    MimeNode.prototype.getEnvelope = function() {
	        var envelope = {
	            from: false,
	            to: []
	        };
	        this._headers.forEach(function(header) {
	            var list = [];
	            if (header.key === 'From' || (!envelope.from && ['Reply-To', 'Sender'].indexOf(header.key) >= 0)) {
	                this._convertAddresses(this._parseAddresses(header.value), list);
	                if (list.length && list[0]) {
	                    envelope.from = list[0];
	                }
	            } else if (['To', 'Cc', 'Bcc'].indexOf(header.key) >= 0) {
	                this._convertAddresses(this._parseAddresses(header.value), envelope.to);
	            }
	        }.bind(this));

	        return envelope;
	    };

	    /////// PRIVATE METHODS

	    /**
	     * Parses addresses. Takes in a single address or an array or an
	     * array of address arrays (eg. To: [[first group], [second group],...])
	     *
	     * @param {Mixed} addresses Addresses to be parsed
	     * @return {Array} An array of address objects
	     */
	    MimeNode.prototype._parseAddresses = function(addresses) {
	        return [].concat.apply([], [].concat(addresses).map(function(address) {
	            if (address && address.address) {
	                address = this._convertAddresses(address);
	            }
	            return addressparser.parse(address);
	        }.bind(this)));
	    };

	    /**
	     * Normalizes a header key, uses Camel-Case form, except for uppercase MIME-
	     *
	     * @param {String} key Key to be normalized
	     * @return {String} key in Camel-Case form
	     */
	    MimeNode.prototype._normalizeHeaderKey = function(key) {
	        return (key || '').toString().
	            // no newlines in keys
	        replace(/\r?\n|\r/g, ' ').
	        trim().toLowerCase().
	        // use uppercase words, except MIME
	        replace(/^MIME\b|^[a-z]|\-[a-z]/ig, function(c) {
	            return c.toUpperCase();
	        });
	    };

	    /**
	     * Joins parsed header value together as 'value; param1=value1; param2=value2'
	     *
	     * @param {Object} structured Parsed header value
	     * @return {String} joined header value
	     */
	    MimeNode.prototype._buildHeaderValue = function(structured) {
	        var paramsArray = [];

	        Object.keys(structured.params || {}).forEach(function(param) {
	            // filename might include unicode characters so it is a special case
	            if (param === 'filename') {
	                mimecodec.continuationEncode(param, structured.params[param], 50).forEach(function(encodedParam) {
	                    // continuation encoded strings are always escaped, so no need to use enclosing quotes
	                    // in fact using quotes might end up with invalid filenames in some clients
	                    paramsArray.push(encodedParam.key + '=' + encodedParam.value);
	                });
	            } else {
	                paramsArray.push(param + '=' + this._escapeHeaderArgument(structured.params[param]));
	            }
	        }.bind(this));

	        return structured.value + (paramsArray.length ? '; ' + paramsArray.join('; ') : '');
	    };

	    /**
	     * Escapes a header argument value (eg. boundary value for content type),
	     * adds surrounding quotes if needed
	     *
	     * @param {String} value Header argument value
	     * @return {String} escaped and quoted (if needed) argument value
	     */
	    MimeNode.prototype._escapeHeaderArgument = function(value) {
	        if (value.match(/[\s'"\\;\/=]|^\-/g)) {
	            return '"' + value.replace(/(["\\])/g, "\\$1") + '"';
	        } else {
	            return value;
	        }
	    };

	    /**
	     * Checks if the content type is multipart and defines boundary if needed.
	     * Doesn't return anything, modifies object argument instead.
	     *
	     * @param {Object} structured Parsed header value for 'Content-Type' key
	     */
	    MimeNode.prototype._handleContentType = function(structured) {
	        this.contentType = structured.value.trim().toLowerCase();

	        this.multipart = this.contentType.split('/').reduce(function(prev, value) {
	            return prev === 'multipart' ? value : false;
	        });

	        if (this.multipart) {
	            this.boundary = structured.params.boundary = structured.params.boundary || this.boundary || this._generateBoundary();
	        } else {
	            this.boundary = false;
	        }
	    };

	    /**
	     * Generates a multipart boundary value
	     *
	     * @return {String} boundary value
	     */
	    MimeNode.prototype._generateBoundary = function() {
	        return '----sinikael-?=_' + this._nodeId + '-' + this.rootNode.baseBoundary;
	    };

	    /**
	     * Encodes a header value for use in the generated rfc2822 email.
	     *
	     * @param {String} key Header key
	     * @param {String} value Header value
	     */
	    MimeNode.prototype._encodeHeaderValue = function(key, value) {
	        key = this._normalizeHeaderKey(key);

	        switch (key) {
	            case 'From':
	            case 'Sender':
	            case 'To':
	            case 'Cc':
	            case 'Bcc':
	            case 'Reply-To':
	                return this._convertAddresses(this._parseAddresses(value));

	            case 'Message-Id':
	            case 'In-Reply-To':
	            case 'Content-Id':
	                value = (value || '').toString().replace(/\r?\n|\r/g, ' ');

	                if (value.charAt(0) !== '<') {
	                    value = '<' + value;
	                }

	                if (value.charAt(value.length - 1) !== '>') {
	                    value = value + '>';
	                }
	                return value;

	            case 'References':
	                value = [].concat.apply([], [].concat(value || '').map(function(elm) {
	                    elm = (elm || '').toString().replace(/\r?\n|\r/g, ' ').trim();
	                    return elm.replace(/<[^>]*>/g, function(str) {
	                        return str.replace(/\s/g, '');
	                    }).split(/\s+/);
	                })).map(function(elm) {
	                    if (elm.charAt(0) !== '<') {
	                        elm = '<' + elm;
	                    }
	                    if (elm.charAt(elm.length - 1) !== '>') {
	                        elm = elm + '>';
	                    }
	                    return elm;
	                });

	                return value.join(' ').trim();

	            default:
	                value = (value || '').toString().replace(/\r?\n|\r/g, ' ');
	                // mimeWordsEncode only encodes if needed, otherwise the original string is returned
	                return mimecodec.mimeWordsEncode(value, 'Q', 52);
	        }
	    };

	    /**
	     * Rebuilds address object using punycode and other adjustments
	     *
	     * @param {Array} addresses An array of address objects
	     * @param {Array} [uniqueList] An array to be populated with addresses
	     * @return {String} address string
	     */
	    MimeNode.prototype._convertAddresses = function(addresses, uniqueList) {
	        var values = [];

	        uniqueList = uniqueList || [];

	        [].concat(addresses || []).forEach(function(address) {
	            if (address.address) {
	                address.address = address.address.replace(/^.*?(?=\@)/, function(user) {
	                    return mimecodec.mimeWordsEncode(user, 'Q', 52);
	                }).replace(/@.+$/, function(domain) {
	                    return '@' + punycode.toASCII(domain.substr(1));
	                });

	                if (!address.name) {
	                    values.push(address.address);
	                } else if (address.name) {
	                    values.push(this._encodeAddressName(address.name) + ' <' + address.address + '>');
	                }

	                if (uniqueList.indexOf(address.address) < 0) {
	                    uniqueList.push(address.address);
	                }
	            } else if (address.group) {
	                values.push(this._encodeAddressName(address.name) + ':' + (address.group.length ? this._convertAddresses(address.group, uniqueList) : '').trim() + ';');
	            }
	        }.bind(this));

	        return values.join(', ');
	    };

	    /**
	     * If needed, mime encodes the name part
	     *
	     * @param {String} name Name part of an address
	     * @returns {String} Mime word encoded string if needed
	     */
	    MimeNode.prototype._encodeAddressName = function(name) {
	        if (!/^[\w ']*$/.test(name)) {
	            if (/^[\x20-\x7e]*$/.test(name)) {
	                return '"' + name.replace(/([\\"])/g, '\\$1') + '"';
	            } else {
	                return mimecodec.mimeWordEncode(name, 'Q', 52);
	            }
	        }
	        return name;
	    };

	    /**
	     * Checks if a value is plaintext string (uses only printable 7bit chars)
	     *
	     * @param {String} value String to be tested
	     * @returns {Boolean} true if it is a plaintext string
	     */
	    MimeNode.prototype._isPlainText = function(value) {
	        if (typeof value !== 'string' || /[\x00-\x08\x0b\x0c\x0e-\x1f\u0080-\uFFFF]/.test(value)) {
	            return false;
	        } else {
	            return true;
	        }
	    };

	    return MimeNode;
	}));


/***/ },
/* 54 */
/*!********************************************************!*\
  !*** ./~/emailjs-mime-types/src/emailjs-mime-types.js ***!
  \********************************************************/
/***/ function(module, exports, __webpack_require__) {

	var __WEBPACK_AMD_DEFINE_FACTORY__, __WEBPACK_AMD_DEFINE_RESULT__;// Copyright (c) 2013 Andris Reinman
	//
	// Permission is hereby granted, free of charge, to any person obtaining a copy
	// of this software and associated documentation files (the "Software"), to deal
	// in the Software without restriction, including without limitation the rights
	// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
	// copies of the Software, and to permit persons to whom the Software is
	// furnished to do so, subject to the following conditions:

	// The above copyright notice and this permission notice shall be included in
	// all copies or substantial portions of the Software.

	// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
	// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
	// THE SOFTWARE.

	(function(root, factory) {
	    'use strict';
	    if (true) {
	        !(__WEBPACK_AMD_DEFINE_FACTORY__ = (factory), __WEBPACK_AMD_DEFINE_RESULT__ = (typeof __WEBPACK_AMD_DEFINE_FACTORY__ === 'function' ? (__WEBPACK_AMD_DEFINE_FACTORY__.call(exports, __webpack_require__, exports, module)) : __WEBPACK_AMD_DEFINE_FACTORY__), __WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
	    } else if (typeof exports === 'object') {
	        module.exports = factory();
	    } else {
	        root['emailjs-mime-types'] = factory();
	    }
	}(this, function() {
	    'use strict';

	    /**
	     * Returns file extension for a content type string. If no suitable extensions
	     * are found, 'bin' is used as the default extension
	     *
	     * @param {String} mimeType Content type to be checked for
	     * @return {String} File extension
	     */
	    function detectExtension(mimeType) {
	        mimeType = (mimeType || '').toString().toLowerCase().replace(/\s/g, '');
	        if (!(mimeType in mimetypesList)) {
	            return 'bin';
	        }

	        if (typeof mimetypesList[mimeType] === 'string') {
	            return mimetypesList[mimeType];
	        }

	        var mimeParts = mimeType.split('/');

	        // search for name match
	        for (var i = 0, len = mimetypesList[mimeType].length; i < len; i++) {
	            if (mimeParts[1] === mimetypesList[mimeType][i]) {
	                return mimetypesList[mimeType][i];
	            }
	        }

	        // use the first one
	        return mimetypesList[mimeType][0];
	    }

	    /**
	     * Returns content type for a file extension. If no suitable content types
	     * are found, 'application/octet-stream' is used as the default content type
	     *
	     * @param {String} extension Extension to be checked for
	     * @return {String} File extension
	     */
	    function detectMimeType(extension) {
	        extension = (extension || '').toString().toLowerCase().replace(/\s/g, '').replace(/^\./g, '');

	        if (!(extension in mimetypesExtensions)) {
	            return 'application/octet-stream';
	        }

	        if (typeof mimetypesExtensions[extension] === 'string') {
	            return mimetypesExtensions[extension];
	        }

	        var mimeParts;

	        // search for name match
	        for (var i = 0, len = mimetypesExtensions[extension].length; i < len; i++) {
	            mimeParts = mimetypesExtensions[extension][i].split('/');
	            if (mimeParts[1] === extension) {
	                return mimetypesExtensions[extension][i];
	            }
	        }

	        // use the first one
	        return mimetypesExtensions[extension][0];
	    }

	    var mimetypesList = {
	        'application/acad': 'dwg',
	        'application/andrew-inset': '',
	        'application/applixware': 'aw',
	        'application/arj': 'arj',
	        'application/atom+xml': 'xml',
	        'application/atomcat+xml': 'atomcat',
	        'application/atomsvc+xml': 'atomsvc',
	        'application/base64': ['mm', 'mme'],
	        'application/binhex': 'hqx',
	        'application/binhex4': 'hqx',
	        'application/book': ['boo', 'book'],
	        'application/ccxml+xml,': 'ccxml',
	        'application/cdf': 'cdf',
	        'application/cdmi-capability': 'cdmia',
	        'application/cdmi-container': 'cdmic',
	        'application/cdmi-domain': 'cdmid',
	        'application/cdmi-object': 'cdmio',
	        'application/cdmi-queue': 'cdmiq',
	        'application/clariscad': 'ccad',
	        'application/commonground': 'dp',
	        'application/cu-seeme': 'cu',
	        'application/davmount+xml': 'davmount',
	        'application/drafting': 'drw',
	        'application/dsptype': 'tsp',
	        'application/dssc+der': 'dssc',
	        'application/dssc+xml': 'xdssc',
	        'application/dxf': 'dxf',
	        'application/ecmascript': ['js', 'es'],
	        'application/emma+xml': 'emma',
	        'application/envoy': 'evy',
	        'application/epub+zip': 'epub',
	        'application/excel': ['xl', 'xla', 'xlb', 'xlc', 'xld', 'xlk', 'xll', 'xlm', 'xls', 'xlt', 'xlv', 'xlw'],
	        'application/exi': 'exi',
	        'application/font-tdpfr': 'pfr',
	        'application/fractals': 'fif',
	        'application/freeloader': 'frl',
	        'application/futuresplash': 'spl',
	        'application/gnutar': 'tgz',
	        'application/groupwise': 'vew',
	        'application/hlp': 'hlp',
	        'application/hta': 'hta',
	        'application/hyperstudio': 'stk',
	        'application/i-deas': 'unv',
	        'application/iges': ['iges', 'igs'],
	        'application/inf': 'inf',
	        'application/internet-property-stream': 'acx',
	        'application/ipfix': 'ipfix',
	        'application/java': 'class',
	        'application/java-archive': 'jar',
	        'application/java-byte-code': 'class',
	        'application/java-serialized-object': 'ser',
	        'application/java-vm': 'class',
	        'application/javascript': 'js',
	        'application/json': 'json',
	        'application/lha': 'lha',
	        'application/lzx': 'lzx',
	        'application/mac-binary': 'bin',
	        'application/mac-binhex': 'hqx',
	        'application/mac-binhex40': 'hqx',
	        'application/mac-compactpro': 'cpt',
	        'application/macbinary': 'bin',
	        'application/mads+xml': 'mads',
	        'application/marc': 'mrc',
	        'application/marcxml+xml': 'mrcx',
	        'application/mathematica': 'ma',
	        'application/mathml+xml': 'mathml',
	        'application/mbedlet': 'mbd',
	        'application/mbox': 'mbox',
	        'application/mcad': 'mcd',
	        'application/mediaservercontrol+xml': 'mscml',
	        'application/metalink4+xml': 'meta4',
	        'application/mets+xml': 'mets',
	        'application/mime': 'aps',
	        'application/mods+xml': 'mods',
	        'application/mp21': 'm21',
	        'application/mp4': 'mp4',
	        'application/mspowerpoint': ['pot', 'pps', 'ppt', 'ppz'],
	        'application/msword': ['doc', 'dot', 'w6w', 'wiz', 'word'],
	        'application/mswrite': 'wri',
	        'application/mxf': 'mxf',
	        'application/netmc': 'mcp',
	        'application/octet-stream': ['*'],
	        'application/oda': 'oda',
	        'application/oebps-package+xml': 'opf',
	        'application/ogg': 'ogx',
	        'application/olescript': 'axs',
	        'application/onenote': 'onetoc',
	        'application/patch-ops-error+xml': 'xer',
	        'application/pdf': 'pdf',
	        'application/pgp-encrypted': '',
	        'application/pgp-signature': 'pgp',
	        'application/pics-rules': 'prf',
	        'application/pkcs-12': 'p12',
	        'application/pkcs-crl': 'crl',
	        'application/pkcs10': 'p10',
	        'application/pkcs7-mime': ['p7c', 'p7m'],
	        'application/pkcs7-signature': 'p7s',
	        'application/pkcs8': 'p8',
	        'application/pkix-attr-cert': 'ac',
	        'application/pkix-cert': ['cer', 'crt'],
	        'application/pkix-crl': 'crl',
	        'application/pkix-pkipath': 'pkipath',
	        'application/pkixcmp': 'pki',
	        'application/plain': 'text',
	        'application/pls+xml': 'pls',
	        'application/postscript': ['ai', 'eps', 'ps'],
	        'application/powerpoint': 'ppt',
	        'application/pro_eng': ['part', 'prt'],
	        'application/prs.cww': 'cww',
	        'application/pskc+xml': 'pskcxml',
	        'application/rdf+xml': 'rdf',
	        'application/reginfo+xml': 'rif',
	        'application/relax-ng-compact-syntax': 'rnc',
	        'application/resource-lists+xml': 'rl',
	        'application/resource-lists-diff+xml': 'rld',
	        'application/ringing-tones': 'rng',
	        'application/rls-services+xml': 'rs',
	        'application/rsd+xml': 'rsd',
	        'application/rss+xml': 'xml',
	        'application/rtf': ['rtf', 'rtx'],
	        'application/sbml+xml': 'sbml',
	        'application/scvp-cv-request': 'scq',
	        'application/scvp-cv-response': 'scs',
	        'application/scvp-vp-request': 'spq',
	        'application/scvp-vp-response': 'spp',
	        'application/sdp': 'sdp',
	        'application/sea': 'sea',
	        'application/set': 'set',
	        'application/set-payment-initiation': 'setpay',
	        'application/set-registration-initiation': 'setreg',
	        'application/shf+xml': 'shf',
	        'application/sla': 'stl',
	        'application/smil': ['smi', 'smil'],
	        'application/smil+xml': 'smi',
	        'application/solids': 'sol',
	        'application/sounder': 'sdr',
	        'application/sparql-query': 'rq',
	        'application/sparql-results+xml': 'srx',
	        'application/srgs': 'gram',
	        'application/srgs+xml': 'grxml',
	        'application/sru+xml': 'sru',
	        'application/ssml+xml': 'ssml',
	        'application/step': ['step', 'stp'],
	        'application/streamingmedia': 'ssm',
	        'application/tei+xml': 'tei',
	        'application/thraud+xml': 'tfi',
	        'application/timestamped-data': 'tsd',
	        'application/toolbook': 'tbk',
	        'application/vda': 'vda',
	        'application/vnd.3gpp.pic-bw-large': 'plb',
	        'application/vnd.3gpp.pic-bw-small': 'psb',
	        'application/vnd.3gpp.pic-bw-var': 'pvb',
	        'application/vnd.3gpp2.tcap': 'tcap',
	        'application/vnd.3m.post-it-notes': 'pwn',
	        'application/vnd.accpac.simply.aso': 'aso',
	        'application/vnd.accpac.simply.imp': 'imp',
	        'application/vnd.acucobol': 'acu',
	        'application/vnd.acucorp': 'atc',
	        'application/vnd.adobe.air-application-installer-package+zip': 'air',
	        'application/vnd.adobe.fxp': 'fxp',
	        'application/vnd.adobe.xdp+xml': 'xdp',
	        'application/vnd.adobe.xfdf': 'xfdf',
	        'application/vnd.ahead.space': 'ahead',
	        'application/vnd.airzip.filesecure.azf': 'azf',
	        'application/vnd.airzip.filesecure.azs': 'azs',
	        'application/vnd.amazon.ebook': 'azw',
	        'application/vnd.americandynamics.acc': 'acc',
	        'application/vnd.amiga.ami': 'ami',
	        'application/vnd.android.package-archive': 'apk',
	        'application/vnd.anser-web-certificate-issue-initiation': 'cii',
	        'application/vnd.anser-web-funds-transfer-initiation': 'fti',
	        'application/vnd.antix.game-component': 'atx',
	        'application/vnd.apple.installer+xml': 'mpkg',
	        'application/vnd.apple.mpegurl': 'm3u8',
	        'application/vnd.aristanetworks.swi': 'swi',
	        'application/vnd.audiograph': 'aep',
	        'application/vnd.blueice.multipass': 'mpm',
	        'application/vnd.bmi': 'bmi',
	        'application/vnd.businessobjects': 'rep',
	        'application/vnd.chemdraw+xml': 'cdxml',
	        'application/vnd.chipnuts.karaoke-mmd': 'mmd',
	        'application/vnd.cinderella': 'cdy',
	        'application/vnd.claymore': 'cla',
	        'application/vnd.cloanto.rp9': 'rp9',
	        'application/vnd.clonk.c4group': 'c4g',
	        'application/vnd.cluetrust.cartomobile-config': 'c11amc',
	        'application/vnd.cluetrust.cartomobile-config-pkg': 'c11amz',
	        'application/vnd.commonspace': 'csp',
	        'application/vnd.contact.cmsg': 'cdbcmsg',
	        'application/vnd.cosmocaller': 'cmc',
	        'application/vnd.crick.clicker': 'clkx',
	        'application/vnd.crick.clicker.keyboard': 'clkk',
	        'application/vnd.crick.clicker.palette': 'clkp',
	        'application/vnd.crick.clicker.template': 'clkt',
	        'application/vnd.crick.clicker.wordbank': 'clkw',
	        'application/vnd.criticaltools.wbs+xml': 'wbs',
	        'application/vnd.ctc-posml': 'pml',
	        'application/vnd.cups-ppd': 'ppd',
	        'application/vnd.curl.car': 'car',
	        'application/vnd.curl.pcurl': 'pcurl',
	        'application/vnd.data-vision.rdz': 'rdz',
	        'application/vnd.denovo.fcselayout-link': 'fe_launch',
	        'application/vnd.dna': 'dna',
	        'application/vnd.dolby.mlp': 'mlp',
	        'application/vnd.dpgraph': 'dpg',
	        'application/vnd.dreamfactory': 'dfac',
	        'application/vnd.dvb.ait': 'ait',
	        'application/vnd.dvb.service': 'svc',
	        'application/vnd.dynageo': 'geo',
	        'application/vnd.ecowin.chart': 'mag',
	        'application/vnd.enliven': 'nml',
	        'application/vnd.epson.esf': 'esf',
	        'application/vnd.epson.msf': 'msf',
	        'application/vnd.epson.quickanime': 'qam',
	        'application/vnd.epson.salt': 'slt',
	        'application/vnd.epson.ssf': 'ssf',
	        'application/vnd.eszigno3+xml': 'es3',
	        'application/vnd.ezpix-album': 'ez2',
	        'application/vnd.ezpix-package': 'ez3',
	        'application/vnd.fdf': 'fdf',
	        'application/vnd.fdsn.seed': 'seed',
	        'application/vnd.flographit': 'gph',
	        'application/vnd.fluxtime.clip': 'ftc',
	        'application/vnd.framemaker': 'fm',
	        'application/vnd.frogans.fnc': 'fnc',
	        'application/vnd.frogans.ltf': 'ltf',
	        'application/vnd.fsc.weblaunch': 'fsc',
	        'application/vnd.fujitsu.oasys': 'oas',
	        'application/vnd.fujitsu.oasys2': 'oa2',
	        'application/vnd.fujitsu.oasys3': 'oa3',
	        'application/vnd.fujitsu.oasysgp': 'fg5',
	        'application/vnd.fujitsu.oasysprs': 'bh2',
	        'application/vnd.fujixerox.ddd': 'ddd',
	        'application/vnd.fujixerox.docuworks': 'xdw',
	        'application/vnd.fujixerox.docuworks.binder': 'xbd',
	        'application/vnd.fuzzysheet': 'fzs',
	        'application/vnd.genomatix.tuxedo': 'txd',
	        'application/vnd.geogebra.file': 'ggb',
	        'application/vnd.geogebra.tool': 'ggt',
	        'application/vnd.geometry-explorer': 'gex',
	        'application/vnd.geonext': 'gxt',
	        'application/vnd.geoplan': 'g2w',
	        'application/vnd.geospace': 'g3w',
	        'application/vnd.gmx': 'gmx',
	        'application/vnd.google-earth.kml+xml': 'kml',
	        'application/vnd.google-earth.kmz': 'kmz',
	        'application/vnd.grafeq': 'gqf',
	        'application/vnd.groove-account': 'gac',
	        'application/vnd.groove-help': 'ghf',
	        'application/vnd.groove-identity-message': 'gim',
	        'application/vnd.groove-injector': 'grv',
	        'application/vnd.groove-tool-message': 'gtm',
	        'application/vnd.groove-tool-template': 'tpl',
	        'application/vnd.groove-vcard': 'vcg',
	        'application/vnd.hal+xml': 'hal',
	        'application/vnd.handheld-entertainment+xml': 'zmm',
	        'application/vnd.hbci': 'hbci',
	        'application/vnd.hhe.lesson-player': 'les',
	        'application/vnd.hp-hpgl': ['hgl', 'hpg', 'hpgl'],
	        'application/vnd.hp-hpid': 'hpid',
	        'application/vnd.hp-hps': 'hps',
	        'application/vnd.hp-jlyt': 'jlt',
	        'application/vnd.hp-pcl': 'pcl',
	        'application/vnd.hp-pclxl': 'pclxl',
	        'application/vnd.hydrostatix.sof-data': 'sfd-hdstx',
	        'application/vnd.hzn-3d-crossword': 'x3d',
	        'application/vnd.ibm.minipay': 'mpy',
	        'application/vnd.ibm.modcap': 'afp',
	        'application/vnd.ibm.rights-management': 'irm',
	        'application/vnd.ibm.secure-container': 'sc',
	        'application/vnd.iccprofile': 'icc',
	        'application/vnd.igloader': 'igl',
	        'application/vnd.immervision-ivp': 'ivp',
	        'application/vnd.immervision-ivu': 'ivu',
	        'application/vnd.insors.igm': 'igm',
	        'application/vnd.intercon.formnet': 'xpw',
	        'application/vnd.intergeo': 'i2g',
	        'application/vnd.intu.qbo': 'qbo',
	        'application/vnd.intu.qfx': 'qfx',
	        'application/vnd.ipunplugged.rcprofile': 'rcprofile',
	        'application/vnd.irepository.package+xml': 'irp',
	        'application/vnd.is-xpr': 'xpr',
	        'application/vnd.isac.fcs': 'fcs',
	        'application/vnd.jam': 'jam',
	        'application/vnd.jcp.javame.midlet-rms': 'rms',
	        'application/vnd.jisp': 'jisp',
	        'application/vnd.joost.joda-archive': 'joda',
	        'application/vnd.kahootz': 'ktz',
	        'application/vnd.kde.karbon': 'karbon',
	        'application/vnd.kde.kchart': 'chrt',
	        'application/vnd.kde.kformula': 'kfo',
	        'application/vnd.kde.kivio': 'flw',
	        'application/vnd.kde.kontour': 'kon',
	        'application/vnd.kde.kpresenter': 'kpr',
	        'application/vnd.kde.kspread': 'ksp',
	        'application/vnd.kde.kword': 'kwd',
	        'application/vnd.kenameaapp': 'htke',
	        'application/vnd.kidspiration': 'kia',
	        'application/vnd.kinar': 'kne',
	        'application/vnd.koan': 'skp',
	        'application/vnd.kodak-descriptor': 'sse',
	        'application/vnd.las.las+xml': 'lasxml',
	        'application/vnd.llamagraphics.life-balance.desktop': 'lbd',
	        'application/vnd.llamagraphics.life-balance.exchange+xml': 'lbe',
	        'application/vnd.lotus-1-2-3': '123',
	        'application/vnd.lotus-approach': 'apr',
	        'application/vnd.lotus-freelance': 'pre',
	        'application/vnd.lotus-notes': 'nsf',
	        'application/vnd.lotus-organizer': 'org',
	        'application/vnd.lotus-screencam': 'scm',
	        'application/vnd.lotus-wordpro': 'lwp',
	        'application/vnd.macports.portpkg': 'portpkg',
	        'application/vnd.mcd': 'mcd',
	        'application/vnd.medcalcdata': 'mc1',
	        'application/vnd.mediastation.cdkey': 'cdkey',
	        'application/vnd.mfer': 'mwf',
	        'application/vnd.mfmp': 'mfm',
	        'application/vnd.micrografx.flo': 'flo',
	        'application/vnd.micrografx.igx': 'igx',
	        'application/vnd.mif': 'mif',
	        'application/vnd.mobius.daf': 'daf',
	        'application/vnd.mobius.dis': 'dis',
	        'application/vnd.mobius.mbk': 'mbk',
	        'application/vnd.mobius.mqy': 'mqy',
	        'application/vnd.mobius.msl': 'msl',
	        'application/vnd.mobius.plc': 'plc',
	        'application/vnd.mobius.txf': 'txf',
	        'application/vnd.mophun.application': 'mpn',
	        'application/vnd.mophun.certificate': 'mpc',
	        'application/vnd.mozilla.xul+xml': 'xul',
	        'application/vnd.ms-artgalry': 'cil',
	        'application/vnd.ms-cab-compressed': 'cab',
	        'application/vnd.ms-excel': ['xla', 'xlc', 'xlm', 'xls', 'xlt', 'xlw', 'xlb', 'xll'],
	        'application/vnd.ms-excel.addin.macroenabled.12': 'xlam',
	        'application/vnd.ms-excel.sheet.binary.macroenabled.12': 'xlsb',
	        'application/vnd.ms-excel.sheet.macroenabled.12': 'xlsm',
	        'application/vnd.ms-excel.template.macroenabled.12': 'xltm',
	        'application/vnd.ms-fontobject': 'eot',
	        'application/vnd.ms-htmlhelp': 'chm',
	        'application/vnd.ms-ims': 'ims',
	        'application/vnd.ms-lrm': 'lrm',
	        'application/vnd.ms-officetheme': 'thmx',
	        'application/vnd.ms-outlook': 'msg',
	        'application/vnd.ms-pki.certstore': 'sst',
	        'application/vnd.ms-pki.pko': 'pko',
	        'application/vnd.ms-pki.seccat': 'cat',
	        'application/vnd.ms-pki.stl': 'stl',
	        'application/vnd.ms-pkicertstore': 'sst',
	        'application/vnd.ms-pkiseccat': 'cat',
	        'application/vnd.ms-pkistl': 'stl',
	        'application/vnd.ms-powerpoint': ['pot', 'pps', 'ppt', 'ppa', 'pwz'],
	        'application/vnd.ms-powerpoint.addin.macroenabled.12': 'ppam',
	        'application/vnd.ms-powerpoint.presentation.macroenabled.12': 'pptm',
	        'application/vnd.ms-powerpoint.slide.macroenabled.12': 'sldm',
	        'application/vnd.ms-powerpoint.slideshow.macroenabled.12': 'ppsm',
	        'application/vnd.ms-powerpoint.template.macroenabled.12': 'potm',
	        'application/vnd.ms-project': 'mpp',
	        'application/vnd.ms-word.document.macroenabled.12': 'docm',
	        'application/vnd.ms-word.template.macroenabled.12': 'dotm',
	        'application/vnd.ms-works': ['wcm', 'wdb', 'wks', 'wps'],
	        'application/vnd.ms-wpl': 'wpl',
	        'application/vnd.ms-xpsdocument': 'xps',
	        'application/vnd.mseq': 'mseq',
	        'application/vnd.musician': 'mus',
	        'application/vnd.muvee.style': 'msty',
	        'application/vnd.neurolanguage.nlu': 'nlu',
	        'application/vnd.noblenet-directory': 'nnd',
	        'application/vnd.noblenet-sealer': 'nns',
	        'application/vnd.noblenet-web': 'nnw',
	        'application/vnd.nokia.configuration-message': 'ncm',
	        'application/vnd.nokia.n-gage.data': 'ngdat',
	        'application/vnd.nokia.n-gage.symbian.install': 'n-gage',
	        'application/vnd.nokia.radio-preset': 'rpst',
	        'application/vnd.nokia.radio-presets': 'rpss',
	        'application/vnd.nokia.ringing-tone': 'rng',
	        'application/vnd.novadigm.edm': 'edm',
	        'application/vnd.novadigm.edx': 'edx',
	        'application/vnd.novadigm.ext': 'ext',
	        'application/vnd.oasis.opendocument.chart': 'odc',
	        'application/vnd.oasis.opendocument.chart-template': 'otc',
	        'application/vnd.oasis.opendocument.database': 'odb',
	        'application/vnd.oasis.opendocument.formula': 'odf',
	        'application/vnd.oasis.opendocument.formula-template': 'odft',
	        'application/vnd.oasis.opendocument.graphics': 'odg',
	        'application/vnd.oasis.opendocument.graphics-template': 'otg',
	        'application/vnd.oasis.opendocument.image': 'odi',
	        'application/vnd.oasis.opendocument.image-template': 'oti',
	        'application/vnd.oasis.opendocument.presentation': 'odp',
	        'application/vnd.oasis.opendocument.presentation-template': 'otp',
	        'application/vnd.oasis.opendocument.spreadsheet': 'ods',
	        'application/vnd.oasis.opendocument.spreadsheet-template': 'ots',
	        'application/vnd.oasis.opendocument.text': 'odt',
	        'application/vnd.oasis.opendocument.text-master': 'odm',
	        'application/vnd.oasis.opendocument.text-template': 'ott',
	        'application/vnd.oasis.opendocument.text-web': 'oth',
	        'application/vnd.olpc-sugar': 'xo',
	        'application/vnd.oma.dd2+xml': 'dd2',
	        'application/vnd.openofficeorg.extension': 'oxt',
	        'application/vnd.openxmlformats-officedocument.presentationml.presentation': 'pptx',
	        'application/vnd.openxmlformats-officedocument.presentationml.slide': 'sldx',
	        'application/vnd.openxmlformats-officedocument.presentationml.slideshow': 'ppsx',
	        'application/vnd.openxmlformats-officedocument.presentationml.template': 'potx',
	        'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet': 'xlsx',
	        'application/vnd.openxmlformats-officedocument.spreadsheetml.template': 'xltx',
	        'application/vnd.openxmlformats-officedocument.wordprocessingml.document': 'docx',
	        'application/vnd.openxmlformats-officedocument.wordprocessingml.template': 'dotx',
	        'application/vnd.osgeo.mapguide.package': 'mgp',
	        'application/vnd.osgi.dp': 'dp',
	        'application/vnd.palm': 'pdb',
	        'application/vnd.pawaafile': 'paw',
	        'application/vnd.pg.format': 'str',
	        'application/vnd.pg.osasli': 'ei6',
	        'application/vnd.picsel': 'efif',
	        'application/vnd.pmi.widget': 'wg',
	        'application/vnd.pocketlearn': 'plf',
	        'application/vnd.powerbuilder6': 'pbd',
	        'application/vnd.previewsystems.box': 'box',
	        'application/vnd.proteus.magazine': 'mgz',
	        'application/vnd.publishare-delta-tree': 'qps',
	        'application/vnd.pvi.ptid1': 'ptid',
	        'application/vnd.quark.quarkxpress': 'qxd',
	        'application/vnd.realvnc.bed': 'bed',
	        'application/vnd.recordare.musicxml': 'mxl',
	        'application/vnd.recordare.musicxml+xml': 'musicxml',
	        'application/vnd.rig.cryptonote': 'cryptonote',
	        'application/vnd.rim.cod': 'cod',
	        'application/vnd.rn-realmedia': 'rm',
	        'application/vnd.rn-realplayer': 'rnx',
	        'application/vnd.route66.link66+xml': 'link66',
	        'application/vnd.sailingtracker.track': 'st',
	        'application/vnd.seemail': 'see',
	        'application/vnd.sema': 'sema',
	        'application/vnd.semd': 'semd',
	        'application/vnd.semf': 'semf',
	        'application/vnd.shana.informed.formdata': 'ifm',
	        'application/vnd.shana.informed.formtemplate': 'itp',
	        'application/vnd.shana.informed.interchange': 'iif',
	        'application/vnd.shana.informed.package': 'ipk',
	        'application/vnd.simtech-mindmapper': 'twd',
	        'application/vnd.smaf': 'mmf',
	        'application/vnd.smart.teacher': 'teacher',
	        'application/vnd.solent.sdkm+xml': 'sdkm',
	        'application/vnd.spotfire.dxp': 'dxp',
	        'application/vnd.spotfire.sfs': 'sfs',
	        'application/vnd.stardivision.calc': 'sdc',
	        'application/vnd.stardivision.draw': 'sda',
	        'application/vnd.stardivision.impress': 'sdd',
	        'application/vnd.stardivision.math': 'smf',
	        'application/vnd.stardivision.writer': 'sdw',
	        'application/vnd.stardivision.writer-global': 'sgl',
	        'application/vnd.stepmania.stepchart': 'sm',
	        'application/vnd.sun.xml.calc': 'sxc',
	        'application/vnd.sun.xml.calc.template': 'stc',
	        'application/vnd.sun.xml.draw': 'sxd',
	        'application/vnd.sun.xml.draw.template': 'std',
	        'application/vnd.sun.xml.impress': 'sxi',
	        'application/vnd.sun.xml.impress.template': 'sti',
	        'application/vnd.sun.xml.math': 'sxm',
	        'application/vnd.sun.xml.writer': 'sxw',
	        'application/vnd.sun.xml.writer.global': 'sxg',
	        'application/vnd.sun.xml.writer.template': 'stw',
	        'application/vnd.sus-calendar': 'sus',
	        'application/vnd.svd': 'svd',
	        'application/vnd.symbian.install': 'sis',
	        'application/vnd.syncml+xml': 'xsm',
	        'application/vnd.syncml.dm+wbxml': 'bdm',
	        'application/vnd.syncml.dm+xml': 'xdm',
	        'application/vnd.tao.intent-module-archive': 'tao',
	        'application/vnd.tmobile-livetv': 'tmo',
	        'application/vnd.trid.tpt': 'tpt',
	        'application/vnd.triscape.mxs': 'mxs',
	        'application/vnd.trueapp': 'tra',
	        'application/vnd.ufdl': 'ufd',
	        'application/vnd.uiq.theme': 'utz',
	        'application/vnd.umajin': 'umj',
	        'application/vnd.unity': 'unityweb',
	        'application/vnd.uoml+xml': 'uoml',
	        'application/vnd.vcx': 'vcx',
	        'application/vnd.visio': 'vsd',
	        'application/vnd.visionary': 'vis',
	        'application/vnd.vsf': 'vsf',
	        'application/vnd.wap.wbxml': 'wbxml',
	        'application/vnd.wap.wmlc': 'wmlc',
	        'application/vnd.wap.wmlscriptc': 'wmlsc',
	        'application/vnd.webturbo': 'wtb',
	        'application/vnd.wolfram.player': 'nbp',
	        'application/vnd.wordperfect': 'wpd',
	        'application/vnd.wqd': 'wqd',
	        'application/vnd.wt.stf': 'stf',
	        'application/vnd.xara': ['web', 'xar'],
	        'application/vnd.xfdl': 'xfdl',
	        'application/vnd.yamaha.hv-dic': 'hvd',
	        'application/vnd.yamaha.hv-script': 'hvs',
	        'application/vnd.yamaha.hv-voice': 'hvp',
	        'application/vnd.yamaha.openscoreformat': 'osf',
	        'application/vnd.yamaha.openscoreformat.osfpvg+xml': 'osfpvg',
	        'application/vnd.yamaha.smaf-audio': 'saf',
	        'application/vnd.yamaha.smaf-phrase': 'spf',
	        'application/vnd.yellowriver-custom-menu': 'cmp',
	        'application/vnd.zul': 'zir',
	        'application/vnd.zzazz.deck+xml': 'zaz',
	        'application/vocaltec-media-desc': 'vmd',
	        'application/vocaltec-media-file': 'vmf',
	        'application/voicexml+xml': 'vxml',
	        'application/widget': 'wgt',
	        'application/winhlp': 'hlp',
	        'application/wordperfect': ['wp', 'wp5', 'wp6', 'wpd'],
	        'application/wordperfect6.0': ['w60', 'wp5'],
	        'application/wordperfect6.1': 'w61',
	        'application/wsdl+xml': 'wsdl',
	        'application/wspolicy+xml': 'wspolicy',
	        'application/x-123': 'wk1',
	        'application/x-7z-compressed': '7z',
	        'application/x-abiword': 'abw',
	        'application/x-ace-compressed': 'ace',
	        'application/x-aim': 'aim',
	        'application/x-authorware-bin': 'aab',
	        'application/x-authorware-map': 'aam',
	        'application/x-authorware-seg': 'aas',
	        'application/x-bcpio': 'bcpio',
	        'application/x-binary': 'bin',
	        'application/x-binhex40': 'hqx',
	        'application/x-bittorrent': 'torrent',
	        'application/x-bsh': ['bsh', 'sh', 'shar'],
	        'application/x-bytecode.elisp': 'elc',
	        'applicaiton/x-bytecode.python': 'pyc',
	        'application/x-bzip': 'bz',
	        'application/x-bzip2': ['boz', 'bz2'],
	        'application/x-cdf': 'cdf',
	        'application/x-cdlink': 'vcd',
	        'application/x-chat': ['cha', 'chat'],
	        'application/x-chess-pgn': 'pgn',
	        'application/x-cmu-raster': 'ras',
	        'application/x-cocoa': 'cco',
	        'application/x-compactpro': 'cpt',
	        'application/x-compress': 'z',
	        'application/x-compressed': ['tgz', 'gz', 'z', 'zip'],
	        'application/x-conference': 'nsc',
	        'application/x-cpio': 'cpio',
	        'application/x-cpt': 'cpt',
	        'application/x-csh': 'csh',
	        'application/x-debian-package': 'deb',
	        'application/x-deepv': 'deepv',
	        'application/x-director': ['dcr', 'dir', 'dxr'],
	        'application/x-doom': 'wad',
	        'application/x-dtbncx+xml': 'ncx',
	        'application/x-dtbook+xml': 'dtb',
	        'application/x-dtbresource+xml': 'res',
	        'application/x-dvi': 'dvi',
	        'application/x-elc': 'elc',
	        'application/x-envoy': ['env', 'evy'],
	        'application/x-esrehber': 'es',
	        'application/x-excel': ['xla', 'xlb', 'xlc', 'xld', 'xlk', 'xll', 'xlm', 'xls', 'xlt', 'xlv', 'xlw'],
	        'application/x-font-bdf': 'bdf',
	        'application/x-font-ghostscript': 'gsf',
	        'application/x-font-linux-psf': 'psf',
	        'application/x-font-otf': 'otf',
	        'application/x-font-pcf': 'pcf',
	        'application/x-font-snf': 'snf',
	        'application/x-font-ttf': 'ttf',
	        'application/x-font-type1': 'pfa',
	        'application/x-font-woff': 'woff',
	        'application/x-frame': 'mif',
	        'application/x-freelance': 'pre',
	        'application/x-futuresplash': 'spl',
	        'application/x-gnumeric': 'gnumeric',
	        'application/x-gsp': 'gsp',
	        'application/x-gss': 'gss',
	        'application/x-gtar': 'gtar',
	        'application/x-gzip': ['gz', 'gzip'],
	        'application/x-hdf': 'hdf',
	        'application/x-helpfile': ['help', 'hlp'],
	        'application/x-httpd-imap': 'imap',
	        'application/x-ima': 'ima',
	        'application/x-internet-signup': ['ins', 'isp'],
	        'application/x-internett-signup': 'ins',
	        'application/x-inventor': 'iv',
	        'application/x-ip2': 'ip',
	        'application/x-iphone': 'iii',
	        'application/x-java-class': 'class',
	        'application/x-java-commerce': 'jcm',
	        'application/x-java-jnlp-file': 'jnlp',
	        'application/x-javascript': 'js',
	        'application/x-koan': ['skd', 'skm', 'skp', 'skt'],
	        'application/x-ksh': 'ksh',
	        'application/x-latex': ['latex', 'ltx'],
	        'application/x-lha': 'lha',
	        'application/x-lisp': 'lsp',
	        'application/x-livescreen': 'ivy',
	        'application/x-lotus': 'wq1',
	        'application/x-lotusscreencam': 'scm',
	        'application/x-lzh': 'lzh',
	        'application/x-lzx': 'lzx',
	        'application/x-mac-binhex40': 'hqx',
	        'application/x-macbinary': 'bin',
	        'application/x-magic-cap-package-1.0': 'mc$',
	        'application/x-mathcad': 'mcd',
	        'application/x-meme': 'mm',
	        'application/x-midi': ['mid', 'midi'],
	        'application/x-mif': 'mif',
	        'application/x-mix-transfer': 'nix',
	        'application/x-mobipocket-ebook': 'prc',
	        'application/x-mplayer2': 'asx',
	        'application/x-ms-application': 'application',
	        'application/x-ms-wmd': 'wmd',
	        'application/x-ms-wmz': 'wmz',
	        'application/x-ms-xbap': 'xbap',
	        'application/x-msaccess': 'mdb',
	        'application/x-msbinder': 'obd',
	        'application/x-mscardfile': 'crd',
	        'application/x-msclip': 'clp',
	        'application/x-msdownload': ['dll', 'exe'],
	        'application/x-msexcel': ['xla', 'xls', 'xlw'],
	        'application/x-msmediaview': ['m13', 'm14', 'mvb'],
	        'application/x-msmetafile': 'wmf',
	        'application/x-msmoney': 'mny',
	        'application/x-mspowerpoint': 'ppt',
	        'application/x-mspublisher': 'pub',
	        'application/x-msschedule': 'scd',
	        'application/x-msterminal': 'trm',
	        'application/x-mswrite': 'wri',
	        'application/x-navi-animation': 'ani',
	        'application/x-navidoc': 'nvd',
	        'application/x-navimap': 'map',
	        'application/x-navistyle': 'stl',
	        'application/x-netcdf': ['cdf', 'nc'],
	        'application/x-newton-compatible-pkg': 'pkg',
	        'application/x-nokia-9000-communicator-add-on-software': 'aos',
	        'application/x-omc': 'omc',
	        'application/x-omcdatamaker': 'omcd',
	        'application/x-omcregerator': 'omcr',
	        'application/x-pagemaker': ['pm4', 'pm5'],
	        'application/x-pcl': 'pcl',
	        'application/x-perfmon': ['pma', 'pmc', 'pml', 'pmr', 'pmw'],
	        'application/x-pixclscript': 'plx',
	        'application/x-pkcs10': 'p10',
	        'application/x-pkcs12': ['p12', 'pfx'],
	        'application/x-pkcs7-certificates': ['p7b', 'spc'],
	        'application/x-pkcs7-certreqresp': 'p7r',
	        'application/x-pkcs7-mime': ['p7c', 'p7m'],
	        'application/x-pkcs7-signature': ['p7s', 'p7a'],
	        'application/x-pointplus': 'css',
	        'application/x-portable-anymap': 'pnm',
	        'application/x-project': ['mpc', 'mpt', 'mpv', 'mpx'],
	        'application/x-qpro': 'wb1',
	        'application/x-rar-compressed': 'rar',
	        'application/x-rtf': 'rtf',
	        'application/x-sdp': 'sdp',
	        'application/x-sea': 'sea',
	        'application/x-seelogo': 'sl',
	        'application/x-sh': 'sh',
	        'application/x-shar': ['shar', 'sh'],
	        'application/x-shockwave-flash': 'swf',
	        'application/x-silverlight-app': 'xap',
	        'application/x-sit': 'sit',
	        'application/x-sprite': ['spr', 'sprite'],
	        'application/x-stuffit': 'sit',
	        'application/x-stuffitx': 'sitx',
	        'application/x-sv4cpio': 'sv4cpio',
	        'application/x-sv4crc': 'sv4crc',
	        'application/x-tar': 'tar',
	        'application/x-tbook': ['sbk', 'tbk'],
	        'application/x-tcl': 'tcl',
	        'application/x-tex': 'tex',
	        'application/x-tex-tfm': 'tfm',
	        'application/x-texinfo': ['texi', 'texinfo'],
	        'application/x-troff': ['roff', 't', 'tr'],
	        'application/x-troff-man': 'man',
	        'application/x-troff-me': 'me',
	        'application/x-troff-ms': 'ms',
	        'application/x-troff-msvideo': 'avi',
	        'application/x-ustar': 'ustar',
	        'application/x-visio': ['vsd', 'vst', 'vsw'],
	        'application/x-vnd.audioexplosion.mzz': 'mzz',
	        'application/x-vnd.ls-xpix': 'xpix',
	        'application/x-vrml': 'vrml',
	        'application/x-wais-source': ['src', 'wsrc'],
	        'application/x-winhelp': 'hlp',
	        'application/x-wintalk': 'wtk',
	        'application/x-world': ['svr', 'wrl'],
	        'application/x-wpwin': 'wpd',
	        'application/x-wri': 'wri',
	        'application/x-x509-ca-cert': ['cer', 'crt', 'der'],
	        'application/x-x509-user-cert': 'crt',
	        'application/x-xfig': 'fig',
	        'application/x-xpinstall': 'xpi',
	        'application/x-zip-compressed': 'zip',
	        'application/xcap-diff+xml': 'xdf',
	        'application/xenc+xml': 'xenc',
	        'application/xhtml+xml': 'xhtml',
	        'application/xml': 'xml',
	        'application/xml-dtd': 'dtd',
	        'application/xop+xml': 'xop',
	        'application/xslt+xml': 'xslt',
	        'application/xspf+xml': 'xspf',
	        'application/xv+xml': 'mxml',
	        'application/yang': 'yang',
	        'application/yin+xml': 'yin',
	        'application/ynd.ms-pkipko': 'pko',
	        'application/zip': 'zip',
	        'audio/adpcm': 'adp',
	        'audio/aiff': ['aif', 'aifc', 'aiff'],
	        'audio/basic': ['au', 'snd'],
	        'audio/it': 'it',
	        'audio/make': ['funk', 'my', 'pfunk'],
	        'audio/make.my.funk': 'pfunk',
	        'audio/mid': ['mid', 'rmi'],
	        'audio/midi': ['kar', 'mid', 'midi'],
	        'audio/mod': 'mod',
	        'audio/mp4': 'mp4a',
	        'audio/mpeg': ['mp3', 'm2a', 'mp2', 'mpa', 'mpg', 'mpga'],
	        'audio/mpeg3': 'mp3',
	        'audio/nspaudio': ['la', 'lma'],
	        'audio/ogg': 'oga',
	        'audio/s3m': 's3m',
	        'audio/tsp-audio': 'tsi',
	        'audio/tsplayer': 'tsp',
	        'audio/vnd.dece.audio': 'uva',
	        'audio/vnd.digital-winds': 'eol',
	        'audio/vnd.dra': 'dra',
	        'audio/vnd.dts': 'dts',
	        'audio/vnd.dts.hd': 'dtshd',
	        'audio/vnd.lucent.voice': 'lvp',
	        'audio/vnd.ms-playready.media.pya': 'pya',
	        'audio/vnd.nuera.ecelp4800': 'ecelp4800',
	        'audio/vnd.nuera.ecelp7470': 'ecelp7470',
	        'audio/vnd.nuera.ecelp9600': 'ecelp9600',
	        'audio/vnd.qcelp': 'qcp',
	        'audio/vnd.rip': 'rip',
	        'audio/voc': 'voc',
	        'audio/voxware': 'vox',
	        'audio/wav': 'wav',
	        'audio/webm': 'weba',
	        'audio/x-aac': 'aac',
	        'audio/x-adpcm': 'snd',
	        'audio/x-aiff': ['aif', 'aifc', 'aiff'],
	        'audio/x-au': 'au',
	        'audio/x-gsm': ['gsd', 'gsm'],
	        'audio/x-jam': 'jam',
	        'audio/x-liveaudio': 'lam',
	        'audio/x-mid': ['mid', 'midi'],
	        'audio/x-midi': ['mid', 'midi'],
	        'audio/x-mod': 'mod',
	        'audio/x-mpeg': 'mp2',
	        'audio/x-mpeg-3': 'mp3',
	        'audio/x-mpegurl': 'm3u',
	        'audio/x-mpequrl': 'm3u',
	        'audio/x-ms-wax': 'wax',
	        'audio/x-ms-wma': 'wma',
	        'audio/x-nspaudio': ['la', 'lma'],
	        'audio/x-pn-realaudio': ['ra', 'ram', 'rm', 'rmm', 'rmp'],
	        'audio/x-pn-realaudio-plugin': ['ra', 'rmp', 'rpm'],
	        'audio/x-psid': 'sid',
	        'audio/x-realaudio': 'ra',
	        'audio/x-twinvq': 'vqf',
	        'audio/x-twinvq-plugin': ['vqe', 'vql'],
	        'audio/x-vnd.audioexplosion.mjuicemediafile': 'mjf',
	        'audio/x-voc': 'voc',
	        'audio/x-wav': 'wav',
	        'audio/xm': 'xm',
	        'chemical/x-cdx': 'cdx',
	        'chemical/x-cif': 'cif',
	        'chemical/x-cmdf': 'cmdf',
	        'chemical/x-cml': 'cml',
	        'chemical/x-csml': 'csml',
	        'chemical/x-pdb': ['pdb', 'xyz'],
	        'chemical/x-xyz': 'xyz',
	        'drawing/x-dwf': 'dwf',
	        'i-world/i-vrml': 'ivr',
	        'image/bmp': ['bmp', 'bm'],
	        'image/cgm': 'cgm',
	        'image/cis-cod': 'cod',
	        'image/cmu-raster': ['ras', 'rast'],
	        'image/fif': 'fif',
	        'image/florian': ['flo', 'turbot'],
	        'image/g3fax': 'g3',
	        'image/gif': 'gif',
	        'image/ief': ['ief', 'iefs'],
	        'image/jpeg': ['jpe', 'jpeg', 'jpg', 'jfif', 'jfif-tbnl'],
	        'image/jutvision': 'jut',
	        'image/ktx': 'ktx',
	        'image/naplps': ['nap', 'naplps'],
	        'image/pict': ['pic', 'pict'],
	        'image/pipeg': 'jfif',
	        'image/pjpeg': ['jfif', 'jpe', 'jpeg', 'jpg'],
	        'image/png': ['png', 'x-png'],
	        'image/prs.btif': 'btif',
	        'image/svg+xml': 'svg',
	        'image/tiff': ['tif', 'tiff'],
	        'image/vasa': 'mcf',
	        'image/vnd.adobe.photoshop': 'psd',
	        'image/vnd.dece.graphic': 'uvi',
	        'image/vnd.djvu': 'djvu',
	        'image/vnd.dvb.subtitle': 'sub',
	        'image/vnd.dwg': ['dwg', 'dxf', 'svf'],
	        'image/vnd.dxf': 'dxf',
	        'image/vnd.fastbidsheet': 'fbs',
	        'image/vnd.fpx': 'fpx',
	        'image/vnd.fst': 'fst',
	        'image/vnd.fujixerox.edmics-mmr': 'mmr',
	        'image/vnd.fujixerox.edmics-rlc': 'rlc',
	        'image/vnd.ms-modi': 'mdi',
	        'image/vnd.net-fpx': ['fpx', 'npx'],
	        'image/vnd.rn-realflash': 'rf',
	        'image/vnd.rn-realpix': 'rp',
	        'image/vnd.wap.wbmp': 'wbmp',
	        'image/vnd.xiff': 'xif',
	        'image/webp': 'webp',
	        'image/x-cmu-raster': 'ras',
	        'image/x-cmx': 'cmx',
	        'image/x-dwg': ['dwg', 'dxf', 'svf'],
	        'image/x-freehand': 'fh',
	        'image/x-icon': 'ico',
	        'image/x-jg': 'art',
	        'image/x-jps': 'jps',
	        'image/x-niff': ['nif', 'niff'],
	        'image/x-pcx': 'pcx',
	        'image/x-pict': ['pct', 'pic'],
	        'image/x-portable-anymap': 'pnm',
	        'image/x-portable-bitmap': 'pbm',
	        'image/x-portable-graymap': 'pgm',
	        'image/x-portable-greymap': 'pgm',
	        'image/x-portable-pixmap': 'ppm',
	        'image/x-quicktime': ['qif', 'qti', 'qtif'],
	        'image/x-rgb': 'rgb',
	        'image/x-tiff': ['tif', 'tiff'],
	        'image/x-windows-bmp': 'bmp',
	        'image/x-xbitmap': 'xbm',
	        'image/x-xbm': 'xbm',
	        'image/x-xpixmap': ['xpm', 'pm'],
	        'image/x-xwd': 'xwd',
	        'image/x-xwindowdump': 'xwd',
	        'image/xbm': 'xbm',
	        'image/xpm': 'xpm',
	        'message/rfc822': ['mht', 'mhtml', 'nws', 'mime', 'eml'],
	        'model/iges': ['iges', 'igs'],
	        'model/mesh': 'msh',
	        'model/vnd.collada+xml': 'dae',
	        'model/vnd.dwf': 'dwf',
	        'model/vnd.gdl': 'gdl',
	        'model/vnd.gtw': 'gtw',
	        'model/vnd.mts': 'mts',
	        'model/vnd.vtu': 'vtu',
	        'model/vrml': ['vrml', 'wrl', 'wrz'],
	        'model/x-pov': 'pov',
	        'multipart/x-gzip': 'gzip',
	        'multipart/x-ustar': 'ustar',
	        'multipart/x-zip': 'zip',
	        'music/crescendo': ['mid', 'midi'],
	        'music/x-karaoke': 'kar',
	        'paleovu/x-pv': 'pvu',
	        'text/asp': 'asp',
	        'text/calendar': 'ics',
	        'text/css': 'css',
	        'text/csv': 'csv',
	        'text/ecmascript': 'js',
	        'text/h323': '323',
	        'text/html': ['htm', 'html', 'stm', 'acgi', 'htmls', 'htx', 'shtml'],
	        'text/iuls': 'uls',
	        'text/javascript': 'js',
	        'text/mcf': 'mcf',
	        'text/n3': 'n3',
	        'text/pascal': 'pas',
	        'text/plain': ['bas', 'c', 'h', 'txt', 'c++', 'cc', 'com', 'conf', 'cxx', 'def', 'f', 'f90', 'for', 'g', 'hh', 'idc', 'jav', 'java', 'list', 'log', 'lst', 'm', 'mar', 'pl', 'sdml', 'text'],
	        'text/plain-bas': 'par',
	        'text/prs.lines.tag': 'dsc',
	        'text/richtext': ['rtx', 'rt', 'rtf'],
	        'text/scriplet': 'wsc',
	        'text/scriptlet': 'sct',
	        'text/sgml': ['sgm', 'sgml'],
	        'text/tab-separated-values': 'tsv',
	        'text/troff': 't',
	        'text/turtle': 'ttl',
	        'text/uri-list': ['uni', 'unis', 'uri', 'uris'],
	        'text/vnd.abc': 'abc',
	        'text/vnd.curl': 'curl',
	        'text/vnd.curl.dcurl': 'dcurl',
	        'text/vnd.curl.mcurl': 'mcurl',
	        'text/vnd.curl.scurl': 'scurl',
	        'text/vnd.fly': 'fly',
	        'text/vnd.fmi.flexstor': 'flx',
	        'text/vnd.graphviz': 'gv',
	        'text/vnd.in3d.3dml': '3dml',
	        'text/vnd.in3d.spot': 'spot',
	        'text/vnd.rn-realtext': 'rt',
	        'text/vnd.sun.j2me.app-descriptor': 'jad',
	        'text/vnd.wap.wml': 'wml',
	        'text/vnd.wap.wmlscript': 'wmls',
	        'text/webviewhtml': 'htt',
	        'text/x-asm': ['asm', 's'],
	        'text/x-audiosoft-intra': 'aip',
	        'text/x-c': ['c', 'cc', 'cpp'],
	        'text/x-component': 'htc',
	        'text/x-fortran': ['f', 'f77', 'f90', 'for'],
	        'text/x-h': ['h', 'hh'],
	        'text/x-java-source': ['jav', 'java'],
	        'text/x-java-source,java': 'java',
	        'text/x-la-asf': 'lsx',
	        'text/x-m': 'm',
	        'text/x-pascal': 'p',
	        'text/x-script': 'hlb',
	        'text/x-script.csh': 'csh',
	        'text/x-script.elisp': 'el',
	        'text/x-script.guile': 'scm',
	        'text/x-script.ksh': 'ksh',
	        'text/x-script.lisp': 'lsp',
	        'text/x-script.perl': 'pl',
	        'text/x-script.perl-module': 'pm',
	        'text/x-script.phyton': 'py',
	        'text/x-script.rexx': 'rexx',
	        'text/x-script.scheme': 'scm',
	        'text/x-script.sh': 'sh',
	        'text/x-script.tcl': 'tcl',
	        'text/x-script.tcsh': 'tcsh',
	        'text/x-script.zsh': 'zsh',
	        'text/x-server-parsed-html': ['shtml', 'ssi'],
	        'text/x-setext': 'etx',
	        'text/x-sgml': ['sgm', 'sgml'],
	        'text/x-speech': ['spc', 'talk'],
	        'text/x-uil': 'uil',
	        'text/x-uuencode': ['uu', 'uue'],
	        'text/x-vcalendar': 'vcs',
	        'text/x-vcard': 'vcf',
	        'text/xml': 'xml',
	        'video/3gpp': '3gp',
	        'video/3gpp2': '3g2',
	        'video/animaflex': 'afl',
	        'video/avi': 'avi',
	        'video/avs-video': 'avs',
	        'video/dl': 'dl',
	        'video/fli': 'fli',
	        'video/gl': 'gl',
	        'video/h261': 'h261',
	        'video/h263': 'h263',
	        'video/h264': 'h264',
	        'video/jpeg': 'jpgv',
	        'video/jpm': 'jpm',
	        'video/mj2': 'mj2',
	        'video/mp4': 'mp4',
	        'video/mpeg': ['mp2', 'mpa', 'mpe', 'mpeg', 'mpg', 'mpv2', 'm1v', 'm2v', 'mp3'],
	        'video/msvideo': 'avi',
	        'video/ogg': 'ogv',
	        'video/quicktime': ['mov', 'qt', 'moov'],
	        'video/vdo': 'vdo',
	        'video/vivo': ['viv', 'vivo'],
	        'video/vnd.dece.hd': 'uvh',
	        'video/vnd.dece.mobile': 'uvm',
	        'video/vnd.dece.pd': 'uvp',
	        'video/vnd.dece.sd': 'uvs',
	        'video/vnd.dece.video': 'uvv',
	        'video/vnd.fvt': 'fvt',
	        'video/vnd.mpegurl': 'mxu',
	        'video/vnd.ms-playready.media.pyv': 'pyv',
	        'video/vnd.rn-realvideo': 'rv',
	        'video/vnd.uvvu.mp4': 'uvu',
	        'video/vnd.vivo': ['viv', 'vivo'],
	        'video/vosaic': 'vos',
	        'video/webm': 'webm',
	        'video/x-amt-demorun': 'xdr',
	        'video/x-amt-showrun': 'xsr',
	        'video/x-atomic3d-feature': 'fmf',
	        'video/x-dl': 'dl',
	        'video/x-dv': ['dif', 'dv'],
	        'video/x-f4v': 'f4v',
	        'video/x-fli': 'fli',
	        'video/x-flv': 'flv',
	        'video/x-gl': 'gl',
	        'video/x-isvideo': 'isu',
	        'video/x-la-asf': ['lsf', 'lsx'],
	        'video/x-m4v': 'm4v',
	        'video/x-motion-jpeg': 'mjpg',
	        'video/x-mpeg': ['mp2', 'mp3'],
	        'video/x-mpeq2a': 'mp2',
	        'video/x-ms-asf': ['asf', 'asr', 'asx'],
	        'video/x-ms-asf-plugin': 'asx',
	        'video/x-ms-wm': 'wm',
	        'video/x-ms-wmv': 'wmv',
	        'video/x-ms-wmx': 'wmx',
	        'video/x-ms-wvx': 'wvx',
	        'video/x-msvideo': 'avi',
	        'video/x-qtc': 'qtc',
	        'video/x-scm': 'scm',
	        'video/x-sgi-movie': ['movie', 'mv'],
	        'windows/metafile': 'wmf',
	        'www/mime': 'mime',
	        'x-conference/x-cooltalk': 'ice',
	        'x-music/x-midi': ['mid', 'midi'],
	        'x-world/x-3dmf': ['3dm', '3dmf', 'qd3', 'qd3d'],
	        'x-world/x-svr': 'svr',
	        'x-world/x-vrml': ['flr', 'vrml', 'wrl', 'wrz', 'xaf', 'xof'],
	        'x-world/x-vrt': 'vrt',
	        'xgl/drawing': 'xgz',
	        'xgl/movie': 'xmz',
	    };

	    var mimetypesExtensions = {
	        '': ['application/andrew-inset', 'application/pgp-encrypted'],
	        '*': 'application/octet-stream',
	        '123': 'application/vnd.lotus-1-2-3',
	        '323': 'text/h323',
	        '3dm': 'x-world/x-3dmf',
	        '3dmf': 'x-world/x-3dmf',
	        '3dml': 'text/vnd.in3d.3dml',
	        '3g2': 'video/3gpp2',
	        '3gp': 'video/3gpp',
	        '7z': 'application/x-7z-compressed',
	        'a': 'application/octet-stream',
	        'aab': 'application/x-authorware-bin',
	        'aac': 'audio/x-aac',
	        'aam': 'application/x-authorware-map',
	        'aas': 'application/x-authorware-seg',
	        'abc': 'text/vnd.abc',
	        'abw': 'application/x-abiword',
	        'ac': 'application/pkix-attr-cert',
	        'acc': 'application/vnd.americandynamics.acc',
	        'ace': 'application/x-ace-compressed',
	        'acgi': 'text/html',
	        'acu': 'application/vnd.acucobol',
	        'acx': 'application/internet-property-stream',
	        'adp': 'audio/adpcm',
	        'aep': 'application/vnd.audiograph',
	        'afl': 'video/animaflex',
	        'afp': 'application/vnd.ibm.modcap',
	        'ahead': 'application/vnd.ahead.space',
	        'ai': 'application/postscript',
	        'aif': ['audio/aiff', 'audio/x-aiff'],
	        'aifc': ['audio/aiff', 'audio/x-aiff'],
	        'aiff': ['audio/aiff', 'audio/x-aiff'],
	        'aim': 'application/x-aim',
	        'aip': 'text/x-audiosoft-intra',
	        'air': 'application/vnd.adobe.air-application-installer-package+zip',
	        'ait': 'application/vnd.dvb.ait',
	        'ami': 'application/vnd.amiga.ami',
	        'ani': 'application/x-navi-animation',
	        'aos': 'application/x-nokia-9000-communicator-add-on-software',
	        'apk': 'application/vnd.android.package-archive',
	        'application': 'application/x-ms-application',
	        'apr': 'application/vnd.lotus-approach',
	        'aps': 'application/mime',
	        'arc': 'application/octet-stream',
	        'arj': ['application/arj', 'application/octet-stream'],
	        'art': 'image/x-jg',
	        'asf': 'video/x-ms-asf',
	        'asm': 'text/x-asm',
	        'aso': 'application/vnd.accpac.simply.aso',
	        'asp': 'text/asp',
	        'asr': 'video/x-ms-asf',
	        'asx': ['video/x-ms-asf', 'application/x-mplayer2', 'video/x-ms-asf-plugin'],
	        'atc': 'application/vnd.acucorp',
	        'atomcat': 'application/atomcat+xml',
	        'atomsvc': 'application/atomsvc+xml',
	        'atx': 'application/vnd.antix.game-component',
	        'au': ['audio/basic', 'audio/x-au'],
	        'avi': ['video/avi', 'video/msvideo', 'application/x-troff-msvideo', 'video/x-msvideo'],
	        'avs': 'video/avs-video',
	        'aw': 'application/applixware',
	        'axs': 'application/olescript',
	        'azf': 'application/vnd.airzip.filesecure.azf',
	        'azs': 'application/vnd.airzip.filesecure.azs',
	        'azw': 'application/vnd.amazon.ebook',
	        'bas': 'text/plain',
	        'bcpio': 'application/x-bcpio',
	        'bdf': 'application/x-font-bdf',
	        'bdm': 'application/vnd.syncml.dm+wbxml',
	        'bed': 'application/vnd.realvnc.bed',
	        'bh2': 'application/vnd.fujitsu.oasysprs',
	        'bin': ['application/octet-stream', 'application/mac-binary', 'application/macbinary', 'application/x-macbinary', 'application/x-binary'],
	        'bm': 'image/bmp',
	        'bmi': 'application/vnd.bmi',
	        'bmp': ['image/bmp', 'image/x-windows-bmp'],
	        'boo': 'application/book',
	        'book': 'application/book',
	        'box': 'application/vnd.previewsystems.box',
	        'boz': 'application/x-bzip2',
	        'bsh': 'application/x-bsh',
	        'btif': 'image/prs.btif',
	        'bz': 'application/x-bzip',
	        'bz2': 'application/x-bzip2',
	        'c': ['text/plain', 'text/x-c'],
	        'c++': 'text/plain',
	        'c11amc': 'application/vnd.cluetrust.cartomobile-config',
	        'c11amz': 'application/vnd.cluetrust.cartomobile-config-pkg',
	        'c4g': 'application/vnd.clonk.c4group',
	        'cab': 'application/vnd.ms-cab-compressed',
	        'car': 'application/vnd.curl.car',
	        'cat': ['application/vnd.ms-pkiseccat', 'application/vnd.ms-pki.seccat'],
	        'cc': ['text/plain', 'text/x-c'],
	        'ccad': 'application/clariscad',
	        'cco': 'application/x-cocoa',
	        'ccxml': 'application/ccxml+xml,',
	        'cdbcmsg': 'application/vnd.contact.cmsg',
	        'cdf': ['application/cdf', 'application/x-cdf', 'application/x-netcdf'],
	        'cdkey': 'application/vnd.mediastation.cdkey',
	        'cdmia': 'application/cdmi-capability',
	        'cdmic': 'application/cdmi-container',
	        'cdmid': 'application/cdmi-domain',
	        'cdmio': 'application/cdmi-object',
	        'cdmiq': 'application/cdmi-queue',
	        'cdx': 'chemical/x-cdx',
	        'cdxml': 'application/vnd.chemdraw+xml',
	        'cdy': 'application/vnd.cinderella',
	        'cer': ['application/pkix-cert', 'application/x-x509-ca-cert'],
	        'cgm': 'image/cgm',
	        'cha': 'application/x-chat',
	        'chat': 'application/x-chat',
	        'chm': 'application/vnd.ms-htmlhelp',
	        'chrt': 'application/vnd.kde.kchart',
	        'cif': 'chemical/x-cif',
	        'cii': 'application/vnd.anser-web-certificate-issue-initiation',
	        'cil': 'application/vnd.ms-artgalry',
	        'cla': 'application/vnd.claymore',
	        'class': ['application/octet-stream', 'application/java', 'application/java-byte-code', 'application/java-vm', 'application/x-java-class'],
	        'clkk': 'application/vnd.crick.clicker.keyboard',
	        'clkp': 'application/vnd.crick.clicker.palette',
	        'clkt': 'application/vnd.crick.clicker.template',
	        'clkw': 'application/vnd.crick.clicker.wordbank',
	        'clkx': 'application/vnd.crick.clicker',
	        'clp': 'application/x-msclip',
	        'cmc': 'application/vnd.cosmocaller',
	        'cmdf': 'chemical/x-cmdf',
	        'cml': 'chemical/x-cml',
	        'cmp': 'application/vnd.yellowriver-custom-menu',
	        'cmx': 'image/x-cmx',
	        'cod': ['image/cis-cod', 'application/vnd.rim.cod'],
	        'com': ['application/octet-stream', 'text/plain'],
	        'conf': 'text/plain',
	        'cpio': 'application/x-cpio',
	        'cpp': 'text/x-c',
	        'cpt': ['application/mac-compactpro', 'application/x-compactpro', 'application/x-cpt'],
	        'crd': 'application/x-mscardfile',
	        'crl': ['application/pkix-crl', 'application/pkcs-crl'],
	        'crt': ['application/pkix-cert', 'application/x-x509-user-cert', 'application/x-x509-ca-cert'],
	        'cryptonote': 'application/vnd.rig.cryptonote',
	        'csh': ['text/x-script.csh', 'application/x-csh'],
	        'csml': 'chemical/x-csml',
	        'csp': 'application/vnd.commonspace',
	        'css': ['text/css', 'application/x-pointplus'],
	        'csv': 'text/csv',
	        'cu': 'application/cu-seeme',
	        'curl': 'text/vnd.curl',
	        'cww': 'application/prs.cww',
	        'cxx': 'text/plain',
	        'dae': 'model/vnd.collada+xml',
	        'daf': 'application/vnd.mobius.daf',
	        'davmount': 'application/davmount+xml',
	        'dcr': 'application/x-director',
	        'dcurl': 'text/vnd.curl.dcurl',
	        'dd2': 'application/vnd.oma.dd2+xml',
	        'ddd': 'application/vnd.fujixerox.ddd',
	        'deb': 'application/x-debian-package',
	        'deepv': 'application/x-deepv',
	        'def': 'text/plain',
	        'der': 'application/x-x509-ca-cert',
	        'dfac': 'application/vnd.dreamfactory',
	        'dif': 'video/x-dv',
	        'dir': 'application/x-director',
	        'dis': 'application/vnd.mobius.dis',
	        'djvu': 'image/vnd.djvu',
	        'dl': ['video/dl', 'video/x-dl'],
	        'dll': 'application/x-msdownload',
	        'dms': 'application/octet-stream',
	        'dna': 'application/vnd.dna',
	        'doc': 'application/msword',
	        'docm': 'application/vnd.ms-word.document.macroenabled.12',
	        'docx': 'application/vnd.openxmlformats-officedocument.wordprocessingml.document',
	        'dot': 'application/msword',
	        'dotm': 'application/vnd.ms-word.template.macroenabled.12',
	        'dotx': 'application/vnd.openxmlformats-officedocument.wordprocessingml.template',
	        'dp': ['application/commonground', 'application/vnd.osgi.dp'],
	        'dpg': 'application/vnd.dpgraph',
	        'dra': 'audio/vnd.dra',
	        'drw': 'application/drafting',
	        'dsc': 'text/prs.lines.tag',
	        'dssc': 'application/dssc+der',
	        'dtb': 'application/x-dtbook+xml',
	        'dtd': 'application/xml-dtd',
	        'dts': 'audio/vnd.dts',
	        'dtshd': 'audio/vnd.dts.hd',
	        'dump': 'application/octet-stream',
	        'dv': 'video/x-dv',
	        'dvi': 'application/x-dvi',
	        'dwf': ['model/vnd.dwf', 'drawing/x-dwf'],
	        'dwg': ['application/acad', 'image/vnd.dwg', 'image/x-dwg'],
	        'dxf': ['application/dxf', 'image/vnd.dwg', 'image/vnd.dxf', 'image/x-dwg'],
	        'dxp': 'application/vnd.spotfire.dxp',
	        'dxr': 'application/x-director',
	        'ecelp4800': 'audio/vnd.nuera.ecelp4800',
	        'ecelp7470': 'audio/vnd.nuera.ecelp7470',
	        'ecelp9600': 'audio/vnd.nuera.ecelp9600',
	        'edm': 'application/vnd.novadigm.edm',
	        'edx': 'application/vnd.novadigm.edx',
	        'efif': 'application/vnd.picsel',
	        'ei6': 'application/vnd.pg.osasli',
	        'el': 'text/x-script.elisp',
	        'elc': ['application/x-elc', 'application/x-bytecode.elisp'],
	        'eml': 'message/rfc822',
	        'emma': 'application/emma+xml',
	        'env': 'application/x-envoy',
	        'eol': 'audio/vnd.digital-winds',
	        'eot': 'application/vnd.ms-fontobject',
	        'eps': 'application/postscript',
	        'epub': 'application/epub+zip',
	        'es': ['application/ecmascript', 'application/x-esrehber'],
	        'es3': 'application/vnd.eszigno3+xml',
	        'esf': 'application/vnd.epson.esf',
	        'etx': 'text/x-setext',
	        'evy': ['application/envoy', 'application/x-envoy'],
	        'exe': ['application/octet-stream', 'application/x-msdownload'],
	        'exi': 'application/exi',
	        'ext': 'application/vnd.novadigm.ext',
	        'ez2': 'application/vnd.ezpix-album',
	        'ez3': 'application/vnd.ezpix-package',
	        'f': ['text/plain', 'text/x-fortran'],
	        'f4v': 'video/x-f4v',
	        'f77': 'text/x-fortran',
	        'f90': ['text/plain', 'text/x-fortran'],
	        'fbs': 'image/vnd.fastbidsheet',
	        'fcs': 'application/vnd.isac.fcs',
	        'fdf': 'application/vnd.fdf',
	        'fe_launch': 'application/vnd.denovo.fcselayout-link',
	        'fg5': 'application/vnd.fujitsu.oasysgp',
	        'fh': 'image/x-freehand',
	        'fif': ['application/fractals', 'image/fif'],
	        'fig': 'application/x-xfig',
	        'fli': ['video/fli', 'video/x-fli'],
	        'flo': ['image/florian', 'application/vnd.micrografx.flo'],
	        'flr': 'x-world/x-vrml',
	        'flv': 'video/x-flv',
	        'flw': 'application/vnd.kde.kivio',
	        'flx': 'text/vnd.fmi.flexstor',
	        'fly': 'text/vnd.fly',
	        'fm': 'application/vnd.framemaker',
	        'fmf': 'video/x-atomic3d-feature',
	        'fnc': 'application/vnd.frogans.fnc',
	        'for': ['text/plain', 'text/x-fortran'],
	        'fpx': ['image/vnd.fpx', 'image/vnd.net-fpx'],
	        'frl': 'application/freeloader',
	        'fsc': 'application/vnd.fsc.weblaunch',
	        'fst': 'image/vnd.fst',
	        'ftc': 'application/vnd.fluxtime.clip',
	        'fti': 'application/vnd.anser-web-funds-transfer-initiation',
	        'funk': 'audio/make',
	        'fvt': 'video/vnd.fvt',
	        'fxp': 'application/vnd.adobe.fxp',
	        'fzs': 'application/vnd.fuzzysheet',
	        'g': 'text/plain',
	        'g2w': 'application/vnd.geoplan',
	        'g3': 'image/g3fax',
	        'g3w': 'application/vnd.geospace',
	        'gac': 'application/vnd.groove-account',
	        'gdl': 'model/vnd.gdl',
	        'geo': 'application/vnd.dynageo',
	        'gex': 'application/vnd.geometry-explorer',
	        'ggb': 'application/vnd.geogebra.file',
	        'ggt': 'application/vnd.geogebra.tool',
	        'ghf': 'application/vnd.groove-help',
	        'gif': 'image/gif',
	        'gim': 'application/vnd.groove-identity-message',
	        'gl': ['video/gl', 'video/x-gl'],
	        'gmx': 'application/vnd.gmx',
	        'gnumeric': 'application/x-gnumeric',
	        'gph': 'application/vnd.flographit',
	        'gqf': 'application/vnd.grafeq',
	        'gram': 'application/srgs',
	        'grv': 'application/vnd.groove-injector',
	        'grxml': 'application/srgs+xml',
	        'gsd': 'audio/x-gsm',
	        'gsf': 'application/x-font-ghostscript',
	        'gsm': 'audio/x-gsm',
	        'gsp': 'application/x-gsp',
	        'gss': 'application/x-gss',
	        'gtar': 'application/x-gtar',
	        'gtm': 'application/vnd.groove-tool-message',
	        'gtw': 'model/vnd.gtw',
	        'gv': 'text/vnd.graphviz',
	        'gxt': 'application/vnd.geonext',
	        'gz': ['application/x-gzip', 'application/x-compressed'],
	        'gzip': ['multipart/x-gzip', 'application/x-gzip'],
	        'h': ['text/plain', 'text/x-h'],
	        'h261': 'video/h261',
	        'h263': 'video/h263',
	        'h264': 'video/h264',
	        'hal': 'application/vnd.hal+xml',
	        'hbci': 'application/vnd.hbci',
	        'hdf': 'application/x-hdf',
	        'help': 'application/x-helpfile',
	        'hgl': 'application/vnd.hp-hpgl',
	        'hh': ['text/plain', 'text/x-h'],
	        'hlb': 'text/x-script',
	        'hlp': ['application/winhlp', 'application/hlp', 'application/x-helpfile', 'application/x-winhelp'],
	        'hpg': 'application/vnd.hp-hpgl',
	        'hpgl': 'application/vnd.hp-hpgl',
	        'hpid': 'application/vnd.hp-hpid',
	        'hps': 'application/vnd.hp-hps',
	        'hqx': ['application/mac-binhex40', 'application/binhex', 'application/binhex4', 'application/mac-binhex', 'application/x-binhex40', 'application/x-mac-binhex40'],
	        'hta': 'application/hta',
	        'htc': 'text/x-component',
	        'htke': 'application/vnd.kenameaapp',
	        'htm': 'text/html',
	        'html': 'text/html',
	        'htmls': 'text/html',
	        'htt': 'text/webviewhtml',
	        'htx': 'text/html',
	        'hvd': 'application/vnd.yamaha.hv-dic',
	        'hvp': 'application/vnd.yamaha.hv-voice',
	        'hvs': 'application/vnd.yamaha.hv-script',
	        'i2g': 'application/vnd.intergeo',
	        'icc': 'application/vnd.iccprofile',
	        'ice': 'x-conference/x-cooltalk',
	        'ico': 'image/x-icon',
	        'ics': 'text/calendar',
	        'idc': 'text/plain',
	        'ief': 'image/ief',
	        'iefs': 'image/ief',
	        'ifm': 'application/vnd.shana.informed.formdata',
	        'iges': ['application/iges', 'model/iges'],
	        'igl': 'application/vnd.igloader',
	        'igm': 'application/vnd.insors.igm',
	        'igs': ['application/iges', 'model/iges'],
	        'igx': 'application/vnd.micrografx.igx',
	        'iif': 'application/vnd.shana.informed.interchange',
	        'iii': 'application/x-iphone',
	        'ima': 'application/x-ima',
	        'imap': 'application/x-httpd-imap',
	        'imp': 'application/vnd.accpac.simply.imp',
	        'ims': 'application/vnd.ms-ims',
	        'inf': 'application/inf',
	        'ins': ['application/x-internet-signup', 'application/x-internett-signup'],
	        'ip': 'application/x-ip2',
	        'ipfix': 'application/ipfix',
	        'ipk': 'application/vnd.shana.informed.package',
	        'irm': 'application/vnd.ibm.rights-management',
	        'irp': 'application/vnd.irepository.package+xml',
	        'isp': 'application/x-internet-signup',
	        'isu': 'video/x-isvideo',
	        'it': 'audio/it',
	        'itp': 'application/vnd.shana.informed.formtemplate',
	        'iv': 'application/x-inventor',
	        'ivp': 'application/vnd.immervision-ivp',
	        'ivr': 'i-world/i-vrml',
	        'ivu': 'application/vnd.immervision-ivu',
	        'ivy': 'application/x-livescreen',
	        'jad': 'text/vnd.sun.j2me.app-descriptor',
	        'jam': ['application/vnd.jam', 'audio/x-jam'],
	        'jar': 'application/java-archive',
	        'jav': ['text/plain', 'text/x-java-source'],
	        'java': ['text/plain', 'text/x-java-source,java', 'text/x-java-source'],
	        'jcm': 'application/x-java-commerce',
	        'jfif': ['image/pipeg', 'image/jpeg', 'image/pjpeg'],
	        'jfif-tbnl': 'image/jpeg',
	        'jisp': 'application/vnd.jisp',
	        'jlt': 'application/vnd.hp-jlyt',
	        'jnlp': 'application/x-java-jnlp-file',
	        'joda': 'application/vnd.joost.joda-archive',
	        'jpe': ['image/jpeg', 'image/pjpeg'],
	        'jpeg': ['image/jpeg', 'image/pjpeg'],
	        'jpg': ['image/jpeg', 'image/pjpeg'],
	        'jpgv': 'video/jpeg',
	        'jpm': 'video/jpm',
	        'jps': 'image/x-jps',
	        'js': ['application/javascript', 'application/ecmascript', 'text/javascript', 'text/ecmascript', 'application/x-javascript'],
	        'json': 'application/json',
	        'jut': 'image/jutvision',
	        'kar': ['audio/midi', 'music/x-karaoke'],
	        'karbon': 'application/vnd.kde.karbon',
	        'kfo': 'application/vnd.kde.kformula',
	        'kia': 'application/vnd.kidspiration',
	        'kml': 'application/vnd.google-earth.kml+xml',
	        'kmz': 'application/vnd.google-earth.kmz',
	        'kne': 'application/vnd.kinar',
	        'kon': 'application/vnd.kde.kontour',
	        'kpr': 'application/vnd.kde.kpresenter',
	        'ksh': ['application/x-ksh', 'text/x-script.ksh'],
	        'ksp': 'application/vnd.kde.kspread',
	        'ktx': 'image/ktx',
	        'ktz': 'application/vnd.kahootz',
	        'kwd': 'application/vnd.kde.kword',
	        'la': ['audio/nspaudio', 'audio/x-nspaudio'],
	        'lam': 'audio/x-liveaudio',
	        'lasxml': 'application/vnd.las.las+xml',
	        'latex': 'application/x-latex',
	        'lbd': 'application/vnd.llamagraphics.life-balance.desktop',
	        'lbe': 'application/vnd.llamagraphics.life-balance.exchange+xml',
	        'les': 'application/vnd.hhe.lesson-player',
	        'lha': ['application/octet-stream', 'application/lha', 'application/x-lha'],
	        'lhx': 'application/octet-stream',
	        'link66': 'application/vnd.route66.link66+xml',
	        'list': 'text/plain',
	        'lma': ['audio/nspaudio', 'audio/x-nspaudio'],
	        'log': 'text/plain',
	        'lrm': 'application/vnd.ms-lrm',
	        'lsf': 'video/x-la-asf',
	        'lsp': ['application/x-lisp', 'text/x-script.lisp'],
	        'lst': 'text/plain',
	        'lsx': ['video/x-la-asf', 'text/x-la-asf'],
	        'ltf': 'application/vnd.frogans.ltf',
	        'ltx': 'application/x-latex',
	        'lvp': 'audio/vnd.lucent.voice',
	        'lwp': 'application/vnd.lotus-wordpro',
	        'lzh': ['application/octet-stream', 'application/x-lzh'],
	        'lzx': ['application/lzx', 'application/octet-stream', 'application/x-lzx'],
	        'm': ['text/plain', 'text/x-m'],
	        'm13': 'application/x-msmediaview',
	        'm14': 'application/x-msmediaview',
	        'm1v': 'video/mpeg',
	        'm21': 'application/mp21',
	        'm2a': 'audio/mpeg',
	        'm2v': 'video/mpeg',
	        'm3u': ['audio/x-mpegurl', 'audio/x-mpequrl'],
	        'm3u8': 'application/vnd.apple.mpegurl',
	        'm4v': 'video/x-m4v',
	        'ma': 'application/mathematica',
	        'mads': 'application/mads+xml',
	        'mag': 'application/vnd.ecowin.chart',
	        'man': 'application/x-troff-man',
	        'map': 'application/x-navimap',
	        'mar': 'text/plain',
	        'mathml': 'application/mathml+xml',
	        'mbd': 'application/mbedlet',
	        'mbk': 'application/vnd.mobius.mbk',
	        'mbox': 'application/mbox',
	        'mc$': 'application/x-magic-cap-package-1.0',
	        'mc1': 'application/vnd.medcalcdata',
	        'mcd': ['application/mcad', 'application/vnd.mcd', 'application/x-mathcad'],
	        'mcf': ['image/vasa', 'text/mcf'],
	        'mcp': 'application/netmc',
	        'mcurl': 'text/vnd.curl.mcurl',
	        'mdb': 'application/x-msaccess',
	        'mdi': 'image/vnd.ms-modi',
	        'me': 'application/x-troff-me',
	        'meta4': 'application/metalink4+xml',
	        'mets': 'application/mets+xml',
	        'mfm': 'application/vnd.mfmp',
	        'mgp': 'application/vnd.osgeo.mapguide.package',
	        'mgz': 'application/vnd.proteus.magazine',
	        'mht': 'message/rfc822',
	        'mhtml': 'message/rfc822',
	        'mid': ['audio/mid', 'audio/midi', 'music/crescendo', 'x-music/x-midi', 'audio/x-midi', 'application/x-midi', 'audio/x-mid'],
	        'midi': ['audio/midi', 'music/crescendo', 'x-music/x-midi', 'audio/x-midi', 'application/x-midi', 'audio/x-mid'],
	        'mif': ['application/vnd.mif', 'application/x-mif', 'application/x-frame'],
	        'mime': ['message/rfc822', 'www/mime'],
	        'mj2': 'video/mj2',
	        'mjf': 'audio/x-vnd.audioexplosion.mjuicemediafile',
	        'mjpg': 'video/x-motion-jpeg',
	        'mlp': 'application/vnd.dolby.mlp',
	        'mm': ['application/base64', 'application/x-meme'],
	        'mmd': 'application/vnd.chipnuts.karaoke-mmd',
	        'mme': 'application/base64',
	        'mmf': 'application/vnd.smaf',
	        'mmr': 'image/vnd.fujixerox.edmics-mmr',
	        'mny': 'application/x-msmoney',
	        'mod': ['audio/mod', 'audio/x-mod'],
	        'mods': 'application/mods+xml',
	        'moov': 'video/quicktime',
	        'mov': 'video/quicktime',
	        'movie': 'video/x-sgi-movie',
	        'mp2': ['video/mpeg', 'audio/mpeg', 'video/x-mpeg', 'audio/x-mpeg', 'video/x-mpeq2a'],
	        'mp3': ['audio/mpeg', 'audio/mpeg3', 'video/mpeg', 'audio/x-mpeg-3', 'video/x-mpeg'],
	        'mp4': ['video/mp4', 'application/mp4'],
	        'mp4a': 'audio/mp4',
	        'mpa': ['video/mpeg', 'audio/mpeg'],
	        'mpc': ['application/vnd.mophun.certificate', 'application/x-project'],
	        'mpe': 'video/mpeg',
	        'mpeg': 'video/mpeg',
	        'mpg': ['video/mpeg', 'audio/mpeg'],
	        'mpga': 'audio/mpeg',
	        'mpkg': 'application/vnd.apple.installer+xml',
	        'mpm': 'application/vnd.blueice.multipass',
	        'mpn': 'application/vnd.mophun.application',
	        'mpp': 'application/vnd.ms-project',
	        'mpt': 'application/x-project',
	        'mpv': 'application/x-project',
	        'mpv2': 'video/mpeg',
	        'mpx': 'application/x-project',
	        'mpy': 'application/vnd.ibm.minipay',
	        'mqy': 'application/vnd.mobius.mqy',
	        'mrc': 'application/marc',
	        'mrcx': 'application/marcxml+xml',
	        'ms': 'application/x-troff-ms',
	        'mscml': 'application/mediaservercontrol+xml',
	        'mseq': 'application/vnd.mseq',
	        'msf': 'application/vnd.epson.msf',
	        'msg': 'application/vnd.ms-outlook',
	        'msh': 'model/mesh',
	        'msl': 'application/vnd.mobius.msl',
	        'msty': 'application/vnd.muvee.style',
	        'mts': 'model/vnd.mts',
	        'mus': 'application/vnd.musician',
	        'musicxml': 'application/vnd.recordare.musicxml+xml',
	        'mv': 'video/x-sgi-movie',
	        'mvb': 'application/x-msmediaview',
	        'mwf': 'application/vnd.mfer',
	        'mxf': 'application/mxf',
	        'mxl': 'application/vnd.recordare.musicxml',
	        'mxml': 'application/xv+xml',
	        'mxs': 'application/vnd.triscape.mxs',
	        'mxu': 'video/vnd.mpegurl',
	        'my': 'audio/make',
	        'mzz': 'application/x-vnd.audioexplosion.mzz',
	        'n-gage': 'application/vnd.nokia.n-gage.symbian.install',
	        'n3': 'text/n3',
	        'nap': 'image/naplps',
	        'naplps': 'image/naplps',
	        'nbp': 'application/vnd.wolfram.player',
	        'nc': 'application/x-netcdf',
	        'ncm': 'application/vnd.nokia.configuration-message',
	        'ncx': 'application/x-dtbncx+xml',
	        'ngdat': 'application/vnd.nokia.n-gage.data',
	        'nif': 'image/x-niff',
	        'niff': 'image/x-niff',
	        'nix': 'application/x-mix-transfer',
	        'nlu': 'application/vnd.neurolanguage.nlu',
	        'nml': 'application/vnd.enliven',
	        'nnd': 'application/vnd.noblenet-directory',
	        'nns': 'application/vnd.noblenet-sealer',
	        'nnw': 'application/vnd.noblenet-web',
	        'npx': 'image/vnd.net-fpx',
	        'nsc': 'application/x-conference',
	        'nsf': 'application/vnd.lotus-notes',
	        'nvd': 'application/x-navidoc',
	        'nws': 'message/rfc822',
	        'o': 'application/octet-stream',
	        'oa2': 'application/vnd.fujitsu.oasys2',
	        'oa3': 'application/vnd.fujitsu.oasys3',
	        'oas': 'application/vnd.fujitsu.oasys',
	        'obd': 'application/x-msbinder',
	        'oda': 'application/oda',
	        'odb': 'application/vnd.oasis.opendocument.database',
	        'odc': 'application/vnd.oasis.opendocument.chart',
	        'odf': 'application/vnd.oasis.opendocument.formula',
	        'odft': 'application/vnd.oasis.opendocument.formula-template',
	        'odg': 'application/vnd.oasis.opendocument.graphics',
	        'odi': 'application/vnd.oasis.opendocument.image',
	        'odm': 'application/vnd.oasis.opendocument.text-master',
	        'odp': 'application/vnd.oasis.opendocument.presentation',
	        'ods': 'application/vnd.oasis.opendocument.spreadsheet',
	        'odt': 'application/vnd.oasis.opendocument.text',
	        'oga': 'audio/ogg',
	        'ogv': 'video/ogg',
	        'ogx': 'application/ogg',
	        'omc': 'application/x-omc',
	        'omcd': 'application/x-omcdatamaker',
	        'omcr': 'application/x-omcregerator',
	        'onetoc': 'application/onenote',
	        'opf': 'application/oebps-package+xml',
	        'org': 'application/vnd.lotus-organizer',
	        'osf': 'application/vnd.yamaha.openscoreformat',
	        'osfpvg': 'application/vnd.yamaha.openscoreformat.osfpvg+xml',
	        'otc': 'application/vnd.oasis.opendocument.chart-template',
	        'otf': 'application/x-font-otf',
	        'otg': 'application/vnd.oasis.opendocument.graphics-template',
	        'oth': 'application/vnd.oasis.opendocument.text-web',
	        'oti': 'application/vnd.oasis.opendocument.image-template',
	        'otp': 'application/vnd.oasis.opendocument.presentation-template',
	        'ots': 'application/vnd.oasis.opendocument.spreadsheet-template',
	        'ott': 'application/vnd.oasis.opendocument.text-template',
	        'oxt': 'application/vnd.openofficeorg.extension',
	        'p': 'text/x-pascal',
	        'p10': ['application/pkcs10', 'application/x-pkcs10'],
	        'p12': ['application/pkcs-12', 'application/x-pkcs12'],
	        'p7a': 'application/x-pkcs7-signature',
	        'p7b': 'application/x-pkcs7-certificates',
	        'p7c': ['application/pkcs7-mime', 'application/x-pkcs7-mime'],
	        'p7m': ['application/pkcs7-mime', 'application/x-pkcs7-mime'],
	        'p7r': 'application/x-pkcs7-certreqresp',
	        'p7s': ['application/pkcs7-signature', 'application/x-pkcs7-signature'],
	        'p8': 'application/pkcs8',
	        'par': 'text/plain-bas',
	        'part': 'application/pro_eng',
	        'pas': 'text/pascal',
	        'paw': 'application/vnd.pawaafile',
	        'pbd': 'application/vnd.powerbuilder6',
	        'pbm': 'image/x-portable-bitmap',
	        'pcf': 'application/x-font-pcf',
	        'pcl': ['application/vnd.hp-pcl', 'application/x-pcl'],
	        'pclxl': 'application/vnd.hp-pclxl',
	        'pct': 'image/x-pict',
	        'pcurl': 'application/vnd.curl.pcurl',
	        'pcx': 'image/x-pcx',
	        'pdb': ['application/vnd.palm', 'chemical/x-pdb'],
	        'pdf': 'application/pdf',
	        'pfa': 'application/x-font-type1',
	        'pfr': 'application/font-tdpfr',
	        'pfunk': ['audio/make', 'audio/make.my.funk'],
	        'pfx': 'application/x-pkcs12',
	        'pgm': ['image/x-portable-graymap', 'image/x-portable-greymap'],
	        'pgn': 'application/x-chess-pgn',
	        'pgp': 'application/pgp-signature',
	        'pic': ['image/pict', 'image/x-pict'],
	        'pict': 'image/pict',
	        'pkg': 'application/x-newton-compatible-pkg',
	        'pki': 'application/pkixcmp',
	        'pkipath': 'application/pkix-pkipath',
	        'pko': ['application/ynd.ms-pkipko', 'application/vnd.ms-pki.pko'],
	        'pl': ['text/plain', 'text/x-script.perl'],
	        'plb': 'application/vnd.3gpp.pic-bw-large',
	        'plc': 'application/vnd.mobius.plc',
	        'plf': 'application/vnd.pocketlearn',
	        'pls': 'application/pls+xml',
	        'plx': 'application/x-pixclscript',
	        'pm': ['text/x-script.perl-module', 'image/x-xpixmap'],
	        'pm4': 'application/x-pagemaker',
	        'pm5': 'application/x-pagemaker',
	        'pma': 'application/x-perfmon',
	        'pmc': 'application/x-perfmon',
	        'pml': ['application/vnd.ctc-posml', 'application/x-perfmon'],
	        'pmr': 'application/x-perfmon',
	        'pmw': 'application/x-perfmon',
	        'png': 'image/png',
	        'pnm': ['application/x-portable-anymap', 'image/x-portable-anymap'],
	        'portpkg': 'application/vnd.macports.portpkg',
	        'pot': ['application/vnd.ms-powerpoint', 'application/mspowerpoint'],
	        'potm': 'application/vnd.ms-powerpoint.template.macroenabled.12',
	        'potx': 'application/vnd.openxmlformats-officedocument.presentationml.template',
	        'pov': 'model/x-pov',
	        'ppa': 'application/vnd.ms-powerpoint',
	        'ppam': 'application/vnd.ms-powerpoint.addin.macroenabled.12',
	        'ppd': 'application/vnd.cups-ppd',
	        'ppm': 'image/x-portable-pixmap',
	        'pps': ['application/vnd.ms-powerpoint', 'application/mspowerpoint'],
	        'ppsm': 'application/vnd.ms-powerpoint.slideshow.macroenabled.12',
	        'ppsx': 'application/vnd.openxmlformats-officedocument.presentationml.slideshow',
	        'ppt': ['application/vnd.ms-powerpoint', 'application/mspowerpoint', 'application/powerpoint', 'application/x-mspowerpoint'],
	        'pptm': 'application/vnd.ms-powerpoint.presentation.macroenabled.12',
	        'pptx': 'application/vnd.openxmlformats-officedocument.presentationml.presentation',
	        'ppz': 'application/mspowerpoint',
	        'prc': 'application/x-mobipocket-ebook',
	        'pre': ['application/vnd.lotus-freelance', 'application/x-freelance'],
	        'prf': 'application/pics-rules',
	        'prt': 'application/pro_eng',
	        'ps': 'application/postscript',
	        'psb': 'application/vnd.3gpp.pic-bw-small',
	        'psd': ['application/octet-stream', 'image/vnd.adobe.photoshop'],
	        'psf': 'application/x-font-linux-psf',
	        'pskcxml': 'application/pskc+xml',
	        'ptid': 'application/vnd.pvi.ptid1',
	        'pub': 'application/x-mspublisher',
	        'pvb': 'application/vnd.3gpp.pic-bw-var',
	        'pvu': 'paleovu/x-pv',
	        'pwn': 'application/vnd.3m.post-it-notes',
	        'pwz': 'application/vnd.ms-powerpoint',
	        'py': 'text/x-script.phyton',
	        'pya': 'audio/vnd.ms-playready.media.pya',
	        'pyc': 'applicaiton/x-bytecode.python',
	        'pyv': 'video/vnd.ms-playready.media.pyv',
	        'qam': 'application/vnd.epson.quickanime',
	        'qbo': 'application/vnd.intu.qbo',
	        'qcp': 'audio/vnd.qcelp',
	        'qd3': 'x-world/x-3dmf',
	        'qd3d': 'x-world/x-3dmf',
	        'qfx': 'application/vnd.intu.qfx',
	        'qif': 'image/x-quicktime',
	        'qps': 'application/vnd.publishare-delta-tree',
	        'qt': 'video/quicktime',
	        'qtc': 'video/x-qtc',
	        'qti': 'image/x-quicktime',
	        'qtif': 'image/x-quicktime',
	        'qxd': 'application/vnd.quark.quarkxpress',
	        'ra': ['audio/x-realaudio', 'audio/x-pn-realaudio', 'audio/x-pn-realaudio-plugin'],
	        'ram': 'audio/x-pn-realaudio',
	        'rar': 'application/x-rar-compressed',
	        'ras': ['image/cmu-raster', 'application/x-cmu-raster', 'image/x-cmu-raster'],
	        'rast': 'image/cmu-raster',
	        'rcprofile': 'application/vnd.ipunplugged.rcprofile',
	        'rdf': 'application/rdf+xml',
	        'rdz': 'application/vnd.data-vision.rdz',
	        'rep': 'application/vnd.businessobjects',
	        'res': 'application/x-dtbresource+xml',
	        'rexx': 'text/x-script.rexx',
	        'rf': 'image/vnd.rn-realflash',
	        'rgb': 'image/x-rgb',
	        'rif': 'application/reginfo+xml',
	        'rip': 'audio/vnd.rip',
	        'rl': 'application/resource-lists+xml',
	        'rlc': 'image/vnd.fujixerox.edmics-rlc',
	        'rld': 'application/resource-lists-diff+xml',
	        'rm': ['application/vnd.rn-realmedia', 'audio/x-pn-realaudio'],
	        'rmi': 'audio/mid',
	        'rmm': 'audio/x-pn-realaudio',
	        'rmp': ['audio/x-pn-realaudio-plugin', 'audio/x-pn-realaudio'],
	        'rms': 'application/vnd.jcp.javame.midlet-rms',
	        'rnc': 'application/relax-ng-compact-syntax',
	        'rng': ['application/ringing-tones', 'application/vnd.nokia.ringing-tone'],
	        'rnx': 'application/vnd.rn-realplayer',
	        'roff': 'application/x-troff',
	        'rp': 'image/vnd.rn-realpix',
	        'rp9': 'application/vnd.cloanto.rp9',
	        'rpm': 'audio/x-pn-realaudio-plugin',
	        'rpss': 'application/vnd.nokia.radio-presets',
	        'rpst': 'application/vnd.nokia.radio-preset',
	        'rq': 'application/sparql-query',
	        'rs': 'application/rls-services+xml',
	        'rsd': 'application/rsd+xml',
	        'rt': ['text/richtext', 'text/vnd.rn-realtext'],
	        'rtf': ['application/rtf', 'text/richtext', 'application/x-rtf'],
	        'rtx': ['text/richtext', 'application/rtf'],
	        'rv': 'video/vnd.rn-realvideo',
	        's': 'text/x-asm',
	        's3m': 'audio/s3m',
	        'saf': 'application/vnd.yamaha.smaf-audio',
	        'saveme': 'application/octet-stream',
	        'sbk': 'application/x-tbook',
	        'sbml': 'application/sbml+xml',
	        'sc': 'application/vnd.ibm.secure-container',
	        'scd': 'application/x-msschedule',
	        'scm': ['application/vnd.lotus-screencam', 'video/x-scm', 'text/x-script.guile', 'application/x-lotusscreencam', 'text/x-script.scheme'],
	        'scq': 'application/scvp-cv-request',
	        'scs': 'application/scvp-cv-response',
	        'sct': 'text/scriptlet',
	        'scurl': 'text/vnd.curl.scurl',
	        'sda': 'application/vnd.stardivision.draw',
	        'sdc': 'application/vnd.stardivision.calc',
	        'sdd': 'application/vnd.stardivision.impress',
	        'sdkm': 'application/vnd.solent.sdkm+xml',
	        'sdml': 'text/plain',
	        'sdp': ['application/sdp', 'application/x-sdp'],
	        'sdr': 'application/sounder',
	        'sdw': 'application/vnd.stardivision.writer',
	        'sea': ['application/sea', 'application/x-sea'],
	        'see': 'application/vnd.seemail',
	        'seed': 'application/vnd.fdsn.seed',
	        'sema': 'application/vnd.sema',
	        'semd': 'application/vnd.semd',
	        'semf': 'application/vnd.semf',
	        'ser': 'application/java-serialized-object',
	        'set': 'application/set',
	        'setpay': 'application/set-payment-initiation',
	        'setreg': 'application/set-registration-initiation',
	        'sfd-hdstx': 'application/vnd.hydrostatix.sof-data',
	        'sfs': 'application/vnd.spotfire.sfs',
	        'sgl': 'application/vnd.stardivision.writer-global',
	        'sgm': ['text/sgml', 'text/x-sgml'],
	        'sgml': ['text/sgml', 'text/x-sgml'],
	        'sh': ['application/x-shar', 'application/x-bsh', 'application/x-sh', 'text/x-script.sh'],
	        'shar': ['application/x-bsh', 'application/x-shar'],
	        'shf': 'application/shf+xml',
	        'shtml': ['text/html', 'text/x-server-parsed-html'],
	        'sid': 'audio/x-psid',
	        'sis': 'application/vnd.symbian.install',
	        'sit': ['application/x-stuffit', 'application/x-sit'],
	        'sitx': 'application/x-stuffitx',
	        'skd': 'application/x-koan',
	        'skm': 'application/x-koan',
	        'skp': ['application/vnd.koan', 'application/x-koan'],
	        'skt': 'application/x-koan',
	        'sl': 'application/x-seelogo',
	        'sldm': 'application/vnd.ms-powerpoint.slide.macroenabled.12',
	        'sldx': 'application/vnd.openxmlformats-officedocument.presentationml.slide',
	        'slt': 'application/vnd.epson.salt',
	        'sm': 'application/vnd.stepmania.stepchart',
	        'smf': 'application/vnd.stardivision.math',
	        'smi': ['application/smil', 'application/smil+xml'],
	        'smil': 'application/smil',
	        'snd': ['audio/basic', 'audio/x-adpcm'],
	        'snf': 'application/x-font-snf',
	        'sol': 'application/solids',
	        'spc': ['text/x-speech', 'application/x-pkcs7-certificates'],
	        'spf': 'application/vnd.yamaha.smaf-phrase',
	        'spl': ['application/futuresplash', 'application/x-futuresplash'],
	        'spot': 'text/vnd.in3d.spot',
	        'spp': 'application/scvp-vp-response',
	        'spq': 'application/scvp-vp-request',
	        'spr': 'application/x-sprite',
	        'sprite': 'application/x-sprite',
	        'src': 'application/x-wais-source',
	        'sru': 'application/sru+xml',
	        'srx': 'application/sparql-results+xml',
	        'sse': 'application/vnd.kodak-descriptor',
	        'ssf': 'application/vnd.epson.ssf',
	        'ssi': 'text/x-server-parsed-html',
	        'ssm': 'application/streamingmedia',
	        'ssml': 'application/ssml+xml',
	        'sst': ['application/vnd.ms-pkicertstore', 'application/vnd.ms-pki.certstore'],
	        'st': 'application/vnd.sailingtracker.track',
	        'stc': 'application/vnd.sun.xml.calc.template',
	        'std': 'application/vnd.sun.xml.draw.template',
	        'step': 'application/step',
	        'stf': 'application/vnd.wt.stf',
	        'sti': 'application/vnd.sun.xml.impress.template',
	        'stk': 'application/hyperstudio',
	        'stl': ['application/vnd.ms-pkistl', 'application/sla', 'application/vnd.ms-pki.stl', 'application/x-navistyle'],
	        'stm': 'text/html',
	        'stp': 'application/step',
	        'str': 'application/vnd.pg.format',
	        'stw': 'application/vnd.sun.xml.writer.template',
	        'sub': 'image/vnd.dvb.subtitle',
	        'sus': 'application/vnd.sus-calendar',
	        'sv4cpio': 'application/x-sv4cpio',
	        'sv4crc': 'application/x-sv4crc',
	        'svc': 'application/vnd.dvb.service',
	        'svd': 'application/vnd.svd',
	        'svf': ['image/vnd.dwg', 'image/x-dwg'],
	        'svg': 'image/svg+xml',
	        'svr': ['x-world/x-svr', 'application/x-world'],
	        'swf': 'application/x-shockwave-flash',
	        'swi': 'application/vnd.aristanetworks.swi',
	        'sxc': 'application/vnd.sun.xml.calc',
	        'sxd': 'application/vnd.sun.xml.draw',
	        'sxg': 'application/vnd.sun.xml.writer.global',
	        'sxi': 'application/vnd.sun.xml.impress',
	        'sxm': 'application/vnd.sun.xml.math',
	        'sxw': 'application/vnd.sun.xml.writer',
	        't': ['text/troff', 'application/x-troff'],
	        'talk': 'text/x-speech',
	        'tao': 'application/vnd.tao.intent-module-archive',
	        'tar': 'application/x-tar',
	        'tbk': ['application/toolbook', 'application/x-tbook'],
	        'tcap': 'application/vnd.3gpp2.tcap',
	        'tcl': ['text/x-script.tcl', 'application/x-tcl'],
	        'tcsh': 'text/x-script.tcsh',
	        'teacher': 'application/vnd.smart.teacher',
	        'tei': 'application/tei+xml',
	        'tex': 'application/x-tex',
	        'texi': 'application/x-texinfo',
	        'texinfo': 'application/x-texinfo',
	        'text': ['application/plain', 'text/plain'],
	        'tfi': 'application/thraud+xml',
	        'tfm': 'application/x-tex-tfm',
	        'tgz': ['application/gnutar', 'application/x-compressed'],
	        'thmx': 'application/vnd.ms-officetheme',
	        'tif': ['image/tiff', 'image/x-tiff'],
	        'tiff': ['image/tiff', 'image/x-tiff'],
	        'tmo': 'application/vnd.tmobile-livetv',
	        'torrent': 'application/x-bittorrent',
	        'tpl': 'application/vnd.groove-tool-template',
	        'tpt': 'application/vnd.trid.tpt',
	        'tr': 'application/x-troff',
	        'tra': 'application/vnd.trueapp',
	        'trm': 'application/x-msterminal',
	        'tsd': 'application/timestamped-data',
	        'tsi': 'audio/tsp-audio',
	        'tsp': ['application/dsptype', 'audio/tsplayer'],
	        'tsv': 'text/tab-separated-values',
	        'ttf': 'application/x-font-ttf',
	        'ttl': 'text/turtle',
	        'turbot': 'image/florian',
	        'twd': 'application/vnd.simtech-mindmapper',
	        'txd': 'application/vnd.genomatix.tuxedo',
	        'txf': 'application/vnd.mobius.txf',
	        'txt': 'text/plain',
	        'ufd': 'application/vnd.ufdl',
	        'uil': 'text/x-uil',
	        'uls': 'text/iuls',
	        'umj': 'application/vnd.umajin',
	        'uni': 'text/uri-list',
	        'unis': 'text/uri-list',
	        'unityweb': 'application/vnd.unity',
	        'unv': 'application/i-deas',
	        'uoml': 'application/vnd.uoml+xml',
	        'uri': 'text/uri-list',
	        'uris': 'text/uri-list',
	        'ustar': ['application/x-ustar', 'multipart/x-ustar'],
	        'utz': 'application/vnd.uiq.theme',
	        'uu': ['application/octet-stream', 'text/x-uuencode'],
	        'uue': 'text/x-uuencode',
	        'uva': 'audio/vnd.dece.audio',
	        'uvh': 'video/vnd.dece.hd',
	        'uvi': 'image/vnd.dece.graphic',
	        'uvm': 'video/vnd.dece.mobile',
	        'uvp': 'video/vnd.dece.pd',
	        'uvs': 'video/vnd.dece.sd',
	        'uvu': 'video/vnd.uvvu.mp4',
	        'uvv': 'video/vnd.dece.video',
	        'vcd': 'application/x-cdlink',
	        'vcf': 'text/x-vcard',
	        'vcg': 'application/vnd.groove-vcard',
	        'vcs': 'text/x-vcalendar',
	        'vcx': 'application/vnd.vcx',
	        'vda': 'application/vda',
	        'vdo': 'video/vdo',
	        'vew': 'application/groupwise',
	        'vis': 'application/vnd.visionary',
	        'viv': ['video/vivo', 'video/vnd.vivo'],
	        'vivo': ['video/vivo', 'video/vnd.vivo'],
	        'vmd': 'application/vocaltec-media-desc',
	        'vmf': 'application/vocaltec-media-file',
	        'voc': ['audio/voc', 'audio/x-voc'],
	        'vos': 'video/vosaic',
	        'vox': 'audio/voxware',
	        'vqe': 'audio/x-twinvq-plugin',
	        'vqf': 'audio/x-twinvq',
	        'vql': 'audio/x-twinvq-plugin',
	        'vrml': ['model/vrml', 'x-world/x-vrml', 'application/x-vrml'],
	        'vrt': 'x-world/x-vrt',
	        'vsd': ['application/vnd.visio', 'application/x-visio'],
	        'vsf': 'application/vnd.vsf',
	        'vst': 'application/x-visio',
	        'vsw': 'application/x-visio',
	        'vtu': 'model/vnd.vtu',
	        'vxml': 'application/voicexml+xml',
	        'w60': 'application/wordperfect6.0',
	        'w61': 'application/wordperfect6.1',
	        'w6w': 'application/msword',
	        'wad': 'application/x-doom',
	        'wav': ['audio/wav', 'audio/x-wav'],
	        'wax': 'audio/x-ms-wax',
	        'wb1': 'application/x-qpro',
	        'wbmp': 'image/vnd.wap.wbmp',
	        'wbs': 'application/vnd.criticaltools.wbs+xml',
	        'wbxml': 'application/vnd.wap.wbxml',
	        'wcm': 'application/vnd.ms-works',
	        'wdb': 'application/vnd.ms-works',
	        'web': 'application/vnd.xara',
	        'weba': 'audio/webm',
	        'webm': 'video/webm',
	        'webp': 'image/webp',
	        'wg': 'application/vnd.pmi.widget',
	        'wgt': 'application/widget',
	        'wiz': 'application/msword',
	        'wk1': 'application/x-123',
	        'wks': 'application/vnd.ms-works',
	        'wm': 'video/x-ms-wm',
	        'wma': 'audio/x-ms-wma',
	        'wmd': 'application/x-ms-wmd',
	        'wmf': ['windows/metafile', 'application/x-msmetafile'],
	        'wml': 'text/vnd.wap.wml',
	        'wmlc': 'application/vnd.wap.wmlc',
	        'wmls': 'text/vnd.wap.wmlscript',
	        'wmlsc': 'application/vnd.wap.wmlscriptc',
	        'wmv': 'video/x-ms-wmv',
	        'wmx': 'video/x-ms-wmx',
	        'wmz': 'application/x-ms-wmz',
	        'woff': 'application/x-font-woff',
	        'word': 'application/msword',
	        'wp': 'application/wordperfect',
	        'wp5': ['application/wordperfect', 'application/wordperfect6.0'],
	        'wp6': 'application/wordperfect',
	        'wpd': ['application/wordperfect', 'application/vnd.wordperfect', 'application/x-wpwin'],
	        'wpl': 'application/vnd.ms-wpl',
	        'wps': 'application/vnd.ms-works',
	        'wq1': 'application/x-lotus',
	        'wqd': 'application/vnd.wqd',
	        'wri': ['application/mswrite', 'application/x-wri', 'application/x-mswrite'],
	        'wrl': ['model/vrml', 'x-world/x-vrml', 'application/x-world'],
	        'wrz': ['model/vrml', 'x-world/x-vrml'],
	        'wsc': 'text/scriplet',
	        'wsdl': 'application/wsdl+xml',
	        'wspolicy': 'application/wspolicy+xml',
	        'wsrc': 'application/x-wais-source',
	        'wtb': 'application/vnd.webturbo',
	        'wtk': 'application/x-wintalk',
	        'wvx': 'video/x-ms-wvx',
	        'x-png': 'image/png',
	        'x3d': 'application/vnd.hzn-3d-crossword',
	        'xaf': 'x-world/x-vrml',
	        'xap': 'application/x-silverlight-app',
	        'xar': 'application/vnd.xara',
	        'xbap': 'application/x-ms-xbap',
	        'xbd': 'application/vnd.fujixerox.docuworks.binder',
	        'xbm': ['image/xbm', 'image/x-xbm', 'image/x-xbitmap'],
	        'xdf': 'application/xcap-diff+xml',
	        'xdm': 'application/vnd.syncml.dm+xml',
	        'xdp': 'application/vnd.adobe.xdp+xml',
	        'xdr': 'video/x-amt-demorun',
	        'xdssc': 'application/dssc+xml',
	        'xdw': 'application/vnd.fujixerox.docuworks',
	        'xenc': 'application/xenc+xml',
	        'xer': 'application/patch-ops-error+xml',
	        'xfdf': 'application/vnd.adobe.xfdf',
	        'xfdl': 'application/vnd.xfdl',
	        'xgz': 'xgl/drawing',
	        'xhtml': 'application/xhtml+xml',
	        'xif': 'image/vnd.xiff',
	        'xl': 'application/excel',
	        'xla': ['application/vnd.ms-excel', 'application/excel', 'application/x-msexcel', 'application/x-excel'],
	        'xlam': 'application/vnd.ms-excel.addin.macroenabled.12',
	        'xlb': ['application/excel', 'application/vnd.ms-excel', 'application/x-excel'],
	        'xlc': ['application/vnd.ms-excel', 'application/excel', 'application/x-excel'],
	        'xld': ['application/excel', 'application/x-excel'],
	        'xlk': ['application/excel', 'application/x-excel'],
	        'xll': ['application/excel', 'application/vnd.ms-excel', 'application/x-excel'],
	        'xlm': ['application/vnd.ms-excel', 'application/excel', 'application/x-excel'],
	        'xls': ['application/vnd.ms-excel', 'application/excel', 'application/x-msexcel', 'application/x-excel'],
	        'xlsb': 'application/vnd.ms-excel.sheet.binary.macroenabled.12',
	        'xlsm': 'application/vnd.ms-excel.sheet.macroenabled.12',
	        'xlsx': 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
	        'xlt': ['application/vnd.ms-excel', 'application/excel', 'application/x-excel'],
	        'xltm': 'application/vnd.ms-excel.template.macroenabled.12',
	        'xltx': 'application/vnd.openxmlformats-officedocument.spreadsheetml.template',
	        'xlv': ['application/excel', 'application/x-excel'],
	        'xlw': ['application/vnd.ms-excel', 'application/excel', 'application/x-msexcel', 'application/x-excel'],
	        'xm': 'audio/xm',
	        'xml': ['application/xml', 'text/xml', 'application/atom+xml', 'application/rss+xml'],
	        'xmz': 'xgl/movie',
	        'xo': 'application/vnd.olpc-sugar',
	        'xof': 'x-world/x-vrml',
	        'xop': 'application/xop+xml',
	        'xpi': 'application/x-xpinstall',
	        'xpix': 'application/x-vnd.ls-xpix',
	        'xpm': ['image/xpm', 'image/x-xpixmap'],
	        'xpr': 'application/vnd.is-xpr',
	        'xps': 'application/vnd.ms-xpsdocument',
	        'xpw': 'application/vnd.intercon.formnet',
	        'xslt': 'application/xslt+xml',
	        'xsm': 'application/vnd.syncml+xml',
	        'xspf': 'application/xspf+xml',
	        'xsr': 'video/x-amt-showrun',
	        'xul': 'application/vnd.mozilla.xul+xml',
	        'xwd': ['image/x-xwd', 'image/x-xwindowdump'],
	        'xyz': ['chemical/x-xyz', 'chemical/x-pdb'],
	        'yang': 'application/yang',
	        'yin': 'application/yin+xml',
	        'z': ['application/x-compressed', 'application/x-compress'],
	        'zaz': 'application/vnd.zzazz.deck+xml',
	        'zip': ['application/zip', 'multipart/x-zip', 'application/x-zip-compressed', 'application/x-compressed'],
	        'zir': 'application/vnd.zul',
	        'zmm': 'application/vnd.handheld-entertainment+xml',
	        'zoo': 'application/octet-stream',
	        'zsh': 'text/x-script.zsh'
	    };

	    return {
	        detectExtension: detectExtension,
	        detectMimeType: detectMimeType
	    };
	}));


/***/ },
/* 55 */
/*!********************************!*\
  !*** ./~/punycode/punycode.js ***!
  \********************************/
/***/ function(module, exports, __webpack_require__) {

	var __WEBPACK_AMD_DEFINE_RESULT__;/* WEBPACK VAR INJECTION */(function(module, global) {/*! https://mths.be/punycode v1.4.1 by @mathias */
	;(function(root) {

		/** Detect free variables */
		var freeExports = typeof exports == 'object' && exports &&
			!exports.nodeType && exports;
		var freeModule = typeof module == 'object' && module &&
			!module.nodeType && module;
		var freeGlobal = typeof global == 'object' && global;
		if (
			freeGlobal.global === freeGlobal ||
			freeGlobal.window === freeGlobal ||
			freeGlobal.self === freeGlobal
		) {
			root = freeGlobal;
		}

		/**
		 * The `punycode` object.
		 * @name punycode
		 * @type Object
		 */
		var punycode,

		/** Highest positive signed 32-bit float value */
		maxInt = 2147483647, // aka. 0x7FFFFFFF or 2^31-1

		/** Bootstring parameters */
		base = 36,
		tMin = 1,
		tMax = 26,
		skew = 38,
		damp = 700,
		initialBias = 72,
		initialN = 128, // 0x80
		delimiter = '-', // '\x2D'

		/** Regular expressions */
		regexPunycode = /^xn--/,
		regexNonASCII = /[^\x20-\x7E]/, // unprintable ASCII chars + non-ASCII chars
		regexSeparators = /[\x2E\u3002\uFF0E\uFF61]/g, // RFC 3490 separators

		/** Error messages */
		errors = {
			'overflow': 'Overflow: input needs wider integers to process',
			'not-basic': 'Illegal input >= 0x80 (not a basic code point)',
			'invalid-input': 'Invalid input'
		},

		/** Convenience shortcuts */
		baseMinusTMin = base - tMin,
		floor = Math.floor,
		stringFromCharCode = String.fromCharCode,

		/** Temporary variable */
		key;

		/*--------------------------------------------------------------------------*/

		/**
		 * A generic error utility function.
		 * @private
		 * @param {String} type The error type.
		 * @returns {Error} Throws a `RangeError` with the applicable error message.
		 */
		function error(type) {
			throw new RangeError(errors[type]);
		}

		/**
		 * A generic `Array#map` utility function.
		 * @private
		 * @param {Array} array The array to iterate over.
		 * @param {Function} callback The function that gets called for every array
		 * item.
		 * @returns {Array} A new array of values returned by the callback function.
		 */
		function map(array, fn) {
			var length = array.length;
			var result = [];
			while (length--) {
				result[length] = fn(array[length]);
			}
			return result;
		}

		/**
		 * A simple `Array#map`-like wrapper to work with domain name strings or email
		 * addresses.
		 * @private
		 * @param {String} domain The domain name or email address.
		 * @param {Function} callback The function that gets called for every
		 * character.
		 * @returns {Array} A new string of characters returned by the callback
		 * function.
		 */
		function mapDomain(string, fn) {
			var parts = string.split('@');
			var result = '';
			if (parts.length > 1) {
				// In email addresses, only the domain name should be punycoded. Leave
				// the local part (i.e. everything up to `@`) intact.
				result = parts[0] + '@';
				string = parts[1];
			}
			// Avoid `split(regex)` for IE8 compatibility. See #17.
			string = string.replace(regexSeparators, '\x2E');
			var labels = string.split('.');
			var encoded = map(labels, fn).join('.');
			return result + encoded;
		}

		/**
		 * Creates an array containing the numeric code points of each Unicode
		 * character in the string. While JavaScript uses UCS-2 internally,
		 * this function will convert a pair of surrogate halves (each of which
		 * UCS-2 exposes as separate characters) into a single code point,
		 * matching UTF-16.
		 * @see `punycode.ucs2.encode`
		 * @see <https://mathiasbynens.be/notes/javascript-encoding>
		 * @memberOf punycode.ucs2
		 * @name decode
		 * @param {String} string The Unicode input string (UCS-2).
		 * @returns {Array} The new array of code points.
		 */
		function ucs2decode(string) {
			var output = [],
			    counter = 0,
			    length = string.length,
			    value,
			    extra;
			while (counter < length) {
				value = string.charCodeAt(counter++);
				if (value >= 0xD800 && value <= 0xDBFF && counter < length) {
					// high surrogate, and there is a next character
					extra = string.charCodeAt(counter++);
					if ((extra & 0xFC00) == 0xDC00) { // low surrogate
						output.push(((value & 0x3FF) << 10) + (extra & 0x3FF) + 0x10000);
					} else {
						// unmatched surrogate; only append this code unit, in case the next
						// code unit is the high surrogate of a surrogate pair
						output.push(value);
						counter--;
					}
				} else {
					output.push(value);
				}
			}
			return output;
		}

		/**
		 * Creates a string based on an array of numeric code points.
		 * @see `punycode.ucs2.decode`
		 * @memberOf punycode.ucs2
		 * @name encode
		 * @param {Array} codePoints The array of numeric code points.
		 * @returns {String} The new Unicode string (UCS-2).
		 */
		function ucs2encode(array) {
			return map(array, function(value) {
				var output = '';
				if (value > 0xFFFF) {
					value -= 0x10000;
					output += stringFromCharCode(value >>> 10 & 0x3FF | 0xD800);
					value = 0xDC00 | value & 0x3FF;
				}
				output += stringFromCharCode(value);
				return output;
			}).join('');
		}

		/**
		 * Converts a basic code point into a digit/integer.
		 * @see `digitToBasic()`
		 * @private
		 * @param {Number} codePoint The basic numeric code point value.
		 * @returns {Number} The numeric value of a basic code point (for use in
		 * representing integers) in the range `0` to `base - 1`, or `base` if
		 * the code point does not represent a value.
		 */
		function basicToDigit(codePoint) {
			if (codePoint - 48 < 10) {
				return codePoint - 22;
			}
			if (codePoint - 65 < 26) {
				return codePoint - 65;
			}
			if (codePoint - 97 < 26) {
				return codePoint - 97;
			}
			return base;
		}

		/**
		 * Converts a digit/integer into a basic code point.
		 * @see `basicToDigit()`
		 * @private
		 * @param {Number} digit The numeric value of a basic code point.
		 * @returns {Number} The basic code point whose value (when used for
		 * representing integers) is `digit`, which needs to be in the range
		 * `0` to `base - 1`. If `flag` is non-zero, the uppercase form is
		 * used; else, the lowercase form is used. The behavior is undefined
		 * if `flag` is non-zero and `digit` has no uppercase form.
		 */
		function digitToBasic(digit, flag) {
			//  0..25 map to ASCII a..z or A..Z
			// 26..35 map to ASCII 0..9
			return digit + 22 + 75 * (digit < 26) - ((flag != 0) << 5);
		}

		/**
		 * Bias adaptation function as per section 3.4 of RFC 3492.
		 * https://tools.ietf.org/html/rfc3492#section-3.4
		 * @private
		 */
		function adapt(delta, numPoints, firstTime) {
			var k = 0;
			delta = firstTime ? floor(delta / damp) : delta >> 1;
			delta += floor(delta / numPoints);
			for (/* no initialization */; delta > baseMinusTMin * tMax >> 1; k += base) {
				delta = floor(delta / baseMinusTMin);
			}
			return floor(k + (baseMinusTMin + 1) * delta / (delta + skew));
		}

		/**
		 * Converts a Punycode string of ASCII-only symbols to a string of Unicode
		 * symbols.
		 * @memberOf punycode
		 * @param {String} input The Punycode string of ASCII-only symbols.
		 * @returns {String} The resulting string of Unicode symbols.
		 */
		function decode(input) {
			// Don't use UCS-2
			var output = [],
			    inputLength = input.length,
			    out,
			    i = 0,
			    n = initialN,
			    bias = initialBias,
			    basic,
			    j,
			    index,
			    oldi,
			    w,
			    k,
			    digit,
			    t,
			    /** Cached calculation results */
			    baseMinusT;

			// Handle the basic code points: let `basic` be the number of input code
			// points before the last delimiter, or `0` if there is none, then copy
			// the first basic code points to the output.

			basic = input.lastIndexOf(delimiter);
			if (basic < 0) {
				basic = 0;
			}

			for (j = 0; j < basic; ++j) {
				// if it's not a basic code point
				if (input.charCodeAt(j) >= 0x80) {
					error('not-basic');
				}
				output.push(input.charCodeAt(j));
			}

			// Main decoding loop: start just after the last delimiter if any basic code
			// points were copied; start at the beginning otherwise.

			for (index = basic > 0 ? basic + 1 : 0; index < inputLength; /* no final expression */) {

				// `index` is the index of the next character to be consumed.
				// Decode a generalized variable-length integer into `delta`,
				// which gets added to `i`. The overflow checking is easier
				// if we increase `i` as we go, then subtract off its starting
				// value at the end to obtain `delta`.
				for (oldi = i, w = 1, k = base; /* no condition */; k += base) {

					if (index >= inputLength) {
						error('invalid-input');
					}

					digit = basicToDigit(input.charCodeAt(index++));

					if (digit >= base || digit > floor((maxInt - i) / w)) {
						error('overflow');
					}

					i += digit * w;
					t = k <= bias ? tMin : (k >= bias + tMax ? tMax : k - bias);

					if (digit < t) {
						break;
					}

					baseMinusT = base - t;
					if (w > floor(maxInt / baseMinusT)) {
						error('overflow');
					}

					w *= baseMinusT;

				}

				out = output.length + 1;
				bias = adapt(i - oldi, out, oldi == 0);

				// `i` was supposed to wrap around from `out` to `0`,
				// incrementing `n` each time, so we'll fix that now:
				if (floor(i / out) > maxInt - n) {
					error('overflow');
				}

				n += floor(i / out);
				i %= out;

				// Insert `n` at position `i` of the output
				output.splice(i++, 0, n);

			}

			return ucs2encode(output);
		}

		/**
		 * Converts a string of Unicode symbols (e.g. a domain name label) to a
		 * Punycode string of ASCII-only symbols.
		 * @memberOf punycode
		 * @param {String} input The string of Unicode symbols.
		 * @returns {String} The resulting Punycode string of ASCII-only symbols.
		 */
		function encode(input) {
			var n,
			    delta,
			    handledCPCount,
			    basicLength,
			    bias,
			    j,
			    m,
			    q,
			    k,
			    t,
			    currentValue,
			    output = [],
			    /** `inputLength` will hold the number of code points in `input`. */
			    inputLength,
			    /** Cached calculation results */
			    handledCPCountPlusOne,
			    baseMinusT,
			    qMinusT;

			// Convert the input in UCS-2 to Unicode
			input = ucs2decode(input);

			// Cache the length
			inputLength = input.length;

			// Initialize the state
			n = initialN;
			delta = 0;
			bias = initialBias;

			// Handle the basic code points
			for (j = 0; j < inputLength; ++j) {
				currentValue = input[j];
				if (currentValue < 0x80) {
					output.push(stringFromCharCode(currentValue));
				}
			}

			handledCPCount = basicLength = output.length;

			// `handledCPCount` is the number of code points that have been handled;
			// `basicLength` is the number of basic code points.

			// Finish the basic string - if it is not empty - with a delimiter
			if (basicLength) {
				output.push(delimiter);
			}

			// Main encoding loop:
			while (handledCPCount < inputLength) {

				// All non-basic code points < n have been handled already. Find the next
				// larger one:
				for (m = maxInt, j = 0; j < inputLength; ++j) {
					currentValue = input[j];
					if (currentValue >= n && currentValue < m) {
						m = currentValue;
					}
				}

				// Increase `delta` enough to advance the decoder's <n,i> state to <m,0>,
				// but guard against overflow
				handledCPCountPlusOne = handledCPCount + 1;
				if (m - n > floor((maxInt - delta) / handledCPCountPlusOne)) {
					error('overflow');
				}

				delta += (m - n) * handledCPCountPlusOne;
				n = m;

				for (j = 0; j < inputLength; ++j) {
					currentValue = input[j];

					if (currentValue < n && ++delta > maxInt) {
						error('overflow');
					}

					if (currentValue == n) {
						// Represent delta as a generalized variable-length integer
						for (q = delta, k = base; /* no condition */; k += base) {
							t = k <= bias ? tMin : (k >= bias + tMax ? tMax : k - bias);
							if (q < t) {
								break;
							}
							qMinusT = q - t;
							baseMinusT = base - t;
							output.push(
								stringFromCharCode(digitToBasic(t + qMinusT % baseMinusT, 0))
							);
							q = floor(qMinusT / baseMinusT);
						}

						output.push(stringFromCharCode(digitToBasic(q, 0)));
						bias = adapt(delta, handledCPCountPlusOne, handledCPCount == basicLength);
						delta = 0;
						++handledCPCount;
					}
				}

				++delta;
				++n;

			}
			return output.join('');
		}

		/**
		 * Converts a Punycode string representing a domain name or an email address
		 * to Unicode. Only the Punycoded parts of the input will be converted, i.e.
		 * it doesn't matter if you call it on a string that has already been
		 * converted to Unicode.
		 * @memberOf punycode
		 * @param {String} input The Punycoded domain name or email address to
		 * convert to Unicode.
		 * @returns {String} The Unicode representation of the given Punycode
		 * string.
		 */
		function toUnicode(input) {
			return mapDomain(input, function(string) {
				return regexPunycode.test(string)
					? decode(string.slice(4).toLowerCase())
					: string;
			});
		}

		/**
		 * Converts a Unicode string representing a domain name or an email address to
		 * Punycode. Only the non-ASCII parts of the domain name will be converted,
		 * i.e. it doesn't matter if you call it with a domain that's already in
		 * ASCII.
		 * @memberOf punycode
		 * @param {String} input The domain name or email address to convert, as a
		 * Unicode string.
		 * @returns {String} The Punycode representation of the given domain name or
		 * email address.
		 */
		function toASCII(input) {
			return mapDomain(input, function(string) {
				return regexNonASCII.test(string)
					? 'xn--' + encode(string)
					: string;
			});
		}

		/*--------------------------------------------------------------------------*/

		/** Define the public API */
		punycode = {
			/**
			 * A string representing the current Punycode.js version number.
			 * @memberOf punycode
			 * @type String
			 */
			'version': '1.4.1',
			/**
			 * An object of methods to convert from JavaScript's internal character
			 * representation (UCS-2) to Unicode code points, and back.
			 * @see <https://mathiasbynens.be/notes/javascript-encoding>
			 * @memberOf punycode
			 * @type Object
			 */
			'ucs2': {
				'decode': ucs2decode,
				'encode': ucs2encode
			},
			'decode': decode,
			'encode': encode,
			'toASCII': toASCII,
			'toUnicode': toUnicode
		};

		/** Expose `punycode` */
		// Some AMD build optimizers, like r.js, check for specific condition patterns
		// like the following:
		if (
			true
		) {
			!(__WEBPACK_AMD_DEFINE_RESULT__ = function() {
				return punycode;
			}.call(exports, __webpack_require__, exports, module), __WEBPACK_AMD_DEFINE_RESULT__ !== undefined && (module.exports = __WEBPACK_AMD_DEFINE_RESULT__));
		} else if (freeExports && freeModule) {
			if (module.exports == freeExports) {
				// in Node.js, io.js, or RingoJS v0.8.0+
				freeModule.exports = punycode;
			} else {
				// in Narwhal or RingoJS v0.7.0-
				for (key in punycode) {
					punycode.hasOwnProperty(key) && (freeExports[key] = punycode[key]);
				}
			}
		} else {
			// in Rhino or a web browser
			root.punycode = punycode;
		}

	}(this));

	/* WEBPACK VAR INJECTION */}.call(exports, __webpack_require__(/*! ./../webpack/buildin/module.js */ 56)(module), (function() { return this; }())))

/***/ },
/* 56 */
/*!***********************************!*\
  !*** (webpack)/buildin/module.js ***!
  \***********************************/
/***/ function(module, exports) {

	module.exports = function(module) {
		if(!module.webpackPolyfill) {
			module.deprecate = function() {};
			module.paths = [];
			// module.parent = undefined by default
			module.children = [];
			module.webpackPolyfill = 1;
		}
		return module;
	}


/***/ },
/* 57 */
/*!*************************************************!*\
  !*** ./src/controller/privateKey.controller.js ***!
  \*************************************************/
/***/ function(module, exports, __webpack_require__) {

	/**
	 * Mailvelope - secure email with OpenPGP encryption for Webmail
	 * Copyright (C) 2015 Mailvelope GmbH
	 *
	 * This program is free software: you can redistribute it and/or modify
	 * it under the terms of the GNU Affero General Public License version 3
	 * as published by the Free Software Foundation.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU Affero General Public License for more details.
	 *
	 * You should have received a copy of the GNU Affero General Public License
	 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
	 */

	'use strict';


	var sub = __webpack_require__(/*! ./sub.controller */ 35);
	var uiLog = __webpack_require__(/*! ../modules/uiLog */ 29);
	var pwdCache = __webpack_require__(/*! ../modules/pwdCache */ 27);
	var sync = __webpack_require__(/*! ./sync.controller */ 34);

	function PrivateKeyController(port) {
	  sub.SubController.call(this, port);
	  this.keyring = __webpack_require__(/*! ../modules/keyring */ 32);
	  this.done = null;
	  this.keyringId = null;
	  this.options = null;
	  this.backupCodePopup = null;
	  this.host = null;
	  this.keyBackup = null;
	  this.pwdControl = null;
	  this.initialSetup = true;
	  this.restorePassword = false;
	  this.newKeyId = '';
	  this.rejectTimer = 0;
	}

	PrivateKeyController.prototype = Object.create(sub.SubController.prototype);

	PrivateKeyController.prototype.generateKey = function(password, options) {
	  var that = this;
	  if (options.keySize !== 2048 && options.keySize !== 4096) {
	    this.ports.keyGenDialog.postMessage({event: 'show-password'});
	    this.ports.keyGenCont.postMessage({event: 'generate-done', error: {message: 'Invalid key length', code: 'KEY_LENGTH_INVALID'}});
	    return;
	  }
	  this.ports.keyGenDialog.postMessage({event: 'show-waiting'});
	  this.keyring.getById(this.keyringId).generateKey({
	    userIds: options.userIds,
	    numBits: options.keySize,
	    passphrase: password
	  }).then(function(data) {
	    that.ports.keyGenCont.postMessage({event: 'generate-done', publicKey: data.publicKeyArmored});
	    if (that.prefs.data().security.password_cache) {
	      pwdCache.set({key: data.key}, password);
	    }
	    if (options.confirmRequired) {
	      that.newKeyId = data.key.primaryKey.keyid.toHex();
	      that.rejectTimer = that.mvelo.util.setTimeout(function() {
	        that.rejectKey(that.newKeyId);
	        that.rejectTimer = 0;
	      }, 10000); // trigger timeout after 10s
	    }
	  }).catch(function(err) {
	    that.ports.keyGenCont.postMessage({event: 'generate-done', error: err});
	  });
	};

	PrivateKeyController.prototype.rejectKey = function() {
	  this.keyring.getById(this.keyringId).removeKey(this.newKeyId, 'private');
	  if (this.prefs.data().security.password_cache) {
	    pwdCache.delete(this.newKeyId);
	  }
	};

	PrivateKeyController.prototype.createPrivateKeyBackup = function() {
	  var that = this;
	  var primaryKey = this.keyring.getById(this.keyringId).getPrimaryKey();
	  if (!primaryKey) {
	    throw { message: 'No private key for backup', code: 'NO_PRIVATE_KEY' };
	  }
	  this.pwdControl = sub.factory.get('pwdDialog');
	  primaryKey.reason = 'PWD_DIALOG_REASON_CREATE_BACKUP';
	  primaryKey.keyringId = this.keyringId;
	  // get password from cache or ask user
	  this.pwdControl.unlockKey(primaryKey)
	    .then(function(primaryKey) {
	      sync.triggerSync(primaryKey);
	      that.keyBackup = that.model.createPrivateKeyBackup(primaryKey.key, primaryKey.password);
	    })
	    .then(function() {
	      return sync.getByKeyring(that.keyringId).backup({backup: that.keyBackup.message});
	    })
	    .then(function() {
	      var page = 'recoverySheet';

	      switch (that.host) {
	        case 'web.de':
	          page += '.1und1.html?brand=webde' + '&id=' + that.id;
	          break;
	        case 'gmx.net':
	        case 'gmx.com':
	        case 'gmx.co.uk':
	        case 'gmx.fr':
	        case 'gmx.es':
	          page += '.1und1.html?brand=gmx' + '&id=' + that.id;
	          break;
	        default:
	          page += '.html' + '?id=' + that.id;
	          break;
	      }

	      var path = 'components/recovery-sheet/' + page;
	      that.mvelo.windows.openPopup(path, {width: 1024, height: 550, modal: false}, function(window) {
	        that.backupCodePopup = window;
	      });
	    })
	    .catch(function(err) {
	      that.ports.keyBackupDialog.postMessage({event: 'error-message', error: err});
	    });
	};

	PrivateKeyController.prototype.restorePrivateKeyBackup = function(code) {
	  //console.log('PrivateKeyController.prototype.restorePrivateKeyBackup()', code);
	  var that = this;

	  sync.getByKeyring(that.keyringId).restore()
	    .then(function(data) {
	      var backup = that.model.restorePrivateKeyBackup(data.backup, code);
	      if (backup.error) {
	        if (backup.error.code === 'WRONG_RESTORE_CODE') {
	          that.ports.restoreBackupDialog.postMessage({event: 'error-message', error: backup.error});
	        } else {
	          that.ports.restoreBackupCont.postMessage({event: 'restore-backup-done', error: backup.error});
	        }
	        return;
	      }
	      var result = that.keyring.getById(that.keyringId).importKeys([{armored: backup.key.armor(), type: 'private'}]);
	      for (var i = 0; i < result.length; i++) {
	        if (result[i].type === 'error') {
	          that.ports.restoreBackupCont.postMessage({event: 'restore-backup-done', error: result[i].message});
	          return;
	        }
	      }
	      if (that.restorePassword) {
	        that.ports.restoreBackupDialog.postMessage({event: 'set-password', password: backup.password});
	      }
	      that.ports.restoreBackupCont.postMessage({event: 'restore-backup-done', data: backup.key.toPublic().armor()});
	      sync.triggerSync({keyringId: that.keyringId, key: backup.key, password: backup.password});
	    })
	    .catch(function(err) {
	      that.ports.restoreBackupDialog.postMessage({event: 'error-message', error: err});
	      that.ports.restoreBackupCont.postMessage({event: 'restore-backup-done', error: err});
	    });
	};

	PrivateKeyController.prototype.getLogoImage = function() {
	  var attr = this.keyring.getById(this.keyringId).getAttributes();
	  return (attr && attr.logo_data_url) ? attr.logo_data_url : null;
	};

	PrivateKeyController.prototype.getBackupCode = function() {
	  return this.keyBackup.backupCode;
	};

	PrivateKeyController.prototype.handlePortMessage = function(msg) {
	  switch (msg.event) {
	    case 'set-init-data':
	      var data = msg.data;
	      this.keyringId = data.keyringId || this.keyringId;
	      this.restorePassword = data.restorePassword || this.restorePassword;
	      break;
	    case 'keygen-user-input':
	    case 'key-backup-user-input':
	      uiLog.push(msg.source, msg.type);
	      break;
	    case 'open-security-settings':
	      this.openSecuritySettings();
	      break;
	    case 'generate-key':
	      this.keyringId = msg.keyringId;
	      this.options = msg.options;
	      this.ports.keyGenDialog.postMessage({event: 'check-dialog-inputs'});
	      break;
	    case 'generate-confirm':
	      if (this.rejectTimer) {
	        this.mvelo.util.clearTimeout(this.rejectTimer);
	        this.rejectTimer = 0;
	      }
	      break;
	    case 'generate-reject':
	      if (this.rejectTimer) {
	        this.mvelo.util.clearTimeout(this.rejectTimer);
	        this.rejectTimer = 0;
	        this.rejectKey(this.newKeyId);
	      }
	      break;
	    case 'set-keybackup-window-props':
	      this.keyringId = msg.keyringId;
	      this.host = msg.host;
	      this.initialSetup = msg.initialSetup;
	      break;
	    case 'input-check':
	      if (msg.isValid) {
	        this.generateKey(msg.pwd, this.options);
	      } else {
	        this.ports.keyGenCont.postMessage({event: 'generate-done', error: {message: 'The inputs "password" and "confirm" are not valid', code: 'INPUT_NOT_VALID'}});
	      }
	      break;
	    case 'keygen-dialog-init':
	      this.ports.keyGenCont.postMessage({event: 'dialog-done'});
	      break;
	    case 'keybackup-dialog-init':
	      this.ports.keyBackupDialog.postMessage({event: 'set-init-data', data: {initialSetup: this.initialSetup}});
	      this.ports.keyBackupCont.postMessage({event: 'dialog-done'});
	      break;
	    case 'restore-backup-dialog-init':
	      this.ports.restoreBackupCont.postMessage({event: 'dialog-done'});
	      break;
	    case 'restore-backup-code':
	      this.restorePrivateKeyBackup(msg.code);
	      break;
	    case 'backup-code-window-init':
	      this.ports.keyBackupCont.postMessage({event: 'popup-isready'});
	      break;
	    case 'get-logo-image':
	      this.ports.backupCodeWindow.postMessage({event: 'set-logo-image', image: this.getLogoImage()});
	      break;
	    case 'get-backup-code':
	      this.ports.backupCodeWindow.postMessage({event: 'set-backup-code', backupCode: this.getBackupCode()});
	      break;
	    case 'create-backup-code-window':
	      try {
	        this.createPrivateKeyBackup();
	      } catch (err) {
	        this.ports.keyBackupCont.postMessage({event: 'popup-isready', error: err});
	      }
	      break;
	    default:
	      console.log('unknown event', msg);
	  }
	};

	exports.PrivateKeyController = PrivateKeyController;


/***/ },
/* 58 */
/*!***********************************!*\
  !*** ./src/firefox/lib/prompt.js ***!
  \***********************************/
/***/ function(module, exports, __webpack_require__) {

	
	'use strict';

	var Cc = __webpack_require__(/*! chrome */ 16).Cc;
	var Ci = __webpack_require__(/*! chrome */ 16).Ci;
	var utils = __webpack_require__(/*! sdk/window/utils */ 59);

	var promptSvc = Cc["@mozilla.org/embedcomp/prompt-service;1"].getService(Ci.nsIPromptService);

	exports.confirm = function(title, text) {
	  return promptSvc.confirm(utils.getMostRecentBrowserWindow(), title, text);
	};


/***/ },
/* 59 */
/*!***********************************!*\
  !*** external "sdk/window/utils" ***!
  \***********************************/
/***/ function(module, exports) {

	module.exports = require("sdk/window/utils");

/***/ }
/******/ ]);